package testcases.CWE134_Uncontrolled_Format_String.s01;

import testcasesupport.*;

public class Main {

	public static void main(String[] args) {
		
		if(args.length != 0) {
		
			if(args[0].equals("-h") || args[0].equals("--help")) {
		
				System.err.println("To use this main, you can either run the program with no " +
				"command line arguments to run all test cases or you can specify one or more classes to test");
				System.err.println("For example:");
				System.err.println("java testcasesupport.Main testcases.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference.custom_function.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference__custom_function_01 testcases.CWE481_Assigning_instead_of_Comparing.bool.CWE481_Assigning_instead_of_Comparing__bool_01");
				System.exit(1);
			}
			
			/* User supplied some class names on the command line, just use those with introspection
			 *
			 * String classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
			 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
 			 * could read class names from command line or use
			 * http://sadun-util.sourceforge.net/api/org/sadun/util/
			 * ClassPackageExplorer.html
			 */

			for (String className : args) {

				try {
					
					/* String classNameWithPackage = "testcases." + className; */
					
					/* IO.writeLine("classNameWithPackage = " + classNameWithPackage); */

					Class<?> myClass = Class.forName(className);

					AbstractTestCase myObject = (AbstractTestCase) myClass
							.newInstance();

					myObject.runTest(className);

				} catch (Exception ex) {

					IO.writeLine("Could not run test for class " + className);
					ex.printStackTrace();

				}
				
				IO.writeLine(""); /* leave a blank line between classes */

			}

		} else {
		
			/* No command line args were used, we want to run every testcase */
			
			/* needed to separate these calls into other methods because
			   we were running into the size limit Java has for a single method */
			runTestCWE1();
			runTestCWE2();
			runTestCWE3();
			runTestCWE4();
			runTestCWE5();
			runTestCWE6();
			runTestCWE7();
			runTestCWE8();
			runTestCWE9();
		}			
	}

private static void runTestCWE1() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-1 */
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_printf_73a()).runTest("CWE134_Uncontrolled_Format_String__Environment_printf_73a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_format_16()).runTest("CWE134_Uncontrolled_Format_String__database_format_16");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_printf_21()).runTest("CWE134_Uncontrolled_Format_String__File_printf_21");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_printf_10()).runTest("CWE134_Uncontrolled_Format_String__File_printf_10");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_printf_02()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_printf_02");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_printf_71a()).runTest("CWE134_Uncontrolled_Format_String__Environment_printf_71a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_printf_81a()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_printf_81a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_format_02()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_format_02");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_format_22a()).runTest("CWE134_Uncontrolled_Format_String__Environment_format_22a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_printf_61a()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_printf_61a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_format_75a()).runTest("CWE134_Uncontrolled_Format_String__File_format_75a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_printf_13()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_printf_13");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_printf_02()).runTest("CWE134_Uncontrolled_Format_String__File_printf_02");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_format_66a()).runTest("CWE134_Uncontrolled_Format_String__Property_format_66a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_format_68a()).runTest("CWE134_Uncontrolled_Format_String__File_format_68a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_printf_53a()).runTest("CWE134_Uncontrolled_Format_String__Environment_printf_53a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_format_11()).runTest("CWE134_Uncontrolled_Format_String__File_format_11");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_printf_52a()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_printf_52a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_printf_09()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_printf_09");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_printf_75a()).runTest("CWE134_Uncontrolled_Format_String__File_printf_75a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_format_73a()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_format_73a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_format_67a()).runTest("CWE134_Uncontrolled_Format_String__File_format_67a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_printf_04()).runTest("CWE134_Uncontrolled_Format_String__Environment_printf_04");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_printf_31()).runTest("CWE134_Uncontrolled_Format_String__database_printf_31");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_printf_17()).runTest("CWE134_Uncontrolled_Format_String__Environment_printf_17");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_printf_67a()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_printf_67a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_printf_53a()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_printf_53a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_printf_06()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_printf_06");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_printf_51a()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_printf_51a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_printf_67a()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_printf_67a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_printf_22a()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_printf_22a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_printf_13()).runTest("CWE134_Uncontrolled_Format_String__database_printf_13");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_printf_09()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_printf_09");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_printf_22a()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_printf_22a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_printf_53a()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_printf_53a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_format_02()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_format_02");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_printf_73a()).runTest("CWE134_Uncontrolled_Format_String__Property_printf_73a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_format_42()).runTest("CWE134_Uncontrolled_Format_String__Environment_format_42");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_format_13()).runTest("CWE134_Uncontrolled_Format_String__Environment_format_13");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_format_54a()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_format_54a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_printf_81a()).runTest("CWE134_Uncontrolled_Format_String__Property_printf_81a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_format_14()).runTest("CWE134_Uncontrolled_Format_String__Environment_format_14");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_format_17()).runTest("CWE134_Uncontrolled_Format_String__Environment_format_17");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_format_67a()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_format_67a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_printf_52a()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_printf_52a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_printf_72a()).runTest("CWE134_Uncontrolled_Format_String__File_printf_72a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_printf_53a()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_printf_53a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_printf_15()).runTest("CWE134_Uncontrolled_Format_String__database_printf_15");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_printf_54a()).runTest("CWE134_Uncontrolled_Format_String__database_printf_54a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_printf_61a()).runTest("CWE134_Uncontrolled_Format_String__Property_printf_61a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_printf_42()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_printf_42");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_format_07()).runTest("CWE134_Uncontrolled_Format_String__File_format_07");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_format_31()).runTest("CWE134_Uncontrolled_Format_String__Environment_format_31");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_format_09()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_format_09");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_format_41()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_format_41");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_printf_66a()).runTest("CWE134_Uncontrolled_Format_String__Environment_printf_66a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_format_21()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_format_21");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_format_12()).runTest("CWE134_Uncontrolled_Format_String__File_format_12");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_format_02()).runTest("CWE134_Uncontrolled_Format_String__Environment_format_02");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_printf_01()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_printf_01");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_printf_52a()).runTest("CWE134_Uncontrolled_Format_String__Environment_printf_52a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_printf_06()).runTest("CWE134_Uncontrolled_Format_String__database_printf_06");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_format_66a()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_format_66a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_format_31()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_format_31");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_format_21()).runTest("CWE134_Uncontrolled_Format_String__Environment_format_21");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_format_04()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_format_04");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_printf_02()).runTest("CWE134_Uncontrolled_Format_String__Environment_printf_02");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_printf_73a()).runTest("CWE134_Uncontrolled_Format_String__File_printf_73a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_printf_21()).runTest("CWE134_Uncontrolled_Format_String__database_printf_21");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_printf_01()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_printf_01");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_format_41()).runTest("CWE134_Uncontrolled_Format_String__Property_format_41");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_printf_11()).runTest("CWE134_Uncontrolled_Format_String__Property_printf_11");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_printf_73a()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_printf_73a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_format_31()).runTest("CWE134_Uncontrolled_Format_String__database_format_31");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_printf_72a()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_printf_72a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_format_02()).runTest("CWE134_Uncontrolled_Format_String__File_format_02");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_format_09()).runTest("CWE134_Uncontrolled_Format_String__Property_format_09");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_printf_71a()).runTest("CWE134_Uncontrolled_Format_String__database_printf_71a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_format_42()).runTest("CWE134_Uncontrolled_Format_String__database_format_42");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_format_14()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_format_14");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_printf_03()).runTest("CWE134_Uncontrolled_Format_String__Environment_printf_03");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_format_68a()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_format_68a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_printf_41()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_printf_41");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_format_04()).runTest("CWE134_Uncontrolled_Format_String__File_format_04");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_format_07()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_format_07");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_format_75a()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_format_75a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_printf_61a()).runTest("CWE134_Uncontrolled_Format_String__Environment_printf_61a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_format_74a()).runTest("CWE134_Uncontrolled_Format_String__File_format_74a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_format_14()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_format_14");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_printf_51a()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_printf_51a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_printf_42()).runTest("CWE134_Uncontrolled_Format_String__Property_printf_42");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_printf_06()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_printf_06");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_format_61a()).runTest("CWE134_Uncontrolled_Format_String__database_format_61a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_format_14()).runTest("CWE134_Uncontrolled_Format_String__database_format_14");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_printf_09()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_printf_09");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_format_11()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_format_11");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_format_68a()).runTest("CWE134_Uncontrolled_Format_String__database_format_68a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_printf_75a()).runTest("CWE134_Uncontrolled_Format_String__Property_printf_75a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_printf_51a()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_printf_51a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_format_11()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_format_11");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_printf_21()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_printf_21");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_format_03()).runTest("CWE134_Uncontrolled_Format_String__File_format_03");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_format_61a()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_format_61a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_printf_72a()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_printf_72a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_format_10()).runTest("CWE134_Uncontrolled_Format_String__File_format_10");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_printf_71a()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_printf_71a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_printf_68a()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_printf_68a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_format_04()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_format_04");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_printf_02()).runTest("CWE134_Uncontrolled_Format_String__Property_printf_02");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_format_17()).runTest("CWE134_Uncontrolled_Format_String__database_format_17");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_format_53a()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_format_53a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_format_54a()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_format_54a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_printf_09()).runTest("CWE134_Uncontrolled_Format_String__Environment_printf_09");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_printf_05()).runTest("CWE134_Uncontrolled_Format_String__database_printf_05");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_format_75a()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_format_75a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_format_09()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_format_09");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_printf_74a()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_printf_74a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_printf_16()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_printf_16");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_printf_06()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_printf_06");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_printf_07()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_printf_07");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_format_10()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_format_10");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_format_03()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_format_03");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_printf_54a()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_printf_54a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_format_74a()).runTest("CWE134_Uncontrolled_Format_String__Environment_format_74a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_printf_04()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_printf_04");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_printf_08()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_printf_08");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_format_53a()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_format_53a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_format_81a()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_format_81a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_printf_16()).runTest("CWE134_Uncontrolled_Format_String__database_printf_16");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_format_53a()).runTest("CWE134_Uncontrolled_Format_String__Property_format_53a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_format_75a()).runTest("CWE134_Uncontrolled_Format_String__Environment_format_75a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_format_12()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_format_12");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_format_17()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_format_17");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_printf_31()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_printf_31");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_printf_11()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_printf_11");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_format_22a()).runTest("CWE134_Uncontrolled_Format_String__Property_format_22a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_printf_10()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_printf_10");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_printf_41()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_printf_41");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_format_54a()).runTest("CWE134_Uncontrolled_Format_String__Environment_format_54a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_format_16()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_format_16");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_format_61a()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_format_61a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_printf_01()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_printf_01");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_format_09()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_format_09");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_format_06()).runTest("CWE134_Uncontrolled_Format_String__File_format_06");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_format_05()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_format_05");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_format_67a()).runTest("CWE134_Uncontrolled_Format_String__Property_format_67a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_format_10()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_format_10");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_printf_04()).runTest("CWE134_Uncontrolled_Format_String__Property_printf_04");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_printf_11()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_printf_11");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_printf_14()).runTest("CWE134_Uncontrolled_Format_String__Environment_printf_14");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_format_53a()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_format_53a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_printf_67a()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_printf_67a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_printf_52a()).runTest("CWE134_Uncontrolled_Format_String__File_printf_52a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_printf_81a()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_printf_81a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_printf_71a()).runTest("CWE134_Uncontrolled_Format_String__Property_printf_71a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_printf_14()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_printf_14");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_format_08()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_format_08");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_format_15()).runTest("CWE134_Uncontrolled_Format_String__Property_format_15");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_printf_04()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_printf_04");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_format_67a()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_format_67a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_printf_71a()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_printf_71a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_format_09()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_format_09");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_printf_68a()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_printf_68a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_format_15()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_format_15");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_format_52a()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_format_52a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_printf_13()).runTest("CWE134_Uncontrolled_Format_String__Environment_printf_13");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_format_21()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_format_21");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_format_13()).runTest("CWE134_Uncontrolled_Format_String__Property_format_13");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_format_45()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_format_45");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_format_68a()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_format_68a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_format_03()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_format_03");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_format_02()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_format_02");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_printf_45()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_printf_45");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_printf_15()).runTest("CWE134_Uncontrolled_Format_String__File_printf_15");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_format_10()).runTest("CWE134_Uncontrolled_Format_String__Property_format_10");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_printf_09()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_printf_09");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_printf_42()).runTest("CWE134_Uncontrolled_Format_String__File_printf_42");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_format_53a()).runTest("CWE134_Uncontrolled_Format_String__database_format_53a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_format_53a()).runTest("CWE134_Uncontrolled_Format_String__Environment_format_53a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_printf_07()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_printf_07");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_format_73a()).runTest("CWE134_Uncontrolled_Format_String__Environment_format_73a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_printf_67a()).runTest("CWE134_Uncontrolled_Format_String__database_printf_67a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_format_71a()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_format_71a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_printf_08()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_printf_08");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_format_41()).runTest("CWE134_Uncontrolled_Format_String__File_format_41");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_printf_06()).runTest("CWE134_Uncontrolled_Format_String__File_printf_06");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_format_06()).runTest("CWE134_Uncontrolled_Format_String__Environment_format_06");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_format_31()).runTest("CWE134_Uncontrolled_Format_String__Property_format_31");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_printf_45()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_printf_45");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_printf_74a()).runTest("CWE134_Uncontrolled_Format_String__database_printf_74a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_format_66a()).runTest("CWE134_Uncontrolled_Format_String__File_format_66a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_printf_09()).runTest("CWE134_Uncontrolled_Format_String__File_printf_09");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_printf_16()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_printf_16");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_format_72a()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_format_72a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_format_15()).runTest("CWE134_Uncontrolled_Format_String__Environment_format_15");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_format_45()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_format_45");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_printf_10()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_printf_10");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_printf_45()).runTest("CWE134_Uncontrolled_Format_String__Property_printf_45");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_printf_02()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_printf_02");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_printf_41()).runTest("CWE134_Uncontrolled_Format_String__Property_printf_41");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_format_81a()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_format_81a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_format_03()).runTest("CWE134_Uncontrolled_Format_String__Property_format_03");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_printf_12()).runTest("CWE134_Uncontrolled_Format_String__Property_printf_12");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_printf_53a()).runTest("CWE134_Uncontrolled_Format_String__database_printf_53a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_printf_10()).runTest("CWE134_Uncontrolled_Format_String__Environment_printf_10");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_format_75a()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_format_75a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_format_13()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_format_13");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_printf_12()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_printf_12");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_printf_22a()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_printf_22a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_format_11()).runTest("CWE134_Uncontrolled_Format_String__Environment_format_11");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_format_54a()).runTest("CWE134_Uncontrolled_Format_String__File_format_54a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_printf_01()).runTest("CWE134_Uncontrolled_Format_String__Environment_printf_01");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_printf_72a()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_printf_72a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_format_41()).runTest("CWE134_Uncontrolled_Format_String__Environment_format_41");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_printf_22a()).runTest("CWE134_Uncontrolled_Format_String__database_printf_22a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_printf_03()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_printf_03");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_printf_01()).runTest("CWE134_Uncontrolled_Format_String__File_printf_01");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_printf_21()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_printf_21");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_printf_07()).runTest("CWE134_Uncontrolled_Format_String__database_printf_07");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_format_09()).runTest("CWE134_Uncontrolled_Format_String__Environment_format_09");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_format_45()).runTest("CWE134_Uncontrolled_Format_String__File_format_45");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_printf_15()).runTest("CWE134_Uncontrolled_Format_String__Environment_printf_15");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_printf_71a()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_printf_71a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_printf_04()).runTest("CWE134_Uncontrolled_Format_String__database_printf_04");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_format_42()).runTest("CWE134_Uncontrolled_Format_String__File_format_42");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_printf_05()).runTest("CWE134_Uncontrolled_Format_String__Environment_printf_05");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_printf_16()).runTest("CWE134_Uncontrolled_Format_String__Property_printf_16");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_printf_75a()).runTest("CWE134_Uncontrolled_Format_String__Environment_printf_75a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_printf_51a()).runTest("CWE134_Uncontrolled_Format_String__database_printf_51a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_format_67a()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_format_67a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_format_16()).runTest("CWE134_Uncontrolled_Format_String__File_format_16");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_printf_68a()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_printf_68a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_format_45()).runTest("CWE134_Uncontrolled_Format_String__Environment_format_45");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_format_10()).runTest("CWE134_Uncontrolled_Format_String__database_format_10");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_format_06()).runTest("CWE134_Uncontrolled_Format_String__database_format_06");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_printf_22a()).runTest("CWE134_Uncontrolled_Format_String__Environment_printf_22a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_format_13()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_format_13");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_format_68a()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_format_68a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_printf_54a()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_printf_54a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_format_52a()).runTest("CWE134_Uncontrolled_Format_String__database_format_52a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_format_42()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_format_42");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_format_61a()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_format_61a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_format_52a()).runTest("CWE134_Uncontrolled_Format_String__Environment_format_52a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_printf_21()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_printf_21");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_format_66a()).runTest("CWE134_Uncontrolled_Format_String__database_format_66a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_printf_42()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_printf_42");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_format_45()).runTest("CWE134_Uncontrolled_Format_String__database_format_45");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_printf_73a()).runTest("CWE134_Uncontrolled_Format_String__database_printf_73a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_printf_72a()).runTest("CWE134_Uncontrolled_Format_String__Environment_printf_72a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_format_54a()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_format_54a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_printf_17()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_printf_17");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_printf_17()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_printf_17");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_format_66a()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_format_66a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_format_01()).runTest("CWE134_Uncontrolled_Format_String__Environment_format_01");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_printf_81a()).runTest("CWE134_Uncontrolled_Format_String__Environment_printf_81a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_printf_74a()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_printf_74a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_format_52a()).runTest("CWE134_Uncontrolled_Format_String__File_format_52a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_printf_81a()).runTest("CWE134_Uncontrolled_Format_String__File_printf_81a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_printf_31()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_printf_31");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_printf_10()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_printf_10");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_printf_53a()).runTest("CWE134_Uncontrolled_Format_String__File_printf_53a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_format_14()).runTest("CWE134_Uncontrolled_Format_String__File_format_14");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_format_67a()).runTest("CWE134_Uncontrolled_Format_String__Environment_format_67a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_format_61a()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_format_61a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_format_22a()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_format_22a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_printf_61a()).runTest("CWE134_Uncontrolled_Format_String__File_printf_61a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_printf_31()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_printf_31");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_printf_22a()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_printf_22a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_format_51a()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_format_51a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_format_42()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_format_42");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_printf_45()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_printf_45");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_format_72a()).runTest("CWE134_Uncontrolled_Format_String__database_format_72a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_printf_13()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_printf_13");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_format_05()).runTest("CWE134_Uncontrolled_Format_String__File_format_05");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_printf_15()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_printf_15");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_format_05()).runTest("CWE134_Uncontrolled_Format_String__database_format_05");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_printf_07()).runTest("CWE134_Uncontrolled_Format_String__File_printf_07");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_format_72a()).runTest("CWE134_Uncontrolled_Format_String__Property_format_72a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_format_51a()).runTest("CWE134_Uncontrolled_Format_String__Property_format_51a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_printf_09()).runTest("CWE134_Uncontrolled_Format_String__database_printf_09");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_format_21()).runTest("CWE134_Uncontrolled_Format_String__Property_format_21");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_format_51a()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_format_51a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_format_04()).runTest("CWE134_Uncontrolled_Format_String__Property_format_04");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_format_01()).runTest("CWE134_Uncontrolled_Format_String__Property_format_01");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_printf_66a()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_printf_66a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_format_16()).runTest("CWE134_Uncontrolled_Format_String__Property_format_16");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_printf_08()).runTest("CWE134_Uncontrolled_Format_String__Property_printf_08");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_printf_13()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_printf_13");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_format_51a()).runTest("CWE134_Uncontrolled_Format_String__database_format_51a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_format_81a()).runTest("CWE134_Uncontrolled_Format_String__Environment_format_81a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_format_15()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_format_15");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_printf_01()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_printf_01");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_printf_17()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_printf_17");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_printf_68a()).runTest("CWE134_Uncontrolled_Format_String__Environment_printf_68a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_format_17()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_format_17");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_format_06()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_format_06");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_format_12()).runTest("CWE134_Uncontrolled_Format_String__Property_format_12");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_format_71a()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_format_71a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_printf_15()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_printf_15");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_printf_81a()).runTest("CWE134_Uncontrolled_Format_String__database_printf_81a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_printf_72a()).runTest("CWE134_Uncontrolled_Format_String__database_printf_72a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_printf_71a()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_printf_71a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_printf_72a()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_printf_72a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_format_04()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_format_04");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_format_21()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_format_21");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_printf_16()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_printf_16");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_printf_02()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_printf_02");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_format_01()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_format_01");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_printf_13()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_printf_13");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_printf_05()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_printf_05");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_printf_54a()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_printf_54a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_format_01()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_format_01");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_printf_17()).runTest("CWE134_Uncontrolled_Format_String__File_printf_17");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_format_17()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_format_17");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_printf_61a()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_printf_61a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_printf_17()).runTest("CWE134_Uncontrolled_Format_String__Property_printf_17");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_format_15()).runTest("CWE134_Uncontrolled_Format_String__database_format_15");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_printf_54a()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_printf_54a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_format_09()).runTest("CWE134_Uncontrolled_Format_String__database_format_09");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_printf_07()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_printf_07");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_printf_75a()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_printf_75a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_format_74a()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_format_74a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_printf_74a()).runTest("CWE134_Uncontrolled_Format_String__Property_printf_74a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_printf_12()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_printf_12");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_format_74a()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_format_74a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_format_71a()).runTest("CWE134_Uncontrolled_Format_String__Property_format_71a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_printf_41()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_printf_41");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_printf_17()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_printf_17");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_printf_11()).runTest("CWE134_Uncontrolled_Format_String__File_printf_11");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_format_42()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_format_42");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_format_73a()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_format_73a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_printf_04()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_printf_04");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_format_66a()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_format_66a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_printf_41()).runTest("CWE134_Uncontrolled_Format_String__database_printf_41");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_format_22a()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_format_22a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_format_81a()).runTest("CWE134_Uncontrolled_Format_String__Property_format_81a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_printf_52a()).runTest("CWE134_Uncontrolled_Format_String__Property_printf_52a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_format_16()).runTest("CWE134_Uncontrolled_Format_String__Environment_format_16");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_format_08()).runTest("CWE134_Uncontrolled_Format_String__database_format_08");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_printf_73a()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_printf_73a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_printf_02()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_printf_02");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_format_07()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_format_07");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_printf_12()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_printf_12");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_format_12()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_format_12");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_printf_73a()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_printf_73a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_printf_74a()).runTest("CWE134_Uncontrolled_Format_String__Environment_printf_74a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_printf_11()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_printf_11");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_printf_21()).runTest("CWE134_Uncontrolled_Format_String__Property_printf_21");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_printf_13()).runTest("CWE134_Uncontrolled_Format_String__File_printf_13");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_printf_09()).runTest("CWE134_Uncontrolled_Format_String__Property_printf_09");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_format_31()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_format_31");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_printf_41()).runTest("CWE134_Uncontrolled_Format_String__Environment_printf_41");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_format_16()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_format_16");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_format_74a()).runTest("CWE134_Uncontrolled_Format_String__Property_format_74a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_printf_66a()).runTest("CWE134_Uncontrolled_Format_String__database_printf_66a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_printf_68a()).runTest("CWE134_Uncontrolled_Format_String__database_printf_68a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_format_12()).runTest("CWE134_Uncontrolled_Format_String__database_format_12");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_format_74a()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_format_74a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_printf_14()).runTest("CWE134_Uncontrolled_Format_String__Property_printf_14");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_printf_16()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_printf_16");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_printf_72a()).runTest("CWE134_Uncontrolled_Format_String__Property_printf_72a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_format_61a()).runTest("CWE134_Uncontrolled_Format_String__Environment_format_61a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_printf_04()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_printf_04");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_printf_42()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_printf_42");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_format_08()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_format_08");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_format_68a()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_format_68a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_format_31()).runTest("CWE134_Uncontrolled_Format_String__File_format_31");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_format_68a()).runTest("CWE134_Uncontrolled_Format_String__Environment_format_68a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_printf_45()).runTest("CWE134_Uncontrolled_Format_String__database_printf_45");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_printf_68a()).runTest("CWE134_Uncontrolled_Format_String__File_printf_68a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_printf_81a()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_printf_81a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_format_16()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_format_16");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_printf_08()).runTest("CWE134_Uncontrolled_Format_String__File_printf_08");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_printf_66a()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_printf_66a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_format_53a()).runTest("CWE134_Uncontrolled_Format_String__File_format_53a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_printf_01()).runTest("CWE134_Uncontrolled_Format_String__database_printf_01");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_printf_16()).runTest("CWE134_Uncontrolled_Format_String__File_printf_16");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_printf_12()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_printf_12");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_format_61a()).runTest("CWE134_Uncontrolled_Format_String__File_format_61a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_format_03()).runTest("CWE134_Uncontrolled_Format_String__database_format_03");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_printf_31()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_printf_31");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_format_81a()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_format_81a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_printf_81a()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_printf_81a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_format_52a()).runTest("CWE134_Uncontrolled_Format_String__Property_format_52a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_printf_12()).runTest("CWE134_Uncontrolled_Format_String__Environment_printf_12");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_printf_12()).runTest("CWE134_Uncontrolled_Format_String__File_printf_12");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_printf_10()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_printf_10");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_printf_31()).runTest("CWE134_Uncontrolled_Format_String__Property_printf_31");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_printf_22a()).runTest("CWE134_Uncontrolled_Format_String__File_printf_22a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_format_17()).runTest("CWE134_Uncontrolled_Format_String__Property_format_17");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_printf_67a()).runTest("CWE134_Uncontrolled_Format_String__Property_printf_67a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_printf_07()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_printf_07");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_format_73a()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_format_73a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_format_07()).runTest("CWE134_Uncontrolled_Format_String__database_format_07");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_format_71a()).runTest("CWE134_Uncontrolled_Format_String__Environment_format_71a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_format_13()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_format_13");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_printf_02()).runTest("CWE134_Uncontrolled_Format_String__database_printf_02");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_printf_42()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_printf_42");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_format_17()).runTest("CWE134_Uncontrolled_Format_String__File_format_17");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_format_45()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_format_45");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_printf_68a()).runTest("CWE134_Uncontrolled_Format_String__Property_printf_68a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_format_04()).runTest("CWE134_Uncontrolled_Format_String__Environment_format_04");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_format_72a()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_format_72a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_format_12()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_format_12");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_printf_45()).runTest("CWE134_Uncontrolled_Format_String__Environment_printf_45");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_format_05()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_format_05");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_format_73a()).runTest("CWE134_Uncontrolled_Format_String__database_format_73a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_format_22a()).runTest("CWE134_Uncontrolled_Format_String__database_format_22a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_printf_14()).runTest("CWE134_Uncontrolled_Format_String__database_printf_14");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_printf_74a()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_printf_74a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_format_11()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_format_11");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_format_81a()).runTest("CWE134_Uncontrolled_Format_String__File_format_81a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_format_72a()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_format_72a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_format_01()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_format_01");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_printf_45()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_printf_45");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_printf_67a()).runTest("CWE134_Uncontrolled_Format_String__File_printf_67a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_format_05()).runTest("CWE134_Uncontrolled_Format_String__Environment_format_05");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_format_51a()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_format_51a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_printf_12()).runTest("CWE134_Uncontrolled_Format_String__database_printf_12");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_format_02()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_format_02");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_format_10()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_format_10");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_format_71a()).runTest("CWE134_Uncontrolled_Format_String__database_format_71a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_format_03()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_format_03");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_format_51a()).runTest("CWE134_Uncontrolled_Format_String__File_format_51a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_format_51a()).runTest("CWE134_Uncontrolled_Format_String__Environment_format_51a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_format_02()).runTest("CWE134_Uncontrolled_Format_String__database_format_02");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_printf_06()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_printf_06");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_format_61a()).runTest("CWE134_Uncontrolled_Format_String__Property_format_61a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_format_10()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_format_10");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_format_06()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_format_06");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_format_11()).runTest("CWE134_Uncontrolled_Format_String__Property_format_11");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_printf_05()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_printf_05");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_printf_04()).runTest("CWE134_Uncontrolled_Format_String__File_printf_04");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_printf_03()).runTest("CWE134_Uncontrolled_Format_String__Property_printf_03");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_format_17()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_format_17");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_format_13()).runTest("CWE134_Uncontrolled_Format_String__File_format_13");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_format_11()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_format_11");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_format_41()).runTest("CWE134_Uncontrolled_Format_String__database_format_41");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_format_75a()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_format_75a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_format_66a()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_format_66a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_format_42()).runTest("CWE134_Uncontrolled_Format_String__Property_format_42");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_format_07()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_format_07");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_format_12()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_format_12");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_printf_03()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_printf_03");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_printf_41()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_printf_41");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_format_11()).runTest("CWE134_Uncontrolled_Format_String__database_format_11");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_format_41()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_format_41");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_format_08()).runTest("CWE134_Uncontrolled_Format_String__File_format_08");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_format_54a()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_format_54a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_printf_08()).runTest("CWE134_Uncontrolled_Format_String__Environment_printf_08");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_format_42()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_format_42");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_format_51a()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_format_51a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_printf_75a()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_printf_75a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_printf_45()).runTest("CWE134_Uncontrolled_Format_String__File_printf_45");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_format_13()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_format_13");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_format_22a()).runTest("CWE134_Uncontrolled_Format_String__File_format_22a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_format_41()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_format_41");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_printf_15()).runTest("CWE134_Uncontrolled_Format_String__Property_printf_15");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_printf_10()).runTest("CWE134_Uncontrolled_Format_String__Property_printf_10");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_printf_01()).runTest("CWE134_Uncontrolled_Format_String__Property_printf_01");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_printf_54a()).runTest("CWE134_Uncontrolled_Format_String__File_printf_54a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_printf_07()).runTest("CWE134_Uncontrolled_Format_String__Environment_printf_07");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_format_52a()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_format_52a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_printf_22a()).runTest("CWE134_Uncontrolled_Format_String__Property_printf_22a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_format_45()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_format_45");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_printf_75a()).runTest("CWE134_Uncontrolled_Format_String__database_printf_75a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_printf_14()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_printf_14");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_format_52a()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_format_52a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_printf_61a()).runTest("CWE134_Uncontrolled_Format_String__database_printf_61a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_format_73a()).runTest("CWE134_Uncontrolled_Format_String__Property_format_73a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_format_06()).runTest("CWE134_Uncontrolled_Format_String__Property_format_06");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_format_13()).runTest("CWE134_Uncontrolled_Format_String__database_format_13");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_format_14()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_format_14");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_printf_21()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_printf_21");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_format_31()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_format_31");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_printf_66a()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_printf_66a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_format_72a()).runTest("CWE134_Uncontrolled_Format_String__File_format_72a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_printf_51a()).runTest("CWE134_Uncontrolled_Format_String__Property_printf_51a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_format_14()).runTest("CWE134_Uncontrolled_Format_String__Property_format_14");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_printf_66a()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_printf_66a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_printf_03()).runTest("CWE134_Uncontrolled_Format_String__File_printf_03");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_printf_03()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_printf_03");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_format_71a()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_format_71a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_printf_61a()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_printf_61a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_printf_42()).runTest("CWE134_Uncontrolled_Format_String__Environment_printf_42");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_format_41()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_format_41");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_printf_74a()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_printf_74a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_format_73a()).runTest("CWE134_Uncontrolled_Format_String__File_format_73a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_format_73a()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_format_73a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_format_21()).runTest("CWE134_Uncontrolled_Format_String__database_format_21");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_printf_05()).runTest("CWE134_Uncontrolled_Format_String__File_printf_05");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_format_01()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_format_01");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_format_15()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_format_15");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_format_71a()).runTest("CWE134_Uncontrolled_Format_String__File_format_71a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_format_08()).runTest("CWE134_Uncontrolled_Format_String__Environment_format_08");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_format_15()).runTest("CWE134_Uncontrolled_Format_String__File_format_15");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_format_08()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_format_08");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_printf_14()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_printf_14");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_printf_03()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_printf_03");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_printf_67a()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_printf_67a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_printf_31()).runTest("CWE134_Uncontrolled_Format_String__Environment_printf_31");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_format_75a()).runTest("CWE134_Uncontrolled_Format_String__Property_format_75a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_format_54a()).runTest("CWE134_Uncontrolled_Format_String__Property_format_54a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_printf_06()).runTest("CWE134_Uncontrolled_Format_String__Property_printf_06");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_format_04()).runTest("CWE134_Uncontrolled_Format_String__database_format_04");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_printf_05()).runTest("CWE134_Uncontrolled_Format_String__Property_printf_05");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_printf_21()).runTest("CWE134_Uncontrolled_Format_String__Environment_printf_21");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_printf_51a()).runTest("CWE134_Uncontrolled_Format_String__File_printf_51a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_printf_14()).runTest("CWE134_Uncontrolled_Format_String__File_printf_14");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_printf_73a()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_printf_73a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_format_03()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_format_03");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_format_05()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_format_05");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_format_81a()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_format_81a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_format_05()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_format_05");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_format_07()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_format_07");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_printf_53a()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_printf_53a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_printf_74a()).runTest("CWE134_Uncontrolled_Format_String__File_printf_74a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_printf_14()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_printf_14");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_printf_52a()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_printf_52a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_format_08()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_format_08");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_format_10()).runTest("CWE134_Uncontrolled_Format_String__Environment_format_10");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_format_03()).runTest("CWE134_Uncontrolled_Format_String__Environment_format_03");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_format_02()).runTest("CWE134_Uncontrolled_Format_String__Property_format_02");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_format_67a()).runTest("CWE134_Uncontrolled_Format_String__database_format_67a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_printf_05()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_printf_05");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_format_09()).runTest("CWE134_Uncontrolled_Format_String__File_format_09");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_format_31()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_format_31");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_format_54a()).runTest("CWE134_Uncontrolled_Format_String__database_format_54a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_format_81a()).runTest("CWE134_Uncontrolled_Format_String__database_format_81a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_printf_66a()).runTest("CWE134_Uncontrolled_Format_String__Property_printf_66a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_printf_52a()).runTest("CWE134_Uncontrolled_Format_String__database_printf_52a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_printf_07()).runTest("CWE134_Uncontrolled_Format_String__Property_printf_07");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_printf_52a()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_printf_52a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_printf_51a()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_printf_51a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_printf_15()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_printf_15");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_printf_15()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_printf_15");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_printf_08()).runTest("CWE134_Uncontrolled_Format_String__database_printf_08");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_format_72a()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_format_72a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_printf_10()).runTest("CWE134_Uncontrolled_Format_String__database_printf_10");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_printf_54a()).runTest("CWE134_Uncontrolled_Format_String__Property_printf_54a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_printf_71a()).runTest("CWE134_Uncontrolled_Format_String__File_printf_71a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_format_22a()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_format_22a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_format_21()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_format_21");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_format_68a()).runTest("CWE134_Uncontrolled_Format_String__Property_format_68a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_format_22a()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_format_22a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_printf_51a()).runTest("CWE134_Uncontrolled_Format_String__Environment_printf_51a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_printf_67a()).runTest("CWE134_Uncontrolled_Format_String__Environment_printf_67a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_printf_66a()).runTest("CWE134_Uncontrolled_Format_String__File_printf_66a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_printf_61a()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_printf_61a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_printf_11()).runTest("CWE134_Uncontrolled_Format_String__Environment_printf_11");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_printf_13()).runTest("CWE134_Uncontrolled_Format_String__Property_printf_13");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_format_04()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_format_04");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_format_12()).runTest("CWE134_Uncontrolled_Format_String__Environment_format_12");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_printf_03()).runTest("CWE134_Uncontrolled_Format_String__database_printf_03");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_format_06()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_format_06");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_format_06()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_format_06");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_format_71a()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_format_71a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_format_08()).runTest("CWE134_Uncontrolled_Format_String__Property_format_08");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_format_67a()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_format_67a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_printf_08()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_printf_08");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_format_05()).runTest("CWE134_Uncontrolled_Format_String__Property_format_05");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_printf_08()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_printf_08");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_format_75a()).runTest("CWE134_Uncontrolled_Format_String__database_format_75a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_printf_41()).runTest("CWE134_Uncontrolled_Format_String__File_printf_41");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_printf_75a()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_printf_75a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_format_01()).runTest("CWE134_Uncontrolled_Format_String__database_format_01");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_format_16()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_format_16");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_format_07()).runTest("CWE134_Uncontrolled_Format_String__Environment_format_07");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_format_15()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_format_15");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_printf_53a()).runTest("CWE134_Uncontrolled_Format_String__Property_printf_53a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_printf_16()).runTest("CWE134_Uncontrolled_Format_String__Environment_printf_16");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_printf_11()).runTest("CWE134_Uncontrolled_Format_String__database_printf_11");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_format_21()).runTest("CWE134_Uncontrolled_Format_String__File_format_21");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_format_72a()).runTest("CWE134_Uncontrolled_Format_String__Environment_format_72a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_printf_06()).runTest("CWE134_Uncontrolled_Format_String__Environment_printf_06");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_printf_68a()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_printf_68a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_printf_17()).runTest("CWE134_Uncontrolled_Format_String__database_printf_17");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_format_53a()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_format_53a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_format_07()).runTest("CWE134_Uncontrolled_Format_String__Property_format_07");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_printf_42()).runTest("CWE134_Uncontrolled_Format_String__database_printf_42");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_format_66a()).runTest("CWE134_Uncontrolled_Format_String__Environment_format_66a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_printf_31()).runTest("CWE134_Uncontrolled_Format_String__File_printf_31");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__console_readLine_format_52a()).runTest("CWE134_Uncontrolled_Format_String__console_readLine_format_52a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__database_format_74a()).runTest("CWE134_Uncontrolled_Format_String__database_format_74a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_printf_75a()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_printf_75a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_format_74a()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_format_74a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Environment_printf_54a()).runTest("CWE134_Uncontrolled_Format_String__Environment_printf_54a");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__File_format_01()).runTest("CWE134_Uncontrolled_Format_String__File_format_01");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__Property_format_45()).runTest("CWE134_Uncontrolled_Format_String__Property_format_45");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__connect_tcp_printf_11()).runTest("CWE134_Uncontrolled_Format_String__connect_tcp_printf_11");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__listen_tcp_format_14()).runTest("CWE134_Uncontrolled_Format_String__listen_tcp_format_14");
			(new testcases.CWE134_Uncontrolled_Format_String.s01.CWE134_Uncontrolled_Format_String__PropertiesFile_printf_05()).runTest("CWE134_Uncontrolled_Format_String__PropertiesFile_printf_05");
			/* END-AUTOGENERATED-JAVA-TESTS-1 */
}

private static void runTestCWE2() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-2 */

			/* END-AUTOGENERATED-JAVA-TESTS-2 */
}

private static void runTestCWE3() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-3 */

			/* END-AUTOGENERATED-JAVA-TESTS-3 */
}

private static void runTestCWE4() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-4 */

			/* END-AUTOGENERATED-JAVA-TESTS-4 */
}

private static void runTestCWE5() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-5 */

			/* END-AUTOGENERATED-JAVA-TESTS-5 */
}

private static void runTestCWE6() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-6 */

			/* END-AUTOGENERATED-JAVA-TESTS-6 */
}

private static void runTestCWE7() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-7 */

			/* END-AUTOGENERATED-JAVA-TESTS-7 */
}

private static void runTestCWE8() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-8 */

			/* END-AUTOGENERATED-JAVA-TESTS-8 */
}

private static void runTestCWE9() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-9 */

			/* END-AUTOGENERATED-JAVA-TESTS-9 */
}
}