package testcases.CWE190_Integer_Overflow.s06;

import testcasesupport.*;

public class Main {

	public static void main(String[] args) {
		
		if(args.length != 0) {
		
			if(args[0].equals("-h") || args[0].equals("--help")) {
		
				System.err.println("To use this main, you can either run the program with no " +
				"command line arguments to run all test cases or you can specify one or more classes to test");
				System.err.println("For example:");
				System.err.println("java testcasesupport.Main testcases.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference.custom_function.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference__custom_function_01 testcases.CWE481_Assigning_instead_of_Comparing.bool.CWE481_Assigning_instead_of_Comparing__bool_01");
				System.exit(1);
			}
			
			/* User supplied some class names on the command line, just use those with introspection
			 *
			 * String classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
			 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
 			 * could read class names from command line or use
			 * http://sadun-util.sourceforge.net/api/org/sadun/util/
			 * ClassPackageExplorer.html
			 */

			for (String className : args) {

				try {
					
					/* String classNameWithPackage = "testcases." + className; */
					
					/* IO.writeLine("classNameWithPackage = " + classNameWithPackage); */

					Class<?> myClass = Class.forName(className);

					AbstractTestCase myObject = (AbstractTestCase) myClass
							.newInstance();

					myObject.runTest(className);

				} catch (Exception ex) {

					IO.writeLine("Could not run test for class " + className);
					ex.printStackTrace();

				}
				
				IO.writeLine(""); /* leave a blank line between classes */

			}

		} else {
		
			/* No command line args were used, we want to run every testcase */
			
			/* needed to separate these calls into other methods because
			   we were running into the size limit Java has for a single method */
			runTestCWE1();
			runTestCWE2();
			runTestCWE3();
			runTestCWE4();
			runTestCWE5();
			runTestCWE6();
			runTestCWE7();
			runTestCWE8();
			runTestCWE9();
		}			
	}

private static void runTestCWE1() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-1 */
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_console_readLine_postinc_09()).runTest("CWE190_Integer_Overflow__long_console_readLine_postinc_09");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_File_postinc_07()).runTest("CWE190_Integer_Overflow__int_File_postinc_07");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_max_postinc_71a()).runTest("CWE190_Integer_Overflow__int_max_postinc_71a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_File_postinc_04()).runTest("CWE190_Integer_Overflow__int_File_postinc_04");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_max_postinc_42()).runTest("CWE190_Integer_Overflow__long_max_postinc_42");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_max_postinc_14()).runTest("CWE190_Integer_Overflow__int_max_postinc_14");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_URLConnection_postinc_74a()).runTest("CWE190_Integer_Overflow__int_URLConnection_postinc_74a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_random_postinc_73a()).runTest("CWE190_Integer_Overflow__int_random_postinc_73a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_max_postinc_09()).runTest("CWE190_Integer_Overflow__byte_max_postinc_09");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_console_readLine_postinc_15()).runTest("CWE190_Integer_Overflow__short_console_readLine_postinc_15");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_PropertiesFile_postinc_05()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_postinc_05");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_connect_tcp_postinc_13()).runTest("CWE190_Integer_Overflow__int_connect_tcp_postinc_13");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_max_postinc_13()).runTest("CWE190_Integer_Overflow__int_max_postinc_13");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_database_postinc_04()).runTest("CWE190_Integer_Overflow__int_database_postinc_04");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_console_readLine_postinc_08()).runTest("CWE190_Integer_Overflow__long_console_readLine_postinc_08");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_max_postinc_71a()).runTest("CWE190_Integer_Overflow__byte_max_postinc_71a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_max_postinc_14()).runTest("CWE190_Integer_Overflow__long_max_postinc_14");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_max_postinc_31()).runTest("CWE190_Integer_Overflow__short_max_postinc_31");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_max_postinc_04()).runTest("CWE190_Integer_Overflow__long_max_postinc_04");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_random_postinc_31()).runTest("CWE190_Integer_Overflow__int_random_postinc_31");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_rand_postinc_05()).runTest("CWE190_Integer_Overflow__short_rand_postinc_05");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_URLConnection_postinc_42()).runTest("CWE190_Integer_Overflow__int_URLConnection_postinc_42");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_random_postinc_66a()).runTest("CWE190_Integer_Overflow__int_random_postinc_66a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_console_readLine_postinc_09()).runTest("CWE190_Integer_Overflow__byte_console_readLine_postinc_09");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_connect_tcp_postinc_06()).runTest("CWE190_Integer_Overflow__int_connect_tcp_postinc_06");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_rand_postinc_13()).runTest("CWE190_Integer_Overflow__short_rand_postinc_13");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_random_postinc_03()).runTest("CWE190_Integer_Overflow__int_random_postinc_03");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_console_readLine_postinc_72a()).runTest("CWE190_Integer_Overflow__long_console_readLine_postinc_72a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_rand_postinc_31()).runTest("CWE190_Integer_Overflow__long_rand_postinc_31");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_max_postinc_10()).runTest("CWE190_Integer_Overflow__long_max_postinc_10");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_random_postinc_05()).runTest("CWE190_Integer_Overflow__int_random_postinc_05");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_URLConnection_postinc_68a()).runTest("CWE190_Integer_Overflow__int_URLConnection_postinc_68a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_database_postinc_41()).runTest("CWE190_Integer_Overflow__int_database_postinc_41");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_max_postinc_68a()).runTest("CWE190_Integer_Overflow__long_max_postinc_68a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_max_postinc_14()).runTest("CWE190_Integer_Overflow__short_max_postinc_14");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_connect_tcp_postinc_12()).runTest("CWE190_Integer_Overflow__int_connect_tcp_postinc_12");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_File_postinc_66a()).runTest("CWE190_Integer_Overflow__int_File_postinc_66a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_rand_postinc_03()).runTest("CWE190_Integer_Overflow__byte_rand_postinc_03");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_random_postinc_15()).runTest("CWE190_Integer_Overflow__int_random_postinc_15");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_max_postinc_09()).runTest("CWE190_Integer_Overflow__short_max_postinc_09");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_PropertiesFile_postinc_71a()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_postinc_71a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_PropertiesFile_postinc_51a()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_postinc_51a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_URLConnection_postinc_13()).runTest("CWE190_Integer_Overflow__int_URLConnection_postinc_13");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_listen_tcp_postinc_75a()).runTest("CWE190_Integer_Overflow__int_listen_tcp_postinc_75a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_max_postinc_42()).runTest("CWE190_Integer_Overflow__byte_max_postinc_42");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_connect_tcp_postinc_75a()).runTest("CWE190_Integer_Overflow__int_connect_tcp_postinc_75a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_connect_tcp_postinc_05()).runTest("CWE190_Integer_Overflow__int_connect_tcp_postinc_05");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_File_postinc_72a()).runTest("CWE190_Integer_Overflow__int_File_postinc_72a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_max_postinc_16()).runTest("CWE190_Integer_Overflow__byte_max_postinc_16");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_console_readLine_postinc_14()).runTest("CWE190_Integer_Overflow__short_console_readLine_postinc_14");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_PropertiesFile_postinc_02()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_postinc_02");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_max_postinc_53a()).runTest("CWE190_Integer_Overflow__int_max_postinc_53a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Environment_postinc_74a()).runTest("CWE190_Integer_Overflow__int_Environment_postinc_74a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_max_postinc_22a()).runTest("CWE190_Integer_Overflow__short_max_postinc_22a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_console_readLine_postinc_45()).runTest("CWE190_Integer_Overflow__short_console_readLine_postinc_45");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_random_postinc_74a()).runTest("CWE190_Integer_Overflow__int_random_postinc_74a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_rand_postinc_14()).runTest("CWE190_Integer_Overflow__byte_rand_postinc_14");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Property_postinc_52a()).runTest("CWE190_Integer_Overflow__int_Property_postinc_52a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_max_postinc_10()).runTest("CWE190_Integer_Overflow__byte_max_postinc_10");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_PropertiesFile_postinc_15()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_postinc_15");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_database_postinc_53a()).runTest("CWE190_Integer_Overflow__int_database_postinc_53a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_File_postinc_53a()).runTest("CWE190_Integer_Overflow__int_File_postinc_53a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_rand_postinc_21()).runTest("CWE190_Integer_Overflow__long_rand_postinc_21");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_console_readLine_postinc_74a()).runTest("CWE190_Integer_Overflow__long_console_readLine_postinc_74a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_console_readLine_postinc_07()).runTest("CWE190_Integer_Overflow__long_console_readLine_postinc_07");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_rand_postinc_45()).runTest("CWE190_Integer_Overflow__short_rand_postinc_45");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_max_postinc_14()).runTest("CWE190_Integer_Overflow__byte_max_postinc_14");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_connect_tcp_postinc_21()).runTest("CWE190_Integer_Overflow__int_connect_tcp_postinc_21");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_console_readLine_postinc_17()).runTest("CWE190_Integer_Overflow__long_console_readLine_postinc_17");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_rand_postinc_05()).runTest("CWE190_Integer_Overflow__byte_rand_postinc_05");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_rand_postinc_53a()).runTest("CWE190_Integer_Overflow__long_rand_postinc_53a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_max_postinc_45()).runTest("CWE190_Integer_Overflow__short_max_postinc_45");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_console_readLine_postinc_75a()).runTest("CWE190_Integer_Overflow__short_console_readLine_postinc_75a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_PropertiesFile_postinc_21()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_postinc_21");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_console_readLine_postinc_17()).runTest("CWE190_Integer_Overflow__short_console_readLine_postinc_17");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_connect_tcp_postinc_54a()).runTest("CWE190_Integer_Overflow__int_connect_tcp_postinc_54a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_console_readLine_postinc_15()).runTest("CWE190_Integer_Overflow__long_console_readLine_postinc_15");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_console_readLine_postinc_72a()).runTest("CWE190_Integer_Overflow__short_console_readLine_postinc_72a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Environment_postinc_71a()).runTest("CWE190_Integer_Overflow__int_Environment_postinc_71a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_rand_postinc_11()).runTest("CWE190_Integer_Overflow__short_rand_postinc_11");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_max_postinc_03()).runTest("CWE190_Integer_Overflow__short_max_postinc_03");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_URLConnection_postinc_81a()).runTest("CWE190_Integer_Overflow__int_URLConnection_postinc_81a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_max_postinc_31()).runTest("CWE190_Integer_Overflow__byte_max_postinc_31");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_console_readLine_postinc_05()).runTest("CWE190_Integer_Overflow__long_console_readLine_postinc_05");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_connect_tcp_postinc_72a()).runTest("CWE190_Integer_Overflow__int_connect_tcp_postinc_72a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_rand_postinc_75a()).runTest("CWE190_Integer_Overflow__byte_rand_postinc_75a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_max_postinc_03()).runTest("CWE190_Integer_Overflow__int_max_postinc_03");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_console_readLine_postinc_03()).runTest("CWE190_Integer_Overflow__byte_console_readLine_postinc_03");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_rand_postinc_67a()).runTest("CWE190_Integer_Overflow__long_rand_postinc_67a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_rand_postinc_53a()).runTest("CWE190_Integer_Overflow__short_rand_postinc_53a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_console_readLine_postinc_10()).runTest("CWE190_Integer_Overflow__short_console_readLine_postinc_10");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_console_readLine_postinc_41()).runTest("CWE190_Integer_Overflow__byte_console_readLine_postinc_41");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_console_readLine_postinc_03()).runTest("CWE190_Integer_Overflow__long_console_readLine_postinc_03");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_File_postinc_52a()).runTest("CWE190_Integer_Overflow__int_File_postinc_52a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_listen_tcp_postinc_12()).runTest("CWE190_Integer_Overflow__int_listen_tcp_postinc_12");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_console_readLine_postinc_02()).runTest("CWE190_Integer_Overflow__long_console_readLine_postinc_02");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_PropertiesFile_postinc_54a()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_postinc_54a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_File_postinc_05()).runTest("CWE190_Integer_Overflow__int_File_postinc_05");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_PropertiesFile_postinc_16()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_postinc_16");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_max_postinc_22a()).runTest("CWE190_Integer_Overflow__byte_max_postinc_22a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_connect_tcp_postinc_03()).runTest("CWE190_Integer_Overflow__int_connect_tcp_postinc_03");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_File_postinc_41()).runTest("CWE190_Integer_Overflow__int_File_postinc_41");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_rand_postinc_15()).runTest("CWE190_Integer_Overflow__byte_rand_postinc_15");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_rand_postinc_11()).runTest("CWE190_Integer_Overflow__byte_rand_postinc_11");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_listen_tcp_postinc_07()).runTest("CWE190_Integer_Overflow__int_listen_tcp_postinc_07");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_console_readLine_postinc_04()).runTest("CWE190_Integer_Overflow__short_console_readLine_postinc_04");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_max_postinc_03()).runTest("CWE190_Integer_Overflow__long_max_postinc_03");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_max_postinc_07()).runTest("CWE190_Integer_Overflow__short_max_postinc_07");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_File_postinc_81a()).runTest("CWE190_Integer_Overflow__int_File_postinc_81a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_console_readLine_postinc_21()).runTest("CWE190_Integer_Overflow__short_console_readLine_postinc_21");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_console_readLine_postinc_51a()).runTest("CWE190_Integer_Overflow__int_console_readLine_postinc_51a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_rand_postinc_07()).runTest("CWE190_Integer_Overflow__short_rand_postinc_07");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_connect_tcp_postinc_07()).runTest("CWE190_Integer_Overflow__int_connect_tcp_postinc_07");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_URLConnection_postinc_72a()).runTest("CWE190_Integer_Overflow__int_URLConnection_postinc_72a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_connect_tcp_postinc_52a()).runTest("CWE190_Integer_Overflow__int_connect_tcp_postinc_52a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_random_postinc_41()).runTest("CWE190_Integer_Overflow__int_random_postinc_41");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_database_postinc_13()).runTest("CWE190_Integer_Overflow__int_database_postinc_13");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_listen_tcp_postinc_72a()).runTest("CWE190_Integer_Overflow__int_listen_tcp_postinc_72a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_console_readLine_postinc_04()).runTest("CWE190_Integer_Overflow__long_console_readLine_postinc_04");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_console_readLine_postinc_42()).runTest("CWE190_Integer_Overflow__int_console_readLine_postinc_42");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_PropertiesFile_postinc_07()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_postinc_07");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Property_postinc_51a()).runTest("CWE190_Integer_Overflow__int_Property_postinc_51a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_random_postinc_51a()).runTest("CWE190_Integer_Overflow__int_random_postinc_51a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_PropertiesFile_postinc_10()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_postinc_10");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_rand_postinc_73a()).runTest("CWE190_Integer_Overflow__short_rand_postinc_73a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_console_readLine_postinc_52a()).runTest("CWE190_Integer_Overflow__long_console_readLine_postinc_52a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_console_readLine_postinc_06()).runTest("CWE190_Integer_Overflow__int_console_readLine_postinc_06");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Property_postinc_74a()).runTest("CWE190_Integer_Overflow__int_Property_postinc_74a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_connect_tcp_postinc_22a()).runTest("CWE190_Integer_Overflow__int_connect_tcp_postinc_22a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_File_postinc_12()).runTest("CWE190_Integer_Overflow__int_File_postinc_12");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Environment_postinc_75a()).runTest("CWE190_Integer_Overflow__int_Environment_postinc_75a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_PropertiesFile_postinc_22a()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_postinc_22a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_max_postinc_67a()).runTest("CWE190_Integer_Overflow__short_max_postinc_67a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_console_readLine_postinc_41()).runTest("CWE190_Integer_Overflow__int_console_readLine_postinc_41");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_console_readLine_postinc_54a()).runTest("CWE190_Integer_Overflow__long_console_readLine_postinc_54a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_max_postinc_68a()).runTest("CWE190_Integer_Overflow__int_max_postinc_68a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_max_postinc_17()).runTest("CWE190_Integer_Overflow__short_max_postinc_17");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_URLConnection_postinc_73a()).runTest("CWE190_Integer_Overflow__int_URLConnection_postinc_73a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_listen_tcp_postinc_03()).runTest("CWE190_Integer_Overflow__int_listen_tcp_postinc_03");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Property_postinc_07()).runTest("CWE190_Integer_Overflow__int_Property_postinc_07");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_listen_tcp_postinc_73a()).runTest("CWE190_Integer_Overflow__int_listen_tcp_postinc_73a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_console_readLine_postinc_31()).runTest("CWE190_Integer_Overflow__short_console_readLine_postinc_31");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_listen_tcp_postinc_09()).runTest("CWE190_Integer_Overflow__int_listen_tcp_postinc_09");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_console_readLine_postinc_41()).runTest("CWE190_Integer_Overflow__short_console_readLine_postinc_41");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Environment_postinc_31()).runTest("CWE190_Integer_Overflow__int_Environment_postinc_31");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_connect_tcp_postinc_61a()).runTest("CWE190_Integer_Overflow__int_connect_tcp_postinc_61a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_rand_postinc_17()).runTest("CWE190_Integer_Overflow__long_rand_postinc_17");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_database_postinc_14()).runTest("CWE190_Integer_Overflow__int_database_postinc_14");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Environment_postinc_42()).runTest("CWE190_Integer_Overflow__int_Environment_postinc_42");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Property_postinc_13()).runTest("CWE190_Integer_Overflow__int_Property_postinc_13");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_max_postinc_21()).runTest("CWE190_Integer_Overflow__short_max_postinc_21");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_rand_postinc_73a()).runTest("CWE190_Integer_Overflow__long_rand_postinc_73a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_rand_postinc_07()).runTest("CWE190_Integer_Overflow__long_rand_postinc_07");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_URLConnection_postinc_07()).runTest("CWE190_Integer_Overflow__int_URLConnection_postinc_07");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_URLConnection_postinc_09()).runTest("CWE190_Integer_Overflow__int_URLConnection_postinc_09");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_max_postinc_67a()).runTest("CWE190_Integer_Overflow__byte_max_postinc_67a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_console_readLine_postinc_12()).runTest("CWE190_Integer_Overflow__short_console_readLine_postinc_12");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_File_postinc_45()).runTest("CWE190_Integer_Overflow__int_File_postinc_45");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_console_readLine_postinc_08()).runTest("CWE190_Integer_Overflow__byte_console_readLine_postinc_08");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_max_postinc_07()).runTest("CWE190_Integer_Overflow__byte_max_postinc_07");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_PropertiesFile_postinc_03()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_postinc_03");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_URLConnection_postinc_04()).runTest("CWE190_Integer_Overflow__int_URLConnection_postinc_04");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_rand_postinc_54a()).runTest("CWE190_Integer_Overflow__byte_rand_postinc_54a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_connect_tcp_postinc_67a()).runTest("CWE190_Integer_Overflow__int_connect_tcp_postinc_67a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_rand_postinc_81a()).runTest("CWE190_Integer_Overflow__byte_rand_postinc_81a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_connect_tcp_postinc_45()).runTest("CWE190_Integer_Overflow__int_connect_tcp_postinc_45");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_File_postinc_03()).runTest("CWE190_Integer_Overflow__int_File_postinc_03");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_connect_tcp_postinc_53a()).runTest("CWE190_Integer_Overflow__int_connect_tcp_postinc_53a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_rand_postinc_13()).runTest("CWE190_Integer_Overflow__long_rand_postinc_13");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_max_postinc_06()).runTest("CWE190_Integer_Overflow__int_max_postinc_06");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_max_postinc_61a()).runTest("CWE190_Integer_Overflow__long_max_postinc_61a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_connect_tcp_postinc_14()).runTest("CWE190_Integer_Overflow__int_connect_tcp_postinc_14");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_rand_postinc_22a()).runTest("CWE190_Integer_Overflow__short_rand_postinc_22a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Environment_postinc_06()).runTest("CWE190_Integer_Overflow__int_Environment_postinc_06");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_URLConnection_postinc_02()).runTest("CWE190_Integer_Overflow__int_URLConnection_postinc_02");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_max_postinc_73a()).runTest("CWE190_Integer_Overflow__int_max_postinc_73a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_random_postinc_75a()).runTest("CWE190_Integer_Overflow__int_random_postinc_75a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_max_postinc_01()).runTest("CWE190_Integer_Overflow__byte_max_postinc_01");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_rand_postinc_17()).runTest("CWE190_Integer_Overflow__short_rand_postinc_17");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Environment_postinc_07()).runTest("CWE190_Integer_Overflow__int_Environment_postinc_07");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_max_postinc_75a()).runTest("CWE190_Integer_Overflow__long_max_postinc_75a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_max_postinc_81a()).runTest("CWE190_Integer_Overflow__byte_max_postinc_81a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_connect_tcp_postinc_68a()).runTest("CWE190_Integer_Overflow__int_connect_tcp_postinc_68a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_File_postinc_15()).runTest("CWE190_Integer_Overflow__int_File_postinc_15");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_console_readLine_postinc_71a()).runTest("CWE190_Integer_Overflow__short_console_readLine_postinc_71a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_rand_postinc_08()).runTest("CWE190_Integer_Overflow__byte_rand_postinc_08");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_database_postinc_16()).runTest("CWE190_Integer_Overflow__int_database_postinc_16");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_max_postinc_66a()).runTest("CWE190_Integer_Overflow__int_max_postinc_66a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_File_postinc_71a()).runTest("CWE190_Integer_Overflow__int_File_postinc_71a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_PropertiesFile_postinc_04()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_postinc_04");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_random_postinc_13()).runTest("CWE190_Integer_Overflow__int_random_postinc_13");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_console_readLine_postinc_52a()).runTest("CWE190_Integer_Overflow__byte_console_readLine_postinc_52a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_rand_postinc_09()).runTest("CWE190_Integer_Overflow__byte_rand_postinc_09");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_random_postinc_11()).runTest("CWE190_Integer_Overflow__int_random_postinc_11");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_max_postinc_06()).runTest("CWE190_Integer_Overflow__short_max_postinc_06");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_File_postinc_09()).runTest("CWE190_Integer_Overflow__int_File_postinc_09");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_database_postinc_42()).runTest("CWE190_Integer_Overflow__int_database_postinc_42");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_listen_tcp_postinc_22a()).runTest("CWE190_Integer_Overflow__int_listen_tcp_postinc_22a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_listen_tcp_postinc_15()).runTest("CWE190_Integer_Overflow__int_listen_tcp_postinc_15");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_File_postinc_02()).runTest("CWE190_Integer_Overflow__int_File_postinc_02");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_max_postinc_02()).runTest("CWE190_Integer_Overflow__short_max_postinc_02");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_rand_postinc_04()).runTest("CWE190_Integer_Overflow__long_rand_postinc_04");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_PropertiesFile_postinc_12()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_postinc_12");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_listen_tcp_postinc_74a()).runTest("CWE190_Integer_Overflow__int_listen_tcp_postinc_74a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_console_readLine_postinc_15()).runTest("CWE190_Integer_Overflow__int_console_readLine_postinc_15");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_PropertiesFile_postinc_17()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_postinc_17");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_connect_tcp_postinc_10()).runTest("CWE190_Integer_Overflow__int_connect_tcp_postinc_10");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_rand_postinc_74a()).runTest("CWE190_Integer_Overflow__long_rand_postinc_74a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_console_readLine_postinc_22a()).runTest("CWE190_Integer_Overflow__int_console_readLine_postinc_22a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Environment_postinc_52a()).runTest("CWE190_Integer_Overflow__int_Environment_postinc_52a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_rand_postinc_09()).runTest("CWE190_Integer_Overflow__short_rand_postinc_09");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_connect_tcp_postinc_81a()).runTest("CWE190_Integer_Overflow__int_connect_tcp_postinc_81a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_rand_postinc_13()).runTest("CWE190_Integer_Overflow__byte_rand_postinc_13");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_max_postinc_73a()).runTest("CWE190_Integer_Overflow__short_max_postinc_73a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_max_postinc_41()).runTest("CWE190_Integer_Overflow__byte_max_postinc_41");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_connect_tcp_postinc_66a()).runTest("CWE190_Integer_Overflow__int_connect_tcp_postinc_66a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_console_readLine_postinc_71a()).runTest("CWE190_Integer_Overflow__byte_console_readLine_postinc_71a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_listen_tcp_postinc_71a()).runTest("CWE190_Integer_Overflow__int_listen_tcp_postinc_71a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_rand_postinc_51a()).runTest("CWE190_Integer_Overflow__long_rand_postinc_51a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_random_postinc_08()).runTest("CWE190_Integer_Overflow__int_random_postinc_08");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_max_postinc_51a()).runTest("CWE190_Integer_Overflow__int_max_postinc_51a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_database_postinc_73a()).runTest("CWE190_Integer_Overflow__int_database_postinc_73a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_URLConnection_postinc_15()).runTest("CWE190_Integer_Overflow__int_URLConnection_postinc_15");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_console_readLine_postinc_67a()).runTest("CWE190_Integer_Overflow__byte_console_readLine_postinc_67a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_URLConnection_postinc_21()).runTest("CWE190_Integer_Overflow__int_URLConnection_postinc_21");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_console_readLine_postinc_74a()).runTest("CWE190_Integer_Overflow__short_console_readLine_postinc_74a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_max_postinc_74a()).runTest("CWE190_Integer_Overflow__long_max_postinc_74a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_max_postinc_45()).runTest("CWE190_Integer_Overflow__int_max_postinc_45");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_listen_tcp_postinc_13()).runTest("CWE190_Integer_Overflow__int_listen_tcp_postinc_13");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_random_postinc_22a()).runTest("CWE190_Integer_Overflow__int_random_postinc_22a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_URLConnection_postinc_10()).runTest("CWE190_Integer_Overflow__int_URLConnection_postinc_10");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_max_postinc_52a()).runTest("CWE190_Integer_Overflow__long_max_postinc_52a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_max_postinc_17()).runTest("CWE190_Integer_Overflow__byte_max_postinc_17");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Environment_postinc_09()).runTest("CWE190_Integer_Overflow__int_Environment_postinc_09");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_PropertiesFile_postinc_42()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_postinc_42");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_console_readLine_postinc_09()).runTest("CWE190_Integer_Overflow__int_console_readLine_postinc_09");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_listen_tcp_postinc_51a()).runTest("CWE190_Integer_Overflow__int_listen_tcp_postinc_51a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_console_readLine_postinc_45()).runTest("CWE190_Integer_Overflow__int_console_readLine_postinc_45");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_max_postinc_53a()).runTest("CWE190_Integer_Overflow__long_max_postinc_53a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Environment_postinc_11()).runTest("CWE190_Integer_Overflow__int_Environment_postinc_11");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_max_postinc_12()).runTest("CWE190_Integer_Overflow__byte_max_postinc_12");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_rand_postinc_15()).runTest("CWE190_Integer_Overflow__short_rand_postinc_15");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_console_readLine_postinc_66a()).runTest("CWE190_Integer_Overflow__byte_console_readLine_postinc_66a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_max_postinc_11()).runTest("CWE190_Integer_Overflow__int_max_postinc_11");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_random_postinc_07()).runTest("CWE190_Integer_Overflow__int_random_postinc_07");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_URLConnection_postinc_12()).runTest("CWE190_Integer_Overflow__int_URLConnection_postinc_12");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Property_postinc_08()).runTest("CWE190_Integer_Overflow__int_Property_postinc_08");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_max_postinc_51a()).runTest("CWE190_Integer_Overflow__short_max_postinc_51a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_rand_postinc_02()).runTest("CWE190_Integer_Overflow__long_rand_postinc_02");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_rand_postinc_73a()).runTest("CWE190_Integer_Overflow__byte_rand_postinc_73a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_File_postinc_61a()).runTest("CWE190_Integer_Overflow__int_File_postinc_61a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_console_readLine_postinc_73a()).runTest("CWE190_Integer_Overflow__short_console_readLine_postinc_73a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_max_postinc_81a()).runTest("CWE190_Integer_Overflow__short_max_postinc_81a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_database_postinc_31()).runTest("CWE190_Integer_Overflow__int_database_postinc_31");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_console_readLine_postinc_14()).runTest("CWE190_Integer_Overflow__int_console_readLine_postinc_14");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_console_readLine_postinc_03()).runTest("CWE190_Integer_Overflow__short_console_readLine_postinc_03");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_console_readLine_postinc_11()).runTest("CWE190_Integer_Overflow__int_console_readLine_postinc_11");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Environment_postinc_10()).runTest("CWE190_Integer_Overflow__int_Environment_postinc_10");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_listen_tcp_postinc_02()).runTest("CWE190_Integer_Overflow__int_listen_tcp_postinc_02");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Environment_postinc_04()).runTest("CWE190_Integer_Overflow__int_Environment_postinc_04");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_File_postinc_14()).runTest("CWE190_Integer_Overflow__int_File_postinc_14");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_console_readLine_postinc_54a()).runTest("CWE190_Integer_Overflow__byte_console_readLine_postinc_54a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_rand_postinc_03()).runTest("CWE190_Integer_Overflow__short_rand_postinc_03");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_console_readLine_postinc_71a()).runTest("CWE190_Integer_Overflow__long_console_readLine_postinc_71a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Property_postinc_05()).runTest("CWE190_Integer_Overflow__int_Property_postinc_05");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_listen_tcp_postinc_61a()).runTest("CWE190_Integer_Overflow__int_listen_tcp_postinc_61a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_max_postinc_15()).runTest("CWE190_Integer_Overflow__int_max_postinc_15");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_rand_postinc_61a()).runTest("CWE190_Integer_Overflow__byte_rand_postinc_61a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_rand_postinc_03()).runTest("CWE190_Integer_Overflow__long_rand_postinc_03");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_max_postinc_71a()).runTest("CWE190_Integer_Overflow__short_max_postinc_71a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_random_postinc_81a()).runTest("CWE190_Integer_Overflow__int_random_postinc_81a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Property_postinc_54a()).runTest("CWE190_Integer_Overflow__int_Property_postinc_54a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_rand_postinc_75a()).runTest("CWE190_Integer_Overflow__short_rand_postinc_75a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_console_readLine_postinc_51a()).runTest("CWE190_Integer_Overflow__long_console_readLine_postinc_51a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_database_postinc_21()).runTest("CWE190_Integer_Overflow__int_database_postinc_21");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_console_readLine_postinc_07()).runTest("CWE190_Integer_Overflow__short_console_readLine_postinc_07");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_console_readLine_postinc_17()).runTest("CWE190_Integer_Overflow__int_console_readLine_postinc_17");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_URLConnection_postinc_06()).runTest("CWE190_Integer_Overflow__int_URLConnection_postinc_06");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_max_postinc_13()).runTest("CWE190_Integer_Overflow__byte_max_postinc_13");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_rand_postinc_54a()).runTest("CWE190_Integer_Overflow__short_rand_postinc_54a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_max_postinc_74a()).runTest("CWE190_Integer_Overflow__short_max_postinc_74a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_rand_postinc_52a()).runTest("CWE190_Integer_Overflow__short_rand_postinc_52a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_File_postinc_11()).runTest("CWE190_Integer_Overflow__int_File_postinc_11");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Environment_postinc_13()).runTest("CWE190_Integer_Overflow__int_Environment_postinc_13");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_console_readLine_postinc_13()).runTest("CWE190_Integer_Overflow__int_console_readLine_postinc_13");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_rand_postinc_12()).runTest("CWE190_Integer_Overflow__byte_rand_postinc_12");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_console_readLine_postinc_12()).runTest("CWE190_Integer_Overflow__byte_console_readLine_postinc_12");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_File_postinc_54a()).runTest("CWE190_Integer_Overflow__int_File_postinc_54a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_max_postinc_21()).runTest("CWE190_Integer_Overflow__int_max_postinc_21");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_database_postinc_07()).runTest("CWE190_Integer_Overflow__int_database_postinc_07");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_rand_postinc_10()).runTest("CWE190_Integer_Overflow__short_rand_postinc_10");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_max_postinc_11()).runTest("CWE190_Integer_Overflow__byte_max_postinc_11");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_console_readLine_postinc_41()).runTest("CWE190_Integer_Overflow__long_console_readLine_postinc_41");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_console_readLine_postinc_05()).runTest("CWE190_Integer_Overflow__int_console_readLine_postinc_05");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_File_postinc_68a()).runTest("CWE190_Integer_Overflow__int_File_postinc_68a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_rand_postinc_74a()).runTest("CWE190_Integer_Overflow__short_rand_postinc_74a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_connect_tcp_postinc_42()).runTest("CWE190_Integer_Overflow__int_connect_tcp_postinc_42");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_console_readLine_postinc_81a()).runTest("CWE190_Integer_Overflow__long_console_readLine_postinc_81a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_max_postinc_45()).runTest("CWE190_Integer_Overflow__long_max_postinc_45");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_listen_tcp_postinc_45()).runTest("CWE190_Integer_Overflow__int_listen_tcp_postinc_45");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_random_postinc_01()).runTest("CWE190_Integer_Overflow__int_random_postinc_01");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_console_readLine_postinc_04()).runTest("CWE190_Integer_Overflow__byte_console_readLine_postinc_04");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Environment_postinc_05()).runTest("CWE190_Integer_Overflow__int_Environment_postinc_05");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_rand_postinc_45()).runTest("CWE190_Integer_Overflow__long_rand_postinc_45");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_PropertiesFile_postinc_14()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_postinc_14");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_rand_postinc_21()).runTest("CWE190_Integer_Overflow__byte_rand_postinc_21");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_max_postinc_15()).runTest("CWE190_Integer_Overflow__long_max_postinc_15");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_URLConnection_postinc_01()).runTest("CWE190_Integer_Overflow__int_URLConnection_postinc_01");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_max_postinc_02()).runTest("CWE190_Integer_Overflow__byte_max_postinc_02");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_max_postinc_13()).runTest("CWE190_Integer_Overflow__short_max_postinc_13");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_connect_tcp_postinc_15()).runTest("CWE190_Integer_Overflow__int_connect_tcp_postinc_15");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_console_readLine_postinc_51a()).runTest("CWE190_Integer_Overflow__short_console_readLine_postinc_51a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_database_postinc_75a()).runTest("CWE190_Integer_Overflow__int_database_postinc_75a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Property_postinc_10()).runTest("CWE190_Integer_Overflow__int_Property_postinc_10");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Property_postinc_22a()).runTest("CWE190_Integer_Overflow__int_Property_postinc_22a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Property_postinc_53a()).runTest("CWE190_Integer_Overflow__int_Property_postinc_53a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_database_postinc_06()).runTest("CWE190_Integer_Overflow__int_database_postinc_06");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_rand_postinc_72a()).runTest("CWE190_Integer_Overflow__long_rand_postinc_72a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_max_postinc_51a()).runTest("CWE190_Integer_Overflow__long_max_postinc_51a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_database_postinc_45()).runTest("CWE190_Integer_Overflow__int_database_postinc_45");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_rand_postinc_04()).runTest("CWE190_Integer_Overflow__short_rand_postinc_04");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Property_postinc_73a()).runTest("CWE190_Integer_Overflow__int_Property_postinc_73a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_console_readLine_postinc_09()).runTest("CWE190_Integer_Overflow__short_console_readLine_postinc_09");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_connect_tcp_postinc_01()).runTest("CWE190_Integer_Overflow__int_connect_tcp_postinc_01");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Property_postinc_41()).runTest("CWE190_Integer_Overflow__int_Property_postinc_41");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_database_postinc_10()).runTest("CWE190_Integer_Overflow__int_database_postinc_10");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_max_postinc_05()).runTest("CWE190_Integer_Overflow__byte_max_postinc_05");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_connect_tcp_postinc_16()).runTest("CWE190_Integer_Overflow__int_connect_tcp_postinc_16");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_max_postinc_05()).runTest("CWE190_Integer_Overflow__short_max_postinc_05");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_rand_postinc_45()).runTest("CWE190_Integer_Overflow__byte_rand_postinc_45");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_PropertiesFile_postinc_73a()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_postinc_73a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_console_readLine_postinc_06()).runTest("CWE190_Integer_Overflow__short_console_readLine_postinc_06");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_console_readLine_postinc_15()).runTest("CWE190_Integer_Overflow__byte_console_readLine_postinc_15");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_random_postinc_16()).runTest("CWE190_Integer_Overflow__int_random_postinc_16");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_listen_tcp_postinc_21()).runTest("CWE190_Integer_Overflow__int_listen_tcp_postinc_21");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_max_postinc_31()).runTest("CWE190_Integer_Overflow__long_max_postinc_31");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Environment_postinc_72a()).runTest("CWE190_Integer_Overflow__int_Environment_postinc_72a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_rand_postinc_01()).runTest("CWE190_Integer_Overflow__byte_rand_postinc_01");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_console_readLine_postinc_75a()).runTest("CWE190_Integer_Overflow__int_console_readLine_postinc_75a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_database_postinc_01()).runTest("CWE190_Integer_Overflow__int_database_postinc_01");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Property_postinc_61a()).runTest("CWE190_Integer_Overflow__int_Property_postinc_61a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_rand_postinc_61a()).runTest("CWE190_Integer_Overflow__short_rand_postinc_61a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_console_readLine_postinc_66a()).runTest("CWE190_Integer_Overflow__long_console_readLine_postinc_66a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_URLConnection_postinc_31()).runTest("CWE190_Integer_Overflow__int_URLConnection_postinc_31");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Property_postinc_16()).runTest("CWE190_Integer_Overflow__int_Property_postinc_16");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_console_readLine_postinc_73a()).runTest("CWE190_Integer_Overflow__long_console_readLine_postinc_73a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_max_postinc_17()).runTest("CWE190_Integer_Overflow__int_max_postinc_17");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_URLConnection_postinc_14()).runTest("CWE190_Integer_Overflow__int_URLConnection_postinc_14");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_max_postinc_53a()).runTest("CWE190_Integer_Overflow__short_max_postinc_53a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Property_postinc_14()).runTest("CWE190_Integer_Overflow__int_Property_postinc_14");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_console_readLine_postinc_21()).runTest("CWE190_Integer_Overflow__long_console_readLine_postinc_21");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_max_postinc_12()).runTest("CWE190_Integer_Overflow__int_max_postinc_12");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_max_postinc_22a()).runTest("CWE190_Integer_Overflow__int_max_postinc_22a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_File_postinc_17()).runTest("CWE190_Integer_Overflow__int_File_postinc_17");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_max_postinc_61a()).runTest("CWE190_Integer_Overflow__byte_max_postinc_61a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_URLConnection_postinc_11()).runTest("CWE190_Integer_Overflow__int_URLConnection_postinc_11");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_console_readLine_postinc_13()).runTest("CWE190_Integer_Overflow__byte_console_readLine_postinc_13");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_rand_postinc_14()).runTest("CWE190_Integer_Overflow__long_rand_postinc_14");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_random_postinc_10()).runTest("CWE190_Integer_Overflow__int_random_postinc_10");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Environment_postinc_67a()).runTest("CWE190_Integer_Overflow__int_Environment_postinc_67a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_database_postinc_81a()).runTest("CWE190_Integer_Overflow__int_database_postinc_81a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_rand_postinc_15()).runTest("CWE190_Integer_Overflow__long_rand_postinc_15");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_listen_tcp_postinc_54a()).runTest("CWE190_Integer_Overflow__int_listen_tcp_postinc_54a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_max_postinc_66a()).runTest("CWE190_Integer_Overflow__byte_max_postinc_66a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Environment_postinc_15()).runTest("CWE190_Integer_Overflow__int_Environment_postinc_15");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_max_postinc_68a()).runTest("CWE190_Integer_Overflow__byte_max_postinc_68a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_database_postinc_51a()).runTest("CWE190_Integer_Overflow__int_database_postinc_51a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_listen_tcp_postinc_66a()).runTest("CWE190_Integer_Overflow__int_listen_tcp_postinc_66a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_URLConnection_postinc_05()).runTest("CWE190_Integer_Overflow__int_URLConnection_postinc_05");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_rand_postinc_02()).runTest("CWE190_Integer_Overflow__short_rand_postinc_02");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_max_postinc_07()).runTest("CWE190_Integer_Overflow__long_max_postinc_07");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_database_postinc_54a()).runTest("CWE190_Integer_Overflow__int_database_postinc_54a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_max_postinc_71a()).runTest("CWE190_Integer_Overflow__long_max_postinc_71a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_URLConnection_postinc_16()).runTest("CWE190_Integer_Overflow__int_URLConnection_postinc_16");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_URLConnection_postinc_67a()).runTest("CWE190_Integer_Overflow__int_URLConnection_postinc_67a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_console_readLine_postinc_72a()).runTest("CWE190_Integer_Overflow__int_console_readLine_postinc_72a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_rand_postinc_68a()).runTest("CWE190_Integer_Overflow__short_rand_postinc_68a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_console_readLine_postinc_11()).runTest("CWE190_Integer_Overflow__byte_console_readLine_postinc_11");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_console_readLine_postinc_54a()).runTest("CWE190_Integer_Overflow__short_console_readLine_postinc_54a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_console_readLine_postinc_81a()).runTest("CWE190_Integer_Overflow__short_console_readLine_postinc_81a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_console_readLine_postinc_81a()).runTest("CWE190_Integer_Overflow__byte_console_readLine_postinc_81a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_random_postinc_61a()).runTest("CWE190_Integer_Overflow__int_random_postinc_61a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_connect_tcp_postinc_09()).runTest("CWE190_Integer_Overflow__int_connect_tcp_postinc_09");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_console_readLine_postinc_22a()).runTest("CWE190_Integer_Overflow__byte_console_readLine_postinc_22a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_console_readLine_postinc_42()).runTest("CWE190_Integer_Overflow__short_console_readLine_postinc_42");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_max_postinc_75a()).runTest("CWE190_Integer_Overflow__int_max_postinc_75a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_listen_tcp_postinc_14()).runTest("CWE190_Integer_Overflow__int_listen_tcp_postinc_14");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_console_readLine_postinc_08()).runTest("CWE190_Integer_Overflow__int_console_readLine_postinc_08");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_PropertiesFile_postinc_09()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_postinc_09");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_console_readLine_postinc_74a()).runTest("CWE190_Integer_Overflow__int_console_readLine_postinc_74a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_rand_postinc_72a()).runTest("CWE190_Integer_Overflow__short_rand_postinc_72a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_PropertiesFile_postinc_08()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_postinc_08");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_database_postinc_67a()).runTest("CWE190_Integer_Overflow__int_database_postinc_67a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_rand_postinc_08()).runTest("CWE190_Integer_Overflow__short_rand_postinc_08");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_File_postinc_06()).runTest("CWE190_Integer_Overflow__int_File_postinc_06");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_max_postinc_04()).runTest("CWE190_Integer_Overflow__int_max_postinc_04");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_max_postinc_66a()).runTest("CWE190_Integer_Overflow__short_max_postinc_66a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_listen_tcp_postinc_01()).runTest("CWE190_Integer_Overflow__int_listen_tcp_postinc_01");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_rand_postinc_22a()).runTest("CWE190_Integer_Overflow__byte_rand_postinc_22a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_console_readLine_postinc_12()).runTest("CWE190_Integer_Overflow__long_console_readLine_postinc_12");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_rand_postinc_09()).runTest("CWE190_Integer_Overflow__long_rand_postinc_09");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Property_postinc_09()).runTest("CWE190_Integer_Overflow__int_Property_postinc_09");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_console_readLine_postinc_07()).runTest("CWE190_Integer_Overflow__byte_console_readLine_postinc_07");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_random_postinc_42()).runTest("CWE190_Integer_Overflow__int_random_postinc_42");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_max_postinc_73a()).runTest("CWE190_Integer_Overflow__byte_max_postinc_73a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_max_postinc_54a()).runTest("CWE190_Integer_Overflow__long_max_postinc_54a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_rand_postinc_04()).runTest("CWE190_Integer_Overflow__byte_rand_postinc_04");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_connect_tcp_postinc_08()).runTest("CWE190_Integer_Overflow__int_connect_tcp_postinc_08");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_console_readLine_postinc_02()).runTest("CWE190_Integer_Overflow__byte_console_readLine_postinc_02");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_max_postinc_21()).runTest("CWE190_Integer_Overflow__long_max_postinc_21");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_database_postinc_09()).runTest("CWE190_Integer_Overflow__int_database_postinc_09");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Property_postinc_06()).runTest("CWE190_Integer_Overflow__int_Property_postinc_06");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Environment_postinc_53a()).runTest("CWE190_Integer_Overflow__int_Environment_postinc_53a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_console_readLine_postinc_81a()).runTest("CWE190_Integer_Overflow__int_console_readLine_postinc_81a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_File_postinc_67a()).runTest("CWE190_Integer_Overflow__int_File_postinc_67a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Environment_postinc_81a()).runTest("CWE190_Integer_Overflow__int_Environment_postinc_81a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_max_postinc_73a()).runTest("CWE190_Integer_Overflow__long_max_postinc_73a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Environment_postinc_66a()).runTest("CWE190_Integer_Overflow__int_Environment_postinc_66a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_max_postinc_45()).runTest("CWE190_Integer_Overflow__byte_max_postinc_45");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_max_postinc_15()).runTest("CWE190_Integer_Overflow__byte_max_postinc_15");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_rand_postinc_42()).runTest("CWE190_Integer_Overflow__byte_rand_postinc_42");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_max_postinc_72a()).runTest("CWE190_Integer_Overflow__int_max_postinc_72a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_File_postinc_75a()).runTest("CWE190_Integer_Overflow__int_File_postinc_75a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Environment_postinc_01()).runTest("CWE190_Integer_Overflow__int_Environment_postinc_01");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_max_postinc_08()).runTest("CWE190_Integer_Overflow__byte_max_postinc_08");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Environment_postinc_14()).runTest("CWE190_Integer_Overflow__int_Environment_postinc_14");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_database_postinc_03()).runTest("CWE190_Integer_Overflow__int_database_postinc_03");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Property_postinc_21()).runTest("CWE190_Integer_Overflow__int_Property_postinc_21");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_console_readLine_postinc_01()).runTest("CWE190_Integer_Overflow__byte_console_readLine_postinc_01");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_rand_postinc_54a()).runTest("CWE190_Integer_Overflow__long_rand_postinc_54a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_console_readLine_postinc_45()).runTest("CWE190_Integer_Overflow__long_console_readLine_postinc_45");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_console_readLine_postinc_06()).runTest("CWE190_Integer_Overflow__long_console_readLine_postinc_06");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_connect_tcp_postinc_41()).runTest("CWE190_Integer_Overflow__int_connect_tcp_postinc_41");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_max_postinc_41()).runTest("CWE190_Integer_Overflow__int_max_postinc_41");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_rand_postinc_71a()).runTest("CWE190_Integer_Overflow__long_rand_postinc_71a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_max_postinc_52a()).runTest("CWE190_Integer_Overflow__int_max_postinc_52a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_max_postinc_13()).runTest("CWE190_Integer_Overflow__long_max_postinc_13");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_rand_postinc_81a()).runTest("CWE190_Integer_Overflow__short_rand_postinc_81a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_File_postinc_51a()).runTest("CWE190_Integer_Overflow__int_File_postinc_51a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_File_postinc_22a()).runTest("CWE190_Integer_Overflow__int_File_postinc_22a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_console_readLine_postinc_17()).runTest("CWE190_Integer_Overflow__byte_console_readLine_postinc_17");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Environment_postinc_51a()).runTest("CWE190_Integer_Overflow__int_Environment_postinc_51a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_database_postinc_15()).runTest("CWE190_Integer_Overflow__int_database_postinc_15");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_connect_tcp_postinc_17()).runTest("CWE190_Integer_Overflow__int_connect_tcp_postinc_17");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_PropertiesFile_postinc_52a()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_postinc_52a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_URLConnection_postinc_54a()).runTest("CWE190_Integer_Overflow__int_URLConnection_postinc_54a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_max_postinc_41()).runTest("CWE190_Integer_Overflow__long_max_postinc_41");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Property_postinc_67a()).runTest("CWE190_Integer_Overflow__int_Property_postinc_67a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_console_readLine_postinc_16()).runTest("CWE190_Integer_Overflow__int_console_readLine_postinc_16");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_connect_tcp_postinc_31()).runTest("CWE190_Integer_Overflow__int_connect_tcp_postinc_31");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_rand_postinc_61a()).runTest("CWE190_Integer_Overflow__long_rand_postinc_61a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_max_postinc_81a()).runTest("CWE190_Integer_Overflow__int_max_postinc_81a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Environment_postinc_17()).runTest("CWE190_Integer_Overflow__int_Environment_postinc_17");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Environment_postinc_54a()).runTest("CWE190_Integer_Overflow__int_Environment_postinc_54a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_max_postinc_11()).runTest("CWE190_Integer_Overflow__short_max_postinc_11");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_max_postinc_16()).runTest("CWE190_Integer_Overflow__int_max_postinc_16");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_connect_tcp_postinc_04()).runTest("CWE190_Integer_Overflow__int_connect_tcp_postinc_04");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_max_postinc_11()).runTest("CWE190_Integer_Overflow__long_max_postinc_11");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_console_readLine_postinc_66a()).runTest("CWE190_Integer_Overflow__int_console_readLine_postinc_66a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_console_readLine_postinc_53a()).runTest("CWE190_Integer_Overflow__byte_console_readLine_postinc_53a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_max_postinc_75a()).runTest("CWE190_Integer_Overflow__short_max_postinc_75a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_max_postinc_03()).runTest("CWE190_Integer_Overflow__byte_max_postinc_03");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_database_postinc_66a()).runTest("CWE190_Integer_Overflow__int_database_postinc_66a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_database_postinc_05()).runTest("CWE190_Integer_Overflow__int_database_postinc_05");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_console_readLine_postinc_05()).runTest("CWE190_Integer_Overflow__short_console_readLine_postinc_05");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_max_postinc_54a()).runTest("CWE190_Integer_Overflow__short_max_postinc_54a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_console_readLine_postinc_67a()).runTest("CWE190_Integer_Overflow__int_console_readLine_postinc_67a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_console_readLine_postinc_14()).runTest("CWE190_Integer_Overflow__long_console_readLine_postinc_14");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_console_readLine_postinc_68a()).runTest("CWE190_Integer_Overflow__byte_console_readLine_postinc_68a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_console_readLine_postinc_72a()).runTest("CWE190_Integer_Overflow__byte_console_readLine_postinc_72a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_random_postinc_12()).runTest("CWE190_Integer_Overflow__int_random_postinc_12");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_console_readLine_postinc_68a()).runTest("CWE190_Integer_Overflow__int_console_readLine_postinc_68a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_console_readLine_postinc_05()).runTest("CWE190_Integer_Overflow__byte_console_readLine_postinc_05");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_console_readLine_postinc_12()).runTest("CWE190_Integer_Overflow__int_console_readLine_postinc_12");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_rand_postinc_68a()).runTest("CWE190_Integer_Overflow__long_rand_postinc_68a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_console_readLine_postinc_04()).runTest("CWE190_Integer_Overflow__int_console_readLine_postinc_04");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_max_postinc_53a()).runTest("CWE190_Integer_Overflow__byte_max_postinc_53a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_database_postinc_68a()).runTest("CWE190_Integer_Overflow__int_database_postinc_68a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_URLConnection_postinc_45()).runTest("CWE190_Integer_Overflow__int_URLConnection_postinc_45");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_URLConnection_postinc_17()).runTest("CWE190_Integer_Overflow__int_URLConnection_postinc_17");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_listen_tcp_postinc_81a()).runTest("CWE190_Integer_Overflow__int_listen_tcp_postinc_81a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_database_postinc_22a()).runTest("CWE190_Integer_Overflow__int_database_postinc_22a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_rand_postinc_12()).runTest("CWE190_Integer_Overflow__long_rand_postinc_12");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_rand_postinc_01()).runTest("CWE190_Integer_Overflow__long_rand_postinc_01");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_PropertiesFile_postinc_72a()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_postinc_72a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_max_postinc_67a()).runTest("CWE190_Integer_Overflow__long_max_postinc_67a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Environment_postinc_22a()).runTest("CWE190_Integer_Overflow__int_Environment_postinc_22a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Environment_postinc_08()).runTest("CWE190_Integer_Overflow__int_Environment_postinc_08");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Property_postinc_71a()).runTest("CWE190_Integer_Overflow__int_Property_postinc_71a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_console_readLine_postinc_61a()).runTest("CWE190_Integer_Overflow__int_console_readLine_postinc_61a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_max_postinc_08()).runTest("CWE190_Integer_Overflow__int_max_postinc_08");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_console_readLine_postinc_10()).runTest("CWE190_Integer_Overflow__byte_console_readLine_postinc_10");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Environment_postinc_21()).runTest("CWE190_Integer_Overflow__int_Environment_postinc_21");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Environment_postinc_02()).runTest("CWE190_Integer_Overflow__int_Environment_postinc_02");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_rand_postinc_71a()).runTest("CWE190_Integer_Overflow__short_rand_postinc_71a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_console_readLine_postinc_16()).runTest("CWE190_Integer_Overflow__short_console_readLine_postinc_16");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_PropertiesFile_postinc_41()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_postinc_41");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_PropertiesFile_postinc_67a()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_postinc_67a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_max_postinc_05()).runTest("CWE190_Integer_Overflow__long_max_postinc_05");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_URLConnection_postinc_51a()).runTest("CWE190_Integer_Overflow__int_URLConnection_postinc_51a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_max_postinc_12()).runTest("CWE190_Integer_Overflow__short_max_postinc_12");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_max_postinc_04()).runTest("CWE190_Integer_Overflow__short_max_postinc_04");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_console_readLine_postinc_73a()).runTest("CWE190_Integer_Overflow__byte_console_readLine_postinc_73a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_rand_postinc_06()).runTest("CWE190_Integer_Overflow__byte_rand_postinc_06");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_console_readLine_postinc_68a()).runTest("CWE190_Integer_Overflow__long_console_readLine_postinc_68a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_database_postinc_61a()).runTest("CWE190_Integer_Overflow__int_database_postinc_61a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_PropertiesFile_postinc_11()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_postinc_11");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_PropertiesFile_postinc_75a()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_postinc_75a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_console_readLine_postinc_52a()).runTest("CWE190_Integer_Overflow__short_console_readLine_postinc_52a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Property_postinc_12()).runTest("CWE190_Integer_Overflow__int_Property_postinc_12");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_max_postinc_31()).runTest("CWE190_Integer_Overflow__int_max_postinc_31");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_listen_tcp_postinc_17()).runTest("CWE190_Integer_Overflow__int_listen_tcp_postinc_17");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_PropertiesFile_postinc_31()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_postinc_31");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_connect_tcp_postinc_11()).runTest("CWE190_Integer_Overflow__int_connect_tcp_postinc_11");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_random_postinc_72a()).runTest("CWE190_Integer_Overflow__int_random_postinc_72a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_max_postinc_42()).runTest("CWE190_Integer_Overflow__int_max_postinc_42");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_rand_postinc_52a()).runTest("CWE190_Integer_Overflow__byte_rand_postinc_52a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Property_postinc_01()).runTest("CWE190_Integer_Overflow__int_Property_postinc_01");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Property_postinc_02()).runTest("CWE190_Integer_Overflow__int_Property_postinc_02");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_rand_postinc_52a()).runTest("CWE190_Integer_Overflow__long_rand_postinc_52a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_PropertiesFile_postinc_45()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_postinc_45");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_database_postinc_71a()).runTest("CWE190_Integer_Overflow__int_database_postinc_71a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_URLConnection_postinc_71a()).runTest("CWE190_Integer_Overflow__int_URLConnection_postinc_71a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Property_postinc_03()).runTest("CWE190_Integer_Overflow__int_Property_postinc_03");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_console_readLine_postinc_21()).runTest("CWE190_Integer_Overflow__int_console_readLine_postinc_21");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_listen_tcp_postinc_52a()).runTest("CWE190_Integer_Overflow__int_listen_tcp_postinc_52a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Environment_postinc_45()).runTest("CWE190_Integer_Overflow__int_Environment_postinc_45");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_rand_postinc_16()).runTest("CWE190_Integer_Overflow__short_rand_postinc_16");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_rand_postinc_72a()).runTest("CWE190_Integer_Overflow__byte_rand_postinc_72a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_URLConnection_postinc_61a()).runTest("CWE190_Integer_Overflow__int_URLConnection_postinc_61a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_URLConnection_postinc_03()).runTest("CWE190_Integer_Overflow__int_URLConnection_postinc_03");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_random_postinc_67a()).runTest("CWE190_Integer_Overflow__int_random_postinc_67a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_console_readLine_postinc_67a()).runTest("CWE190_Integer_Overflow__long_console_readLine_postinc_67a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Property_postinc_68a()).runTest("CWE190_Integer_Overflow__int_Property_postinc_68a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_console_readLine_postinc_01()).runTest("CWE190_Integer_Overflow__short_console_readLine_postinc_01");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Property_postinc_72a()).runTest("CWE190_Integer_Overflow__int_Property_postinc_72a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_rand_postinc_67a()).runTest("CWE190_Integer_Overflow__byte_rand_postinc_67a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_console_readLine_postinc_22a()).runTest("CWE190_Integer_Overflow__short_console_readLine_postinc_22a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_PropertiesFile_postinc_66a()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_postinc_66a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_console_readLine_postinc_10()).runTest("CWE190_Integer_Overflow__long_console_readLine_postinc_10");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_max_postinc_09()).runTest("CWE190_Integer_Overflow__int_max_postinc_09");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Property_postinc_11()).runTest("CWE190_Integer_Overflow__int_Property_postinc_11");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_random_postinc_21()).runTest("CWE190_Integer_Overflow__int_random_postinc_21");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_max_postinc_21()).runTest("CWE190_Integer_Overflow__byte_max_postinc_21");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Property_postinc_31()).runTest("CWE190_Integer_Overflow__int_Property_postinc_31");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_PropertiesFile_postinc_01()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_postinc_01");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_max_postinc_02()).runTest("CWE190_Integer_Overflow__int_max_postinc_02");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_listen_tcp_postinc_68a()).runTest("CWE190_Integer_Overflow__int_listen_tcp_postinc_68a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_max_postinc_17()).runTest("CWE190_Integer_Overflow__long_max_postinc_17");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_console_readLine_postinc_67a()).runTest("CWE190_Integer_Overflow__short_console_readLine_postinc_67a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_console_readLine_postinc_08()).runTest("CWE190_Integer_Overflow__short_console_readLine_postinc_08");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_console_readLine_postinc_74a()).runTest("CWE190_Integer_Overflow__byte_console_readLine_postinc_74a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_max_postinc_52a()).runTest("CWE190_Integer_Overflow__short_max_postinc_52a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_database_postinc_08()).runTest("CWE190_Integer_Overflow__int_database_postinc_08");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_max_postinc_10()).runTest("CWE190_Integer_Overflow__int_max_postinc_10");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_console_readLine_postinc_31()).runTest("CWE190_Integer_Overflow__int_console_readLine_postinc_31");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_console_readLine_postinc_01()).runTest("CWE190_Integer_Overflow__long_console_readLine_postinc_01");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Environment_postinc_03()).runTest("CWE190_Integer_Overflow__int_Environment_postinc_03");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_rand_postinc_16()).runTest("CWE190_Integer_Overflow__long_rand_postinc_16");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_rand_postinc_74a()).runTest("CWE190_Integer_Overflow__byte_rand_postinc_74a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_database_postinc_72a()).runTest("CWE190_Integer_Overflow__int_database_postinc_72a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_rand_postinc_22a()).runTest("CWE190_Integer_Overflow__long_rand_postinc_22a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_max_postinc_10()).runTest("CWE190_Integer_Overflow__short_max_postinc_10");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_console_readLine_postinc_06()).runTest("CWE190_Integer_Overflow__byte_console_readLine_postinc_06");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_random_postinc_04()).runTest("CWE190_Integer_Overflow__int_random_postinc_04");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_console_readLine_postinc_01()).runTest("CWE190_Integer_Overflow__int_console_readLine_postinc_01");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_File_postinc_16()).runTest("CWE190_Integer_Overflow__int_File_postinc_16");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Environment_postinc_61a()).runTest("CWE190_Integer_Overflow__int_Environment_postinc_61a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_PropertiesFile_postinc_13()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_postinc_13");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_console_readLine_postinc_52a()).runTest("CWE190_Integer_Overflow__int_console_readLine_postinc_52a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Property_postinc_17()).runTest("CWE190_Integer_Overflow__int_Property_postinc_17");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_max_postinc_52a()).runTest("CWE190_Integer_Overflow__byte_max_postinc_52a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_max_postinc_08()).runTest("CWE190_Integer_Overflow__short_max_postinc_08");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_max_postinc_01()).runTest("CWE190_Integer_Overflow__int_max_postinc_01");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_rand_postinc_16()).runTest("CWE190_Integer_Overflow__byte_rand_postinc_16");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_rand_postinc_81a()).runTest("CWE190_Integer_Overflow__long_rand_postinc_81a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_random_postinc_14()).runTest("CWE190_Integer_Overflow__int_random_postinc_14");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_rand_postinc_41()).runTest("CWE190_Integer_Overflow__long_rand_postinc_41");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_listen_tcp_postinc_05()).runTest("CWE190_Integer_Overflow__int_listen_tcp_postinc_05");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_rand_postinc_06()).runTest("CWE190_Integer_Overflow__long_rand_postinc_06");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_random_postinc_45()).runTest("CWE190_Integer_Overflow__int_random_postinc_45");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_rand_postinc_41()).runTest("CWE190_Integer_Overflow__byte_rand_postinc_41");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_max_postinc_42()).runTest("CWE190_Integer_Overflow__short_max_postinc_42");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_console_readLine_postinc_31()).runTest("CWE190_Integer_Overflow__byte_console_readLine_postinc_31");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_console_readLine_postinc_51a()).runTest("CWE190_Integer_Overflow__byte_console_readLine_postinc_51a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_max_postinc_22a()).runTest("CWE190_Integer_Overflow__long_max_postinc_22a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_max_postinc_54a()).runTest("CWE190_Integer_Overflow__int_max_postinc_54a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_PropertiesFile_postinc_06()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_postinc_06");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_max_postinc_75a()).runTest("CWE190_Integer_Overflow__byte_max_postinc_75a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Environment_postinc_12()).runTest("CWE190_Integer_Overflow__int_Environment_postinc_12");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Environment_postinc_73a()).runTest("CWE190_Integer_Overflow__int_Environment_postinc_73a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_listen_tcp_postinc_04()).runTest("CWE190_Integer_Overflow__int_listen_tcp_postinc_04");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_max_postinc_12()).runTest("CWE190_Integer_Overflow__long_max_postinc_12");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_console_readLine_postinc_11()).runTest("CWE190_Integer_Overflow__long_console_readLine_postinc_11");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_max_postinc_81a()).runTest("CWE190_Integer_Overflow__long_max_postinc_81a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_console_readLine_postinc_03()).runTest("CWE190_Integer_Overflow__int_console_readLine_postinc_03");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_max_postinc_51a()).runTest("CWE190_Integer_Overflow__byte_max_postinc_51a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_max_postinc_02()).runTest("CWE190_Integer_Overflow__long_max_postinc_02");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_listen_tcp_postinc_06()).runTest("CWE190_Integer_Overflow__int_listen_tcp_postinc_06");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_console_readLine_postinc_71a()).runTest("CWE190_Integer_Overflow__int_console_readLine_postinc_71a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_console_readLine_postinc_22a()).runTest("CWE190_Integer_Overflow__long_console_readLine_postinc_22a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_max_postinc_15()).runTest("CWE190_Integer_Overflow__short_max_postinc_15");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_rand_postinc_66a()).runTest("CWE190_Integer_Overflow__long_rand_postinc_66a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_listen_tcp_postinc_41()).runTest("CWE190_Integer_Overflow__int_listen_tcp_postinc_41");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_rand_postinc_10()).runTest("CWE190_Integer_Overflow__long_rand_postinc_10");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_rand_postinc_66a()).runTest("CWE190_Integer_Overflow__byte_rand_postinc_66a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_rand_postinc_68a()).runTest("CWE190_Integer_Overflow__byte_rand_postinc_68a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_database_postinc_17()).runTest("CWE190_Integer_Overflow__int_database_postinc_17");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_console_readLine_postinc_75a()).runTest("CWE190_Integer_Overflow__long_console_readLine_postinc_75a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_console_readLine_postinc_13()).runTest("CWE190_Integer_Overflow__long_console_readLine_postinc_13");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_console_readLine_postinc_11()).runTest("CWE190_Integer_Overflow__short_console_readLine_postinc_11");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_console_readLine_postinc_53a()).runTest("CWE190_Integer_Overflow__long_console_readLine_postinc_53a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_File_postinc_01()).runTest("CWE190_Integer_Overflow__int_File_postinc_01");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_rand_postinc_05()).runTest("CWE190_Integer_Overflow__long_rand_postinc_05");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_rand_postinc_07()).runTest("CWE190_Integer_Overflow__byte_rand_postinc_07");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_max_postinc_06()).runTest("CWE190_Integer_Overflow__byte_max_postinc_06");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_console_readLine_postinc_02()).runTest("CWE190_Integer_Overflow__short_console_readLine_postinc_02");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_max_postinc_04()).runTest("CWE190_Integer_Overflow__byte_max_postinc_04");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_max_postinc_74a()).runTest("CWE190_Integer_Overflow__int_max_postinc_74a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Environment_postinc_68a()).runTest("CWE190_Integer_Overflow__int_Environment_postinc_68a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_max_postinc_01()).runTest("CWE190_Integer_Overflow__long_max_postinc_01");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_max_postinc_54a()).runTest("CWE190_Integer_Overflow__byte_max_postinc_54a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_URLConnection_postinc_41()).runTest("CWE190_Integer_Overflow__int_URLConnection_postinc_41");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_File_postinc_73a()).runTest("CWE190_Integer_Overflow__int_File_postinc_73a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_listen_tcp_postinc_11()).runTest("CWE190_Integer_Overflow__int_listen_tcp_postinc_11");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_listen_tcp_postinc_42()).runTest("CWE190_Integer_Overflow__int_listen_tcp_postinc_42");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_rand_postinc_42()).runTest("CWE190_Integer_Overflow__long_rand_postinc_42");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_random_postinc_54a()).runTest("CWE190_Integer_Overflow__int_random_postinc_54a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_max_postinc_61a()).runTest("CWE190_Integer_Overflow__short_max_postinc_61a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_listen_tcp_postinc_67a()).runTest("CWE190_Integer_Overflow__int_listen_tcp_postinc_67a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_rand_postinc_31()).runTest("CWE190_Integer_Overflow__short_rand_postinc_31");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_max_postinc_07()).runTest("CWE190_Integer_Overflow__int_max_postinc_07");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_max_postinc_09()).runTest("CWE190_Integer_Overflow__long_max_postinc_09");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_console_readLine_postinc_13()).runTest("CWE190_Integer_Overflow__short_console_readLine_postinc_13");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_rand_postinc_02()).runTest("CWE190_Integer_Overflow__byte_rand_postinc_02");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Environment_postinc_16()).runTest("CWE190_Integer_Overflow__int_Environment_postinc_16");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_rand_postinc_53a()).runTest("CWE190_Integer_Overflow__byte_rand_postinc_53a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_console_readLine_postinc_31()).runTest("CWE190_Integer_Overflow__long_console_readLine_postinc_31");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_max_postinc_66a()).runTest("CWE190_Integer_Overflow__long_max_postinc_66a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_database_postinc_02()).runTest("CWE190_Integer_Overflow__int_database_postinc_02");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_rand_postinc_08()).runTest("CWE190_Integer_Overflow__long_rand_postinc_08");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Property_postinc_66a()).runTest("CWE190_Integer_Overflow__int_Property_postinc_66a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_max_postinc_67a()).runTest("CWE190_Integer_Overflow__int_max_postinc_67a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_connect_tcp_postinc_51a()).runTest("CWE190_Integer_Overflow__int_connect_tcp_postinc_51a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_console_readLine_postinc_61a()).runTest("CWE190_Integer_Overflow__byte_console_readLine_postinc_61a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_File_postinc_08()).runTest("CWE190_Integer_Overflow__int_File_postinc_08");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_console_readLine_postinc_53a()).runTest("CWE190_Integer_Overflow__int_console_readLine_postinc_53a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_rand_postinc_41()).runTest("CWE190_Integer_Overflow__short_rand_postinc_41");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Property_postinc_45()).runTest("CWE190_Integer_Overflow__int_Property_postinc_45");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_PropertiesFile_postinc_74a()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_postinc_74a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_File_postinc_21()).runTest("CWE190_Integer_Overflow__int_File_postinc_21");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_URLConnection_postinc_75a()).runTest("CWE190_Integer_Overflow__int_URLConnection_postinc_75a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_max_postinc_08()).runTest("CWE190_Integer_Overflow__long_max_postinc_08");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_console_readLine_postinc_42()).runTest("CWE190_Integer_Overflow__byte_console_readLine_postinc_42");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_console_readLine_postinc_16()).runTest("CWE190_Integer_Overflow__byte_console_readLine_postinc_16");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_database_postinc_74a()).runTest("CWE190_Integer_Overflow__int_database_postinc_74a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_rand_postinc_17()).runTest("CWE190_Integer_Overflow__byte_rand_postinc_17");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_max_postinc_05()).runTest("CWE190_Integer_Overflow__int_max_postinc_05");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_rand_postinc_67a()).runTest("CWE190_Integer_Overflow__short_rand_postinc_67a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_max_postinc_61a()).runTest("CWE190_Integer_Overflow__int_max_postinc_61a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_console_readLine_postinc_66a()).runTest("CWE190_Integer_Overflow__short_console_readLine_postinc_66a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_console_readLine_postinc_07()).runTest("CWE190_Integer_Overflow__int_console_readLine_postinc_07");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_max_postinc_74a()).runTest("CWE190_Integer_Overflow__byte_max_postinc_74a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_console_readLine_postinc_75a()).runTest("CWE190_Integer_Overflow__byte_console_readLine_postinc_75a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_random_postinc_02()).runTest("CWE190_Integer_Overflow__int_random_postinc_02");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Property_postinc_75a()).runTest("CWE190_Integer_Overflow__int_Property_postinc_75a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Property_postinc_42()).runTest("CWE190_Integer_Overflow__int_Property_postinc_42");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Property_postinc_04()).runTest("CWE190_Integer_Overflow__int_Property_postinc_04");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_URLConnection_postinc_22a()).runTest("CWE190_Integer_Overflow__int_URLConnection_postinc_22a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_rand_postinc_42()).runTest("CWE190_Integer_Overflow__short_rand_postinc_42");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_listen_tcp_postinc_53a()).runTest("CWE190_Integer_Overflow__int_listen_tcp_postinc_53a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Environment_postinc_41()).runTest("CWE190_Integer_Overflow__int_Environment_postinc_41");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_max_postinc_72a()).runTest("CWE190_Integer_Overflow__long_max_postinc_72a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_console_readLine_postinc_16()).runTest("CWE190_Integer_Overflow__long_console_readLine_postinc_16");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_random_postinc_17()).runTest("CWE190_Integer_Overflow__int_random_postinc_17");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_console_readLine_postinc_61a()).runTest("CWE190_Integer_Overflow__long_console_readLine_postinc_61a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_console_readLine_postinc_42()).runTest("CWE190_Integer_Overflow__long_console_readLine_postinc_42");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_rand_postinc_75a()).runTest("CWE190_Integer_Overflow__long_rand_postinc_75a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_connect_tcp_postinc_73a()).runTest("CWE190_Integer_Overflow__int_connect_tcp_postinc_73a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_listen_tcp_postinc_10()).runTest("CWE190_Integer_Overflow__int_listen_tcp_postinc_10");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_PropertiesFile_postinc_61a()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_postinc_61a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_connect_tcp_postinc_74a()).runTest("CWE190_Integer_Overflow__int_connect_tcp_postinc_74a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_rand_postinc_21()).runTest("CWE190_Integer_Overflow__short_rand_postinc_21");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_console_readLine_postinc_54a()).runTest("CWE190_Integer_Overflow__int_console_readLine_postinc_54a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_console_readLine_postinc_73a()).runTest("CWE190_Integer_Overflow__int_console_readLine_postinc_73a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_rand_postinc_51a()).runTest("CWE190_Integer_Overflow__byte_rand_postinc_51a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Property_postinc_15()).runTest("CWE190_Integer_Overflow__int_Property_postinc_15");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_PropertiesFile_postinc_53a()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_postinc_53a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_max_postinc_16()).runTest("CWE190_Integer_Overflow__long_max_postinc_16");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_URLConnection_postinc_08()).runTest("CWE190_Integer_Overflow__int_URLConnection_postinc_08");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_database_postinc_11()).runTest("CWE190_Integer_Overflow__int_database_postinc_11");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_console_readLine_postinc_14()).runTest("CWE190_Integer_Overflow__byte_console_readLine_postinc_14");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_database_postinc_12()).runTest("CWE190_Integer_Overflow__int_database_postinc_12");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_listen_tcp_postinc_31()).runTest("CWE190_Integer_Overflow__int_listen_tcp_postinc_31");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_PropertiesFile_postinc_81a()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_postinc_81a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_random_postinc_09()).runTest("CWE190_Integer_Overflow__int_random_postinc_09");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_rand_postinc_51a()).runTest("CWE190_Integer_Overflow__short_rand_postinc_51a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_rand_postinc_14()).runTest("CWE190_Integer_Overflow__short_rand_postinc_14");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_console_readLine_postinc_68a()).runTest("CWE190_Integer_Overflow__short_console_readLine_postinc_68a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_max_postinc_72a()).runTest("CWE190_Integer_Overflow__short_max_postinc_72a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_rand_postinc_06()).runTest("CWE190_Integer_Overflow__short_rand_postinc_06");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_console_readLine_postinc_53a()).runTest("CWE190_Integer_Overflow__short_console_readLine_postinc_53a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_listen_tcp_postinc_16()).runTest("CWE190_Integer_Overflow__int_listen_tcp_postinc_16");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_connect_tcp_postinc_02()).runTest("CWE190_Integer_Overflow__int_connect_tcp_postinc_02");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_max_postinc_01()).runTest("CWE190_Integer_Overflow__short_max_postinc_01");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_max_postinc_41()).runTest("CWE190_Integer_Overflow__short_max_postinc_41");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_rand_postinc_71a()).runTest("CWE190_Integer_Overflow__byte_rand_postinc_71a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_database_postinc_52a()).runTest("CWE190_Integer_Overflow__int_database_postinc_52a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_rand_postinc_31()).runTest("CWE190_Integer_Overflow__byte_rand_postinc_31");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_File_postinc_10()).runTest("CWE190_Integer_Overflow__int_File_postinc_10");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_random_postinc_06()).runTest("CWE190_Integer_Overflow__int_random_postinc_06");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_max_postinc_68a()).runTest("CWE190_Integer_Overflow__short_max_postinc_68a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_connect_tcp_postinc_71a()).runTest("CWE190_Integer_Overflow__int_connect_tcp_postinc_71a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_URLConnection_postinc_66a()).runTest("CWE190_Integer_Overflow__int_URLConnection_postinc_66a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_random_postinc_71a()).runTest("CWE190_Integer_Overflow__int_random_postinc_71a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_console_readLine_postinc_61a()).runTest("CWE190_Integer_Overflow__short_console_readLine_postinc_61a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_rand_postinc_66a()).runTest("CWE190_Integer_Overflow__short_rand_postinc_66a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_URLConnection_postinc_53a()).runTest("CWE190_Integer_Overflow__int_URLConnection_postinc_53a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_rand_postinc_11()).runTest("CWE190_Integer_Overflow__long_rand_postinc_11");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_rand_postinc_10()).runTest("CWE190_Integer_Overflow__byte_rand_postinc_10");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_listen_tcp_postinc_08()).runTest("CWE190_Integer_Overflow__int_listen_tcp_postinc_08");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_URLConnection_postinc_52a()).runTest("CWE190_Integer_Overflow__int_URLConnection_postinc_52a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_random_postinc_68a()).runTest("CWE190_Integer_Overflow__int_random_postinc_68a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_File_postinc_74a()).runTest("CWE190_Integer_Overflow__int_File_postinc_74a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_console_readLine_postinc_21()).runTest("CWE190_Integer_Overflow__byte_console_readLine_postinc_21");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__long_max_postinc_06()).runTest("CWE190_Integer_Overflow__long_max_postinc_06");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_console_readLine_postinc_10()).runTest("CWE190_Integer_Overflow__int_console_readLine_postinc_10");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_rand_postinc_01()).runTest("CWE190_Integer_Overflow__short_rand_postinc_01");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_PropertiesFile_postinc_68a()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_postinc_68a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_rand_postinc_12()).runTest("CWE190_Integer_Overflow__short_rand_postinc_12");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_console_readLine_postinc_45()).runTest("CWE190_Integer_Overflow__byte_console_readLine_postinc_45");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__short_max_postinc_16()).runTest("CWE190_Integer_Overflow__short_max_postinc_16");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__byte_max_postinc_72a()).runTest("CWE190_Integer_Overflow__byte_max_postinc_72a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_random_postinc_52a()).runTest("CWE190_Integer_Overflow__int_random_postinc_52a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_random_postinc_53a()).runTest("CWE190_Integer_Overflow__int_random_postinc_53a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_console_readLine_postinc_02()).runTest("CWE190_Integer_Overflow__int_console_readLine_postinc_02");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_File_postinc_42()).runTest("CWE190_Integer_Overflow__int_File_postinc_42");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_Property_postinc_81a()).runTest("CWE190_Integer_Overflow__int_Property_postinc_81a");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_File_postinc_13()).runTest("CWE190_Integer_Overflow__int_File_postinc_13");
			(new testcases.CWE190_Integer_Overflow.s06.CWE190_Integer_Overflow__int_File_postinc_31()).runTest("CWE190_Integer_Overflow__int_File_postinc_31");
			/* END-AUTOGENERATED-JAVA-TESTS-1 */
}

private static void runTestCWE2() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-2 */

			/* END-AUTOGENERATED-JAVA-TESTS-2 */
}

private static void runTestCWE3() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-3 */

			/* END-AUTOGENERATED-JAVA-TESTS-3 */
}

private static void runTestCWE4() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-4 */

			/* END-AUTOGENERATED-JAVA-TESTS-4 */
}

private static void runTestCWE5() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-5 */

			/* END-AUTOGENERATED-JAVA-TESTS-5 */
}

private static void runTestCWE6() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-6 */

			/* END-AUTOGENERATED-JAVA-TESTS-6 */
}

private static void runTestCWE7() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-7 */

			/* END-AUTOGENERATED-JAVA-TESTS-7 */
}

private static void runTestCWE8() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-8 */

			/* END-AUTOGENERATED-JAVA-TESTS-8 */
}

private static void runTestCWE9() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-9 */

			/* END-AUTOGENERATED-JAVA-TESTS-9 */
}
}