package testcases.CWE190_Integer_Overflow.s07;

import testcasesupport.*;

public class Main {

	public static void main(String[] args) {
		
		if(args.length != 0) {
		
			if(args[0].equals("-h") || args[0].equals("--help")) {
		
				System.err.println("To use this main, you can either run the program with no " +
				"command line arguments to run all test cases or you can specify one or more classes to test");
				System.err.println("For example:");
				System.err.println("java testcasesupport.Main testcases.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference.custom_function.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference__custom_function_01 testcases.CWE481_Assigning_instead_of_Comparing.bool.CWE481_Assigning_instead_of_Comparing__bool_01");
				System.exit(1);
			}
			
			/* User supplied some class names on the command line, just use those with introspection
			 *
			 * String classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
			 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
 			 * could read class names from command line or use
			 * http://sadun-util.sourceforge.net/api/org/sadun/util/
			 * ClassPackageExplorer.html
			 */

			for (String className : args) {

				try {
					
					/* String classNameWithPackage = "testcases." + className; */
					
					/* IO.writeLine("classNameWithPackage = " + classNameWithPackage); */

					Class<?> myClass = Class.forName(className);

					AbstractTestCase myObject = (AbstractTestCase) myClass
							.newInstance();

					myObject.runTest(className);

				} catch (Exception ex) {

					IO.writeLine("Could not run test for class " + className);
					ex.printStackTrace();

				}
				
				IO.writeLine(""); /* leave a blank line between classes */

			}

		} else {
		
			/* No command line args were used, we want to run every testcase */
			
			/* needed to separate these calls into other methods because
			   we were running into the size limit Java has for a single method */
			runTestCWE1();
			runTestCWE2();
			runTestCWE3();
			runTestCWE4();
			runTestCWE5();
			runTestCWE6();
			runTestCWE7();
			runTestCWE8();
			runTestCWE9();
		}			
	}

private static void runTestCWE1() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-1 */
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_console_readLine_preinc_66a()).runTest("CWE190_Integer_Overflow__byte_console_readLine_preinc_66a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_rand_preinc_45()).runTest("CWE190_Integer_Overflow__byte_rand_preinc_45");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_rand_preinc_02()).runTest("CWE190_Integer_Overflow__short_rand_preinc_02");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_max_preinc_04()).runTest("CWE190_Integer_Overflow__int_max_preinc_04");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_console_readLine_preinc_01()).runTest("CWE190_Integer_Overflow__short_console_readLine_preinc_01");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_console_readLine_preinc_67a()).runTest("CWE190_Integer_Overflow__byte_console_readLine_preinc_67a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_rand_preinc_16()).runTest("CWE190_Integer_Overflow__byte_rand_preinc_16");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_listen_tcp_preinc_03()).runTest("CWE190_Integer_Overflow__int_listen_tcp_preinc_03");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_URLConnection_preinc_61a()).runTest("CWE190_Integer_Overflow__int_URLConnection_preinc_61a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_database_preinc_17()).runTest("CWE190_Integer_Overflow__int_database_preinc_17");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_console_readLine_preinc_14()).runTest("CWE190_Integer_Overflow__long_console_readLine_preinc_14");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Property_preinc_08()).runTest("CWE190_Integer_Overflow__int_Property_preinc_08");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Property_preinc_51a()).runTest("CWE190_Integer_Overflow__int_Property_preinc_51a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_URLConnection_preinc_10()).runTest("CWE190_Integer_Overflow__int_URLConnection_preinc_10");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_random_preinc_73a()).runTest("CWE190_Integer_Overflow__int_random_preinc_73a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_max_preinc_73a()).runTest("CWE190_Integer_Overflow__int_max_preinc_73a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Property_preinc_53a()).runTest("CWE190_Integer_Overflow__int_Property_preinc_53a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_max_preinc_45()).runTest("CWE190_Integer_Overflow__int_max_preinc_45");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_database_preinc_51a()).runTest("CWE190_Integer_Overflow__int_database_preinc_51a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_rand_preinc_22a()).runTest("CWE190_Integer_Overflow__long_rand_preinc_22a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_max_preinc_42()).runTest("CWE190_Integer_Overflow__short_max_preinc_42");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_console_readLine_preinc_22a()).runTest("CWE190_Integer_Overflow__byte_console_readLine_preinc_22a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_max_preinc_17()).runTest("CWE190_Integer_Overflow__short_max_preinc_17");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_max_preinc_75a()).runTest("CWE190_Integer_Overflow__long_max_preinc_75a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_console_readLine_preinc_04()).runTest("CWE190_Integer_Overflow__byte_console_readLine_preinc_04");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Property_preinc_66a()).runTest("CWE190_Integer_Overflow__int_Property_preinc_66a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_rand_preinc_75a()).runTest("CWE190_Integer_Overflow__short_rand_preinc_75a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_console_readLine_preinc_11()).runTest("CWE190_Integer_Overflow__short_console_readLine_preinc_11");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_listen_tcp_preinc_45()).runTest("CWE190_Integer_Overflow__int_listen_tcp_preinc_45");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_max_preinc_05()).runTest("CWE190_Integer_Overflow__short_max_preinc_05");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_console_readLine_preinc_52a()).runTest("CWE190_Integer_Overflow__short_console_readLine_preinc_52a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_URLConnection_preinc_31()).runTest("CWE190_Integer_Overflow__int_URLConnection_preinc_31");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_max_preinc_03()).runTest("CWE190_Integer_Overflow__byte_max_preinc_03");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_console_readLine_preinc_41()).runTest("CWE190_Integer_Overflow__byte_console_readLine_preinc_41");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_max_preinc_02()).runTest("CWE190_Integer_Overflow__short_max_preinc_02");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_console_readLine_preinc_12()).runTest("CWE190_Integer_Overflow__short_console_readLine_preinc_12");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_database_preinc_73a()).runTest("CWE190_Integer_Overflow__int_database_preinc_73a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_console_readLine_preinc_05()).runTest("CWE190_Integer_Overflow__int_console_readLine_preinc_05");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_random_preinc_52a()).runTest("CWE190_Integer_Overflow__int_random_preinc_52a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_max_preinc_15()).runTest("CWE190_Integer_Overflow__short_max_preinc_15");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Environment_preinc_02()).runTest("CWE190_Integer_Overflow__int_Environment_preinc_02");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_console_readLine_preinc_41()).runTest("CWE190_Integer_Overflow__short_console_readLine_preinc_41");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_random_preinc_13()).runTest("CWE190_Integer_Overflow__int_random_preinc_13");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_listen_tcp_preinc_75a()).runTest("CWE190_Integer_Overflow__int_listen_tcp_preinc_75a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Property_preinc_61a()).runTest("CWE190_Integer_Overflow__int_Property_preinc_61a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_rand_preinc_08()).runTest("CWE190_Integer_Overflow__long_rand_preinc_08");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_console_readLine_preinc_21()).runTest("CWE190_Integer_Overflow__int_console_readLine_preinc_21");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_max_preinc_22a()).runTest("CWE190_Integer_Overflow__int_max_preinc_22a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_max_preinc_06()).runTest("CWE190_Integer_Overflow__int_max_preinc_06");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_rand_preinc_31()).runTest("CWE190_Integer_Overflow__short_rand_preinc_31");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_database_preinc_22a()).runTest("CWE190_Integer_Overflow__int_database_preinc_22a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_rand_preinc_12()).runTest("CWE190_Integer_Overflow__short_rand_preinc_12");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_console_readLine_preinc_01()).runTest("CWE190_Integer_Overflow__byte_console_readLine_preinc_01");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_console_readLine_preinc_54a()).runTest("CWE190_Integer_Overflow__int_console_readLine_preinc_54a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_console_readLine_preinc_02()).runTest("CWE190_Integer_Overflow__byte_console_readLine_preinc_02");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_PropertiesFile_preinc_73a()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_preinc_73a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_PropertiesFile_preinc_01()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_preinc_01");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_console_readLine_preinc_13()).runTest("CWE190_Integer_Overflow__byte_console_readLine_preinc_13");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_rand_preinc_17()).runTest("CWE190_Integer_Overflow__short_rand_preinc_17");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Property_preinc_13()).runTest("CWE190_Integer_Overflow__int_Property_preinc_13");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_max_preinc_68a()).runTest("CWE190_Integer_Overflow__short_max_preinc_68a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_database_preinc_41()).runTest("CWE190_Integer_Overflow__int_database_preinc_41");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_connect_tcp_preinc_45()).runTest("CWE190_Integer_Overflow__int_connect_tcp_preinc_45");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_max_preinc_16()).runTest("CWE190_Integer_Overflow__int_max_preinc_16");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_rand_preinc_74a()).runTest("CWE190_Integer_Overflow__byte_rand_preinc_74a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_console_readLine_preinc_14()).runTest("CWE190_Integer_Overflow__byte_console_readLine_preinc_14");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_max_preinc_12()).runTest("CWE190_Integer_Overflow__long_max_preinc_12");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_database_preinc_07()).runTest("CWE190_Integer_Overflow__int_database_preinc_07");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_max_preinc_81a()).runTest("CWE190_Integer_Overflow__short_max_preinc_81a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_random_preinc_21()).runTest("CWE190_Integer_Overflow__int_random_preinc_21");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_rand_preinc_22a()).runTest("CWE190_Integer_Overflow__byte_rand_preinc_22a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_console_readLine_preinc_12()).runTest("CWE190_Integer_Overflow__long_console_readLine_preinc_12");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_console_readLine_preinc_75a()).runTest("CWE190_Integer_Overflow__int_console_readLine_preinc_75a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_rand_preinc_17()).runTest("CWE190_Integer_Overflow__byte_rand_preinc_17");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_rand_preinc_52a()).runTest("CWE190_Integer_Overflow__long_rand_preinc_52a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_console_readLine_preinc_81a()).runTest("CWE190_Integer_Overflow__short_console_readLine_preinc_81a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_URLConnection_preinc_02()).runTest("CWE190_Integer_Overflow__int_URLConnection_preinc_02");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_File_preinc_12()).runTest("CWE190_Integer_Overflow__int_File_preinc_12");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_random_preinc_05()).runTest("CWE190_Integer_Overflow__int_random_preinc_05");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Environment_preinc_53a()).runTest("CWE190_Integer_Overflow__int_Environment_preinc_53a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_PropertiesFile_preinc_04()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_preinc_04");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Property_preinc_15()).runTest("CWE190_Integer_Overflow__int_Property_preinc_15");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_rand_preinc_41()).runTest("CWE190_Integer_Overflow__long_rand_preinc_41");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_listen_tcp_preinc_07()).runTest("CWE190_Integer_Overflow__int_listen_tcp_preinc_07");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_rand_preinc_74a()).runTest("CWE190_Integer_Overflow__short_rand_preinc_74a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_connect_tcp_preinc_10()).runTest("CWE190_Integer_Overflow__int_connect_tcp_preinc_10");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_PropertiesFile_preinc_72a()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_preinc_72a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_connect_tcp_preinc_31()).runTest("CWE190_Integer_Overflow__int_connect_tcp_preinc_31");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_random_preinc_41()).runTest("CWE190_Integer_Overflow__int_random_preinc_41");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_database_preinc_04()).runTest("CWE190_Integer_Overflow__int_database_preinc_04");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_File_preinc_11()).runTest("CWE190_Integer_Overflow__int_File_preinc_11");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_connect_tcp_preinc_13()).runTest("CWE190_Integer_Overflow__int_connect_tcp_preinc_13");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_listen_tcp_preinc_01()).runTest("CWE190_Integer_Overflow__int_listen_tcp_preinc_01");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_max_preinc_74a()).runTest("CWE190_Integer_Overflow__short_max_preinc_74a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_rand_preinc_31()).runTest("CWE190_Integer_Overflow__long_rand_preinc_31");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_listen_tcp_preinc_10()).runTest("CWE190_Integer_Overflow__int_listen_tcp_preinc_10");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_random_preinc_07()).runTest("CWE190_Integer_Overflow__int_random_preinc_07");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_rand_preinc_71a()).runTest("CWE190_Integer_Overflow__long_rand_preinc_71a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_File_preinc_74a()).runTest("CWE190_Integer_Overflow__int_File_preinc_74a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_connect_tcp_preinc_17()).runTest("CWE190_Integer_Overflow__int_connect_tcp_preinc_17");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_console_readLine_preinc_72a()).runTest("CWE190_Integer_Overflow__int_console_readLine_preinc_72a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_max_preinc_51a()).runTest("CWE190_Integer_Overflow__byte_max_preinc_51a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_console_readLine_preinc_51a()).runTest("CWE190_Integer_Overflow__int_console_readLine_preinc_51a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_rand_preinc_81a()).runTest("CWE190_Integer_Overflow__short_rand_preinc_81a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_max_preinc_14()).runTest("CWE190_Integer_Overflow__short_max_preinc_14");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_connect_tcp_preinc_21()).runTest("CWE190_Integer_Overflow__int_connect_tcp_preinc_21");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_rand_preinc_22a()).runTest("CWE190_Integer_Overflow__short_rand_preinc_22a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Environment_preinc_09()).runTest("CWE190_Integer_Overflow__int_Environment_preinc_09");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_PropertiesFile_preinc_31()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_preinc_31");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_PropertiesFile_preinc_14()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_preinc_14");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_console_readLine_preinc_21()).runTest("CWE190_Integer_Overflow__byte_console_readLine_preinc_21");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_PropertiesFile_preinc_52a()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_preinc_52a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_console_readLine_preinc_04()).runTest("CWE190_Integer_Overflow__long_console_readLine_preinc_04");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_max_preinc_41()).runTest("CWE190_Integer_Overflow__long_max_preinc_41");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_max_preinc_75a()).runTest("CWE190_Integer_Overflow__byte_max_preinc_75a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Property_preinc_02()).runTest("CWE190_Integer_Overflow__int_Property_preinc_02");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_connect_tcp_preinc_12()).runTest("CWE190_Integer_Overflow__int_connect_tcp_preinc_12");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_max_preinc_12()).runTest("CWE190_Integer_Overflow__short_max_preinc_12");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_max_preinc_31()).runTest("CWE190_Integer_Overflow__long_max_preinc_31");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_database_preinc_75a()).runTest("CWE190_Integer_Overflow__int_database_preinc_75a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_database_preinc_12()).runTest("CWE190_Integer_Overflow__int_database_preinc_12");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_random_preinc_54a()).runTest("CWE190_Integer_Overflow__int_random_preinc_54a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_rand_preinc_11()).runTest("CWE190_Integer_Overflow__byte_rand_preinc_11");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_console_readLine_preinc_17()).runTest("CWE190_Integer_Overflow__byte_console_readLine_preinc_17");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_console_readLine_preinc_17()).runTest("CWE190_Integer_Overflow__long_console_readLine_preinc_17");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_listen_tcp_preinc_54a()).runTest("CWE190_Integer_Overflow__int_listen_tcp_preinc_54a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_console_readLine_preinc_74a()).runTest("CWE190_Integer_Overflow__short_console_readLine_preinc_74a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_PropertiesFile_preinc_11()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_preinc_11");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_console_readLine_preinc_53a()).runTest("CWE190_Integer_Overflow__short_console_readLine_preinc_53a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_rand_preinc_10()).runTest("CWE190_Integer_Overflow__long_rand_preinc_10");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_rand_preinc_13()).runTest("CWE190_Integer_Overflow__long_rand_preinc_13");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_rand_preinc_75a()).runTest("CWE190_Integer_Overflow__long_rand_preinc_75a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_PropertiesFile_preinc_06()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_preinc_06");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_database_preinc_68a()).runTest("CWE190_Integer_Overflow__int_database_preinc_68a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_console_readLine_preinc_81a()).runTest("CWE190_Integer_Overflow__int_console_readLine_preinc_81a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_max_preinc_66a()).runTest("CWE190_Integer_Overflow__long_max_preinc_66a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_File_preinc_75a()).runTest("CWE190_Integer_Overflow__int_File_preinc_75a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_rand_preinc_05()).runTest("CWE190_Integer_Overflow__byte_rand_preinc_05");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_rand_preinc_21()).runTest("CWE190_Integer_Overflow__long_rand_preinc_21");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Environment_preinc_15()).runTest("CWE190_Integer_Overflow__int_Environment_preinc_15");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_console_readLine_preinc_45()).runTest("CWE190_Integer_Overflow__byte_console_readLine_preinc_45");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_max_preinc_41()).runTest("CWE190_Integer_Overflow__short_max_preinc_41");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_URLConnection_preinc_71a()).runTest("CWE190_Integer_Overflow__int_URLConnection_preinc_71a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_console_readLine_preinc_61a()).runTest("CWE190_Integer_Overflow__byte_console_readLine_preinc_61a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_max_preinc_73a()).runTest("CWE190_Integer_Overflow__long_max_preinc_73a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_rand_preinc_51a()).runTest("CWE190_Integer_Overflow__byte_rand_preinc_51a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_database_preinc_42()).runTest("CWE190_Integer_Overflow__int_database_preinc_42");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_random_preinc_06()).runTest("CWE190_Integer_Overflow__int_random_preinc_06");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_database_preinc_15()).runTest("CWE190_Integer_Overflow__int_database_preinc_15");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_max_preinc_52a()).runTest("CWE190_Integer_Overflow__short_max_preinc_52a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_File_preinc_09()).runTest("CWE190_Integer_Overflow__int_File_preinc_09");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_rand_preinc_01()).runTest("CWE190_Integer_Overflow__long_rand_preinc_01");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_listen_tcp_preinc_12()).runTest("CWE190_Integer_Overflow__int_listen_tcp_preinc_12");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_URLConnection_preinc_13()).runTest("CWE190_Integer_Overflow__int_URLConnection_preinc_13");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_random_preinc_75a()).runTest("CWE190_Integer_Overflow__int_random_preinc_75a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_console_readLine_preinc_72a()).runTest("CWE190_Integer_Overflow__short_console_readLine_preinc_72a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_listen_tcp_preinc_72a()).runTest("CWE190_Integer_Overflow__int_listen_tcp_preinc_72a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_rand_preinc_03()).runTest("CWE190_Integer_Overflow__long_rand_preinc_03");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_max_preinc_11()).runTest("CWE190_Integer_Overflow__int_max_preinc_11");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_URLConnection_preinc_06()).runTest("CWE190_Integer_Overflow__int_URLConnection_preinc_06");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_console_readLine_preinc_05()).runTest("CWE190_Integer_Overflow__short_console_readLine_preinc_05");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_console_readLine_preinc_41()).runTest("CWE190_Integer_Overflow__long_console_readLine_preinc_41");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_File_preinc_53a()).runTest("CWE190_Integer_Overflow__int_File_preinc_53a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_max_preinc_61a()).runTest("CWE190_Integer_Overflow__short_max_preinc_61a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_rand_preinc_68a()).runTest("CWE190_Integer_Overflow__long_rand_preinc_68a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_File_preinc_15()).runTest("CWE190_Integer_Overflow__int_File_preinc_15");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_PropertiesFile_preinc_07()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_preinc_07");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_console_readLine_preinc_06()).runTest("CWE190_Integer_Overflow__int_console_readLine_preinc_06");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_max_preinc_11()).runTest("CWE190_Integer_Overflow__byte_max_preinc_11");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_listen_tcp_preinc_81a()).runTest("CWE190_Integer_Overflow__int_listen_tcp_preinc_81a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_console_readLine_preinc_71a()).runTest("CWE190_Integer_Overflow__byte_console_readLine_preinc_71a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_connect_tcp_preinc_66a()).runTest("CWE190_Integer_Overflow__int_connect_tcp_preinc_66a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_max_preinc_71a()).runTest("CWE190_Integer_Overflow__byte_max_preinc_71a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_rand_preinc_67a()).runTest("CWE190_Integer_Overflow__short_rand_preinc_67a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_connect_tcp_preinc_14()).runTest("CWE190_Integer_Overflow__int_connect_tcp_preinc_14");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_max_preinc_09()).runTest("CWE190_Integer_Overflow__long_max_preinc_09");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_rand_preinc_02()).runTest("CWE190_Integer_Overflow__long_rand_preinc_02");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_rand_preinc_73a()).runTest("CWE190_Integer_Overflow__byte_rand_preinc_73a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_PropertiesFile_preinc_21()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_preinc_21");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_listen_tcp_preinc_05()).runTest("CWE190_Integer_Overflow__int_listen_tcp_preinc_05");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_console_readLine_preinc_22a()).runTest("CWE190_Integer_Overflow__int_console_readLine_preinc_22a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Environment_preinc_13()).runTest("CWE190_Integer_Overflow__int_Environment_preinc_13");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_max_preinc_74a()).runTest("CWE190_Integer_Overflow__byte_max_preinc_74a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Environment_preinc_14()).runTest("CWE190_Integer_Overflow__int_Environment_preinc_14");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_random_preinc_16()).runTest("CWE190_Integer_Overflow__int_random_preinc_16");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_max_preinc_05()).runTest("CWE190_Integer_Overflow__byte_max_preinc_05");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_database_preinc_11()).runTest("CWE190_Integer_Overflow__int_database_preinc_11");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_max_preinc_02()).runTest("CWE190_Integer_Overflow__byte_max_preinc_02");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_max_preinc_51a()).runTest("CWE190_Integer_Overflow__long_max_preinc_51a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_connect_tcp_preinc_75a()).runTest("CWE190_Integer_Overflow__int_connect_tcp_preinc_75a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_rand_preinc_08()).runTest("CWE190_Integer_Overflow__byte_rand_preinc_08");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_connect_tcp_preinc_51a()).runTest("CWE190_Integer_Overflow__int_connect_tcp_preinc_51a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_random_preinc_04()).runTest("CWE190_Integer_Overflow__int_random_preinc_04");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_console_readLine_preinc_31()).runTest("CWE190_Integer_Overflow__byte_console_readLine_preinc_31");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_console_readLine_preinc_16()).runTest("CWE190_Integer_Overflow__short_console_readLine_preinc_16");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_rand_preinc_53a()).runTest("CWE190_Integer_Overflow__byte_rand_preinc_53a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_max_preinc_09()).runTest("CWE190_Integer_Overflow__byte_max_preinc_09");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_File_preinc_22a()).runTest("CWE190_Integer_Overflow__int_File_preinc_22a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_console_readLine_preinc_06()).runTest("CWE190_Integer_Overflow__byte_console_readLine_preinc_06");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_URLConnection_preinc_66a()).runTest("CWE190_Integer_Overflow__int_URLConnection_preinc_66a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_rand_preinc_75a()).runTest("CWE190_Integer_Overflow__byte_rand_preinc_75a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_connect_tcp_preinc_04()).runTest("CWE190_Integer_Overflow__int_connect_tcp_preinc_04");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_rand_preinc_68a()).runTest("CWE190_Integer_Overflow__byte_rand_preinc_68a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_URLConnection_preinc_72a()).runTest("CWE190_Integer_Overflow__int_URLConnection_preinc_72a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_File_preinc_66a()).runTest("CWE190_Integer_Overflow__int_File_preinc_66a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_rand_preinc_13()).runTest("CWE190_Integer_Overflow__short_rand_preinc_13");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_URLConnection_preinc_54a()).runTest("CWE190_Integer_Overflow__int_URLConnection_preinc_54a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_max_preinc_66a()).runTest("CWE190_Integer_Overflow__byte_max_preinc_66a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_random_preinc_72a()).runTest("CWE190_Integer_Overflow__int_random_preinc_72a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_max_preinc_08()).runTest("CWE190_Integer_Overflow__byte_max_preinc_08");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_max_preinc_72a()).runTest("CWE190_Integer_Overflow__byte_max_preinc_72a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_rand_preinc_66a()).runTest("CWE190_Integer_Overflow__long_rand_preinc_66a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_max_preinc_74a()).runTest("CWE190_Integer_Overflow__long_max_preinc_74a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_console_readLine_preinc_54a()).runTest("CWE190_Integer_Overflow__short_console_readLine_preinc_54a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_max_preinc_13()).runTest("CWE190_Integer_Overflow__short_max_preinc_13");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_max_preinc_14()).runTest("CWE190_Integer_Overflow__long_max_preinc_14");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_max_preinc_42()).runTest("CWE190_Integer_Overflow__int_max_preinc_42");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Environment_preinc_12()).runTest("CWE190_Integer_Overflow__int_Environment_preinc_12");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_max_preinc_45()).runTest("CWE190_Integer_Overflow__long_max_preinc_45");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_listen_tcp_preinc_14()).runTest("CWE190_Integer_Overflow__int_listen_tcp_preinc_14");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_PropertiesFile_preinc_09()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_preinc_09");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_random_preinc_61a()).runTest("CWE190_Integer_Overflow__int_random_preinc_61a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_rand_preinc_05()).runTest("CWE190_Integer_Overflow__long_rand_preinc_05");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_max_preinc_17()).runTest("CWE190_Integer_Overflow__int_max_preinc_17");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_PropertiesFile_preinc_10()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_preinc_10");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_max_preinc_06()).runTest("CWE190_Integer_Overflow__long_max_preinc_06");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_max_preinc_22a()).runTest("CWE190_Integer_Overflow__long_max_preinc_22a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_console_readLine_preinc_10()).runTest("CWE190_Integer_Overflow__byte_console_readLine_preinc_10");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_connect_tcp_preinc_09()).runTest("CWE190_Integer_Overflow__int_connect_tcp_preinc_09");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_database_preinc_52a()).runTest("CWE190_Integer_Overflow__int_database_preinc_52a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_URLConnection_preinc_41()).runTest("CWE190_Integer_Overflow__int_URLConnection_preinc_41");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_listen_tcp_preinc_16()).runTest("CWE190_Integer_Overflow__int_listen_tcp_preinc_16");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_rand_preinc_72a()).runTest("CWE190_Integer_Overflow__byte_rand_preinc_72a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_max_preinc_67a()).runTest("CWE190_Integer_Overflow__long_max_preinc_67a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_console_readLine_preinc_05()).runTest("CWE190_Integer_Overflow__long_console_readLine_preinc_05");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_console_readLine_preinc_66a()).runTest("CWE190_Integer_Overflow__short_console_readLine_preinc_66a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_connect_tcp_preinc_05()).runTest("CWE190_Integer_Overflow__int_connect_tcp_preinc_05");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_database_preinc_21()).runTest("CWE190_Integer_Overflow__int_database_preinc_21");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_rand_preinc_66a()).runTest("CWE190_Integer_Overflow__short_rand_preinc_66a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_PropertiesFile_preinc_75a()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_preinc_75a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_max_preinc_72a()).runTest("CWE190_Integer_Overflow__int_max_preinc_72a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_rand_preinc_01()).runTest("CWE190_Integer_Overflow__short_rand_preinc_01");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_max_preinc_31()).runTest("CWE190_Integer_Overflow__int_max_preinc_31");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_File_preinc_73a()).runTest("CWE190_Integer_Overflow__int_File_preinc_73a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_console_readLine_preinc_16()).runTest("CWE190_Integer_Overflow__byte_console_readLine_preinc_16");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_max_preinc_06()).runTest("CWE190_Integer_Overflow__short_max_preinc_06");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_listen_tcp_preinc_73a()).runTest("CWE190_Integer_Overflow__int_listen_tcp_preinc_73a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_random_preinc_03()).runTest("CWE190_Integer_Overflow__int_random_preinc_03");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_console_readLine_preinc_67a()).runTest("CWE190_Integer_Overflow__int_console_readLine_preinc_67a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_console_readLine_preinc_17()).runTest("CWE190_Integer_Overflow__int_console_readLine_preinc_17");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_console_readLine_preinc_75a()).runTest("CWE190_Integer_Overflow__long_console_readLine_preinc_75a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_File_preinc_08()).runTest("CWE190_Integer_Overflow__int_File_preinc_08");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_rand_preinc_45()).runTest("CWE190_Integer_Overflow__short_rand_preinc_45");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_max_preinc_68a()).runTest("CWE190_Integer_Overflow__byte_max_preinc_68a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_console_readLine_preinc_11()).runTest("CWE190_Integer_Overflow__long_console_readLine_preinc_11");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_console_readLine_preinc_42()).runTest("CWE190_Integer_Overflow__long_console_readLine_preinc_42");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_File_preinc_42()).runTest("CWE190_Integer_Overflow__int_File_preinc_42");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_connect_tcp_preinc_07()).runTest("CWE190_Integer_Overflow__int_connect_tcp_preinc_07");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Environment_preinc_21()).runTest("CWE190_Integer_Overflow__int_Environment_preinc_21");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_database_preinc_08()).runTest("CWE190_Integer_Overflow__int_database_preinc_08");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Property_preinc_45()).runTest("CWE190_Integer_Overflow__int_Property_preinc_45");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Environment_preinc_10()).runTest("CWE190_Integer_Overflow__int_Environment_preinc_10");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_URLConnection_preinc_73a()).runTest("CWE190_Integer_Overflow__int_URLConnection_preinc_73a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_rand_preinc_74a()).runTest("CWE190_Integer_Overflow__long_rand_preinc_74a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_console_readLine_preinc_07()).runTest("CWE190_Integer_Overflow__byte_console_readLine_preinc_07");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_console_readLine_preinc_42()).runTest("CWE190_Integer_Overflow__int_console_readLine_preinc_42");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_console_readLine_preinc_66a()).runTest("CWE190_Integer_Overflow__long_console_readLine_preinc_66a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_console_readLine_preinc_71a()).runTest("CWE190_Integer_Overflow__int_console_readLine_preinc_71a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_PropertiesFile_preinc_67a()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_preinc_67a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_max_preinc_01()).runTest("CWE190_Integer_Overflow__long_max_preinc_01");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_PropertiesFile_preinc_71a()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_preinc_71a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Environment_preinc_01()).runTest("CWE190_Integer_Overflow__int_Environment_preinc_01");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_max_preinc_45()).runTest("CWE190_Integer_Overflow__short_max_preinc_45");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_listen_tcp_preinc_09()).runTest("CWE190_Integer_Overflow__int_listen_tcp_preinc_09");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_rand_preinc_12()).runTest("CWE190_Integer_Overflow__byte_rand_preinc_12");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_max_preinc_61a()).runTest("CWE190_Integer_Overflow__long_max_preinc_61a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Property_preinc_41()).runTest("CWE190_Integer_Overflow__int_Property_preinc_41");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_rand_preinc_21()).runTest("CWE190_Integer_Overflow__byte_rand_preinc_21");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_PropertiesFile_preinc_13()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_preinc_13");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_console_readLine_preinc_09()).runTest("CWE190_Integer_Overflow__short_console_readLine_preinc_09");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_rand_preinc_04()).runTest("CWE190_Integer_Overflow__long_rand_preinc_04");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_max_preinc_22a()).runTest("CWE190_Integer_Overflow__byte_max_preinc_22a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_URLConnection_preinc_15()).runTest("CWE190_Integer_Overflow__int_URLConnection_preinc_15");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_console_readLine_preinc_17()).runTest("CWE190_Integer_Overflow__short_console_readLine_preinc_17");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_max_preinc_15()).runTest("CWE190_Integer_Overflow__int_max_preinc_15");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_File_preinc_01()).runTest("CWE190_Integer_Overflow__int_File_preinc_01");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_database_preinc_31()).runTest("CWE190_Integer_Overflow__int_database_preinc_31");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_rand_preinc_52a()).runTest("CWE190_Integer_Overflow__byte_rand_preinc_52a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_console_readLine_preinc_51a()).runTest("CWE190_Integer_Overflow__long_console_readLine_preinc_51a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_max_preinc_54a()).runTest("CWE190_Integer_Overflow__byte_max_preinc_54a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Property_preinc_81a()).runTest("CWE190_Integer_Overflow__int_Property_preinc_81a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_rand_preinc_53a()).runTest("CWE190_Integer_Overflow__long_rand_preinc_53a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_rand_preinc_15()).runTest("CWE190_Integer_Overflow__byte_rand_preinc_15");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_connect_tcp_preinc_01()).runTest("CWE190_Integer_Overflow__int_connect_tcp_preinc_01");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_rand_preinc_42()).runTest("CWE190_Integer_Overflow__short_rand_preinc_42");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_console_readLine_preinc_53a()).runTest("CWE190_Integer_Overflow__int_console_readLine_preinc_53a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_connect_tcp_preinc_61a()).runTest("CWE190_Integer_Overflow__int_connect_tcp_preinc_61a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_URLConnection_preinc_53a()).runTest("CWE190_Integer_Overflow__int_URLConnection_preinc_53a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_rand_preinc_52a()).runTest("CWE190_Integer_Overflow__short_rand_preinc_52a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_listen_tcp_preinc_08()).runTest("CWE190_Integer_Overflow__int_listen_tcp_preinc_08");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_max_preinc_75a()).runTest("CWE190_Integer_Overflow__short_max_preinc_75a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_URLConnection_preinc_42()).runTest("CWE190_Integer_Overflow__int_URLConnection_preinc_42");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_max_preinc_07()).runTest("CWE190_Integer_Overflow__short_max_preinc_07");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_console_readLine_preinc_12()).runTest("CWE190_Integer_Overflow__int_console_readLine_preinc_12");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_max_preinc_81a()).runTest("CWE190_Integer_Overflow__int_max_preinc_81a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_console_readLine_preinc_74a()).runTest("CWE190_Integer_Overflow__long_console_readLine_preinc_74a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_console_readLine_preinc_07()).runTest("CWE190_Integer_Overflow__short_console_readLine_preinc_07");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_console_readLine_preinc_31()).runTest("CWE190_Integer_Overflow__long_console_readLine_preinc_31");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_database_preinc_01()).runTest("CWE190_Integer_Overflow__int_database_preinc_01");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_console_readLine_preinc_06()).runTest("CWE190_Integer_Overflow__long_console_readLine_preinc_06");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_console_readLine_preinc_15()).runTest("CWE190_Integer_Overflow__short_console_readLine_preinc_15");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_URLConnection_preinc_22a()).runTest("CWE190_Integer_Overflow__int_URLConnection_preinc_22a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Environment_preinc_66a()).runTest("CWE190_Integer_Overflow__int_Environment_preinc_66a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_max_preinc_68a()).runTest("CWE190_Integer_Overflow__int_max_preinc_68a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_database_preinc_09()).runTest("CWE190_Integer_Overflow__int_database_preinc_09");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_random_preinc_66a()).runTest("CWE190_Integer_Overflow__int_random_preinc_66a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_console_readLine_preinc_42()).runTest("CWE190_Integer_Overflow__short_console_readLine_preinc_42");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_File_preinc_07()).runTest("CWE190_Integer_Overflow__int_File_preinc_07");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_URLConnection_preinc_16()).runTest("CWE190_Integer_Overflow__int_URLConnection_preinc_16");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_rand_preinc_73a()).runTest("CWE190_Integer_Overflow__short_rand_preinc_73a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_connect_tcp_preinc_22a()).runTest("CWE190_Integer_Overflow__int_connect_tcp_preinc_22a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_listen_tcp_preinc_68a()).runTest("CWE190_Integer_Overflow__int_listen_tcp_preinc_68a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_max_preinc_13()).runTest("CWE190_Integer_Overflow__byte_max_preinc_13");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_rand_preinc_06()).runTest("CWE190_Integer_Overflow__byte_rand_preinc_06");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_PropertiesFile_preinc_51a()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_preinc_51a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_console_readLine_preinc_22a()).runTest("CWE190_Integer_Overflow__short_console_readLine_preinc_22a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_console_readLine_preinc_10()).runTest("CWE190_Integer_Overflow__long_console_readLine_preinc_10");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_URLConnection_preinc_01()).runTest("CWE190_Integer_Overflow__int_URLConnection_preinc_01");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Environment_preinc_06()).runTest("CWE190_Integer_Overflow__int_Environment_preinc_06");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_console_readLine_preinc_13()).runTest("CWE190_Integer_Overflow__short_console_readLine_preinc_13");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_console_readLine_preinc_21()).runTest("CWE190_Integer_Overflow__short_console_readLine_preinc_21");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_URLConnection_preinc_67a()).runTest("CWE190_Integer_Overflow__int_URLConnection_preinc_67a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_rand_preinc_01()).runTest("CWE190_Integer_Overflow__byte_rand_preinc_01");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_console_readLine_preinc_02()).runTest("CWE190_Integer_Overflow__int_console_readLine_preinc_02");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_console_readLine_preinc_45()).runTest("CWE190_Integer_Overflow__int_console_readLine_preinc_45");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_max_preinc_21()).runTest("CWE190_Integer_Overflow__long_max_preinc_21");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_max_preinc_14()).runTest("CWE190_Integer_Overflow__byte_max_preinc_14");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_database_preinc_14()).runTest("CWE190_Integer_Overflow__int_database_preinc_14");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Environment_preinc_31()).runTest("CWE190_Integer_Overflow__int_Environment_preinc_31");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_console_readLine_preinc_06()).runTest("CWE190_Integer_Overflow__short_console_readLine_preinc_06");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_rand_preinc_07()).runTest("CWE190_Integer_Overflow__short_rand_preinc_07");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_console_readLine_preinc_08()).runTest("CWE190_Integer_Overflow__int_console_readLine_preinc_08");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_connect_tcp_preinc_71a()).runTest("CWE190_Integer_Overflow__int_connect_tcp_preinc_71a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_max_preinc_08()).runTest("CWE190_Integer_Overflow__short_max_preinc_08");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_rand_preinc_81a()).runTest("CWE190_Integer_Overflow__byte_rand_preinc_81a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_random_preinc_12()).runTest("CWE190_Integer_Overflow__int_random_preinc_12");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_max_preinc_71a()).runTest("CWE190_Integer_Overflow__short_max_preinc_71a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_max_preinc_21()).runTest("CWE190_Integer_Overflow__int_max_preinc_21");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_PropertiesFile_preinc_22a()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_preinc_22a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_console_readLine_preinc_31()).runTest("CWE190_Integer_Overflow__short_console_readLine_preinc_31");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_console_readLine_preinc_15()).runTest("CWE190_Integer_Overflow__byte_console_readLine_preinc_15");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_max_preinc_51a()).runTest("CWE190_Integer_Overflow__int_max_preinc_51a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_max_preinc_09()).runTest("CWE190_Integer_Overflow__int_max_preinc_09");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_File_preinc_16()).runTest("CWE190_Integer_Overflow__int_File_preinc_16");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_console_readLine_preinc_22a()).runTest("CWE190_Integer_Overflow__long_console_readLine_preinc_22a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_PropertiesFile_preinc_02()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_preinc_02");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_connect_tcp_preinc_54a()).runTest("CWE190_Integer_Overflow__int_connect_tcp_preinc_54a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_rand_preinc_67a()).runTest("CWE190_Integer_Overflow__byte_rand_preinc_67a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_database_preinc_02()).runTest("CWE190_Integer_Overflow__int_database_preinc_02");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_max_preinc_17()).runTest("CWE190_Integer_Overflow__byte_max_preinc_17");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_console_readLine_preinc_74a()).runTest("CWE190_Integer_Overflow__int_console_readLine_preinc_74a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_listen_tcp_preinc_13()).runTest("CWE190_Integer_Overflow__int_listen_tcp_preinc_13");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_max_preinc_10()).runTest("CWE190_Integer_Overflow__short_max_preinc_10");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_max_preinc_72a()).runTest("CWE190_Integer_Overflow__short_max_preinc_72a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_max_preinc_41()).runTest("CWE190_Integer_Overflow__byte_max_preinc_41");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_console_readLine_preinc_54a()).runTest("CWE190_Integer_Overflow__byte_console_readLine_preinc_54a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_PropertiesFile_preinc_05()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_preinc_05");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Environment_preinc_45()).runTest("CWE190_Integer_Overflow__int_Environment_preinc_45");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_URLConnection_preinc_09()).runTest("CWE190_Integer_Overflow__int_URLConnection_preinc_09");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_rand_preinc_08()).runTest("CWE190_Integer_Overflow__short_rand_preinc_08");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_database_preinc_13()).runTest("CWE190_Integer_Overflow__int_database_preinc_13");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_console_readLine_preinc_10()).runTest("CWE190_Integer_Overflow__short_console_readLine_preinc_10");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_console_readLine_preinc_73a()).runTest("CWE190_Integer_Overflow__long_console_readLine_preinc_73a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_console_readLine_preinc_41()).runTest("CWE190_Integer_Overflow__int_console_readLine_preinc_41");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Property_preinc_11()).runTest("CWE190_Integer_Overflow__int_Property_preinc_11");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_max_preinc_54a()).runTest("CWE190_Integer_Overflow__long_max_preinc_54a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_random_preinc_71a()).runTest("CWE190_Integer_Overflow__int_random_preinc_71a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_listen_tcp_preinc_52a()).runTest("CWE190_Integer_Overflow__int_listen_tcp_preinc_52a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_console_readLine_preinc_12()).runTest("CWE190_Integer_Overflow__byte_console_readLine_preinc_12");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_max_preinc_15()).runTest("CWE190_Integer_Overflow__byte_max_preinc_15");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_rand_preinc_10()).runTest("CWE190_Integer_Overflow__short_rand_preinc_10");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_listen_tcp_preinc_15()).runTest("CWE190_Integer_Overflow__int_listen_tcp_preinc_15");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_console_readLine_preinc_68a()).runTest("CWE190_Integer_Overflow__long_console_readLine_preinc_68a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Environment_preinc_71a()).runTest("CWE190_Integer_Overflow__int_Environment_preinc_71a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_rand_preinc_31()).runTest("CWE190_Integer_Overflow__byte_rand_preinc_31");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Property_preinc_54a()).runTest("CWE190_Integer_Overflow__int_Property_preinc_54a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_console_readLine_preinc_09()).runTest("CWE190_Integer_Overflow__int_console_readLine_preinc_09");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_console_readLine_preinc_13()).runTest("CWE190_Integer_Overflow__int_console_readLine_preinc_13");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_database_preinc_66a()).runTest("CWE190_Integer_Overflow__int_database_preinc_66a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_PropertiesFile_preinc_45()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_preinc_45");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_rand_preinc_17()).runTest("CWE190_Integer_Overflow__long_rand_preinc_17");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_database_preinc_61a()).runTest("CWE190_Integer_Overflow__int_database_preinc_61a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_console_readLine_preinc_72a()).runTest("CWE190_Integer_Overflow__byte_console_readLine_preinc_72a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Environment_preinc_03()).runTest("CWE190_Integer_Overflow__int_Environment_preinc_03");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Environment_preinc_61a()).runTest("CWE190_Integer_Overflow__int_Environment_preinc_61a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_rand_preinc_42()).runTest("CWE190_Integer_Overflow__byte_rand_preinc_42");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_console_readLine_preinc_71a()).runTest("CWE190_Integer_Overflow__long_console_readLine_preinc_71a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_max_preinc_42()).runTest("CWE190_Integer_Overflow__byte_max_preinc_42");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_URLConnection_preinc_12()).runTest("CWE190_Integer_Overflow__int_URLConnection_preinc_12");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_max_preinc_04()).runTest("CWE190_Integer_Overflow__long_max_preinc_04");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_max_preinc_14()).runTest("CWE190_Integer_Overflow__int_max_preinc_14");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_console_readLine_preinc_73a()).runTest("CWE190_Integer_Overflow__short_console_readLine_preinc_73a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_rand_preinc_42()).runTest("CWE190_Integer_Overflow__long_rand_preinc_42");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_random_preinc_15()).runTest("CWE190_Integer_Overflow__int_random_preinc_15");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_random_preinc_17()).runTest("CWE190_Integer_Overflow__int_random_preinc_17");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_console_readLine_preinc_53a()).runTest("CWE190_Integer_Overflow__byte_console_readLine_preinc_53a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_max_preinc_16()).runTest("CWE190_Integer_Overflow__long_max_preinc_16");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_console_readLine_preinc_68a()).runTest("CWE190_Integer_Overflow__short_console_readLine_preinc_68a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_console_readLine_preinc_73a()).runTest("CWE190_Integer_Overflow__byte_console_readLine_preinc_73a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_listen_tcp_preinc_71a()).runTest("CWE190_Integer_Overflow__int_listen_tcp_preinc_71a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_max_preinc_13()).runTest("CWE190_Integer_Overflow__long_max_preinc_13");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_console_readLine_preinc_31()).runTest("CWE190_Integer_Overflow__int_console_readLine_preinc_31");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Property_preinc_03()).runTest("CWE190_Integer_Overflow__int_Property_preinc_03");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_listen_tcp_preinc_51a()).runTest("CWE190_Integer_Overflow__int_listen_tcp_preinc_51a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_File_preinc_17()).runTest("CWE190_Integer_Overflow__int_File_preinc_17");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Property_preinc_06()).runTest("CWE190_Integer_Overflow__int_Property_preinc_06");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Environment_preinc_16()).runTest("CWE190_Integer_Overflow__int_Environment_preinc_16");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_console_readLine_preinc_61a()).runTest("CWE190_Integer_Overflow__short_console_readLine_preinc_61a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_max_preinc_31()).runTest("CWE190_Integer_Overflow__short_max_preinc_31");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_max_preinc_45()).runTest("CWE190_Integer_Overflow__byte_max_preinc_45");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Environment_preinc_74a()).runTest("CWE190_Integer_Overflow__int_Environment_preinc_74a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_File_preinc_06()).runTest("CWE190_Integer_Overflow__int_File_preinc_06");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_console_readLine_preinc_15()).runTest("CWE190_Integer_Overflow__long_console_readLine_preinc_15");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_rand_preinc_15()).runTest("CWE190_Integer_Overflow__long_rand_preinc_15");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_max_preinc_02()).runTest("CWE190_Integer_Overflow__int_max_preinc_02");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_URLConnection_preinc_21()).runTest("CWE190_Integer_Overflow__int_URLConnection_preinc_21");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_max_preinc_71a()).runTest("CWE190_Integer_Overflow__int_max_preinc_71a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Property_preinc_17()).runTest("CWE190_Integer_Overflow__int_Property_preinc_17");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_max_preinc_06()).runTest("CWE190_Integer_Overflow__byte_max_preinc_06");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_random_preinc_51a()).runTest("CWE190_Integer_Overflow__int_random_preinc_51a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_PropertiesFile_preinc_74a()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_preinc_74a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_rand_preinc_54a()).runTest("CWE190_Integer_Overflow__short_rand_preinc_54a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_rand_preinc_12()).runTest("CWE190_Integer_Overflow__long_rand_preinc_12");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Property_preinc_31()).runTest("CWE190_Integer_Overflow__int_Property_preinc_31");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_max_preinc_21()).runTest("CWE190_Integer_Overflow__byte_max_preinc_21");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_database_preinc_72a()).runTest("CWE190_Integer_Overflow__int_database_preinc_72a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_console_readLine_preinc_02()).runTest("CWE190_Integer_Overflow__long_console_readLine_preinc_02");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_URLConnection_preinc_51a()).runTest("CWE190_Integer_Overflow__int_URLConnection_preinc_51a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_PropertiesFile_preinc_61a()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_preinc_61a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_console_readLine_preinc_11()).runTest("CWE190_Integer_Overflow__int_console_readLine_preinc_11");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_rand_preinc_66a()).runTest("CWE190_Integer_Overflow__byte_rand_preinc_66a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_console_readLine_preinc_03()).runTest("CWE190_Integer_Overflow__byte_console_readLine_preinc_03");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_PropertiesFile_preinc_12()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_preinc_12");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_console_readLine_preinc_74a()).runTest("CWE190_Integer_Overflow__byte_console_readLine_preinc_74a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Property_preinc_12()).runTest("CWE190_Integer_Overflow__int_Property_preinc_12");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_File_preinc_45()).runTest("CWE190_Integer_Overflow__int_File_preinc_45");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Environment_preinc_67a()).runTest("CWE190_Integer_Overflow__int_Environment_preinc_67a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_max_preinc_68a()).runTest("CWE190_Integer_Overflow__long_max_preinc_68a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_max_preinc_01()).runTest("CWE190_Integer_Overflow__short_max_preinc_01");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_URLConnection_preinc_07()).runTest("CWE190_Integer_Overflow__int_URLConnection_preinc_07");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Environment_preinc_08()).runTest("CWE190_Integer_Overflow__int_Environment_preinc_08");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_URLConnection_preinc_03()).runTest("CWE190_Integer_Overflow__int_URLConnection_preinc_03");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_listen_tcp_preinc_66a()).runTest("CWE190_Integer_Overflow__int_listen_tcp_preinc_66a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_listen_tcp_preinc_17()).runTest("CWE190_Integer_Overflow__int_listen_tcp_preinc_17");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_max_preinc_52a()).runTest("CWE190_Integer_Overflow__int_max_preinc_52a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_File_preinc_67a()).runTest("CWE190_Integer_Overflow__int_File_preinc_67a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_max_preinc_05()).runTest("CWE190_Integer_Overflow__long_max_preinc_05");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_File_preinc_51a()).runTest("CWE190_Integer_Overflow__int_File_preinc_51a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_console_readLine_preinc_09()).runTest("CWE190_Integer_Overflow__long_console_readLine_preinc_09");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_max_preinc_71a()).runTest("CWE190_Integer_Overflow__long_max_preinc_71a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_max_preinc_21()).runTest("CWE190_Integer_Overflow__short_max_preinc_21");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_rand_preinc_68a()).runTest("CWE190_Integer_Overflow__short_rand_preinc_68a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_URLConnection_preinc_45()).runTest("CWE190_Integer_Overflow__int_URLConnection_preinc_45");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_max_preinc_11()).runTest("CWE190_Integer_Overflow__short_max_preinc_11");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_random_preinc_08()).runTest("CWE190_Integer_Overflow__int_random_preinc_08");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_rand_preinc_72a()).runTest("CWE190_Integer_Overflow__short_rand_preinc_72a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Property_preinc_04()).runTest("CWE190_Integer_Overflow__int_Property_preinc_04");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_File_preinc_13()).runTest("CWE190_Integer_Overflow__int_File_preinc_13");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_max_preinc_52a()).runTest("CWE190_Integer_Overflow__long_max_preinc_52a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_connect_tcp_preinc_81a()).runTest("CWE190_Integer_Overflow__int_connect_tcp_preinc_81a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_rand_preinc_61a()).runTest("CWE190_Integer_Overflow__long_rand_preinc_61a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_connect_tcp_preinc_03()).runTest("CWE190_Integer_Overflow__int_connect_tcp_preinc_03");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_console_readLine_preinc_75a()).runTest("CWE190_Integer_Overflow__byte_console_readLine_preinc_75a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_console_readLine_preinc_15()).runTest("CWE190_Integer_Overflow__int_console_readLine_preinc_15");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_rand_preinc_11()).runTest("CWE190_Integer_Overflow__long_rand_preinc_11");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_File_preinc_68a()).runTest("CWE190_Integer_Overflow__int_File_preinc_68a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_PropertiesFile_preinc_81a()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_preinc_81a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_database_preinc_71a()).runTest("CWE190_Integer_Overflow__int_database_preinc_71a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_console_readLine_preinc_07()).runTest("CWE190_Integer_Overflow__long_console_readLine_preinc_07");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_max_preinc_10()).runTest("CWE190_Integer_Overflow__byte_max_preinc_10");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_max_preinc_61a()).runTest("CWE190_Integer_Overflow__int_max_preinc_61a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_connect_tcp_preinc_41()).runTest("CWE190_Integer_Overflow__int_connect_tcp_preinc_41");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_URLConnection_preinc_74a()).runTest("CWE190_Integer_Overflow__int_URLConnection_preinc_74a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_connect_tcp_preinc_74a()).runTest("CWE190_Integer_Overflow__int_connect_tcp_preinc_74a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_max_preinc_08()).runTest("CWE190_Integer_Overflow__long_max_preinc_08");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_connect_tcp_preinc_73a()).runTest("CWE190_Integer_Overflow__int_connect_tcp_preinc_73a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_console_readLine_preinc_10()).runTest("CWE190_Integer_Overflow__int_console_readLine_preinc_10");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_listen_tcp_preinc_21()).runTest("CWE190_Integer_Overflow__int_listen_tcp_preinc_21");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_File_preinc_04()).runTest("CWE190_Integer_Overflow__int_File_preinc_04");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Property_preinc_16()).runTest("CWE190_Integer_Overflow__int_Property_preinc_16");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_rand_preinc_14()).runTest("CWE190_Integer_Overflow__short_rand_preinc_14");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_max_preinc_11()).runTest("CWE190_Integer_Overflow__long_max_preinc_11");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_max_preinc_16()).runTest("CWE190_Integer_Overflow__short_max_preinc_16");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_max_preinc_67a()).runTest("CWE190_Integer_Overflow__short_max_preinc_67a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_console_readLine_preinc_67a()).runTest("CWE190_Integer_Overflow__short_console_readLine_preinc_67a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_console_readLine_preinc_07()).runTest("CWE190_Integer_Overflow__int_console_readLine_preinc_07");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_console_readLine_preinc_11()).runTest("CWE190_Integer_Overflow__byte_console_readLine_preinc_11");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_rand_preinc_04()).runTest("CWE190_Integer_Overflow__byte_rand_preinc_04");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_console_readLine_preinc_03()).runTest("CWE190_Integer_Overflow__int_console_readLine_preinc_03");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_max_preinc_16()).runTest("CWE190_Integer_Overflow__byte_max_preinc_16");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_max_preinc_41()).runTest("CWE190_Integer_Overflow__int_max_preinc_41");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_rand_preinc_72a()).runTest("CWE190_Integer_Overflow__long_rand_preinc_72a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_max_preinc_81a()).runTest("CWE190_Integer_Overflow__long_max_preinc_81a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_max_preinc_09()).runTest("CWE190_Integer_Overflow__short_max_preinc_09");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Environment_preinc_17()).runTest("CWE190_Integer_Overflow__int_Environment_preinc_17");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_URLConnection_preinc_52a()).runTest("CWE190_Integer_Overflow__int_URLConnection_preinc_52a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_max_preinc_10()).runTest("CWE190_Integer_Overflow__long_max_preinc_10");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_console_readLine_preinc_16()).runTest("CWE190_Integer_Overflow__long_console_readLine_preinc_16");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_max_preinc_54a()).runTest("CWE190_Integer_Overflow__short_max_preinc_54a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_PropertiesFile_preinc_42()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_preinc_42");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_random_preinc_81a()).runTest("CWE190_Integer_Overflow__int_random_preinc_81a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_rand_preinc_71a()).runTest("CWE190_Integer_Overflow__byte_rand_preinc_71a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_console_readLine_preinc_81a()).runTest("CWE190_Integer_Overflow__long_console_readLine_preinc_81a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_rand_preinc_61a()).runTest("CWE190_Integer_Overflow__short_rand_preinc_61a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_max_preinc_07()).runTest("CWE190_Integer_Overflow__int_max_preinc_07");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_console_readLine_preinc_08()).runTest("CWE190_Integer_Overflow__long_console_readLine_preinc_08");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_rand_preinc_02()).runTest("CWE190_Integer_Overflow__byte_rand_preinc_02");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_console_readLine_preinc_42()).runTest("CWE190_Integer_Overflow__byte_console_readLine_preinc_42");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_database_preinc_16()).runTest("CWE190_Integer_Overflow__int_database_preinc_16");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_console_readLine_preinc_61a()).runTest("CWE190_Integer_Overflow__long_console_readLine_preinc_61a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_random_preinc_53a()).runTest("CWE190_Integer_Overflow__int_random_preinc_53a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_database_preinc_74a()).runTest("CWE190_Integer_Overflow__int_database_preinc_74a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_File_preinc_03()).runTest("CWE190_Integer_Overflow__int_File_preinc_03");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_connect_tcp_preinc_06()).runTest("CWE190_Integer_Overflow__int_connect_tcp_preinc_06");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_rand_preinc_61a()).runTest("CWE190_Integer_Overflow__byte_rand_preinc_61a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_console_readLine_preinc_45()).runTest("CWE190_Integer_Overflow__short_console_readLine_preinc_45");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_File_preinc_21()).runTest("CWE190_Integer_Overflow__int_File_preinc_21");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Environment_preinc_42()).runTest("CWE190_Integer_Overflow__int_Environment_preinc_42");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_random_preinc_67a()).runTest("CWE190_Integer_Overflow__int_random_preinc_67a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_File_preinc_31()).runTest("CWE190_Integer_Overflow__int_File_preinc_31");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_max_preinc_31()).runTest("CWE190_Integer_Overflow__byte_max_preinc_31");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_rand_preinc_03()).runTest("CWE190_Integer_Overflow__byte_rand_preinc_03");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_database_preinc_67a()).runTest("CWE190_Integer_Overflow__int_database_preinc_67a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_console_readLine_preinc_21()).runTest("CWE190_Integer_Overflow__long_console_readLine_preinc_21");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_PropertiesFile_preinc_68a()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_preinc_68a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_max_preinc_08()).runTest("CWE190_Integer_Overflow__int_max_preinc_08");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_console_readLine_preinc_52a()).runTest("CWE190_Integer_Overflow__byte_console_readLine_preinc_52a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_connect_tcp_preinc_53a()).runTest("CWE190_Integer_Overflow__int_connect_tcp_preinc_53a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_console_readLine_preinc_75a()).runTest("CWE190_Integer_Overflow__short_console_readLine_preinc_75a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Environment_preinc_68a()).runTest("CWE190_Integer_Overflow__int_Environment_preinc_68a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_rand_preinc_13()).runTest("CWE190_Integer_Overflow__byte_rand_preinc_13");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_rand_preinc_53a()).runTest("CWE190_Integer_Overflow__short_rand_preinc_53a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_URLConnection_preinc_08()).runTest("CWE190_Integer_Overflow__int_URLConnection_preinc_08");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Property_preinc_68a()).runTest("CWE190_Integer_Overflow__int_Property_preinc_68a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Property_preinc_67a()).runTest("CWE190_Integer_Overflow__int_Property_preinc_67a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_rand_preinc_04()).runTest("CWE190_Integer_Overflow__short_rand_preinc_04");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_connect_tcp_preinc_11()).runTest("CWE190_Integer_Overflow__int_connect_tcp_preinc_11");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Environment_preinc_52a()).runTest("CWE190_Integer_Overflow__int_Environment_preinc_52a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_max_preinc_03()).runTest("CWE190_Integer_Overflow__int_max_preinc_03");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Environment_preinc_07()).runTest("CWE190_Integer_Overflow__int_Environment_preinc_07");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_max_preinc_53a()).runTest("CWE190_Integer_Overflow__long_max_preinc_53a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_max_preinc_03()).runTest("CWE190_Integer_Overflow__long_max_preinc_03");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_connect_tcp_preinc_67a()).runTest("CWE190_Integer_Overflow__int_connect_tcp_preinc_67a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_rand_preinc_54a()).runTest("CWE190_Integer_Overflow__byte_rand_preinc_54a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_max_preinc_42()).runTest("CWE190_Integer_Overflow__long_max_preinc_42");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_PropertiesFile_preinc_54a()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_preinc_54a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_listen_tcp_preinc_41()).runTest("CWE190_Integer_Overflow__int_listen_tcp_preinc_41");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Property_preinc_09()).runTest("CWE190_Integer_Overflow__int_Property_preinc_09");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_random_preinc_01()).runTest("CWE190_Integer_Overflow__int_random_preinc_01");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_rand_preinc_14()).runTest("CWE190_Integer_Overflow__long_rand_preinc_14");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_File_preinc_54a()).runTest("CWE190_Integer_Overflow__int_File_preinc_54a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_rand_preinc_07()).runTest("CWE190_Integer_Overflow__byte_rand_preinc_07");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_rand_preinc_54a()).runTest("CWE190_Integer_Overflow__long_rand_preinc_54a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_URLConnection_preinc_11()).runTest("CWE190_Integer_Overflow__int_URLConnection_preinc_11");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Environment_preinc_73a()).runTest("CWE190_Integer_Overflow__int_Environment_preinc_73a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_listen_tcp_preinc_67a()).runTest("CWE190_Integer_Overflow__int_listen_tcp_preinc_67a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_max_preinc_66a()).runTest("CWE190_Integer_Overflow__int_max_preinc_66a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_rand_preinc_03()).runTest("CWE190_Integer_Overflow__short_rand_preinc_03");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_listen_tcp_preinc_06()).runTest("CWE190_Integer_Overflow__int_listen_tcp_preinc_06");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_connect_tcp_preinc_42()).runTest("CWE190_Integer_Overflow__int_connect_tcp_preinc_42");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_max_preinc_54a()).runTest("CWE190_Integer_Overflow__int_max_preinc_54a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_max_preinc_03()).runTest("CWE190_Integer_Overflow__short_max_preinc_03");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_max_preinc_01()).runTest("CWE190_Integer_Overflow__byte_max_preinc_01");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_console_readLine_preinc_01()).runTest("CWE190_Integer_Overflow__int_console_readLine_preinc_01");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_URLConnection_preinc_75a()).runTest("CWE190_Integer_Overflow__int_URLConnection_preinc_75a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_random_preinc_14()).runTest("CWE190_Integer_Overflow__int_random_preinc_14");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_max_preinc_73a()).runTest("CWE190_Integer_Overflow__short_max_preinc_73a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_database_preinc_81a()).runTest("CWE190_Integer_Overflow__int_database_preinc_81a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_console_readLine_preinc_53a()).runTest("CWE190_Integer_Overflow__long_console_readLine_preinc_53a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_max_preinc_07()).runTest("CWE190_Integer_Overflow__long_max_preinc_07");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_PropertiesFile_preinc_03()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_preinc_03");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_connect_tcp_preinc_15()).runTest("CWE190_Integer_Overflow__int_connect_tcp_preinc_15");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Property_preinc_71a()).runTest("CWE190_Integer_Overflow__int_Property_preinc_71a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_max_preinc_52a()).runTest("CWE190_Integer_Overflow__byte_max_preinc_52a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_rand_preinc_11()).runTest("CWE190_Integer_Overflow__short_rand_preinc_11");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Environment_preinc_54a()).runTest("CWE190_Integer_Overflow__int_Environment_preinc_54a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_max_preinc_10()).runTest("CWE190_Integer_Overflow__int_max_preinc_10");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_rand_preinc_09()).runTest("CWE190_Integer_Overflow__short_rand_preinc_09");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_max_preinc_53a()).runTest("CWE190_Integer_Overflow__short_max_preinc_53a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_rand_preinc_09()).runTest("CWE190_Integer_Overflow__byte_rand_preinc_09");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_rand_preinc_07()).runTest("CWE190_Integer_Overflow__long_rand_preinc_07");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_File_preinc_52a()).runTest("CWE190_Integer_Overflow__int_File_preinc_52a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_max_preinc_53a()).runTest("CWE190_Integer_Overflow__int_max_preinc_53a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_database_preinc_45()).runTest("CWE190_Integer_Overflow__int_database_preinc_45");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_database_preinc_10()).runTest("CWE190_Integer_Overflow__int_database_preinc_10");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Environment_preinc_51a()).runTest("CWE190_Integer_Overflow__int_Environment_preinc_51a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_rand_preinc_09()).runTest("CWE190_Integer_Overflow__long_rand_preinc_09");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_max_preinc_53a()).runTest("CWE190_Integer_Overflow__byte_max_preinc_53a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_console_readLine_preinc_52a()).runTest("CWE190_Integer_Overflow__int_console_readLine_preinc_52a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_console_readLine_preinc_61a()).runTest("CWE190_Integer_Overflow__int_console_readLine_preinc_61a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Property_preinc_22a()).runTest("CWE190_Integer_Overflow__int_Property_preinc_22a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Property_preinc_73a()).runTest("CWE190_Integer_Overflow__int_Property_preinc_73a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_rand_preinc_45()).runTest("CWE190_Integer_Overflow__long_rand_preinc_45");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_PropertiesFile_preinc_53a()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_preinc_53a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_URLConnection_preinc_68a()).runTest("CWE190_Integer_Overflow__int_URLConnection_preinc_68a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_PropertiesFile_preinc_66a()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_preinc_66a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_random_preinc_02()).runTest("CWE190_Integer_Overflow__int_random_preinc_02");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Property_preinc_05()).runTest("CWE190_Integer_Overflow__int_Property_preinc_05");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_rand_preinc_05()).runTest("CWE190_Integer_Overflow__short_rand_preinc_05");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_File_preinc_61a()).runTest("CWE190_Integer_Overflow__int_File_preinc_61a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_console_readLine_preinc_04()).runTest("CWE190_Integer_Overflow__short_console_readLine_preinc_04");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Environment_preinc_04()).runTest("CWE190_Integer_Overflow__int_Environment_preinc_04");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_connect_tcp_preinc_52a()).runTest("CWE190_Integer_Overflow__int_connect_tcp_preinc_52a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_console_readLine_preinc_05()).runTest("CWE190_Integer_Overflow__byte_console_readLine_preinc_05");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_console_readLine_preinc_16()).runTest("CWE190_Integer_Overflow__int_console_readLine_preinc_16");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_console_readLine_preinc_08()).runTest("CWE190_Integer_Overflow__short_console_readLine_preinc_08");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_rand_preinc_21()).runTest("CWE190_Integer_Overflow__short_rand_preinc_21");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_PropertiesFile_preinc_16()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_preinc_16");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_random_preinc_45()).runTest("CWE190_Integer_Overflow__int_random_preinc_45");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_console_readLine_preinc_14()).runTest("CWE190_Integer_Overflow__int_console_readLine_preinc_14");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_console_readLine_preinc_81a()).runTest("CWE190_Integer_Overflow__byte_console_readLine_preinc_81a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_rand_preinc_51a()).runTest("CWE190_Integer_Overflow__long_rand_preinc_51a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_database_preinc_06()).runTest("CWE190_Integer_Overflow__int_database_preinc_06");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_File_preinc_72a()).runTest("CWE190_Integer_Overflow__int_File_preinc_72a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Environment_preinc_41()).runTest("CWE190_Integer_Overflow__int_Environment_preinc_41");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Property_preinc_72a()).runTest("CWE190_Integer_Overflow__int_Property_preinc_72a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_URLConnection_preinc_81a()).runTest("CWE190_Integer_Overflow__int_URLConnection_preinc_81a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_rand_preinc_14()).runTest("CWE190_Integer_Overflow__byte_rand_preinc_14");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_listen_tcp_preinc_61a()).runTest("CWE190_Integer_Overflow__int_listen_tcp_preinc_61a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_max_preinc_15()).runTest("CWE190_Integer_Overflow__long_max_preinc_15");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_database_preinc_54a()).runTest("CWE190_Integer_Overflow__int_database_preinc_54a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_rand_preinc_16()).runTest("CWE190_Integer_Overflow__short_rand_preinc_16");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_console_readLine_preinc_01()).runTest("CWE190_Integer_Overflow__long_console_readLine_preinc_01");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_max_preinc_73a()).runTest("CWE190_Integer_Overflow__byte_max_preinc_73a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_max_preinc_13()).runTest("CWE190_Integer_Overflow__int_max_preinc_13");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_console_readLine_preinc_51a()).runTest("CWE190_Integer_Overflow__short_console_readLine_preinc_51a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_max_preinc_75a()).runTest("CWE190_Integer_Overflow__int_max_preinc_75a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_File_preinc_41()).runTest("CWE190_Integer_Overflow__int_File_preinc_41");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Environment_preinc_81a()).runTest("CWE190_Integer_Overflow__int_Environment_preinc_81a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_max_preinc_04()).runTest("CWE190_Integer_Overflow__short_max_preinc_04");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_console_readLine_preinc_03()).runTest("CWE190_Integer_Overflow__long_console_readLine_preinc_03");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_listen_tcp_preinc_11()).runTest("CWE190_Integer_Overflow__int_listen_tcp_preinc_11");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_rand_preinc_15()).runTest("CWE190_Integer_Overflow__short_rand_preinc_15");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_connect_tcp_preinc_68a()).runTest("CWE190_Integer_Overflow__int_connect_tcp_preinc_68a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_rand_preinc_06()).runTest("CWE190_Integer_Overflow__short_rand_preinc_06");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_rand_preinc_41()).runTest("CWE190_Integer_Overflow__short_rand_preinc_41");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_listen_tcp_preinc_53a()).runTest("CWE190_Integer_Overflow__int_listen_tcp_preinc_53a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_database_preinc_05()).runTest("CWE190_Integer_Overflow__int_database_preinc_05");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Environment_preinc_22a()).runTest("CWE190_Integer_Overflow__int_Environment_preinc_22a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Property_preinc_74a()).runTest("CWE190_Integer_Overflow__int_Property_preinc_74a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_console_readLine_preinc_02()).runTest("CWE190_Integer_Overflow__short_console_readLine_preinc_02");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_max_preinc_02()).runTest("CWE190_Integer_Overflow__long_max_preinc_02");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_max_preinc_67a()).runTest("CWE190_Integer_Overflow__int_max_preinc_67a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_max_preinc_17()).runTest("CWE190_Integer_Overflow__long_max_preinc_17");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_database_preinc_53a()).runTest("CWE190_Integer_Overflow__int_database_preinc_53a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_max_preinc_81a()).runTest("CWE190_Integer_Overflow__byte_max_preinc_81a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_console_readLine_preinc_54a()).runTest("CWE190_Integer_Overflow__long_console_readLine_preinc_54a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_rand_preinc_16()).runTest("CWE190_Integer_Overflow__long_rand_preinc_16");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_console_readLine_preinc_51a()).runTest("CWE190_Integer_Overflow__byte_console_readLine_preinc_51a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_PropertiesFile_preinc_08()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_preinc_08");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_max_preinc_04()).runTest("CWE190_Integer_Overflow__byte_max_preinc_04");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_max_preinc_22a()).runTest("CWE190_Integer_Overflow__short_max_preinc_22a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_URLConnection_preinc_14()).runTest("CWE190_Integer_Overflow__int_URLConnection_preinc_14");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_console_readLine_preinc_09()).runTest("CWE190_Integer_Overflow__byte_console_readLine_preinc_09");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_rand_preinc_81a()).runTest("CWE190_Integer_Overflow__long_rand_preinc_81a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Property_preinc_01()).runTest("CWE190_Integer_Overflow__int_Property_preinc_01");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_console_readLine_preinc_13()).runTest("CWE190_Integer_Overflow__long_console_readLine_preinc_13");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_console_readLine_preinc_03()).runTest("CWE190_Integer_Overflow__short_console_readLine_preinc_03");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_console_readLine_preinc_68a()).runTest("CWE190_Integer_Overflow__int_console_readLine_preinc_68a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_random_preinc_31()).runTest("CWE190_Integer_Overflow__int_random_preinc_31");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Property_preinc_52a()).runTest("CWE190_Integer_Overflow__int_Property_preinc_52a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_listen_tcp_preinc_04()).runTest("CWE190_Integer_Overflow__int_listen_tcp_preinc_04");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_File_preinc_71a()).runTest("CWE190_Integer_Overflow__int_File_preinc_71a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_URLConnection_preinc_05()).runTest("CWE190_Integer_Overflow__int_URLConnection_preinc_05");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_console_readLine_preinc_08()).runTest("CWE190_Integer_Overflow__byte_console_readLine_preinc_08");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_console_readLine_preinc_72a()).runTest("CWE190_Integer_Overflow__long_console_readLine_preinc_72a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Environment_preinc_72a()).runTest("CWE190_Integer_Overflow__int_Environment_preinc_72a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_max_preinc_74a()).runTest("CWE190_Integer_Overflow__int_max_preinc_74a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_PropertiesFile_preinc_17()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_preinc_17");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_rand_preinc_67a()).runTest("CWE190_Integer_Overflow__long_rand_preinc_67a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_max_preinc_51a()).runTest("CWE190_Integer_Overflow__short_max_preinc_51a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Property_preinc_10()).runTest("CWE190_Integer_Overflow__int_Property_preinc_10");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_connect_tcp_preinc_02()).runTest("CWE190_Integer_Overflow__int_connect_tcp_preinc_02");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_URLConnection_preinc_17()).runTest("CWE190_Integer_Overflow__int_URLConnection_preinc_17");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_console_readLine_preinc_45()).runTest("CWE190_Integer_Overflow__long_console_readLine_preinc_45");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Environment_preinc_05()).runTest("CWE190_Integer_Overflow__int_Environment_preinc_05");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_random_preinc_09()).runTest("CWE190_Integer_Overflow__int_random_preinc_09");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_rand_preinc_06()).runTest("CWE190_Integer_Overflow__long_rand_preinc_06");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_console_readLine_preinc_52a()).runTest("CWE190_Integer_Overflow__long_console_readLine_preinc_52a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_rand_preinc_41()).runTest("CWE190_Integer_Overflow__byte_rand_preinc_41");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_rand_preinc_71a()).runTest("CWE190_Integer_Overflow__short_rand_preinc_71a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_random_preinc_22a()).runTest("CWE190_Integer_Overflow__int_random_preinc_22a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_File_preinc_14()).runTest("CWE190_Integer_Overflow__int_File_preinc_14");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_File_preinc_81a()).runTest("CWE190_Integer_Overflow__int_File_preinc_81a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_max_preinc_72a()).runTest("CWE190_Integer_Overflow__long_max_preinc_72a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_URLConnection_preinc_04()).runTest("CWE190_Integer_Overflow__int_URLConnection_preinc_04");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_File_preinc_10()).runTest("CWE190_Integer_Overflow__int_File_preinc_10");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Property_preinc_75a()).runTest("CWE190_Integer_Overflow__int_Property_preinc_75a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_random_preinc_68a()).runTest("CWE190_Integer_Overflow__int_random_preinc_68a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_console_readLine_preinc_68a()).runTest("CWE190_Integer_Overflow__byte_console_readLine_preinc_68a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_max_preinc_01()).runTest("CWE190_Integer_Overflow__int_max_preinc_01");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Property_preinc_21()).runTest("CWE190_Integer_Overflow__int_Property_preinc_21");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_console_readLine_preinc_71a()).runTest("CWE190_Integer_Overflow__short_console_readLine_preinc_71a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_max_preinc_66a()).runTest("CWE190_Integer_Overflow__short_max_preinc_66a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_random_preinc_10()).runTest("CWE190_Integer_Overflow__int_random_preinc_10");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_max_preinc_67a()).runTest("CWE190_Integer_Overflow__byte_max_preinc_67a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_database_preinc_03()).runTest("CWE190_Integer_Overflow__int_database_preinc_03");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_listen_tcp_preinc_22a()).runTest("CWE190_Integer_Overflow__int_listen_tcp_preinc_22a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_PropertiesFile_preinc_15()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_preinc_15");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_console_readLine_preinc_73a()).runTest("CWE190_Integer_Overflow__int_console_readLine_preinc_73a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_listen_tcp_preinc_02()).runTest("CWE190_Integer_Overflow__int_listen_tcp_preinc_02");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_max_preinc_05()).runTest("CWE190_Integer_Overflow__int_max_preinc_05");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_connect_tcp_preinc_16()).runTest("CWE190_Integer_Overflow__int_connect_tcp_preinc_16");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_max_preinc_07()).runTest("CWE190_Integer_Overflow__byte_max_preinc_07");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_random_preinc_42()).runTest("CWE190_Integer_Overflow__int_random_preinc_42");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_random_preinc_74a()).runTest("CWE190_Integer_Overflow__int_random_preinc_74a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_max_preinc_12()).runTest("CWE190_Integer_Overflow__byte_max_preinc_12");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_console_readLine_preinc_04()).runTest("CWE190_Integer_Overflow__int_console_readLine_preinc_04");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_listen_tcp_preinc_74a()).runTest("CWE190_Integer_Overflow__int_listen_tcp_preinc_74a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_rand_preinc_10()).runTest("CWE190_Integer_Overflow__byte_rand_preinc_10");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_rand_preinc_73a()).runTest("CWE190_Integer_Overflow__long_rand_preinc_73a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_max_preinc_12()).runTest("CWE190_Integer_Overflow__int_max_preinc_12");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_listen_tcp_preinc_31()).runTest("CWE190_Integer_Overflow__int_listen_tcp_preinc_31");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__byte_max_preinc_61a()).runTest("CWE190_Integer_Overflow__byte_max_preinc_61a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_console_readLine_preinc_66a()).runTest("CWE190_Integer_Overflow__int_console_readLine_preinc_66a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Property_preinc_14()).runTest("CWE190_Integer_Overflow__int_Property_preinc_14");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Environment_preinc_75a()).runTest("CWE190_Integer_Overflow__int_Environment_preinc_75a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_console_readLine_preinc_14()).runTest("CWE190_Integer_Overflow__short_console_readLine_preinc_14");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__short_rand_preinc_51a()).runTest("CWE190_Integer_Overflow__short_rand_preinc_51a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Property_preinc_07()).runTest("CWE190_Integer_Overflow__int_Property_preinc_07");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_listen_tcp_preinc_42()).runTest("CWE190_Integer_Overflow__int_listen_tcp_preinc_42");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_File_preinc_05()).runTest("CWE190_Integer_Overflow__int_File_preinc_05");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_PropertiesFile_preinc_41()).runTest("CWE190_Integer_Overflow__int_PropertiesFile_preinc_41");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_connect_tcp_preinc_72a()).runTest("CWE190_Integer_Overflow__int_connect_tcp_preinc_72a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_random_preinc_11()).runTest("CWE190_Integer_Overflow__int_random_preinc_11");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__long_console_readLine_preinc_67a()).runTest("CWE190_Integer_Overflow__long_console_readLine_preinc_67a");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_connect_tcp_preinc_08()).runTest("CWE190_Integer_Overflow__int_connect_tcp_preinc_08");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_File_preinc_02()).runTest("CWE190_Integer_Overflow__int_File_preinc_02");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Property_preinc_42()).runTest("CWE190_Integer_Overflow__int_Property_preinc_42");
			(new testcases.CWE190_Integer_Overflow.s07.CWE190_Integer_Overflow__int_Environment_preinc_11()).runTest("CWE190_Integer_Overflow__int_Environment_preinc_11");
			/* END-AUTOGENERATED-JAVA-TESTS-1 */
}

private static void runTestCWE2() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-2 */

			/* END-AUTOGENERATED-JAVA-TESTS-2 */
}

private static void runTestCWE3() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-3 */

			/* END-AUTOGENERATED-JAVA-TESTS-3 */
}

private static void runTestCWE4() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-4 */

			/* END-AUTOGENERATED-JAVA-TESTS-4 */
}

private static void runTestCWE5() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-5 */

			/* END-AUTOGENERATED-JAVA-TESTS-5 */
}

private static void runTestCWE6() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-6 */

			/* END-AUTOGENERATED-JAVA-TESTS-6 */
}

private static void runTestCWE7() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-7 */

			/* END-AUTOGENERATED-JAVA-TESTS-7 */
}

private static void runTestCWE8() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-8 */

			/* END-AUTOGENERATED-JAVA-TESTS-8 */
}

private static void runTestCWE9() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-9 */

			/* END-AUTOGENERATED-JAVA-TESTS-9 */
}
}