package testcases.CWE191_Integer_Underflow.s01;

import testcasesupport.*;

public class Main {

	public static void main(String[] args) {
		
		if(args.length != 0) {
		
			if(args[0].equals("-h") || args[0].equals("--help")) {
		
				System.err.println("To use this main, you can either run the program with no " +
				"command line arguments to run all test cases or you can specify one or more classes to test");
				System.err.println("For example:");
				System.err.println("java testcasesupport.Main testcases.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference.custom_function.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference__custom_function_01 testcases.CWE481_Assigning_instead_of_Comparing.bool.CWE481_Assigning_instead_of_Comparing__bool_01");
				System.exit(1);
			}
			
			/* User supplied some class names on the command line, just use those with introspection
			 *
			 * String classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
			 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
 			 * could read class names from command line or use
			 * http://sadun-util.sourceforge.net/api/org/sadun/util/
			 * ClassPackageExplorer.html
			 */

			for (String className : args) {

				try {
					
					/* String classNameWithPackage = "testcases." + className; */
					
					/* IO.writeLine("classNameWithPackage = " + classNameWithPackage); */

					Class<?> myClass = Class.forName(className);

					AbstractTestCase myObject = (AbstractTestCase) myClass
							.newInstance();

					myObject.runTest(className);

				} catch (Exception ex) {

					IO.writeLine("Could not run test for class " + className);
					ex.printStackTrace();

				}
				
				IO.writeLine(""); /* leave a blank line between classes */

			}

		} else {
		
			/* No command line args were used, we want to run every testcase */
			
			/* needed to separate these calls into other methods because
			   we were running into the size limit Java has for a single method */
			runTestCWE1();
			runTestCWE2();
			runTestCWE3();
			runTestCWE4();
			runTestCWE5();
			runTestCWE6();
			runTestCWE7();
			runTestCWE8();
			runTestCWE9();
		}			
	}

private static void runTestCWE1() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-1 */
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_multiply_45()).runTest("CWE191_Integer_Underflow__byte_rand_multiply_45");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_multiply_07()).runTest("CWE191_Integer_Underflow__int_database_multiply_07");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_multiply_54a()).runTest("CWE191_Integer_Underflow__byte_rand_multiply_54a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_sub_81a()).runTest("CWE191_Integer_Underflow__byte_rand_sub_81a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_multiply_41()).runTest("CWE191_Integer_Underflow__int_connect_tcp_multiply_41");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_multiply_51a()).runTest("CWE191_Integer_Underflow__int_database_multiply_51a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_sub_02()).runTest("CWE191_Integer_Underflow__int_database_sub_02");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_sub_14()).runTest("CWE191_Integer_Underflow__int_File_sub_14");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_multiply_42()).runTest("CWE191_Integer_Underflow__int_console_readLine_multiply_42");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_sub_42()).runTest("CWE191_Integer_Underflow__byte_rand_sub_42");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_sub_53a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_sub_53a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_sub_45()).runTest("CWE191_Integer_Underflow__int_Environment_sub_45");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_sub_66a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_sub_66a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_multiply_05()).runTest("CWE191_Integer_Underflow__int_Environment_multiply_05");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_multiply_75a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_multiply_75a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_multiply_68a()).runTest("CWE191_Integer_Underflow__int_database_multiply_68a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_sub_15()).runTest("CWE191_Integer_Underflow__byte_min_sub_15");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_multiply_73a()).runTest("CWE191_Integer_Underflow__int_File_multiply_73a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_sub_09()).runTest("CWE191_Integer_Underflow__int_Environment_sub_09");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_multiply_02()).runTest("CWE191_Integer_Underflow__byte_min_multiply_02");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_sub_12()).runTest("CWE191_Integer_Underflow__int_connect_tcp_sub_12");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_sub_42()).runTest("CWE191_Integer_Underflow__byte_min_sub_42");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_sub_45()).runTest("CWE191_Integer_Underflow__int_console_readLine_sub_45");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_multiply_17()).runTest("CWE191_Integer_Underflow__int_File_multiply_17");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_sub_81a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_sub_81a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_multiply_06()).runTest("CWE191_Integer_Underflow__byte_console_readLine_multiply_06");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_sub_53a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_sub_53a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_multiply_81a()).runTest("CWE191_Integer_Underflow__byte_rand_multiply_81a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_multiply_06()).runTest("CWE191_Integer_Underflow__int_File_multiply_06");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_sub_31()).runTest("CWE191_Integer_Underflow__int_database_sub_31");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_sub_51a()).runTest("CWE191_Integer_Underflow__int_console_readLine_sub_51a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_multiply_13()).runTest("CWE191_Integer_Underflow__int_console_readLine_multiply_13");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_sub_06()).runTest("CWE191_Integer_Underflow__int_console_readLine_sub_06");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_sub_68a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_sub_68a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_sub_71a()).runTest("CWE191_Integer_Underflow__int_database_sub_71a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_multiply_03()).runTest("CWE191_Integer_Underflow__byte_console_readLine_multiply_03");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_sub_15()).runTest("CWE191_Integer_Underflow__int_console_readLine_sub_15");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_sub_07()).runTest("CWE191_Integer_Underflow__byte_console_readLine_sub_07");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_multiply_61a()).runTest("CWE191_Integer_Underflow__int_File_multiply_61a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_sub_75a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_sub_75a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_multiply_13()).runTest("CWE191_Integer_Underflow__int_Environment_multiply_13");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_sub_41()).runTest("CWE191_Integer_Underflow__byte_rand_sub_41");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_sub_52a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_sub_52a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_sub_74a()).runTest("CWE191_Integer_Underflow__byte_rand_sub_74a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_sub_75a()).runTest("CWE191_Integer_Underflow__byte_rand_sub_75a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_sub_71a()).runTest("CWE191_Integer_Underflow__int_Environment_sub_71a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_multiply_74a()).runTest("CWE191_Integer_Underflow__int_Environment_multiply_74a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_multiply_68a()).runTest("CWE191_Integer_Underflow__byte_min_multiply_68a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_multiply_16()).runTest("CWE191_Integer_Underflow__byte_console_readLine_multiply_16");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_multiply_10()).runTest("CWE191_Integer_Underflow__int_console_readLine_multiply_10");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_multiply_68a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_multiply_68a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_sub_61a()).runTest("CWE191_Integer_Underflow__int_File_sub_61a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_sub_09()).runTest("CWE191_Integer_Underflow__byte_rand_sub_09");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_sub_31()).runTest("CWE191_Integer_Underflow__byte_rand_sub_31");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_sub_02()).runTest("CWE191_Integer_Underflow__byte_console_readLine_sub_02");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_multiply_66a()).runTest("CWE191_Integer_Underflow__byte_min_multiply_66a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_multiply_53a()).runTest("CWE191_Integer_Underflow__byte_rand_multiply_53a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_sub_15()).runTest("CWE191_Integer_Underflow__int_database_sub_15");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_sub_52a()).runTest("CWE191_Integer_Underflow__byte_rand_sub_52a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_sub_67a()).runTest("CWE191_Integer_Underflow__int_database_sub_67a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_multiply_68a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_multiply_68a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_multiply_75a()).runTest("CWE191_Integer_Underflow__byte_min_multiply_75a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_sub_09()).runTest("CWE191_Integer_Underflow__int_File_sub_09");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_sub_05()).runTest("CWE191_Integer_Underflow__int_database_sub_05");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_multiply_73a()).runTest("CWE191_Integer_Underflow__int_console_readLine_multiply_73a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_multiply_21()).runTest("CWE191_Integer_Underflow__int_database_multiply_21");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_sub_07()).runTest("CWE191_Integer_Underflow__int_database_sub_07");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_multiply_66a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_multiply_66a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_multiply_31()).runTest("CWE191_Integer_Underflow__int_File_multiply_31");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_multiply_21()).runTest("CWE191_Integer_Underflow__int_File_multiply_21");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_multiply_51a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_multiply_51a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_sub_53a()).runTest("CWE191_Integer_Underflow__byte_min_sub_53a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_sub_06()).runTest("CWE191_Integer_Underflow__int_File_sub_06");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_multiply_75a()).runTest("CWE191_Integer_Underflow__byte_rand_multiply_75a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_sub_17()).runTest("CWE191_Integer_Underflow__int_database_sub_17");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_multiply_53a()).runTest("CWE191_Integer_Underflow__byte_min_multiply_53a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_multiply_10()).runTest("CWE191_Integer_Underflow__byte_min_multiply_10");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_sub_67a()).runTest("CWE191_Integer_Underflow__byte_min_sub_67a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_multiply_53a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_multiply_53a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_sub_42()).runTest("CWE191_Integer_Underflow__int_console_readLine_sub_42");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_sub_16()).runTest("CWE191_Integer_Underflow__byte_min_sub_16");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_sub_45()).runTest("CWE191_Integer_Underflow__byte_console_readLine_sub_45");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_multiply_16()).runTest("CWE191_Integer_Underflow__byte_min_multiply_16");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_sub_66a()).runTest("CWE191_Integer_Underflow__byte_rand_sub_66a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_multiply_12()).runTest("CWE191_Integer_Underflow__byte_console_readLine_multiply_12");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_multiply_09()).runTest("CWE191_Integer_Underflow__int_database_multiply_09");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_multiply_22a()).runTest("CWE191_Integer_Underflow__byte_rand_multiply_22a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_sub_31()).runTest("CWE191_Integer_Underflow__int_File_sub_31");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_multiply_74a()).runTest("CWE191_Integer_Underflow__int_console_readLine_multiply_74a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_multiply_52a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_multiply_52a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_multiply_17()).runTest("CWE191_Integer_Underflow__byte_console_readLine_multiply_17");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_sub_13()).runTest("CWE191_Integer_Underflow__int_Environment_sub_13");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_sub_66a()).runTest("CWE191_Integer_Underflow__int_console_readLine_sub_66a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_multiply_68a()).runTest("CWE191_Integer_Underflow__int_Environment_multiply_68a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_multiply_05()).runTest("CWE191_Integer_Underflow__byte_rand_multiply_05");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_sub_10()).runTest("CWE191_Integer_Underflow__int_connect_tcp_sub_10");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_sub_68a()).runTest("CWE191_Integer_Underflow__byte_min_sub_68a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_multiply_22a()).runTest("CWE191_Integer_Underflow__int_File_multiply_22a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_sub_68a()).runTest("CWE191_Integer_Underflow__int_File_sub_68a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_multiply_12()).runTest("CWE191_Integer_Underflow__int_console_readLine_multiply_12");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_sub_05()).runTest("CWE191_Integer_Underflow__byte_min_sub_05");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_multiply_10()).runTest("CWE191_Integer_Underflow__int_File_multiply_10");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_multiply_52a()).runTest("CWE191_Integer_Underflow__int_File_multiply_52a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_multiply_53a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_multiply_53a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_sub_17()).runTest("CWE191_Integer_Underflow__byte_min_sub_17");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_multiply_17()).runTest("CWE191_Integer_Underflow__int_database_multiply_17");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_multiply_67a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_multiply_67a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_sub_75a()).runTest("CWE191_Integer_Underflow__byte_min_sub_75a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_sub_22a()).runTest("CWE191_Integer_Underflow__byte_rand_sub_22a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_multiply_72a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_multiply_72a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_sub_68a()).runTest("CWE191_Integer_Underflow__int_Environment_sub_68a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_multiply_14()).runTest("CWE191_Integer_Underflow__int_console_readLine_multiply_14");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_multiply_81a()).runTest("CWE191_Integer_Underflow__int_console_readLine_multiply_81a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_sub_53a()).runTest("CWE191_Integer_Underflow__int_database_sub_53a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_multiply_45()).runTest("CWE191_Integer_Underflow__int_connect_tcp_multiply_45");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_sub_45()).runTest("CWE191_Integer_Underflow__int_connect_tcp_sub_45");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_multiply_52a()).runTest("CWE191_Integer_Underflow__int_console_readLine_multiply_52a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_sub_45()).runTest("CWE191_Integer_Underflow__byte_rand_sub_45");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_multiply_81a()).runTest("CWE191_Integer_Underflow__byte_min_multiply_81a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_sub_51a()).runTest("CWE191_Integer_Underflow__int_Environment_sub_51a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_sub_09()).runTest("CWE191_Integer_Underflow__int_console_readLine_sub_09");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_sub_41()).runTest("CWE191_Integer_Underflow__int_Environment_sub_41");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_multiply_66a()).runTest("CWE191_Integer_Underflow__int_Environment_multiply_66a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_sub_12()).runTest("CWE191_Integer_Underflow__int_File_sub_12");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_multiply_45()).runTest("CWE191_Integer_Underflow__int_File_multiply_45");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_sub_41()).runTest("CWE191_Integer_Underflow__int_connect_tcp_sub_41");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_sub_68a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_sub_68a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_multiply_11()).runTest("CWE191_Integer_Underflow__int_File_multiply_11");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_multiply_11()).runTest("CWE191_Integer_Underflow__byte_min_multiply_11");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_multiply_51a()).runTest("CWE191_Integer_Underflow__int_File_multiply_51a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_sub_08()).runTest("CWE191_Integer_Underflow__byte_console_readLine_sub_08");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_sub_10()).runTest("CWE191_Integer_Underflow__int_Environment_sub_10");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_sub_54a()).runTest("CWE191_Integer_Underflow__int_database_sub_54a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_multiply_74a()).runTest("CWE191_Integer_Underflow__byte_rand_multiply_74a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_sub_81a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_sub_81a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_sub_81a()).runTest("CWE191_Integer_Underflow__int_database_sub_81a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_sub_72a()).runTest("CWE191_Integer_Underflow__int_Environment_sub_72a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_sub_42()).runTest("CWE191_Integer_Underflow__int_database_sub_42");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_multiply_22a()).runTest("CWE191_Integer_Underflow__int_Environment_multiply_22a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_sub_03()).runTest("CWE191_Integer_Underflow__int_Environment_sub_03");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_sub_72a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_sub_72a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_multiply_52a()).runTest("CWE191_Integer_Underflow__byte_rand_multiply_52a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_multiply_16()).runTest("CWE191_Integer_Underflow__int_connect_tcp_multiply_16");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_multiply_11()).runTest("CWE191_Integer_Underflow__int_Environment_multiply_11");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_sub_22a()).runTest("CWE191_Integer_Underflow__int_database_sub_22a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_sub_66a()).runTest("CWE191_Integer_Underflow__int_database_sub_66a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_multiply_22a()).runTest("CWE191_Integer_Underflow__byte_min_multiply_22a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_sub_02()).runTest("CWE191_Integer_Underflow__int_console_readLine_sub_02");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_multiply_09()).runTest("CWE191_Integer_Underflow__int_connect_tcp_multiply_09");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_multiply_61a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_multiply_61a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_multiply_06()).runTest("CWE191_Integer_Underflow__int_console_readLine_multiply_06");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_multiply_75a()).runTest("CWE191_Integer_Underflow__int_console_readLine_multiply_75a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_multiply_51a()).runTest("CWE191_Integer_Underflow__byte_min_multiply_51a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_sub_75a()).runTest("CWE191_Integer_Underflow__int_File_sub_75a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_multiply_42()).runTest("CWE191_Integer_Underflow__int_File_multiply_42");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_multiply_54a()).runTest("CWE191_Integer_Underflow__int_Environment_multiply_54a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_sub_67a()).runTest("CWE191_Integer_Underflow__int_Environment_sub_67a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_sub_10()).runTest("CWE191_Integer_Underflow__byte_min_sub_10");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_sub_08()).runTest("CWE191_Integer_Underflow__int_connect_tcp_sub_08");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_multiply_05()).runTest("CWE191_Integer_Underflow__int_File_multiply_05");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_sub_06()).runTest("CWE191_Integer_Underflow__byte_rand_sub_06");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_multiply_11()).runTest("CWE191_Integer_Underflow__int_connect_tcp_multiply_11");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_sub_17()).runTest("CWE191_Integer_Underflow__int_connect_tcp_sub_17");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_sub_21()).runTest("CWE191_Integer_Underflow__byte_console_readLine_sub_21");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_sub_53a()).runTest("CWE191_Integer_Underflow__int_File_sub_53a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_multiply_02()).runTest("CWE191_Integer_Underflow__byte_rand_multiply_02");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_sub_07()).runTest("CWE191_Integer_Underflow__int_File_sub_07");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_multiply_14()).runTest("CWE191_Integer_Underflow__int_File_multiply_14");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_sub_08()).runTest("CWE191_Integer_Underflow__int_database_sub_08");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_multiply_16()).runTest("CWE191_Integer_Underflow__int_database_multiply_16");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_multiply_02()).runTest("CWE191_Integer_Underflow__byte_console_readLine_multiply_02");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_sub_22a()).runTest("CWE191_Integer_Underflow__int_console_readLine_sub_22a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_multiply_07()).runTest("CWE191_Integer_Underflow__int_console_readLine_multiply_07");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_sub_22a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_sub_22a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_sub_53a()).runTest("CWE191_Integer_Underflow__byte_rand_sub_53a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_sub_06()).runTest("CWE191_Integer_Underflow__byte_min_sub_06");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_sub_10()).runTest("CWE191_Integer_Underflow__byte_console_readLine_sub_10");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_multiply_04()).runTest("CWE191_Integer_Underflow__int_connect_tcp_multiply_04");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_sub_14()).runTest("CWE191_Integer_Underflow__byte_rand_sub_14");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_multiply_73a()).runTest("CWE191_Integer_Underflow__int_database_multiply_73a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_sub_13()).runTest("CWE191_Integer_Underflow__int_connect_tcp_sub_13");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_sub_06()).runTest("CWE191_Integer_Underflow__int_Environment_sub_06");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_multiply_07()).runTest("CWE191_Integer_Underflow__int_File_multiply_07");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_sub_71a()).runTest("CWE191_Integer_Underflow__byte_rand_sub_71a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_sub_31()).runTest("CWE191_Integer_Underflow__int_connect_tcp_sub_31");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_multiply_06()).runTest("CWE191_Integer_Underflow__byte_rand_multiply_06");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_multiply_15()).runTest("CWE191_Integer_Underflow__int_database_multiply_15");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_sub_14()).runTest("CWE191_Integer_Underflow__int_connect_tcp_sub_14");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_multiply_12()).runTest("CWE191_Integer_Underflow__byte_min_multiply_12");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_multiply_15()).runTest("CWE191_Integer_Underflow__int_console_readLine_multiply_15");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_sub_12()).runTest("CWE191_Integer_Underflow__byte_min_sub_12");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_multiply_66a()).runTest("CWE191_Integer_Underflow__int_database_multiply_66a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_multiply_05()).runTest("CWE191_Integer_Underflow__int_connect_tcp_multiply_05");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_sub_07()).runTest("CWE191_Integer_Underflow__int_Environment_sub_07");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_sub_04()).runTest("CWE191_Integer_Underflow__int_File_sub_04");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_multiply_31()).runTest("CWE191_Integer_Underflow__byte_min_multiply_31");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_sub_09()).runTest("CWE191_Integer_Underflow__byte_console_readLine_sub_09");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_sub_01()).runTest("CWE191_Integer_Underflow__byte_rand_sub_01");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_multiply_66a()).runTest("CWE191_Integer_Underflow__int_console_readLine_multiply_66a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_multiply_17()).runTest("CWE191_Integer_Underflow__byte_min_multiply_17");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_multiply_45()).runTest("CWE191_Integer_Underflow__int_database_multiply_45");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_multiply_67a()).runTest("CWE191_Integer_Underflow__int_Environment_multiply_67a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_multiply_74a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_multiply_74a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_sub_52a()).runTest("CWE191_Integer_Underflow__int_console_readLine_sub_52a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_sub_15()).runTest("CWE191_Integer_Underflow__byte_console_readLine_sub_15");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_multiply_42()).runTest("CWE191_Integer_Underflow__int_connect_tcp_multiply_42");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_multiply_42()).runTest("CWE191_Integer_Underflow__int_Environment_multiply_42");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_sub_42()).runTest("CWE191_Integer_Underflow__int_File_sub_42");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_sub_01()).runTest("CWE191_Integer_Underflow__byte_console_readLine_sub_01");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_sub_16()).runTest("CWE191_Integer_Underflow__byte_console_readLine_sub_16");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_multiply_05()).runTest("CWE191_Integer_Underflow__int_database_multiply_05");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_sub_06()).runTest("CWE191_Integer_Underflow__int_connect_tcp_sub_06");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_multiply_22a()).runTest("CWE191_Integer_Underflow__int_database_multiply_22a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_sub_41()).runTest("CWE191_Integer_Underflow__int_database_sub_41");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_sub_42()).runTest("CWE191_Integer_Underflow__byte_console_readLine_sub_42");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_sub_71a()).runTest("CWE191_Integer_Underflow__byte_min_sub_71a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_multiply_17()).runTest("CWE191_Integer_Underflow__byte_rand_multiply_17");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_sub_08()).runTest("CWE191_Integer_Underflow__int_File_sub_08");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_multiply_61a()).runTest("CWE191_Integer_Underflow__int_database_multiply_61a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_sub_22a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_sub_22a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_sub_02()).runTest("CWE191_Integer_Underflow__byte_min_sub_02");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_sub_14()).runTest("CWE191_Integer_Underflow__int_console_readLine_sub_14");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_sub_71a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_sub_71a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_multiply_15()).runTest("CWE191_Integer_Underflow__int_connect_tcp_multiply_15");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_multiply_12()).runTest("CWE191_Integer_Underflow__int_connect_tcp_multiply_12");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_multiply_66a()).runTest("CWE191_Integer_Underflow__int_File_multiply_66a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_multiply_12()).runTest("CWE191_Integer_Underflow__int_File_multiply_12");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_multiply_12()).runTest("CWE191_Integer_Underflow__byte_rand_multiply_12");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_multiply_81a()).runTest("CWE191_Integer_Underflow__int_Environment_multiply_81a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_sub_73a()).runTest("CWE191_Integer_Underflow__byte_rand_sub_73a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_multiply_01()).runTest("CWE191_Integer_Underflow__int_Environment_multiply_01");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_sub_10()).runTest("CWE191_Integer_Underflow__byte_rand_sub_10");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_multiply_54a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_multiply_54a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_sub_16()).runTest("CWE191_Integer_Underflow__int_database_sub_16");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_multiply_16()).runTest("CWE191_Integer_Underflow__int_Environment_multiply_16");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_multiply_08()).runTest("CWE191_Integer_Underflow__byte_min_multiply_08");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_multiply_13()).runTest("CWE191_Integer_Underflow__byte_console_readLine_multiply_13");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_sub_17()).runTest("CWE191_Integer_Underflow__int_console_readLine_sub_17");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_sub_51a()).runTest("CWE191_Integer_Underflow__byte_min_sub_51a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_multiply_05()).runTest("CWE191_Integer_Underflow__byte_console_readLine_multiply_05");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_multiply_75a()).runTest("CWE191_Integer_Underflow__int_database_multiply_75a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_sub_14()).runTest("CWE191_Integer_Underflow__byte_console_readLine_sub_14");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_multiply_04()).runTest("CWE191_Integer_Underflow__byte_min_multiply_04");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_multiply_66a()).runTest("CWE191_Integer_Underflow__byte_rand_multiply_66a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_sub_72a()).runTest("CWE191_Integer_Underflow__int_console_readLine_sub_72a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_multiply_67a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_multiply_67a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_sub_72a()).runTest("CWE191_Integer_Underflow__int_database_sub_72a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_multiply_74a()).runTest("CWE191_Integer_Underflow__byte_min_multiply_74a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_multiply_52a()).runTest("CWE191_Integer_Underflow__int_Environment_multiply_52a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_multiply_75a()).runTest("CWE191_Integer_Underflow__int_File_multiply_75a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_multiply_13()).runTest("CWE191_Integer_Underflow__int_File_multiply_13");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_multiply_08()).runTest("CWE191_Integer_Underflow__int_File_multiply_08");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_sub_31()).runTest("CWE191_Integer_Underflow__int_Environment_sub_31");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_multiply_04()).runTest("CWE191_Integer_Underflow__byte_console_readLine_multiply_04");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_sub_81a()).runTest("CWE191_Integer_Underflow__int_console_readLine_sub_81a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_multiply_17()).runTest("CWE191_Integer_Underflow__int_connect_tcp_multiply_17");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_multiply_09()).runTest("CWE191_Integer_Underflow__int_File_multiply_09");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_multiply_61a()).runTest("CWE191_Integer_Underflow__byte_rand_multiply_61a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_sub_61a()).runTest("CWE191_Integer_Underflow__int_Environment_sub_61a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_sub_03()).runTest("CWE191_Integer_Underflow__int_console_readLine_sub_03");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_multiply_12()).runTest("CWE191_Integer_Underflow__int_Environment_multiply_12");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_multiply_51a()).runTest("CWE191_Integer_Underflow__int_Environment_multiply_51a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_sub_66a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_sub_66a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_sub_41()).runTest("CWE191_Integer_Underflow__byte_min_sub_41");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_sub_61a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_sub_61a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_multiply_08()).runTest("CWE191_Integer_Underflow__byte_rand_multiply_08");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_multiply_22a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_multiply_22a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_sub_05()).runTest("CWE191_Integer_Underflow__byte_console_readLine_sub_05");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_multiply_14()).runTest("CWE191_Integer_Underflow__byte_min_multiply_14");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_sub_16()).runTest("CWE191_Integer_Underflow__int_File_sub_16");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_sub_02()).runTest("CWE191_Integer_Underflow__int_Environment_sub_02");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_sub_01()).runTest("CWE191_Integer_Underflow__int_File_sub_01");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_multiply_07()).runTest("CWE191_Integer_Underflow__int_connect_tcp_multiply_07");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_sub_11()).runTest("CWE191_Integer_Underflow__int_console_readLine_sub_11");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_multiply_10()).runTest("CWE191_Integer_Underflow__int_Environment_multiply_10");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_multiply_81a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_multiply_81a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_multiply_22a()).runTest("CWE191_Integer_Underflow__int_console_readLine_multiply_22a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_multiply_21()).runTest("CWE191_Integer_Underflow__int_connect_tcp_multiply_21");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_multiply_54a()).runTest("CWE191_Integer_Underflow__int_console_readLine_multiply_54a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_sub_66a()).runTest("CWE191_Integer_Underflow__byte_min_sub_66a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_sub_31()).runTest("CWE191_Integer_Underflow__byte_console_readLine_sub_31");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_sub_16()).runTest("CWE191_Integer_Underflow__int_console_readLine_sub_16");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_multiply_03()).runTest("CWE191_Integer_Underflow__byte_min_multiply_03");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_sub_66a()).runTest("CWE191_Integer_Underflow__int_Environment_sub_66a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_multiply_42()).runTest("CWE191_Integer_Underflow__int_database_multiply_42");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_sub_61a()).runTest("CWE191_Integer_Underflow__byte_rand_sub_61a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_sub_74a()).runTest("CWE191_Integer_Underflow__byte_min_sub_74a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_sub_74a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_sub_74a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_sub_52a()).runTest("CWE191_Integer_Underflow__int_database_sub_52a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_multiply_67a()).runTest("CWE191_Integer_Underflow__byte_min_multiply_67a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_multiply_01()).runTest("CWE191_Integer_Underflow__int_connect_tcp_multiply_01");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_sub_73a()).runTest("CWE191_Integer_Underflow__int_console_readLine_sub_73a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_sub_04()).runTest("CWE191_Integer_Underflow__byte_console_readLine_sub_04");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_sub_13()).runTest("CWE191_Integer_Underflow__int_File_sub_13");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_sub_73a()).runTest("CWE191_Integer_Underflow__int_database_sub_73a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_sub_21()).runTest("CWE191_Integer_Underflow__int_console_readLine_sub_21");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_multiply_08()).runTest("CWE191_Integer_Underflow__int_Environment_multiply_08");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_sub_11()).runTest("CWE191_Integer_Underflow__byte_rand_sub_11");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_sub_10()).runTest("CWE191_Integer_Underflow__int_console_readLine_sub_10");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_sub_13()).runTest("CWE191_Integer_Underflow__int_database_sub_13");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_sub_02()).runTest("CWE191_Integer_Underflow__int_connect_tcp_sub_02");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_sub_66a()).runTest("CWE191_Integer_Underflow__int_File_sub_66a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_multiply_72a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_multiply_72a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_sub_08()).runTest("CWE191_Integer_Underflow__int_console_readLine_sub_08");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_multiply_10()).runTest("CWE191_Integer_Underflow__byte_console_readLine_multiply_10");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_sub_73a()).runTest("CWE191_Integer_Underflow__int_File_sub_73a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_sub_53a()).runTest("CWE191_Integer_Underflow__int_Environment_sub_53a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_sub_73a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_sub_73a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_sub_10()).runTest("CWE191_Integer_Underflow__int_File_sub_10");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_multiply_09()).runTest("CWE191_Integer_Underflow__byte_console_readLine_multiply_09");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_sub_13()).runTest("CWE191_Integer_Underflow__byte_console_readLine_sub_13");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_multiply_72a()).runTest("CWE191_Integer_Underflow__byte_rand_multiply_72a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_sub_74a()).runTest("CWE191_Integer_Underflow__int_File_sub_74a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_sub_72a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_sub_72a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_multiply_72a()).runTest("CWE191_Integer_Underflow__int_database_multiply_72a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_sub_16()).runTest("CWE191_Integer_Underflow__int_connect_tcp_sub_16");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_sub_05()).runTest("CWE191_Integer_Underflow__int_connect_tcp_sub_05");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_sub_08()).runTest("CWE191_Integer_Underflow__byte_min_sub_08");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_sub_16()).runTest("CWE191_Integer_Underflow__int_Environment_sub_16");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_multiply_41()).runTest("CWE191_Integer_Underflow__int_Environment_multiply_41");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_multiply_81a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_multiply_81a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_multiply_11()).runTest("CWE191_Integer_Underflow__byte_rand_multiply_11");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_sub_22a()).runTest("CWE191_Integer_Underflow__byte_min_sub_22a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_sub_12()).runTest("CWE191_Integer_Underflow__byte_console_readLine_sub_12");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_sub_75a()).runTest("CWE191_Integer_Underflow__int_console_readLine_sub_75a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_sub_54a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_sub_54a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_sub_11()).runTest("CWE191_Integer_Underflow__byte_console_readLine_sub_11");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_sub_14()).runTest("CWE191_Integer_Underflow__int_Environment_sub_14");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_multiply_67a()).runTest("CWE191_Integer_Underflow__int_database_multiply_67a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_sub_68a()).runTest("CWE191_Integer_Underflow__int_console_readLine_sub_68a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_multiply_15()).runTest("CWE191_Integer_Underflow__byte_console_readLine_multiply_15");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_sub_07()).runTest("CWE191_Integer_Underflow__byte_min_sub_07");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_multiply_13()).runTest("CWE191_Integer_Underflow__byte_rand_multiply_13");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_multiply_81a()).runTest("CWE191_Integer_Underflow__int_File_multiply_81a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_multiply_03()).runTest("CWE191_Integer_Underflow__int_database_multiply_03");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_multiply_02()).runTest("CWE191_Integer_Underflow__int_database_multiply_02");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_multiply_21()).runTest("CWE191_Integer_Underflow__int_console_readLine_multiply_21");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_multiply_16()).runTest("CWE191_Integer_Underflow__byte_rand_multiply_16");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_sub_21()).runTest("CWE191_Integer_Underflow__int_File_sub_21");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_multiply_68a()).runTest("CWE191_Integer_Underflow__byte_rand_multiply_68a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_sub_73a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_sub_73a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_multiply_13()).runTest("CWE191_Integer_Underflow__int_connect_tcp_multiply_13");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_multiply_67a()).runTest("CWE191_Integer_Underflow__int_File_multiply_67a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_multiply_71a()).runTest("CWE191_Integer_Underflow__byte_rand_multiply_71a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_sub_13()).runTest("CWE191_Integer_Underflow__byte_rand_sub_13");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_multiply_71a()).runTest("CWE191_Integer_Underflow__int_console_readLine_multiply_71a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_multiply_71a()).runTest("CWE191_Integer_Underflow__byte_min_multiply_71a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_sub_31()).runTest("CWE191_Integer_Underflow__int_console_readLine_sub_31");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_multiply_05()).runTest("CWE191_Integer_Underflow__int_console_readLine_multiply_05");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_multiply_73a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_multiply_73a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_sub_75a()).runTest("CWE191_Integer_Underflow__int_Environment_sub_75a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_multiply_81a()).runTest("CWE191_Integer_Underflow__int_database_multiply_81a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_multiply_31()).runTest("CWE191_Integer_Underflow__int_Environment_multiply_31");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_sub_14()).runTest("CWE191_Integer_Underflow__byte_min_sub_14");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_multiply_31()).runTest("CWE191_Integer_Underflow__int_database_multiply_31");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_multiply_71a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_multiply_71a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_multiply_08()).runTest("CWE191_Integer_Underflow__byte_console_readLine_multiply_08");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_sub_02()).runTest("CWE191_Integer_Underflow__int_File_sub_02");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_sub_53a()).runTest("CWE191_Integer_Underflow__int_console_readLine_sub_53a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_multiply_06()).runTest("CWE191_Integer_Underflow__int_Environment_multiply_06");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_sub_67a()).runTest("CWE191_Integer_Underflow__int_console_readLine_sub_67a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_sub_07()).runTest("CWE191_Integer_Underflow__int_console_readLine_sub_07");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_multiply_07()).runTest("CWE191_Integer_Underflow__byte_console_readLine_multiply_07");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_multiply_07()).runTest("CWE191_Integer_Underflow__byte_min_multiply_07");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_multiply_14()).runTest("CWE191_Integer_Underflow__byte_console_readLine_multiply_14");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_sub_74a()).runTest("CWE191_Integer_Underflow__int_database_sub_74a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_sub_04()).runTest("CWE191_Integer_Underflow__int_connect_tcp_sub_04");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_sub_72a()).runTest("CWE191_Integer_Underflow__byte_min_sub_72a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_sub_06()).runTest("CWE191_Integer_Underflow__byte_console_readLine_sub_06");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_multiply_71a()).runTest("CWE191_Integer_Underflow__int_Environment_multiply_71a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_sub_51a()).runTest("CWE191_Integer_Underflow__byte_rand_sub_51a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_sub_41()).runTest("CWE191_Integer_Underflow__byte_console_readLine_sub_41");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_sub_13()).runTest("CWE191_Integer_Underflow__int_console_readLine_sub_13");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_multiply_09()).runTest("CWE191_Integer_Underflow__int_console_readLine_multiply_09");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_multiply_04()).runTest("CWE191_Integer_Underflow__int_database_multiply_04");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_sub_13()).runTest("CWE191_Integer_Underflow__byte_min_sub_13");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_multiply_66a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_multiply_66a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_sub_12()).runTest("CWE191_Integer_Underflow__byte_rand_sub_12");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_multiply_75a()).runTest("CWE191_Integer_Underflow__int_Environment_multiply_75a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_sub_52a()).runTest("CWE191_Integer_Underflow__int_File_sub_52a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_sub_11()).runTest("CWE191_Integer_Underflow__int_connect_tcp_sub_11");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_sub_04()).runTest("CWE191_Integer_Underflow__int_Environment_sub_04");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_sub_22a()).runTest("CWE191_Integer_Underflow__int_Environment_sub_22a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_multiply_54a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_multiply_54a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_sub_04()).runTest("CWE191_Integer_Underflow__byte_min_sub_04");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_sub_15()).runTest("CWE191_Integer_Underflow__int_File_sub_15");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_sub_54a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_sub_54a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_sub_45()).runTest("CWE191_Integer_Underflow__int_database_sub_45");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_multiply_41()).runTest("CWE191_Integer_Underflow__int_console_readLine_multiply_41");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_sub_52a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_sub_52a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_sub_41()).runTest("CWE191_Integer_Underflow__int_File_sub_41");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_multiply_01()).runTest("CWE191_Integer_Underflow__byte_min_multiply_01");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_sub_11()).runTest("CWE191_Integer_Underflow__int_database_sub_11");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_multiply_51a()).runTest("CWE191_Integer_Underflow__byte_rand_multiply_51a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_sub_06()).runTest("CWE191_Integer_Underflow__int_database_sub_06");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_sub_54a()).runTest("CWE191_Integer_Underflow__int_File_sub_54a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_multiply_16()).runTest("CWE191_Integer_Underflow__int_console_readLine_multiply_16");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_sub_52a()).runTest("CWE191_Integer_Underflow__int_Environment_sub_52a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_multiply_45()).runTest("CWE191_Integer_Underflow__int_console_readLine_multiply_45");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_sub_01()).runTest("CWE191_Integer_Underflow__byte_min_sub_01");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_sub_51a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_sub_51a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_sub_54a()).runTest("CWE191_Integer_Underflow__int_Environment_sub_54a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_multiply_08()).runTest("CWE191_Integer_Underflow__int_database_multiply_08");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_sub_11()).runTest("CWE191_Integer_Underflow__byte_min_sub_11");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_sub_67a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_sub_67a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_sub_42()).runTest("CWE191_Integer_Underflow__int_Environment_sub_42");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_multiply_09()).runTest("CWE191_Integer_Underflow__byte_min_multiply_09");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_sub_45()).runTest("CWE191_Integer_Underflow__byte_min_sub_45");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_multiply_11()).runTest("CWE191_Integer_Underflow__int_database_multiply_11");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_multiply_74a()).runTest("CWE191_Integer_Underflow__int_File_multiply_74a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_multiply_10()).runTest("CWE191_Integer_Underflow__int_connect_tcp_multiply_10");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_multiply_17()).runTest("CWE191_Integer_Underflow__int_Environment_multiply_17");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_multiply_73a()).runTest("CWE191_Integer_Underflow__byte_rand_multiply_73a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_multiply_41()).runTest("CWE191_Integer_Underflow__byte_min_multiply_41");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_sub_61a()).runTest("CWE191_Integer_Underflow__int_database_sub_61a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_sub_21()).runTest("CWE191_Integer_Underflow__int_database_sub_21");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_multiply_61a()).runTest("CWE191_Integer_Underflow__int_Environment_multiply_61a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_sub_73a()).runTest("CWE191_Integer_Underflow__int_Environment_sub_73a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_sub_51a()).runTest("CWE191_Integer_Underflow__int_database_sub_51a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_multiply_11()).runTest("CWE191_Integer_Underflow__byte_console_readLine_multiply_11");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_multiply_71a()).runTest("CWE191_Integer_Underflow__int_File_multiply_71a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_multiply_45()).runTest("CWE191_Integer_Underflow__byte_console_readLine_multiply_45");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_multiply_42()).runTest("CWE191_Integer_Underflow__byte_rand_multiply_42");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_sub_02()).runTest("CWE191_Integer_Underflow__byte_rand_sub_02");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_multiply_31()).runTest("CWE191_Integer_Underflow__int_console_readLine_multiply_31");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_sub_72a()).runTest("CWE191_Integer_Underflow__int_File_sub_72a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_sub_08()).runTest("CWE191_Integer_Underflow__byte_rand_sub_08");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_multiply_01()).runTest("CWE191_Integer_Underflow__byte_rand_multiply_01");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_multiply_68a()).runTest("CWE191_Integer_Underflow__int_console_readLine_multiply_68a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_multiply_14()).runTest("CWE191_Integer_Underflow__byte_rand_multiply_14");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_multiply_03()).runTest("CWE191_Integer_Underflow__int_connect_tcp_multiply_03");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_multiply_04()).runTest("CWE191_Integer_Underflow__int_Environment_multiply_04");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_multiply_04()).runTest("CWE191_Integer_Underflow__int_File_multiply_04");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_multiply_06()).runTest("CWE191_Integer_Underflow__int_database_multiply_06");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_sub_21()).runTest("CWE191_Integer_Underflow__byte_rand_sub_21");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_sub_21()).runTest("CWE191_Integer_Underflow__int_connect_tcp_sub_21");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_sub_15()).runTest("CWE191_Integer_Underflow__byte_rand_sub_15");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_sub_74a()).runTest("CWE191_Integer_Underflow__int_Environment_sub_74a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_multiply_05()).runTest("CWE191_Integer_Underflow__byte_min_multiply_05");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_sub_17()).runTest("CWE191_Integer_Underflow__int_File_sub_17");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_sub_54a()).runTest("CWE191_Integer_Underflow__byte_rand_sub_54a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_sub_08()).runTest("CWE191_Integer_Underflow__int_Environment_sub_08");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_multiply_54a()).runTest("CWE191_Integer_Underflow__byte_min_multiply_54a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_sub_67a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_sub_67a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_sub_03()).runTest("CWE191_Integer_Underflow__int_connect_tcp_sub_03");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_multiply_15()).runTest("CWE191_Integer_Underflow__byte_rand_multiply_15");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_multiply_42()).runTest("CWE191_Integer_Underflow__byte_min_multiply_42");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_multiply_73a()).runTest("CWE191_Integer_Underflow__byte_min_multiply_73a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_sub_68a()).runTest("CWE191_Integer_Underflow__int_database_sub_68a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_multiply_75a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_multiply_75a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_multiply_53a()).runTest("CWE191_Integer_Underflow__int_console_readLine_multiply_53a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_sub_10()).runTest("CWE191_Integer_Underflow__int_database_sub_10");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_sub_04()).runTest("CWE191_Integer_Underflow__int_console_readLine_sub_04");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_sub_21()).runTest("CWE191_Integer_Underflow__byte_min_sub_21");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_sub_52a()).runTest("CWE191_Integer_Underflow__byte_min_sub_52a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_sub_45()).runTest("CWE191_Integer_Underflow__int_File_sub_45");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_sub_42()).runTest("CWE191_Integer_Underflow__int_connect_tcp_sub_42");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_multiply_09()).runTest("CWE191_Integer_Underflow__int_Environment_multiply_09");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_multiply_51a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_multiply_51a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_sub_01()).runTest("CWE191_Integer_Underflow__int_connect_tcp_sub_01");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_sub_05()).runTest("CWE191_Integer_Underflow__int_File_sub_05");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_multiply_72a()).runTest("CWE191_Integer_Underflow__int_Environment_multiply_72a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_sub_03()).runTest("CWE191_Integer_Underflow__byte_console_readLine_sub_03");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_multiply_72a()).runTest("CWE191_Integer_Underflow__int_File_multiply_72a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_multiply_73a()).runTest("CWE191_Integer_Underflow__int_Environment_multiply_73a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_multiply_14()).runTest("CWE191_Integer_Underflow__int_database_multiply_14");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_multiply_13()).runTest("CWE191_Integer_Underflow__int_database_multiply_13");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_multiply_31()).runTest("CWE191_Integer_Underflow__byte_console_readLine_multiply_31");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_multiply_15()).runTest("CWE191_Integer_Underflow__byte_min_multiply_15");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_multiply_12()).runTest("CWE191_Integer_Underflow__int_database_multiply_12");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_multiply_71a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_multiply_71a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_multiply_42()).runTest("CWE191_Integer_Underflow__byte_console_readLine_multiply_42");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_sub_22a()).runTest("CWE191_Integer_Underflow__int_File_sub_22a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_multiply_08()).runTest("CWE191_Integer_Underflow__int_console_readLine_multiply_08");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_multiply_61a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_multiply_61a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_multiply_71a()).runTest("CWE191_Integer_Underflow__int_database_multiply_71a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_multiply_04()).runTest("CWE191_Integer_Underflow__byte_rand_multiply_04");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_multiply_72a()).runTest("CWE191_Integer_Underflow__byte_min_multiply_72a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_multiply_22a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_multiply_22a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_sub_81a()).runTest("CWE191_Integer_Underflow__int_File_sub_81a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_multiply_52a()).runTest("CWE191_Integer_Underflow__int_database_multiply_52a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_multiply_41()).runTest("CWE191_Integer_Underflow__int_File_multiply_41");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_sub_72a()).runTest("CWE191_Integer_Underflow__byte_rand_sub_72a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_multiply_54a()).runTest("CWE191_Integer_Underflow__int_File_multiply_54a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_sub_11()).runTest("CWE191_Integer_Underflow__int_File_sub_11");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_sub_17()).runTest("CWE191_Integer_Underflow__int_Environment_sub_17");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_sub_09()).runTest("CWE191_Integer_Underflow__byte_min_sub_09");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_sub_05()).runTest("CWE191_Integer_Underflow__byte_rand_sub_05");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_sub_75a()).runTest("CWE191_Integer_Underflow__int_database_sub_75a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_multiply_03()).runTest("CWE191_Integer_Underflow__int_File_multiply_03");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_sub_12()).runTest("CWE191_Integer_Underflow__int_console_readLine_sub_12");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_multiply_03()).runTest("CWE191_Integer_Underflow__int_console_readLine_multiply_03");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_sub_11()).runTest("CWE191_Integer_Underflow__int_Environment_sub_11");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_multiply_07()).runTest("CWE191_Integer_Underflow__int_Environment_multiply_07");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_sub_71a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_sub_71a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_sub_81a()).runTest("CWE191_Integer_Underflow__byte_min_sub_81a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_multiply_01()).runTest("CWE191_Integer_Underflow__int_console_readLine_multiply_01");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_multiply_10()).runTest("CWE191_Integer_Underflow__byte_rand_multiply_10");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_multiply_74a()).runTest("CWE191_Integer_Underflow__int_database_multiply_74a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_multiply_01()).runTest("CWE191_Integer_Underflow__int_File_multiply_01");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_sub_01()).runTest("CWE191_Integer_Underflow__int_database_sub_01");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_sub_67a()).runTest("CWE191_Integer_Underflow__int_File_sub_67a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_multiply_51a()).runTest("CWE191_Integer_Underflow__int_console_readLine_multiply_51a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_multiply_04()).runTest("CWE191_Integer_Underflow__int_console_readLine_multiply_04");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_sub_09()).runTest("CWE191_Integer_Underflow__int_connect_tcp_sub_09");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_sub_15()).runTest("CWE191_Integer_Underflow__int_Environment_sub_15");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_multiply_10()).runTest("CWE191_Integer_Underflow__int_database_multiply_10");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_multiply_41()).runTest("CWE191_Integer_Underflow__byte_console_readLine_multiply_41");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_sub_41()).runTest("CWE191_Integer_Underflow__int_console_readLine_sub_41");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_sub_67a()).runTest("CWE191_Integer_Underflow__byte_rand_sub_67a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_multiply_02()).runTest("CWE191_Integer_Underflow__int_connect_tcp_multiply_02");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_multiply_53a()).runTest("CWE191_Integer_Underflow__int_database_multiply_53a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_multiply_14()).runTest("CWE191_Integer_Underflow__int_Environment_multiply_14");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_multiply_16()).runTest("CWE191_Integer_Underflow__int_File_multiply_16");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_multiply_73a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_multiply_73a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_multiply_21()).runTest("CWE191_Integer_Underflow__int_Environment_multiply_21");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_multiply_61a()).runTest("CWE191_Integer_Underflow__int_console_readLine_multiply_61a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_multiply_68a()).runTest("CWE191_Integer_Underflow__int_File_multiply_68a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_multiply_17()).runTest("CWE191_Integer_Underflow__int_console_readLine_multiply_17");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_multiply_21()).runTest("CWE191_Integer_Underflow__byte_rand_multiply_21");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_sub_03()).runTest("CWE191_Integer_Underflow__byte_min_sub_03");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_sub_17()).runTest("CWE191_Integer_Underflow__byte_console_readLine_sub_17");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_sub_14()).runTest("CWE191_Integer_Underflow__int_database_sub_14");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_sub_74a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_sub_74a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_sub_81a()).runTest("CWE191_Integer_Underflow__int_Environment_sub_81a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_multiply_67a()).runTest("CWE191_Integer_Underflow__int_console_readLine_multiply_67a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_sub_05()).runTest("CWE191_Integer_Underflow__int_Environment_sub_05");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_multiply_02()).runTest("CWE191_Integer_Underflow__int_Environment_multiply_02");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_sub_61a()).runTest("CWE191_Integer_Underflow__byte_min_sub_61a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_sub_09()).runTest("CWE191_Integer_Underflow__int_database_sub_09");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_multiply_41()).runTest("CWE191_Integer_Underflow__byte_rand_multiply_41");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_sub_51a()).runTest("CWE191_Integer_Underflow__int_File_sub_51a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_sub_03()).runTest("CWE191_Integer_Underflow__int_database_sub_03");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_sub_01()).runTest("CWE191_Integer_Underflow__int_Environment_sub_01");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_multiply_15()).runTest("CWE191_Integer_Underflow__int_Environment_multiply_15");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_sub_17()).runTest("CWE191_Integer_Underflow__byte_rand_sub_17");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_multiply_02()).runTest("CWE191_Integer_Underflow__int_File_multiply_02");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_multiply_53a()).runTest("CWE191_Integer_Underflow__int_Environment_multiply_53a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_multiply_45()).runTest("CWE191_Integer_Underflow__int_Environment_multiply_45");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_multiply_21()).runTest("CWE191_Integer_Underflow__byte_console_readLine_multiply_21");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_sub_75a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_sub_75a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_multiply_52a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_multiply_52a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_multiply_61a()).runTest("CWE191_Integer_Underflow__byte_min_multiply_61a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_sub_04()).runTest("CWE191_Integer_Underflow__int_database_sub_04");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_sub_71a()).runTest("CWE191_Integer_Underflow__int_console_readLine_sub_71a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_multiply_31()).runTest("CWE191_Integer_Underflow__int_connect_tcp_multiply_31");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_sub_07()).runTest("CWE191_Integer_Underflow__byte_rand_sub_07");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_multiply_72a()).runTest("CWE191_Integer_Underflow__int_console_readLine_multiply_72a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_multiply_09()).runTest("CWE191_Integer_Underflow__byte_rand_multiply_09");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_multiply_06()).runTest("CWE191_Integer_Underflow__byte_min_multiply_06");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_multiply_21()).runTest("CWE191_Integer_Underflow__byte_min_multiply_21");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_sub_07()).runTest("CWE191_Integer_Underflow__int_connect_tcp_sub_07");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_multiply_03()).runTest("CWE191_Integer_Underflow__byte_rand_multiply_03");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_sub_61a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_sub_61a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_sub_61a()).runTest("CWE191_Integer_Underflow__int_console_readLine_sub_61a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_sub_03()).runTest("CWE191_Integer_Underflow__int_File_sub_03");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_multiply_03()).runTest("CWE191_Integer_Underflow__int_Environment_multiply_03");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_multiply_01()).runTest("CWE191_Integer_Underflow__int_database_multiply_01");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_sub_16()).runTest("CWE191_Integer_Underflow__byte_rand_sub_16");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_multiply_07()).runTest("CWE191_Integer_Underflow__byte_rand_multiply_07");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_multiply_74a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_multiply_74a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_multiply_06()).runTest("CWE191_Integer_Underflow__int_connect_tcp_multiply_06");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_multiply_41()).runTest("CWE191_Integer_Underflow__int_database_multiply_41");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_multiply_53a()).runTest("CWE191_Integer_Underflow__int_File_multiply_53a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_multiply_67a()).runTest("CWE191_Integer_Underflow__byte_rand_multiply_67a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_multiply_02()).runTest("CWE191_Integer_Underflow__int_console_readLine_multiply_02");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_sub_12()).runTest("CWE191_Integer_Underflow__int_Environment_sub_12");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_Environment_sub_21()).runTest("CWE191_Integer_Underflow__int_Environment_sub_21");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_sub_15()).runTest("CWE191_Integer_Underflow__int_connect_tcp_sub_15");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_sub_01()).runTest("CWE191_Integer_Underflow__int_console_readLine_sub_01");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_multiply_11()).runTest("CWE191_Integer_Underflow__int_console_readLine_multiply_11");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_multiply_31()).runTest("CWE191_Integer_Underflow__byte_rand_multiply_31");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_multiply_15()).runTest("CWE191_Integer_Underflow__int_File_multiply_15");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_sub_05()).runTest("CWE191_Integer_Underflow__int_console_readLine_sub_05");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_multiply_14()).runTest("CWE191_Integer_Underflow__int_connect_tcp_multiply_14");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_sub_04()).runTest("CWE191_Integer_Underflow__byte_rand_sub_04");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_sub_74a()).runTest("CWE191_Integer_Underflow__int_console_readLine_sub_74a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_File_sub_71a()).runTest("CWE191_Integer_Underflow__int_File_sub_71a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_sub_51a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_sub_51a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_multiply_13()).runTest("CWE191_Integer_Underflow__byte_min_multiply_13");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_sub_03()).runTest("CWE191_Integer_Underflow__byte_rand_sub_03");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_multiply_45()).runTest("CWE191_Integer_Underflow__byte_min_multiply_45");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_multiply_54a()).runTest("CWE191_Integer_Underflow__int_database_multiply_54a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_sub_54a()).runTest("CWE191_Integer_Underflow__byte_min_sub_54a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_connect_tcp_multiply_08()).runTest("CWE191_Integer_Underflow__int_connect_tcp_multiply_08");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_rand_sub_68a()).runTest("CWE191_Integer_Underflow__byte_rand_sub_68a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_multiply_52a()).runTest("CWE191_Integer_Underflow__byte_min_multiply_52a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_console_readLine_sub_54a()).runTest("CWE191_Integer_Underflow__int_console_readLine_sub_54a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__int_database_sub_12()).runTest("CWE191_Integer_Underflow__int_database_sub_12");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_sub_73a()).runTest("CWE191_Integer_Underflow__byte_min_sub_73a");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_console_readLine_multiply_01()).runTest("CWE191_Integer_Underflow__byte_console_readLine_multiply_01");
			(new testcases.CWE191_Integer_Underflow.s01.CWE191_Integer_Underflow__byte_min_sub_31()).runTest("CWE191_Integer_Underflow__byte_min_sub_31");
			/* END-AUTOGENERATED-JAVA-TESTS-1 */
}

private static void runTestCWE2() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-2 */

			/* END-AUTOGENERATED-JAVA-TESTS-2 */
}

private static void runTestCWE3() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-3 */

			/* END-AUTOGENERATED-JAVA-TESTS-3 */
}

private static void runTestCWE4() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-4 */

			/* END-AUTOGENERATED-JAVA-TESTS-4 */
}

private static void runTestCWE5() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-5 */

			/* END-AUTOGENERATED-JAVA-TESTS-5 */
}

private static void runTestCWE6() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-6 */

			/* END-AUTOGENERATED-JAVA-TESTS-6 */
}

private static void runTestCWE7() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-7 */

			/* END-AUTOGENERATED-JAVA-TESTS-7 */
}

private static void runTestCWE8() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-8 */

			/* END-AUTOGENERATED-JAVA-TESTS-8 */
}

private static void runTestCWE9() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-9 */

			/* END-AUTOGENERATED-JAVA-TESTS-9 */
}
}