package testcases.CWE191_Integer_Underflow.s02;

import testcasesupport.*;

public class Main {

	public static void main(String[] args) {
		
		if(args.length != 0) {
		
			if(args[0].equals("-h") || args[0].equals("--help")) {
		
				System.err.println("To use this main, you can either run the program with no " +
				"command line arguments to run all test cases or you can specify one or more classes to test");
				System.err.println("For example:");
				System.err.println("java testcasesupport.Main testcases.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference.custom_function.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference__custom_function_01 testcases.CWE481_Assigning_instead_of_Comparing.bool.CWE481_Assigning_instead_of_Comparing__bool_01");
				System.exit(1);
			}
			
			/* User supplied some class names on the command line, just use those with introspection
			 *
			 * String classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
			 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
 			 * could read class names from command line or use
			 * http://sadun-util.sourceforge.net/api/org/sadun/util/
			 * ClassPackageExplorer.html
			 */

			for (String className : args) {

				try {
					
					/* String classNameWithPackage = "testcases." + className; */
					
					/* IO.writeLine("classNameWithPackage = " + classNameWithPackage); */

					Class<?> myClass = Class.forName(className);

					AbstractTestCase myObject = (AbstractTestCase) myClass
							.newInstance();

					myObject.runTest(className);

				} catch (Exception ex) {

					IO.writeLine("Could not run test for class " + className);
					ex.printStackTrace();

				}
				
				IO.writeLine(""); /* leave a blank line between classes */

			}

		} else {
		
			/* No command line args were used, we want to run every testcase */
			
			/* needed to separate these calls into other methods because
			   we were running into the size limit Java has for a single method */
			runTestCWE1();
			runTestCWE2();
			runTestCWE3();
			runTestCWE4();
			runTestCWE5();
			runTestCWE6();
			runTestCWE7();
			runTestCWE8();
			runTestCWE9();
		}			
	}

private static void runTestCWE1() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-1 */
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_multiply_54a()).runTest("CWE191_Integer_Underflow__int_min_multiply_54a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_multiply_75a()).runTest("CWE191_Integer_Underflow__int_Property_multiply_75a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_sub_21()).runTest("CWE191_Integer_Underflow__int_random_sub_21");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_multiply_74a()).runTest("CWE191_Integer_Underflow__int_Property_multiply_74a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_sub_22a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_sub_22a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_multiply_53a()).runTest("CWE191_Integer_Underflow__int_Property_multiply_53a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_multiply_75a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_multiply_75a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_multiply_42()).runTest("CWE191_Integer_Underflow__int_min_multiply_42");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_multiply_16()).runTest("CWE191_Integer_Underflow__int_Property_multiply_16");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_multiply_12()).runTest("CWE191_Integer_Underflow__int_min_multiply_12");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_sub_03()).runTest("CWE191_Integer_Underflow__int_min_sub_03");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_sub_05()).runTest("CWE191_Integer_Underflow__int_listen_tcp_sub_05");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_sub_07()).runTest("CWE191_Integer_Underflow__int_min_sub_07");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_sub_68a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_sub_68a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_sub_45()).runTest("CWE191_Integer_Underflow__int_random_sub_45");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_sub_72a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_sub_72a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_multiply_15()).runTest("CWE191_Integer_Underflow__int_listen_tcp_multiply_15");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_multiply_03()).runTest("CWE191_Integer_Underflow__int_random_multiply_03");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_multiply_21()).runTest("CWE191_Integer_Underflow__int_listen_tcp_multiply_21");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_sub_51a()).runTest("CWE191_Integer_Underflow__int_random_sub_51a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_sub_54a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_sub_54a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_sub_12()).runTest("CWE191_Integer_Underflow__int_Property_sub_12");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_sub_10()).runTest("CWE191_Integer_Underflow__int_random_sub_10");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_multiply_17()).runTest("CWE191_Integer_Underflow__int_listen_tcp_multiply_17");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_multiply_75a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_multiply_75a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_multiply_31()).runTest("CWE191_Integer_Underflow__int_listen_tcp_multiply_31");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_sub_03()).runTest("CWE191_Integer_Underflow__int_listen_tcp_sub_03");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_multiply_67a()).runTest("CWE191_Integer_Underflow__int_Property_multiply_67a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_multiply_31()).runTest("CWE191_Integer_Underflow__int_min_multiply_31");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_sub_75a()).runTest("CWE191_Integer_Underflow__int_min_sub_75a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_multiply_67a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_multiply_67a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_sub_53a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_sub_53a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_multiply_01()).runTest("CWE191_Integer_Underflow__int_listen_tcp_multiply_01");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_multiply_67a()).runTest("CWE191_Integer_Underflow__int_random_multiply_67a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_sub_07()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_sub_07");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_sub_72a()).runTest("CWE191_Integer_Underflow__int_Property_sub_72a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_multiply_05()).runTest("CWE191_Integer_Underflow__int_random_multiply_05");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_sub_31()).runTest("CWE191_Integer_Underflow__int_Property_sub_31");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_multiply_10()).runTest("CWE191_Integer_Underflow__int_min_multiply_10");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_multiply_03()).runTest("CWE191_Integer_Underflow__int_min_multiply_03");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_multiply_75a()).runTest("CWE191_Integer_Underflow__int_random_multiply_75a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_sub_21()).runTest("CWE191_Integer_Underflow__int_listen_tcp_sub_21");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_multiply_67a()).runTest("CWE191_Integer_Underflow__int_min_multiply_67a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_sub_01()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_sub_01");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_multiply_03()).runTest("CWE191_Integer_Underflow__int_Property_multiply_03");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_sub_61a()).runTest("CWE191_Integer_Underflow__int_min_sub_61a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_sub_06()).runTest("CWE191_Integer_Underflow__int_Property_sub_06");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_multiply_51a()).runTest("CWE191_Integer_Underflow__int_min_multiply_51a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_sub_02()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_sub_02");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_multiply_02()).runTest("CWE191_Integer_Underflow__int_random_multiply_02");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_sub_74a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_sub_74a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_multiply_81a()).runTest("CWE191_Integer_Underflow__int_Property_multiply_81a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_multiply_45()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_multiply_45");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_multiply_45()).runTest("CWE191_Integer_Underflow__int_listen_tcp_multiply_45");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_multiply_72a()).runTest("CWE191_Integer_Underflow__int_Property_multiply_72a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_multiply_73a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_multiply_73a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_sub_01()).runTest("CWE191_Integer_Underflow__int_Property_sub_01");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_multiply_74a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_multiply_74a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_sub_41()).runTest("CWE191_Integer_Underflow__int_listen_tcp_sub_41");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_multiply_71a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_multiply_71a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_sub_51a()).runTest("CWE191_Integer_Underflow__int_Property_sub_51a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_sub_04()).runTest("CWE191_Integer_Underflow__int_random_sub_04");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_multiply_31()).runTest("CWE191_Integer_Underflow__int_random_multiply_31");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_multiply_41()).runTest("CWE191_Integer_Underflow__int_Property_multiply_41");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_sub_14()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_sub_14");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_sub_11()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_sub_11");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_multiply_04()).runTest("CWE191_Integer_Underflow__int_min_multiply_04");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_multiply_52a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_multiply_52a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_multiply_06()).runTest("CWE191_Integer_Underflow__int_listen_tcp_multiply_06");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_multiply_13()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_multiply_13");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_sub_31()).runTest("CWE191_Integer_Underflow__int_random_sub_31");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_sub_66a()).runTest("CWE191_Integer_Underflow__int_random_sub_66a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_sub_06()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_sub_06");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_sub_13()).runTest("CWE191_Integer_Underflow__int_random_sub_13");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_multiply_73a()).runTest("CWE191_Integer_Underflow__int_Property_multiply_73a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_sub_41()).runTest("CWE191_Integer_Underflow__int_Property_sub_41");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_multiply_14()).runTest("CWE191_Integer_Underflow__int_listen_tcp_multiply_14");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_sub_17()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_sub_17");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_sub_02()).runTest("CWE191_Integer_Underflow__int_random_sub_02");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_multiply_72a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_multiply_72a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_sub_71a()).runTest("CWE191_Integer_Underflow__int_Property_sub_71a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_sub_10()).runTest("CWE191_Integer_Underflow__int_min_sub_10");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_multiply_16()).runTest("CWE191_Integer_Underflow__int_random_multiply_16");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_sub_04()).runTest("CWE191_Integer_Underflow__int_min_sub_04");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_sub_75a()).runTest("CWE191_Integer_Underflow__int_Property_sub_75a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_multiply_02()).runTest("CWE191_Integer_Underflow__int_Property_multiply_02");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_sub_14()).runTest("CWE191_Integer_Underflow__int_min_sub_14");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_sub_15()).runTest("CWE191_Integer_Underflow__int_min_sub_15");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_sub_42()).runTest("CWE191_Integer_Underflow__int_random_sub_42");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_multiply_16()).runTest("CWE191_Integer_Underflow__int_listen_tcp_multiply_16");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_sub_10()).runTest("CWE191_Integer_Underflow__int_Property_sub_10");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_multiply_74a()).runTest("CWE191_Integer_Underflow__int_random_multiply_74a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_multiply_02()).runTest("CWE191_Integer_Underflow__int_listen_tcp_multiply_02");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_sub_13()).runTest("CWE191_Integer_Underflow__int_Property_sub_13");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_sub_03()).runTest("CWE191_Integer_Underflow__int_Property_sub_03");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_sub_01()).runTest("CWE191_Integer_Underflow__int_min_sub_01");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_multiply_21()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_multiply_21");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_sub_08()).runTest("CWE191_Integer_Underflow__int_random_sub_08");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_sub_73a()).runTest("CWE191_Integer_Underflow__int_Property_sub_73a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_multiply_21()).runTest("CWE191_Integer_Underflow__int_min_multiply_21");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_sub_67a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_sub_67a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_multiply_15()).runTest("CWE191_Integer_Underflow__int_random_multiply_15");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_sub_45()).runTest("CWE191_Integer_Underflow__int_listen_tcp_sub_45");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_sub_73a()).runTest("CWE191_Integer_Underflow__int_random_sub_73a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_multiply_81a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_multiply_81a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_sub_71a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_sub_71a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_sub_67a()).runTest("CWE191_Integer_Underflow__int_Property_sub_67a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_multiply_22a()).runTest("CWE191_Integer_Underflow__int_min_multiply_22a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_multiply_31()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_multiply_31");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_sub_14()).runTest("CWE191_Integer_Underflow__int_listen_tcp_sub_14");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_sub_31()).runTest("CWE191_Integer_Underflow__int_listen_tcp_sub_31");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_multiply_12()).runTest("CWE191_Integer_Underflow__int_random_multiply_12");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_multiply_16()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_multiply_16");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_multiply_14()).runTest("CWE191_Integer_Underflow__int_Property_multiply_14");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_sub_14()).runTest("CWE191_Integer_Underflow__int_Property_sub_14");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_sub_54a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_sub_54a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_multiply_10()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_multiply_10");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_multiply_54a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_multiply_54a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_sub_10()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_sub_10");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_sub_73a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_sub_73a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_sub_15()).runTest("CWE191_Integer_Underflow__int_listen_tcp_sub_15");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_multiply_11()).runTest("CWE191_Integer_Underflow__int_random_multiply_11");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_multiply_42()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_multiply_42");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_multiply_66a()).runTest("CWE191_Integer_Underflow__int_Property_multiply_66a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_sub_42()).runTest("CWE191_Integer_Underflow__int_listen_tcp_sub_42");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_multiply_17()).runTest("CWE191_Integer_Underflow__int_random_multiply_17");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_sub_51a()).runTest("CWE191_Integer_Underflow__int_min_sub_51a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_multiply_42()).runTest("CWE191_Integer_Underflow__int_random_multiply_42");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_multiply_04()).runTest("CWE191_Integer_Underflow__int_random_multiply_04");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_sub_31()).runTest("CWE191_Integer_Underflow__int_min_sub_31");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_sub_16()).runTest("CWE191_Integer_Underflow__int_Property_sub_16");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_multiply_08()).runTest("CWE191_Integer_Underflow__int_listen_tcp_multiply_08");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_multiply_06()).runTest("CWE191_Integer_Underflow__int_min_multiply_06");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_multiply_21()).runTest("CWE191_Integer_Underflow__int_random_multiply_21");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_multiply_01()).runTest("CWE191_Integer_Underflow__int_min_multiply_01");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_multiply_22a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_multiply_22a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_multiply_73a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_multiply_73a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_multiply_41()).runTest("CWE191_Integer_Underflow__int_listen_tcp_multiply_41");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_sub_02()).runTest("CWE191_Integer_Underflow__int_Property_sub_02");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_multiply_01()).runTest("CWE191_Integer_Underflow__int_random_multiply_01");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_multiply_81a()).runTest("CWE191_Integer_Underflow__int_min_multiply_81a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_sub_75a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_sub_75a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_multiply_07()).runTest("CWE191_Integer_Underflow__int_random_multiply_07");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_sub_66a()).runTest("CWE191_Integer_Underflow__int_min_sub_66a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_sub_16()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_sub_16");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_multiply_17()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_multiply_17");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_multiply_10()).runTest("CWE191_Integer_Underflow__int_random_multiply_10");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_sub_72a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_sub_72a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_multiply_07()).runTest("CWE191_Integer_Underflow__int_listen_tcp_multiply_07");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_multiply_09()).runTest("CWE191_Integer_Underflow__int_random_multiply_09");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_multiply_74a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_multiply_74a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_sub_41()).runTest("CWE191_Integer_Underflow__int_min_sub_41");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_multiply_16()).runTest("CWE191_Integer_Underflow__int_min_multiply_16");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_multiply_54a()).runTest("CWE191_Integer_Underflow__int_Property_multiply_54a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_multiply_73a()).runTest("CWE191_Integer_Underflow__int_min_multiply_73a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_multiply_71a()).runTest("CWE191_Integer_Underflow__int_random_multiply_71a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_multiply_52a()).runTest("CWE191_Integer_Underflow__int_random_multiply_52a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_multiply_61a()).runTest("CWE191_Integer_Underflow__int_min_multiply_61a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_multiply_09()).runTest("CWE191_Integer_Underflow__int_listen_tcp_multiply_09");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_multiply_81a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_multiply_81a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_multiply_71a()).runTest("CWE191_Integer_Underflow__int_min_multiply_71a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_sub_15()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_sub_15");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_sub_42()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_sub_42");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_sub_31()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_sub_31");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_sub_73a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_sub_73a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_multiply_02()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_multiply_02");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_sub_21()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_sub_21");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_sub_04()).runTest("CWE191_Integer_Underflow__int_listen_tcp_sub_04");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_sub_05()).runTest("CWE191_Integer_Underflow__int_Property_sub_05");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_sub_52a()).runTest("CWE191_Integer_Underflow__int_random_sub_52a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_sub_12()).runTest("CWE191_Integer_Underflow__int_min_sub_12");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_multiply_05()).runTest("CWE191_Integer_Underflow__int_min_multiply_05");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_multiply_15()).runTest("CWE191_Integer_Underflow__int_min_multiply_15");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_sub_54a()).runTest("CWE191_Integer_Underflow__int_random_sub_54a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_multiply_67a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_multiply_67a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_multiply_71a()).runTest("CWE191_Integer_Underflow__int_Property_multiply_71a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_sub_74a()).runTest("CWE191_Integer_Underflow__int_min_sub_74a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_multiply_45()).runTest("CWE191_Integer_Underflow__int_Property_multiply_45");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_multiply_45()).runTest("CWE191_Integer_Underflow__int_min_multiply_45");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_multiply_52a()).runTest("CWE191_Integer_Underflow__int_Property_multiply_52a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_multiply_66a()).runTest("CWE191_Integer_Underflow__int_min_multiply_66a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_multiply_22a()).runTest("CWE191_Integer_Underflow__int_Property_multiply_22a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_multiply_68a()).runTest("CWE191_Integer_Underflow__int_min_multiply_68a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_sub_74a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_sub_74a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_multiply_09()).runTest("CWE191_Integer_Underflow__int_Property_multiply_09");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_multiply_52a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_multiply_52a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_multiply_11()).runTest("CWE191_Integer_Underflow__int_min_multiply_11");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_sub_16()).runTest("CWE191_Integer_Underflow__int_min_sub_16");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_sub_02()).runTest("CWE191_Integer_Underflow__int_listen_tcp_sub_02");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_multiply_41()).runTest("CWE191_Integer_Underflow__int_min_multiply_41");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_sub_81a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_sub_81a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_sub_10()).runTest("CWE191_Integer_Underflow__int_listen_tcp_sub_10");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_sub_51a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_sub_51a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_multiply_51a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_multiply_51a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_multiply_13()).runTest("CWE191_Integer_Underflow__int_listen_tcp_multiply_13");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_multiply_07()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_multiply_07");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_multiply_05()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_multiply_05");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_sub_45()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_sub_45");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_sub_22a()).runTest("CWE191_Integer_Underflow__int_random_sub_22a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_multiply_12()).runTest("CWE191_Integer_Underflow__int_listen_tcp_multiply_12");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_sub_15()).runTest("CWE191_Integer_Underflow__int_random_sub_15");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_multiply_05()).runTest("CWE191_Integer_Underflow__int_listen_tcp_multiply_05");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_multiply_06()).runTest("CWE191_Integer_Underflow__int_random_multiply_06");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_multiply_09()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_multiply_09");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_multiply_61a()).runTest("CWE191_Integer_Underflow__int_random_multiply_61a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_sub_14()).runTest("CWE191_Integer_Underflow__int_random_sub_14");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_sub_13()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_sub_13");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_multiply_13()).runTest("CWE191_Integer_Underflow__int_Property_multiply_13");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_multiply_14()).runTest("CWE191_Integer_Underflow__int_random_multiply_14");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_sub_17()).runTest("CWE191_Integer_Underflow__int_listen_tcp_sub_17");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_sub_67a()).runTest("CWE191_Integer_Underflow__int_min_sub_67a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_sub_07()).runTest("CWE191_Integer_Underflow__int_listen_tcp_sub_07");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_sub_81a()).runTest("CWE191_Integer_Underflow__int_Property_sub_81a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_sub_53a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_sub_53a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_sub_68a()).runTest("CWE191_Integer_Underflow__int_Property_sub_68a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_multiply_04()).runTest("CWE191_Integer_Underflow__int_listen_tcp_multiply_04");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_multiply_72a()).runTest("CWE191_Integer_Underflow__int_min_multiply_72a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_multiply_21()).runTest("CWE191_Integer_Underflow__int_Property_multiply_21");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_multiply_08()).runTest("CWE191_Integer_Underflow__int_random_multiply_08");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_sub_68a()).runTest("CWE191_Integer_Underflow__int_min_sub_68a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_multiply_01()).runTest("CWE191_Integer_Underflow__int_Property_multiply_01");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_sub_22a()).runTest("CWE191_Integer_Underflow__int_min_sub_22a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_multiply_74a()).runTest("CWE191_Integer_Underflow__int_min_multiply_74a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_sub_11()).runTest("CWE191_Integer_Underflow__int_min_sub_11");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_sub_11()).runTest("CWE191_Integer_Underflow__int_Property_sub_11");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_multiply_53a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_multiply_53a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_multiply_54a()).runTest("CWE191_Integer_Underflow__int_random_multiply_54a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_sub_41()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_sub_41");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_sub_66a()).runTest("CWE191_Integer_Underflow__int_Property_sub_66a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_multiply_11()).runTest("CWE191_Integer_Underflow__int_Property_multiply_11");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_multiply_45()).runTest("CWE191_Integer_Underflow__int_random_multiply_45");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_multiply_06()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_multiply_06");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_sub_09()).runTest("CWE191_Integer_Underflow__int_Property_sub_09");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_multiply_51a()).runTest("CWE191_Integer_Underflow__int_Property_multiply_51a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_sub_11()).runTest("CWE191_Integer_Underflow__int_random_sub_11");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_sub_61a()).runTest("CWE191_Integer_Underflow__int_Property_sub_61a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_sub_52a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_sub_52a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_multiply_14()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_multiply_14");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_sub_04()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_sub_04");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_sub_13()).runTest("CWE191_Integer_Underflow__int_min_sub_13");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_sub_61a()).runTest("CWE191_Integer_Underflow__int_random_sub_61a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_multiply_11()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_multiply_11");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_sub_05()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_sub_05");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_sub_68a()).runTest("CWE191_Integer_Underflow__int_random_sub_68a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_sub_71a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_sub_71a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_sub_61a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_sub_61a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_sub_09()).runTest("CWE191_Integer_Underflow__int_min_sub_09");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_sub_12()).runTest("CWE191_Integer_Underflow__int_listen_tcp_sub_12");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_sub_08()).runTest("CWE191_Integer_Underflow__int_listen_tcp_sub_08");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_sub_05()).runTest("CWE191_Integer_Underflow__int_min_sub_05");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_sub_17()).runTest("CWE191_Integer_Underflow__int_random_sub_17");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_sub_08()).runTest("CWE191_Integer_Underflow__int_Property_sub_08");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_sub_06()).runTest("CWE191_Integer_Underflow__int_min_sub_06");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_sub_15()).runTest("CWE191_Integer_Underflow__int_Property_sub_15");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_sub_09()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_sub_09");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_sub_72a()).runTest("CWE191_Integer_Underflow__int_min_sub_72a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_multiply_31()).runTest("CWE191_Integer_Underflow__int_Property_multiply_31");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_multiply_81a()).runTest("CWE191_Integer_Underflow__int_random_multiply_81a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_multiply_68a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_multiply_68a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_multiply_42()).runTest("CWE191_Integer_Underflow__int_Property_multiply_42");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_multiply_61a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_multiply_61a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_sub_07()).runTest("CWE191_Integer_Underflow__int_random_sub_07");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_sub_06()).runTest("CWE191_Integer_Underflow__int_listen_tcp_sub_06");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_sub_11()).runTest("CWE191_Integer_Underflow__int_listen_tcp_sub_11");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_multiply_08()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_multiply_08");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_sub_73a()).runTest("CWE191_Integer_Underflow__int_min_sub_73a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_multiply_61a()).runTest("CWE191_Integer_Underflow__int_Property_multiply_61a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_sub_07()).runTest("CWE191_Integer_Underflow__int_Property_sub_07");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_sub_53a()).runTest("CWE191_Integer_Underflow__int_min_sub_53a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_multiply_15()).runTest("CWE191_Integer_Underflow__int_Property_multiply_15");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_multiply_06()).runTest("CWE191_Integer_Underflow__int_Property_multiply_06");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_sub_21()).runTest("CWE191_Integer_Underflow__int_min_sub_21");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_multiply_10()).runTest("CWE191_Integer_Underflow__int_Property_multiply_10");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_sub_12()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_sub_12");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_multiply_09()).runTest("CWE191_Integer_Underflow__int_min_multiply_09");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_sub_67a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_sub_67a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_multiply_04()).runTest("CWE191_Integer_Underflow__int_Property_multiply_04");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_sub_01()).runTest("CWE191_Integer_Underflow__int_random_sub_01");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_sub_53a()).runTest("CWE191_Integer_Underflow__int_random_sub_53a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_multiply_13()).runTest("CWE191_Integer_Underflow__int_min_multiply_13");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_multiply_11()).runTest("CWE191_Integer_Underflow__int_listen_tcp_multiply_11");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_multiply_15()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_multiply_15");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_multiply_42()).runTest("CWE191_Integer_Underflow__int_listen_tcp_multiply_42");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_multiply_71a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_multiply_71a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_multiply_53a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_multiply_53a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_multiply_07()).runTest("CWE191_Integer_Underflow__int_min_multiply_07");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_multiply_41()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_multiply_41");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_sub_53a()).runTest("CWE191_Integer_Underflow__int_Property_sub_53a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_multiply_12()).runTest("CWE191_Integer_Underflow__int_Property_multiply_12");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_sub_54a()).runTest("CWE191_Integer_Underflow__int_min_sub_54a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_sub_71a()).runTest("CWE191_Integer_Underflow__int_min_sub_71a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_multiply_68a()).runTest("CWE191_Integer_Underflow__int_Property_multiply_68a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_sub_05()).runTest("CWE191_Integer_Underflow__int_random_sub_05");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_sub_21()).runTest("CWE191_Integer_Underflow__int_Property_sub_21");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_multiply_66a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_multiply_66a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_sub_04()).runTest("CWE191_Integer_Underflow__int_Property_sub_04");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_sub_74a()).runTest("CWE191_Integer_Underflow__int_random_sub_74a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_sub_12()).runTest("CWE191_Integer_Underflow__int_random_sub_12");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_sub_81a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_sub_81a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_multiply_53a()).runTest("CWE191_Integer_Underflow__int_min_multiply_53a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_multiply_66a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_multiply_66a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_multiply_08()).runTest("CWE191_Integer_Underflow__int_Property_multiply_08");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_multiply_73a()).runTest("CWE191_Integer_Underflow__int_random_multiply_73a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_sub_66a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_sub_66a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_multiply_41()).runTest("CWE191_Integer_Underflow__int_random_multiply_41");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_multiply_72a()).runTest("CWE191_Integer_Underflow__int_random_multiply_72a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_multiply_07()).runTest("CWE191_Integer_Underflow__int_Property_multiply_07");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_multiply_10()).runTest("CWE191_Integer_Underflow__int_listen_tcp_multiply_10");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_sub_66a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_sub_66a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_multiply_52a()).runTest("CWE191_Integer_Underflow__int_min_multiply_52a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_sub_75a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_sub_75a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_sub_13()).runTest("CWE191_Integer_Underflow__int_listen_tcp_sub_13");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_sub_22a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_sub_22a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_multiply_01()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_multiply_01");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_sub_42()).runTest("CWE191_Integer_Underflow__int_Property_sub_42");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_multiply_03()).runTest("CWE191_Integer_Underflow__int_listen_tcp_multiply_03");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_multiply_68a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_multiply_68a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_multiply_72a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_multiply_72a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_sub_45()).runTest("CWE191_Integer_Underflow__int_min_sub_45");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_sub_81a()).runTest("CWE191_Integer_Underflow__int_random_sub_81a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_multiply_68a()).runTest("CWE191_Integer_Underflow__int_random_multiply_68a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_sub_42()).runTest("CWE191_Integer_Underflow__int_min_sub_42");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_sub_54a()).runTest("CWE191_Integer_Underflow__int_Property_sub_54a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_sub_08()).runTest("CWE191_Integer_Underflow__int_min_sub_08");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_sub_52a()).runTest("CWE191_Integer_Underflow__int_min_sub_52a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_multiply_53a()).runTest("CWE191_Integer_Underflow__int_random_multiply_53a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_multiply_03()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_multiply_03");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_multiply_61a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_multiply_61a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_multiply_51a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_multiply_51a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_multiply_22a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_multiply_22a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_sub_51a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_sub_51a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_multiply_04()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_multiply_04");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_sub_16()).runTest("CWE191_Integer_Underflow__int_listen_tcp_sub_16");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_multiply_54a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_multiply_54a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_multiply_66a()).runTest("CWE191_Integer_Underflow__int_random_multiply_66a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_multiply_17()).runTest("CWE191_Integer_Underflow__int_Property_multiply_17");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_sub_03()).runTest("CWE191_Integer_Underflow__int_random_sub_03");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_sub_17()).runTest("CWE191_Integer_Underflow__int_Property_sub_17");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_multiply_05()).runTest("CWE191_Integer_Underflow__int_Property_multiply_05");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_multiply_51a()).runTest("CWE191_Integer_Underflow__int_random_multiply_51a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_sub_81a()).runTest("CWE191_Integer_Underflow__int_min_sub_81a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_multiply_02()).runTest("CWE191_Integer_Underflow__int_min_multiply_02");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_sub_52a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_sub_52a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_sub_41()).runTest("CWE191_Integer_Underflow__int_random_sub_41");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_sub_22a()).runTest("CWE191_Integer_Underflow__int_Property_sub_22a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_multiply_75a()).runTest("CWE191_Integer_Underflow__int_min_multiply_75a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_sub_52a()).runTest("CWE191_Integer_Underflow__int_Property_sub_52a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_sub_17()).runTest("CWE191_Integer_Underflow__int_min_sub_17");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_sub_74a()).runTest("CWE191_Integer_Underflow__int_Property_sub_74a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_Property_sub_45()).runTest("CWE191_Integer_Underflow__int_Property_sub_45");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_sub_06()).runTest("CWE191_Integer_Underflow__int_random_sub_06");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_sub_72a()).runTest("CWE191_Integer_Underflow__int_random_sub_72a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_sub_75a()).runTest("CWE191_Integer_Underflow__int_random_sub_75a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_multiply_22a()).runTest("CWE191_Integer_Underflow__int_random_multiply_22a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_sub_08()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_sub_08");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_sub_03()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_sub_03");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_multiply_17()).runTest("CWE191_Integer_Underflow__int_min_multiply_17");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_sub_68a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_sub_68a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_multiply_12()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_multiply_12");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_sub_09()).runTest("CWE191_Integer_Underflow__int_random_sub_09");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_multiply_08()).runTest("CWE191_Integer_Underflow__int_min_multiply_08");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_sub_16()).runTest("CWE191_Integer_Underflow__int_random_sub_16");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_multiply_14()).runTest("CWE191_Integer_Underflow__int_min_multiply_14");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_PropertiesFile_sub_61a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_sub_61a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_min_sub_02()).runTest("CWE191_Integer_Underflow__int_min_sub_02");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_multiply_13()).runTest("CWE191_Integer_Underflow__int_random_multiply_13");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_sub_01()).runTest("CWE191_Integer_Underflow__int_listen_tcp_sub_01");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_sub_67a()).runTest("CWE191_Integer_Underflow__int_random_sub_67a");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_listen_tcp_sub_09()).runTest("CWE191_Integer_Underflow__int_listen_tcp_sub_09");
			(new testcases.CWE191_Integer_Underflow.s02.CWE191_Integer_Underflow__int_random_sub_71a()).runTest("CWE191_Integer_Underflow__int_random_sub_71a");
			/* END-AUTOGENERATED-JAVA-TESTS-1 */
}

private static void runTestCWE2() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-2 */

			/* END-AUTOGENERATED-JAVA-TESTS-2 */
}

private static void runTestCWE3() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-3 */

			/* END-AUTOGENERATED-JAVA-TESTS-3 */
}

private static void runTestCWE4() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-4 */

			/* END-AUTOGENERATED-JAVA-TESTS-4 */
}

private static void runTestCWE5() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-5 */

			/* END-AUTOGENERATED-JAVA-TESTS-5 */
}

private static void runTestCWE6() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-6 */

			/* END-AUTOGENERATED-JAVA-TESTS-6 */
}

private static void runTestCWE7() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-7 */

			/* END-AUTOGENERATED-JAVA-TESTS-7 */
}

private static void runTestCWE8() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-8 */

			/* END-AUTOGENERATED-JAVA-TESTS-8 */
}

private static void runTestCWE9() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-9 */

			/* END-AUTOGENERATED-JAVA-TESTS-9 */
}
}