package testcases.CWE191_Integer_Underflow.s04;

import testcasesupport.*;

public class Main {

	public static void main(String[] args) {
		
		if(args.length != 0) {
		
			if(args[0].equals("-h") || args[0].equals("--help")) {
		
				System.err.println("To use this main, you can either run the program with no " +
				"command line arguments to run all test cases or you can specify one or more classes to test");
				System.err.println("For example:");
				System.err.println("java testcasesupport.Main testcases.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference.custom_function.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference__custom_function_01 testcases.CWE481_Assigning_instead_of_Comparing.bool.CWE481_Assigning_instead_of_Comparing__bool_01");
				System.exit(1);
			}
			
			/* User supplied some class names on the command line, just use those with introspection
			 *
			 * String classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
			 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
 			 * could read class names from command line or use
			 * http://sadun-util.sourceforge.net/api/org/sadun/util/
			 * ClassPackageExplorer.html
			 */

			for (String className : args) {

				try {
					
					/* String classNameWithPackage = "testcases." + className; */
					
					/* IO.writeLine("classNameWithPackage = " + classNameWithPackage); */

					Class<?> myClass = Class.forName(className);

					AbstractTestCase myObject = (AbstractTestCase) myClass
							.newInstance();

					myObject.runTest(className);

				} catch (Exception ex) {

					IO.writeLine("Could not run test for class " + className);
					ex.printStackTrace();

				}
				
				IO.writeLine(""); /* leave a blank line between classes */

			}

		} else {
		
			/* No command line args were used, we want to run every testcase */
			
			/* needed to separate these calls into other methods because
			   we were running into the size limit Java has for a single method */
			runTestCWE1();
			runTestCWE2();
			runTestCWE3();
			runTestCWE4();
			runTestCWE5();
			runTestCWE6();
			runTestCWE7();
			runTestCWE8();
			runTestCWE9();
		}			
	}

private static void runTestCWE1() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-1 */
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Environment_postdec_72a()).runTest("CWE191_Integer_Underflow__int_Environment_postdec_72a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_min_postdec_54a()).runTest("CWE191_Integer_Underflow__short_min_postdec_54a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Property_postdec_74a()).runTest("CWE191_Integer_Underflow__int_Property_postdec_74a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_min_postdec_45()).runTest("CWE191_Integer_Underflow__long_min_postdec_45");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_min_postdec_01()).runTest("CWE191_Integer_Underflow__long_min_postdec_01");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_database_postdec_52a()).runTest("CWE191_Integer_Underflow__int_database_postdec_52a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_rand_postdec_01()).runTest("CWE191_Integer_Underflow__long_rand_postdec_01");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_min_postdec_17()).runTest("CWE191_Integer_Underflow__long_min_postdec_17");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_random_postdec_14()).runTest("CWE191_Integer_Underflow__int_random_postdec_14");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_database_postdec_68a()).runTest("CWE191_Integer_Underflow__int_database_postdec_68a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_min_postdec_71a()).runTest("CWE191_Integer_Underflow__short_min_postdec_71a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_console_readLine_postdec_52a()).runTest("CWE191_Integer_Underflow__int_console_readLine_postdec_52a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_min_postdec_66a()).runTest("CWE191_Integer_Underflow__byte_min_postdec_66a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_File_postdec_10()).runTest("CWE191_Integer_Underflow__int_File_postdec_10");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_min_postdec_05()).runTest("CWE191_Integer_Underflow__byte_min_postdec_05");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_min_postdec_03()).runTest("CWE191_Integer_Underflow__short_min_postdec_03");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_rand_postdec_14()).runTest("CWE191_Integer_Underflow__short_rand_postdec_14");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_min_postdec_06()).runTest("CWE191_Integer_Underflow__long_min_postdec_06");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_min_postdec_41()).runTest("CWE191_Integer_Underflow__short_min_postdec_41");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_PropertiesFile_postdec_17()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_postdec_17");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_random_postdec_06()).runTest("CWE191_Integer_Underflow__int_random_postdec_06");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_min_postdec_66a()).runTest("CWE191_Integer_Underflow__long_min_postdec_66a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_min_postdec_68a()).runTest("CWE191_Integer_Underflow__short_min_postdec_68a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_rand_postdec_04()).runTest("CWE191_Integer_Underflow__byte_rand_postdec_04");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_File_postdec_09()).runTest("CWE191_Integer_Underflow__int_File_postdec_09");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_connect_tcp_postdec_51a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_postdec_51a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_console_readLine_postdec_61a()).runTest("CWE191_Integer_Underflow__long_console_readLine_postdec_61a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_rand_postdec_42()).runTest("CWE191_Integer_Underflow__byte_rand_postdec_42");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_rand_postdec_31()).runTest("CWE191_Integer_Underflow__short_rand_postdec_31");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_rand_postdec_74a()).runTest("CWE191_Integer_Underflow__long_rand_postdec_74a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_min_postdec_75a()).runTest("CWE191_Integer_Underflow__short_min_postdec_75a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_min_postdec_71a()).runTest("CWE191_Integer_Underflow__int_min_postdec_71a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_connect_tcp_postdec_15()).runTest("CWE191_Integer_Underflow__int_connect_tcp_postdec_15");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_PropertiesFile_postdec_67a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_postdec_67a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_listen_tcp_postdec_67a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_postdec_67a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_random_postdec_03()).runTest("CWE191_Integer_Underflow__int_random_postdec_03");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_rand_postdec_45()).runTest("CWE191_Integer_Underflow__long_rand_postdec_45");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_rand_postdec_15()).runTest("CWE191_Integer_Underflow__short_rand_postdec_15");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_PropertiesFile_postdec_81a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_postdec_81a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_connect_tcp_postdec_11()).runTest("CWE191_Integer_Underflow__int_connect_tcp_postdec_11");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_File_postdec_51a()).runTest("CWE191_Integer_Underflow__int_File_postdec_51a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_rand_postdec_12()).runTest("CWE191_Integer_Underflow__short_rand_postdec_12");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_rand_postdec_10()).runTest("CWE191_Integer_Underflow__short_rand_postdec_10");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_rand_postdec_02()).runTest("CWE191_Integer_Underflow__short_rand_postdec_02");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_File_postdec_04()).runTest("CWE191_Integer_Underflow__int_File_postdec_04");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Property_postdec_21()).runTest("CWE191_Integer_Underflow__int_Property_postdec_21");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_min_postdec_72a()).runTest("CWE191_Integer_Underflow__byte_min_postdec_72a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_min_postdec_21()).runTest("CWE191_Integer_Underflow__short_min_postdec_21");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_min_postdec_45()).runTest("CWE191_Integer_Underflow__short_min_postdec_45");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_console_readLine_postdec_61a()).runTest("CWE191_Integer_Underflow__int_console_readLine_postdec_61a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Environment_postdec_52a()).runTest("CWE191_Integer_Underflow__int_Environment_postdec_52a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_console_readLine_postdec_45()).runTest("CWE191_Integer_Underflow__byte_console_readLine_postdec_45");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_min_postdec_16()).runTest("CWE191_Integer_Underflow__long_min_postdec_16");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_min_postdec_75a()).runTest("CWE191_Integer_Underflow__byte_min_postdec_75a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Environment_postdec_73a()).runTest("CWE191_Integer_Underflow__int_Environment_postdec_73a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_connect_tcp_postdec_04()).runTest("CWE191_Integer_Underflow__int_connect_tcp_postdec_04");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Property_postdec_22a()).runTest("CWE191_Integer_Underflow__int_Property_postdec_22a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_URLConnection_postdec_09()).runTest("CWE191_Integer_Underflow__int_URLConnection_postdec_09");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_console_readLine_postdec_10()).runTest("CWE191_Integer_Underflow__byte_console_readLine_postdec_10");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_listen_tcp_postdec_16()).runTest("CWE191_Integer_Underflow__int_listen_tcp_postdec_16");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_min_postdec_09()).runTest("CWE191_Integer_Underflow__short_min_postdec_09");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_min_postdec_67a()).runTest("CWE191_Integer_Underflow__long_min_postdec_67a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_connect_tcp_postdec_42()).runTest("CWE191_Integer_Underflow__int_connect_tcp_postdec_42");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_URLConnection_postdec_71a()).runTest("CWE191_Integer_Underflow__int_URLConnection_postdec_71a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_rand_postdec_08()).runTest("CWE191_Integer_Underflow__byte_rand_postdec_08");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_console_readLine_postdec_14()).runTest("CWE191_Integer_Underflow__short_console_readLine_postdec_14");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_random_postdec_02()).runTest("CWE191_Integer_Underflow__int_random_postdec_02");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_console_readLine_postdec_04()).runTest("CWE191_Integer_Underflow__int_console_readLine_postdec_04");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_rand_postdec_31()).runTest("CWE191_Integer_Underflow__byte_rand_postdec_31");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_min_postdec_68a()).runTest("CWE191_Integer_Underflow__byte_min_postdec_68a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_rand_postdec_04()).runTest("CWE191_Integer_Underflow__long_rand_postdec_04");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_database_postdec_02()).runTest("CWE191_Integer_Underflow__int_database_postdec_02");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_console_readLine_postdec_08()).runTest("CWE191_Integer_Underflow__byte_console_readLine_postdec_08");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_listen_tcp_postdec_68a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_postdec_68a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_connect_tcp_postdec_72a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_postdec_72a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_console_readLine_postdec_54a()).runTest("CWE191_Integer_Underflow__short_console_readLine_postdec_54a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_listen_tcp_postdec_09()).runTest("CWE191_Integer_Underflow__int_listen_tcp_postdec_09");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_listen_tcp_postdec_15()).runTest("CWE191_Integer_Underflow__int_listen_tcp_postdec_15");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_min_postdec_42()).runTest("CWE191_Integer_Underflow__long_min_postdec_42");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_console_readLine_postdec_72a()).runTest("CWE191_Integer_Underflow__short_console_readLine_postdec_72a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_console_readLine_postdec_10()).runTest("CWE191_Integer_Underflow__long_console_readLine_postdec_10");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_URLConnection_postdec_74a()).runTest("CWE191_Integer_Underflow__int_URLConnection_postdec_74a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_console_readLine_postdec_51a()).runTest("CWE191_Integer_Underflow__short_console_readLine_postdec_51a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Property_postdec_13()).runTest("CWE191_Integer_Underflow__int_Property_postdec_13");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_console_readLine_postdec_68a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_postdec_68a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_min_postdec_14()).runTest("CWE191_Integer_Underflow__long_min_postdec_14");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_min_postdec_15()).runTest("CWE191_Integer_Underflow__byte_min_postdec_15");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_connect_tcp_postdec_13()).runTest("CWE191_Integer_Underflow__int_connect_tcp_postdec_13");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_min_postdec_11()).runTest("CWE191_Integer_Underflow__int_min_postdec_11");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_random_postdec_41()).runTest("CWE191_Integer_Underflow__int_random_postdec_41");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_URLConnection_postdec_22a()).runTest("CWE191_Integer_Underflow__int_URLConnection_postdec_22a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_console_readLine_postdec_01()).runTest("CWE191_Integer_Underflow__int_console_readLine_postdec_01");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_PropertiesFile_postdec_22a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_postdec_22a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_min_postdec_08()).runTest("CWE191_Integer_Underflow__long_min_postdec_08");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_database_postdec_08()).runTest("CWE191_Integer_Underflow__int_database_postdec_08");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Environment_postdec_81a()).runTest("CWE191_Integer_Underflow__int_Environment_postdec_81a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_min_postdec_16()).runTest("CWE191_Integer_Underflow__byte_min_postdec_16");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Environment_postdec_71a()).runTest("CWE191_Integer_Underflow__int_Environment_postdec_71a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_PropertiesFile_postdec_16()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_postdec_16");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Environment_postdec_17()).runTest("CWE191_Integer_Underflow__int_Environment_postdec_17");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_rand_postdec_53a()).runTest("CWE191_Integer_Underflow__short_rand_postdec_53a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_File_postdec_81a()).runTest("CWE191_Integer_Underflow__int_File_postdec_81a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_console_readLine_postdec_66a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_postdec_66a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_listen_tcp_postdec_52a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_postdec_52a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_PropertiesFile_postdec_74a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_postdec_74a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_database_postdec_01()).runTest("CWE191_Integer_Underflow__int_database_postdec_01");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_PropertiesFile_postdec_42()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_postdec_42");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_URLConnection_postdec_45()).runTest("CWE191_Integer_Underflow__int_URLConnection_postdec_45");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_rand_postdec_61a()).runTest("CWE191_Integer_Underflow__byte_rand_postdec_61a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_random_postdec_12()).runTest("CWE191_Integer_Underflow__int_random_postdec_12");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_connect_tcp_postdec_74a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_postdec_74a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_database_postdec_45()).runTest("CWE191_Integer_Underflow__int_database_postdec_45");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Property_postdec_08()).runTest("CWE191_Integer_Underflow__int_Property_postdec_08");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_min_postdec_73a()).runTest("CWE191_Integer_Underflow__short_min_postdec_73a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_console_readLine_postdec_15()).runTest("CWE191_Integer_Underflow__int_console_readLine_postdec_15");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_console_readLine_postdec_11()).runTest("CWE191_Integer_Underflow__int_console_readLine_postdec_11");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_connect_tcp_postdec_52a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_postdec_52a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Property_postdec_12()).runTest("CWE191_Integer_Underflow__int_Property_postdec_12");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Environment_postdec_07()).runTest("CWE191_Integer_Underflow__int_Environment_postdec_07");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Environment_postdec_51a()).runTest("CWE191_Integer_Underflow__int_Environment_postdec_51a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_console_readLine_postdec_06()).runTest("CWE191_Integer_Underflow__byte_console_readLine_postdec_06");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_console_readLine_postdec_02()).runTest("CWE191_Integer_Underflow__short_console_readLine_postdec_02");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_rand_postdec_08()).runTest("CWE191_Integer_Underflow__short_rand_postdec_08");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_database_postdec_14()).runTest("CWE191_Integer_Underflow__int_database_postdec_14");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_URLConnection_postdec_01()).runTest("CWE191_Integer_Underflow__int_URLConnection_postdec_01");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_min_postdec_13()).runTest("CWE191_Integer_Underflow__short_min_postdec_13");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_console_readLine_postdec_22a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_postdec_22a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_console_readLine_postdec_74a()).runTest("CWE191_Integer_Underflow__int_console_readLine_postdec_74a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_listen_tcp_postdec_02()).runTest("CWE191_Integer_Underflow__int_listen_tcp_postdec_02");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_connect_tcp_postdec_05()).runTest("CWE191_Integer_Underflow__int_connect_tcp_postdec_05");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_min_postdec_72a()).runTest("CWE191_Integer_Underflow__long_min_postdec_72a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Property_postdec_04()).runTest("CWE191_Integer_Underflow__int_Property_postdec_04");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_min_postdec_12()).runTest("CWE191_Integer_Underflow__int_min_postdec_12");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_min_postdec_41()).runTest("CWE191_Integer_Underflow__byte_min_postdec_41");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_rand_postdec_51a()).runTest("CWE191_Integer_Underflow__byte_rand_postdec_51a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_min_postdec_07()).runTest("CWE191_Integer_Underflow__byte_min_postdec_07");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Environment_postdec_21()).runTest("CWE191_Integer_Underflow__int_Environment_postdec_21");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_random_postdec_22a()).runTest("CWE191_Integer_Underflow__int_random_postdec_22a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_listen_tcp_postdec_51a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_postdec_51a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_random_postdec_01()).runTest("CWE191_Integer_Underflow__int_random_postdec_01");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Property_postdec_02()).runTest("CWE191_Integer_Underflow__int_Property_postdec_02");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_min_postdec_51a()).runTest("CWE191_Integer_Underflow__int_min_postdec_51a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_min_postdec_81a()).runTest("CWE191_Integer_Underflow__long_min_postdec_81a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_min_postdec_01()).runTest("CWE191_Integer_Underflow__byte_min_postdec_01");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_min_postdec_72a()).runTest("CWE191_Integer_Underflow__int_min_postdec_72a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_min_postdec_71a()).runTest("CWE191_Integer_Underflow__byte_min_postdec_71a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_rand_postdec_73a()).runTest("CWE191_Integer_Underflow__short_rand_postdec_73a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_rand_postdec_81a()).runTest("CWE191_Integer_Underflow__long_rand_postdec_81a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_console_readLine_postdec_21()).runTest("CWE191_Integer_Underflow__byte_console_readLine_postdec_21");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_random_postdec_45()).runTest("CWE191_Integer_Underflow__int_random_postdec_45");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_connect_tcp_postdec_31()).runTest("CWE191_Integer_Underflow__int_connect_tcp_postdec_31");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_console_readLine_postdec_03()).runTest("CWE191_Integer_Underflow__long_console_readLine_postdec_03");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_min_postdec_15()).runTest("CWE191_Integer_Underflow__short_min_postdec_15");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_listen_tcp_postdec_45()).runTest("CWE191_Integer_Underflow__int_listen_tcp_postdec_45");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_rand_postdec_03()).runTest("CWE191_Integer_Underflow__long_rand_postdec_03");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_min_postdec_45()).runTest("CWE191_Integer_Underflow__int_min_postdec_45");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_min_postdec_03()).runTest("CWE191_Integer_Underflow__int_min_postdec_03");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_min_postdec_11()).runTest("CWE191_Integer_Underflow__long_min_postdec_11");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_File_postdec_67a()).runTest("CWE191_Integer_Underflow__int_File_postdec_67a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_rand_postdec_54a()).runTest("CWE191_Integer_Underflow__byte_rand_postdec_54a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_console_readLine_postdec_75a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_postdec_75a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_console_readLine_postdec_05()).runTest("CWE191_Integer_Underflow__long_console_readLine_postdec_05");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_rand_postdec_09()).runTest("CWE191_Integer_Underflow__long_rand_postdec_09");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_min_postdec_10()).runTest("CWE191_Integer_Underflow__short_min_postdec_10");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_console_readLine_postdec_42()).runTest("CWE191_Integer_Underflow__long_console_readLine_postdec_42");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_console_readLine_postdec_71a()).runTest("CWE191_Integer_Underflow__short_console_readLine_postdec_71a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_URLConnection_postdec_66a()).runTest("CWE191_Integer_Underflow__int_URLConnection_postdec_66a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_PropertiesFile_postdec_53a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_postdec_53a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_console_readLine_postdec_04()).runTest("CWE191_Integer_Underflow__long_console_readLine_postdec_04");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_PropertiesFile_postdec_21()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_postdec_21");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_rand_postdec_08()).runTest("CWE191_Integer_Underflow__long_rand_postdec_08");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_database_postdec_21()).runTest("CWE191_Integer_Underflow__int_database_postdec_21");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_console_readLine_postdec_10()).runTest("CWE191_Integer_Underflow__int_console_readLine_postdec_10");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Environment_postdec_02()).runTest("CWE191_Integer_Underflow__int_Environment_postdec_02");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_min_postdec_09()).runTest("CWE191_Integer_Underflow__byte_min_postdec_09");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_URLConnection_postdec_67a()).runTest("CWE191_Integer_Underflow__int_URLConnection_postdec_67a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_rand_postdec_21()).runTest("CWE191_Integer_Underflow__short_rand_postdec_21");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_database_postdec_74a()).runTest("CWE191_Integer_Underflow__int_database_postdec_74a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_min_postdec_75a()).runTest("CWE191_Integer_Underflow__long_min_postdec_75a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_rand_postdec_54a()).runTest("CWE191_Integer_Underflow__short_rand_postdec_54a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Environment_postdec_45()).runTest("CWE191_Integer_Underflow__int_Environment_postdec_45");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_connect_tcp_postdec_02()).runTest("CWE191_Integer_Underflow__int_connect_tcp_postdec_02");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_console_readLine_postdec_61a()).runTest("CWE191_Integer_Underflow__short_console_readLine_postdec_61a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_min_postdec_74a()).runTest("CWE191_Integer_Underflow__int_min_postdec_74a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_URLConnection_postdec_81a()).runTest("CWE191_Integer_Underflow__int_URLConnection_postdec_81a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_listen_tcp_postdec_05()).runTest("CWE191_Integer_Underflow__int_listen_tcp_postdec_05");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_min_postdec_04()).runTest("CWE191_Integer_Underflow__byte_min_postdec_04");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_connect_tcp_postdec_67a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_postdec_67a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_rand_postdec_09()).runTest("CWE191_Integer_Underflow__byte_rand_postdec_09");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_min_postdec_12()).runTest("CWE191_Integer_Underflow__byte_min_postdec_12");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_File_postdec_72a()).runTest("CWE191_Integer_Underflow__int_File_postdec_72a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Environment_postdec_54a()).runTest("CWE191_Integer_Underflow__int_Environment_postdec_54a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_min_postdec_09()).runTest("CWE191_Integer_Underflow__long_min_postdec_09");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_random_postdec_67a()).runTest("CWE191_Integer_Underflow__int_random_postdec_67a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_rand_postdec_22a()).runTest("CWE191_Integer_Underflow__byte_rand_postdec_22a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_console_readLine_postdec_15()).runTest("CWE191_Integer_Underflow__long_console_readLine_postdec_15");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_database_postdec_06()).runTest("CWE191_Integer_Underflow__int_database_postdec_06");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_rand_postdec_09()).runTest("CWE191_Integer_Underflow__short_rand_postdec_09");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_min_postdec_06()).runTest("CWE191_Integer_Underflow__int_min_postdec_06");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_min_postdec_51a()).runTest("CWE191_Integer_Underflow__short_min_postdec_51a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_console_readLine_postdec_67a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_postdec_67a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_rand_postdec_12()).runTest("CWE191_Integer_Underflow__byte_rand_postdec_12");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_File_postdec_01()).runTest("CWE191_Integer_Underflow__int_File_postdec_01");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_listen_tcp_postdec_12()).runTest("CWE191_Integer_Underflow__int_listen_tcp_postdec_12");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Property_postdec_42()).runTest("CWE191_Integer_Underflow__int_Property_postdec_42");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_min_postdec_03()).runTest("CWE191_Integer_Underflow__long_min_postdec_03");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_console_readLine_postdec_08()).runTest("CWE191_Integer_Underflow__int_console_readLine_postdec_08");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_random_postdec_09()).runTest("CWE191_Integer_Underflow__int_random_postdec_09");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_random_postdec_75a()).runTest("CWE191_Integer_Underflow__int_random_postdec_75a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_listen_tcp_postdec_54a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_postdec_54a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_rand_postdec_01()).runTest("CWE191_Integer_Underflow__byte_rand_postdec_01");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_rand_postdec_04()).runTest("CWE191_Integer_Underflow__short_rand_postdec_04");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_listen_tcp_postdec_21()).runTest("CWE191_Integer_Underflow__int_listen_tcp_postdec_21");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_min_postdec_04()).runTest("CWE191_Integer_Underflow__short_min_postdec_04");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_min_postdec_66a()).runTest("CWE191_Integer_Underflow__int_min_postdec_66a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Property_postdec_11()).runTest("CWE191_Integer_Underflow__int_Property_postdec_11");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Environment_postdec_11()).runTest("CWE191_Integer_Underflow__int_Environment_postdec_11");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_URLConnection_postdec_05()).runTest("CWE191_Integer_Underflow__int_URLConnection_postdec_05");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Property_postdec_52a()).runTest("CWE191_Integer_Underflow__int_Property_postdec_52a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_rand_postdec_53a()).runTest("CWE191_Integer_Underflow__long_rand_postdec_53a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_database_postdec_17()).runTest("CWE191_Integer_Underflow__int_database_postdec_17");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_console_readLine_postdec_68a()).runTest("CWE191_Integer_Underflow__long_console_readLine_postdec_68a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_database_postdec_66a()).runTest("CWE191_Integer_Underflow__int_database_postdec_66a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_rand_postdec_81a()).runTest("CWE191_Integer_Underflow__byte_rand_postdec_81a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_console_readLine_postdec_08()).runTest("CWE191_Integer_Underflow__long_console_readLine_postdec_08");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_console_readLine_postdec_01()).runTest("CWE191_Integer_Underflow__long_console_readLine_postdec_01");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_connect_tcp_postdec_45()).runTest("CWE191_Integer_Underflow__int_connect_tcp_postdec_45");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_database_postdec_41()).runTest("CWE191_Integer_Underflow__int_database_postdec_41");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_min_postdec_68a()).runTest("CWE191_Integer_Underflow__int_min_postdec_68a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_console_readLine_postdec_75a()).runTest("CWE191_Integer_Underflow__long_console_readLine_postdec_75a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_min_postdec_52a()).runTest("CWE191_Integer_Underflow__int_min_postdec_52a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_min_postdec_17()).runTest("CWE191_Integer_Underflow__byte_min_postdec_17");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_console_readLine_postdec_81a()).runTest("CWE191_Integer_Underflow__long_console_readLine_postdec_81a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Environment_postdec_12()).runTest("CWE191_Integer_Underflow__int_Environment_postdec_12");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_console_readLine_postdec_11()).runTest("CWE191_Integer_Underflow__long_console_readLine_postdec_11");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_min_postdec_54a()).runTest("CWE191_Integer_Underflow__long_min_postdec_54a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_min_postdec_09()).runTest("CWE191_Integer_Underflow__int_min_postdec_09");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_min_postdec_81a()).runTest("CWE191_Integer_Underflow__byte_min_postdec_81a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_URLConnection_postdec_08()).runTest("CWE191_Integer_Underflow__int_URLConnection_postdec_08");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_console_readLine_postdec_71a()).runTest("CWE191_Integer_Underflow__long_console_readLine_postdec_71a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_min_postdec_72a()).runTest("CWE191_Integer_Underflow__short_min_postdec_72a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_database_postdec_75a()).runTest("CWE191_Integer_Underflow__int_database_postdec_75a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Environment_postdec_03()).runTest("CWE191_Integer_Underflow__int_Environment_postdec_03");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_console_readLine_postdec_09()).runTest("CWE191_Integer_Underflow__int_console_readLine_postdec_09");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_URLConnection_postdec_15()).runTest("CWE191_Integer_Underflow__int_URLConnection_postdec_15");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_rand_postdec_17()).runTest("CWE191_Integer_Underflow__short_rand_postdec_17");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_rand_postdec_03()).runTest("CWE191_Integer_Underflow__short_rand_postdec_03");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_connect_tcp_postdec_73a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_postdec_73a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_console_readLine_postdec_06()).runTest("CWE191_Integer_Underflow__long_console_readLine_postdec_06");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_rand_postdec_22a()).runTest("CWE191_Integer_Underflow__short_rand_postdec_22a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_min_postdec_52a()).runTest("CWE191_Integer_Underflow__byte_min_postdec_52a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_rand_postdec_42()).runTest("CWE191_Integer_Underflow__long_rand_postdec_42");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Environment_postdec_75a()).runTest("CWE191_Integer_Underflow__int_Environment_postdec_75a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_console_readLine_postdec_04()).runTest("CWE191_Integer_Underflow__byte_console_readLine_postdec_04");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_console_readLine_postdec_52a()).runTest("CWE191_Integer_Underflow__short_console_readLine_postdec_52a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Environment_postdec_15()).runTest("CWE191_Integer_Underflow__int_Environment_postdec_15");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_random_postdec_04()).runTest("CWE191_Integer_Underflow__int_random_postdec_04");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_File_postdec_52a()).runTest("CWE191_Integer_Underflow__int_File_postdec_52a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_database_postdec_16()).runTest("CWE191_Integer_Underflow__int_database_postdec_16");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_listen_tcp_postdec_01()).runTest("CWE191_Integer_Underflow__int_listen_tcp_postdec_01");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_console_readLine_postdec_09()).runTest("CWE191_Integer_Underflow__long_console_readLine_postdec_09");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_listen_tcp_postdec_53a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_postdec_53a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_PropertiesFile_postdec_12()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_postdec_12");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_PropertiesFile_postdec_13()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_postdec_13");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_File_postdec_14()).runTest("CWE191_Integer_Underflow__int_File_postdec_14");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_random_postdec_72a()).runTest("CWE191_Integer_Underflow__int_random_postdec_72a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_PropertiesFile_postdec_61a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_postdec_61a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_console_readLine_postdec_07()).runTest("CWE191_Integer_Underflow__long_console_readLine_postdec_07");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_rand_postdec_74a()).runTest("CWE191_Integer_Underflow__short_rand_postdec_74a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_database_postdec_04()).runTest("CWE191_Integer_Underflow__int_database_postdec_04");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_rand_postdec_67a()).runTest("CWE191_Integer_Underflow__byte_rand_postdec_67a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_URLConnection_postdec_31()).runTest("CWE191_Integer_Underflow__int_URLConnection_postdec_31");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_PropertiesFile_postdec_31()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_postdec_31");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Environment_postdec_31()).runTest("CWE191_Integer_Underflow__int_Environment_postdec_31");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_rand_postdec_41()).runTest("CWE191_Integer_Underflow__short_rand_postdec_41");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_File_postdec_66a()).runTest("CWE191_Integer_Underflow__int_File_postdec_66a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_rand_postdec_73a()).runTest("CWE191_Integer_Underflow__long_rand_postdec_73a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_rand_postdec_15()).runTest("CWE191_Integer_Underflow__long_rand_postdec_15");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_console_readLine_postdec_75a()).runTest("CWE191_Integer_Underflow__short_console_readLine_postdec_75a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_File_postdec_75a()).runTest("CWE191_Integer_Underflow__int_File_postdec_75a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_min_postdec_75a()).runTest("CWE191_Integer_Underflow__int_min_postdec_75a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_min_postdec_53a()).runTest("CWE191_Integer_Underflow__long_min_postdec_53a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_random_postdec_81a()).runTest("CWE191_Integer_Underflow__int_random_postdec_81a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_random_postdec_21()).runTest("CWE191_Integer_Underflow__int_random_postdec_21");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_URLConnection_postdec_61a()).runTest("CWE191_Integer_Underflow__int_URLConnection_postdec_61a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Property_postdec_66a()).runTest("CWE191_Integer_Underflow__int_Property_postdec_66a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_console_readLine_postdec_07()).runTest("CWE191_Integer_Underflow__int_console_readLine_postdec_07");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_console_readLine_postdec_09()).runTest("CWE191_Integer_Underflow__short_console_readLine_postdec_09");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_rand_postdec_54a()).runTest("CWE191_Integer_Underflow__long_rand_postdec_54a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_console_readLine_postdec_51a()).runTest("CWE191_Integer_Underflow__long_console_readLine_postdec_51a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_min_postdec_14()).runTest("CWE191_Integer_Underflow__short_min_postdec_14");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_File_postdec_53a()).runTest("CWE191_Integer_Underflow__int_File_postdec_53a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_database_postdec_53a()).runTest("CWE191_Integer_Underflow__int_database_postdec_53a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_min_postdec_15()).runTest("CWE191_Integer_Underflow__long_min_postdec_15");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_connect_tcp_postdec_01()).runTest("CWE191_Integer_Underflow__int_connect_tcp_postdec_01");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_database_postdec_71a()).runTest("CWE191_Integer_Underflow__int_database_postdec_71a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_URLConnection_postdec_17()).runTest("CWE191_Integer_Underflow__int_URLConnection_postdec_17");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_rand_postdec_05()).runTest("CWE191_Integer_Underflow__short_rand_postdec_05");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_rand_postdec_72a()).runTest("CWE191_Integer_Underflow__long_rand_postdec_72a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_min_postdec_51a()).runTest("CWE191_Integer_Underflow__long_min_postdec_51a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_console_readLine_postdec_67a()).runTest("CWE191_Integer_Underflow__short_console_readLine_postdec_67a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_rand_postdec_07()).runTest("CWE191_Integer_Underflow__byte_rand_postdec_07");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_PropertiesFile_postdec_52a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_postdec_52a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_connect_tcp_postdec_66a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_postdec_66a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_min_postdec_21()).runTest("CWE191_Integer_Underflow__long_min_postdec_21");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_min_postdec_67a()).runTest("CWE191_Integer_Underflow__short_min_postdec_67a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_rand_postdec_15()).runTest("CWE191_Integer_Underflow__byte_rand_postdec_15");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_console_readLine_postdec_21()).runTest("CWE191_Integer_Underflow__long_console_readLine_postdec_21");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_console_readLine_postdec_17()).runTest("CWE191_Integer_Underflow__short_console_readLine_postdec_17");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_min_postdec_17()).runTest("CWE191_Integer_Underflow__short_min_postdec_17");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_URLConnection_postdec_21()).runTest("CWE191_Integer_Underflow__int_URLConnection_postdec_21");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_min_postdec_07()).runTest("CWE191_Integer_Underflow__short_min_postdec_07");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_console_readLine_postdec_66a()).runTest("CWE191_Integer_Underflow__long_console_readLine_postdec_66a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_connect_tcp_postdec_14()).runTest("CWE191_Integer_Underflow__int_connect_tcp_postdec_14");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_rand_postdec_06()).runTest("CWE191_Integer_Underflow__long_rand_postdec_06");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_database_postdec_81a()).runTest("CWE191_Integer_Underflow__int_database_postdec_81a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_File_postdec_15()).runTest("CWE191_Integer_Underflow__int_File_postdec_15");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_connect_tcp_postdec_21()).runTest("CWE191_Integer_Underflow__int_connect_tcp_postdec_21");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_URLConnection_postdec_11()).runTest("CWE191_Integer_Underflow__int_URLConnection_postdec_11");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_console_readLine_postdec_31()).runTest("CWE191_Integer_Underflow__long_console_readLine_postdec_31");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_console_readLine_postdec_61a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_postdec_61a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Property_postdec_71a()).runTest("CWE191_Integer_Underflow__int_Property_postdec_71a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_console_readLine_postdec_66a()).runTest("CWE191_Integer_Underflow__int_console_readLine_postdec_66a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_console_readLine_postdec_02()).runTest("CWE191_Integer_Underflow__long_console_readLine_postdec_02");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_min_postdec_02()).runTest("CWE191_Integer_Underflow__long_min_postdec_02");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_listen_tcp_postdec_11()).runTest("CWE191_Integer_Underflow__int_listen_tcp_postdec_11");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_min_postdec_05()).runTest("CWE191_Integer_Underflow__int_min_postdec_05");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_rand_postdec_11()).runTest("CWE191_Integer_Underflow__byte_rand_postdec_11");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Environment_postdec_41()).runTest("CWE191_Integer_Underflow__int_Environment_postdec_41");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_rand_postdec_11()).runTest("CWE191_Integer_Underflow__long_rand_postdec_11");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_URLConnection_postdec_42()).runTest("CWE191_Integer_Underflow__int_URLConnection_postdec_42");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_rand_postdec_10()).runTest("CWE191_Integer_Underflow__long_rand_postdec_10");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_console_readLine_postdec_41()).runTest("CWE191_Integer_Underflow__int_console_readLine_postdec_41");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_min_postdec_22a()).runTest("CWE191_Integer_Underflow__long_min_postdec_22a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_console_readLine_postdec_31()).runTest("CWE191_Integer_Underflow__short_console_readLine_postdec_31");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_min_postdec_02()).runTest("CWE191_Integer_Underflow__int_min_postdec_02");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_min_postdec_10()).runTest("CWE191_Integer_Underflow__long_min_postdec_10");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_console_readLine_postdec_12()).runTest("CWE191_Integer_Underflow__long_console_readLine_postdec_12");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_URLConnection_postdec_02()).runTest("CWE191_Integer_Underflow__int_URLConnection_postdec_02");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_random_postdec_73a()).runTest("CWE191_Integer_Underflow__int_random_postdec_73a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_URLConnection_postdec_16()).runTest("CWE191_Integer_Underflow__int_URLConnection_postdec_16");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Property_postdec_53a()).runTest("CWE191_Integer_Underflow__int_Property_postdec_53a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_database_postdec_13()).runTest("CWE191_Integer_Underflow__int_database_postdec_13");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_rand_postdec_71a()).runTest("CWE191_Integer_Underflow__short_rand_postdec_71a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_console_readLine_postdec_13()).runTest("CWE191_Integer_Underflow__short_console_readLine_postdec_13");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_console_readLine_postdec_51a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_postdec_51a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Environment_postdec_74a()).runTest("CWE191_Integer_Underflow__int_Environment_postdec_74a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_min_postdec_10()).runTest("CWE191_Integer_Underflow__byte_min_postdec_10");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Property_postdec_73a()).runTest("CWE191_Integer_Underflow__int_Property_postdec_73a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_min_postdec_74a()).runTest("CWE191_Integer_Underflow__long_min_postdec_74a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_console_readLine_postdec_71a()).runTest("CWE191_Integer_Underflow__int_console_readLine_postdec_71a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_min_postdec_52a()).runTest("CWE191_Integer_Underflow__short_min_postdec_52a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_console_readLine_postdec_42()).runTest("CWE191_Integer_Underflow__int_console_readLine_postdec_42");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Property_postdec_51a()).runTest("CWE191_Integer_Underflow__int_Property_postdec_51a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_min_postdec_74a()).runTest("CWE191_Integer_Underflow__byte_min_postdec_74a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_console_readLine_postdec_22a()).runTest("CWE191_Integer_Underflow__long_console_readLine_postdec_22a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_File_postdec_11()).runTest("CWE191_Integer_Underflow__int_File_postdec_11");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_min_postdec_53a()).runTest("CWE191_Integer_Underflow__int_min_postdec_53a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_min_postdec_74a()).runTest("CWE191_Integer_Underflow__short_min_postdec_74a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_random_postdec_13()).runTest("CWE191_Integer_Underflow__int_random_postdec_13");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_rand_postdec_05()).runTest("CWE191_Integer_Underflow__byte_rand_postdec_05");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_min_postdec_17()).runTest("CWE191_Integer_Underflow__int_min_postdec_17");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_rand_postdec_52a()).runTest("CWE191_Integer_Underflow__long_rand_postdec_52a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_rand_postdec_75a()).runTest("CWE191_Integer_Underflow__short_rand_postdec_75a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_database_postdec_12()).runTest("CWE191_Integer_Underflow__int_database_postdec_12");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_min_postdec_52a()).runTest("CWE191_Integer_Underflow__long_min_postdec_52a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_console_readLine_postdec_53a()).runTest("CWE191_Integer_Underflow__int_console_readLine_postdec_53a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_rand_postdec_66a()).runTest("CWE191_Integer_Underflow__long_rand_postdec_66a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_rand_postdec_72a()).runTest("CWE191_Integer_Underflow__byte_rand_postdec_72a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_console_readLine_postdec_74a()).runTest("CWE191_Integer_Underflow__long_console_readLine_postdec_74a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_min_postdec_54a()).runTest("CWE191_Integer_Underflow__byte_min_postdec_54a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_database_postdec_10()).runTest("CWE191_Integer_Underflow__int_database_postdec_10");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_min_postdec_05()).runTest("CWE191_Integer_Underflow__long_min_postdec_05");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_min_postdec_67a()).runTest("CWE191_Integer_Underflow__int_min_postdec_67a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_min_postdec_06()).runTest("CWE191_Integer_Underflow__byte_min_postdec_06");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_rand_postdec_68a()).runTest("CWE191_Integer_Underflow__short_rand_postdec_68a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_random_postdec_42()).runTest("CWE191_Integer_Underflow__int_random_postdec_42");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_rand_postdec_21()).runTest("CWE191_Integer_Underflow__long_rand_postdec_21");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_random_postdec_16()).runTest("CWE191_Integer_Underflow__int_random_postdec_16");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_rand_postdec_06()).runTest("CWE191_Integer_Underflow__byte_rand_postdec_06");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Environment_postdec_01()).runTest("CWE191_Integer_Underflow__int_Environment_postdec_01");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_console_readLine_postdec_68a()).runTest("CWE191_Integer_Underflow__int_console_readLine_postdec_68a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_console_readLine_postdec_06()).runTest("CWE191_Integer_Underflow__int_console_readLine_postdec_06");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_min_postdec_61a()).runTest("CWE191_Integer_Underflow__long_min_postdec_61a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_min_postdec_08()).runTest("CWE191_Integer_Underflow__short_min_postdec_08");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_rand_postdec_75a()).runTest("CWE191_Integer_Underflow__byte_rand_postdec_75a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_min_postdec_04()).runTest("CWE191_Integer_Underflow__long_min_postdec_04");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_PropertiesFile_postdec_51a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_postdec_51a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_console_readLine_postdec_73a()).runTest("CWE191_Integer_Underflow__long_console_readLine_postdec_73a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_console_readLine_postdec_22a()).runTest("CWE191_Integer_Underflow__int_console_readLine_postdec_22a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_min_postdec_53a()).runTest("CWE191_Integer_Underflow__short_min_postdec_53a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_console_readLine_postdec_41()).runTest("CWE191_Integer_Underflow__byte_console_readLine_postdec_41");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_listen_tcp_postdec_72a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_postdec_72a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_rand_postdec_71a()).runTest("CWE191_Integer_Underflow__byte_rand_postdec_71a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Property_postdec_75a()).runTest("CWE191_Integer_Underflow__int_Property_postdec_75a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_URLConnection_postdec_51a()).runTest("CWE191_Integer_Underflow__int_URLConnection_postdec_51a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_File_postdec_42()).runTest("CWE191_Integer_Underflow__int_File_postdec_42");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_PropertiesFile_postdec_05()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_postdec_05");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_console_readLine_postdec_12()).runTest("CWE191_Integer_Underflow__short_console_readLine_postdec_12");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_console_readLine_postdec_31()).runTest("CWE191_Integer_Underflow__int_console_readLine_postdec_31");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_rand_postdec_06()).runTest("CWE191_Integer_Underflow__short_rand_postdec_06");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_rand_postdec_11()).runTest("CWE191_Integer_Underflow__short_rand_postdec_11");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_URLConnection_postdec_10()).runTest("CWE191_Integer_Underflow__int_URLConnection_postdec_10");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_min_postdec_31()).runTest("CWE191_Integer_Underflow__int_min_postdec_31");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_rand_postdec_67a()).runTest("CWE191_Integer_Underflow__long_rand_postdec_67a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_min_postdec_31()).runTest("CWE191_Integer_Underflow__byte_min_postdec_31");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_connect_tcp_postdec_08()).runTest("CWE191_Integer_Underflow__int_connect_tcp_postdec_08");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_connect_tcp_postdec_12()).runTest("CWE191_Integer_Underflow__int_connect_tcp_postdec_12");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_min_postdec_31()).runTest("CWE191_Integer_Underflow__short_min_postdec_31");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_console_readLine_postdec_51a()).runTest("CWE191_Integer_Underflow__int_console_readLine_postdec_51a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_File_postdec_73a()).runTest("CWE191_Integer_Underflow__int_File_postdec_73a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_rand_postdec_22a()).runTest("CWE191_Integer_Underflow__long_rand_postdec_22a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_listen_tcp_postdec_06()).runTest("CWE191_Integer_Underflow__int_listen_tcp_postdec_06");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_PropertiesFile_postdec_02()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_postdec_02");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_console_readLine_postdec_21()).runTest("CWE191_Integer_Underflow__short_console_readLine_postdec_21");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_listen_tcp_postdec_14()).runTest("CWE191_Integer_Underflow__int_listen_tcp_postdec_14");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_min_postdec_45()).runTest("CWE191_Integer_Underflow__byte_min_postdec_45");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_console_readLine_postdec_07()).runTest("CWE191_Integer_Underflow__byte_console_readLine_postdec_07");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_connect_tcp_postdec_53a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_postdec_53a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_random_postdec_31()).runTest("CWE191_Integer_Underflow__int_random_postdec_31");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_rand_postdec_41()).runTest("CWE191_Integer_Underflow__byte_rand_postdec_41");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_console_readLine_postdec_53a()).runTest("CWE191_Integer_Underflow__long_console_readLine_postdec_53a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_PropertiesFile_postdec_45()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_postdec_45");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_connect_tcp_postdec_61a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_postdec_61a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_min_postdec_22a()).runTest("CWE191_Integer_Underflow__short_min_postdec_22a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_console_readLine_postdec_42()).runTest("CWE191_Integer_Underflow__byte_console_readLine_postdec_42");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_listen_tcp_postdec_31()).runTest("CWE191_Integer_Underflow__int_listen_tcp_postdec_31");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_min_postdec_05()).runTest("CWE191_Integer_Underflow__short_min_postdec_05");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Property_postdec_16()).runTest("CWE191_Integer_Underflow__int_Property_postdec_16");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Property_postdec_31()).runTest("CWE191_Integer_Underflow__int_Property_postdec_31");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_random_postdec_74a()).runTest("CWE191_Integer_Underflow__int_random_postdec_74a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_console_readLine_postdec_73a()).runTest("CWE191_Integer_Underflow__int_console_readLine_postdec_73a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_console_readLine_postdec_08()).runTest("CWE191_Integer_Underflow__short_console_readLine_postdec_08");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_random_postdec_52a()).runTest("CWE191_Integer_Underflow__int_random_postdec_52a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_URLConnection_postdec_52a()).runTest("CWE191_Integer_Underflow__int_URLConnection_postdec_52a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_random_postdec_17()).runTest("CWE191_Integer_Underflow__int_random_postdec_17");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_rand_postdec_66a()).runTest("CWE191_Integer_Underflow__short_rand_postdec_66a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_rand_postdec_42()).runTest("CWE191_Integer_Underflow__short_rand_postdec_42");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_console_readLine_postdec_71a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_postdec_71a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Environment_postdec_06()).runTest("CWE191_Integer_Underflow__int_Environment_postdec_06");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Property_postdec_14()).runTest("CWE191_Integer_Underflow__int_Property_postdec_14");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_console_readLine_postdec_13()).runTest("CWE191_Integer_Underflow__int_console_readLine_postdec_13");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Property_postdec_67a()).runTest("CWE191_Integer_Underflow__int_Property_postdec_67a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_min_postdec_11()).runTest("CWE191_Integer_Underflow__byte_min_postdec_11");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_connect_tcp_postdec_07()).runTest("CWE191_Integer_Underflow__int_connect_tcp_postdec_07");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_min_postdec_03()).runTest("CWE191_Integer_Underflow__byte_min_postdec_03");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_rand_postdec_52a()).runTest("CWE191_Integer_Underflow__short_rand_postdec_52a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_min_postdec_06()).runTest("CWE191_Integer_Underflow__short_min_postdec_06");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_console_readLine_postdec_68a()).runTest("CWE191_Integer_Underflow__short_console_readLine_postdec_68a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_console_readLine_postdec_02()).runTest("CWE191_Integer_Underflow__byte_console_readLine_postdec_02");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_console_readLine_postdec_41()).runTest("CWE191_Integer_Underflow__short_console_readLine_postdec_41");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_console_readLine_postdec_03()).runTest("CWE191_Integer_Underflow__short_console_readLine_postdec_03");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_listen_tcp_postdec_13()).runTest("CWE191_Integer_Underflow__int_listen_tcp_postdec_13");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_File_postdec_12()).runTest("CWE191_Integer_Underflow__int_File_postdec_12");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_console_readLine_postdec_81a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_postdec_81a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_PropertiesFile_postdec_03()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_postdec_03");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_random_postdec_54a()).runTest("CWE191_Integer_Underflow__int_random_postdec_54a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_min_postdec_12()).runTest("CWE191_Integer_Underflow__long_min_postdec_12");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_connect_tcp_postdec_16()).runTest("CWE191_Integer_Underflow__int_connect_tcp_postdec_16");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_rand_postdec_03()).runTest("CWE191_Integer_Underflow__byte_rand_postdec_03");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Environment_postdec_66a()).runTest("CWE191_Integer_Underflow__int_Environment_postdec_66a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_rand_postdec_81a()).runTest("CWE191_Integer_Underflow__short_rand_postdec_81a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_console_readLine_postdec_45()).runTest("CWE191_Integer_Underflow__int_console_readLine_postdec_45");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_min_postdec_12()).runTest("CWE191_Integer_Underflow__short_min_postdec_12");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_connect_tcp_postdec_22a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_postdec_22a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_min_postdec_67a()).runTest("CWE191_Integer_Underflow__byte_min_postdec_67a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_rand_postdec_75a()).runTest("CWE191_Integer_Underflow__long_rand_postdec_75a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_min_postdec_16()).runTest("CWE191_Integer_Underflow__short_min_postdec_16");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_console_readLine_postdec_73a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_postdec_73a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_console_readLine_postdec_42()).runTest("CWE191_Integer_Underflow__short_console_readLine_postdec_42");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_connect_tcp_postdec_09()).runTest("CWE191_Integer_Underflow__int_connect_tcp_postdec_09");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Property_postdec_17()).runTest("CWE191_Integer_Underflow__int_Property_postdec_17");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Property_postdec_68a()).runTest("CWE191_Integer_Underflow__int_Property_postdec_68a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_min_postdec_08()).runTest("CWE191_Integer_Underflow__byte_min_postdec_08");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_console_readLine_postdec_54a()).runTest("CWE191_Integer_Underflow__long_console_readLine_postdec_54a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_min_postdec_14()).runTest("CWE191_Integer_Underflow__byte_min_postdec_14");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_min_postdec_61a()).runTest("CWE191_Integer_Underflow__short_min_postdec_61a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_File_postdec_06()).runTest("CWE191_Integer_Underflow__int_File_postdec_06");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Environment_postdec_16()).runTest("CWE191_Integer_Underflow__int_Environment_postdec_16");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_PropertiesFile_postdec_01()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_postdec_01");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_PropertiesFile_postdec_75a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_postdec_75a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_PropertiesFile_postdec_71a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_postdec_71a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_database_postdec_67a()).runTest("CWE191_Integer_Underflow__int_database_postdec_67a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_PropertiesFile_postdec_15()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_postdec_15");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_console_readLine_postdec_45()).runTest("CWE191_Integer_Underflow__long_console_readLine_postdec_45");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_File_postdec_03()).runTest("CWE191_Integer_Underflow__int_File_postdec_03");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_rand_postdec_14()).runTest("CWE191_Integer_Underflow__byte_rand_postdec_14");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_PropertiesFile_postdec_66a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_postdec_66a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_min_postdec_66a()).runTest("CWE191_Integer_Underflow__short_min_postdec_66a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_console_readLine_postdec_53a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_postdec_53a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_File_postdec_16()).runTest("CWE191_Integer_Underflow__int_File_postdec_16");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_min_postdec_53a()).runTest("CWE191_Integer_Underflow__byte_min_postdec_53a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_console_readLine_postdec_45()).runTest("CWE191_Integer_Underflow__short_console_readLine_postdec_45");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_console_readLine_postdec_05()).runTest("CWE191_Integer_Underflow__short_console_readLine_postdec_05");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_rand_postdec_53a()).runTest("CWE191_Integer_Underflow__byte_rand_postdec_53a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_min_postdec_01()).runTest("CWE191_Integer_Underflow__short_min_postdec_01");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_console_readLine_postdec_54a()).runTest("CWE191_Integer_Underflow__int_console_readLine_postdec_54a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_rand_postdec_21()).runTest("CWE191_Integer_Underflow__byte_rand_postdec_21");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_database_postdec_22a()).runTest("CWE191_Integer_Underflow__int_database_postdec_22a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_random_postdec_51a()).runTest("CWE191_Integer_Underflow__int_random_postdec_51a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_rand_postdec_16()).runTest("CWE191_Integer_Underflow__short_rand_postdec_16");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_console_readLine_postdec_14()).runTest("CWE191_Integer_Underflow__byte_console_readLine_postdec_14");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Environment_postdec_53a()).runTest("CWE191_Integer_Underflow__int_Environment_postdec_53a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_listen_tcp_postdec_42()).runTest("CWE191_Integer_Underflow__int_listen_tcp_postdec_42");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_min_postdec_22a()).runTest("CWE191_Integer_Underflow__int_min_postdec_22a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_console_readLine_postdec_72a()).runTest("CWE191_Integer_Underflow__long_console_readLine_postdec_72a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_random_postdec_71a()).runTest("CWE191_Integer_Underflow__int_random_postdec_71a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Property_postdec_54a()).runTest("CWE191_Integer_Underflow__int_Property_postdec_54a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_connect_tcp_postdec_68a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_postdec_68a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_rand_postdec_14()).runTest("CWE191_Integer_Underflow__long_rand_postdec_14");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Environment_postdec_10()).runTest("CWE191_Integer_Underflow__int_Environment_postdec_10");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_console_readLine_postdec_72a()).runTest("CWE191_Integer_Underflow__int_console_readLine_postdec_72a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_min_postdec_21()).runTest("CWE191_Integer_Underflow__int_min_postdec_21");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_console_readLine_postdec_16()).runTest("CWE191_Integer_Underflow__byte_console_readLine_postdec_16");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_listen_tcp_postdec_71a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_postdec_71a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_listen_tcp_postdec_61a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_postdec_61a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_rand_postdec_10()).runTest("CWE191_Integer_Underflow__byte_rand_postdec_10");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_File_postdec_22a()).runTest("CWE191_Integer_Underflow__int_File_postdec_22a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_rand_postdec_05()).runTest("CWE191_Integer_Underflow__long_rand_postdec_05");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_File_postdec_02()).runTest("CWE191_Integer_Underflow__int_File_postdec_02");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_PropertiesFile_postdec_11()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_postdec_11");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_connect_tcp_postdec_41()).runTest("CWE191_Integer_Underflow__int_connect_tcp_postdec_41");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_URLConnection_postdec_75a()).runTest("CWE191_Integer_Underflow__int_URLConnection_postdec_75a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_console_readLine_postdec_12()).runTest("CWE191_Integer_Underflow__int_console_readLine_postdec_12");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_rand_postdec_71a()).runTest("CWE191_Integer_Underflow__long_rand_postdec_71a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_console_readLine_postdec_17()).runTest("CWE191_Integer_Underflow__long_console_readLine_postdec_17");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Property_postdec_41()).runTest("CWE191_Integer_Underflow__int_Property_postdec_41");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_min_postdec_15()).runTest("CWE191_Integer_Underflow__int_min_postdec_15");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_rand_postdec_67a()).runTest("CWE191_Integer_Underflow__short_rand_postdec_67a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_console_readLine_postdec_07()).runTest("CWE191_Integer_Underflow__short_console_readLine_postdec_07");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_connect_tcp_postdec_54a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_postdec_54a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_min_postdec_01()).runTest("CWE191_Integer_Underflow__int_min_postdec_01");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_File_postdec_41()).runTest("CWE191_Integer_Underflow__int_File_postdec_41");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_database_postdec_72a()).runTest("CWE191_Integer_Underflow__int_database_postdec_72a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_rand_postdec_16()).runTest("CWE191_Integer_Underflow__long_rand_postdec_16");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_database_postdec_42()).runTest("CWE191_Integer_Underflow__int_database_postdec_42");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_connect_tcp_postdec_75a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_postdec_75a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_rand_postdec_01()).runTest("CWE191_Integer_Underflow__short_rand_postdec_01");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_rand_postdec_02()).runTest("CWE191_Integer_Underflow__byte_rand_postdec_02");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_rand_postdec_41()).runTest("CWE191_Integer_Underflow__long_rand_postdec_41");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_min_postdec_61a()).runTest("CWE191_Integer_Underflow__byte_min_postdec_61a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_console_readLine_postdec_72a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_postdec_72a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_console_readLine_postdec_16()).runTest("CWE191_Integer_Underflow__short_console_readLine_postdec_16");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_random_postdec_07()).runTest("CWE191_Integer_Underflow__int_random_postdec_07");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_rand_postdec_13()).runTest("CWE191_Integer_Underflow__long_rand_postdec_13");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Environment_postdec_67a()).runTest("CWE191_Integer_Underflow__int_Environment_postdec_67a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_console_readLine_postdec_66a()).runTest("CWE191_Integer_Underflow__short_console_readLine_postdec_66a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_console_readLine_postdec_14()).runTest("CWE191_Integer_Underflow__int_console_readLine_postdec_14");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_random_postdec_66a()).runTest("CWE191_Integer_Underflow__int_random_postdec_66a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_PropertiesFile_postdec_68a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_postdec_68a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_PropertiesFile_postdec_04()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_postdec_04");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_console_readLine_postdec_81a()).runTest("CWE191_Integer_Underflow__short_console_readLine_postdec_81a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_min_postdec_11()).runTest("CWE191_Integer_Underflow__short_min_postdec_11");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_min_postdec_41()).runTest("CWE191_Integer_Underflow__int_min_postdec_41");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_URLConnection_postdec_72a()).runTest("CWE191_Integer_Underflow__int_URLConnection_postdec_72a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_rand_postdec_13()).runTest("CWE191_Integer_Underflow__short_rand_postdec_13");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_console_readLine_postdec_17()).runTest("CWE191_Integer_Underflow__byte_console_readLine_postdec_17");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_min_postdec_51a()).runTest("CWE191_Integer_Underflow__byte_min_postdec_51a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Property_postdec_05()).runTest("CWE191_Integer_Underflow__int_Property_postdec_05");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_rand_postdec_07()).runTest("CWE191_Integer_Underflow__long_rand_postdec_07");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_console_readLine_postdec_01()).runTest("CWE191_Integer_Underflow__short_console_readLine_postdec_01");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_rand_postdec_13()).runTest("CWE191_Integer_Underflow__byte_rand_postdec_13");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_console_readLine_postdec_05()).runTest("CWE191_Integer_Underflow__byte_console_readLine_postdec_05");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_min_postdec_68a()).runTest("CWE191_Integer_Underflow__long_min_postdec_68a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_connect_tcp_postdec_10()).runTest("CWE191_Integer_Underflow__int_connect_tcp_postdec_10");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_listen_tcp_postdec_03()).runTest("CWE191_Integer_Underflow__int_listen_tcp_postdec_03");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_console_readLine_postdec_21()).runTest("CWE191_Integer_Underflow__int_console_readLine_postdec_21");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_min_postdec_16()).runTest("CWE191_Integer_Underflow__int_min_postdec_16");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_console_readLine_postdec_03()).runTest("CWE191_Integer_Underflow__int_console_readLine_postdec_03");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_listen_tcp_postdec_75a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_postdec_75a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_console_readLine_postdec_75a()).runTest("CWE191_Integer_Underflow__int_console_readLine_postdec_75a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_console_readLine_postdec_54a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_postdec_54a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_File_postdec_68a()).runTest("CWE191_Integer_Underflow__int_File_postdec_68a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Environment_postdec_13()).runTest("CWE191_Integer_Underflow__int_Environment_postdec_13");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_rand_postdec_51a()).runTest("CWE191_Integer_Underflow__short_rand_postdec_51a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_rand_postdec_68a()).runTest("CWE191_Integer_Underflow__byte_rand_postdec_68a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_console_readLine_postdec_03()).runTest("CWE191_Integer_Underflow__byte_console_readLine_postdec_03");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_rand_postdec_74a()).runTest("CWE191_Integer_Underflow__byte_rand_postdec_74a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_min_postdec_71a()).runTest("CWE191_Integer_Underflow__long_min_postdec_71a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_console_readLine_postdec_16()).runTest("CWE191_Integer_Underflow__int_console_readLine_postdec_16");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_min_postdec_73a()).runTest("CWE191_Integer_Underflow__byte_min_postdec_73a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_PropertiesFile_postdec_07()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_postdec_07");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_connect_tcp_postdec_17()).runTest("CWE191_Integer_Underflow__int_connect_tcp_postdec_17");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_rand_postdec_12()).runTest("CWE191_Integer_Underflow__long_rand_postdec_12");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_min_postdec_73a()).runTest("CWE191_Integer_Underflow__long_min_postdec_73a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_console_readLine_postdec_74a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_postdec_74a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_console_readLine_postdec_09()).runTest("CWE191_Integer_Underflow__byte_console_readLine_postdec_09");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_console_readLine_postdec_15()).runTest("CWE191_Integer_Underflow__byte_console_readLine_postdec_15");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Property_postdec_03()).runTest("CWE191_Integer_Underflow__int_Property_postdec_03");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_database_postdec_09()).runTest("CWE191_Integer_Underflow__int_database_postdec_09");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_random_postdec_11()).runTest("CWE191_Integer_Underflow__int_random_postdec_11");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Environment_postdec_05()).runTest("CWE191_Integer_Underflow__int_Environment_postdec_05");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_URLConnection_postdec_07()).runTest("CWE191_Integer_Underflow__int_URLConnection_postdec_07");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_listen_tcp_postdec_74a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_postdec_74a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_min_postdec_54a()).runTest("CWE191_Integer_Underflow__int_min_postdec_54a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_URLConnection_postdec_54a()).runTest("CWE191_Integer_Underflow__int_URLConnection_postdec_54a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_console_readLine_postdec_73a()).runTest("CWE191_Integer_Underflow__short_console_readLine_postdec_73a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_PropertiesFile_postdec_14()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_postdec_14");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_connect_tcp_postdec_81a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_postdec_81a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Property_postdec_07()).runTest("CWE191_Integer_Underflow__int_Property_postdec_07");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_min_postdec_13()).runTest("CWE191_Integer_Underflow__long_min_postdec_13");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_min_postdec_73a()).runTest("CWE191_Integer_Underflow__int_min_postdec_73a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_PropertiesFile_postdec_72a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_postdec_72a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_min_postdec_42()).runTest("CWE191_Integer_Underflow__short_min_postdec_42");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_connect_tcp_postdec_06()).runTest("CWE191_Integer_Underflow__int_connect_tcp_postdec_06");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_listen_tcp_postdec_73a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_postdec_73a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_console_readLine_postdec_22a()).runTest("CWE191_Integer_Underflow__short_console_readLine_postdec_22a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_min_postdec_02()).runTest("CWE191_Integer_Underflow__short_min_postdec_02");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_min_postdec_10()).runTest("CWE191_Integer_Underflow__int_min_postdec_10");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_rand_postdec_72a()).runTest("CWE191_Integer_Underflow__short_rand_postdec_72a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_min_postdec_02()).runTest("CWE191_Integer_Underflow__byte_min_postdec_02");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_listen_tcp_postdec_08()).runTest("CWE191_Integer_Underflow__int_listen_tcp_postdec_08");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_min_postdec_42()).runTest("CWE191_Integer_Underflow__int_min_postdec_42");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_console_readLine_postdec_52a()).runTest("CWE191_Integer_Underflow__long_console_readLine_postdec_52a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_random_postdec_61a()).runTest("CWE191_Integer_Underflow__int_random_postdec_61a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_File_postdec_54a()).runTest("CWE191_Integer_Underflow__int_File_postdec_54a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Property_postdec_45()).runTest("CWE191_Integer_Underflow__int_Property_postdec_45");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_rand_postdec_68a()).runTest("CWE191_Integer_Underflow__long_rand_postdec_68a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_console_readLine_postdec_15()).runTest("CWE191_Integer_Underflow__short_console_readLine_postdec_15");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_URLConnection_postdec_13()).runTest("CWE191_Integer_Underflow__int_URLConnection_postdec_13");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_PropertiesFile_postdec_41()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_postdec_41");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_PropertiesFile_postdec_73a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_postdec_73a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_File_postdec_74a()).runTest("CWE191_Integer_Underflow__int_File_postdec_74a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_random_postdec_53a()).runTest("CWE191_Integer_Underflow__int_random_postdec_53a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_min_postdec_07()).runTest("CWE191_Integer_Underflow__long_min_postdec_07");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_database_postdec_61a()).runTest("CWE191_Integer_Underflow__int_database_postdec_61a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_min_postdec_81a()).runTest("CWE191_Integer_Underflow__int_min_postdec_81a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Property_postdec_10()).runTest("CWE191_Integer_Underflow__int_Property_postdec_10");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_listen_tcp_postdec_04()).runTest("CWE191_Integer_Underflow__int_listen_tcp_postdec_04");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Environment_postdec_61a()).runTest("CWE191_Integer_Underflow__int_Environment_postdec_61a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_random_postdec_15()).runTest("CWE191_Integer_Underflow__int_random_postdec_15");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_PropertiesFile_postdec_09()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_postdec_09");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_rand_postdec_51a()).runTest("CWE191_Integer_Underflow__long_rand_postdec_51a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_min_postdec_42()).runTest("CWE191_Integer_Underflow__byte_min_postdec_42");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Property_postdec_09()).runTest("CWE191_Integer_Underflow__int_Property_postdec_09");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_rand_postdec_31()).runTest("CWE191_Integer_Underflow__long_rand_postdec_31");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_random_postdec_08()).runTest("CWE191_Integer_Underflow__int_random_postdec_08");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_min_postdec_41()).runTest("CWE191_Integer_Underflow__long_min_postdec_41");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_File_postdec_05()).runTest("CWE191_Integer_Underflow__int_File_postdec_05");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_console_readLine_postdec_52a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_postdec_52a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_rand_postdec_07()).runTest("CWE191_Integer_Underflow__short_rand_postdec_07");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_console_readLine_postdec_16()).runTest("CWE191_Integer_Underflow__long_console_readLine_postdec_16");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Environment_postdec_14()).runTest("CWE191_Integer_Underflow__int_Environment_postdec_14");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_console_readLine_postdec_02()).runTest("CWE191_Integer_Underflow__int_console_readLine_postdec_02");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_console_readLine_postdec_13()).runTest("CWE191_Integer_Underflow__byte_console_readLine_postdec_13");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Property_postdec_81a()).runTest("CWE191_Integer_Underflow__int_Property_postdec_81a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_listen_tcp_postdec_17()).runTest("CWE191_Integer_Underflow__int_listen_tcp_postdec_17");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_database_postdec_51a()).runTest("CWE191_Integer_Underflow__int_database_postdec_51a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_console_readLine_postdec_11()).runTest("CWE191_Integer_Underflow__short_console_readLine_postdec_11");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_URLConnection_postdec_12()).runTest("CWE191_Integer_Underflow__int_URLConnection_postdec_12");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_File_postdec_13()).runTest("CWE191_Integer_Underflow__int_File_postdec_13");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_File_postdec_08()).runTest("CWE191_Integer_Underflow__int_File_postdec_08");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Environment_postdec_68a()).runTest("CWE191_Integer_Underflow__int_Environment_postdec_68a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_listen_tcp_postdec_07()).runTest("CWE191_Integer_Underflow__int_listen_tcp_postdec_07");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_database_postdec_03()).runTest("CWE191_Integer_Underflow__int_database_postdec_03");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_console_readLine_postdec_12()).runTest("CWE191_Integer_Underflow__byte_console_readLine_postdec_12");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_rand_postdec_02()).runTest("CWE191_Integer_Underflow__long_rand_postdec_02");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_connect_tcp_postdec_03()).runTest("CWE191_Integer_Underflow__int_connect_tcp_postdec_03");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_URLConnection_postdec_03()).runTest("CWE191_Integer_Underflow__int_URLConnection_postdec_03");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_min_postdec_08()).runTest("CWE191_Integer_Underflow__int_min_postdec_08");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_File_postdec_61a()).runTest("CWE191_Integer_Underflow__int_File_postdec_61a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_rand_postdec_45()).runTest("CWE191_Integer_Underflow__byte_rand_postdec_45");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_File_postdec_71a()).runTest("CWE191_Integer_Underflow__int_File_postdec_71a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Property_postdec_61a()).runTest("CWE191_Integer_Underflow__int_Property_postdec_61a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_database_postdec_11()).runTest("CWE191_Integer_Underflow__int_database_postdec_11");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_console_readLine_postdec_81a()).runTest("CWE191_Integer_Underflow__int_console_readLine_postdec_81a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_min_postdec_31()).runTest("CWE191_Integer_Underflow__long_min_postdec_31");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_listen_tcp_postdec_10()).runTest("CWE191_Integer_Underflow__int_listen_tcp_postdec_10");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_database_postdec_07()).runTest("CWE191_Integer_Underflow__int_database_postdec_07");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Property_postdec_06()).runTest("CWE191_Integer_Underflow__int_Property_postdec_06");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_URLConnection_postdec_68a()).runTest("CWE191_Integer_Underflow__int_URLConnection_postdec_68a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_listen_tcp_postdec_41()).runTest("CWE191_Integer_Underflow__int_listen_tcp_postdec_41");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_console_readLine_postdec_01()).runTest("CWE191_Integer_Underflow__byte_console_readLine_postdec_01");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_rand_postdec_61a()).runTest("CWE191_Integer_Underflow__long_rand_postdec_61a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_rand_postdec_17()).runTest("CWE191_Integer_Underflow__byte_rand_postdec_17");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_File_postdec_21()).runTest("CWE191_Integer_Underflow__int_File_postdec_21");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_URLConnection_postdec_41()).runTest("CWE191_Integer_Underflow__int_URLConnection_postdec_41");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_console_readLine_postdec_31()).runTest("CWE191_Integer_Underflow__byte_console_readLine_postdec_31");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_console_readLine_postdec_17()).runTest("CWE191_Integer_Underflow__int_console_readLine_postdec_17");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_console_readLine_postdec_06()).runTest("CWE191_Integer_Underflow__short_console_readLine_postdec_06");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_min_postdec_81a()).runTest("CWE191_Integer_Underflow__short_min_postdec_81a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_listen_tcp_postdec_22a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_postdec_22a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_random_postdec_05()).runTest("CWE191_Integer_Underflow__int_random_postdec_05");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Property_postdec_01()).runTest("CWE191_Integer_Underflow__int_Property_postdec_01");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_console_readLine_postdec_74a()).runTest("CWE191_Integer_Underflow__short_console_readLine_postdec_74a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_min_postdec_07()).runTest("CWE191_Integer_Underflow__int_min_postdec_07");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_PropertiesFile_postdec_06()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_postdec_06");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Environment_postdec_04()).runTest("CWE191_Integer_Underflow__int_Environment_postdec_04");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_min_postdec_13()).runTest("CWE191_Integer_Underflow__int_min_postdec_13");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_URLConnection_postdec_73a()).runTest("CWE191_Integer_Underflow__int_URLConnection_postdec_73a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_console_readLine_postdec_05()).runTest("CWE191_Integer_Underflow__int_console_readLine_postdec_05");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_min_postdec_21()).runTest("CWE191_Integer_Underflow__byte_min_postdec_21");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_connect_tcp_postdec_71a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_postdec_71a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_File_postdec_45()).runTest("CWE191_Integer_Underflow__int_File_postdec_45");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_PropertiesFile_postdec_10()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_postdec_10");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_File_postdec_31()).runTest("CWE191_Integer_Underflow__int_File_postdec_31");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_database_postdec_73a()).runTest("CWE191_Integer_Underflow__int_database_postdec_73a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_listen_tcp_postdec_81a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_postdec_81a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_PropertiesFile_postdec_08()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_postdec_08");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_URLConnection_postdec_53a()).runTest("CWE191_Integer_Underflow__int_URLConnection_postdec_53a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_rand_postdec_16()).runTest("CWE191_Integer_Underflow__byte_rand_postdec_16");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Property_postdec_15()).runTest("CWE191_Integer_Underflow__int_Property_postdec_15");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_console_readLine_postdec_10()).runTest("CWE191_Integer_Underflow__short_console_readLine_postdec_10");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_URLConnection_postdec_14()).runTest("CWE191_Integer_Underflow__int_URLConnection_postdec_14");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_rand_postdec_73a()).runTest("CWE191_Integer_Underflow__byte_rand_postdec_73a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_console_readLine_postdec_14()).runTest("CWE191_Integer_Underflow__long_console_readLine_postdec_14");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_console_readLine_postdec_67a()).runTest("CWE191_Integer_Underflow__long_console_readLine_postdec_67a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_database_postdec_31()).runTest("CWE191_Integer_Underflow__int_database_postdec_31");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_database_postdec_54a()).runTest("CWE191_Integer_Underflow__int_database_postdec_54a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_rand_postdec_61a()).runTest("CWE191_Integer_Underflow__short_rand_postdec_61a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_random_postdec_10()).runTest("CWE191_Integer_Underflow__int_random_postdec_10");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Environment_postdec_42()).runTest("CWE191_Integer_Underflow__int_Environment_postdec_42");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_rand_postdec_52a()).runTest("CWE191_Integer_Underflow__byte_rand_postdec_52a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_console_readLine_postdec_11()).runTest("CWE191_Integer_Underflow__byte_console_readLine_postdec_11");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_min_postdec_04()).runTest("CWE191_Integer_Underflow__int_min_postdec_04");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_rand_postdec_45()).runTest("CWE191_Integer_Underflow__short_rand_postdec_45");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_database_postdec_05()).runTest("CWE191_Integer_Underflow__int_database_postdec_05");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_listen_tcp_postdec_66a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_postdec_66a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_File_postdec_17()).runTest("CWE191_Integer_Underflow__int_File_postdec_17");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Environment_postdec_08()).runTest("CWE191_Integer_Underflow__int_Environment_postdec_08");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_console_readLine_postdec_04()).runTest("CWE191_Integer_Underflow__short_console_readLine_postdec_04");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_database_postdec_15()).runTest("CWE191_Integer_Underflow__int_database_postdec_15");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_URLConnection_postdec_06()).runTest("CWE191_Integer_Underflow__int_URLConnection_postdec_06");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_PropertiesFile_postdec_54a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_postdec_54a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_min_postdec_22a()).runTest("CWE191_Integer_Underflow__byte_min_postdec_22a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_random_postdec_68a()).runTest("CWE191_Integer_Underflow__int_random_postdec_68a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_rand_postdec_17()).runTest("CWE191_Integer_Underflow__long_rand_postdec_17");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_min_postdec_14()).runTest("CWE191_Integer_Underflow__int_min_postdec_14");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Environment_postdec_09()).runTest("CWE191_Integer_Underflow__int_Environment_postdec_09");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_min_postdec_61a()).runTest("CWE191_Integer_Underflow__int_min_postdec_61a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Environment_postdec_22a()).runTest("CWE191_Integer_Underflow__int_Environment_postdec_22a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_Property_postdec_72a()).runTest("CWE191_Integer_Underflow__int_Property_postdec_72a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_console_readLine_postdec_67a()).runTest("CWE191_Integer_Underflow__int_console_readLine_postdec_67a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_console_readLine_postdec_41()).runTest("CWE191_Integer_Underflow__long_console_readLine_postdec_41");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_min_postdec_13()).runTest("CWE191_Integer_Underflow__byte_min_postdec_13");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_File_postdec_07()).runTest("CWE191_Integer_Underflow__int_File_postdec_07");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__long_console_readLine_postdec_13()).runTest("CWE191_Integer_Underflow__long_console_readLine_postdec_13");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__short_console_readLine_postdec_53a()).runTest("CWE191_Integer_Underflow__short_console_readLine_postdec_53a");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__int_URLConnection_postdec_04()).runTest("CWE191_Integer_Underflow__int_URLConnection_postdec_04");
			(new testcases.CWE191_Integer_Underflow.s04.CWE191_Integer_Underflow__byte_rand_postdec_66a()).runTest("CWE191_Integer_Underflow__byte_rand_postdec_66a");
			/* END-AUTOGENERATED-JAVA-TESTS-1 */
}

private static void runTestCWE2() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-2 */

			/* END-AUTOGENERATED-JAVA-TESTS-2 */
}

private static void runTestCWE3() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-3 */

			/* END-AUTOGENERATED-JAVA-TESTS-3 */
}

private static void runTestCWE4() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-4 */

			/* END-AUTOGENERATED-JAVA-TESTS-4 */
}

private static void runTestCWE5() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-5 */

			/* END-AUTOGENERATED-JAVA-TESTS-5 */
}

private static void runTestCWE6() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-6 */

			/* END-AUTOGENERATED-JAVA-TESTS-6 */
}

private static void runTestCWE7() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-7 */

			/* END-AUTOGENERATED-JAVA-TESTS-7 */
}

private static void runTestCWE8() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-8 */

			/* END-AUTOGENERATED-JAVA-TESTS-8 */
}

private static void runTestCWE9() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-9 */

			/* END-AUTOGENERATED-JAVA-TESTS-9 */
}
}