package testcases.CWE191_Integer_Underflow.s05;

import testcasesupport.*;

public class Main {

	public static void main(String[] args) {
		
		if(args.length != 0) {
		
			if(args[0].equals("-h") || args[0].equals("--help")) {
		
				System.err.println("To use this main, you can either run the program with no " +
				"command line arguments to run all test cases or you can specify one or more classes to test");
				System.err.println("For example:");
				System.err.println("java testcasesupport.Main testcases.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference.custom_function.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference__custom_function_01 testcases.CWE481_Assigning_instead_of_Comparing.bool.CWE481_Assigning_instead_of_Comparing__bool_01");
				System.exit(1);
			}
			
			/* User supplied some class names on the command line, just use those with introspection
			 *
			 * String classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
			 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
 			 * could read class names from command line or use
			 * http://sadun-util.sourceforge.net/api/org/sadun/util/
			 * ClassPackageExplorer.html
			 */

			for (String className : args) {

				try {
					
					/* String classNameWithPackage = "testcases." + className; */
					
					/* IO.writeLine("classNameWithPackage = " + classNameWithPackage); */

					Class<?> myClass = Class.forName(className);

					AbstractTestCase myObject = (AbstractTestCase) myClass
							.newInstance();

					myObject.runTest(className);

				} catch (Exception ex) {

					IO.writeLine("Could not run test for class " + className);
					ex.printStackTrace();

				}
				
				IO.writeLine(""); /* leave a blank line between classes */

			}

		} else {
		
			/* No command line args were used, we want to run every testcase */
			
			/* needed to separate these calls into other methods because
			   we were running into the size limit Java has for a single method */
			runTestCWE1();
			runTestCWE2();
			runTestCWE3();
			runTestCWE4();
			runTestCWE5();
			runTestCWE6();
			runTestCWE7();
			runTestCWE8();
			runTestCWE9();
		}			
	}

private static void runTestCWE1() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-1 */
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_rand_predec_14()).runTest("CWE191_Integer_Underflow__long_rand_predec_14");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_console_readLine_predec_72a()).runTest("CWE191_Integer_Underflow__long_console_readLine_predec_72a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_PropertiesFile_predec_45()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_predec_45");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_listen_tcp_predec_04()).runTest("CWE191_Integer_Underflow__int_listen_tcp_predec_04");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_min_predec_13()).runTest("CWE191_Integer_Underflow__int_min_predec_13");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Environment_predec_45()).runTest("CWE191_Integer_Underflow__int_Environment_predec_45");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_random_predec_13()).runTest("CWE191_Integer_Underflow__int_random_predec_13");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Environment_predec_07()).runTest("CWE191_Integer_Underflow__int_Environment_predec_07");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_database_predec_03()).runTest("CWE191_Integer_Underflow__int_database_predec_03");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_console_readLine_predec_75a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_predec_75a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_console_readLine_predec_41()).runTest("CWE191_Integer_Underflow__short_console_readLine_predec_41");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Environment_predec_75a()).runTest("CWE191_Integer_Underflow__int_Environment_predec_75a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_rand_predec_16()).runTest("CWE191_Integer_Underflow__byte_rand_predec_16");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_random_predec_10()).runTest("CWE191_Integer_Underflow__int_random_predec_10");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_console_readLine_predec_16()).runTest("CWE191_Integer_Underflow__short_console_readLine_predec_16");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_database_predec_10()).runTest("CWE191_Integer_Underflow__int_database_predec_10");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_rand_predec_21()).runTest("CWE191_Integer_Underflow__short_rand_predec_21");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_random_predec_03()).runTest("CWE191_Integer_Underflow__int_random_predec_03");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_min_predec_07()).runTest("CWE191_Integer_Underflow__short_min_predec_07");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_PropertiesFile_predec_13()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_predec_13");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_min_predec_71a()).runTest("CWE191_Integer_Underflow__long_min_predec_71a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_random_predec_66a()).runTest("CWE191_Integer_Underflow__int_random_predec_66a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_console_readLine_predec_01()).runTest("CWE191_Integer_Underflow__byte_console_readLine_predec_01");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_console_readLine_predec_16()).runTest("CWE191_Integer_Underflow__byte_console_readLine_predec_16");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_min_predec_15()).runTest("CWE191_Integer_Underflow__short_min_predec_15");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_rand_predec_71a()).runTest("CWE191_Integer_Underflow__long_rand_predec_71a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_min_predec_03()).runTest("CWE191_Integer_Underflow__int_min_predec_03");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_File_predec_06()).runTest("CWE191_Integer_Underflow__int_File_predec_06");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_connect_tcp_predec_81a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_predec_81a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_connect_tcp_predec_12()).runTest("CWE191_Integer_Underflow__int_connect_tcp_predec_12");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_console_readLine_predec_71a()).runTest("CWE191_Integer_Underflow__long_console_readLine_predec_71a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_PropertiesFile_predec_02()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_predec_02");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_rand_predec_01()).runTest("CWE191_Integer_Underflow__long_rand_predec_01");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_console_readLine_predec_07()).runTest("CWE191_Integer_Underflow__long_console_readLine_predec_07");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_rand_predec_31()).runTest("CWE191_Integer_Underflow__short_rand_predec_31");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_listen_tcp_predec_12()).runTest("CWE191_Integer_Underflow__int_listen_tcp_predec_12");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_URLConnection_predec_31()).runTest("CWE191_Integer_Underflow__int_URLConnection_predec_31");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_rand_predec_11()).runTest("CWE191_Integer_Underflow__byte_rand_predec_11");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_console_readLine_predec_73a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_predec_73a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Property_predec_61a()).runTest("CWE191_Integer_Underflow__int_Property_predec_61a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_URLConnection_predec_05()).runTest("CWE191_Integer_Underflow__int_URLConnection_predec_05");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_rand_predec_68a()).runTest("CWE191_Integer_Underflow__long_rand_predec_68a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_listen_tcp_predec_09()).runTest("CWE191_Integer_Underflow__int_listen_tcp_predec_09");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_min_predec_01()).runTest("CWE191_Integer_Underflow__short_min_predec_01");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_min_predec_15()).runTest("CWE191_Integer_Underflow__long_min_predec_15");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_console_readLine_predec_13()).runTest("CWE191_Integer_Underflow__byte_console_readLine_predec_13");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Environment_predec_51a()).runTest("CWE191_Integer_Underflow__int_Environment_predec_51a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_database_predec_54a()).runTest("CWE191_Integer_Underflow__int_database_predec_54a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_min_predec_31()).runTest("CWE191_Integer_Underflow__int_min_predec_31");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_min_predec_09()).runTest("CWE191_Integer_Underflow__int_min_predec_09");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_rand_predec_05()).runTest("CWE191_Integer_Underflow__long_rand_predec_05");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_console_readLine_predec_05()).runTest("CWE191_Integer_Underflow__short_console_readLine_predec_05");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_console_readLine_predec_31()).runTest("CWE191_Integer_Underflow__long_console_readLine_predec_31");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_connect_tcp_predec_07()).runTest("CWE191_Integer_Underflow__int_connect_tcp_predec_07");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_random_predec_07()).runTest("CWE191_Integer_Underflow__int_random_predec_07");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Environment_predec_54a()).runTest("CWE191_Integer_Underflow__int_Environment_predec_54a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_console_readLine_predec_31()).runTest("CWE191_Integer_Underflow__short_console_readLine_predec_31");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_rand_predec_10()).runTest("CWE191_Integer_Underflow__byte_rand_predec_10");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_min_predec_72a()).runTest("CWE191_Integer_Underflow__byte_min_predec_72a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_console_readLine_predec_05()).runTest("CWE191_Integer_Underflow__long_console_readLine_predec_05");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_connect_tcp_predec_75a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_predec_75a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_console_readLine_predec_17()).runTest("CWE191_Integer_Underflow__int_console_readLine_predec_17");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_database_predec_75a()).runTest("CWE191_Integer_Underflow__int_database_predec_75a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Property_predec_74a()).runTest("CWE191_Integer_Underflow__int_Property_predec_74a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_random_predec_72a()).runTest("CWE191_Integer_Underflow__int_random_predec_72a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_rand_predec_42()).runTest("CWE191_Integer_Underflow__short_rand_predec_42");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_connect_tcp_predec_22a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_predec_22a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_min_predec_21()).runTest("CWE191_Integer_Underflow__short_min_predec_21");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_console_readLine_predec_53a()).runTest("CWE191_Integer_Underflow__int_console_readLine_predec_53a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_min_predec_22a()).runTest("CWE191_Integer_Underflow__byte_min_predec_22a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_PropertiesFile_predec_01()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_predec_01");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_listen_tcp_predec_54a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_predec_54a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_rand_predec_68a()).runTest("CWE191_Integer_Underflow__short_rand_predec_68a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_rand_predec_11()).runTest("CWE191_Integer_Underflow__short_rand_predec_11");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_PropertiesFile_predec_53a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_predec_53a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_console_readLine_predec_22a()).runTest("CWE191_Integer_Underflow__short_console_readLine_predec_22a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_rand_predec_54a()).runTest("CWE191_Integer_Underflow__short_rand_predec_54a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_connect_tcp_predec_16()).runTest("CWE191_Integer_Underflow__int_connect_tcp_predec_16");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_File_predec_09()).runTest("CWE191_Integer_Underflow__int_File_predec_09");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_min_predec_68a()).runTest("CWE191_Integer_Underflow__int_min_predec_68a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_database_predec_09()).runTest("CWE191_Integer_Underflow__int_database_predec_09");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_connect_tcp_predec_54a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_predec_54a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_connect_tcp_predec_01()).runTest("CWE191_Integer_Underflow__int_connect_tcp_predec_01");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_URLConnection_predec_06()).runTest("CWE191_Integer_Underflow__int_URLConnection_predec_06");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_min_predec_42()).runTest("CWE191_Integer_Underflow__int_min_predec_42");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_min_predec_21()).runTest("CWE191_Integer_Underflow__byte_min_predec_21");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_min_predec_06()).runTest("CWE191_Integer_Underflow__short_min_predec_06");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Property_predec_42()).runTest("CWE191_Integer_Underflow__int_Property_predec_42");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_connect_tcp_predec_08()).runTest("CWE191_Integer_Underflow__int_connect_tcp_predec_08");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Property_predec_15()).runTest("CWE191_Integer_Underflow__int_Property_predec_15");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_rand_predec_22a()).runTest("CWE191_Integer_Underflow__byte_rand_predec_22a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Property_predec_06()).runTest("CWE191_Integer_Underflow__int_Property_predec_06");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Environment_predec_16()).runTest("CWE191_Integer_Underflow__int_Environment_predec_16");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_rand_predec_05()).runTest("CWE191_Integer_Underflow__short_rand_predec_05");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_rand_predec_05()).runTest("CWE191_Integer_Underflow__byte_rand_predec_05");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Environment_predec_01()).runTest("CWE191_Integer_Underflow__int_Environment_predec_01");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_random_predec_21()).runTest("CWE191_Integer_Underflow__int_random_predec_21");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_console_readLine_predec_74a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_predec_74a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Property_predec_52a()).runTest("CWE191_Integer_Underflow__int_Property_predec_52a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Property_predec_68a()).runTest("CWE191_Integer_Underflow__int_Property_predec_68a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Environment_predec_10()).runTest("CWE191_Integer_Underflow__int_Environment_predec_10");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_PropertiesFile_predec_68a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_predec_68a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_listen_tcp_predec_07()).runTest("CWE191_Integer_Underflow__int_listen_tcp_predec_07");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_min_predec_06()).runTest("CWE191_Integer_Underflow__byte_min_predec_06");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_database_predec_01()).runTest("CWE191_Integer_Underflow__int_database_predec_01");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_database_predec_53a()).runTest("CWE191_Integer_Underflow__int_database_predec_53a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_rand_predec_81a()).runTest("CWE191_Integer_Underflow__long_rand_predec_81a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_rand_predec_17()).runTest("CWE191_Integer_Underflow__long_rand_predec_17");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_rand_predec_31()).runTest("CWE191_Integer_Underflow__byte_rand_predec_31");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_min_predec_08()).runTest("CWE191_Integer_Underflow__short_min_predec_08");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_console_readLine_predec_02()).runTest("CWE191_Integer_Underflow__int_console_readLine_predec_02");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_rand_predec_41()).runTest("CWE191_Integer_Underflow__byte_rand_predec_41");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_min_predec_75a()).runTest("CWE191_Integer_Underflow__byte_min_predec_75a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_rand_predec_08()).runTest("CWE191_Integer_Underflow__long_rand_predec_08");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_min_predec_10()).runTest("CWE191_Integer_Underflow__byte_min_predec_10");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_console_readLine_predec_42()).runTest("CWE191_Integer_Underflow__int_console_readLine_predec_42");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_min_predec_01()).runTest("CWE191_Integer_Underflow__int_min_predec_01");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_console_readLine_predec_22a()).runTest("CWE191_Integer_Underflow__int_console_readLine_predec_22a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Property_predec_02()).runTest("CWE191_Integer_Underflow__int_Property_predec_02");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_console_readLine_predec_08()).runTest("CWE191_Integer_Underflow__short_console_readLine_predec_08");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_min_predec_61a()).runTest("CWE191_Integer_Underflow__short_min_predec_61a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_connect_tcp_predec_31()).runTest("CWE191_Integer_Underflow__int_connect_tcp_predec_31");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_min_predec_01()).runTest("CWE191_Integer_Underflow__long_min_predec_01");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Environment_predec_21()).runTest("CWE191_Integer_Underflow__int_Environment_predec_21");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_rand_predec_54a()).runTest("CWE191_Integer_Underflow__byte_rand_predec_54a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_database_predec_13()).runTest("CWE191_Integer_Underflow__int_database_predec_13");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_connect_tcp_predec_13()).runTest("CWE191_Integer_Underflow__int_connect_tcp_predec_13");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_console_readLine_predec_74a()).runTest("CWE191_Integer_Underflow__long_console_readLine_predec_74a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_listen_tcp_predec_03()).runTest("CWE191_Integer_Underflow__int_listen_tcp_predec_03");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_console_readLine_predec_67a()).runTest("CWE191_Integer_Underflow__short_console_readLine_predec_67a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_PropertiesFile_predec_21()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_predec_21");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_connect_tcp_predec_41()).runTest("CWE191_Integer_Underflow__int_connect_tcp_predec_41");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_database_predec_11()).runTest("CWE191_Integer_Underflow__int_database_predec_11");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_console_readLine_predec_11()).runTest("CWE191_Integer_Underflow__byte_console_readLine_predec_11");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Property_predec_31()).runTest("CWE191_Integer_Underflow__int_Property_predec_31");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_rand_predec_08()).runTest("CWE191_Integer_Underflow__byte_rand_predec_08");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_database_predec_02()).runTest("CWE191_Integer_Underflow__int_database_predec_02");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_rand_predec_02()).runTest("CWE191_Integer_Underflow__short_rand_predec_02");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_console_readLine_predec_04()).runTest("CWE191_Integer_Underflow__short_console_readLine_predec_04");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_rand_predec_01()).runTest("CWE191_Integer_Underflow__short_rand_predec_01");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_console_readLine_predec_01()).runTest("CWE191_Integer_Underflow__int_console_readLine_predec_01");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_File_predec_05()).runTest("CWE191_Integer_Underflow__int_File_predec_05");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_rand_predec_22a()).runTest("CWE191_Integer_Underflow__long_rand_predec_22a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_min_predec_52a()).runTest("CWE191_Integer_Underflow__byte_min_predec_52a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_min_predec_17()).runTest("CWE191_Integer_Underflow__int_min_predec_17");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Environment_predec_04()).runTest("CWE191_Integer_Underflow__int_Environment_predec_04");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_console_readLine_predec_15()).runTest("CWE191_Integer_Underflow__int_console_readLine_predec_15");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_min_predec_02()).runTest("CWE191_Integer_Underflow__byte_min_predec_02");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_listen_tcp_predec_22a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_predec_22a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_rand_predec_54a()).runTest("CWE191_Integer_Underflow__long_rand_predec_54a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_min_predec_11()).runTest("CWE191_Integer_Underflow__int_min_predec_11");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_rand_predec_21()).runTest("CWE191_Integer_Underflow__byte_rand_predec_21");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_listen_tcp_predec_61a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_predec_61a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_console_readLine_predec_31()).runTest("CWE191_Integer_Underflow__int_console_readLine_predec_31");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_min_predec_12()).runTest("CWE191_Integer_Underflow__int_min_predec_12");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_min_predec_73a()).runTest("CWE191_Integer_Underflow__int_min_predec_73a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_rand_predec_17()).runTest("CWE191_Integer_Underflow__byte_rand_predec_17");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_listen_tcp_predec_81a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_predec_81a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_min_predec_42()).runTest("CWE191_Integer_Underflow__short_min_predec_42");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_connect_tcp_predec_02()).runTest("CWE191_Integer_Underflow__int_connect_tcp_predec_02");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_console_readLine_predec_15()).runTest("CWE191_Integer_Underflow__short_console_readLine_predec_15");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_File_predec_52a()).runTest("CWE191_Integer_Underflow__int_File_predec_52a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_rand_predec_52a()).runTest("CWE191_Integer_Underflow__byte_rand_predec_52a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_File_predec_08()).runTest("CWE191_Integer_Underflow__int_File_predec_08");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_File_predec_74a()).runTest("CWE191_Integer_Underflow__int_File_predec_74a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_min_predec_71a()).runTest("CWE191_Integer_Underflow__byte_min_predec_71a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_random_predec_01()).runTest("CWE191_Integer_Underflow__int_random_predec_01");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_PropertiesFile_predec_73a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_predec_73a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_min_predec_21()).runTest("CWE191_Integer_Underflow__int_min_predec_21");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_rand_predec_10()).runTest("CWE191_Integer_Underflow__long_rand_predec_10");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_console_readLine_predec_67a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_predec_67a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_rand_predec_06()).runTest("CWE191_Integer_Underflow__byte_rand_predec_06");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_rand_predec_61a()).runTest("CWE191_Integer_Underflow__short_rand_predec_61a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_min_predec_52a()).runTest("CWE191_Integer_Underflow__long_min_predec_52a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Property_predec_41()).runTest("CWE191_Integer_Underflow__int_Property_predec_41");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_rand_predec_61a()).runTest("CWE191_Integer_Underflow__long_rand_predec_61a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_rand_predec_42()).runTest("CWE191_Integer_Underflow__byte_rand_predec_42");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_min_predec_07()).runTest("CWE191_Integer_Underflow__byte_min_predec_07");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_console_readLine_predec_03()).runTest("CWE191_Integer_Underflow__byte_console_readLine_predec_03");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_min_predec_14()).runTest("CWE191_Integer_Underflow__int_min_predec_14");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_rand_predec_71a()).runTest("CWE191_Integer_Underflow__short_rand_predec_71a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_min_predec_04()).runTest("CWE191_Integer_Underflow__byte_min_predec_04");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_rand_predec_75a()).runTest("CWE191_Integer_Underflow__short_rand_predec_75a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_console_readLine_predec_16()).runTest("CWE191_Integer_Underflow__long_console_readLine_predec_16");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_min_predec_14()).runTest("CWE191_Integer_Underflow__long_min_predec_14");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Property_predec_01()).runTest("CWE191_Integer_Underflow__int_Property_predec_01");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_min_predec_16()).runTest("CWE191_Integer_Underflow__byte_min_predec_16");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_listen_tcp_predec_06()).runTest("CWE191_Integer_Underflow__int_listen_tcp_predec_06");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_rand_predec_07()).runTest("CWE191_Integer_Underflow__long_rand_predec_07");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_console_readLine_predec_45()).runTest("CWE191_Integer_Underflow__byte_console_readLine_predec_45");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_min_predec_45()).runTest("CWE191_Integer_Underflow__int_min_predec_45");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_console_readLine_predec_03()).runTest("CWE191_Integer_Underflow__long_console_readLine_predec_03");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_console_readLine_predec_21()).runTest("CWE191_Integer_Underflow__int_console_readLine_predec_21");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_console_readLine_predec_75a()).runTest("CWE191_Integer_Underflow__long_console_readLine_predec_75a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Environment_predec_53a()).runTest("CWE191_Integer_Underflow__int_Environment_predec_53a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_rand_predec_21()).runTest("CWE191_Integer_Underflow__long_rand_predec_21");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_console_readLine_predec_07()).runTest("CWE191_Integer_Underflow__short_console_readLine_predec_07");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_min_predec_66a()).runTest("CWE191_Integer_Underflow__short_min_predec_66a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_console_readLine_predec_81a()).runTest("CWE191_Integer_Underflow__int_console_readLine_predec_81a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_random_predec_22a()).runTest("CWE191_Integer_Underflow__int_random_predec_22a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_PropertiesFile_predec_75a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_predec_75a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_min_predec_53a()).runTest("CWE191_Integer_Underflow__int_min_predec_53a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_random_predec_71a()).runTest("CWE191_Integer_Underflow__int_random_predec_71a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_connect_tcp_predec_15()).runTest("CWE191_Integer_Underflow__int_connect_tcp_predec_15");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_URLConnection_predec_67a()).runTest("CWE191_Integer_Underflow__int_URLConnection_predec_67a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_database_predec_42()).runTest("CWE191_Integer_Underflow__int_database_predec_42");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_rand_predec_72a()).runTest("CWE191_Integer_Underflow__short_rand_predec_72a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_console_readLine_predec_66a()).runTest("CWE191_Integer_Underflow__long_console_readLine_predec_66a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_connect_tcp_predec_42()).runTest("CWE191_Integer_Underflow__int_connect_tcp_predec_42");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_min_predec_09()).runTest("CWE191_Integer_Underflow__byte_min_predec_09");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_console_readLine_predec_15()).runTest("CWE191_Integer_Underflow__long_console_readLine_predec_15");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_rand_predec_15()).runTest("CWE191_Integer_Underflow__short_rand_predec_15");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_console_readLine_predec_05()).runTest("CWE191_Integer_Underflow__byte_console_readLine_predec_05");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_random_predec_45()).runTest("CWE191_Integer_Underflow__int_random_predec_45");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Environment_predec_74a()).runTest("CWE191_Integer_Underflow__int_Environment_predec_74a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_rand_predec_75a()).runTest("CWE191_Integer_Underflow__long_rand_predec_75a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_min_predec_68a()).runTest("CWE191_Integer_Underflow__short_min_predec_68a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_listen_tcp_predec_66a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_predec_66a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_console_readLine_predec_14()).runTest("CWE191_Integer_Underflow__short_console_readLine_predec_14");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_min_predec_41()).runTest("CWE191_Integer_Underflow__byte_min_predec_41");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_min_predec_52a()).runTest("CWE191_Integer_Underflow__int_min_predec_52a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_min_predec_01()).runTest("CWE191_Integer_Underflow__byte_min_predec_01");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_listen_tcp_predec_68a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_predec_68a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_URLConnection_predec_51a()).runTest("CWE191_Integer_Underflow__int_URLConnection_predec_51a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Property_predec_11()).runTest("CWE191_Integer_Underflow__int_Property_predec_11");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Property_predec_04()).runTest("CWE191_Integer_Underflow__int_Property_predec_04");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_min_predec_81a()).runTest("CWE191_Integer_Underflow__int_min_predec_81a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Property_predec_66a()).runTest("CWE191_Integer_Underflow__int_Property_predec_66a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_rand_predec_04()).runTest("CWE191_Integer_Underflow__long_rand_predec_04");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_listen_tcp_predec_10()).runTest("CWE191_Integer_Underflow__int_listen_tcp_predec_10");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_rand_predec_52a()).runTest("CWE191_Integer_Underflow__long_rand_predec_52a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_min_predec_67a()).runTest("CWE191_Integer_Underflow__byte_min_predec_67a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Environment_predec_68a()).runTest("CWE191_Integer_Underflow__int_Environment_predec_68a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_min_predec_11()).runTest("CWE191_Integer_Underflow__short_min_predec_11");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_random_predec_31()).runTest("CWE191_Integer_Underflow__int_random_predec_31");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_console_readLine_predec_14()).runTest("CWE191_Integer_Underflow__long_console_readLine_predec_14");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_console_readLine_predec_01()).runTest("CWE191_Integer_Underflow__short_console_readLine_predec_01");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_min_predec_54a()).runTest("CWE191_Integer_Underflow__short_min_predec_54a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_connect_tcp_predec_72a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_predec_72a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_random_predec_02()).runTest("CWE191_Integer_Underflow__int_random_predec_02");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_File_predec_15()).runTest("CWE191_Integer_Underflow__int_File_predec_15");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_console_readLine_predec_11()).runTest("CWE191_Integer_Underflow__short_console_readLine_predec_11");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_connect_tcp_predec_66a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_predec_66a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_console_readLine_predec_81a()).runTest("CWE191_Integer_Underflow__short_console_readLine_predec_81a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_PropertiesFile_predec_17()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_predec_17");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_File_predec_16()).runTest("CWE191_Integer_Underflow__int_File_predec_16");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_min_predec_11()).runTest("CWE191_Integer_Underflow__byte_min_predec_11");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_console_readLine_predec_67a()).runTest("CWE191_Integer_Underflow__int_console_readLine_predec_67a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_console_readLine_predec_12()).runTest("CWE191_Integer_Underflow__short_console_readLine_predec_12");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_random_predec_15()).runTest("CWE191_Integer_Underflow__int_random_predec_15");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_min_predec_61a()).runTest("CWE191_Integer_Underflow__byte_min_predec_61a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_URLConnection_predec_16()).runTest("CWE191_Integer_Underflow__int_URLConnection_predec_16");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_console_readLine_predec_09()).runTest("CWE191_Integer_Underflow__long_console_readLine_predec_09");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Property_predec_09()).runTest("CWE191_Integer_Underflow__int_Property_predec_09");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_min_predec_45()).runTest("CWE191_Integer_Underflow__byte_min_predec_45");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_database_predec_15()).runTest("CWE191_Integer_Underflow__int_database_predec_15");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_random_predec_11()).runTest("CWE191_Integer_Underflow__int_random_predec_11");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_console_readLine_predec_51a()).runTest("CWE191_Integer_Underflow__short_console_readLine_predec_51a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_rand_predec_45()).runTest("CWE191_Integer_Underflow__short_rand_predec_45");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_min_predec_53a()).runTest("CWE191_Integer_Underflow__short_min_predec_53a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_console_readLine_predec_54a()).runTest("CWE191_Integer_Underflow__int_console_readLine_predec_54a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_console_readLine_predec_54a()).runTest("CWE191_Integer_Underflow__short_console_readLine_predec_54a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_min_predec_67a()).runTest("CWE191_Integer_Underflow__int_min_predec_67a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_database_predec_05()).runTest("CWE191_Integer_Underflow__int_database_predec_05");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_console_readLine_predec_71a()).runTest("CWE191_Integer_Underflow__int_console_readLine_predec_71a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_connect_tcp_predec_14()).runTest("CWE191_Integer_Underflow__int_connect_tcp_predec_14");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_min_predec_54a()).runTest("CWE191_Integer_Underflow__long_min_predec_54a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_connect_tcp_predec_74a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_predec_74a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_File_predec_41()).runTest("CWE191_Integer_Underflow__int_File_predec_41");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_rand_predec_74a()).runTest("CWE191_Integer_Underflow__short_rand_predec_74a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_min_predec_10()).runTest("CWE191_Integer_Underflow__int_min_predec_10");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_console_readLine_predec_45()).runTest("CWE191_Integer_Underflow__short_console_readLine_predec_45");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_console_readLine_predec_14()).runTest("CWE191_Integer_Underflow__int_console_readLine_predec_14");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Environment_predec_61a()).runTest("CWE191_Integer_Underflow__int_Environment_predec_61a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_min_predec_05()).runTest("CWE191_Integer_Underflow__long_min_predec_05");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_connect_tcp_predec_06()).runTest("CWE191_Integer_Underflow__int_connect_tcp_predec_06");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_rand_predec_11()).runTest("CWE191_Integer_Underflow__long_rand_predec_11");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_rand_predec_15()).runTest("CWE191_Integer_Underflow__long_rand_predec_15");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_min_predec_53a()).runTest("CWE191_Integer_Underflow__byte_min_predec_53a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Property_predec_05()).runTest("CWE191_Integer_Underflow__int_Property_predec_05");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_console_readLine_predec_81a()).runTest("CWE191_Integer_Underflow__long_console_readLine_predec_81a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_min_predec_12()).runTest("CWE191_Integer_Underflow__short_min_predec_12");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_random_predec_16()).runTest("CWE191_Integer_Underflow__int_random_predec_16");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Property_predec_13()).runTest("CWE191_Integer_Underflow__int_Property_predec_13");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_database_predec_21()).runTest("CWE191_Integer_Underflow__int_database_predec_21");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_rand_predec_02()).runTest("CWE191_Integer_Underflow__long_rand_predec_02");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_console_readLine_predec_42()).runTest("CWE191_Integer_Underflow__long_console_readLine_predec_42");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_min_predec_22a()).runTest("CWE191_Integer_Underflow__int_min_predec_22a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_URLConnection_predec_74a()).runTest("CWE191_Integer_Underflow__int_URLConnection_predec_74a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_min_predec_05()).runTest("CWE191_Integer_Underflow__short_min_predec_05");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Environment_predec_17()).runTest("CWE191_Integer_Underflow__int_Environment_predec_17");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_connect_tcp_predec_52a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_predec_52a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_listen_tcp_predec_42()).runTest("CWE191_Integer_Underflow__int_listen_tcp_predec_42");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_console_readLine_predec_07()).runTest("CWE191_Integer_Underflow__byte_console_readLine_predec_07");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_File_predec_11()).runTest("CWE191_Integer_Underflow__int_File_predec_11");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_console_readLine_predec_51a()).runTest("CWE191_Integer_Underflow__int_console_readLine_predec_51a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_File_predec_14()).runTest("CWE191_Integer_Underflow__int_File_predec_14");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_console_readLine_predec_61a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_predec_61a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_connect_tcp_predec_51a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_predec_51a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_URLConnection_predec_02()).runTest("CWE191_Integer_Underflow__int_URLConnection_predec_02");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_URLConnection_predec_11()).runTest("CWE191_Integer_Underflow__int_URLConnection_predec_11");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_min_predec_08()).runTest("CWE191_Integer_Underflow__long_min_predec_08");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_PropertiesFile_predec_08()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_predec_08");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_console_readLine_predec_02()).runTest("CWE191_Integer_Underflow__long_console_readLine_predec_02");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_console_readLine_predec_03()).runTest("CWE191_Integer_Underflow__short_console_readLine_predec_03");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_console_readLine_predec_22a()).runTest("CWE191_Integer_Underflow__long_console_readLine_predec_22a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_URLConnection_predec_81a()).runTest("CWE191_Integer_Underflow__int_URLConnection_predec_81a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_console_readLine_predec_74a()).runTest("CWE191_Integer_Underflow__short_console_readLine_predec_74a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_rand_predec_72a()).runTest("CWE191_Integer_Underflow__long_rand_predec_72a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_listen_tcp_predec_13()).runTest("CWE191_Integer_Underflow__int_listen_tcp_predec_13");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Environment_predec_42()).runTest("CWE191_Integer_Underflow__int_Environment_predec_42");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_random_predec_52a()).runTest("CWE191_Integer_Underflow__int_random_predec_52a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_File_predec_68a()).runTest("CWE191_Integer_Underflow__int_File_predec_68a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_min_predec_02()).runTest("CWE191_Integer_Underflow__short_min_predec_02");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_random_predec_41()).runTest("CWE191_Integer_Underflow__int_random_predec_41");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_PropertiesFile_predec_05()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_predec_05");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_console_readLine_predec_81a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_predec_81a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_random_predec_68a()).runTest("CWE191_Integer_Underflow__int_random_predec_68a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_URLConnection_predec_09()).runTest("CWE191_Integer_Underflow__int_URLConnection_predec_09");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_console_readLine_predec_06()).runTest("CWE191_Integer_Underflow__short_console_readLine_predec_06");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Environment_predec_14()).runTest("CWE191_Integer_Underflow__int_Environment_predec_14");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_rand_predec_74a()).runTest("CWE191_Integer_Underflow__byte_rand_predec_74a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_listen_tcp_predec_11()).runTest("CWE191_Integer_Underflow__int_listen_tcp_predec_11");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_min_predec_72a()).runTest("CWE191_Integer_Underflow__long_min_predec_72a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_console_readLine_predec_41()).runTest("CWE191_Integer_Underflow__int_console_readLine_predec_41");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_min_predec_67a()).runTest("CWE191_Integer_Underflow__short_min_predec_67a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_rand_predec_03()).runTest("CWE191_Integer_Underflow__short_rand_predec_03");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_console_readLine_predec_21()).runTest("CWE191_Integer_Underflow__short_console_readLine_predec_21");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_database_predec_06()).runTest("CWE191_Integer_Underflow__int_database_predec_06");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_URLConnection_predec_01()).runTest("CWE191_Integer_Underflow__int_URLConnection_predec_01");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_min_predec_03()).runTest("CWE191_Integer_Underflow__byte_min_predec_03");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_console_readLine_predec_17()).runTest("CWE191_Integer_Underflow__long_console_readLine_predec_17");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_rand_predec_14()).runTest("CWE191_Integer_Underflow__short_rand_predec_14");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_rand_predec_06()).runTest("CWE191_Integer_Underflow__long_rand_predec_06");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_rand_predec_01()).runTest("CWE191_Integer_Underflow__byte_rand_predec_01");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_URLConnection_predec_08()).runTest("CWE191_Integer_Underflow__int_URLConnection_predec_08");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_listen_tcp_predec_45()).runTest("CWE191_Integer_Underflow__int_listen_tcp_predec_45");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_console_readLine_predec_61a()).runTest("CWE191_Integer_Underflow__int_console_readLine_predec_61a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_database_predec_17()).runTest("CWE191_Integer_Underflow__int_database_predec_17");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Property_predec_51a()).runTest("CWE191_Integer_Underflow__int_Property_predec_51a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_URLConnection_predec_10()).runTest("CWE191_Integer_Underflow__int_URLConnection_predec_10");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_min_predec_10()).runTest("CWE191_Integer_Underflow__short_min_predec_10");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_listen_tcp_predec_15()).runTest("CWE191_Integer_Underflow__int_listen_tcp_predec_15");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_connect_tcp_predec_61a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_predec_61a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_File_predec_13()).runTest("CWE191_Integer_Underflow__int_File_predec_13");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_database_predec_72a()).runTest("CWE191_Integer_Underflow__int_database_predec_72a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_rand_predec_02()).runTest("CWE191_Integer_Underflow__byte_rand_predec_02");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_connect_tcp_predec_09()).runTest("CWE191_Integer_Underflow__int_connect_tcp_predec_09");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_rand_predec_81a()).runTest("CWE191_Integer_Underflow__byte_rand_predec_81a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_URLConnection_predec_12()).runTest("CWE191_Integer_Underflow__int_URLConnection_predec_12");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_console_readLine_predec_73a()).runTest("CWE191_Integer_Underflow__int_console_readLine_predec_73a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_console_readLine_predec_04()).runTest("CWE191_Integer_Underflow__byte_console_readLine_predec_04");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_min_predec_17()).runTest("CWE191_Integer_Underflow__short_min_predec_17");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_connect_tcp_predec_05()).runTest("CWE191_Integer_Underflow__int_connect_tcp_predec_05");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_File_predec_51a()).runTest("CWE191_Integer_Underflow__int_File_predec_51a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_PropertiesFile_predec_06()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_predec_06");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_rand_predec_73a()).runTest("CWE191_Integer_Underflow__short_rand_predec_73a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_console_readLine_predec_42()).runTest("CWE191_Integer_Underflow__short_console_readLine_predec_42");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_min_predec_09()).runTest("CWE191_Integer_Underflow__short_min_predec_09");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_connect_tcp_predec_71a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_predec_71a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_database_predec_22a()).runTest("CWE191_Integer_Underflow__int_database_predec_22a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_console_readLine_predec_68a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_predec_68a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_console_readLine_predec_17()).runTest("CWE191_Integer_Underflow__short_console_readLine_predec_17");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_min_predec_03()).runTest("CWE191_Integer_Underflow__short_min_predec_03");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_min_predec_41()).runTest("CWE191_Integer_Underflow__short_min_predec_41");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_PropertiesFile_predec_61a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_predec_61a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_random_predec_67a()).runTest("CWE191_Integer_Underflow__int_random_predec_67a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_min_predec_66a()).runTest("CWE191_Integer_Underflow__long_min_predec_66a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_File_predec_31()).runTest("CWE191_Integer_Underflow__int_File_predec_31");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Property_predec_17()).runTest("CWE191_Integer_Underflow__int_Property_predec_17");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_console_readLine_predec_74a()).runTest("CWE191_Integer_Underflow__int_console_readLine_predec_74a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_min_predec_74a()).runTest("CWE191_Integer_Underflow__int_min_predec_74a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_console_readLine_predec_12()).runTest("CWE191_Integer_Underflow__int_console_readLine_predec_12");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Property_predec_72a()).runTest("CWE191_Integer_Underflow__int_Property_predec_72a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Environment_predec_66a()).runTest("CWE191_Integer_Underflow__int_Environment_predec_66a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_rand_predec_12()).runTest("CWE191_Integer_Underflow__long_rand_predec_12");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_database_predec_41()).runTest("CWE191_Integer_Underflow__int_database_predec_41");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_console_readLine_predec_52a()).runTest("CWE191_Integer_Underflow__short_console_readLine_predec_52a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_File_predec_67a()).runTest("CWE191_Integer_Underflow__int_File_predec_67a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Environment_predec_72a()).runTest("CWE191_Integer_Underflow__int_Environment_predec_72a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_console_readLine_predec_08()).runTest("CWE191_Integer_Underflow__byte_console_readLine_predec_08");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_random_predec_54a()).runTest("CWE191_Integer_Underflow__int_random_predec_54a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Environment_predec_11()).runTest("CWE191_Integer_Underflow__int_Environment_predec_11");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_File_predec_22a()).runTest("CWE191_Integer_Underflow__int_File_predec_22a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_console_readLine_predec_68a()).runTest("CWE191_Integer_Underflow__long_console_readLine_predec_68a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Property_predec_75a()).runTest("CWE191_Integer_Underflow__int_Property_predec_75a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_console_readLine_predec_09()).runTest("CWE191_Integer_Underflow__int_console_readLine_predec_09");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_URLConnection_predec_53a()).runTest("CWE191_Integer_Underflow__int_URLConnection_predec_53a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_rand_predec_73a()).runTest("CWE191_Integer_Underflow__byte_rand_predec_73a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_listen_tcp_predec_73a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_predec_73a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_rand_predec_09()).runTest("CWE191_Integer_Underflow__long_rand_predec_09");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_min_predec_13()).runTest("CWE191_Integer_Underflow__byte_min_predec_13");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_console_readLine_predec_42()).runTest("CWE191_Integer_Underflow__byte_console_readLine_predec_42");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_min_predec_74a()).runTest("CWE191_Integer_Underflow__long_min_predec_74a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_min_predec_08()).runTest("CWE191_Integer_Underflow__byte_min_predec_08");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_console_readLine_predec_75a()).runTest("CWE191_Integer_Underflow__int_console_readLine_predec_75a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_console_readLine_predec_52a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_predec_52a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_database_predec_61a()).runTest("CWE191_Integer_Underflow__int_database_predec_61a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_PropertiesFile_predec_41()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_predec_41");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Environment_predec_22a()).runTest("CWE191_Integer_Underflow__int_Environment_predec_22a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_min_predec_05()).runTest("CWE191_Integer_Underflow__byte_min_predec_05");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_File_predec_02()).runTest("CWE191_Integer_Underflow__int_File_predec_02");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Environment_predec_67a()).runTest("CWE191_Integer_Underflow__int_Environment_predec_67a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_rand_predec_13()).runTest("CWE191_Integer_Underflow__byte_rand_predec_13");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_console_readLine_predec_06()).runTest("CWE191_Integer_Underflow__byte_console_readLine_predec_06");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_random_predec_08()).runTest("CWE191_Integer_Underflow__int_random_predec_08");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_rand_predec_45()).runTest("CWE191_Integer_Underflow__byte_rand_predec_45");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_min_predec_16()).runTest("CWE191_Integer_Underflow__short_min_predec_16");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_PropertiesFile_predec_42()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_predec_42");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_console_readLine_predec_10()).runTest("CWE191_Integer_Underflow__byte_console_readLine_predec_10");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_min_predec_21()).runTest("CWE191_Integer_Underflow__long_min_predec_21");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_min_predec_13()).runTest("CWE191_Integer_Underflow__short_min_predec_13");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_listen_tcp_predec_01()).runTest("CWE191_Integer_Underflow__int_listen_tcp_predec_01");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_connect_tcp_predec_17()).runTest("CWE191_Integer_Underflow__int_connect_tcp_predec_17");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_min_predec_68a()).runTest("CWE191_Integer_Underflow__long_min_predec_68a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_console_readLine_predec_73a()).runTest("CWE191_Integer_Underflow__short_console_readLine_predec_73a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_min_predec_73a()).runTest("CWE191_Integer_Underflow__byte_min_predec_73a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_console_readLine_predec_67a()).runTest("CWE191_Integer_Underflow__long_console_readLine_predec_67a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_random_predec_17()).runTest("CWE191_Integer_Underflow__int_random_predec_17");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_database_predec_71a()).runTest("CWE191_Integer_Underflow__int_database_predec_71a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_File_predec_45()).runTest("CWE191_Integer_Underflow__int_File_predec_45");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_min_predec_14()).runTest("CWE191_Integer_Underflow__byte_min_predec_14");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_random_predec_61a()).runTest("CWE191_Integer_Underflow__int_random_predec_61a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_console_readLine_predec_09()).runTest("CWE191_Integer_Underflow__byte_console_readLine_predec_09");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Property_predec_54a()).runTest("CWE191_Integer_Underflow__int_Property_predec_54a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_URLConnection_predec_72a()).runTest("CWE191_Integer_Underflow__int_URLConnection_predec_72a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_File_predec_03()).runTest("CWE191_Integer_Underflow__int_File_predec_03");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_console_readLine_predec_06()).runTest("CWE191_Integer_Underflow__int_console_readLine_predec_06");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_console_readLine_predec_66a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_predec_66a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_rand_predec_09()).runTest("CWE191_Integer_Underflow__short_rand_predec_09");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_random_predec_04()).runTest("CWE191_Integer_Underflow__int_random_predec_04");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_listen_tcp_predec_51a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_predec_51a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_URLConnection_predec_14()).runTest("CWE191_Integer_Underflow__int_URLConnection_predec_14");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_PropertiesFile_predec_04()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_predec_04");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_connect_tcp_predec_03()).runTest("CWE191_Integer_Underflow__int_connect_tcp_predec_03");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_console_readLine_predec_31()).runTest("CWE191_Integer_Underflow__byte_console_readLine_predec_31");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_listen_tcp_predec_41()).runTest("CWE191_Integer_Underflow__int_listen_tcp_predec_41");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_URLConnection_predec_13()).runTest("CWE191_Integer_Underflow__int_URLConnection_predec_13");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_File_predec_54a()).runTest("CWE191_Integer_Underflow__int_File_predec_54a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_console_readLine_predec_54a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_predec_54a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_URLConnection_predec_03()).runTest("CWE191_Integer_Underflow__int_URLConnection_predec_03");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_console_readLine_predec_11()).runTest("CWE191_Integer_Underflow__int_console_readLine_predec_11");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Property_predec_67a()).runTest("CWE191_Integer_Underflow__int_Property_predec_67a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_min_predec_11()).runTest("CWE191_Integer_Underflow__long_min_predec_11");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_URLConnection_predec_15()).runTest("CWE191_Integer_Underflow__int_URLConnection_predec_15");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_random_predec_09()).runTest("CWE191_Integer_Underflow__int_random_predec_09");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_console_readLine_predec_72a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_predec_72a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_min_predec_66a()).runTest("CWE191_Integer_Underflow__int_min_predec_66a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_min_predec_81a()).runTest("CWE191_Integer_Underflow__short_min_predec_81a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_PropertiesFile_predec_11()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_predec_11");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_console_readLine_predec_71a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_predec_71a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_File_predec_75a()).runTest("CWE191_Integer_Underflow__int_File_predec_75a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_min_predec_06()).runTest("CWE191_Integer_Underflow__long_min_predec_06");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_random_predec_12()).runTest("CWE191_Integer_Underflow__int_random_predec_12");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_min_predec_81a()).runTest("CWE191_Integer_Underflow__byte_min_predec_81a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_min_predec_54a()).runTest("CWE191_Integer_Underflow__int_min_predec_54a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_database_predec_67a()).runTest("CWE191_Integer_Underflow__int_database_predec_67a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_min_predec_68a()).runTest("CWE191_Integer_Underflow__byte_min_predec_68a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_database_predec_45()).runTest("CWE191_Integer_Underflow__int_database_predec_45");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_rand_predec_51a()).runTest("CWE191_Integer_Underflow__short_rand_predec_51a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_database_predec_73a()).runTest("CWE191_Integer_Underflow__int_database_predec_73a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_database_predec_52a()).runTest("CWE191_Integer_Underflow__int_database_predec_52a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_random_predec_51a()).runTest("CWE191_Integer_Underflow__int_random_predec_51a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_rand_predec_51a()).runTest("CWE191_Integer_Underflow__byte_rand_predec_51a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_console_readLine_predec_12()).runTest("CWE191_Integer_Underflow__long_console_readLine_predec_12");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Property_predec_16()).runTest("CWE191_Integer_Underflow__int_Property_predec_16");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_rand_predec_12()).runTest("CWE191_Integer_Underflow__byte_rand_predec_12");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Environment_predec_81a()).runTest("CWE191_Integer_Underflow__int_Environment_predec_81a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_console_readLine_predec_61a()).runTest("CWE191_Integer_Underflow__long_console_readLine_predec_61a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Property_predec_03()).runTest("CWE191_Integer_Underflow__int_Property_predec_03");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_rand_predec_17()).runTest("CWE191_Integer_Underflow__short_rand_predec_17");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_File_predec_53a()).runTest("CWE191_Integer_Underflow__int_File_predec_53a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_listen_tcp_predec_72a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_predec_72a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_File_predec_81a()).runTest("CWE191_Integer_Underflow__int_File_predec_81a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_console_readLine_predec_10()).runTest("CWE191_Integer_Underflow__short_console_readLine_predec_10");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_min_predec_51a()).runTest("CWE191_Integer_Underflow__int_min_predec_51a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_URLConnection_predec_68a()).runTest("CWE191_Integer_Underflow__int_URLConnection_predec_68a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_rand_predec_81a()).runTest("CWE191_Integer_Underflow__short_rand_predec_81a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Environment_predec_08()).runTest("CWE191_Integer_Underflow__int_Environment_predec_08");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_rand_predec_42()).runTest("CWE191_Integer_Underflow__long_rand_predec_42");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_console_readLine_predec_10()).runTest("CWE191_Integer_Underflow__int_console_readLine_predec_10");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_min_predec_08()).runTest("CWE191_Integer_Underflow__int_min_predec_08");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_listen_tcp_predec_16()).runTest("CWE191_Integer_Underflow__int_listen_tcp_predec_16");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_console_readLine_predec_66a()).runTest("CWE191_Integer_Underflow__short_console_readLine_predec_66a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_console_readLine_predec_53a()).runTest("CWE191_Integer_Underflow__long_console_readLine_predec_53a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_rand_predec_66a()).runTest("CWE191_Integer_Underflow__short_rand_predec_66a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_console_readLine_predec_14()).runTest("CWE191_Integer_Underflow__byte_console_readLine_predec_14");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_PropertiesFile_predec_81a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_predec_81a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_console_readLine_predec_10()).runTest("CWE191_Integer_Underflow__long_console_readLine_predec_10");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_min_predec_22a()).runTest("CWE191_Integer_Underflow__long_min_predec_22a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_PropertiesFile_predec_12()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_predec_12");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_rand_predec_72a()).runTest("CWE191_Integer_Underflow__byte_rand_predec_72a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_PropertiesFile_predec_16()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_predec_16");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_File_predec_07()).runTest("CWE191_Integer_Underflow__int_File_predec_07");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Property_predec_71a()).runTest("CWE191_Integer_Underflow__int_Property_predec_71a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_rand_predec_66a()).runTest("CWE191_Integer_Underflow__byte_rand_predec_66a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_min_predec_52a()).runTest("CWE191_Integer_Underflow__short_min_predec_52a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_console_readLine_predec_11()).runTest("CWE191_Integer_Underflow__long_console_readLine_predec_11");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Environment_predec_06()).runTest("CWE191_Integer_Underflow__int_Environment_predec_06");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Property_predec_21()).runTest("CWE191_Integer_Underflow__int_Property_predec_21");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_console_readLine_predec_09()).runTest("CWE191_Integer_Underflow__short_console_readLine_predec_09");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_random_predec_73a()).runTest("CWE191_Integer_Underflow__int_random_predec_73a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_min_predec_75a()).runTest("CWE191_Integer_Underflow__int_min_predec_75a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Property_predec_45()).runTest("CWE191_Integer_Underflow__int_Property_predec_45");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_console_readLine_predec_21()).runTest("CWE191_Integer_Underflow__long_console_readLine_predec_21");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_database_predec_14()).runTest("CWE191_Integer_Underflow__int_database_predec_14");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Environment_predec_73a()).runTest("CWE191_Integer_Underflow__int_Environment_predec_73a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_console_readLine_predec_07()).runTest("CWE191_Integer_Underflow__int_console_readLine_predec_07");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_URLConnection_predec_66a()).runTest("CWE191_Integer_Underflow__int_URLConnection_predec_66a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_URLConnection_predec_07()).runTest("CWE191_Integer_Underflow__int_URLConnection_predec_07");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Property_predec_14()).runTest("CWE191_Integer_Underflow__int_Property_predec_14");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_console_readLine_predec_02()).runTest("CWE191_Integer_Underflow__short_console_readLine_predec_02");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_console_readLine_predec_15()).runTest("CWE191_Integer_Underflow__byte_console_readLine_predec_15");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_min_predec_41()).runTest("CWE191_Integer_Underflow__int_min_predec_41");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Environment_predec_02()).runTest("CWE191_Integer_Underflow__int_Environment_predec_02");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_console_readLine_predec_16()).runTest("CWE191_Integer_Underflow__int_console_readLine_predec_16");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Property_predec_22a()).runTest("CWE191_Integer_Underflow__int_Property_predec_22a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_min_predec_14()).runTest("CWE191_Integer_Underflow__short_min_predec_14");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_rand_predec_15()).runTest("CWE191_Integer_Underflow__byte_rand_predec_15");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_rand_predec_04()).runTest("CWE191_Integer_Underflow__byte_rand_predec_04");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_min_predec_03()).runTest("CWE191_Integer_Underflow__long_min_predec_03");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_connect_tcp_predec_04()).runTest("CWE191_Integer_Underflow__int_connect_tcp_predec_04");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_URLConnection_predec_04()).runTest("CWE191_Integer_Underflow__int_URLConnection_predec_04");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_File_predec_04()).runTest("CWE191_Integer_Underflow__int_File_predec_04");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_console_readLine_predec_66a()).runTest("CWE191_Integer_Underflow__int_console_readLine_predec_66a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_listen_tcp_predec_21()).runTest("CWE191_Integer_Underflow__int_listen_tcp_predec_21");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_URLConnection_predec_17()).runTest("CWE191_Integer_Underflow__int_URLConnection_predec_17");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_min_predec_72a()).runTest("CWE191_Integer_Underflow__short_min_predec_72a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Property_predec_07()).runTest("CWE191_Integer_Underflow__int_Property_predec_07");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_File_predec_71a()).runTest("CWE191_Integer_Underflow__int_File_predec_71a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_console_readLine_predec_08()).runTest("CWE191_Integer_Underflow__int_console_readLine_predec_08");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_URLConnection_predec_21()).runTest("CWE191_Integer_Underflow__int_URLConnection_predec_21");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_rand_predec_73a()).runTest("CWE191_Integer_Underflow__long_rand_predec_73a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_File_predec_73a()).runTest("CWE191_Integer_Underflow__int_File_predec_73a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_console_readLine_predec_22a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_predec_22a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_database_predec_12()).runTest("CWE191_Integer_Underflow__int_database_predec_12");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_rand_predec_10()).runTest("CWE191_Integer_Underflow__short_rand_predec_10");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_rand_predec_52a()).runTest("CWE191_Integer_Underflow__short_rand_predec_52a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_connect_tcp_predec_11()).runTest("CWE191_Integer_Underflow__int_connect_tcp_predec_11");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_rand_predec_74a()).runTest("CWE191_Integer_Underflow__long_rand_predec_74a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_listen_tcp_predec_53a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_predec_53a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_PropertiesFile_predec_51a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_predec_51a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Environment_predec_09()).runTest("CWE191_Integer_Underflow__int_Environment_predec_09");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_min_predec_15()).runTest("CWE191_Integer_Underflow__int_min_predec_15");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_random_predec_75a()).runTest("CWE191_Integer_Underflow__int_random_predec_75a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_console_readLine_predec_54a()).runTest("CWE191_Integer_Underflow__long_console_readLine_predec_54a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_File_predec_72a()).runTest("CWE191_Integer_Underflow__int_File_predec_72a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_console_readLine_predec_08()).runTest("CWE191_Integer_Underflow__long_console_readLine_predec_08");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_min_predec_53a()).runTest("CWE191_Integer_Underflow__long_min_predec_53a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_URLConnection_predec_61a()).runTest("CWE191_Integer_Underflow__int_URLConnection_predec_61a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_min_predec_06()).runTest("CWE191_Integer_Underflow__int_min_predec_06");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_min_predec_71a()).runTest("CWE191_Integer_Underflow__short_min_predec_71a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_min_predec_10()).runTest("CWE191_Integer_Underflow__long_min_predec_10");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_PropertiesFile_predec_72a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_predec_72a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_rand_predec_51a()).runTest("CWE191_Integer_Underflow__long_rand_predec_51a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_min_predec_02()).runTest("CWE191_Integer_Underflow__long_min_predec_02");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_connect_tcp_predec_10()).runTest("CWE191_Integer_Underflow__int_connect_tcp_predec_10");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Environment_predec_05()).runTest("CWE191_Integer_Underflow__int_Environment_predec_05");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_console_readLine_predec_51a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_predec_51a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_File_predec_61a()).runTest("CWE191_Integer_Underflow__int_File_predec_61a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_database_predec_68a()).runTest("CWE191_Integer_Underflow__int_database_predec_68a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_min_predec_31()).runTest("CWE191_Integer_Underflow__short_min_predec_31");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_console_readLine_predec_17()).runTest("CWE191_Integer_Underflow__byte_console_readLine_predec_17");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_console_readLine_predec_71a()).runTest("CWE191_Integer_Underflow__short_console_readLine_predec_71a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_rand_predec_45()).runTest("CWE191_Integer_Underflow__long_rand_predec_45");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_console_readLine_predec_41()).runTest("CWE191_Integer_Underflow__long_console_readLine_predec_41");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_rand_predec_66a()).runTest("CWE191_Integer_Underflow__long_rand_predec_66a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_rand_predec_75a()).runTest("CWE191_Integer_Underflow__byte_rand_predec_75a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_min_predec_31()).runTest("CWE191_Integer_Underflow__byte_min_predec_31");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_console_readLine_predec_13()).runTest("CWE191_Integer_Underflow__long_console_readLine_predec_13");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_PropertiesFile_predec_15()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_predec_15");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_console_readLine_predec_72a()).runTest("CWE191_Integer_Underflow__short_console_readLine_predec_72a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_connect_tcp_predec_45()).runTest("CWE191_Integer_Underflow__int_connect_tcp_predec_45");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_min_predec_45()).runTest("CWE191_Integer_Underflow__short_min_predec_45");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_console_readLine_predec_53a()).runTest("CWE191_Integer_Underflow__byte_console_readLine_predec_53a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_console_readLine_predec_73a()).runTest("CWE191_Integer_Underflow__long_console_readLine_predec_73a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_min_predec_67a()).runTest("CWE191_Integer_Underflow__long_min_predec_67a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Environment_predec_52a()).runTest("CWE191_Integer_Underflow__int_Environment_predec_52a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_URLConnection_predec_45()).runTest("CWE191_Integer_Underflow__int_URLConnection_predec_45");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Environment_predec_13()).runTest("CWE191_Integer_Underflow__int_Environment_predec_13");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_database_predec_81a()).runTest("CWE191_Integer_Underflow__int_database_predec_81a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_PropertiesFile_predec_66a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_predec_66a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_min_predec_73a()).runTest("CWE191_Integer_Underflow__short_min_predec_73a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_min_predec_41()).runTest("CWE191_Integer_Underflow__long_min_predec_41");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_PropertiesFile_predec_74a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_predec_74a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_min_predec_31()).runTest("CWE191_Integer_Underflow__long_min_predec_31");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_random_predec_05()).runTest("CWE191_Integer_Underflow__int_random_predec_05");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_URLConnection_predec_41()).runTest("CWE191_Integer_Underflow__int_URLConnection_predec_41");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_console_readLine_predec_12()).runTest("CWE191_Integer_Underflow__byte_console_readLine_predec_12");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_rand_predec_67a()).runTest("CWE191_Integer_Underflow__byte_rand_predec_67a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_console_readLine_predec_52a()).runTest("CWE191_Integer_Underflow__long_console_readLine_predec_52a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_min_predec_04()).runTest("CWE191_Integer_Underflow__int_min_predec_04");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_URLConnection_predec_75a()).runTest("CWE191_Integer_Underflow__int_URLConnection_predec_75a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_console_readLine_predec_21()).runTest("CWE191_Integer_Underflow__byte_console_readLine_predec_21");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_rand_predec_13()).runTest("CWE191_Integer_Underflow__short_rand_predec_13");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_database_predec_16()).runTest("CWE191_Integer_Underflow__int_database_predec_16");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_min_predec_61a()).runTest("CWE191_Integer_Underflow__int_min_predec_61a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_rand_predec_41()).runTest("CWE191_Integer_Underflow__short_rand_predec_41");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_rand_predec_53a()).runTest("CWE191_Integer_Underflow__long_rand_predec_53a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_random_predec_53a()).runTest("CWE191_Integer_Underflow__int_random_predec_53a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_console_readLine_predec_45()).runTest("CWE191_Integer_Underflow__long_console_readLine_predec_45");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_console_readLine_predec_45()).runTest("CWE191_Integer_Underflow__int_console_readLine_predec_45");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_PropertiesFile_predec_52a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_predec_52a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_console_readLine_predec_06()).runTest("CWE191_Integer_Underflow__long_console_readLine_predec_06");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_PropertiesFile_predec_54a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_predec_54a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_connect_tcp_predec_21()).runTest("CWE191_Integer_Underflow__int_connect_tcp_predec_21");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_min_predec_42()).runTest("CWE191_Integer_Underflow__byte_min_predec_42");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_URLConnection_predec_73a()).runTest("CWE191_Integer_Underflow__int_URLConnection_predec_73a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_min_predec_16()).runTest("CWE191_Integer_Underflow__long_min_predec_16");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_rand_predec_13()).runTest("CWE191_Integer_Underflow__long_rand_predec_13");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_min_predec_04()).runTest("CWE191_Integer_Underflow__long_min_predec_04");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_connect_tcp_predec_68a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_predec_68a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_rand_predec_08()).runTest("CWE191_Integer_Underflow__short_rand_predec_08");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_random_predec_06()).runTest("CWE191_Integer_Underflow__int_random_predec_06");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_min_predec_51a()).runTest("CWE191_Integer_Underflow__byte_min_predec_51a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Environment_predec_03()).runTest("CWE191_Integer_Underflow__int_Environment_predec_03");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_database_predec_51a()).runTest("CWE191_Integer_Underflow__int_database_predec_51a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_min_predec_45()).runTest("CWE191_Integer_Underflow__long_min_predec_45");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_listen_tcp_predec_52a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_predec_52a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_random_predec_42()).runTest("CWE191_Integer_Underflow__int_random_predec_42");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_rand_predec_04()).runTest("CWE191_Integer_Underflow__short_rand_predec_04");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_console_readLine_predec_13()).runTest("CWE191_Integer_Underflow__short_console_readLine_predec_13");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_random_predec_14()).runTest("CWE191_Integer_Underflow__int_random_predec_14");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_min_predec_07()).runTest("CWE191_Integer_Underflow__long_min_predec_07");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_random_predec_81a()).runTest("CWE191_Integer_Underflow__int_random_predec_81a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_console_readLine_predec_53a()).runTest("CWE191_Integer_Underflow__short_console_readLine_predec_53a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_console_readLine_predec_61a()).runTest("CWE191_Integer_Underflow__short_console_readLine_predec_61a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_min_predec_17()).runTest("CWE191_Integer_Underflow__long_min_predec_17");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_PropertiesFile_predec_07()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_predec_07");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_rand_predec_12()).runTest("CWE191_Integer_Underflow__short_rand_predec_12");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Property_predec_53a()).runTest("CWE191_Integer_Underflow__int_Property_predec_53a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_connect_tcp_predec_53a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_predec_53a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_min_predec_81a()).runTest("CWE191_Integer_Underflow__long_min_predec_81a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_database_predec_04()).runTest("CWE191_Integer_Underflow__int_database_predec_04");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_rand_predec_67a()).runTest("CWE191_Integer_Underflow__long_rand_predec_67a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_database_predec_07()).runTest("CWE191_Integer_Underflow__int_database_predec_07");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_min_predec_71a()).runTest("CWE191_Integer_Underflow__int_min_predec_71a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_rand_predec_61a()).runTest("CWE191_Integer_Underflow__byte_rand_predec_61a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_listen_tcp_predec_75a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_predec_75a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_min_predec_66a()).runTest("CWE191_Integer_Underflow__byte_min_predec_66a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_listen_tcp_predec_67a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_predec_67a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_rand_predec_71a()).runTest("CWE191_Integer_Underflow__byte_rand_predec_71a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_PropertiesFile_predec_22a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_predec_22a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_rand_predec_31()).runTest("CWE191_Integer_Underflow__long_rand_predec_31");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_console_readLine_predec_68a()).runTest("CWE191_Integer_Underflow__int_console_readLine_predec_68a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Environment_predec_41()).runTest("CWE191_Integer_Underflow__int_Environment_predec_41");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_console_readLine_predec_13()).runTest("CWE191_Integer_Underflow__int_console_readLine_predec_13");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_database_predec_08()).runTest("CWE191_Integer_Underflow__int_database_predec_08");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_min_predec_16()).runTest("CWE191_Integer_Underflow__int_min_predec_16");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Environment_predec_15()).runTest("CWE191_Integer_Underflow__int_Environment_predec_15");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_min_predec_75a()).runTest("CWE191_Integer_Underflow__long_min_predec_75a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_console_readLine_predec_68a()).runTest("CWE191_Integer_Underflow__short_console_readLine_predec_68a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_console_readLine_predec_41()).runTest("CWE191_Integer_Underflow__byte_console_readLine_predec_41");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_File_predec_17()).runTest("CWE191_Integer_Underflow__int_File_predec_17");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_database_predec_66a()).runTest("CWE191_Integer_Underflow__int_database_predec_66a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_listen_tcp_predec_17()).runTest("CWE191_Integer_Underflow__int_listen_tcp_predec_17");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Property_predec_81a()).runTest("CWE191_Integer_Underflow__int_Property_predec_81a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_console_readLine_predec_03()).runTest("CWE191_Integer_Underflow__int_console_readLine_predec_03");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_min_predec_05()).runTest("CWE191_Integer_Underflow__int_min_predec_05");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_listen_tcp_predec_14()).runTest("CWE191_Integer_Underflow__int_listen_tcp_predec_14");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_min_predec_42()).runTest("CWE191_Integer_Underflow__long_min_predec_42");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_PropertiesFile_predec_14()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_predec_14");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_File_predec_21()).runTest("CWE191_Integer_Underflow__int_File_predec_21");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_min_predec_04()).runTest("CWE191_Integer_Underflow__short_min_predec_04");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_min_predec_72a()).runTest("CWE191_Integer_Underflow__int_min_predec_72a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_URLConnection_predec_52a()).runTest("CWE191_Integer_Underflow__int_URLConnection_predec_52a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Property_predec_73a()).runTest("CWE191_Integer_Underflow__int_Property_predec_73a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_console_readLine_predec_05()).runTest("CWE191_Integer_Underflow__int_console_readLine_predec_05");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_listen_tcp_predec_02()).runTest("CWE191_Integer_Underflow__int_listen_tcp_predec_02");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Environment_predec_12()).runTest("CWE191_Integer_Underflow__int_Environment_predec_12");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_rand_predec_68a()).runTest("CWE191_Integer_Underflow__byte_rand_predec_68a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_min_predec_13()).runTest("CWE191_Integer_Underflow__long_min_predec_13");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_min_predec_12()).runTest("CWE191_Integer_Underflow__long_min_predec_12");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_console_readLine_predec_04()).runTest("CWE191_Integer_Underflow__int_console_readLine_predec_04");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_rand_predec_67a()).runTest("CWE191_Integer_Underflow__short_rand_predec_67a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_URLConnection_predec_22a()).runTest("CWE191_Integer_Underflow__int_URLConnection_predec_22a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_rand_predec_22a()).runTest("CWE191_Integer_Underflow__short_rand_predec_22a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Property_predec_10()).runTest("CWE191_Integer_Underflow__int_Property_predec_10");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_rand_predec_14()).runTest("CWE191_Integer_Underflow__byte_rand_predec_14");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_PropertiesFile_predec_67a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_predec_67a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_min_predec_73a()).runTest("CWE191_Integer_Underflow__long_min_predec_73a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_min_predec_51a()).runTest("CWE191_Integer_Underflow__long_min_predec_51a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_database_predec_31()).runTest("CWE191_Integer_Underflow__int_database_predec_31");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_min_predec_12()).runTest("CWE191_Integer_Underflow__byte_min_predec_12");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_rand_predec_03()).runTest("CWE191_Integer_Underflow__long_rand_predec_03");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_min_predec_07()).runTest("CWE191_Integer_Underflow__int_min_predec_07");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_database_predec_74a()).runTest("CWE191_Integer_Underflow__int_database_predec_74a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_min_predec_74a()).runTest("CWE191_Integer_Underflow__short_min_predec_74a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Environment_predec_71a()).runTest("CWE191_Integer_Underflow__int_Environment_predec_71a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_File_predec_01()).runTest("CWE191_Integer_Underflow__int_File_predec_01");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_console_readLine_predec_02()).runTest("CWE191_Integer_Underflow__byte_console_readLine_predec_02");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_PropertiesFile_predec_09()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_predec_09");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_rand_predec_09()).runTest("CWE191_Integer_Underflow__byte_rand_predec_09");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_min_predec_09()).runTest("CWE191_Integer_Underflow__long_min_predec_09");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_connect_tcp_predec_73a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_predec_73a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_min_predec_54a()).runTest("CWE191_Integer_Underflow__byte_min_predec_54a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_random_predec_74a()).runTest("CWE191_Integer_Underflow__int_random_predec_74a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_rand_predec_41()).runTest("CWE191_Integer_Underflow__long_rand_predec_41");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_rand_predec_07()).runTest("CWE191_Integer_Underflow__short_rand_predec_07");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_min_predec_61a()).runTest("CWE191_Integer_Underflow__long_min_predec_61a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Property_predec_12()).runTest("CWE191_Integer_Underflow__int_Property_predec_12");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_min_predec_17()).runTest("CWE191_Integer_Underflow__byte_min_predec_17");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_File_predec_10()).runTest("CWE191_Integer_Underflow__int_File_predec_10");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_console_readLine_predec_52a()).runTest("CWE191_Integer_Underflow__int_console_readLine_predec_52a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_rand_predec_53a()).runTest("CWE191_Integer_Underflow__short_rand_predec_53a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_rand_predec_16()).runTest("CWE191_Integer_Underflow__long_rand_predec_16");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_URLConnection_predec_71a()).runTest("CWE191_Integer_Underflow__int_URLConnection_predec_71a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_console_readLine_predec_51a()).runTest("CWE191_Integer_Underflow__long_console_readLine_predec_51a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_connect_tcp_predec_67a()).runTest("CWE191_Integer_Underflow__int_connect_tcp_predec_67a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_console_readLine_predec_72a()).runTest("CWE191_Integer_Underflow__int_console_readLine_predec_72a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_PropertiesFile_predec_71a()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_predec_71a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Property_predec_08()).runTest("CWE191_Integer_Underflow__int_Property_predec_08");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_listen_tcp_predec_74a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_predec_74a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_File_predec_66a()).runTest("CWE191_Integer_Underflow__int_File_predec_66a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_URLConnection_predec_54a()).runTest("CWE191_Integer_Underflow__int_URLConnection_predec_54a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_rand_predec_06()).runTest("CWE191_Integer_Underflow__short_rand_predec_06");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_File_predec_12()).runTest("CWE191_Integer_Underflow__int_File_predec_12");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_listen_tcp_predec_08()).runTest("CWE191_Integer_Underflow__int_listen_tcp_predec_08");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_PropertiesFile_predec_03()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_predec_03");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_rand_predec_53a()).runTest("CWE191_Integer_Underflow__byte_rand_predec_53a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_listen_tcp_predec_71a()).runTest("CWE191_Integer_Underflow__int_listen_tcp_predec_71a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_rand_predec_03()).runTest("CWE191_Integer_Underflow__byte_rand_predec_03");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_min_predec_74a()).runTest("CWE191_Integer_Underflow__byte_min_predec_74a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_rand_predec_07()).runTest("CWE191_Integer_Underflow__byte_rand_predec_07");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_listen_tcp_predec_31()).runTest("CWE191_Integer_Underflow__int_listen_tcp_predec_31");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_PropertiesFile_predec_10()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_predec_10");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_console_readLine_predec_01()).runTest("CWE191_Integer_Underflow__long_console_readLine_predec_01");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_File_predec_42()).runTest("CWE191_Integer_Underflow__int_File_predec_42");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__byte_min_predec_15()).runTest("CWE191_Integer_Underflow__byte_min_predec_15");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_min_predec_22a()).runTest("CWE191_Integer_Underflow__short_min_predec_22a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_min_predec_51a()).runTest("CWE191_Integer_Underflow__short_min_predec_51a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_Environment_predec_31()).runTest("CWE191_Integer_Underflow__int_Environment_predec_31");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__long_console_readLine_predec_04()).runTest("CWE191_Integer_Underflow__long_console_readLine_predec_04");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_URLConnection_predec_42()).runTest("CWE191_Integer_Underflow__int_URLConnection_predec_42");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_min_predec_75a()).runTest("CWE191_Integer_Underflow__short_min_predec_75a");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_min_predec_02()).runTest("CWE191_Integer_Underflow__int_min_predec_02");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_PropertiesFile_predec_31()).runTest("CWE191_Integer_Underflow__int_PropertiesFile_predec_31");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__int_listen_tcp_predec_05()).runTest("CWE191_Integer_Underflow__int_listen_tcp_predec_05");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_rand_predec_16()).runTest("CWE191_Integer_Underflow__short_rand_predec_16");
			(new testcases.CWE191_Integer_Underflow.s05.CWE191_Integer_Underflow__short_console_readLine_predec_75a()).runTest("CWE191_Integer_Underflow__short_console_readLine_predec_75a");
			/* END-AUTOGENERATED-JAVA-TESTS-1 */
}

private static void runTestCWE2() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-2 */

			/* END-AUTOGENERATED-JAVA-TESTS-2 */
}

private static void runTestCWE3() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-3 */

			/* END-AUTOGENERATED-JAVA-TESTS-3 */
}

private static void runTestCWE4() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-4 */

			/* END-AUTOGENERATED-JAVA-TESTS-4 */
}

private static void runTestCWE5() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-5 */

			/* END-AUTOGENERATED-JAVA-TESTS-5 */
}

private static void runTestCWE6() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-6 */

			/* END-AUTOGENERATED-JAVA-TESTS-6 */
}

private static void runTestCWE7() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-7 */

			/* END-AUTOGENERATED-JAVA-TESTS-7 */
}

private static void runTestCWE8() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-8 */

			/* END-AUTOGENERATED-JAVA-TESTS-8 */
}

private static void runTestCWE9() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-9 */

			/* END-AUTOGENERATED-JAVA-TESTS-9 */
}
}