package testcases.CWE193_Off_by_One_Error;

import testcasesupport.*;

public class Main {

	public static void main(String[] args) {
		
		if(args.length != 0) {
		
			if(args[0].equals("-h") || args[0].equals("--help")) {
		
				System.err.println("To use this main, you can either run the program with no " +
				"command line arguments to run all test cases or you can specify one or more classes to test");
				System.err.println("For example:");
				System.err.println("java testcasesupport.Main testcases.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference.custom_function.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference__custom_function_01 testcases.CWE481_Assigning_instead_of_Comparing.bool.CWE481_Assigning_instead_of_Comparing__bool_01");
				System.exit(1);
			}
			
			/* User supplied some class names on the command line, just use those with introspection
			 *
			 * String classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
			 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
 			 * could read class names from command line or use
			 * http://sadun-util.sourceforge.net/api/org/sadun/util/
			 * ClassPackageExplorer.html
			 */

			for (String className : args) {

				try {
					
					/* String classNameWithPackage = "testcases." + className; */
					
					/* IO.writeLine("classNameWithPackage = " + classNameWithPackage); */

					Class<?> myClass = Class.forName(className);

					AbstractTestCase myObject = (AbstractTestCase) myClass
							.newInstance();

					myObject.runTest(className);

				} catch (Exception ex) {

					IO.writeLine("Could not run test for class " + className);
					ex.printStackTrace();

				}
				
				IO.writeLine(""); /* leave a blank line between classes */

			}

		} else {
		
			/* No command line args were used, we want to run every testcase */
			
			/* needed to separate these calls into other methods because
			   we were running into the size limit Java has for a single method */
			runTestCWE1();
			runTestCWE2();
			runTestCWE3();
			runTestCWE4();
			runTestCWE5();
			runTestCWE6();
			runTestCWE7();
			runTestCWE8();
			runTestCWE9();
		}			
	}

private static void runTestCWE1() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-1 */
			(new testcases.CWE193_Off_by_One_Error.CWE193_Off_by_One_Error__while_16()).runTest("CWE193_Off_by_One_Error__while_16");
			(new testcases.CWE193_Off_by_One_Error.CWE193_Off_by_One_Error__do_09()).runTest("CWE193_Off_by_One_Error__do_09");
			(new testcases.CWE193_Off_by_One_Error.CWE193_Off_by_One_Error__for_14()).runTest("CWE193_Off_by_One_Error__for_14");
			(new testcases.CWE193_Off_by_One_Error.CWE193_Off_by_One_Error__while_10()).runTest("CWE193_Off_by_One_Error__while_10");
			(new testcases.CWE193_Off_by_One_Error.CWE193_Off_by_One_Error__do_13()).runTest("CWE193_Off_by_One_Error__do_13");
			(new testcases.CWE193_Off_by_One_Error.CWE193_Off_by_One_Error__while_01()).runTest("CWE193_Off_by_One_Error__while_01");
			(new testcases.CWE193_Off_by_One_Error.CWE193_Off_by_One_Error__for_02()).runTest("CWE193_Off_by_One_Error__for_02");
			(new testcases.CWE193_Off_by_One_Error.CWE193_Off_by_One_Error__for_15()).runTest("CWE193_Off_by_One_Error__for_15");
			(new testcases.CWE193_Off_by_One_Error.CWE193_Off_by_One_Error__do_12()).runTest("CWE193_Off_by_One_Error__do_12");
			(new testcases.CWE193_Off_by_One_Error.CWE193_Off_by_One_Error__for_10()).runTest("CWE193_Off_by_One_Error__for_10");
			(new testcases.CWE193_Off_by_One_Error.CWE193_Off_by_One_Error__do_04()).runTest("CWE193_Off_by_One_Error__do_04");
			(new testcases.CWE193_Off_by_One_Error.CWE193_Off_by_One_Error__while_02()).runTest("CWE193_Off_by_One_Error__while_02");
			(new testcases.CWE193_Off_by_One_Error.CWE193_Off_by_One_Error__while_07()).runTest("CWE193_Off_by_One_Error__while_07");
			(new testcases.CWE193_Off_by_One_Error.CWE193_Off_by_One_Error__while_17()).runTest("CWE193_Off_by_One_Error__while_17");
			(new testcases.CWE193_Off_by_One_Error.CWE193_Off_by_One_Error__for_12()).runTest("CWE193_Off_by_One_Error__for_12");
			(new testcases.CWE193_Off_by_One_Error.CWE193_Off_by_One_Error__while_11()).runTest("CWE193_Off_by_One_Error__while_11");
			(new testcases.CWE193_Off_by_One_Error.CWE193_Off_by_One_Error__for_04()).runTest("CWE193_Off_by_One_Error__for_04");
			(new testcases.CWE193_Off_by_One_Error.CWE193_Off_by_One_Error__do_07()).runTest("CWE193_Off_by_One_Error__do_07");
			(new testcases.CWE193_Off_by_One_Error.CWE193_Off_by_One_Error__for_06()).runTest("CWE193_Off_by_One_Error__for_06");
			(new testcases.CWE193_Off_by_One_Error.CWE193_Off_by_One_Error__while_09()).runTest("CWE193_Off_by_One_Error__while_09");
			(new testcases.CWE193_Off_by_One_Error.CWE193_Off_by_One_Error__for_16()).runTest("CWE193_Off_by_One_Error__for_16");
			(new testcases.CWE193_Off_by_One_Error.CWE193_Off_by_One_Error__do_01()).runTest("CWE193_Off_by_One_Error__do_01");
			(new testcases.CWE193_Off_by_One_Error.CWE193_Off_by_One_Error__for_01()).runTest("CWE193_Off_by_One_Error__for_01");
			(new testcases.CWE193_Off_by_One_Error.CWE193_Off_by_One_Error__for_07()).runTest("CWE193_Off_by_One_Error__for_07");
			(new testcases.CWE193_Off_by_One_Error.CWE193_Off_by_One_Error__do_10()).runTest("CWE193_Off_by_One_Error__do_10");
			(new testcases.CWE193_Off_by_One_Error.CWE193_Off_by_One_Error__while_12()).runTest("CWE193_Off_by_One_Error__while_12");
			(new testcases.CWE193_Off_by_One_Error.CWE193_Off_by_One_Error__while_04()).runTest("CWE193_Off_by_One_Error__while_04");
			(new testcases.CWE193_Off_by_One_Error.CWE193_Off_by_One_Error__while_13()).runTest("CWE193_Off_by_One_Error__while_13");
			(new testcases.CWE193_Off_by_One_Error.CWE193_Off_by_One_Error__do_15()).runTest("CWE193_Off_by_One_Error__do_15");
			(new testcases.CWE193_Off_by_One_Error.CWE193_Off_by_One_Error__do_11()).runTest("CWE193_Off_by_One_Error__do_11");
			(new testcases.CWE193_Off_by_One_Error.CWE193_Off_by_One_Error__while_05()).runTest("CWE193_Off_by_One_Error__while_05");
			(new testcases.CWE193_Off_by_One_Error.CWE193_Off_by_One_Error__for_05()).runTest("CWE193_Off_by_One_Error__for_05");
			(new testcases.CWE193_Off_by_One_Error.CWE193_Off_by_One_Error__for_03()).runTest("CWE193_Off_by_One_Error__for_03");
			(new testcases.CWE193_Off_by_One_Error.CWE193_Off_by_One_Error__do_02()).runTest("CWE193_Off_by_One_Error__do_02");
			(new testcases.CWE193_Off_by_One_Error.CWE193_Off_by_One_Error__while_15()).runTest("CWE193_Off_by_One_Error__while_15");
			(new testcases.CWE193_Off_by_One_Error.CWE193_Off_by_One_Error__for_13()).runTest("CWE193_Off_by_One_Error__for_13");
			(new testcases.CWE193_Off_by_One_Error.CWE193_Off_by_One_Error__for_09()).runTest("CWE193_Off_by_One_Error__for_09");
			(new testcases.CWE193_Off_by_One_Error.CWE193_Off_by_One_Error__while_14()).runTest("CWE193_Off_by_One_Error__while_14");
			(new testcases.CWE193_Off_by_One_Error.CWE193_Off_by_One_Error__do_06()).runTest("CWE193_Off_by_One_Error__do_06");
			(new testcases.CWE193_Off_by_One_Error.CWE193_Off_by_One_Error__while_03()).runTest("CWE193_Off_by_One_Error__while_03");
			(new testcases.CWE193_Off_by_One_Error.CWE193_Off_by_One_Error__do_08()).runTest("CWE193_Off_by_One_Error__do_08");
			(new testcases.CWE193_Off_by_One_Error.CWE193_Off_by_One_Error__do_14()).runTest("CWE193_Off_by_One_Error__do_14");
			(new testcases.CWE193_Off_by_One_Error.CWE193_Off_by_One_Error__do_05()).runTest("CWE193_Off_by_One_Error__do_05");
			(new testcases.CWE193_Off_by_One_Error.CWE193_Off_by_One_Error__while_06()).runTest("CWE193_Off_by_One_Error__while_06");
			(new testcases.CWE193_Off_by_One_Error.CWE193_Off_by_One_Error__do_17()).runTest("CWE193_Off_by_One_Error__do_17");
			(new testcases.CWE193_Off_by_One_Error.CWE193_Off_by_One_Error__for_17()).runTest("CWE193_Off_by_One_Error__for_17");
			(new testcases.CWE193_Off_by_One_Error.CWE193_Off_by_One_Error__for_08()).runTest("CWE193_Off_by_One_Error__for_08");
			(new testcases.CWE193_Off_by_One_Error.CWE193_Off_by_One_Error__do_16()).runTest("CWE193_Off_by_One_Error__do_16");
			(new testcases.CWE193_Off_by_One_Error.CWE193_Off_by_One_Error__for_11()).runTest("CWE193_Off_by_One_Error__for_11");
			(new testcases.CWE193_Off_by_One_Error.CWE193_Off_by_One_Error__while_08()).runTest("CWE193_Off_by_One_Error__while_08");
			(new testcases.CWE193_Off_by_One_Error.CWE193_Off_by_One_Error__do_03()).runTest("CWE193_Off_by_One_Error__do_03");
			/* END-AUTOGENERATED-JAVA-TESTS-1 */
}

private static void runTestCWE2() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-2 */

			/* END-AUTOGENERATED-JAVA-TESTS-2 */
}

private static void runTestCWE3() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-3 */

			/* END-AUTOGENERATED-JAVA-TESTS-3 */
}

private static void runTestCWE4() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-4 */

			/* END-AUTOGENERATED-JAVA-TESTS-4 */
}

private static void runTestCWE5() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-5 */

			/* END-AUTOGENERATED-JAVA-TESTS-5 */
}

private static void runTestCWE6() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-6 */

			/* END-AUTOGENERATED-JAVA-TESTS-6 */
}

private static void runTestCWE7() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-7 */

			/* END-AUTOGENERATED-JAVA-TESTS-7 */
}

private static void runTestCWE8() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-8 */

			/* END-AUTOGENERATED-JAVA-TESTS-8 */
}

private static void runTestCWE9() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-9 */

			/* END-AUTOGENERATED-JAVA-TESTS-9 */
}
}