package testcases.CWE197_Numeric_Truncation_Error.s01;

import testcasesupport.*;

public class Main {

	public static void main(String[] args) {
		
		if(args.length != 0) {
		
			if(args[0].equals("-h") || args[0].equals("--help")) {
		
				System.err.println("To use this main, you can either run the program with no " +
				"command line arguments to run all test cases or you can specify one or more classes to test");
				System.err.println("For example:");
				System.err.println("java testcasesupport.Main testcases.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference.custom_function.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference__custom_function_01 testcases.CWE481_Assigning_instead_of_Comparing.bool.CWE481_Assigning_instead_of_Comparing__bool_01");
				System.exit(1);
			}
			
			/* User supplied some class names on the command line, just use those with introspection
			 *
			 * String classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
			 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
 			 * could read class names from command line or use
			 * http://sadun-util.sourceforge.net/api/org/sadun/util/
			 * ClassPackageExplorer.html
			 */

			for (String className : args) {

				try {
					
					/* String classNameWithPackage = "testcases." + className; */
					
					/* IO.writeLine("classNameWithPackage = " + classNameWithPackage); */

					Class<?> myClass = Class.forName(className);

					AbstractTestCase myObject = (AbstractTestCase) myClass
							.newInstance();

					myObject.runTest(className);

				} catch (Exception ex) {

					IO.writeLine("Could not run test for class " + className);
					ex.printStackTrace();

				}
				
				IO.writeLine(""); /* leave a blank line between classes */

			}

		} else {
		
			/* No command line args were used, we want to run every testcase */
			
			/* needed to separate these calls into other methods because
			   we were running into the size limit Java has for a single method */
			runTestCWE1();
			runTestCWE2();
			runTestCWE3();
			runTestCWE4();
			runTestCWE5();
			runTestCWE6();
			runTestCWE7();
			runTestCWE8();
			runTestCWE9();
		}			
	}

private static void runTestCWE1() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-1 */
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_short_21()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_short_21");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_byte_75a()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_75a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_71a()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_71a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_byte_16()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_byte_16");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_short_53a()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_53a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_08()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_08");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_byte_16()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_16");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_short_66a()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_short_66a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_51a()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_51a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_51a()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_51a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_short_09()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_short_09");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_short_03()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_short_03");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_short_52a()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_52a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_byte_17()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_17");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_byte_73a()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_73a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_52a()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_52a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_byte_52a()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_52a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_byte_67a()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_67a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_short_15()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_short_15");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_45()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_45");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_54a()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_54a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_byte_66a()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_66a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_04()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_04");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_short_03()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_short_03");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_05()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_05");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_22a()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_22a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_17()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_17");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_10()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_10");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_short_14()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_14");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_52a()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_52a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_11()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_11");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_14()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_14");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_52a()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_52a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_67a()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_67a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_byte_14()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_14");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_66a()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_66a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_short_61a()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_short_61a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_byte_14()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_14");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_71a()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_71a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_byte_61a()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_61a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_72a()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_72a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_41()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_41");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_byte_07()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_byte_07");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_byte_73a()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_73a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_09()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_09");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_68a()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_68a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_short_15()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_15");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_06()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_06");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_byte_61a()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_61a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_byte_09()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_09");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_short_08()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_08");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_short_05()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_short_05");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_short_74a()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_short_74a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_byte_08()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_byte_08");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_byte_11()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_11");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_short_06()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_short_06");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_73a()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_73a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_byte_61a()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_61a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_04()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_04");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_41()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_41");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_73a()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_73a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_71a()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_71a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_75a()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_75a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_10()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_10");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_09()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_09");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_74a()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_74a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_67a()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_67a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_17()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_17");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_07()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_07");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_short_21()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_21");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_51a()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_51a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_15()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_15");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_byte_68a()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_68a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_short_42()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_short_42");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_05()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_05");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_08()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_08");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_05()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_05");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_67a()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_67a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_68a()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_68a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_42()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_42");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_13()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_13");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_54a()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_54a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_14()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_14");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_13()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_13");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_short_45()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_short_45");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_22a()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_22a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_short_22a()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_short_22a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_short_71a()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_short_71a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_14()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_14");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_53a()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_53a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_short_42()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_short_42");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_short_81a()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_short_81a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_12()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_12");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_68a()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_68a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_81a()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_81a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_11()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_11");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_short_72a()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_short_72a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_72a()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_72a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_73a()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_73a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_byte_61a()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_byte_61a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_byte_15()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_15");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_byte_11()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_byte_11");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_short_41()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_short_41");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_06()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_06");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_short_66a()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_short_66a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_75a()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_75a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_17()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_17");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_byte_04()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_04");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_byte_31()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_31");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_02()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_02");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_short_05()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_short_05");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_75a()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_75a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_21()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_21");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_04()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_04");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_byte_02()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_02");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_short_17()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_short_17");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_53a()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_53a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_short_75a()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_75a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_31()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_31");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_66a()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_66a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_byte_74a()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_74a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_11()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_11");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_72a()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_72a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_72a()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_72a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_16()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_16");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_10()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_10");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_17()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_17");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_74a()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_74a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_short_22a()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_22a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_short_02()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_short_02");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_byte_31()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_31");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_short_75a()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_short_75a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_81a()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_81a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_byte_75a()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_75a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_byte_13()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_13");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_42()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_42");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_53a()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_53a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_22a()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_22a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_byte_42()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_42");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_short_12()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_short_12");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_byte_06()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_06");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_short_09()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_09");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_byte_15()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_15");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_byte_09()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_09");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_short_15()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_short_15");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_byte_09()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_09");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_03()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_03");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_short_04()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_short_04");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_short_14()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_short_14");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_08()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_08");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_41()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_41");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_byte_81a()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_81a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_52a()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_52a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_short_54a()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_short_54a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_06()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_06");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_73a()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_73a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_short_03()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_03");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_byte_53a()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_53a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_short_08()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_short_08");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_54a()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_54a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_02()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_02");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_12()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_12");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_byte_11()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_11");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_byte_21()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_21");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_02()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_02");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_short_74a()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_short_74a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_byte_03()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_byte_03");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_short_73a()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_73a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_45()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_45");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_16()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_16");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_short_03()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_short_03");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_13()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_13");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_byte_67a()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_byte_67a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_byte_22a()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_22a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_13()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_13");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_41()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_41");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_short_54a()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_short_54a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_short_61a()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_short_61a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_45()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_45");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_short_81a()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_short_81a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_short_14()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_short_14");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_short_42()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_short_42");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_short_72a()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_short_72a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_short_31()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_31");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_01()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_01");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_short_01()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_short_01");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_14()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_14");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_short_72a()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_short_72a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_byte_81a()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_81a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_byte_14()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_byte_14");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_09()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_09");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_short_81a()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_81a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_16()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_16");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_byte_51a()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_51a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_13()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_13");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_byte_12()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_12");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_21()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_21");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_09()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_09");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_13()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_13");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_byte_54a()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_byte_54a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_21()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_21");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_byte_13()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_13");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_12()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_12");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_81a()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_81a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_byte_31()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_byte_31");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_41()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_41");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_05()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_05");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_byte_75a()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_byte_75a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_short_16()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_short_16");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_21()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_21");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_03()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_03");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_45()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_45");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_31()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_31");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_byte_12()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_12");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_byte_72a()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_72a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_short_16()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_short_16");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_81a()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_81a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_66a()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_66a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_short_53a()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_short_53a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_04()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_04");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_03()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_03");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_short_04()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_short_04");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_21()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_21");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_short_51a()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_short_51a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_66a()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_66a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_54a()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_54a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_byte_66a()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_66a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_21()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_21");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_byte_68a()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_68a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_byte_53a()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_53a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_byte_45()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_45");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_byte_41()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_41");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_short_15()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_short_15");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_75a()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_75a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_22a()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_22a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_short_45()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_short_45");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_short_75a()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_short_75a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_45()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_45");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_byte_21()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_byte_21");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_byte_52a()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_byte_52a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_byte_74a()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_byte_74a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_short_74a()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_short_74a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_byte_01()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_01");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_byte_08()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_08");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_short_08()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_short_08");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_03()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_03");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_short_13()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_short_13");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_31()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_31");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_67a()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_67a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_04()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_04");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_75a()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_75a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_short_21()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_short_21");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_byte_17()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_17");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_short_41()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_41");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_51a()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_51a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_short_68a()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_68a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_short_17()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_short_17");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_byte_66a()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_byte_66a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_31()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_31");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_byte_71a()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_71a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_03()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_03");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_short_09()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_short_09");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_71a()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_71a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_short_31()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_short_31");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_71a()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_71a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_byte_04()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_byte_04");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_short_12()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_short_12");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_byte_71a()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_byte_71a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_short_52a()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_short_52a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_short_07()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_short_07");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_51a()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_51a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_02()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_02");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_74a()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_74a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_short_22a()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_short_22a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_31()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_31");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_short_52a()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_short_52a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_byte_67a()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_67a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_10()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_10");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_short_13()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_13");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_short_68a()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_short_68a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_42()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_42");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_22a()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_22a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_short_10()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_short_10");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_short_74a()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_74a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_byte_54a()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_54a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_short_11()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_short_11");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_byte_10()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_10");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_byte_06()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_byte_06");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_22a()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_22a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_73a()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_73a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_02()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_02");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_byte_45()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_45");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_02()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_02");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_03()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_03");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_short_72a()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_72a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_15()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_15");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_75a()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_75a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_short_73a()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_short_73a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_short_81a()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_short_81a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_short_75a()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_short_75a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_15()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_15");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_byte_71a()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_71a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_75a()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_75a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_16()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_16");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_byte_45()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_byte_45");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_short_05()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_short_05");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_16()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_16");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_74a()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_74a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_17()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_17");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_byte_22a()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_byte_22a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_45()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_45");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_71a()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_71a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_byte_53a()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_byte_53a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_byte_10()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_10");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_22a()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_22a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_03()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_03");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_71a()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_71a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_67a()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_67a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_short_51a()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_short_51a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_61a()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_61a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_byte_21()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_21");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_66a()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_66a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_short_06()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_short_06");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_byte_73a()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_73a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_byte_71a()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_71a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_byte_41()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_41");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_17()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_17");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_08()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_08");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_short_53a()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_short_53a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_66a()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_66a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_54a()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_54a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_byte_05()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_05");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_61a()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_61a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_byte_51a()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_51a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_41()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_41");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_08()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_08");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_byte_42()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_byte_42");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_byte_03()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_03");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_01()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_01");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_05()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_05");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_15()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_15");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_68a()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_68a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_66a()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_66a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_61a()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_61a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_byte_06()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_06");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_01()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_01");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_13()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_13");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_71a()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_71a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_byte_53a()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_53a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_42()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_42");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_short_21()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_short_21");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_11()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_11");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_byte_54a()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_54a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_byte_81a()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_81a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_byte_75a()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_75a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_10()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_10");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_byte_07()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_07");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_short_73a()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_short_73a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_06()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_06");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_short_01()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_short_01");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_03()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_03");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_11()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_11");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_short_12()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_short_12");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_byte_74a()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_74a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_byte_52a()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_52a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_short_31()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_short_31");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_byte_06()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_06");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_05()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_05");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_short_01()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_01");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_short_05()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_05");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_01()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_01");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_short_10()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_10");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_byte_42()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_42");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_01()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_01");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_72a()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_72a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_byte_72a()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_72a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_short_61a()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_61a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_short_54a()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_54a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_short_52a()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_short_52a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_15()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_15");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_byte_11()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_11");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_17()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_17");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_short_45()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_45");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_07()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_07");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_byte_13()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_byte_13");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_short_06()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_short_06");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_06()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_06");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_10()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_10");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_31()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_31");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_byte_10()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_byte_10");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_74a()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_74a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_short_41()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_short_41");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_12()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_12");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_short_67a()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_short_67a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_short_51a()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_51a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_42()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_42");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_01()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_01");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_byte_05()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_byte_05");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_byte_02()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_02");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_byte_05()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_05");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_66a()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_66a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_byte_04()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_04");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_byte_41()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_byte_41");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_07()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_07");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_byte_51a()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_byte_51a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_45()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_45");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_31()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_31");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_01()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_01");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_61a()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_61a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_14()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_14");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_07()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_07");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_14()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_14");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_byte_17()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_byte_17");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_short_12()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_12");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_21()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_21");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_byte_15()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_15");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_short_13()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_short_13");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_byte_81a()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_byte_81a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_short_06()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_06");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_15()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_15");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_07()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_07");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_short_13()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_short_13");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_53a()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_53a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_byte_01()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_01");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_short_02()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_short_02");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_31()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_31");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_04()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_04");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_72a()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_72a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_byte_72a()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_byte_72a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_04()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_04");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_short_02()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_02");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_53a()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_53a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_short_67a()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_short_67a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_byte_13()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_13");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_short_66a()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_66a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_byte_54a()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_54a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_short_17()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_17");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_short_14()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_short_14");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_short_11()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_11");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_byte_02()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_byte_02");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_12()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_12");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_short_68a()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_short_68a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_53a()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_53a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_73a()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_73a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_short_67a()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_short_67a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_byte_01()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_byte_01");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_short_45()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_short_45");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_byte_03()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_03");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_byte_22a()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_22a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_short_04()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_04");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_short_09()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_short_09");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_byte_05()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_05");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_11()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_11");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_04()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_04");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_10()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_10");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_72a()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_72a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_09()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_09");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_52a()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_52a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_byte_12()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_12");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_07()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_07");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_12()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_12");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_short_10()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_short_10");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_14()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_14");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_06()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_06");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_08()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_08");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_short_71a()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_71a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_byte_41()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_41");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_byte_68a()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_68a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_short_71a()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_short_71a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_short_73a()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_short_73a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_53a()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_53a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_67a()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_67a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_68a()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_68a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_06()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_06");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_14()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_14");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_byte_08()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_08");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_12()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_12");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_byte_68a()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_byte_68a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_byte_08()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_08");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_61a()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_61a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_short_07()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_07");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_74a()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_74a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_short_42()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_42");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_byte_66a()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_66a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_16()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_16");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_51a()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_51a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_byte_22a()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_22a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_51a()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_51a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_short_61a()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_short_61a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_74a()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_74a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_10()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_10");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_short_16()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_short_16");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_byte_09()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_byte_09");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_07()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_07");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_81a()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_81a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_byte_15()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_byte_15");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_byte_02()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_02");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_17()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_17");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_51a()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_51a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_16()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_16");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_41()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_41");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_54a()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_54a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_short_41()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_short_41");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_byte_31()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_31");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_short_11()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_short_11");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_byte_14()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_14");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_short_04()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_short_04");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_02()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_02");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_short_17()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_short_17");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_byte_16()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_16");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_67a()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_67a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_68a()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_68a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_11()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_11");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_53a()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_53a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_73a()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_73a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_42()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_42");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_short_66a()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_short_66a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_short_07()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_short_07");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_81a()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_81a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_02()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_02");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_09()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_09");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_07()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_07");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_byte_17()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_17");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_81a()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_81a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_54a()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_54a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_52a()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_52a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_08()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_08");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_byte_21()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_21");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_short_11()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_short_11");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_byte_07()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_07");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_byte_52a()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_52a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_short_71a()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_short_71a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_06()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_06");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_45()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_45");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_05()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_05");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_01()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_01");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_41()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_41");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_short_51a()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_short_51a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_81a()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_81a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_byte_72a()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_72a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_61a()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_61a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_15()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_15");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_73a()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_73a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_byte_01()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_01");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_68a()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_68a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_short_01()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_short_01");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_42()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_42");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_short_07()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_short_07");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_short_08()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_short_08");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_12()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_12");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_short_10()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_short_10");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_16()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_16");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_short_31()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_short_31");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_byte_51a()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_51a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_byte_73a()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_byte_73a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_09()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_09");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_75a()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_75a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_short_02()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_short_02");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_54a()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_54a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_22a()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_22a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_byte_10()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_10");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_72a()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_72a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_09()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_09");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_68a()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_68a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_byte_74a()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_74a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_byte_42()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_42");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_byte_45()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_45");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_08()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_08");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_byte_12()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_byte_12");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_13()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_13");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_database_to_short_68a()).runTest("CWE197_Numeric_Truncation_Error__int_database_to_short_68a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_short_67a()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_67a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_74a()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_byte_74a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_short_16()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_16");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_byte_03()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_03");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_short_22a()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_short_22a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_byte_67a()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_67a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_15()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_short_15");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_42()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_42");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_short_53a()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_short_53a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_byte_04()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_04");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_Environment_to_byte_07()).runTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_07");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_File_to_byte_16()).runTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_16");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_05()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_05");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_52a()).runTest("CWE197_Numeric_Truncation_Error__int_PropertiesFile_to_byte_52a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_52a()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_52a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_21()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_short_21");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_large_to_short_54a()).runTest("CWE197_Numeric_Truncation_Error__int_large_to_short_54a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_67a()).runTest("CWE197_Numeric_Truncation_Error__int_console_readLine_to_short_67a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_61a()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_short_61a");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_11()).runTest("CWE197_Numeric_Truncation_Error__int_listen_tcp_to_byte_11");
			(new testcases.CWE197_Numeric_Truncation_Error.s01.CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_61a()).runTest("CWE197_Numeric_Truncation_Error__int_connect_tcp_to_byte_61a");
			/* END-AUTOGENERATED-JAVA-TESTS-1 */
}

private static void runTestCWE2() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-2 */

			/* END-AUTOGENERATED-JAVA-TESTS-2 */
}

private static void runTestCWE3() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-3 */

			/* END-AUTOGENERATED-JAVA-TESTS-3 */
}

private static void runTestCWE4() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-4 */

			/* END-AUTOGENERATED-JAVA-TESTS-4 */
}

private static void runTestCWE5() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-5 */

			/* END-AUTOGENERATED-JAVA-TESTS-5 */
}

private static void runTestCWE6() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-6 */

			/* END-AUTOGENERATED-JAVA-TESTS-6 */
}

private static void runTestCWE7() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-7 */

			/* END-AUTOGENERATED-JAVA-TESTS-7 */
}

private static void runTestCWE8() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-8 */

			/* END-AUTOGENERATED-JAVA-TESTS-8 */
}

private static void runTestCWE9() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-9 */

			/* END-AUTOGENERATED-JAVA-TESTS-9 */
}
}