package testcases.CWE197_Numeric_Truncation_Error.s02;

import testcasesupport.*;

public class Main {

	public static void main(String[] args) {
		
		if(args.length != 0) {
		
			if(args[0].equals("-h") || args[0].equals("--help")) {
		
				System.err.println("To use this main, you can either run the program with no " +
				"command line arguments to run all test cases or you can specify one or more classes to test");
				System.err.println("For example:");
				System.err.println("java testcasesupport.Main testcases.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference.custom_function.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference__custom_function_01 testcases.CWE481_Assigning_instead_of_Comparing.bool.CWE481_Assigning_instead_of_Comparing__bool_01");
				System.exit(1);
			}
			
			/* User supplied some class names on the command line, just use those with introspection
			 *
			 * String classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
			 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
 			 * could read class names from command line or use
			 * http://sadun-util.sourceforge.net/api/org/sadun/util/
			 * ClassPackageExplorer.html
			 */

			for (String className : args) {

				try {
					
					/* String classNameWithPackage = "testcases." + className; */
					
					/* IO.writeLine("classNameWithPackage = " + classNameWithPackage); */

					Class<?> myClass = Class.forName(className);

					AbstractTestCase myObject = (AbstractTestCase) myClass
							.newInstance();

					myObject.runTest(className);

				} catch (Exception ex) {

					IO.writeLine("Could not run test for class " + className);
					ex.printStackTrace();

				}
				
				IO.writeLine(""); /* leave a blank line between classes */

			}

		} else {
		
			/* No command line args were used, we want to run every testcase */
			
			/* needed to separate these calls into other methods because
			   we were running into the size limit Java has for a single method */
			runTestCWE1();
			runTestCWE2();
			runTestCWE3();
			runTestCWE4();
			runTestCWE5();
			runTestCWE6();
			runTestCWE7();
			runTestCWE8();
			runTestCWE9();
		}			
	}

private static void runTestCWE1() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-1 */
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_short_07()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_short_07");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_61a()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_61a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_short_04()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_short_04");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_byte_72a()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_byte_72a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_byte_09()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_byte_09");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_File_52a()).runTest("CWE197_Numeric_Truncation_Error__short_File_52a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_byte_81a()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_byte_81a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Property_61a()).runTest("CWE197_Numeric_Truncation_Error__short_Property_61a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_random_67a()).runTest("CWE197_Numeric_Truncation_Error__short_random_67a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_large_72a()).runTest("CWE197_Numeric_Truncation_Error__short_large_72a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_14()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_14");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_52a()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_52a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_short_68a()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_short_68a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_console_readLine_14()).runTest("CWE197_Numeric_Truncation_Error__short_console_readLine_14");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_short_31()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_short_31");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_database_03()).runTest("CWE197_Numeric_Truncation_Error__short_database_03");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Property_04()).runTest("CWE197_Numeric_Truncation_Error__short_Property_04");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_byte_52a()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_byte_52a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_81a()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_81a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_16()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_16");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_listen_tcp_08()).runTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_08");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_large_12()).runTest("CWE197_Numeric_Truncation_Error__short_large_12");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_connect_tcp_66a()).runTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_66a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_short_09()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_short_09");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_database_16()).runTest("CWE197_Numeric_Truncation_Error__short_database_16");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_13()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_13");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_random_61a()).runTest("CWE197_Numeric_Truncation_Error__short_random_61a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_random_51a()).runTest("CWE197_Numeric_Truncation_Error__short_random_51a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_console_readLine_11()).runTest("CWE197_Numeric_Truncation_Error__short_console_readLine_11");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_byte_08()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_byte_08");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_console_readLine_68a()).runTest("CWE197_Numeric_Truncation_Error__short_console_readLine_68a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Environment_66a()).runTest("CWE197_Numeric_Truncation_Error__short_Environment_66a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_byte_73a()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_byte_73a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_byte_66a()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_byte_66a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_File_04()).runTest("CWE197_Numeric_Truncation_Error__short_File_04");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_short_16()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_short_16");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_connect_tcp_02()).runTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_02");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_listen_tcp_81a()).runTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_81a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_01()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_01");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_75a()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_75a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_byte_21()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_byte_21");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_byte_68a()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_byte_68a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_connect_tcp_45()).runTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_45");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_database_61a()).runTest("CWE197_Numeric_Truncation_Error__short_database_61a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_random_45()).runTest("CWE197_Numeric_Truncation_Error__short_random_45");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_short_01()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_short_01");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Property_11()).runTest("CWE197_Numeric_Truncation_Error__short_Property_11");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_console_readLine_10()).runTest("CWE197_Numeric_Truncation_Error__short_console_readLine_10");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_byte_42()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_byte_42");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_66a()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_66a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_listen_tcp_22a()).runTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_22a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_random_13()).runTest("CWE197_Numeric_Truncation_Error__short_random_13");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_console_readLine_17()).runTest("CWE197_Numeric_Truncation_Error__short_console_readLine_17");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_console_readLine_04()).runTest("CWE197_Numeric_Truncation_Error__short_console_readLine_04");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_large_02()).runTest("CWE197_Numeric_Truncation_Error__short_large_02");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_byte_16()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_byte_16");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_large_07()).runTest("CWE197_Numeric_Truncation_Error__short_large_07");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_short_73a()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_short_73a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_database_15()).runTest("CWE197_Numeric_Truncation_Error__short_database_15");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_connect_tcp_53a()).runTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_53a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_console_readLine_15()).runTest("CWE197_Numeric_Truncation_Error__short_console_readLine_15");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_short_54a()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_short_54a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Property_15()).runTest("CWE197_Numeric_Truncation_Error__short_Property_15");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_short_51a()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_short_51a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_21()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_21");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_byte_15()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_byte_15");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_PropertiesFile_10()).runTest("CWE197_Numeric_Truncation_Error__short_PropertiesFile_10");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_random_12()).runTest("CWE197_Numeric_Truncation_Error__short_random_12");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_connect_tcp_13()).runTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_13");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Environment_81a()).runTest("CWE197_Numeric_Truncation_Error__short_Environment_81a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_random_53a()).runTest("CWE197_Numeric_Truncation_Error__short_random_53a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_connect_tcp_11()).runTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_11");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_08()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_08");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_listen_tcp_10()).runTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_10");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_45()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_45");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_File_45()).runTest("CWE197_Numeric_Truncation_Error__short_File_45");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_short_74a()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_short_74a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_console_readLine_05()).runTest("CWE197_Numeric_Truncation_Error__short_console_readLine_05");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Environment_74a()).runTest("CWE197_Numeric_Truncation_Error__short_Environment_74a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_console_readLine_52a()).runTest("CWE197_Numeric_Truncation_Error__short_console_readLine_52a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_connect_tcp_31()).runTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_31");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_console_readLine_71a()).runTest("CWE197_Numeric_Truncation_Error__short_console_readLine_71a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_byte_45()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_byte_45");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_listen_tcp_13()).runTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_13");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_large_01()).runTest("CWE197_Numeric_Truncation_Error__short_large_01");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_byte_13()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_byte_13");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_File_53a()).runTest("CWE197_Numeric_Truncation_Error__short_File_53a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_byte_51a()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_byte_51a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_short_71a()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_short_71a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_connect_tcp_16()).runTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_16");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_connect_tcp_68a()).runTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_68a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Property_71a()).runTest("CWE197_Numeric_Truncation_Error__short_Property_71a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_short_06()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_short_06");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_53a()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_53a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_short_16()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_short_16");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_10()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_10");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_PropertiesFile_51a()).runTest("CWE197_Numeric_Truncation_Error__short_PropertiesFile_51a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_byte_71a()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_byte_71a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_database_17()).runTest("CWE197_Numeric_Truncation_Error__short_database_17");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_database_11()).runTest("CWE197_Numeric_Truncation_Error__short_database_11");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Property_81a()).runTest("CWE197_Numeric_Truncation_Error__short_Property_81a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_72a()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_72a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_database_06()).runTest("CWE197_Numeric_Truncation_Error__short_database_06");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_large_06()).runTest("CWE197_Numeric_Truncation_Error__short_large_06");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_random_31()).runTest("CWE197_Numeric_Truncation_Error__short_random_31");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_console_readLine_02()).runTest("CWE197_Numeric_Truncation_Error__short_console_readLine_02");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_short_66a()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_short_66a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_PropertiesFile_74a()).runTest("CWE197_Numeric_Truncation_Error__short_PropertiesFile_74a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Environment_72a()).runTest("CWE197_Numeric_Truncation_Error__short_Environment_72a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_large_15()).runTest("CWE197_Numeric_Truncation_Error__short_large_15");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_listen_tcp_67a()).runTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_67a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_database_02()).runTest("CWE197_Numeric_Truncation_Error__short_database_02");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_database_72a()).runTest("CWE197_Numeric_Truncation_Error__short_database_72a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_listen_tcp_14()).runTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_14");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Property_13()).runTest("CWE197_Numeric_Truncation_Error__short_Property_13");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_byte_11()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_byte_11");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_short_68a()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_short_68a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_console_readLine_06()).runTest("CWE197_Numeric_Truncation_Error__short_console_readLine_06");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_PropertiesFile_15()).runTest("CWE197_Numeric_Truncation_Error__short_PropertiesFile_15");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Environment_05()).runTest("CWE197_Numeric_Truncation_Error__short_Environment_05");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_short_11()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_short_11");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_connect_tcp_14()).runTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_14");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_console_readLine_41()).runTest("CWE197_Numeric_Truncation_Error__short_console_readLine_41");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_connect_tcp_05()).runTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_05");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_short_13()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_short_13");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_database_81a()).runTest("CWE197_Numeric_Truncation_Error__short_database_81a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_short_14()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_short_14");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_File_11()).runTest("CWE197_Numeric_Truncation_Error__short_File_11");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Property_01()).runTest("CWE197_Numeric_Truncation_Error__short_Property_01");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_12()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_12");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_random_11()).runTest("CWE197_Numeric_Truncation_Error__short_random_11");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_06()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_06");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_short_71a()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_short_71a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_database_53a()).runTest("CWE197_Numeric_Truncation_Error__short_database_53a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_console_readLine_07()).runTest("CWE197_Numeric_Truncation_Error__short_console_readLine_07");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_random_17()).runTest("CWE197_Numeric_Truncation_Error__short_random_17");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_listen_tcp_75a()).runTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_75a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_68a()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_68a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_byte_81a()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_byte_81a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_console_readLine_08()).runTest("CWE197_Numeric_Truncation_Error__short_console_readLine_08");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_PropertiesFile_05()).runTest("CWE197_Numeric_Truncation_Error__short_PropertiesFile_05");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_short_15()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_short_15");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_File_15()).runTest("CWE197_Numeric_Truncation_Error__short_File_15");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Property_02()).runTest("CWE197_Numeric_Truncation_Error__short_Property_02");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_short_75a()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_short_75a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_PropertiesFile_31()).runTest("CWE197_Numeric_Truncation_Error__short_PropertiesFile_31");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_short_31()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_short_31");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_41()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_41");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_connect_tcp_08()).runTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_08");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Environment_53a()).runTest("CWE197_Numeric_Truncation_Error__short_Environment_53a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_console_readLine_09()).runTest("CWE197_Numeric_Truncation_Error__short_console_readLine_09");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_large_21()).runTest("CWE197_Numeric_Truncation_Error__short_large_21");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_database_73a()).runTest("CWE197_Numeric_Truncation_Error__short_database_73a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_81a()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_81a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_byte_74a()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_byte_74a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Environment_61a()).runTest("CWE197_Numeric_Truncation_Error__short_Environment_61a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Environment_15()).runTest("CWE197_Numeric_Truncation_Error__short_Environment_15");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_large_42()).runTest("CWE197_Numeric_Truncation_Error__short_large_42");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Property_42()).runTest("CWE197_Numeric_Truncation_Error__short_Property_42");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_random_72a()).runTest("CWE197_Numeric_Truncation_Error__short_random_72a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_byte_67a()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_byte_67a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_listen_tcp_11()).runTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_11");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_database_71a()).runTest("CWE197_Numeric_Truncation_Error__short_database_71a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_listen_tcp_41()).runTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_41");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_console_readLine_22a()).runTest("CWE197_Numeric_Truncation_Error__short_console_readLine_22a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_72a()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_72a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_17()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_17");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_large_08()).runTest("CWE197_Numeric_Truncation_Error__short_large_08");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_connect_tcp_09()).runTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_09");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_random_10()).runTest("CWE197_Numeric_Truncation_Error__short_random_10");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_11()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_11");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_console_readLine_74a()).runTest("CWE197_Numeric_Truncation_Error__short_console_readLine_74a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_short_12()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_short_12");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_File_13()).runTest("CWE197_Numeric_Truncation_Error__short_File_13");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_File_09()).runTest("CWE197_Numeric_Truncation_Error__short_File_09");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Property_53a()).runTest("CWE197_Numeric_Truncation_Error__short_Property_53a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_14()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_14");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_PropertiesFile_09()).runTest("CWE197_Numeric_Truncation_Error__short_PropertiesFile_09");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_byte_14()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_byte_14");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_listen_tcp_07()).runTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_07");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_File_17()).runTest("CWE197_Numeric_Truncation_Error__short_File_17");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_68a()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_68a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_short_10()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_short_10");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_console_readLine_21()).runTest("CWE197_Numeric_Truncation_Error__short_console_readLine_21");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_short_81a()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_short_81a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_large_41()).runTest("CWE197_Numeric_Truncation_Error__short_large_41");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_listen_tcp_45()).runTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_45");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_random_03()).runTest("CWE197_Numeric_Truncation_Error__short_random_03");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Environment_52a()).runTest("CWE197_Numeric_Truncation_Error__short_Environment_52a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_database_45()).runTest("CWE197_Numeric_Truncation_Error__short_database_45");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_connect_tcp_71a()).runTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_71a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_54a()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_54a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Property_45()).runTest("CWE197_Numeric_Truncation_Error__short_Property_45");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_File_66a()).runTest("CWE197_Numeric_Truncation_Error__short_File_66a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_short_03()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_short_03");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_short_08()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_short_08");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Environment_10()).runTest("CWE197_Numeric_Truncation_Error__short_Environment_10");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_byte_71a()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_byte_71a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_17()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_17");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_PropertiesFile_68a()).runTest("CWE197_Numeric_Truncation_Error__short_PropertiesFile_68a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_byte_04()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_byte_04");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_listen_tcp_52a()).runTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_52a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_short_03()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_short_03");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_large_14()).runTest("CWE197_Numeric_Truncation_Error__short_large_14");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_byte_14()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_byte_14");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_random_74a()).runTest("CWE197_Numeric_Truncation_Error__short_random_74a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Environment_08()).runTest("CWE197_Numeric_Truncation_Error__short_Environment_08");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_listen_tcp_54a()).runTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_54a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_listen_tcp_17()).runTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_17");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_connect_tcp_22a()).runTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_22a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_PropertiesFile_66a()).runTest("CWE197_Numeric_Truncation_Error__short_PropertiesFile_66a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_File_51a()).runTest("CWE197_Numeric_Truncation_Error__short_File_51a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_connect_tcp_21()).runTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_21");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_connect_tcp_81a()).runTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_81a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_connect_tcp_74a()).runTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_74a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Property_54a()).runTest("CWE197_Numeric_Truncation_Error__short_Property_54a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_connect_tcp_67a()).runTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_67a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_PropertiesFile_07()).runTest("CWE197_Numeric_Truncation_Error__short_PropertiesFile_07");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Property_14()).runTest("CWE197_Numeric_Truncation_Error__short_Property_14");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Environment_13()).runTest("CWE197_Numeric_Truncation_Error__short_Environment_13");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_console_readLine_12()).runTest("CWE197_Numeric_Truncation_Error__short_console_readLine_12");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_database_67a()).runTest("CWE197_Numeric_Truncation_Error__short_database_67a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_connect_tcp_15()).runTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_15");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_byte_54a()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_byte_54a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_22a()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_22a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_byte_73a()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_byte_73a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_short_22a()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_short_22a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_connect_tcp_72a()).runTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_72a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_database_22a()).runTest("CWE197_Numeric_Truncation_Error__short_database_22a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_byte_21()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_byte_21");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_42()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_42");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_PropertiesFile_22a()).runTest("CWE197_Numeric_Truncation_Error__short_PropertiesFile_22a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_listen_tcp_06()).runTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_06");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Environment_16()).runTest("CWE197_Numeric_Truncation_Error__short_Environment_16");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_06()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_06");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_byte_10()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_byte_10");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_large_68a()).runTest("CWE197_Numeric_Truncation_Error__short_large_68a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_byte_17()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_byte_17");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_large_54a()).runTest("CWE197_Numeric_Truncation_Error__short_large_54a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Environment_71a()).runTest("CWE197_Numeric_Truncation_Error__short_Environment_71a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_console_readLine_61a()).runTest("CWE197_Numeric_Truncation_Error__short_console_readLine_61a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_short_17()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_short_17");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_byte_45()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_byte_45");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_database_12()).runTest("CWE197_Numeric_Truncation_Error__short_database_12");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_random_52a()).runTest("CWE197_Numeric_Truncation_Error__short_random_52a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_large_52a()).runTest("CWE197_Numeric_Truncation_Error__short_large_52a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Environment_51a()).runTest("CWE197_Numeric_Truncation_Error__short_Environment_51a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Environment_04()).runTest("CWE197_Numeric_Truncation_Error__short_Environment_04");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_large_09()).runTest("CWE197_Numeric_Truncation_Error__short_large_09");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_short_11()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_short_11");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_console_readLine_72a()).runTest("CWE197_Numeric_Truncation_Error__short_console_readLine_72a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_connect_tcp_06()).runTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_06");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_random_71a()).runTest("CWE197_Numeric_Truncation_Error__short_random_71a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Environment_41()).runTest("CWE197_Numeric_Truncation_Error__short_Environment_41");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_byte_02()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_byte_02");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_51a()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_51a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_PropertiesFile_73a()).runTest("CWE197_Numeric_Truncation_Error__short_PropertiesFile_73a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Property_21()).runTest("CWE197_Numeric_Truncation_Error__short_Property_21");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_PropertiesFile_81a()).runTest("CWE197_Numeric_Truncation_Error__short_PropertiesFile_81a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_large_10()).runTest("CWE197_Numeric_Truncation_Error__short_large_10");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_short_54a()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_short_54a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_large_45()).runTest("CWE197_Numeric_Truncation_Error__short_large_45");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_File_61a()).runTest("CWE197_Numeric_Truncation_Error__short_File_61a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_byte_07()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_byte_07");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_03()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_03");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_File_71a()).runTest("CWE197_Numeric_Truncation_Error__short_File_71a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_byte_54a()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_byte_54a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Property_68a()).runTest("CWE197_Numeric_Truncation_Error__short_Property_68a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_File_06()).runTest("CWE197_Numeric_Truncation_Error__short_File_06");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_short_08()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_short_08");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_PropertiesFile_13()).runTest("CWE197_Numeric_Truncation_Error__short_PropertiesFile_13");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_PropertiesFile_67a()).runTest("CWE197_Numeric_Truncation_Error__short_PropertiesFile_67a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_short_22a()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_short_22a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_short_52a()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_short_52a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_09()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_09");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_connect_tcp_42()).runTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_42");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_short_10()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_short_10");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_byte_11()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_byte_11");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_16()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_16");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_connect_tcp_03()).runTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_03");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_byte_52a()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_byte_52a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_byte_08()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_byte_08");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_PropertiesFile_11()).runTest("CWE197_Numeric_Truncation_Error__short_PropertiesFile_11");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Property_05()).runTest("CWE197_Numeric_Truncation_Error__short_Property_05");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_File_05()).runTest("CWE197_Numeric_Truncation_Error__short_File_05");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_byte_67a()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_byte_67a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_byte_41()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_byte_41");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_PropertiesFile_52a()).runTest("CWE197_Numeric_Truncation_Error__short_PropertiesFile_52a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_10()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_10");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_listen_tcp_15()).runTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_15");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_listen_tcp_31()).runTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_31");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_byte_66a()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_byte_66a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_short_61a()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_short_61a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Environment_09()).runTest("CWE197_Numeric_Truncation_Error__short_Environment_09");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_byte_17()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_byte_17");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_67a()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_67a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_byte_61a()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_byte_61a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_75a()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_75a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_byte_42()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_byte_42");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_large_67a()).runTest("CWE197_Numeric_Truncation_Error__short_large_67a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_database_68a()).runTest("CWE197_Numeric_Truncation_Error__short_database_68a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_byte_07()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_byte_07");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_connect_tcp_54a()).runTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_54a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_listen_tcp_16()).runTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_16");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_15()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_15");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_File_73a()).runTest("CWE197_Numeric_Truncation_Error__short_File_73a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_database_08()).runTest("CWE197_Numeric_Truncation_Error__short_database_08");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Environment_07()).runTest("CWE197_Numeric_Truncation_Error__short_Environment_07");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_random_14()).runTest("CWE197_Numeric_Truncation_Error__short_random_14");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_connect_tcp_73a()).runTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_73a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_byte_10()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_byte_10");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_connect_tcp_61a()).runTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_61a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Property_67a()).runTest("CWE197_Numeric_Truncation_Error__short_Property_67a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_67a()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_67a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Property_03()).runTest("CWE197_Numeric_Truncation_Error__short_Property_03");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_File_14()).runTest("CWE197_Numeric_Truncation_Error__short_File_14");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_short_75a()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_short_75a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_console_readLine_42()).runTest("CWE197_Numeric_Truncation_Error__short_console_readLine_42");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_short_21()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_short_21");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_byte_75a()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_byte_75a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_66a()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_66a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_database_04()).runTest("CWE197_Numeric_Truncation_Error__short_database_04");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_connect_tcp_75a()).runTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_75a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_byte_06()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_byte_06");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_database_14()).runTest("CWE197_Numeric_Truncation_Error__short_database_14");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_PropertiesFile_41()).runTest("CWE197_Numeric_Truncation_Error__short_PropertiesFile_41");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Environment_03()).runTest("CWE197_Numeric_Truncation_Error__short_Environment_03");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_PropertiesFile_54a()).runTest("CWE197_Numeric_Truncation_Error__short_PropertiesFile_54a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_short_01()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_short_01");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Property_08()).runTest("CWE197_Numeric_Truncation_Error__short_Property_08");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_51a()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_51a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_random_04()).runTest("CWE197_Numeric_Truncation_Error__short_random_04");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_large_66a()).runTest("CWE197_Numeric_Truncation_Error__short_large_66a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_large_05()).runTest("CWE197_Numeric_Truncation_Error__short_large_05");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Environment_68a()).runTest("CWE197_Numeric_Truncation_Error__short_Environment_68a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_random_75a()).runTest("CWE197_Numeric_Truncation_Error__short_random_75a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_random_73a()).runTest("CWE197_Numeric_Truncation_Error__short_random_73a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_short_21()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_short_21");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_console_readLine_67a()).runTest("CWE197_Numeric_Truncation_Error__short_console_readLine_67a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_short_06()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_short_06");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_short_12()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_short_12");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_PropertiesFile_61a()).runTest("CWE197_Numeric_Truncation_Error__short_PropertiesFile_61a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_short_53a()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_short_53a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_random_22a()).runTest("CWE197_Numeric_Truncation_Error__short_random_22a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_13()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_13");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_random_08()).runTest("CWE197_Numeric_Truncation_Error__short_random_08");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_listen_tcp_53a()).runTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_53a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_byte_16()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_byte_16");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_File_03()).runTest("CWE197_Numeric_Truncation_Error__short_File_03");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_console_readLine_45()).runTest("CWE197_Numeric_Truncation_Error__short_console_readLine_45");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_02()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_02");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_database_07()).runTest("CWE197_Numeric_Truncation_Error__short_database_07");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_01()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_01");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_listen_tcp_09()).runTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_09");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_File_54a()).runTest("CWE197_Numeric_Truncation_Error__short_File_54a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_short_45()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_short_45");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_byte_22a()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_byte_22a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_short_67a()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_short_67a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_connect_tcp_51a()).runTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_51a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_large_17()).runTest("CWE197_Numeric_Truncation_Error__short_large_17");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_File_12()).runTest("CWE197_Numeric_Truncation_Error__short_File_12");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_22a()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_22a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_byte_05()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_byte_05");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_PropertiesFile_08()).runTest("CWE197_Numeric_Truncation_Error__short_PropertiesFile_08");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_05()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_05");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_PropertiesFile_75a()).runTest("CWE197_Numeric_Truncation_Error__short_PropertiesFile_75a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Property_75a()).runTest("CWE197_Numeric_Truncation_Error__short_Property_75a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_74a()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_74a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_PropertiesFile_16()).runTest("CWE197_Numeric_Truncation_Error__short_PropertiesFile_16");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_File_08()).runTest("CWE197_Numeric_Truncation_Error__short_File_08");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_File_41()).runTest("CWE197_Numeric_Truncation_Error__short_File_41");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_random_81a()).runTest("CWE197_Numeric_Truncation_Error__short_random_81a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_listen_tcp_21()).runTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_21");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_random_42()).runTest("CWE197_Numeric_Truncation_Error__short_random_42");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_console_readLine_13()).runTest("CWE197_Numeric_Truncation_Error__short_console_readLine_13");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_large_03()).runTest("CWE197_Numeric_Truncation_Error__short_large_03");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_File_68a()).runTest("CWE197_Numeric_Truncation_Error__short_File_68a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_short_51a()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_short_51a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_byte_53a()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_byte_53a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_PropertiesFile_02()).runTest("CWE197_Numeric_Truncation_Error__short_PropertiesFile_02");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Property_41()).runTest("CWE197_Numeric_Truncation_Error__short_Property_41");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_short_66a()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_short_66a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_short_41()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_short_41");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Environment_22a()).runTest("CWE197_Numeric_Truncation_Error__short_Environment_22a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Environment_31()).runTest("CWE197_Numeric_Truncation_Error__short_Environment_31");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_byte_75a()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_byte_75a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_random_41()).runTest("CWE197_Numeric_Truncation_Error__short_random_41");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_short_81a()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_short_81a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_large_11()).runTest("CWE197_Numeric_Truncation_Error__short_large_11");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_random_09()).runTest("CWE197_Numeric_Truncation_Error__short_random_09");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Environment_21()).runTest("CWE197_Numeric_Truncation_Error__short_Environment_21");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_listen_tcp_72a()).runTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_72a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_07()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_07");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_short_41()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_short_41");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_byte_68a()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_byte_68a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_File_10()).runTest("CWE197_Numeric_Truncation_Error__short_File_10");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_02()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_02");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_console_readLine_75a()).runTest("CWE197_Numeric_Truncation_Error__short_console_readLine_75a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_listen_tcp_66a()).runTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_66a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_short_05()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_short_05");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_byte_53a()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_byte_53a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_short_72a()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_short_72a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_listen_tcp_05()).runTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_05");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_12()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_12");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_console_readLine_16()).runTest("CWE197_Numeric_Truncation_Error__short_console_readLine_16");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_large_71a()).runTest("CWE197_Numeric_Truncation_Error__short_large_71a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_PropertiesFile_21()).runTest("CWE197_Numeric_Truncation_Error__short_PropertiesFile_21");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_random_21()).runTest("CWE197_Numeric_Truncation_Error__short_random_21");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Environment_06()).runTest("CWE197_Numeric_Truncation_Error__short_Environment_06");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_console_readLine_73a()).runTest("CWE197_Numeric_Truncation_Error__short_console_readLine_73a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_byte_01()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_byte_01");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_PropertiesFile_42()).runTest("CWE197_Numeric_Truncation_Error__short_PropertiesFile_42");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_byte_31()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_byte_31");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_database_66a()).runTest("CWE197_Numeric_Truncation_Error__short_database_66a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Property_51a()).runTest("CWE197_Numeric_Truncation_Error__short_Property_51a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_31()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_31");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_File_31()).runTest("CWE197_Numeric_Truncation_Error__short_File_31");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_listen_tcp_02()).runTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_02");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Property_10()).runTest("CWE197_Numeric_Truncation_Error__short_Property_10");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_random_15()).runTest("CWE197_Numeric_Truncation_Error__short_random_15");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Property_16()).runTest("CWE197_Numeric_Truncation_Error__short_Property_16");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Environment_42()).runTest("CWE197_Numeric_Truncation_Error__short_Environment_42");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_listen_tcp_73a()).runTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_73a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_database_05()).runTest("CWE197_Numeric_Truncation_Error__short_database_05");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_42()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_42");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_large_31()).runTest("CWE197_Numeric_Truncation_Error__short_large_31");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_short_02()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_short_02");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_short_15()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_short_15");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_File_22a()).runTest("CWE197_Numeric_Truncation_Error__short_File_22a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_database_10()).runTest("CWE197_Numeric_Truncation_Error__short_database_10");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_PropertiesFile_45()).runTest("CWE197_Numeric_Truncation_Error__short_PropertiesFile_45");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_connect_tcp_17()).runTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_17");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_console_readLine_51a()).runTest("CWE197_Numeric_Truncation_Error__short_console_readLine_51a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_File_16()).runTest("CWE197_Numeric_Truncation_Error__short_File_16");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_PropertiesFile_17()).runTest("CWE197_Numeric_Truncation_Error__short_PropertiesFile_17");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_byte_05()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_byte_05");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_listen_tcp_03()).runTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_03");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Environment_01()).runTest("CWE197_Numeric_Truncation_Error__short_Environment_01");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_byte_72a()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_byte_72a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_random_05()).runTest("CWE197_Numeric_Truncation_Error__short_random_05");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_large_13()).runTest("CWE197_Numeric_Truncation_Error__short_large_13");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_large_61a()).runTest("CWE197_Numeric_Truncation_Error__short_large_61a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Property_73a()).runTest("CWE197_Numeric_Truncation_Error__short_Property_73a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_random_06()).runTest("CWE197_Numeric_Truncation_Error__short_random_06");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Property_66a()).runTest("CWE197_Numeric_Truncation_Error__short_Property_66a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Property_12()).runTest("CWE197_Numeric_Truncation_Error__short_Property_12");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_listen_tcp_51a()).runTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_51a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_short_42()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_short_42");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_short_74a()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_short_74a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Property_52a()).runTest("CWE197_Numeric_Truncation_Error__short_Property_52a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_console_readLine_03()).runTest("CWE197_Numeric_Truncation_Error__short_console_readLine_03");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_short_45()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_short_45");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_random_16()).runTest("CWE197_Numeric_Truncation_Error__short_random_16");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Environment_45()).runTest("CWE197_Numeric_Truncation_Error__short_Environment_45");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_byte_22a()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_byte_22a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_15()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_15");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_File_07()).runTest("CWE197_Numeric_Truncation_Error__short_File_07");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_File_01()).runTest("CWE197_Numeric_Truncation_Error__short_File_01");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_PropertiesFile_14()).runTest("CWE197_Numeric_Truncation_Error__short_PropertiesFile_14");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_short_05()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_short_05");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_52a()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_52a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_large_51a()).runTest("CWE197_Numeric_Truncation_Error__short_large_51a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_large_22a()).runTest("CWE197_Numeric_Truncation_Error__short_large_22a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_random_54a()).runTest("CWE197_Numeric_Truncation_Error__short_random_54a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_byte_06()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_byte_06");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_listen_tcp_71a()).runTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_71a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_random_68a()).runTest("CWE197_Numeric_Truncation_Error__short_random_68a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_71a()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_71a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_listen_tcp_04()).runTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_04");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_short_17()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_short_17");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_console_readLine_66a()).runTest("CWE197_Numeric_Truncation_Error__short_console_readLine_66a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_short_04()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_short_04");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Property_72a()).runTest("CWE197_Numeric_Truncation_Error__short_Property_72a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Property_22a()).runTest("CWE197_Numeric_Truncation_Error__short_Property_22a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_large_73a()).runTest("CWE197_Numeric_Truncation_Error__short_large_73a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Environment_54a()).runTest("CWE197_Numeric_Truncation_Error__short_Environment_54a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_short_09()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_short_09");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_large_81a()).runTest("CWE197_Numeric_Truncation_Error__short_large_81a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_PropertiesFile_72a()).runTest("CWE197_Numeric_Truncation_Error__short_PropertiesFile_72a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_short_73a()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_short_73a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_byte_15()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_byte_15");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_large_75a()).runTest("CWE197_Numeric_Truncation_Error__short_large_75a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_short_72a()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_short_72a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_03()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_03");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_listen_tcp_12()).runTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_12");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_54a()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_54a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Environment_75a()).runTest("CWE197_Numeric_Truncation_Error__short_Environment_75a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_byte_03()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_byte_03");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_61a()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_61a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_database_54a()).runTest("CWE197_Numeric_Truncation_Error__short_database_54a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_database_21()).runTest("CWE197_Numeric_Truncation_Error__short_database_21");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_PropertiesFile_12()).runTest("CWE197_Numeric_Truncation_Error__short_PropertiesFile_12");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_random_07()).runTest("CWE197_Numeric_Truncation_Error__short_random_07");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_05()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_05");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_console_readLine_81a()).runTest("CWE197_Numeric_Truncation_Error__short_console_readLine_81a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_byte_09()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_byte_09");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_listen_tcp_74a()).runTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_74a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_large_04()).runTest("CWE197_Numeric_Truncation_Error__short_large_04");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_short_53a()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_short_53a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_PropertiesFile_53a()).runTest("CWE197_Numeric_Truncation_Error__short_PropertiesFile_53a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Environment_11()).runTest("CWE197_Numeric_Truncation_Error__short_Environment_11");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_connect_tcp_41()).runTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_41");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Property_06()).runTest("CWE197_Numeric_Truncation_Error__short_Property_06");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Environment_02()).runTest("CWE197_Numeric_Truncation_Error__short_Environment_02");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_07()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_07");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_File_67a()).runTest("CWE197_Numeric_Truncation_Error__short_File_67a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_PropertiesFile_03()).runTest("CWE197_Numeric_Truncation_Error__short_PropertiesFile_03");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_11()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_11");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_04()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_04");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_71a()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_71a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_connect_tcp_07()).runTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_07");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_random_01()).runTest("CWE197_Numeric_Truncation_Error__short_random_01");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_byte_31()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_byte_31");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_short_61a()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_short_61a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Property_17()).runTest("CWE197_Numeric_Truncation_Error__short_Property_17");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_connect_tcp_01()).runTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_01");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_random_02()).runTest("CWE197_Numeric_Truncation_Error__short_random_02");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_PropertiesFile_06()).runTest("CWE197_Numeric_Truncation_Error__short_PropertiesFile_06");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Property_31()).runTest("CWE197_Numeric_Truncation_Error__short_Property_31");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Environment_73a()).runTest("CWE197_Numeric_Truncation_Error__short_Environment_73a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_byte_13()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_byte_13");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_connect_tcp_12()).runTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_12");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_database_42()).runTest("CWE197_Numeric_Truncation_Error__short_database_42");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_connect_tcp_04()).runTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_04");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_database_74a()).runTest("CWE197_Numeric_Truncation_Error__short_database_74a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_PropertiesFile_71a()).runTest("CWE197_Numeric_Truncation_Error__short_PropertiesFile_71a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_console_readLine_31()).runTest("CWE197_Numeric_Truncation_Error__short_console_readLine_31");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_database_09()).runTest("CWE197_Numeric_Truncation_Error__short_database_09");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_41()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_41");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_31()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_31");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Property_07()).runTest("CWE197_Numeric_Truncation_Error__short_Property_07");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_short_07()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_short_07");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_File_42()).runTest("CWE197_Numeric_Truncation_Error__short_File_42");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_PropertiesFile_04()).runTest("CWE197_Numeric_Truncation_Error__short_PropertiesFile_04");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_PropertiesFile_01()).runTest("CWE197_Numeric_Truncation_Error__short_PropertiesFile_01");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_database_52a()).runTest("CWE197_Numeric_Truncation_Error__short_database_52a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_console_readLine_54a()).runTest("CWE197_Numeric_Truncation_Error__short_console_readLine_54a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Environment_14()).runTest("CWE197_Numeric_Truncation_Error__short_Environment_14");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_45()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_45");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_byte_04()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_byte_04");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_File_02()).runTest("CWE197_Numeric_Truncation_Error__short_File_02");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_21()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_21");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_listen_tcp_61a()).runTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_61a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_File_74a()).runTest("CWE197_Numeric_Truncation_Error__short_File_74a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_database_75a()).runTest("CWE197_Numeric_Truncation_Error__short_database_75a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_listen_tcp_68a()).runTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_68a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Environment_17()).runTest("CWE197_Numeric_Truncation_Error__short_Environment_17");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_short_14()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_short_14");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Environment_12()).runTest("CWE197_Numeric_Truncation_Error__short_Environment_12");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_73a()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_73a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_File_21()).runTest("CWE197_Numeric_Truncation_Error__short_File_21");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_byte_41()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_byte_41");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_large_16()).runTest("CWE197_Numeric_Truncation_Error__short_large_16");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_listen_tcp_42()).runTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_42");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_File_75a()).runTest("CWE197_Numeric_Truncation_Error__short_File_75a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_byte_12()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_byte_12");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_random_66a()).runTest("CWE197_Numeric_Truncation_Error__short_random_66a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_short_52a()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_short_52a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_console_readLine_01()).runTest("CWE197_Numeric_Truncation_Error__short_console_readLine_01");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_console_readLine_53a()).runTest("CWE197_Numeric_Truncation_Error__short_console_readLine_53a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_database_01()).runTest("CWE197_Numeric_Truncation_Error__short_database_01");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Property_74a()).runTest("CWE197_Numeric_Truncation_Error__short_Property_74a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_short_13()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_short_13");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_connect_tcp_52a()).runTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_52a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_large_53a()).runTest("CWE197_Numeric_Truncation_Error__short_large_53a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_large_74a()).runTest("CWE197_Numeric_Truncation_Error__short_large_74a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_74a()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_74a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_listen_tcp_01()).runTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_01");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_database_13()).runTest("CWE197_Numeric_Truncation_Error__short_database_13");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_short_67a()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_short_67a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_database_51a()).runTest("CWE197_Numeric_Truncation_Error__short_database_51a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_04()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_04");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_connect_tcp_10()).runTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_10");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_byte_12()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_byte_12");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_byte_02()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_byte_02");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_short_42()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_short_42");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_byte_74a()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_byte_74a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_database_31()).runTest("CWE197_Numeric_Truncation_Error__short_database_31");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_byte_01()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_byte_01");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_73a()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_73a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_File_81a()).runTest("CWE197_Numeric_Truncation_Error__short_File_81a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_byte_61a()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_byte_61a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_byte_03()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_byte_03");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Environment_67a()).runTest("CWE197_Numeric_Truncation_Error__short_Environment_67a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_08()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_byte_08");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_File_72a()).runTest("CWE197_Numeric_Truncation_Error__short_File_72a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_Property_09()).runTest("CWE197_Numeric_Truncation_Error__short_Property_09");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__short_database_41()).runTest("CWE197_Numeric_Truncation_Error__short_database_41");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_Property_to_short_02()).runTest("CWE197_Numeric_Truncation_Error__int_Property_to_short_02");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_09()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_09");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_random_to_byte_51a()).runTest("CWE197_Numeric_Truncation_Error__int_random_to_byte_51a");
			(new testcases.CWE197_Numeric_Truncation_Error.s02.CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_53a()).runTest("CWE197_Numeric_Truncation_Error__int_URLConnection_to_short_53a");
			/* END-AUTOGENERATED-JAVA-TESTS-1 */
}

private static void runTestCWE2() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-2 */

			/* END-AUTOGENERATED-JAVA-TESTS-2 */
}

private static void runTestCWE3() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-3 */

			/* END-AUTOGENERATED-JAVA-TESTS-3 */
}

private static void runTestCWE4() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-4 */

			/* END-AUTOGENERATED-JAVA-TESTS-4 */
}

private static void runTestCWE5() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-5 */

			/* END-AUTOGENERATED-JAVA-TESTS-5 */
}

private static void runTestCWE6() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-6 */

			/* END-AUTOGENERATED-JAVA-TESTS-6 */
}

private static void runTestCWE7() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-7 */

			/* END-AUTOGENERATED-JAVA-TESTS-7 */
}

private static void runTestCWE8() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-8 */

			/* END-AUTOGENERATED-JAVA-TESTS-8 */
}

private static void runTestCWE9() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-9 */

			/* END-AUTOGENERATED-JAVA-TESTS-9 */
}
}