package testcases.CWE259_Hard_Coded_Password;

import testcasesupport.*;

public class Main {

	public static void main(String[] args) {
		
		if(args.length != 0) {
		
			if(args[0].equals("-h") || args[0].equals("--help")) {
		
				System.err.println("To use this main, you can either run the program with no " +
				"command line arguments to run all test cases or you can specify one or more classes to test");
				System.err.println("For example:");
				System.err.println("java testcasesupport.Main testcases.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference.custom_function.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference__custom_function_01 testcases.CWE481_Assigning_instead_of_Comparing.bool.CWE481_Assigning_instead_of_Comparing__bool_01");
				System.exit(1);
			}
			
			/* User supplied some class names on the command line, just use those with introspection
			 *
			 * String classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
			 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
 			 * could read class names from command line or use
			 * http://sadun-util.sourceforge.net/api/org/sadun/util/
			 * ClassPackageExplorer.html
			 */

			for (String className : args) {

				try {
					
					/* String classNameWithPackage = "testcases." + className; */
					
					/* IO.writeLine("classNameWithPackage = " + classNameWithPackage); */

					Class<?> myClass = Class.forName(className);

					AbstractTestCase myObject = (AbstractTestCase) myClass
							.newInstance();

					myObject.runTest(className);

				} catch (Exception ex) {

					IO.writeLine("Could not run test for class " + className);
					ex.printStackTrace();

				}
				
				IO.writeLine(""); /* leave a blank line between classes */

			}

		} else {
		
			/* No command line args were used, we want to run every testcase */
			
			/* needed to separate these calls into other methods because
			   we were running into the size limit Java has for a single method */
			runTestCWE1();
			runTestCWE2();
			runTestCWE3();
			runTestCWE4();
			runTestCWE5();
			runTestCWE6();
			runTestCWE7();
			runTestCWE8();
			runTestCWE9();
		}			
	}

private static void runTestCWE1() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-1 */

			/* END-AUTOGENERATED-JAVA-TESTS-1 */
}

private static void runTestCWE2() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-2 */
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__passwordAuth_31()).runTest("CWE259_Hard_Coded_Password__passwordAuth_31");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__kerberosKey_17()).runTest("CWE259_Hard_Coded_Password__kerberosKey_17");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__kerberosKey_02()).runTest("CWE259_Hard_Coded_Password__kerberosKey_02");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__passwordAuth_52a()).runTest("CWE259_Hard_Coded_Password__passwordAuth_52a");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__passwordAuth_72a()).runTest("CWE259_Hard_Coded_Password__passwordAuth_72a");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__kerberosKey_04()).runTest("CWE259_Hard_Coded_Password__kerberosKey_04");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__driverManager_01()).runTest("CWE259_Hard_Coded_Password__driverManager_01");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__driverManager_73a()).runTest("CWE259_Hard_Coded_Password__driverManager_73a");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__passwordAuth_51a()).runTest("CWE259_Hard_Coded_Password__passwordAuth_51a");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__driverManager_07()).runTest("CWE259_Hard_Coded_Password__driverManager_07");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__driverManager_21()).runTest("CWE259_Hard_Coded_Password__driverManager_21");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__driverManager_22a()).runTest("CWE259_Hard_Coded_Password__driverManager_22a");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__passwordAuth_01()).runTest("CWE259_Hard_Coded_Password__passwordAuth_01");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__kerberosKey_54a()).runTest("CWE259_Hard_Coded_Password__kerberosKey_54a");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__kerberosKey_67a()).runTest("CWE259_Hard_Coded_Password__kerberosKey_67a");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__driverManager_41()).runTest("CWE259_Hard_Coded_Password__driverManager_41");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__passwordAuth_17()).runTest("CWE259_Hard_Coded_Password__passwordAuth_17");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__kerberosKey_05()).runTest("CWE259_Hard_Coded_Password__kerberosKey_05");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__kerberosKey_15()).runTest("CWE259_Hard_Coded_Password__kerberosKey_15");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__kerberosKey_13()).runTest("CWE259_Hard_Coded_Password__kerberosKey_13");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__kerberosKey_45()).runTest("CWE259_Hard_Coded_Password__kerberosKey_45");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__driverManager_52a()).runTest("CWE259_Hard_Coded_Password__driverManager_52a");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__passwordAuth_10()).runTest("CWE259_Hard_Coded_Password__passwordAuth_10");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__passwordAuth_22a()).runTest("CWE259_Hard_Coded_Password__passwordAuth_22a");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__passwordAuth_54a()).runTest("CWE259_Hard_Coded_Password__passwordAuth_54a");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__driverManager_66a()).runTest("CWE259_Hard_Coded_Password__driverManager_66a");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__passwordAuth_03()).runTest("CWE259_Hard_Coded_Password__passwordAuth_03");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__kerberosKey_71a()).runTest("CWE259_Hard_Coded_Password__kerberosKey_71a");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__driverManager_53a()).runTest("CWE259_Hard_Coded_Password__driverManager_53a");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__driverManager_68a()).runTest("CWE259_Hard_Coded_Password__driverManager_68a");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__kerberosKey_01()).runTest("CWE259_Hard_Coded_Password__kerberosKey_01");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__passwordAuth_53a()).runTest("CWE259_Hard_Coded_Password__passwordAuth_53a");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__driverManager_02()).runTest("CWE259_Hard_Coded_Password__driverManager_02");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__passwordAuth_15()).runTest("CWE259_Hard_Coded_Password__passwordAuth_15");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__passwordAuth_68a()).runTest("CWE259_Hard_Coded_Password__passwordAuth_68a");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__passwordAuth_08()).runTest("CWE259_Hard_Coded_Password__passwordAuth_08");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__driverManager_42()).runTest("CWE259_Hard_Coded_Password__driverManager_42");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__kerberosKey_68a()).runTest("CWE259_Hard_Coded_Password__kerberosKey_68a");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__driverManager_81a()).runTest("CWE259_Hard_Coded_Password__driverManager_81a");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__passwordAuth_11()).runTest("CWE259_Hard_Coded_Password__passwordAuth_11");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__driverManager_12()).runTest("CWE259_Hard_Coded_Password__driverManager_12");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__driverManager_10()).runTest("CWE259_Hard_Coded_Password__driverManager_10");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__passwordAuth_05()).runTest("CWE259_Hard_Coded_Password__passwordAuth_05");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__passwordAuth_67a()).runTest("CWE259_Hard_Coded_Password__passwordAuth_67a");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__kerberosKey_61a()).runTest("CWE259_Hard_Coded_Password__kerberosKey_61a");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__passwordAuth_73a()).runTest("CWE259_Hard_Coded_Password__passwordAuth_73a");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__passwordAuth_21()).runTest("CWE259_Hard_Coded_Password__passwordAuth_21");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__driverManager_08()).runTest("CWE259_Hard_Coded_Password__driverManager_08");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__passwordAuth_81a()).runTest("CWE259_Hard_Coded_Password__passwordAuth_81a");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__kerberosKey_72a()).runTest("CWE259_Hard_Coded_Password__kerberosKey_72a");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__driverManager_04()).runTest("CWE259_Hard_Coded_Password__driverManager_04");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__kerberosKey_31()).runTest("CWE259_Hard_Coded_Password__kerberosKey_31");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__driverManager_05()).runTest("CWE259_Hard_Coded_Password__driverManager_05");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__driverManager_75a()).runTest("CWE259_Hard_Coded_Password__driverManager_75a");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__driverManager_17()).runTest("CWE259_Hard_Coded_Password__driverManager_17");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__kerberosKey_66a()).runTest("CWE259_Hard_Coded_Password__kerberosKey_66a");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__passwordAuth_07()).runTest("CWE259_Hard_Coded_Password__passwordAuth_07");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__kerberosKey_16()).runTest("CWE259_Hard_Coded_Password__kerberosKey_16");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__passwordAuth_02()).runTest("CWE259_Hard_Coded_Password__passwordAuth_02");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__kerberosKey_75a()).runTest("CWE259_Hard_Coded_Password__kerberosKey_75a");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__kerberosKey_41()).runTest("CWE259_Hard_Coded_Password__kerberosKey_41");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__passwordAuth_61a()).runTest("CWE259_Hard_Coded_Password__passwordAuth_61a");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__kerberosKey_74a()).runTest("CWE259_Hard_Coded_Password__kerberosKey_74a");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__driverManager_03()).runTest("CWE259_Hard_Coded_Password__driverManager_03");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__driverManager_51a()).runTest("CWE259_Hard_Coded_Password__driverManager_51a");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__driverManager_15()).runTest("CWE259_Hard_Coded_Password__driverManager_15");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__passwordAuth_06()).runTest("CWE259_Hard_Coded_Password__passwordAuth_06");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__kerberosKey_73a()).runTest("CWE259_Hard_Coded_Password__kerberosKey_73a");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__passwordAuth_12()).runTest("CWE259_Hard_Coded_Password__passwordAuth_12");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__kerberosKey_21()).runTest("CWE259_Hard_Coded_Password__kerberosKey_21");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__passwordAuth_04()).runTest("CWE259_Hard_Coded_Password__passwordAuth_04");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__driverManager_71a()).runTest("CWE259_Hard_Coded_Password__driverManager_71a");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__passwordAuth_14()).runTest("CWE259_Hard_Coded_Password__passwordAuth_14");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__kerberosKey_07()).runTest("CWE259_Hard_Coded_Password__kerberosKey_07");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__passwordAuth_42()).runTest("CWE259_Hard_Coded_Password__passwordAuth_42");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__kerberosKey_81a()).runTest("CWE259_Hard_Coded_Password__kerberosKey_81a");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__driverManager_14()).runTest("CWE259_Hard_Coded_Password__driverManager_14");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__passwordAuth_09()).runTest("CWE259_Hard_Coded_Password__passwordAuth_09");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__driverManager_61a()).runTest("CWE259_Hard_Coded_Password__driverManager_61a");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__driverManager_67a()).runTest("CWE259_Hard_Coded_Password__driverManager_67a");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__kerberosKey_14()).runTest("CWE259_Hard_Coded_Password__kerberosKey_14");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__kerberosKey_12()).runTest("CWE259_Hard_Coded_Password__kerberosKey_12");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__driverManager_11()).runTest("CWE259_Hard_Coded_Password__driverManager_11");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__kerberosKey_53a()).runTest("CWE259_Hard_Coded_Password__kerberosKey_53a");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__driverManager_09()).runTest("CWE259_Hard_Coded_Password__driverManager_09");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__passwordAuth_16()).runTest("CWE259_Hard_Coded_Password__passwordAuth_16");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__kerberosKey_10()).runTest("CWE259_Hard_Coded_Password__kerberosKey_10");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__passwordAuth_41()).runTest("CWE259_Hard_Coded_Password__passwordAuth_41");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__passwordAuth_74a()).runTest("CWE259_Hard_Coded_Password__passwordAuth_74a");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__kerberosKey_08()).runTest("CWE259_Hard_Coded_Password__kerberosKey_08");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__passwordAuth_71a()).runTest("CWE259_Hard_Coded_Password__passwordAuth_71a");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__passwordAuth_13()).runTest("CWE259_Hard_Coded_Password__passwordAuth_13");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__driverManager_45()).runTest("CWE259_Hard_Coded_Password__driverManager_45");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__driverManager_13()).runTest("CWE259_Hard_Coded_Password__driverManager_13");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__passwordAuth_66a()).runTest("CWE259_Hard_Coded_Password__passwordAuth_66a");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__driverManager_31()).runTest("CWE259_Hard_Coded_Password__driverManager_31");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__driverManager_06()).runTest("CWE259_Hard_Coded_Password__driverManager_06");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__kerberosKey_09()).runTest("CWE259_Hard_Coded_Password__kerberosKey_09");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__driverManager_54a()).runTest("CWE259_Hard_Coded_Password__driverManager_54a");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__driverManager_16()).runTest("CWE259_Hard_Coded_Password__driverManager_16");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__kerberosKey_03()).runTest("CWE259_Hard_Coded_Password__kerberosKey_03");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__kerberosKey_06()).runTest("CWE259_Hard_Coded_Password__kerberosKey_06");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__kerberosKey_52a()).runTest("CWE259_Hard_Coded_Password__kerberosKey_52a");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__kerberosKey_11()).runTest("CWE259_Hard_Coded_Password__kerberosKey_11");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__kerberosKey_51a()).runTest("CWE259_Hard_Coded_Password__kerberosKey_51a");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__driverManager_74a()).runTest("CWE259_Hard_Coded_Password__driverManager_74a");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__driverManager_72a()).runTest("CWE259_Hard_Coded_Password__driverManager_72a");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__kerberosKey_22a()).runTest("CWE259_Hard_Coded_Password__kerberosKey_22a");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__passwordAuth_75a()).runTest("CWE259_Hard_Coded_Password__passwordAuth_75a");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__passwordAuth_45()).runTest("CWE259_Hard_Coded_Password__passwordAuth_45");
			(new testcases.CWE259_Hard_Coded_Password.CWE259_Hard_Coded_Password__kerberosKey_42()).runTest("CWE259_Hard_Coded_Password__kerberosKey_42");
			/* END-AUTOGENERATED-JAVA-TESTS-2 */
}

private static void runTestCWE3() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-3 */

			/* END-AUTOGENERATED-JAVA-TESTS-3 */
}

private static void runTestCWE4() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-4 */

			/* END-AUTOGENERATED-JAVA-TESTS-4 */
}

private static void runTestCWE5() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-5 */

			/* END-AUTOGENERATED-JAVA-TESTS-5 */
}

private static void runTestCWE6() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-6 */

			/* END-AUTOGENERATED-JAVA-TESTS-6 */
}

private static void runTestCWE7() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-7 */

			/* END-AUTOGENERATED-JAVA-TESTS-7 */
}

private static void runTestCWE8() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-8 */

			/* END-AUTOGENERATED-JAVA-TESTS-8 */
}

private static void runTestCWE9() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-9 */

			/* END-AUTOGENERATED-JAVA-TESTS-9 */
}
}