package testcases.CWE319_Cleartext_Tx_Sensitive_Info;

import testcasesupport.*;

public class Main {

	public static void main(String[] args) {
		
		if(args.length != 0) {
		
			if(args[0].equals("-h") || args[0].equals("--help")) {
		
				System.err.println("To use this main, you can either run the program with no " +
				"command line arguments to run all test cases or you can specify one or more classes to test");
				System.err.println("For example:");
				System.err.println("java testcasesupport.Main testcases.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference.custom_function.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference__custom_function_01 testcases.CWE481_Assigning_instead_of_Comparing.bool.CWE481_Assigning_instead_of_Comparing__bool_01");
				System.exit(1);
			}
			
			/* User supplied some class names on the command line, just use those with introspection
			 *
			 * String classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
			 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
 			 * could read class names from command line or use
			 * http://sadun-util.sourceforge.net/api/org/sadun/util/
			 * ClassPackageExplorer.html
			 */

			for (String className : args) {

				try {
					
					/* String classNameWithPackage = "testcases." + className; */
					
					/* IO.writeLine("classNameWithPackage = " + classNameWithPackage); */

					Class<?> myClass = Class.forName(className);

					AbstractTestCase myObject = (AbstractTestCase) myClass
							.newInstance();

					myObject.runTest(className);

				} catch (Exception ex) {

					IO.writeLine("Could not run test for class " + className);
					ex.printStackTrace();

				}
				
				IO.writeLine(""); /* leave a blank line between classes */

			}

		} else {
		
			/* No command line args were used, we want to run every testcase */
			
			/* needed to separate these calls into other methods because
			   we were running into the size limit Java has for a single method */
			runTestCWE1();
			runTestCWE2();
			runTestCWE3();
			runTestCWE4();
			runTestCWE5();
			runTestCWE6();
			runTestCWE7();
			runTestCWE8();
			runTestCWE9();
		}			
	}

private static void runTestCWE1() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-1 */

			/* END-AUTOGENERATED-JAVA-TESTS-1 */
}

private static void runTestCWE2() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-2 */

			/* END-AUTOGENERATED-JAVA-TESTS-2 */
}

private static void runTestCWE3() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-3 */
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_42()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_42");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_75a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_75a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_54a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_54a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__send_45()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__send_45");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_09()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_09");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_14()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_14");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_04()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_04");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_81a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_81a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_61a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_61a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_12()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_12");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_45()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_45");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_75a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_75a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__send_54a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__send_54a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_68a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_68a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_61a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_61a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_21()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_21");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_31()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_31");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_05()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_05");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__send_75a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__send_75a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_12()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_12");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_54a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_54a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_52a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_52a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_06()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_06");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_22a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_22a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_52a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_52a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_68a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_68a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_12()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_12");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_21()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_21");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__send_15()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__send_15");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_06()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_06");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_11()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_11");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_51a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_51a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_22a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_22a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_06()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_06");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_67a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_67a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_13()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_13");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_06()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_06");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_06()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_06");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_15()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_15");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_11()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_11");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__send_73a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__send_73a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_71a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_71a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_81a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_81a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_02()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_02");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_45()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_45");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_81a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_81a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_14()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_14");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_71a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_71a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_22a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_22a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_05()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_05");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_74a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_74a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_16()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_16");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_12()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_12");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__send_07()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__send_07");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_66a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_66a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_81a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_81a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__send_10()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__send_10");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_17()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_17");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_72a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_72a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_51a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_51a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_74a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_74a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_07()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_07");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_75a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_75a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_41()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_41");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_75a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_75a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_13()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_13");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_17()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_17");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_61a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_61a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_41()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_41");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_15()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_15");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_03()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_03");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__send_08()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__send_08");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_72a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_72a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_42()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_42");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_21()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_21");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_03()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_03");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_71a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_71a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_66a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_66a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_81a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_81a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_17()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_17");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_09()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_09");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_75a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_75a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_74a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_74a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_81a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_81a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_71a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_71a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_73a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_73a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_31()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_31");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_73a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_73a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_11()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_11");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_73a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_73a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_16()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_16");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__send_72a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__send_72a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_68a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_68a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_09()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_09");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_14()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_14");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_08()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_08");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_09()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_09");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_09()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_09");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_08()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_08");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_54a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_54a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__send_21()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__send_21");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_67a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_67a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__send_13()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__send_13");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_74a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_74a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_61a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_61a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_68a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_68a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_10()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_10");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_41()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_41");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_17()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_17");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_67a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_67a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_66a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_66a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_13()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_13");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_01()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_01");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_16()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_16");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_53a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_53a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_73a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_73a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_05()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_05");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_08()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_08");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_31()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_31");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_09()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_09");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_71a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_71a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_02()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_02");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_22a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_22a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_10()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_10");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_68a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_68a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__send_16()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__send_16");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__send_31()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__send_31");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_22a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_22a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_12()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_12");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_42()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_42");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__send_41()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__send_41");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_12()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_12");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_17()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_17");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_02()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_02");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_08()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_08");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_52a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_52a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_01()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_01");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_67a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_67a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_45()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_45");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_31()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_31");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_31()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_31");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__send_61a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__send_61a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__send_67a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__send_67a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_09()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_09");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_75a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_75a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_41()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_41");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_52a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_52a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_42()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_42");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_02()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_02");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_45()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_45");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_66a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_66a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_15()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_15");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__send_02()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__send_02");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_42()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_42");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_01()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_01");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_12()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_12");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_16()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_16");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_01()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_01");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_04()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_04");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_14()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_14");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_22a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_22a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_11()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_11");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_08()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_08");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_22a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_22a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_51a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_51a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__send_71a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__send_71a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_51a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_51a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_54a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_54a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_31()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_31");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_14()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_14");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__send_74a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__send_74a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_72a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_72a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_53a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_53a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_53a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_53a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_74a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_74a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_61a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_61a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_08()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_08");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_13()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_13");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_16()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_16");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_17()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_17");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_53a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_53a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_73a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_73a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_07()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_07");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_08()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_08");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_08()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_08");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__send_03()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__send_03");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_71a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_71a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_13()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_13");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__send_42()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__send_42");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_04()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_04");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_11()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_11");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_04()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_04");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__send_09()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__send_09");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_73a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_73a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_51a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_51a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_72a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_72a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_66a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_66a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_14()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_14");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_06()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_06");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_10()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_10");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_05()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_05");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_11()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_11");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_01()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_01");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_01()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_01");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_71a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_71a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_15()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_15");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_03()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_03");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_16()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_16");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_51a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_51a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_03()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_03");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_04()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_04");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_72a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_72a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_66a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_66a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_10()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_10");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_72a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_72a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_52a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_52a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_06()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_06");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_01()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_01");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_16()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_16");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_54a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_54a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_45()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_45");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_16()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_16");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_14()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_14");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_41()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_41");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_21()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_21");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_31()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_31");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_45()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_45");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_05()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_05");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_61a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_61a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__send_12()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__send_12");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_13()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_13");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_13()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_13");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_17()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_17");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_21()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_21");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_42()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_42");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_68a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_68a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_05()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_05");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_22a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_22a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_01()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_01");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_21()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_21");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_45()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_45");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_03()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_03");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_74a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_74a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_61a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_61a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_12()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_12");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_73a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_73a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_81a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_81a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_16()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_16");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_53a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_53a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__send_11()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__send_11");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_73a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_73a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_05()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_05");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_74a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_74a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__send_22a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__send_22a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_10()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_10");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_66a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_66a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__send_52a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__send_52a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_14()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_14");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_54a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_54a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_74a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_74a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_31()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_31");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_07()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_07");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_05()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_05");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_52a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_52a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_07()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_07");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_53a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_53a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_10()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_10");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_42()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_42");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_72a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_72a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_13()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_13");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_67a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_67a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_45()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_45");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_75a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_75a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_51a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_51a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_75a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_75a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_53a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_53a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_41()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_41");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_07()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_07");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_45()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_45");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_54a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_54a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_03()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_03");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_74a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_74a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_04()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_04");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__send_01()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__send_01");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_68a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_68a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_67a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_67a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__send_68a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__send_68a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_71a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_71a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_67a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_67a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_12()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_12");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__send_81a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__send_81a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_13()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_13");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_03()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_03");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_06()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_06");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__send_04()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__send_04");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_15()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_15");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_06()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_06");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_02()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_02");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_10()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_10");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_11()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_11");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__send_17()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__send_17");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_07()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_07");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_03()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_03");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_17()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_17");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_41()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_41");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__send_14()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__send_14");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_03()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_03");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_75a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_75a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_15()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_15");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_21()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_21");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_02()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_02");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_71a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_71a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__send_66a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__send_66a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_61a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_61a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_72a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_72a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_11()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_11");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_22a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_22a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_02()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_02");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__send_06()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__send_06");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__send_51a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__send_51a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_41()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_41");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_15()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_15");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_17()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_17");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_10()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_10");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_07()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_07");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_81a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_81a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_04()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_04");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_15()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_15");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_66a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_66a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_73a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_73a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_09()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_09");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_51a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_51a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_42()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_42");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_31()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_31");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_04()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_04");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_07()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_07");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_01()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_01");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_05()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_05");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__send_53a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__send_53a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_53a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_53a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_52a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_52a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_68a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_68a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_02()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_02");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_10()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_10");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_07()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_07");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_15()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_15");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_21()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_21");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_72a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_72a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_67a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_67a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_08()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_kerberosKey_08");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_02()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_driverManager_02");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_54a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_kerberosKey_54a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_54a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_54a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_68a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_68a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_09()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_09");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_21()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_21");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_42()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_driverManager_42");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_11()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_11");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_61a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_61a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_67a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_67a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_51a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_51a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_81a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_passwordAuth_81a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_52a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_driverManager_52a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_53a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__URLConnection_kerberosKey_53a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_14()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_14");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_41()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_41");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__send_05()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__send_05");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_66a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_66a");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_04()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_passwordAuth_04");
			(new testcases.CWE319_Cleartext_Tx_Sensitive_Info.CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_52a()).runTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_passwordAuth_52a");
			/* END-AUTOGENERATED-JAVA-TESTS-3 */
}

private static void runTestCWE4() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-4 */

			/* END-AUTOGENERATED-JAVA-TESTS-4 */
}

private static void runTestCWE5() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-5 */

			/* END-AUTOGENERATED-JAVA-TESTS-5 */
}

private static void runTestCWE6() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-6 */

			/* END-AUTOGENERATED-JAVA-TESTS-6 */
}

private static void runTestCWE7() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-7 */

			/* END-AUTOGENERATED-JAVA-TESTS-7 */
}

private static void runTestCWE8() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-8 */

			/* END-AUTOGENERATED-JAVA-TESTS-8 */
}

private static void runTestCWE9() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-9 */

			/* END-AUTOGENERATED-JAVA-TESTS-9 */
}
}