package testcases.CWE328_Reversible_One_Way_Hash;

import testcasesupport.*;

public class Main {

	public static void main(String[] args) {
		
		if(args.length != 0) {
		
			if(args[0].equals("-h") || args[0].equals("--help")) {
		
				System.err.println("To use this main, you can either run the program with no " +
				"command line arguments to run all test cases or you can specify one or more classes to test");
				System.err.println("For example:");
				System.err.println("java testcasesupport.Main testcases.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference.custom_function.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference__custom_function_01 testcases.CWE481_Assigning_instead_of_Comparing.bool.CWE481_Assigning_instead_of_Comparing__bool_01");
				System.exit(1);
			}
			
			/* User supplied some class names on the command line, just use those with introspection
			 *
			 * String classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
			 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
 			 * could read class names from command line or use
			 * http://sadun-util.sourceforge.net/api/org/sadun/util/
			 * ClassPackageExplorer.html
			 */

			for (String className : args) {

				try {
					
					/* String classNameWithPackage = "testcases." + className; */
					
					/* IO.writeLine("classNameWithPackage = " + classNameWithPackage); */

					Class<?> myClass = Class.forName(className);

					AbstractTestCase myObject = (AbstractTestCase) myClass
							.newInstance();

					myObject.runTest(className);

				} catch (Exception ex) {

					IO.writeLine("Could not run test for class " + className);
					ex.printStackTrace();

				}
				
				IO.writeLine(""); /* leave a blank line between classes */

			}

		} else {
		
			/* No command line args were used, we want to run every testcase */
			
			/* needed to separate these calls into other methods because
			   we were running into the size limit Java has for a single method */
			runTestCWE1();
			runTestCWE2();
			runTestCWE3();
			runTestCWE4();
			runTestCWE5();
			runTestCWE6();
			runTestCWE7();
			runTestCWE8();
			runTestCWE9();
		}			
	}

private static void runTestCWE1() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-1 */

			/* END-AUTOGENERATED-JAVA-TESTS-1 */
}

private static void runTestCWE2() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-2 */

			/* END-AUTOGENERATED-JAVA-TESTS-2 */
}

private static void runTestCWE3() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-3 */
			(new testcases.CWE328_Reversible_One_Way_Hash.CWE328_Reversible_One_Way_Hash__MD5_09()).runTest("CWE328_Reversible_One_Way_Hash__MD5_09");
			(new testcases.CWE328_Reversible_One_Way_Hash.CWE328_Reversible_One_Way_Hash__MD5_01()).runTest("CWE328_Reversible_One_Way_Hash__MD5_01");
			(new testcases.CWE328_Reversible_One_Way_Hash.CWE328_Reversible_One_Way_Hash__SHA1_16()).runTest("CWE328_Reversible_One_Way_Hash__SHA1_16");
			(new testcases.CWE328_Reversible_One_Way_Hash.CWE328_Reversible_One_Way_Hash__SHA1_15()).runTest("CWE328_Reversible_One_Way_Hash__SHA1_15");
			(new testcases.CWE328_Reversible_One_Way_Hash.CWE328_Reversible_One_Way_Hash__MD5_03()).runTest("CWE328_Reversible_One_Way_Hash__MD5_03");
			(new testcases.CWE328_Reversible_One_Way_Hash.CWE328_Reversible_One_Way_Hash__SHA1_10()).runTest("CWE328_Reversible_One_Way_Hash__SHA1_10");
			(new testcases.CWE328_Reversible_One_Way_Hash.CWE328_Reversible_One_Way_Hash__MD5_07()).runTest("CWE328_Reversible_One_Way_Hash__MD5_07");
			(new testcases.CWE328_Reversible_One_Way_Hash.CWE328_Reversible_One_Way_Hash__MD2_12()).runTest("CWE328_Reversible_One_Way_Hash__MD2_12");
			(new testcases.CWE328_Reversible_One_Way_Hash.CWE328_Reversible_One_Way_Hash__SHA1_03()).runTest("CWE328_Reversible_One_Way_Hash__SHA1_03");
			(new testcases.CWE328_Reversible_One_Way_Hash.CWE328_Reversible_One_Way_Hash__SHA1_08()).runTest("CWE328_Reversible_One_Way_Hash__SHA1_08");
			(new testcases.CWE328_Reversible_One_Way_Hash.CWE328_Reversible_One_Way_Hash__MD5_06()).runTest("CWE328_Reversible_One_Way_Hash__MD5_06");
			(new testcases.CWE328_Reversible_One_Way_Hash.CWE328_Reversible_One_Way_Hash__MD5_16()).runTest("CWE328_Reversible_One_Way_Hash__MD5_16");
			(new testcases.CWE328_Reversible_One_Way_Hash.CWE328_Reversible_One_Way_Hash__MD2_08()).runTest("CWE328_Reversible_One_Way_Hash__MD2_08");
			(new testcases.CWE328_Reversible_One_Way_Hash.CWE328_Reversible_One_Way_Hash__MD5_15()).runTest("CWE328_Reversible_One_Way_Hash__MD5_15");
			(new testcases.CWE328_Reversible_One_Way_Hash.CWE328_Reversible_One_Way_Hash__SHA1_07()).runTest("CWE328_Reversible_One_Way_Hash__SHA1_07");
			(new testcases.CWE328_Reversible_One_Way_Hash.CWE328_Reversible_One_Way_Hash__SHA1_05()).runTest("CWE328_Reversible_One_Way_Hash__SHA1_05");
			(new testcases.CWE328_Reversible_One_Way_Hash.CWE328_Reversible_One_Way_Hash__MD2_11()).runTest("CWE328_Reversible_One_Way_Hash__MD2_11");
			(new testcases.CWE328_Reversible_One_Way_Hash.CWE328_Reversible_One_Way_Hash__MD2_04()).runTest("CWE328_Reversible_One_Way_Hash__MD2_04");
			(new testcases.CWE328_Reversible_One_Way_Hash.CWE328_Reversible_One_Way_Hash__MD2_05()).runTest("CWE328_Reversible_One_Way_Hash__MD2_05");
			(new testcases.CWE328_Reversible_One_Way_Hash.CWE328_Reversible_One_Way_Hash__MD2_16()).runTest("CWE328_Reversible_One_Way_Hash__MD2_16");
			(new testcases.CWE328_Reversible_One_Way_Hash.CWE328_Reversible_One_Way_Hash__MD5_04()).runTest("CWE328_Reversible_One_Way_Hash__MD5_04");
			(new testcases.CWE328_Reversible_One_Way_Hash.CWE328_Reversible_One_Way_Hash__MD5_12()).runTest("CWE328_Reversible_One_Way_Hash__MD5_12");
			(new testcases.CWE328_Reversible_One_Way_Hash.CWE328_Reversible_One_Way_Hash__SHA1_06()).runTest("CWE328_Reversible_One_Way_Hash__SHA1_06");
			(new testcases.CWE328_Reversible_One_Way_Hash.CWE328_Reversible_One_Way_Hash__MD2_02()).runTest("CWE328_Reversible_One_Way_Hash__MD2_02");
			(new testcases.CWE328_Reversible_One_Way_Hash.CWE328_Reversible_One_Way_Hash__MD5_10()).runTest("CWE328_Reversible_One_Way_Hash__MD5_10");
			(new testcases.CWE328_Reversible_One_Way_Hash.CWE328_Reversible_One_Way_Hash__SHA1_17()).runTest("CWE328_Reversible_One_Way_Hash__SHA1_17");
			(new testcases.CWE328_Reversible_One_Way_Hash.CWE328_Reversible_One_Way_Hash__MD5_13()).runTest("CWE328_Reversible_One_Way_Hash__MD5_13");
			(new testcases.CWE328_Reversible_One_Way_Hash.CWE328_Reversible_One_Way_Hash__MD2_10()).runTest("CWE328_Reversible_One_Way_Hash__MD2_10");
			(new testcases.CWE328_Reversible_One_Way_Hash.CWE328_Reversible_One_Way_Hash__MD2_13()).runTest("CWE328_Reversible_One_Way_Hash__MD2_13");
			(new testcases.CWE328_Reversible_One_Way_Hash.CWE328_Reversible_One_Way_Hash__MD2_07()).runTest("CWE328_Reversible_One_Way_Hash__MD2_07");
			(new testcases.CWE328_Reversible_One_Way_Hash.CWE328_Reversible_One_Way_Hash__SHA1_02()).runTest("CWE328_Reversible_One_Way_Hash__SHA1_02");
			(new testcases.CWE328_Reversible_One_Way_Hash.CWE328_Reversible_One_Way_Hash__MD2_17()).runTest("CWE328_Reversible_One_Way_Hash__MD2_17");
			(new testcases.CWE328_Reversible_One_Way_Hash.CWE328_Reversible_One_Way_Hash__MD2_06()).runTest("CWE328_Reversible_One_Way_Hash__MD2_06");
			(new testcases.CWE328_Reversible_One_Way_Hash.CWE328_Reversible_One_Way_Hash__SHA1_11()).runTest("CWE328_Reversible_One_Way_Hash__SHA1_11");
			(new testcases.CWE328_Reversible_One_Way_Hash.CWE328_Reversible_One_Way_Hash__SHA1_14()).runTest("CWE328_Reversible_One_Way_Hash__SHA1_14");
			(new testcases.CWE328_Reversible_One_Way_Hash.CWE328_Reversible_One_Way_Hash__MD2_15()).runTest("CWE328_Reversible_One_Way_Hash__MD2_15");
			(new testcases.CWE328_Reversible_One_Way_Hash.CWE328_Reversible_One_Way_Hash__MD2_03()).runTest("CWE328_Reversible_One_Way_Hash__MD2_03");
			(new testcases.CWE328_Reversible_One_Way_Hash.CWE328_Reversible_One_Way_Hash__MD5_11()).runTest("CWE328_Reversible_One_Way_Hash__MD5_11");
			(new testcases.CWE328_Reversible_One_Way_Hash.CWE328_Reversible_One_Way_Hash__SHA1_04()).runTest("CWE328_Reversible_One_Way_Hash__SHA1_04");
			(new testcases.CWE328_Reversible_One_Way_Hash.CWE328_Reversible_One_Way_Hash__MD5_08()).runTest("CWE328_Reversible_One_Way_Hash__MD5_08");
			(new testcases.CWE328_Reversible_One_Way_Hash.CWE328_Reversible_One_Way_Hash__SHA1_01()).runTest("CWE328_Reversible_One_Way_Hash__SHA1_01");
			(new testcases.CWE328_Reversible_One_Way_Hash.CWE328_Reversible_One_Way_Hash__MD5_05()).runTest("CWE328_Reversible_One_Way_Hash__MD5_05");
			(new testcases.CWE328_Reversible_One_Way_Hash.CWE328_Reversible_One_Way_Hash__MD5_14()).runTest("CWE328_Reversible_One_Way_Hash__MD5_14");
			(new testcases.CWE328_Reversible_One_Way_Hash.CWE328_Reversible_One_Way_Hash__MD5_17()).runTest("CWE328_Reversible_One_Way_Hash__MD5_17");
			(new testcases.CWE328_Reversible_One_Way_Hash.CWE328_Reversible_One_Way_Hash__SHA1_09()).runTest("CWE328_Reversible_One_Way_Hash__SHA1_09");
			(new testcases.CWE328_Reversible_One_Way_Hash.CWE328_Reversible_One_Way_Hash__SHA1_13()).runTest("CWE328_Reversible_One_Way_Hash__SHA1_13");
			(new testcases.CWE328_Reversible_One_Way_Hash.CWE328_Reversible_One_Way_Hash__SHA1_12()).runTest("CWE328_Reversible_One_Way_Hash__SHA1_12");
			(new testcases.CWE328_Reversible_One_Way_Hash.CWE328_Reversible_One_Way_Hash__MD2_14()).runTest("CWE328_Reversible_One_Way_Hash__MD2_14");
			(new testcases.CWE328_Reversible_One_Way_Hash.CWE328_Reversible_One_Way_Hash__MD2_09()).runTest("CWE328_Reversible_One_Way_Hash__MD2_09");
			(new testcases.CWE328_Reversible_One_Way_Hash.CWE328_Reversible_One_Way_Hash__MD5_02()).runTest("CWE328_Reversible_One_Way_Hash__MD5_02");
			(new testcases.CWE328_Reversible_One_Way_Hash.CWE328_Reversible_One_Way_Hash__MD2_01()).runTest("CWE328_Reversible_One_Way_Hash__MD2_01");
			/* END-AUTOGENERATED-JAVA-TESTS-3 */
}

private static void runTestCWE4() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-4 */

			/* END-AUTOGENERATED-JAVA-TESTS-4 */
}

private static void runTestCWE5() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-5 */

			/* END-AUTOGENERATED-JAVA-TESTS-5 */
}

private static void runTestCWE6() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-6 */

			/* END-AUTOGENERATED-JAVA-TESTS-6 */
}

private static void runTestCWE7() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-7 */

			/* END-AUTOGENERATED-JAVA-TESTS-7 */
}

private static void runTestCWE8() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-8 */

			/* END-AUTOGENERATED-JAVA-TESTS-8 */
}

private static void runTestCWE9() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-9 */

			/* END-AUTOGENERATED-JAVA-TESTS-9 */
}
}