package testcases.CWE369_Divide_by_Zero.s02;

import testcasesupport.*;

public class Main {

	public static void main(String[] args) {
		
		if(args.length != 0) {
		
			if(args[0].equals("-h") || args[0].equals("--help")) {
		
				System.err.println("To use this main, you can either run the program with no " +
				"command line arguments to run all test cases or you can specify one or more classes to test");
				System.err.println("For example:");
				System.err.println("java testcasesupport.Main testcases.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference.custom_function.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference__custom_function_01 testcases.CWE481_Assigning_instead_of_Comparing.bool.CWE481_Assigning_instead_of_Comparing__bool_01");
				System.exit(1);
			}
			
			/* User supplied some class names on the command line, just use those with introspection
			 *
			 * String classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
			 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
 			 * could read class names from command line or use
			 * http://sadun-util.sourceforge.net/api/org/sadun/util/
			 * ClassPackageExplorer.html
			 */

			for (String className : args) {

				try {
					
					/* String classNameWithPackage = "testcases." + className; */
					
					/* IO.writeLine("classNameWithPackage = " + classNameWithPackage); */

					Class<?> myClass = Class.forName(className);

					AbstractTestCase myObject = (AbstractTestCase) myClass
							.newInstance();

					myObject.runTest(className);

				} catch (Exception ex) {

					IO.writeLine("Could not run test for class " + className);
					ex.printStackTrace();

				}
				
				IO.writeLine(""); /* leave a blank line between classes */

			}

		} else {
		
			/* No command line args were used, we want to run every testcase */
			
			/* needed to separate these calls into other methods because
			   we were running into the size limit Java has for a single method */
			runTestCWE1();
			runTestCWE2();
			runTestCWE3();
			runTestCWE4();
			runTestCWE5();
			runTestCWE6();
			runTestCWE7();
			runTestCWE8();
			runTestCWE9();
		}			
	}

private static void runTestCWE1() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-1 */

			/* END-AUTOGENERATED-JAVA-TESTS-1 */
}

private static void runTestCWE2() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-2 */

			/* END-AUTOGENERATED-JAVA-TESTS-2 */
}

private static void runTestCWE3() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-3 */
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_modulo_22a()).runTest("CWE369_Divide_by_Zero__float_zero_modulo_22a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_divide_53a()).runTest("CWE369_Divide_by_Zero__int_database_divide_53a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_divide_42()).runTest("CWE369_Divide_by_Zero__float_random_divide_42");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_divide_05()).runTest("CWE369_Divide_by_Zero__float_zero_divide_05");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_divide_12()).runTest("CWE369_Divide_by_Zero__float_URLConnection_divide_12");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_divide_09()).runTest("CWE369_Divide_by_Zero__int_database_divide_09");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_modulo_41()).runTest("CWE369_Divide_by_Zero__int_database_modulo_41");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_modulo_06()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_modulo_06");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_divide_72a()).runTest("CWE369_Divide_by_Zero__float_zero_divide_72a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_divide_66a()).runTest("CWE369_Divide_by_Zero__int_File_divide_66a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_divide_71a()).runTest("CWE369_Divide_by_Zero__int_database_divide_71a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_modulo_73a()).runTest("CWE369_Divide_by_Zero__int_database_modulo_73a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_modulo_81a()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_modulo_81a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_modulo_45()).runTest("CWE369_Divide_by_Zero__int_database_modulo_45");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_divide_41()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_divide_41");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_modulo_52a()).runTest("CWE369_Divide_by_Zero__float_zero_modulo_52a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_modulo_71a()).runTest("CWE369_Divide_by_Zero__int_database_modulo_71a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_modulo_16()).runTest("CWE369_Divide_by_Zero__int_database_modulo_16");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_divide_05()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_divide_05");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_divide_11()).runTest("CWE369_Divide_by_Zero__int_Environment_divide_11");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_divide_02()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_divide_02");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_divide_14()).runTest("CWE369_Divide_by_Zero__int_File_divide_14");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_divide_81a()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_divide_81a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_modulo_17()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_modulo_17");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_divide_02()).runTest("CWE369_Divide_by_Zero__int_database_divide_02");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_divide_03()).runTest("CWE369_Divide_by_Zero__int_Environment_divide_03");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_divide_09()).runTest("CWE369_Divide_by_Zero__int_console_readLine_divide_09");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_modulo_75a()).runTest("CWE369_Divide_by_Zero__int_File_modulo_75a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_modulo_10()).runTest("CWE369_Divide_by_Zero__float_zero_modulo_10");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_divide_41()).runTest("CWE369_Divide_by_Zero__int_Environment_divide_41");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_modulo_16()).runTest("CWE369_Divide_by_Zero__float_random_modulo_16");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_modulo_09()).runTest("CWE369_Divide_by_Zero__int_console_readLine_modulo_09");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_modulo_67a()).runTest("CWE369_Divide_by_Zero__int_Environment_modulo_67a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_divide_03()).runTest("CWE369_Divide_by_Zero__float_URLConnection_divide_03");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_modulo_22a()).runTest("CWE369_Divide_by_Zero__int_File_modulo_22a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_modulo_74a()).runTest("CWE369_Divide_by_Zero__float_zero_modulo_74a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_divide_16()).runTest("CWE369_Divide_by_Zero__int_console_readLine_divide_16");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_modulo_14()).runTest("CWE369_Divide_by_Zero__int_console_readLine_modulo_14");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_modulo_14()).runTest("CWE369_Divide_by_Zero__int_database_modulo_14");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_divide_03()).runTest("CWE369_Divide_by_Zero__float_zero_divide_03");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_modulo_05()).runTest("CWE369_Divide_by_Zero__int_database_modulo_05");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_divide_41()).runTest("CWE369_Divide_by_Zero__int_File_divide_41");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_modulo_10()).runTest("CWE369_Divide_by_Zero__int_Environment_modulo_10");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_divide_08()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_divide_08");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_modulo_66a()).runTest("CWE369_Divide_by_Zero__float_zero_modulo_66a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_divide_05()).runTest("CWE369_Divide_by_Zero__int_database_divide_05");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_modulo_06()).runTest("CWE369_Divide_by_Zero__int_console_readLine_modulo_06");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_modulo_67a()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_modulo_67a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_divide_66a()).runTest("CWE369_Divide_by_Zero__int_Environment_divide_66a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_divide_51a()).runTest("CWE369_Divide_by_Zero__int_database_divide_51a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_modulo_17()).runTest("CWE369_Divide_by_Zero__int_console_readLine_modulo_17");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_divide_81a()).runTest("CWE369_Divide_by_Zero__int_database_divide_81a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_modulo_75a()).runTest("CWE369_Divide_by_Zero__int_Environment_modulo_75a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_modulo_45()).runTest("CWE369_Divide_by_Zero__int_console_readLine_modulo_45");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_modulo_21()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_modulo_21");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_modulo_10()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_modulo_10");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_modulo_73a()).runTest("CWE369_Divide_by_Zero__int_console_readLine_modulo_73a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_modulo_54a()).runTest("CWE369_Divide_by_Zero__int_console_readLine_modulo_54a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_divide_08()).runTest("CWE369_Divide_by_Zero__int_database_divide_08");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_divide_75a()).runTest("CWE369_Divide_by_Zero__int_console_readLine_divide_75a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_modulo_51a()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_modulo_51a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_modulo_71a()).runTest("CWE369_Divide_by_Zero__int_console_readLine_modulo_71a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_divide_53a()).runTest("CWE369_Divide_by_Zero__float_zero_divide_53a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_divide_08()).runTest("CWE369_Divide_by_Zero__float_random_divide_08");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_modulo_53a()).runTest("CWE369_Divide_by_Zero__float_zero_modulo_53a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_modulo_05()).runTest("CWE369_Divide_by_Zero__float_zero_modulo_05");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_divide_66a()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_divide_66a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_modulo_02()).runTest("CWE369_Divide_by_Zero__int_File_modulo_02");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_divide_81a()).runTest("CWE369_Divide_by_Zero__int_console_readLine_divide_81a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_modulo_04()).runTest("CWE369_Divide_by_Zero__int_Environment_modulo_04");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_modulo_71a()).runTest("CWE369_Divide_by_Zero__float_random_modulo_71a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_modulo_16()).runTest("CWE369_Divide_by_Zero__int_console_readLine_modulo_16");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_modulo_02()).runTest("CWE369_Divide_by_Zero__float_URLConnection_modulo_02");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_divide_73a()).runTest("CWE369_Divide_by_Zero__float_random_divide_73a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_modulo_15()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_modulo_15");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_modulo_17()).runTest("CWE369_Divide_by_Zero__float_URLConnection_modulo_17");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_divide_66a()).runTest("CWE369_Divide_by_Zero__float_zero_divide_66a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_divide_08()).runTest("CWE369_Divide_by_Zero__int_Environment_divide_08");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_divide_68a()).runTest("CWE369_Divide_by_Zero__float_URLConnection_divide_68a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_divide_02()).runTest("CWE369_Divide_by_Zero__int_Environment_divide_02");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_modulo_04()).runTest("CWE369_Divide_by_Zero__float_URLConnection_modulo_04");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_divide_67a()).runTest("CWE369_Divide_by_Zero__int_Environment_divide_67a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_modulo_09()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_modulo_09");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_modulo_22a()).runTest("CWE369_Divide_by_Zero__int_console_readLine_modulo_22a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_divide_14()).runTest("CWE369_Divide_by_Zero__int_database_divide_14");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_divide_21()).runTest("CWE369_Divide_by_Zero__int_Environment_divide_21");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_divide_53a()).runTest("CWE369_Divide_by_Zero__float_random_divide_53a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_divide_17()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_divide_17");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_modulo_09()).runTest("CWE369_Divide_by_Zero__int_Environment_modulo_09");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_modulo_12()).runTest("CWE369_Divide_by_Zero__float_URLConnection_modulo_12");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_modulo_72a()).runTest("CWE369_Divide_by_Zero__int_console_readLine_modulo_72a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_divide_41()).runTest("CWE369_Divide_by_Zero__int_console_readLine_divide_41");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_modulo_13()).runTest("CWE369_Divide_by_Zero__int_Environment_modulo_13");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_divide_31()).runTest("CWE369_Divide_by_Zero__float_zero_divide_31");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_modulo_71a()).runTest("CWE369_Divide_by_Zero__int_File_modulo_71a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_divide_22a()).runTest("CWE369_Divide_by_Zero__int_database_divide_22a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_divide_22a()).runTest("CWE369_Divide_by_Zero__float_URLConnection_divide_22a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_modulo_68a()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_modulo_68a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_divide_09()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_divide_09");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_divide_13()).runTest("CWE369_Divide_by_Zero__float_zero_divide_13");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_divide_11()).runTest("CWE369_Divide_by_Zero__float_random_divide_11");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_modulo_74a()).runTest("CWE369_Divide_by_Zero__int_Environment_modulo_74a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_divide_66a()).runTest("CWE369_Divide_by_Zero__int_console_readLine_divide_66a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_divide_12()).runTest("CWE369_Divide_by_Zero__int_database_divide_12");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_divide_02()).runTest("CWE369_Divide_by_Zero__float_zero_divide_02");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_modulo_81a()).runTest("CWE369_Divide_by_Zero__float_zero_modulo_81a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_divide_14()).runTest("CWE369_Divide_by_Zero__int_Environment_divide_14");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_modulo_61a()).runTest("CWE369_Divide_by_Zero__float_random_modulo_61a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_divide_04()).runTest("CWE369_Divide_by_Zero__int_database_divide_04");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_divide_61a()).runTest("CWE369_Divide_by_Zero__float_random_divide_61a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_divide_22a()).runTest("CWE369_Divide_by_Zero__float_random_divide_22a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_modulo_01()).runTest("CWE369_Divide_by_Zero__float_random_modulo_01");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_modulo_73a()).runTest("CWE369_Divide_by_Zero__float_random_modulo_73a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_modulo_72a()).runTest("CWE369_Divide_by_Zero__float_zero_modulo_72a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_modulo_61a()).runTest("CWE369_Divide_by_Zero__int_File_modulo_61a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_divide_03()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_divide_03");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_modulo_74a()).runTest("CWE369_Divide_by_Zero__int_console_readLine_modulo_74a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_modulo_21()).runTest("CWE369_Divide_by_Zero__float_random_modulo_21");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_modulo_67a()).runTest("CWE369_Divide_by_Zero__int_File_modulo_67a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_divide_68a()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_divide_68a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_modulo_08()).runTest("CWE369_Divide_by_Zero__int_console_readLine_modulo_08");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_modulo_73a()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_modulo_73a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_divide_11()).runTest("CWE369_Divide_by_Zero__float_URLConnection_divide_11");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_divide_07()).runTest("CWE369_Divide_by_Zero__int_console_readLine_divide_07");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_divide_12()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_divide_12");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_divide_07()).runTest("CWE369_Divide_by_Zero__float_zero_divide_07");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_modulo_66a()).runTest("CWE369_Divide_by_Zero__int_File_modulo_66a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_divide_06()).runTest("CWE369_Divide_by_Zero__int_database_divide_06");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_modulo_12()).runTest("CWE369_Divide_by_Zero__int_Environment_modulo_12");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_divide_54a()).runTest("CWE369_Divide_by_Zero__int_database_divide_54a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_divide_52a()).runTest("CWE369_Divide_by_Zero__float_random_divide_52a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_modulo_11()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_modulo_11");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_modulo_74a()).runTest("CWE369_Divide_by_Zero__int_database_modulo_74a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_divide_52a()).runTest("CWE369_Divide_by_Zero__float_URLConnection_divide_52a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_modulo_61a()).runTest("CWE369_Divide_by_Zero__int_database_modulo_61a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_modulo_16()).runTest("CWE369_Divide_by_Zero__float_URLConnection_modulo_16");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_divide_75a()).runTest("CWE369_Divide_by_Zero__int_database_divide_75a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_modulo_11()).runTest("CWE369_Divide_by_Zero__int_Environment_modulo_11");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_modulo_31()).runTest("CWE369_Divide_by_Zero__float_random_modulo_31");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_divide_16()).runTest("CWE369_Divide_by_Zero__int_database_divide_16");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_modulo_68a()).runTest("CWE369_Divide_by_Zero__int_File_modulo_68a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_divide_31()).runTest("CWE369_Divide_by_Zero__int_File_divide_31");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_modulo_10()).runTest("CWE369_Divide_by_Zero__int_database_modulo_10");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_modulo_14()).runTest("CWE369_Divide_by_Zero__float_zero_modulo_14");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_modulo_61a()).runTest("CWE369_Divide_by_Zero__int_console_readLine_modulo_61a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_modulo_31()).runTest("CWE369_Divide_by_Zero__int_console_readLine_modulo_31");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_divide_05()).runTest("CWE369_Divide_by_Zero__int_Environment_divide_05");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_divide_21()).runTest("CWE369_Divide_by_Zero__int_File_divide_21");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_modulo_21()).runTest("CWE369_Divide_by_Zero__int_File_modulo_21");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_modulo_05()).runTest("CWE369_Divide_by_Zero__int_Environment_modulo_05");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_divide_07()).runTest("CWE369_Divide_by_Zero__float_random_divide_07");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_divide_68a()).runTest("CWE369_Divide_by_Zero__float_zero_divide_68a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_divide_11()).runTest("CWE369_Divide_by_Zero__int_database_divide_11");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_divide_15()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_divide_15");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_modulo_72a()).runTest("CWE369_Divide_by_Zero__int_database_modulo_72a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_divide_01()).runTest("CWE369_Divide_by_Zero__int_database_divide_01");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_divide_53a()).runTest("CWE369_Divide_by_Zero__int_File_divide_53a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_modulo_72a()).runTest("CWE369_Divide_by_Zero__int_File_modulo_72a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_modulo_05()).runTest("CWE369_Divide_by_Zero__float_URLConnection_modulo_05");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_modulo_03()).runTest("CWE369_Divide_by_Zero__float_random_modulo_03");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_modulo_21()).runTest("CWE369_Divide_by_Zero__int_Environment_modulo_21");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_modulo_61a()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_modulo_61a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_modulo_01()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_modulo_01");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_modulo_02()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_modulo_02");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_modulo_66a()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_modulo_66a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_modulo_03()).runTest("CWE369_Divide_by_Zero__int_File_modulo_03");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_modulo_31()).runTest("CWE369_Divide_by_Zero__int_Environment_modulo_31");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_modulo_67a()).runTest("CWE369_Divide_by_Zero__float_URLConnection_modulo_67a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_modulo_06()).runTest("CWE369_Divide_by_Zero__float_URLConnection_modulo_06");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_divide_14()).runTest("CWE369_Divide_by_Zero__float_random_divide_14");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_modulo_11()).runTest("CWE369_Divide_by_Zero__int_database_modulo_11");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_divide_17()).runTest("CWE369_Divide_by_Zero__float_zero_divide_17");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_modulo_09()).runTest("CWE369_Divide_by_Zero__float_zero_modulo_09");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_modulo_04()).runTest("CWE369_Divide_by_Zero__float_random_modulo_04");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_modulo_31()).runTest("CWE369_Divide_by_Zero__int_File_modulo_31");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_divide_06()).runTest("CWE369_Divide_by_Zero__int_console_readLine_divide_06");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_divide_15()).runTest("CWE369_Divide_by_Zero__int_File_divide_15");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_divide_06()).runTest("CWE369_Divide_by_Zero__float_URLConnection_divide_06");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_modulo_17()).runTest("CWE369_Divide_by_Zero__int_database_modulo_17");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_modulo_07()).runTest("CWE369_Divide_by_Zero__float_URLConnection_modulo_07");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_modulo_11()).runTest("CWE369_Divide_by_Zero__int_console_readLine_modulo_11");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_divide_45()).runTest("CWE369_Divide_by_Zero__float_URLConnection_divide_45");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_divide_15()).runTest("CWE369_Divide_by_Zero__int_Environment_divide_15");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_modulo_16()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_modulo_16");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_modulo_10()).runTest("CWE369_Divide_by_Zero__float_random_modulo_10");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_divide_74a()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_divide_74a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_divide_13()).runTest("CWE369_Divide_by_Zero__float_URLConnection_divide_13");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_modulo_02()).runTest("CWE369_Divide_by_Zero__int_console_readLine_modulo_02");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_modulo_45()).runTest("CWE369_Divide_by_Zero__int_File_modulo_45");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_modulo_66a()).runTest("CWE369_Divide_by_Zero__float_URLConnection_modulo_66a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_modulo_09()).runTest("CWE369_Divide_by_Zero__int_database_modulo_09");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_modulo_51a()).runTest("CWE369_Divide_by_Zero__int_database_modulo_51a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_divide_01()).runTest("CWE369_Divide_by_Zero__int_File_divide_01");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_modulo_73a()).runTest("CWE369_Divide_by_Zero__int_Environment_modulo_73a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_modulo_52a()).runTest("CWE369_Divide_by_Zero__int_console_readLine_modulo_52a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_divide_14()).runTest("CWE369_Divide_by_Zero__int_console_readLine_divide_14");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_divide_10()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_divide_10");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_modulo_41()).runTest("CWE369_Divide_by_Zero__float_random_modulo_41");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_modulo_02()).runTest("CWE369_Divide_by_Zero__float_random_modulo_02");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_divide_42()).runTest("CWE369_Divide_by_Zero__float_URLConnection_divide_42");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_modulo_14()).runTest("CWE369_Divide_by_Zero__int_Environment_modulo_14");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_divide_21()).runTest("CWE369_Divide_by_Zero__float_URLConnection_divide_21");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_divide_31()).runTest("CWE369_Divide_by_Zero__int_console_readLine_divide_31");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_divide_15()).runTest("CWE369_Divide_by_Zero__float_zero_divide_15");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_modulo_13()).runTest("CWE369_Divide_by_Zero__float_zero_modulo_13");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_modulo_01()).runTest("CWE369_Divide_by_Zero__int_console_readLine_modulo_01");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_modulo_54a()).runTest("CWE369_Divide_by_Zero__int_database_modulo_54a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_divide_52a()).runTest("CWE369_Divide_by_Zero__int_console_readLine_divide_52a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_modulo_03()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_modulo_03");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_divide_72a()).runTest("CWE369_Divide_by_Zero__int_console_readLine_divide_72a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_divide_02()).runTest("CWE369_Divide_by_Zero__int_File_divide_02");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_divide_21()).runTest("CWE369_Divide_by_Zero__int_console_readLine_divide_21");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_divide_03()).runTest("CWE369_Divide_by_Zero__int_File_divide_03");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_divide_05()).runTest("CWE369_Divide_by_Zero__float_random_divide_05");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_modulo_52a()).runTest("CWE369_Divide_by_Zero__int_Environment_modulo_52a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_modulo_15()).runTest("CWE369_Divide_by_Zero__float_random_modulo_15");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_divide_74a()).runTest("CWE369_Divide_by_Zero__float_URLConnection_divide_74a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_divide_73a()).runTest("CWE369_Divide_by_Zero__float_URLConnection_divide_73a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_divide_11()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_divide_11");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_divide_54a()).runTest("CWE369_Divide_by_Zero__int_console_readLine_divide_54a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_divide_52a()).runTest("CWE369_Divide_by_Zero__int_Environment_divide_52a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_divide_45()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_divide_45");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_divide_13()).runTest("CWE369_Divide_by_Zero__int_database_divide_13");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_divide_81a()).runTest("CWE369_Divide_by_Zero__float_URLConnection_divide_81a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_modulo_11()).runTest("CWE369_Divide_by_Zero__int_File_modulo_11");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_divide_42()).runTest("CWE369_Divide_by_Zero__float_zero_divide_42");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_divide_16()).runTest("CWE369_Divide_by_Zero__int_File_divide_16");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_modulo_68a()).runTest("CWE369_Divide_by_Zero__int_database_modulo_68a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_modulo_08()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_modulo_08");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_divide_61a()).runTest("CWE369_Divide_by_Zero__float_URLConnection_divide_61a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_divide_73a()).runTest("CWE369_Divide_by_Zero__int_database_divide_73a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_divide_75a()).runTest("CWE369_Divide_by_Zero__int_Environment_divide_75a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_modulo_45()).runTest("CWE369_Divide_by_Zero__float_URLConnection_modulo_45");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_modulo_17()).runTest("CWE369_Divide_by_Zero__int_Environment_modulo_17");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_divide_75a()).runTest("CWE369_Divide_by_Zero__int_File_divide_75a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_divide_67a()).runTest("CWE369_Divide_by_Zero__float_URLConnection_divide_67a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_divide_61a()).runTest("CWE369_Divide_by_Zero__int_database_divide_61a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_divide_04()).runTest("CWE369_Divide_by_Zero__int_Environment_divide_04");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_modulo_73a()).runTest("CWE369_Divide_by_Zero__float_URLConnection_modulo_73a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_divide_81a()).runTest("CWE369_Divide_by_Zero__int_File_divide_81a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_modulo_14()).runTest("CWE369_Divide_by_Zero__int_File_modulo_14");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_modulo_51a()).runTest("CWE369_Divide_by_Zero__float_URLConnection_modulo_51a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_modulo_54a()).runTest("CWE369_Divide_by_Zero__float_URLConnection_modulo_54a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_modulo_08()).runTest("CWE369_Divide_by_Zero__int_Environment_modulo_08");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_divide_15()).runTest("CWE369_Divide_by_Zero__int_console_readLine_divide_15");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_modulo_54a()).runTest("CWE369_Divide_by_Zero__float_random_modulo_54a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_modulo_45()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_modulo_45");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_divide_51a()).runTest("CWE369_Divide_by_Zero__int_console_readLine_divide_51a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_modulo_68a()).runTest("CWE369_Divide_by_Zero__int_Environment_modulo_68a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_divide_04()).runTest("CWE369_Divide_by_Zero__float_random_divide_04");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_divide_11()).runTest("CWE369_Divide_by_Zero__int_File_divide_11");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_divide_73a()).runTest("CWE369_Divide_by_Zero__int_File_divide_73a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_divide_08()).runTest("CWE369_Divide_by_Zero__float_zero_divide_08");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_modulo_54a()).runTest("CWE369_Divide_by_Zero__float_zero_modulo_54a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_divide_16()).runTest("CWE369_Divide_by_Zero__int_Environment_divide_16");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_divide_51a()).runTest("CWE369_Divide_by_Zero__int_Environment_divide_51a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_modulo_75a()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_modulo_75a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_divide_09()).runTest("CWE369_Divide_by_Zero__int_Environment_divide_09");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_modulo_09()).runTest("CWE369_Divide_by_Zero__float_URLConnection_modulo_09");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_modulo_75a()).runTest("CWE369_Divide_by_Zero__float_URLConnection_modulo_75a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_divide_51a()).runTest("CWE369_Divide_by_Zero__int_File_divide_51a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_divide_17()).runTest("CWE369_Divide_by_Zero__float_URLConnection_divide_17");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_modulo_75a()).runTest("CWE369_Divide_by_Zero__int_database_modulo_75a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_divide_61a()).runTest("CWE369_Divide_by_Zero__int_File_divide_61a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_divide_67a()).runTest("CWE369_Divide_by_Zero__int_database_divide_67a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_divide_66a()).runTest("CWE369_Divide_by_Zero__float_random_divide_66a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_modulo_14()).runTest("CWE369_Divide_by_Zero__float_random_modulo_14");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_modulo_68a()).runTest("CWE369_Divide_by_Zero__int_console_readLine_modulo_68a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_divide_12()).runTest("CWE369_Divide_by_Zero__int_File_divide_12");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_modulo_07()).runTest("CWE369_Divide_by_Zero__int_database_modulo_07");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_modulo_05()).runTest("CWE369_Divide_by_Zero__float_random_modulo_05");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_modulo_05()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_modulo_05");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_modulo_67a()).runTest("CWE369_Divide_by_Zero__float_zero_modulo_67a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_modulo_54a()).runTest("CWE369_Divide_by_Zero__int_File_modulo_54a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_modulo_81a()).runTest("CWE369_Divide_by_Zero__int_console_readLine_modulo_81a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_modulo_75a()).runTest("CWE369_Divide_by_Zero__float_random_modulo_75a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_modulo_17()).runTest("CWE369_Divide_by_Zero__int_File_modulo_17");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_divide_21()).runTest("CWE369_Divide_by_Zero__int_database_divide_21");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_divide_41()).runTest("CWE369_Divide_by_Zero__int_database_divide_41");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_divide_13()).runTest("CWE369_Divide_by_Zero__float_random_divide_13");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_modulo_52a()).runTest("CWE369_Divide_by_Zero__int_database_modulo_52a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_divide_01()).runTest("CWE369_Divide_by_Zero__float_URLConnection_divide_01");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_divide_12()).runTest("CWE369_Divide_by_Zero__float_random_divide_12");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_divide_71a()).runTest("CWE369_Divide_by_Zero__float_random_divide_71a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_modulo_41()).runTest("CWE369_Divide_by_Zero__float_zero_modulo_41");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_divide_66a()).runTest("CWE369_Divide_by_Zero__int_database_divide_66a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_divide_67a()).runTest("CWE369_Divide_by_Zero__int_console_readLine_divide_67a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_modulo_05()).runTest("CWE369_Divide_by_Zero__int_File_modulo_05");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_divide_03()).runTest("CWE369_Divide_by_Zero__int_database_divide_03");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_divide_10()).runTest("CWE369_Divide_by_Zero__float_URLConnection_divide_10");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_divide_42()).runTest("CWE369_Divide_by_Zero__int_File_divide_42");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_divide_06()).runTest("CWE369_Divide_by_Zero__int_File_divide_06");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_divide_06()).runTest("CWE369_Divide_by_Zero__float_random_divide_06");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_modulo_41()).runTest("CWE369_Divide_by_Zero__float_URLConnection_modulo_41");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_modulo_22a()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_modulo_22a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_divide_21()).runTest("CWE369_Divide_by_Zero__float_zero_divide_21");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_divide_61a()).runTest("CWE369_Divide_by_Zero__float_zero_divide_61a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_divide_45()).runTest("CWE369_Divide_by_Zero__float_random_divide_45");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_divide_42()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_divide_42");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_divide_15()).runTest("CWE369_Divide_by_Zero__float_random_divide_15");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_divide_10()).runTest("CWE369_Divide_by_Zero__float_random_divide_10");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_modulo_13()).runTest("CWE369_Divide_by_Zero__float_URLConnection_modulo_13");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_divide_81a()).runTest("CWE369_Divide_by_Zero__int_Environment_divide_81a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_divide_52a()).runTest("CWE369_Divide_by_Zero__int_database_divide_52a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_divide_06()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_divide_06");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_modulo_21()).runTest("CWE369_Divide_by_Zero__int_database_modulo_21");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_divide_10()).runTest("CWE369_Divide_by_Zero__float_zero_divide_10");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_modulo_45()).runTest("CWE369_Divide_by_Zero__int_Environment_modulo_45");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_modulo_10()).runTest("CWE369_Divide_by_Zero__int_File_modulo_10");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_divide_22a()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_divide_22a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_divide_22a()).runTest("CWE369_Divide_by_Zero__int_File_divide_22a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_divide_75a()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_divide_75a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_divide_72a()).runTest("CWE369_Divide_by_Zero__float_random_divide_72a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_modulo_61a()).runTest("CWE369_Divide_by_Zero__float_zero_modulo_61a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_divide_74a()).runTest("CWE369_Divide_by_Zero__float_zero_divide_74a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_divide_75a()).runTest("CWE369_Divide_by_Zero__float_random_divide_75a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_modulo_22a()).runTest("CWE369_Divide_by_Zero__int_database_modulo_22a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_divide_71a()).runTest("CWE369_Divide_by_Zero__float_zero_divide_71a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_modulo_08()).runTest("CWE369_Divide_by_Zero__int_File_modulo_08");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_modulo_71a()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_modulo_71a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_modulo_71a()).runTest("CWE369_Divide_by_Zero__float_URLConnection_modulo_71a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_modulo_09()).runTest("CWE369_Divide_by_Zero__float_random_modulo_09");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_divide_52a()).runTest("CWE369_Divide_by_Zero__int_File_divide_52a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_modulo_03()).runTest("CWE369_Divide_by_Zero__int_console_readLine_modulo_03");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_modulo_53a()).runTest("CWE369_Divide_by_Zero__int_database_modulo_53a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_divide_16()).runTest("CWE369_Divide_by_Zero__float_random_divide_16");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_divide_02()).runTest("CWE369_Divide_by_Zero__float_URLConnection_divide_02");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_modulo_05()).runTest("CWE369_Divide_by_Zero__int_console_readLine_modulo_05");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_divide_22a()).runTest("CWE369_Divide_by_Zero__int_Environment_divide_22a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_divide_22a()).runTest("CWE369_Divide_by_Zero__float_zero_divide_22a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_divide_09()).runTest("CWE369_Divide_by_Zero__float_URLConnection_divide_09");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_divide_05()).runTest("CWE369_Divide_by_Zero__int_File_divide_05");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_modulo_22a()).runTest("CWE369_Divide_by_Zero__float_URLConnection_modulo_22a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_divide_08()).runTest("CWE369_Divide_by_Zero__int_console_readLine_divide_08");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_modulo_16()).runTest("CWE369_Divide_by_Zero__int_Environment_modulo_16");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_modulo_01()).runTest("CWE369_Divide_by_Zero__int_Environment_modulo_01");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_modulo_42()).runTest("CWE369_Divide_by_Zero__int_database_modulo_42");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_modulo_74a()).runTest("CWE369_Divide_by_Zero__int_File_modulo_74a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_divide_72a()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_divide_72a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_modulo_42()).runTest("CWE369_Divide_by_Zero__int_File_modulo_42");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_divide_22a()).runTest("CWE369_Divide_by_Zero__int_console_readLine_divide_22a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_divide_07()).runTest("CWE369_Divide_by_Zero__float_URLConnection_divide_07");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_modulo_51a()).runTest("CWE369_Divide_by_Zero__int_File_modulo_51a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_divide_68a()).runTest("CWE369_Divide_by_Zero__int_database_divide_68a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_divide_72a()).runTest("CWE369_Divide_by_Zero__int_database_divide_72a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_modulo_73a()).runTest("CWE369_Divide_by_Zero__int_File_modulo_73a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_divide_61a()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_divide_61a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_divide_45()).runTest("CWE369_Divide_by_Zero__int_Environment_divide_45");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_modulo_52a()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_modulo_52a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_modulo_01()).runTest("CWE369_Divide_by_Zero__int_File_modulo_01");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_modulo_14()).runTest("CWE369_Divide_by_Zero__float_URLConnection_modulo_14");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_divide_53a()).runTest("CWE369_Divide_by_Zero__int_console_readLine_divide_53a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_modulo_51a()).runTest("CWE369_Divide_by_Zero__float_zero_modulo_51a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_divide_09()).runTest("CWE369_Divide_by_Zero__float_random_divide_09");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_divide_31()).runTest("CWE369_Divide_by_Zero__int_database_divide_31");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_divide_03()).runTest("CWE369_Divide_by_Zero__float_random_divide_03");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_modulo_11()).runTest("CWE369_Divide_by_Zero__float_zero_modulo_11");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_divide_14()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_divide_14");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_divide_09()).runTest("CWE369_Divide_by_Zero__float_zero_divide_09");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_modulo_04()).runTest("CWE369_Divide_by_Zero__int_File_modulo_04");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_divide_54a()).runTest("CWE369_Divide_by_Zero__float_URLConnection_divide_54a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_divide_16()).runTest("CWE369_Divide_by_Zero__float_URLConnection_divide_16");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_modulo_12()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_modulo_12");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_modulo_13()).runTest("CWE369_Divide_by_Zero__int_File_modulo_13");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_modulo_72a()).runTest("CWE369_Divide_by_Zero__float_URLConnection_modulo_72a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_modulo_15()).runTest("CWE369_Divide_by_Zero__float_zero_modulo_15");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_modulo_12()).runTest("CWE369_Divide_by_Zero__float_zero_modulo_12");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_divide_51a()).runTest("CWE369_Divide_by_Zero__float_random_divide_51a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_divide_31()).runTest("CWE369_Divide_by_Zero__int_Environment_divide_31");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_modulo_07()).runTest("CWE369_Divide_by_Zero__float_zero_modulo_07");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_modulo_42()).runTest("CWE369_Divide_by_Zero__float_URLConnection_modulo_42");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_modulo_11()).runTest("CWE369_Divide_by_Zero__float_random_modulo_11");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_modulo_06()).runTest("CWE369_Divide_by_Zero__float_zero_modulo_06");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_divide_81a()).runTest("CWE369_Divide_by_Zero__float_random_divide_81a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_modulo_04()).runTest("CWE369_Divide_by_Zero__int_console_readLine_modulo_04");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_divide_04()).runTest("CWE369_Divide_by_Zero__float_URLConnection_divide_04");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_modulo_71a()).runTest("CWE369_Divide_by_Zero__float_zero_modulo_71a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_divide_07()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_divide_07");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_modulo_22a()).runTest("CWE369_Divide_by_Zero__float_random_modulo_22a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_divide_41()).runTest("CWE369_Divide_by_Zero__float_random_divide_41");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_divide_67a()).runTest("CWE369_Divide_by_Zero__int_File_divide_67a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_divide_42()).runTest("CWE369_Divide_by_Zero__int_database_divide_42");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_divide_72a()).runTest("CWE369_Divide_by_Zero__float_URLConnection_divide_72a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_divide_71a()).runTest("CWE369_Divide_by_Zero__float_URLConnection_divide_71a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_divide_01()).runTest("CWE369_Divide_by_Zero__float_random_divide_01");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_divide_17()).runTest("CWE369_Divide_by_Zero__int_console_readLine_divide_17");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_modulo_04()).runTest("CWE369_Divide_by_Zero__int_database_modulo_04");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_divide_52a()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_divide_52a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_divide_21()).runTest("CWE369_Divide_by_Zero__float_random_divide_21");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_divide_15()).runTest("CWE369_Divide_by_Zero__int_database_divide_15");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_divide_31()).runTest("CWE369_Divide_by_Zero__float_random_divide_31");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_divide_54a()).runTest("CWE369_Divide_by_Zero__int_File_divide_54a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_modulo_81a()).runTest("CWE369_Divide_by_Zero__int_database_modulo_81a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_modulo_68a()).runTest("CWE369_Divide_by_Zero__float_URLConnection_modulo_68a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_divide_41()).runTest("CWE369_Divide_by_Zero__float_zero_divide_41");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_divide_54a()).runTest("CWE369_Divide_by_Zero__float_random_divide_54a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_modulo_68a()).runTest("CWE369_Divide_by_Zero__float_random_modulo_68a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_divide_71a()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_divide_71a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_modulo_15()).runTest("CWE369_Divide_by_Zero__int_database_modulo_15");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_divide_08()).runTest("CWE369_Divide_by_Zero__float_URLConnection_divide_08");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_modulo_67a()).runTest("CWE369_Divide_by_Zero__int_console_readLine_modulo_67a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_divide_04()).runTest("CWE369_Divide_by_Zero__float_zero_divide_04");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_divide_17()).runTest("CWE369_Divide_by_Zero__int_database_divide_17");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_modulo_45()).runTest("CWE369_Divide_by_Zero__float_zero_modulo_45");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_modulo_61a()).runTest("CWE369_Divide_by_Zero__float_URLConnection_modulo_61a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_divide_21()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_divide_21");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_divide_11()).runTest("CWE369_Divide_by_Zero__float_zero_divide_11");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_modulo_45()).runTest("CWE369_Divide_by_Zero__float_random_modulo_45");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_modulo_51a()).runTest("CWE369_Divide_by_Zero__float_random_modulo_51a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_modulo_15()).runTest("CWE369_Divide_by_Zero__float_URLConnection_modulo_15");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_modulo_71a()).runTest("CWE369_Divide_by_Zero__int_Environment_modulo_71a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_modulo_10()).runTest("CWE369_Divide_by_Zero__float_URLConnection_modulo_10");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_divide_74a()).runTest("CWE369_Divide_by_Zero__int_console_readLine_divide_74a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_modulo_21()).runTest("CWE369_Divide_by_Zero__float_URLConnection_modulo_21");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_divide_07()).runTest("CWE369_Divide_by_Zero__int_database_divide_07");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_modulo_07()).runTest("CWE369_Divide_by_Zero__int_console_readLine_modulo_07");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_divide_04()).runTest("CWE369_Divide_by_Zero__int_console_readLine_divide_04");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_modulo_41()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_modulo_41");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_divide_75a()).runTest("CWE369_Divide_by_Zero__float_zero_divide_75a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_modulo_03()).runTest("CWE369_Divide_by_Zero__int_database_modulo_03");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_divide_74a()).runTest("CWE369_Divide_by_Zero__float_random_divide_74a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_modulo_72a()).runTest("CWE369_Divide_by_Zero__int_Environment_modulo_72a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_divide_45()).runTest("CWE369_Divide_by_Zero__int_File_divide_45");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_divide_16()).runTest("CWE369_Divide_by_Zero__float_zero_divide_16");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_divide_68a()).runTest("CWE369_Divide_by_Zero__int_console_readLine_divide_68a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_modulo_07()).runTest("CWE369_Divide_by_Zero__int_Environment_modulo_07");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_modulo_03()).runTest("CWE369_Divide_by_Zero__int_Environment_modulo_03");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_divide_54a()).runTest("CWE369_Divide_by_Zero__float_zero_divide_54a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_divide_05()).runTest("CWE369_Divide_by_Zero__float_URLConnection_divide_05");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_divide_12()).runTest("CWE369_Divide_by_Zero__int_console_readLine_divide_12");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_modulo_21()).runTest("CWE369_Divide_by_Zero__float_zero_modulo_21");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_modulo_14()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_modulo_14");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_divide_02()).runTest("CWE369_Divide_by_Zero__int_console_readLine_divide_02");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_divide_10()).runTest("CWE369_Divide_by_Zero__int_File_divide_10");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_modulo_53a()).runTest("CWE369_Divide_by_Zero__int_console_readLine_modulo_53a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_modulo_66a()).runTest("CWE369_Divide_by_Zero__float_random_modulo_66a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_divide_10()).runTest("CWE369_Divide_by_Zero__int_Environment_divide_10");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_modulo_06()).runTest("CWE369_Divide_by_Zero__int_database_modulo_06");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_modulo_61a()).runTest("CWE369_Divide_by_Zero__int_Environment_modulo_61a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_divide_12()).runTest("CWE369_Divide_by_Zero__int_Environment_divide_12");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_modulo_16()).runTest("CWE369_Divide_by_Zero__float_zero_modulo_16");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_divide_31()).runTest("CWE369_Divide_by_Zero__float_URLConnection_divide_31");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_divide_13()).runTest("CWE369_Divide_by_Zero__int_File_divide_13");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_modulo_06()).runTest("CWE369_Divide_by_Zero__int_File_modulo_06");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_modulo_12()).runTest("CWE369_Divide_by_Zero__int_console_readLine_modulo_12");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_modulo_42()).runTest("CWE369_Divide_by_Zero__int_console_readLine_modulo_42");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_modulo_15()).runTest("CWE369_Divide_by_Zero__int_Environment_modulo_15");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_modulo_08()).runTest("CWE369_Divide_by_Zero__float_zero_modulo_08");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_modulo_74a()).runTest("CWE369_Divide_by_Zero__float_URLConnection_modulo_74a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_modulo_53a()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_modulo_53a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_divide_53a()).runTest("CWE369_Divide_by_Zero__float_URLConnection_divide_53a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_divide_42()).runTest("CWE369_Divide_by_Zero__int_console_readLine_divide_42");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_modulo_22a()).runTest("CWE369_Divide_by_Zero__int_Environment_modulo_22a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_modulo_01()).runTest("CWE369_Divide_by_Zero__int_database_modulo_01");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_modulo_81a()).runTest("CWE369_Divide_by_Zero__int_File_modulo_81a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_divide_05()).runTest("CWE369_Divide_by_Zero__int_console_readLine_divide_05");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_modulo_31()).runTest("CWE369_Divide_by_Zero__float_URLConnection_modulo_31");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_modulo_73a()).runTest("CWE369_Divide_by_Zero__float_zero_modulo_73a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_modulo_02()).runTest("CWE369_Divide_by_Zero__float_zero_modulo_02");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_divide_45()).runTest("CWE369_Divide_by_Zero__int_database_divide_45");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_modulo_51a()).runTest("CWE369_Divide_by_Zero__int_console_readLine_modulo_51a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_divide_71a()).runTest("CWE369_Divide_by_Zero__int_File_divide_71a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_divide_01()).runTest("CWE369_Divide_by_Zero__int_Environment_divide_01");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_divide_67a()).runTest("CWE369_Divide_by_Zero__float_zero_divide_67a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_divide_53a()).runTest("CWE369_Divide_by_Zero__int_Environment_divide_53a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_modulo_81a()).runTest("CWE369_Divide_by_Zero__int_Environment_modulo_81a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_modulo_52a()).runTest("CWE369_Divide_by_Zero__float_random_modulo_52a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_divide_66a()).runTest("CWE369_Divide_by_Zero__float_URLConnection_divide_66a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_modulo_09()).runTest("CWE369_Divide_by_Zero__int_File_modulo_09");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_divide_07()).runTest("CWE369_Divide_by_Zero__int_File_divide_07");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_modulo_15()).runTest("CWE369_Divide_by_Zero__int_File_modulo_15");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_divide_81a()).runTest("CWE369_Divide_by_Zero__float_zero_divide_81a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_modulo_08()).runTest("CWE369_Divide_by_Zero__float_URLConnection_modulo_08");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_divide_45()).runTest("CWE369_Divide_by_Zero__float_zero_divide_45");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_modulo_54a()).runTest("CWE369_Divide_by_Zero__int_Environment_modulo_54a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_modulo_03()).runTest("CWE369_Divide_by_Zero__float_URLConnection_modulo_03");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_modulo_74a()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_modulo_74a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_modulo_42()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_modulo_42");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_modulo_04()).runTest("CWE369_Divide_by_Zero__float_zero_modulo_04");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_modulo_68a()).runTest("CWE369_Divide_by_Zero__float_zero_modulo_68a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_divide_14()).runTest("CWE369_Divide_by_Zero__float_URLConnection_divide_14");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_modulo_42()).runTest("CWE369_Divide_by_Zero__int_Environment_modulo_42");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_modulo_21()).runTest("CWE369_Divide_by_Zero__int_console_readLine_modulo_21");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_modulo_10()).runTest("CWE369_Divide_by_Zero__int_console_readLine_modulo_10");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_divide_17()).runTest("CWE369_Divide_by_Zero__float_random_divide_17");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_modulo_53a()).runTest("CWE369_Divide_by_Zero__float_URLConnection_modulo_53a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_divide_54a()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_divide_54a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_modulo_72a()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_modulo_72a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_divide_73a()).runTest("CWE369_Divide_by_Zero__float_zero_divide_73a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_divide_17()).runTest("CWE369_Divide_by_Zero__int_File_divide_17");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_divide_08()).runTest("CWE369_Divide_by_Zero__int_File_divide_08");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_modulo_08()).runTest("CWE369_Divide_by_Zero__float_random_modulo_08");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_divide_16()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_divide_16");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_divide_42()).runTest("CWE369_Divide_by_Zero__int_Environment_divide_42");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_divide_54a()).runTest("CWE369_Divide_by_Zero__int_Environment_divide_54a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_divide_06()).runTest("CWE369_Divide_by_Zero__float_zero_divide_06");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_modulo_02()).runTest("CWE369_Divide_by_Zero__int_Environment_modulo_02");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_divide_52a()).runTest("CWE369_Divide_by_Zero__float_zero_divide_52a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_divide_45()).runTest("CWE369_Divide_by_Zero__int_console_readLine_divide_45");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_divide_74a()).runTest("CWE369_Divide_by_Zero__int_File_divide_74a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_modulo_53a()).runTest("CWE369_Divide_by_Zero__int_File_modulo_53a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_divide_04()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_divide_04");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_modulo_66a()).runTest("CWE369_Divide_by_Zero__int_database_modulo_66a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_divide_72a()).runTest("CWE369_Divide_by_Zero__int_Environment_divide_72a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_modulo_11()).runTest("CWE369_Divide_by_Zero__float_URLConnection_modulo_11");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_divide_14()).runTest("CWE369_Divide_by_Zero__float_zero_divide_14");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_divide_73a()).runTest("CWE369_Divide_by_Zero__int_Environment_divide_73a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_modulo_41()).runTest("CWE369_Divide_by_Zero__int_File_modulo_41");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_divide_51a()).runTest("CWE369_Divide_by_Zero__float_URLConnection_divide_51a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_modulo_81a()).runTest("CWE369_Divide_by_Zero__float_URLConnection_modulo_81a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_modulo_13()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_modulo_13");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_modulo_67a()).runTest("CWE369_Divide_by_Zero__int_database_modulo_67a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_divide_13()).runTest("CWE369_Divide_by_Zero__int_console_readLine_divide_13");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_modulo_72a()).runTest("CWE369_Divide_by_Zero__float_random_modulo_72a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_divide_73a()).runTest("CWE369_Divide_by_Zero__int_console_readLine_divide_73a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_modulo_12()).runTest("CWE369_Divide_by_Zero__float_random_modulo_12");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_modulo_81a()).runTest("CWE369_Divide_by_Zero__float_random_modulo_81a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_divide_61a()).runTest("CWE369_Divide_by_Zero__int_Environment_divide_61a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_modulo_06()).runTest("CWE369_Divide_by_Zero__int_Environment_modulo_06");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_divide_68a()).runTest("CWE369_Divide_by_Zero__int_File_divide_68a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_modulo_31()).runTest("CWE369_Divide_by_Zero__float_zero_modulo_31");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_divide_11()).runTest("CWE369_Divide_by_Zero__int_console_readLine_divide_11");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_divide_75a()).runTest("CWE369_Divide_by_Zero__float_URLConnection_divide_75a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_modulo_12()).runTest("CWE369_Divide_by_Zero__int_database_modulo_12");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_divide_68a()).runTest("CWE369_Divide_by_Zero__float_random_divide_68a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_modulo_13()).runTest("CWE369_Divide_by_Zero__int_database_modulo_13");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_modulo_17()).runTest("CWE369_Divide_by_Zero__float_zero_modulo_17");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_divide_07()).runTest("CWE369_Divide_by_Zero__int_Environment_divide_07");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_divide_73a()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_divide_73a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_divide_51a()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_divide_51a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_divide_06()).runTest("CWE369_Divide_by_Zero__int_Environment_divide_06");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_divide_01()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_divide_01");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_divide_61a()).runTest("CWE369_Divide_by_Zero__int_console_readLine_divide_61a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_modulo_31()).runTest("CWE369_Divide_by_Zero__int_database_modulo_31");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_modulo_07()).runTest("CWE369_Divide_by_Zero__float_random_modulo_07");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_divide_72a()).runTest("CWE369_Divide_by_Zero__int_File_divide_72a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_divide_68a()).runTest("CWE369_Divide_by_Zero__int_Environment_divide_68a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_modulo_01()).runTest("CWE369_Divide_by_Zero__float_URLConnection_modulo_01");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_modulo_17()).runTest("CWE369_Divide_by_Zero__float_random_modulo_17");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_modulo_67a()).runTest("CWE369_Divide_by_Zero__float_random_modulo_67a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_modulo_13()).runTest("CWE369_Divide_by_Zero__float_random_modulo_13");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_divide_02()).runTest("CWE369_Divide_by_Zero__float_random_divide_02");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_modulo_16()).runTest("CWE369_Divide_by_Zero__int_File_modulo_16");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_modulo_51a()).runTest("CWE369_Divide_by_Zero__int_Environment_modulo_51a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_modulo_42()).runTest("CWE369_Divide_by_Zero__float_zero_modulo_42");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_modulo_07()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_modulo_07");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_modulo_75a()).runTest("CWE369_Divide_by_Zero__float_zero_modulo_75a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_divide_17()).runTest("CWE369_Divide_by_Zero__int_Environment_divide_17");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_divide_01()).runTest("CWE369_Divide_by_Zero__int_console_readLine_divide_01");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_modulo_66a()).runTest("CWE369_Divide_by_Zero__int_Environment_modulo_66a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_modulo_41()).runTest("CWE369_Divide_by_Zero__int_Environment_modulo_41");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_divide_71a()).runTest("CWE369_Divide_by_Zero__int_Environment_divide_71a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_modulo_52a()).runTest("CWE369_Divide_by_Zero__int_File_modulo_52a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_divide_74a()).runTest("CWE369_Divide_by_Zero__int_Environment_divide_74a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_modulo_53a()).runTest("CWE369_Divide_by_Zero__int_Environment_modulo_53a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_divide_12()).runTest("CWE369_Divide_by_Zero__float_zero_divide_12");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_divide_67a()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_divide_67a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_modulo_06()).runTest("CWE369_Divide_by_Zero__float_random_modulo_06");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_modulo_74a()).runTest("CWE369_Divide_by_Zero__float_random_modulo_74a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_modulo_03()).runTest("CWE369_Divide_by_Zero__float_zero_modulo_03");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_modulo_02()).runTest("CWE369_Divide_by_Zero__int_database_modulo_02");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_divide_04()).runTest("CWE369_Divide_by_Zero__int_File_divide_04");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_divide_71a()).runTest("CWE369_Divide_by_Zero__int_console_readLine_divide_71a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_modulo_15()).runTest("CWE369_Divide_by_Zero__int_console_readLine_modulo_15");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_divide_15()).runTest("CWE369_Divide_by_Zero__float_URLConnection_divide_15");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_divide_01()).runTest("CWE369_Divide_by_Zero__float_zero_divide_01");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_divide_74a()).runTest("CWE369_Divide_by_Zero__int_database_divide_74a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_modulo_13()).runTest("CWE369_Divide_by_Zero__int_console_readLine_modulo_13");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_Environment_divide_13()).runTest("CWE369_Divide_by_Zero__int_Environment_divide_13");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_divide_31()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_divide_31");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_divide_13()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_divide_13");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_modulo_75a()).runTest("CWE369_Divide_by_Zero__int_console_readLine_modulo_75a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_modulo_12()).runTest("CWE369_Divide_by_Zero__int_File_modulo_12");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_modulo_41()).runTest("CWE369_Divide_by_Zero__int_console_readLine_modulo_41");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_modulo_31()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_modulo_31");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_modulo_52a()).runTest("CWE369_Divide_by_Zero__float_URLConnection_modulo_52a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_divide_53a()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_divide_53a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_divide_51a()).runTest("CWE369_Divide_by_Zero__float_zero_divide_51a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_divide_03()).runTest("CWE369_Divide_by_Zero__int_console_readLine_divide_03");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_URLConnection_divide_41()).runTest("CWE369_Divide_by_Zero__float_URLConnection_divide_41");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_divide_67a()).runTest("CWE369_Divide_by_Zero__float_random_divide_67a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_divide_10()).runTest("CWE369_Divide_by_Zero__int_console_readLine_divide_10");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_zero_modulo_01()).runTest("CWE369_Divide_by_Zero__float_zero_modulo_01");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_modulo_54a()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_modulo_54a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_modulo_42()).runTest("CWE369_Divide_by_Zero__float_random_modulo_42");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_modulo_08()).runTest("CWE369_Divide_by_Zero__int_database_modulo_08");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_database_divide_10()).runTest("CWE369_Divide_by_Zero__int_database_divide_10");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_divide_09()).runTest("CWE369_Divide_by_Zero__int_File_divide_09");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_connect_tcp_modulo_04()).runTest("CWE369_Divide_by_Zero__int_connect_tcp_modulo_04");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__float_random_modulo_53a()).runTest("CWE369_Divide_by_Zero__float_random_modulo_53a");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_File_modulo_07()).runTest("CWE369_Divide_by_Zero__int_File_modulo_07");
			(new testcases.CWE369_Divide_by_Zero.s02.CWE369_Divide_by_Zero__int_console_readLine_modulo_66a()).runTest("CWE369_Divide_by_Zero__int_console_readLine_modulo_66a");
			/* END-AUTOGENERATED-JAVA-TESTS-3 */
}

private static void runTestCWE4() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-4 */

			/* END-AUTOGENERATED-JAVA-TESTS-4 */
}

private static void runTestCWE5() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-5 */

			/* END-AUTOGENERATED-JAVA-TESTS-5 */
}

private static void runTestCWE6() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-6 */

			/* END-AUTOGENERATED-JAVA-TESTS-6 */
}

private static void runTestCWE7() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-7 */

			/* END-AUTOGENERATED-JAVA-TESTS-7 */
}

private static void runTestCWE8() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-8 */

			/* END-AUTOGENERATED-JAVA-TESTS-8 */
}

private static void runTestCWE9() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-9 */

			/* END-AUTOGENERATED-JAVA-TESTS-9 */
}
}