package testcases.CWE390_Error_Without_Action;

import testcasesupport.*;

public class Main {

	public static void main(String[] args) {
		
		if(args.length != 0) {
		
			if(args[0].equals("-h") || args[0].equals("--help")) {
		
				System.err.println("To use this main, you can either run the program with no " +
				"command line arguments to run all test cases or you can specify one or more classes to test");
				System.err.println("For example:");
				System.err.println("java testcasesupport.Main testcases.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference.custom_function.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference__custom_function_01 testcases.CWE481_Assigning_instead_of_Comparing.bool.CWE481_Assigning_instead_of_Comparing__bool_01");
				System.exit(1);
			}
			
			/* User supplied some class names on the command line, just use those with introspection
			 *
			 * String classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
			 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
 			 * could read class names from command line or use
			 * http://sadun-util.sourceforge.net/api/org/sadun/util/
			 * ClassPackageExplorer.html
			 */

			for (String className : args) {

				try {
					
					/* String classNameWithPackage = "testcases." + className; */
					
					/* IO.writeLine("classNameWithPackage = " + classNameWithPackage); */

					Class<?> myClass = Class.forName(className);

					AbstractTestCase myObject = (AbstractTestCase) myClass
							.newInstance();

					myObject.runTest(className);

				} catch (Exception ex) {

					IO.writeLine("Could not run test for class " + className);
					ex.printStackTrace();

				}
				
				IO.writeLine(""); /* leave a blank line between classes */

			}

		} else {
		
			/* No command line args were used, we want to run every testcase */
			
			/* needed to separate these calls into other methods because
			   we were running into the size limit Java has for a single method */
			runTestCWE1();
			runTestCWE2();
			runTestCWE3();
			runTestCWE4();
			runTestCWE5();
			runTestCWE6();
			runTestCWE7();
			runTestCWE8();
			runTestCWE9();
		}			
	}

private static void runTestCWE1() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-1 */

			/* END-AUTOGENERATED-JAVA-TESTS-1 */
}

private static void runTestCWE2() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-2 */

			/* END-AUTOGENERATED-JAVA-TESTS-2 */
}

private static void runTestCWE3() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-3 */
			(new testcases.CWE390_Error_Without_Action.CWE390_Error_Without_Action__mkdirs_09()).runTest("CWE390_Error_Without_Action__mkdirs_09");
			(new testcases.CWE390_Error_Without_Action.CWE390_Error_Without_Action__mkdirs_08()).runTest("CWE390_Error_Without_Action__mkdirs_08");
			(new testcases.CWE390_Error_Without_Action.CWE390_Error_Without_Action__reader_01()).runTest("CWE390_Error_Without_Action__reader_01");
			(new testcases.CWE390_Error_Without_Action.CWE390_Error_Without_Action__reader_17()).runTest("CWE390_Error_Without_Action__reader_17");
			(new testcases.CWE390_Error_Without_Action.CWE390_Error_Without_Action__mkdirs_17()).runTest("CWE390_Error_Without_Action__mkdirs_17");
			(new testcases.CWE390_Error_Without_Action.CWE390_Error_Without_Action__reader_05()).runTest("CWE390_Error_Without_Action__reader_05");
			(new testcases.CWE390_Error_Without_Action.CWE390_Error_Without_Action__reader_13()).runTest("CWE390_Error_Without_Action__reader_13");
			(new testcases.CWE390_Error_Without_Action.CWE390_Error_Without_Action__mkdirs_03()).runTest("CWE390_Error_Without_Action__mkdirs_03");
			(new testcases.CWE390_Error_Without_Action.CWE390_Error_Without_Action__mkdirs_12()).runTest("CWE390_Error_Without_Action__mkdirs_12");
			(new testcases.CWE390_Error_Without_Action.CWE390_Error_Without_Action__mkdirs_04()).runTest("CWE390_Error_Without_Action__mkdirs_04");
			(new testcases.CWE390_Error_Without_Action.CWE390_Error_Without_Action__mkdirs_06()).runTest("CWE390_Error_Without_Action__mkdirs_06");
			(new testcases.CWE390_Error_Without_Action.CWE390_Error_Without_Action__mkdirs_15()).runTest("CWE390_Error_Without_Action__mkdirs_15");
			(new testcases.CWE390_Error_Without_Action.CWE390_Error_Without_Action__mkdirs_14()).runTest("CWE390_Error_Without_Action__mkdirs_14");
			(new testcases.CWE390_Error_Without_Action.CWE390_Error_Without_Action__mkdirs_11()).runTest("CWE390_Error_Without_Action__mkdirs_11");
			(new testcases.CWE390_Error_Without_Action.CWE390_Error_Without_Action__reader_02()).runTest("CWE390_Error_Without_Action__reader_02");
			(new testcases.CWE390_Error_Without_Action.CWE390_Error_Without_Action__mkdirs_16()).runTest("CWE390_Error_Without_Action__mkdirs_16");
			(new testcases.CWE390_Error_Without_Action.CWE390_Error_Without_Action__mkdirs_05()).runTest("CWE390_Error_Without_Action__mkdirs_05");
			(new testcases.CWE390_Error_Without_Action.CWE390_Error_Without_Action__reader_09()).runTest("CWE390_Error_Without_Action__reader_09");
			(new testcases.CWE390_Error_Without_Action.CWE390_Error_Without_Action__reader_11()).runTest("CWE390_Error_Without_Action__reader_11");
			(new testcases.CWE390_Error_Without_Action.CWE390_Error_Without_Action__mkdirs_10()).runTest("CWE390_Error_Without_Action__mkdirs_10");
			(new testcases.CWE390_Error_Without_Action.CWE390_Error_Without_Action__reader_03()).runTest("CWE390_Error_Without_Action__reader_03");
			(new testcases.CWE390_Error_Without_Action.CWE390_Error_Without_Action__mkdirs_02()).runTest("CWE390_Error_Without_Action__mkdirs_02");
			(new testcases.CWE390_Error_Without_Action.CWE390_Error_Without_Action__reader_12()).runTest("CWE390_Error_Without_Action__reader_12");
			(new testcases.CWE390_Error_Without_Action.CWE390_Error_Without_Action__reader_07()).runTest("CWE390_Error_Without_Action__reader_07");
			(new testcases.CWE390_Error_Without_Action.CWE390_Error_Without_Action__reader_08()).runTest("CWE390_Error_Without_Action__reader_08");
			(new testcases.CWE390_Error_Without_Action.CWE390_Error_Without_Action__reader_06()).runTest("CWE390_Error_Without_Action__reader_06");
			(new testcases.CWE390_Error_Without_Action.CWE390_Error_Without_Action__mkdirs_07()).runTest("CWE390_Error_Without_Action__mkdirs_07");
			(new testcases.CWE390_Error_Without_Action.CWE390_Error_Without_Action__reader_04()).runTest("CWE390_Error_Without_Action__reader_04");
			(new testcases.CWE390_Error_Without_Action.CWE390_Error_Without_Action__reader_15()).runTest("CWE390_Error_Without_Action__reader_15");
			(new testcases.CWE390_Error_Without_Action.CWE390_Error_Without_Action__mkdirs_01()).runTest("CWE390_Error_Without_Action__mkdirs_01");
			(new testcases.CWE390_Error_Without_Action.CWE390_Error_Without_Action__reader_14()).runTest("CWE390_Error_Without_Action__reader_14");
			(new testcases.CWE390_Error_Without_Action.CWE390_Error_Without_Action__reader_10()).runTest("CWE390_Error_Without_Action__reader_10");
			(new testcases.CWE390_Error_Without_Action.CWE390_Error_Without_Action__mkdirs_13()).runTest("CWE390_Error_Without_Action__mkdirs_13");
			(new testcases.CWE390_Error_Without_Action.CWE390_Error_Without_Action__reader_16()).runTest("CWE390_Error_Without_Action__reader_16");
			/* END-AUTOGENERATED-JAVA-TESTS-3 */
}

private static void runTestCWE4() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-4 */

			/* END-AUTOGENERATED-JAVA-TESTS-4 */
}

private static void runTestCWE5() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-5 */

			/* END-AUTOGENERATED-JAVA-TESTS-5 */
}

private static void runTestCWE6() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-6 */

			/* END-AUTOGENERATED-JAVA-TESTS-6 */
}

private static void runTestCWE7() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-7 */

			/* END-AUTOGENERATED-JAVA-TESTS-7 */
}

private static void runTestCWE8() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-8 */

			/* END-AUTOGENERATED-JAVA-TESTS-8 */
}

private static void runTestCWE9() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-9 */

			/* END-AUTOGENERATED-JAVA-TESTS-9 */
}
}