package testcases.CWE398_Poor_Code_Quality;

import testcasesupport.*;

public class Main {

	public static void main(String[] args) {
		
		if(args.length != 0) {
		
			if(args[0].equals("-h") || args[0].equals("--help")) {
		
				System.err.println("To use this main, you can either run the program with no " +
				"command line arguments to run all test cases or you can specify one or more classes to test");
				System.err.println("For example:");
				System.err.println("java testcasesupport.Main testcases.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference.custom_function.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference__custom_function_01 testcases.CWE481_Assigning_instead_of_Comparing.bool.CWE481_Assigning_instead_of_Comparing__bool_01");
				System.exit(1);
			}
			
			/* User supplied some class names on the command line, just use those with introspection
			 *
			 * String classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
			 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
 			 * could read class names from command line or use
			 * http://sadun-util.sourceforge.net/api/org/sadun/util/
			 * ClassPackageExplorer.html
			 */

			for (String className : args) {

				try {
					
					/* String classNameWithPackage = "testcases." + className; */
					
					/* IO.writeLine("classNameWithPackage = " + classNameWithPackage); */

					Class<?> myClass = Class.forName(className);

					AbstractTestCase myObject = (AbstractTestCase) myClass
							.newInstance();

					myObject.runTest(className);

				} catch (Exception ex) {

					IO.writeLine("Could not run test for class " + className);
					ex.printStackTrace();

				}
				
				IO.writeLine(""); /* leave a blank line between classes */

			}

		} else {
		
			/* No command line args were used, we want to run every testcase */
			
			/* needed to separate these calls into other methods because
			   we were running into the size limit Java has for a single method */
			runTestCWE1();
			runTestCWE2();
			runTestCWE3();
			runTestCWE4();
			runTestCWE5();
			runTestCWE6();
			runTestCWE7();
			runTestCWE8();
			runTestCWE9();
		}			
	}

private static void runTestCWE1() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-1 */

			/* END-AUTOGENERATED-JAVA-TESTS-1 */
}

private static void runTestCWE2() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-2 */

			/* END-AUTOGENERATED-JAVA-TESTS-2 */
}

private static void runTestCWE3() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-3 */
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__semicolon_04()).runTest("CWE398_Poor_Code_Quality__semicolon_04");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__semicolon_11()).runTest("CWE398_Poor_Code_Quality__semicolon_11");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_for_02()).runTest("CWE398_Poor_Code_Quality__empty_for_02");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_for_06()).runTest("CWE398_Poor_Code_Quality__empty_for_06");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__semicolon_07()).runTest("CWE398_Poor_Code_Quality__semicolon_07");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_else_12()).runTest("CWE398_Poor_Code_Quality__empty_else_12");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_while_11()).runTest("CWE398_Poor_Code_Quality__empty_while_11");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_else_07()).runTest("CWE398_Poor_Code_Quality__empty_else_07");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_if_08()).runTest("CWE398_Poor_Code_Quality__empty_if_08");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_block_12()).runTest("CWE398_Poor_Code_Quality__empty_block_12");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_else_02()).runTest("CWE398_Poor_Code_Quality__empty_else_02");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_case_12()).runTest("CWE398_Poor_Code_Quality__empty_case_12");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__equals_17()).runTest("CWE398_Poor_Code_Quality__equals_17");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_else_11()).runTest("CWE398_Poor_Code_Quality__empty_else_11");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_if_11()).runTest("CWE398_Poor_Code_Quality__empty_if_11");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__equals_01()).runTest("CWE398_Poor_Code_Quality__equals_01");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_block_15()).runTest("CWE398_Poor_Code_Quality__empty_block_15");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__semicolon_01()).runTest("CWE398_Poor_Code_Quality__semicolon_01");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_while_16()).runTest("CWE398_Poor_Code_Quality__empty_while_16");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_block_13()).runTest("CWE398_Poor_Code_Quality__empty_block_13");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_block_01()).runTest("CWE398_Poor_Code_Quality__empty_block_01");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_for_01()).runTest("CWE398_Poor_Code_Quality__empty_for_01");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_for_08()).runTest("CWE398_Poor_Code_Quality__empty_for_08");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_for_05()).runTest("CWE398_Poor_Code_Quality__empty_for_05");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_if_17()).runTest("CWE398_Poor_Code_Quality__empty_if_17");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_case_17()).runTest("CWE398_Poor_Code_Quality__empty_case_17");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_case_16()).runTest("CWE398_Poor_Code_Quality__empty_case_16");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_while_02()).runTest("CWE398_Poor_Code_Quality__empty_while_02");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_while_12()).runTest("CWE398_Poor_Code_Quality__empty_while_12");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_case_02()).runTest("CWE398_Poor_Code_Quality__empty_case_02");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__equals_05()).runTest("CWE398_Poor_Code_Quality__equals_05");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__equals_02()).runTest("CWE398_Poor_Code_Quality__equals_02");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__semicolon_13()).runTest("CWE398_Poor_Code_Quality__semicolon_13");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_else_10()).runTest("CWE398_Poor_Code_Quality__empty_else_10");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_if_12()).runTest("CWE398_Poor_Code_Quality__empty_if_12");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__equals_16()).runTest("CWE398_Poor_Code_Quality__equals_16");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_case_06()).runTest("CWE398_Poor_Code_Quality__empty_case_06");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_case_04()).runTest("CWE398_Poor_Code_Quality__empty_case_04");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_if_01()).runTest("CWE398_Poor_Code_Quality__empty_if_01");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_if_09()).runTest("CWE398_Poor_Code_Quality__empty_if_09");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_if_02()).runTest("CWE398_Poor_Code_Quality__empty_if_02");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__equals_06()).runTest("CWE398_Poor_Code_Quality__equals_06");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_block_08()).runTest("CWE398_Poor_Code_Quality__empty_block_08");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_while_03()).runTest("CWE398_Poor_Code_Quality__empty_while_03");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_block_11()).runTest("CWE398_Poor_Code_Quality__empty_block_11");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_for_09()).runTest("CWE398_Poor_Code_Quality__empty_for_09");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_block_06()).runTest("CWE398_Poor_Code_Quality__empty_block_06");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__semicolon_03()).runTest("CWE398_Poor_Code_Quality__semicolon_03");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_while_09()).runTest("CWE398_Poor_Code_Quality__empty_while_09");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__equals_03()).runTest("CWE398_Poor_Code_Quality__equals_03");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__semicolon_08()).runTest("CWE398_Poor_Code_Quality__semicolon_08");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_case_13()).runTest("CWE398_Poor_Code_Quality__empty_case_13");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_if_05()).runTest("CWE398_Poor_Code_Quality__empty_if_05");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__semicolon_05()).runTest("CWE398_Poor_Code_Quality__semicolon_05");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_else_03()).runTest("CWE398_Poor_Code_Quality__empty_else_03");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_while_17()).runTest("CWE398_Poor_Code_Quality__empty_while_17");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_block_03()).runTest("CWE398_Poor_Code_Quality__empty_block_03");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__equals_10()).runTest("CWE398_Poor_Code_Quality__equals_10");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__equals_13()).runTest("CWE398_Poor_Code_Quality__equals_13");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_case_09()).runTest("CWE398_Poor_Code_Quality__empty_case_09");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_while_01()).runTest("CWE398_Poor_Code_Quality__empty_while_01");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__semicolon_09()).runTest("CWE398_Poor_Code_Quality__semicolon_09");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_block_05()).runTest("CWE398_Poor_Code_Quality__empty_block_05");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_while_05()).runTest("CWE398_Poor_Code_Quality__empty_while_05");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_while_15()).runTest("CWE398_Poor_Code_Quality__empty_while_15");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_for_17()).runTest("CWE398_Poor_Code_Quality__empty_for_17");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_for_10()).runTest("CWE398_Poor_Code_Quality__empty_for_10");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_case_15()).runTest("CWE398_Poor_Code_Quality__empty_case_15");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_else_05()).runTest("CWE398_Poor_Code_Quality__empty_else_05");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_if_10()).runTest("CWE398_Poor_Code_Quality__empty_if_10");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_for_16()).runTest("CWE398_Poor_Code_Quality__empty_for_16");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_while_08()).runTest("CWE398_Poor_Code_Quality__empty_while_08");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_block_14()).runTest("CWE398_Poor_Code_Quality__empty_block_14");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_else_14()).runTest("CWE398_Poor_Code_Quality__empty_else_14");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_if_13()).runTest("CWE398_Poor_Code_Quality__empty_if_13");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_block_02()).runTest("CWE398_Poor_Code_Quality__empty_block_02");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_if_06()).runTest("CWE398_Poor_Code_Quality__empty_if_06");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_else_17()).runTest("CWE398_Poor_Code_Quality__empty_else_17");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__equals_14()).runTest("CWE398_Poor_Code_Quality__equals_14");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_block_09()).runTest("CWE398_Poor_Code_Quality__empty_block_09");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__equals_09()).runTest("CWE398_Poor_Code_Quality__equals_09");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_if_07()).runTest("CWE398_Poor_Code_Quality__empty_if_07");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_if_03()).runTest("CWE398_Poor_Code_Quality__empty_if_03");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_block_16()).runTest("CWE398_Poor_Code_Quality__empty_block_16");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_case_08()).runTest("CWE398_Poor_Code_Quality__empty_case_08");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_while_14()).runTest("CWE398_Poor_Code_Quality__empty_while_14");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_if_16()).runTest("CWE398_Poor_Code_Quality__empty_if_16");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_for_15()).runTest("CWE398_Poor_Code_Quality__empty_for_15");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__semicolon_06()).runTest("CWE398_Poor_Code_Quality__semicolon_06");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__equals_08()).runTest("CWE398_Poor_Code_Quality__equals_08");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_for_07()).runTest("CWE398_Poor_Code_Quality__empty_for_07");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_else_08()).runTest("CWE398_Poor_Code_Quality__empty_else_08");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_case_01()).runTest("CWE398_Poor_Code_Quality__empty_case_01");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__equals_04()).runTest("CWE398_Poor_Code_Quality__equals_04");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_for_11()).runTest("CWE398_Poor_Code_Quality__empty_for_11");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_else_13()).runTest("CWE398_Poor_Code_Quality__empty_else_13");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_block_07()).runTest("CWE398_Poor_Code_Quality__empty_block_07");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__equals_12()).runTest("CWE398_Poor_Code_Quality__equals_12");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__semicolon_02()).runTest("CWE398_Poor_Code_Quality__semicolon_02");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__equals_07()).runTest("CWE398_Poor_Code_Quality__equals_07");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_else_01()).runTest("CWE398_Poor_Code_Quality__empty_else_01");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_else_06()).runTest("CWE398_Poor_Code_Quality__empty_else_06");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_while_04()).runTest("CWE398_Poor_Code_Quality__empty_while_04");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_else_15()).runTest("CWE398_Poor_Code_Quality__empty_else_15");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__semicolon_12()).runTest("CWE398_Poor_Code_Quality__semicolon_12");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_case_14()).runTest("CWE398_Poor_Code_Quality__empty_case_14");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_for_03()).runTest("CWE398_Poor_Code_Quality__empty_for_03");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_else_16()).runTest("CWE398_Poor_Code_Quality__empty_else_16");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__semicolon_14()).runTest("CWE398_Poor_Code_Quality__semicolon_14");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_for_13()).runTest("CWE398_Poor_Code_Quality__empty_for_13");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_for_04()).runTest("CWE398_Poor_Code_Quality__empty_for_04");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_else_09()).runTest("CWE398_Poor_Code_Quality__empty_else_09");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_block_17()).runTest("CWE398_Poor_Code_Quality__empty_block_17");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_while_13()).runTest("CWE398_Poor_Code_Quality__empty_while_13");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_while_07()).runTest("CWE398_Poor_Code_Quality__empty_while_07");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_if_14()).runTest("CWE398_Poor_Code_Quality__empty_if_14");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__semicolon_16()).runTest("CWE398_Poor_Code_Quality__semicolon_16");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_case_05()).runTest("CWE398_Poor_Code_Quality__empty_case_05");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__semicolon_17()).runTest("CWE398_Poor_Code_Quality__semicolon_17");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__equals_15()).runTest("CWE398_Poor_Code_Quality__equals_15");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_if_15()).runTest("CWE398_Poor_Code_Quality__empty_if_15");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__equals_11()).runTest("CWE398_Poor_Code_Quality__equals_11");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__semicolon_15()).runTest("CWE398_Poor_Code_Quality__semicolon_15");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_while_06()).runTest("CWE398_Poor_Code_Quality__empty_while_06");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_case_11()).runTest("CWE398_Poor_Code_Quality__empty_case_11");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_case_03()).runTest("CWE398_Poor_Code_Quality__empty_case_03");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_if_04()).runTest("CWE398_Poor_Code_Quality__empty_if_04");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_case_10()).runTest("CWE398_Poor_Code_Quality__empty_case_10");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_block_04()).runTest("CWE398_Poor_Code_Quality__empty_block_04");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_for_12()).runTest("CWE398_Poor_Code_Quality__empty_for_12");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_block_10()).runTest("CWE398_Poor_Code_Quality__empty_block_10");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_case_07()).runTest("CWE398_Poor_Code_Quality__empty_case_07");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_function_01()).runTest("CWE398_Poor_Code_Quality__empty_function_01");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_for_14()).runTest("CWE398_Poor_Code_Quality__empty_for_14");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_while_10()).runTest("CWE398_Poor_Code_Quality__empty_while_10");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__empty_else_04()).runTest("CWE398_Poor_Code_Quality__empty_else_04");
			(new testcases.CWE398_Poor_Code_Quality.CWE398_Poor_Code_Quality__semicolon_10()).runTest("CWE398_Poor_Code_Quality__semicolon_10");
			/* END-AUTOGENERATED-JAVA-TESTS-3 */
}

private static void runTestCWE4() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-4 */

			/* END-AUTOGENERATED-JAVA-TESTS-4 */
}

private static void runTestCWE5() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-5 */

			/* END-AUTOGENERATED-JAVA-TESTS-5 */
}

private static void runTestCWE6() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-6 */

			/* END-AUTOGENERATED-JAVA-TESTS-6 */
}

private static void runTestCWE7() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-7 */

			/* END-AUTOGENERATED-JAVA-TESTS-7 */
}

private static void runTestCWE8() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-8 */

			/* END-AUTOGENERATED-JAVA-TESTS-8 */
}

private static void runTestCWE9() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-9 */

			/* END-AUTOGENERATED-JAVA-TESTS-9 */
}
}