package testcases.CWE400_Resource_Exhaustion.s01;

import testcasesupport.*;

public class Main {

	public static void main(String[] args) {
		
		if(args.length != 0) {
		
			if(args[0].equals("-h") || args[0].equals("--help")) {
		
				System.err.println("To use this main, you can either run the program with no " +
				"command line arguments to run all test cases or you can specify one or more classes to test");
				System.err.println("For example:");
				System.err.println("java testcasesupport.Main testcases.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference.custom_function.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference__custom_function_01 testcases.CWE481_Assigning_instead_of_Comparing.bool.CWE481_Assigning_instead_of_Comparing__bool_01");
				System.exit(1);
			}
			
			/* User supplied some class names on the command line, just use those with introspection
			 *
			 * String classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
			 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
 			 * could read class names from command line or use
			 * http://sadun-util.sourceforge.net/api/org/sadun/util/
			 * ClassPackageExplorer.html
			 */

			for (String className : args) {

				try {
					
					/* String classNameWithPackage = "testcases." + className; */
					
					/* IO.writeLine("classNameWithPackage = " + classNameWithPackage); */

					Class<?> myClass = Class.forName(className);

					AbstractTestCase myObject = (AbstractTestCase) myClass
							.newInstance();

					myObject.runTest(className);

				} catch (Exception ex) {

					IO.writeLine("Could not run test for class " + className);
					ex.printStackTrace();

				}
				
				IO.writeLine(""); /* leave a blank line between classes */

			}

		} else {
		
			/* No command line args were used, we want to run every testcase */
			
			/* needed to separate these calls into other methods because
			   we were running into the size limit Java has for a single method */
			runTestCWE1();
			runTestCWE2();
			runTestCWE3();
			runTestCWE4();
			runTestCWE5();
			runTestCWE6();
			runTestCWE7();
			runTestCWE8();
			runTestCWE9();
		}			
	}

private static void runTestCWE1() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-1 */

			/* END-AUTOGENERATED-JAVA-TESTS-1 */
}

private static void runTestCWE2() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-2 */

			/* END-AUTOGENERATED-JAVA-TESTS-2 */
}

private static void runTestCWE3() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-3 */

			/* END-AUTOGENERATED-JAVA-TESTS-3 */
}

private static void runTestCWE4() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-4 */
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_for_loop_72a()).runTest("CWE400_Resource_Exhaustion__File_for_loop_72a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_write_81a()).runTest("CWE400_Resource_Exhaustion__Environment_write_81a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_for_loop_67a()).runTest("CWE400_Resource_Exhaustion__Environment_for_loop_67a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_for_loop_52a()).runTest("CWE400_Resource_Exhaustion__database_for_loop_52a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_for_loop_04()).runTest("CWE400_Resource_Exhaustion__console_readLine_for_loop_04");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_write_74a()).runTest("CWE400_Resource_Exhaustion__File_write_74a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_write_22a()).runTest("CWE400_Resource_Exhaustion__console_readLine_write_22a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_for_loop_02()).runTest("CWE400_Resource_Exhaustion__console_readLine_for_loop_02");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_write_17()).runTest("CWE400_Resource_Exhaustion__database_write_17");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_write_14()).runTest("CWE400_Resource_Exhaustion__File_write_14");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_for_loop_71a()).runTest("CWE400_Resource_Exhaustion__File_for_loop_71a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_write_75a()).runTest("CWE400_Resource_Exhaustion__connect_tcp_write_75a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_write_66a()).runTest("CWE400_Resource_Exhaustion__console_readLine_write_66a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_for_loop_03()).runTest("CWE400_Resource_Exhaustion__console_readLine_for_loop_03");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_for_loop_08()).runTest("CWE400_Resource_Exhaustion__console_readLine_for_loop_08");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_for_loop_67a()).runTest("CWE400_Resource_Exhaustion__console_readLine_for_loop_67a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_write_01()).runTest("CWE400_Resource_Exhaustion__console_readLine_write_01");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_for_loop_41()).runTest("CWE400_Resource_Exhaustion__connect_tcp_for_loop_41");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_for_loop_03()).runTest("CWE400_Resource_Exhaustion__File_for_loop_03");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_for_loop_17()).runTest("CWE400_Resource_Exhaustion__Environment_for_loop_17");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_for_loop_72a()).runTest("CWE400_Resource_Exhaustion__database_for_loop_72a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_write_21()).runTest("CWE400_Resource_Exhaustion__console_readLine_write_21");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_for_loop_15()).runTest("CWE400_Resource_Exhaustion__connect_tcp_for_loop_15");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_write_05()).runTest("CWE400_Resource_Exhaustion__database_write_05");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_write_01()).runTest("CWE400_Resource_Exhaustion__database_write_01");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_for_loop_10()).runTest("CWE400_Resource_Exhaustion__Environment_for_loop_10");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_write_71a()).runTest("CWE400_Resource_Exhaustion__console_readLine_write_71a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_write_72a()).runTest("CWE400_Resource_Exhaustion__database_write_72a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_write_15()).runTest("CWE400_Resource_Exhaustion__connect_tcp_write_15");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_write_42()).runTest("CWE400_Resource_Exhaustion__console_readLine_write_42");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_for_loop_05()).runTest("CWE400_Resource_Exhaustion__Environment_for_loop_05");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_for_loop_31()).runTest("CWE400_Resource_Exhaustion__File_for_loop_31");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_write_03()).runTest("CWE400_Resource_Exhaustion__database_write_03");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_write_71a()).runTest("CWE400_Resource_Exhaustion__File_write_71a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_for_loop_54a()).runTest("CWE400_Resource_Exhaustion__database_for_loop_54a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_for_loop_75a()).runTest("CWE400_Resource_Exhaustion__Environment_for_loop_75a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_write_17()).runTest("CWE400_Resource_Exhaustion__File_write_17");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_for_loop_54a()).runTest("CWE400_Resource_Exhaustion__Environment_for_loop_54a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_write_16()).runTest("CWE400_Resource_Exhaustion__connect_tcp_write_16");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_for_loop_68a()).runTest("CWE400_Resource_Exhaustion__Environment_for_loop_68a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_write_04()).runTest("CWE400_Resource_Exhaustion__File_write_04");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_write_06()).runTest("CWE400_Resource_Exhaustion__database_write_06");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_write_16()).runTest("CWE400_Resource_Exhaustion__File_write_16");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_for_loop_75a()).runTest("CWE400_Resource_Exhaustion__connect_tcp_for_loop_75a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_for_loop_01()).runTest("CWE400_Resource_Exhaustion__database_for_loop_01");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_for_loop_04()).runTest("CWE400_Resource_Exhaustion__Environment_for_loop_04");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_for_loop_74a()).runTest("CWE400_Resource_Exhaustion__database_for_loop_74a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_write_08()).runTest("CWE400_Resource_Exhaustion__File_write_08");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_write_53a()).runTest("CWE400_Resource_Exhaustion__console_readLine_write_53a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_write_21()).runTest("CWE400_Resource_Exhaustion__connect_tcp_write_21");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_write_67a()).runTest("CWE400_Resource_Exhaustion__database_write_67a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_write_12()).runTest("CWE400_Resource_Exhaustion__Environment_write_12");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_write_67a()).runTest("CWE400_Resource_Exhaustion__console_readLine_write_67a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_write_04()).runTest("CWE400_Resource_Exhaustion__console_readLine_write_04");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_write_45()).runTest("CWE400_Resource_Exhaustion__database_write_45");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_write_05()).runTest("CWE400_Resource_Exhaustion__connect_tcp_write_05");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_write_04()).runTest("CWE400_Resource_Exhaustion__Environment_write_04");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_for_loop_21()).runTest("CWE400_Resource_Exhaustion__connect_tcp_for_loop_21");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_write_51a()).runTest("CWE400_Resource_Exhaustion__console_readLine_write_51a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_write_73a()).runTest("CWE400_Resource_Exhaustion__File_write_73a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_for_loop_54a()).runTest("CWE400_Resource_Exhaustion__connect_tcp_for_loop_54a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_write_16()).runTest("CWE400_Resource_Exhaustion__database_write_16");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_for_loop_81a()).runTest("CWE400_Resource_Exhaustion__connect_tcp_for_loop_81a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_for_loop_11()).runTest("CWE400_Resource_Exhaustion__File_for_loop_11");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_write_75a()).runTest("CWE400_Resource_Exhaustion__Environment_write_75a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_for_loop_73a()).runTest("CWE400_Resource_Exhaustion__database_for_loop_73a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_for_loop_21()).runTest("CWE400_Resource_Exhaustion__console_readLine_for_loop_21");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_write_66a()).runTest("CWE400_Resource_Exhaustion__File_write_66a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_write_73a()).runTest("CWE400_Resource_Exhaustion__database_write_73a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_write_05()).runTest("CWE400_Resource_Exhaustion__File_write_05");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_write_01()).runTest("CWE400_Resource_Exhaustion__connect_tcp_write_01");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_for_loop_74a()).runTest("CWE400_Resource_Exhaustion__Environment_for_loop_74a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_for_loop_12()).runTest("CWE400_Resource_Exhaustion__Environment_for_loop_12");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_write_13()).runTest("CWE400_Resource_Exhaustion__File_write_13");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_write_16()).runTest("CWE400_Resource_Exhaustion__console_readLine_write_16");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_for_loop_42()).runTest("CWE400_Resource_Exhaustion__connect_tcp_for_loop_42");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_write_71a()).runTest("CWE400_Resource_Exhaustion__Environment_write_71a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_write_10()).runTest("CWE400_Resource_Exhaustion__console_readLine_write_10");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_for_loop_81a()).runTest("CWE400_Resource_Exhaustion__Environment_for_loop_81a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_write_08()).runTest("CWE400_Resource_Exhaustion__Environment_write_08");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_write_72a()).runTest("CWE400_Resource_Exhaustion__console_readLine_write_72a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_write_02()).runTest("CWE400_Resource_Exhaustion__connect_tcp_write_02");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_for_loop_03()).runTest("CWE400_Resource_Exhaustion__connect_tcp_for_loop_03");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_write_72a()).runTest("CWE400_Resource_Exhaustion__connect_tcp_write_72a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_write_01()).runTest("CWE400_Resource_Exhaustion__File_write_01");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_for_loop_74a()).runTest("CWE400_Resource_Exhaustion__File_for_loop_74a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_write_21()).runTest("CWE400_Resource_Exhaustion__Environment_write_21");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_for_loop_42()).runTest("CWE400_Resource_Exhaustion__database_for_loop_42");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_write_75a()).runTest("CWE400_Resource_Exhaustion__database_write_75a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_for_loop_21()).runTest("CWE400_Resource_Exhaustion__database_for_loop_21");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_for_loop_22a()).runTest("CWE400_Resource_Exhaustion__Environment_for_loop_22a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_write_05()).runTest("CWE400_Resource_Exhaustion__console_readLine_write_05");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_for_loop_45()).runTest("CWE400_Resource_Exhaustion__File_for_loop_45");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_for_loop_71a()).runTest("CWE400_Resource_Exhaustion__connect_tcp_for_loop_71a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_write_14()).runTest("CWE400_Resource_Exhaustion__connect_tcp_write_14");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_for_loop_31()).runTest("CWE400_Resource_Exhaustion__Environment_for_loop_31");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_write_11()).runTest("CWE400_Resource_Exhaustion__console_readLine_write_11");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_for_loop_06()).runTest("CWE400_Resource_Exhaustion__console_readLine_for_loop_06");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_write_68a()).runTest("CWE400_Resource_Exhaustion__database_write_68a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_write_72a()).runTest("CWE400_Resource_Exhaustion__File_write_72a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_write_54a()).runTest("CWE400_Resource_Exhaustion__File_write_54a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_for_loop_68a()).runTest("CWE400_Resource_Exhaustion__connect_tcp_for_loop_68a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_write_41()).runTest("CWE400_Resource_Exhaustion__File_write_41");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_write_10()).runTest("CWE400_Resource_Exhaustion__database_write_10");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_for_loop_74a()).runTest("CWE400_Resource_Exhaustion__connect_tcp_for_loop_74a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_write_53a()).runTest("CWE400_Resource_Exhaustion__Environment_write_53a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_for_loop_14()).runTest("CWE400_Resource_Exhaustion__console_readLine_for_loop_14");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_write_75a()).runTest("CWE400_Resource_Exhaustion__console_readLine_write_75a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_write_02()).runTest("CWE400_Resource_Exhaustion__console_readLine_write_02");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_write_61a()).runTest("CWE400_Resource_Exhaustion__File_write_61a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_write_13()).runTest("CWE400_Resource_Exhaustion__Environment_write_13");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_for_loop_67a()).runTest("CWE400_Resource_Exhaustion__database_for_loop_67a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_write_13()).runTest("CWE400_Resource_Exhaustion__database_write_13");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_write_04()).runTest("CWE400_Resource_Exhaustion__database_write_04");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_for_loop_71a()).runTest("CWE400_Resource_Exhaustion__Environment_for_loop_71a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_for_loop_31()).runTest("CWE400_Resource_Exhaustion__connect_tcp_for_loop_31");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_for_loop_12()).runTest("CWE400_Resource_Exhaustion__database_for_loop_12");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_for_loop_66a()).runTest("CWE400_Resource_Exhaustion__connect_tcp_for_loop_66a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_for_loop_51a()).runTest("CWE400_Resource_Exhaustion__console_readLine_for_loop_51a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_for_loop_11()).runTest("CWE400_Resource_Exhaustion__connect_tcp_for_loop_11");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_for_loop_22a()).runTest("CWE400_Resource_Exhaustion__console_readLine_for_loop_22a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_for_loop_09()).runTest("CWE400_Resource_Exhaustion__connect_tcp_for_loop_09");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_write_22a()).runTest("CWE400_Resource_Exhaustion__database_write_22a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_for_loop_06()).runTest("CWE400_Resource_Exhaustion__Environment_for_loop_06");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_for_loop_75a()).runTest("CWE400_Resource_Exhaustion__database_for_loop_75a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_for_loop_01()).runTest("CWE400_Resource_Exhaustion__File_for_loop_01");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_for_loop_61a()).runTest("CWE400_Resource_Exhaustion__connect_tcp_for_loop_61a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_write_08()).runTest("CWE400_Resource_Exhaustion__console_readLine_write_08");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_for_loop_07()).runTest("CWE400_Resource_Exhaustion__Environment_for_loop_07");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_for_loop_10()).runTest("CWE400_Resource_Exhaustion__console_readLine_for_loop_10");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_write_22a()).runTest("CWE400_Resource_Exhaustion__File_write_22a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_for_loop_66a()).runTest("CWE400_Resource_Exhaustion__database_for_loop_66a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_for_loop_66a()).runTest("CWE400_Resource_Exhaustion__Environment_for_loop_66a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_for_loop_03()).runTest("CWE400_Resource_Exhaustion__Environment_for_loop_03");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_for_loop_51a()).runTest("CWE400_Resource_Exhaustion__connect_tcp_for_loop_51a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_write_07()).runTest("CWE400_Resource_Exhaustion__connect_tcp_write_07");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_for_loop_52a()).runTest("CWE400_Resource_Exhaustion__Environment_for_loop_52a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_for_loop_07()).runTest("CWE400_Resource_Exhaustion__database_for_loop_07");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_write_51a()).runTest("CWE400_Resource_Exhaustion__connect_tcp_write_51a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_for_loop_04()).runTest("CWE400_Resource_Exhaustion__connect_tcp_for_loop_04");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_for_loop_67a()).runTest("CWE400_Resource_Exhaustion__File_for_loop_67a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_for_loop_53a()).runTest("CWE400_Resource_Exhaustion__database_for_loop_53a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_write_09()).runTest("CWE400_Resource_Exhaustion__File_write_09");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_write_73a()).runTest("CWE400_Resource_Exhaustion__connect_tcp_write_73a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_for_loop_01()).runTest("CWE400_Resource_Exhaustion__Environment_for_loop_01");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_for_loop_68a()).runTest("CWE400_Resource_Exhaustion__database_for_loop_68a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_for_loop_05()).runTest("CWE400_Resource_Exhaustion__connect_tcp_for_loop_05");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_for_loop_09()).runTest("CWE400_Resource_Exhaustion__console_readLine_for_loop_09");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_for_loop_72a()).runTest("CWE400_Resource_Exhaustion__console_readLine_for_loop_72a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_for_loop_68a()).runTest("CWE400_Resource_Exhaustion__File_for_loop_68a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_for_loop_45()).runTest("CWE400_Resource_Exhaustion__database_for_loop_45");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_for_loop_12()).runTest("CWE400_Resource_Exhaustion__console_readLine_for_loop_12");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_write_74a()).runTest("CWE400_Resource_Exhaustion__Environment_write_74a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_for_loop_13()).runTest("CWE400_Resource_Exhaustion__File_for_loop_13");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_for_loop_15()).runTest("CWE400_Resource_Exhaustion__File_for_loop_15");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_write_09()).runTest("CWE400_Resource_Exhaustion__connect_tcp_write_09");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_write_15()).runTest("CWE400_Resource_Exhaustion__Environment_write_15");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_write_51a()).runTest("CWE400_Resource_Exhaustion__Environment_write_51a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_write_12()).runTest("CWE400_Resource_Exhaustion__database_write_12");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_write_31()).runTest("CWE400_Resource_Exhaustion__database_write_31");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_write_07()).runTest("CWE400_Resource_Exhaustion__Environment_write_07");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_for_loop_22a()).runTest("CWE400_Resource_Exhaustion__File_for_loop_22a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_for_loop_41()).runTest("CWE400_Resource_Exhaustion__Environment_for_loop_41");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_write_10()).runTest("CWE400_Resource_Exhaustion__connect_tcp_write_10");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_write_07()).runTest("CWE400_Resource_Exhaustion__database_write_07");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_write_10()).runTest("CWE400_Resource_Exhaustion__Environment_write_10");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_for_loop_03()).runTest("CWE400_Resource_Exhaustion__database_for_loop_03");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_for_loop_67a()).runTest("CWE400_Resource_Exhaustion__connect_tcp_for_loop_67a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_write_02()).runTest("CWE400_Resource_Exhaustion__database_write_02");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_for_loop_14()).runTest("CWE400_Resource_Exhaustion__connect_tcp_for_loop_14");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_for_loop_22a()).runTest("CWE400_Resource_Exhaustion__database_for_loop_22a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_for_loop_81a()).runTest("CWE400_Resource_Exhaustion__File_for_loop_81a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_write_45()).runTest("CWE400_Resource_Exhaustion__File_write_45");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_for_loop_41()).runTest("CWE400_Resource_Exhaustion__database_for_loop_41");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_for_loop_42()).runTest("CWE400_Resource_Exhaustion__Environment_for_loop_42");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_for_loop_06()).runTest("CWE400_Resource_Exhaustion__connect_tcp_for_loop_06");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_write_12()).runTest("CWE400_Resource_Exhaustion__File_write_12");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_for_loop_02()).runTest("CWE400_Resource_Exhaustion__File_for_loop_02");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_for_loop_16()).runTest("CWE400_Resource_Exhaustion__connect_tcp_for_loop_16");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_write_41()).runTest("CWE400_Resource_Exhaustion__Environment_write_41");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_write_12()).runTest("CWE400_Resource_Exhaustion__connect_tcp_write_12");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_write_54a()).runTest("CWE400_Resource_Exhaustion__connect_tcp_write_54a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_for_loop_66a()).runTest("CWE400_Resource_Exhaustion__console_readLine_for_loop_66a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_for_loop_54a()).runTest("CWE400_Resource_Exhaustion__File_for_loop_54a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_for_loop_17()).runTest("CWE400_Resource_Exhaustion__File_for_loop_17");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_for_loop_51a()).runTest("CWE400_Resource_Exhaustion__File_for_loop_51a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_write_42()).runTest("CWE400_Resource_Exhaustion__Environment_write_42");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_for_loop_07()).runTest("CWE400_Resource_Exhaustion__console_readLine_for_loop_07");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_for_loop_13()).runTest("CWE400_Resource_Exhaustion__connect_tcp_for_loop_13");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_write_14()).runTest("CWE400_Resource_Exhaustion__Environment_write_14");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_for_loop_45()).runTest("CWE400_Resource_Exhaustion__Environment_for_loop_45");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_write_10()).runTest("CWE400_Resource_Exhaustion__File_write_10");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_for_loop_73a()).runTest("CWE400_Resource_Exhaustion__console_readLine_for_loop_73a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_for_loop_41()).runTest("CWE400_Resource_Exhaustion__File_for_loop_41");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_for_loop_05()).runTest("CWE400_Resource_Exhaustion__console_readLine_for_loop_05");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_write_14()).runTest("CWE400_Resource_Exhaustion__database_write_14");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_write_41()).runTest("CWE400_Resource_Exhaustion__console_readLine_write_41");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_write_15()).runTest("CWE400_Resource_Exhaustion__database_write_15");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_write_71a()).runTest("CWE400_Resource_Exhaustion__database_write_71a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_write_72a()).runTest("CWE400_Resource_Exhaustion__Environment_write_72a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_write_61a()).runTest("CWE400_Resource_Exhaustion__Environment_write_61a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_write_04()).runTest("CWE400_Resource_Exhaustion__connect_tcp_write_04");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_write_07()).runTest("CWE400_Resource_Exhaustion__console_readLine_write_07");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_write_09()).runTest("CWE400_Resource_Exhaustion__database_write_09");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_for_loop_51a()).runTest("CWE400_Resource_Exhaustion__Environment_for_loop_51a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_write_51a()).runTest("CWE400_Resource_Exhaustion__database_write_51a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_for_loop_10()).runTest("CWE400_Resource_Exhaustion__File_for_loop_10");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_write_22a()).runTest("CWE400_Resource_Exhaustion__Environment_write_22a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_write_61a()).runTest("CWE400_Resource_Exhaustion__connect_tcp_write_61a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_for_loop_10()).runTest("CWE400_Resource_Exhaustion__database_for_loop_10");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_write_11()).runTest("CWE400_Resource_Exhaustion__database_write_11");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_write_53a()).runTest("CWE400_Resource_Exhaustion__File_write_53a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_write_41()).runTest("CWE400_Resource_Exhaustion__connect_tcp_write_41");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_write_13()).runTest("CWE400_Resource_Exhaustion__connect_tcp_write_13");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_write_13()).runTest("CWE400_Resource_Exhaustion__console_readLine_write_13");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_write_31()).runTest("CWE400_Resource_Exhaustion__console_readLine_write_31");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_write_08()).runTest("CWE400_Resource_Exhaustion__database_write_08");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_write_31()).runTest("CWE400_Resource_Exhaustion__Environment_write_31");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_for_loop_05()).runTest("CWE400_Resource_Exhaustion__database_for_loop_05");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_write_52a()).runTest("CWE400_Resource_Exhaustion__Environment_write_52a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_write_06()).runTest("CWE400_Resource_Exhaustion__Environment_write_06");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_for_loop_06()).runTest("CWE400_Resource_Exhaustion__database_for_loop_06");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_for_loop_16()).runTest("CWE400_Resource_Exhaustion__console_readLine_for_loop_16");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_write_01()).runTest("CWE400_Resource_Exhaustion__Environment_write_01");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_for_loop_42()).runTest("CWE400_Resource_Exhaustion__File_for_loop_42");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_write_61a()).runTest("CWE400_Resource_Exhaustion__database_write_61a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_write_42()).runTest("CWE400_Resource_Exhaustion__database_write_42");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_for_loop_61a()).runTest("CWE400_Resource_Exhaustion__File_for_loop_61a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_for_loop_45()).runTest("CWE400_Resource_Exhaustion__console_readLine_for_loop_45");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_write_42()).runTest("CWE400_Resource_Exhaustion__File_write_42");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_for_loop_16()).runTest("CWE400_Resource_Exhaustion__File_for_loop_16");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_write_14()).runTest("CWE400_Resource_Exhaustion__console_readLine_write_14");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_write_07()).runTest("CWE400_Resource_Exhaustion__File_write_07");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_for_loop_81a()).runTest("CWE400_Resource_Exhaustion__console_readLine_for_loop_81a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_write_15()).runTest("CWE400_Resource_Exhaustion__File_write_15");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_for_loop_05()).runTest("CWE400_Resource_Exhaustion__File_for_loop_05");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_write_17()).runTest("CWE400_Resource_Exhaustion__connect_tcp_write_17");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_for_loop_53a()).runTest("CWE400_Resource_Exhaustion__Environment_for_loop_53a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_for_loop_15()).runTest("CWE400_Resource_Exhaustion__Environment_for_loop_15");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_write_06()).runTest("CWE400_Resource_Exhaustion__connect_tcp_write_06");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_for_loop_61a()).runTest("CWE400_Resource_Exhaustion__database_for_loop_61a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_for_loop_75a()).runTest("CWE400_Resource_Exhaustion__File_for_loop_75a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_for_loop_52a()).runTest("CWE400_Resource_Exhaustion__console_readLine_for_loop_52a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_write_31()).runTest("CWE400_Resource_Exhaustion__File_write_31");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_write_11()).runTest("CWE400_Resource_Exhaustion__File_write_11");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_write_05()).runTest("CWE400_Resource_Exhaustion__Environment_write_05");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_for_loop_09()).runTest("CWE400_Resource_Exhaustion__File_for_loop_09");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_write_74a()).runTest("CWE400_Resource_Exhaustion__connect_tcp_write_74a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_for_loop_04()).runTest("CWE400_Resource_Exhaustion__File_for_loop_04");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_for_loop_01()).runTest("CWE400_Resource_Exhaustion__connect_tcp_for_loop_01");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_write_81a()).runTest("CWE400_Resource_Exhaustion__console_readLine_write_81a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_for_loop_73a()).runTest("CWE400_Resource_Exhaustion__Environment_for_loop_73a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_write_03()).runTest("CWE400_Resource_Exhaustion__Environment_write_03");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_for_loop_11()).runTest("CWE400_Resource_Exhaustion__console_readLine_for_loop_11");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_for_loop_45()).runTest("CWE400_Resource_Exhaustion__connect_tcp_for_loop_45");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_write_68a()).runTest("CWE400_Resource_Exhaustion__File_write_68a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_for_loop_02()).runTest("CWE400_Resource_Exhaustion__Environment_for_loop_02");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_write_17()).runTest("CWE400_Resource_Exhaustion__Environment_write_17");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_write_02()).runTest("CWE400_Resource_Exhaustion__Environment_write_02");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_for_loop_42()).runTest("CWE400_Resource_Exhaustion__console_readLine_for_loop_42");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_for_loop_07()).runTest("CWE400_Resource_Exhaustion__connect_tcp_for_loop_07");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_write_75a()).runTest("CWE400_Resource_Exhaustion__File_write_75a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_write_73a()).runTest("CWE400_Resource_Exhaustion__Environment_write_73a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_for_loop_09()).runTest("CWE400_Resource_Exhaustion__Environment_for_loop_09");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_write_21()).runTest("CWE400_Resource_Exhaustion__database_write_21");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_for_loop_08()).runTest("CWE400_Resource_Exhaustion__database_for_loop_08");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_write_11()).runTest("CWE400_Resource_Exhaustion__Environment_write_11");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_write_06()).runTest("CWE400_Resource_Exhaustion__console_readLine_write_06");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_write_03()).runTest("CWE400_Resource_Exhaustion__File_write_03");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_write_66a()).runTest("CWE400_Resource_Exhaustion__Environment_write_66a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_for_loop_22a()).runTest("CWE400_Resource_Exhaustion__connect_tcp_for_loop_22a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_for_loop_06()).runTest("CWE400_Resource_Exhaustion__File_for_loop_06");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_write_31()).runTest("CWE400_Resource_Exhaustion__connect_tcp_write_31");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_for_loop_66a()).runTest("CWE400_Resource_Exhaustion__File_for_loop_66a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_for_loop_52a()).runTest("CWE400_Resource_Exhaustion__connect_tcp_for_loop_52a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_for_loop_16()).runTest("CWE400_Resource_Exhaustion__database_for_loop_16");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_write_09()).runTest("CWE400_Resource_Exhaustion__console_readLine_write_09");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_for_loop_13()).runTest("CWE400_Resource_Exhaustion__Environment_for_loop_13");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_for_loop_10()).runTest("CWE400_Resource_Exhaustion__connect_tcp_for_loop_10");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_for_loop_04()).runTest("CWE400_Resource_Exhaustion__database_for_loop_04");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_write_66a()).runTest("CWE400_Resource_Exhaustion__connect_tcp_write_66a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_for_loop_61a()).runTest("CWE400_Resource_Exhaustion__console_readLine_for_loop_61a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_write_52a()).runTest("CWE400_Resource_Exhaustion__connect_tcp_write_52a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_for_loop_17()).runTest("CWE400_Resource_Exhaustion__database_for_loop_17");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_write_41()).runTest("CWE400_Resource_Exhaustion__database_write_41");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_write_21()).runTest("CWE400_Resource_Exhaustion__File_write_21");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_write_54a()).runTest("CWE400_Resource_Exhaustion__Environment_write_54a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_write_51a()).runTest("CWE400_Resource_Exhaustion__File_write_51a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_for_loop_81a()).runTest("CWE400_Resource_Exhaustion__database_for_loop_81a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_for_loop_53a()).runTest("CWE400_Resource_Exhaustion__console_readLine_for_loop_53a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_write_54a()).runTest("CWE400_Resource_Exhaustion__database_write_54a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_for_loop_21()).runTest("CWE400_Resource_Exhaustion__File_for_loop_21");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_for_loop_72a()).runTest("CWE400_Resource_Exhaustion__Environment_for_loop_72a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_for_loop_11()).runTest("CWE400_Resource_Exhaustion__Environment_for_loop_11");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_for_loop_71a()).runTest("CWE400_Resource_Exhaustion__database_for_loop_71a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_write_45()).runTest("CWE400_Resource_Exhaustion__connect_tcp_write_45");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_write_45()).runTest("CWE400_Resource_Exhaustion__console_readLine_write_45");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_write_68a()).runTest("CWE400_Resource_Exhaustion__Environment_write_68a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_for_loop_61a()).runTest("CWE400_Resource_Exhaustion__Environment_for_loop_61a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_write_66a()).runTest("CWE400_Resource_Exhaustion__database_write_66a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_write_11()).runTest("CWE400_Resource_Exhaustion__connect_tcp_write_11");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_write_73a()).runTest("CWE400_Resource_Exhaustion__console_readLine_write_73a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_for_loop_21()).runTest("CWE400_Resource_Exhaustion__Environment_for_loop_21");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_write_42()).runTest("CWE400_Resource_Exhaustion__connect_tcp_write_42");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_for_loop_74a()).runTest("CWE400_Resource_Exhaustion__console_readLine_for_loop_74a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_write_67a()).runTest("CWE400_Resource_Exhaustion__connect_tcp_write_67a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_for_loop_52a()).runTest("CWE400_Resource_Exhaustion__File_for_loop_52a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_write_06()).runTest("CWE400_Resource_Exhaustion__File_write_06");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_write_52a()).runTest("CWE400_Resource_Exhaustion__console_readLine_write_52a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_for_loop_68a()).runTest("CWE400_Resource_Exhaustion__console_readLine_for_loop_68a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_for_loop_73a()).runTest("CWE400_Resource_Exhaustion__File_for_loop_73a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_write_02()).runTest("CWE400_Resource_Exhaustion__File_write_02");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_write_81a()).runTest("CWE400_Resource_Exhaustion__File_write_81a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_write_68a()).runTest("CWE400_Resource_Exhaustion__connect_tcp_write_68a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_for_loop_31()).runTest("CWE400_Resource_Exhaustion__console_readLine_for_loop_31");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_write_71a()).runTest("CWE400_Resource_Exhaustion__connect_tcp_write_71a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_write_03()).runTest("CWE400_Resource_Exhaustion__connect_tcp_write_03");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_write_15()).runTest("CWE400_Resource_Exhaustion__console_readLine_write_15");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_write_08()).runTest("CWE400_Resource_Exhaustion__connect_tcp_write_08");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_for_loop_11()).runTest("CWE400_Resource_Exhaustion__database_for_loop_11");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_for_loop_72a()).runTest("CWE400_Resource_Exhaustion__connect_tcp_for_loop_72a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_for_loop_01()).runTest("CWE400_Resource_Exhaustion__console_readLine_for_loop_01");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_write_67a()).runTest("CWE400_Resource_Exhaustion__Environment_write_67a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_for_loop_17()).runTest("CWE400_Resource_Exhaustion__connect_tcp_for_loop_17");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_write_16()).runTest("CWE400_Resource_Exhaustion__Environment_write_16");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_for_loop_13()).runTest("CWE400_Resource_Exhaustion__database_for_loop_13");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_write_17()).runTest("CWE400_Resource_Exhaustion__console_readLine_write_17");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_for_loop_41()).runTest("CWE400_Resource_Exhaustion__console_readLine_for_loop_41");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_write_53a()).runTest("CWE400_Resource_Exhaustion__database_write_53a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_for_loop_71a()).runTest("CWE400_Resource_Exhaustion__console_readLine_for_loop_71a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_for_loop_02()).runTest("CWE400_Resource_Exhaustion__database_for_loop_02");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_for_loop_12()).runTest("CWE400_Resource_Exhaustion__connect_tcp_for_loop_12");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_write_52a()).runTest("CWE400_Resource_Exhaustion__database_write_52a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_write_52a()).runTest("CWE400_Resource_Exhaustion__File_write_52a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_for_loop_53a()).runTest("CWE400_Resource_Exhaustion__File_for_loop_53a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_for_loop_16()).runTest("CWE400_Resource_Exhaustion__Environment_for_loop_16");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_for_loop_54a()).runTest("CWE400_Resource_Exhaustion__console_readLine_for_loop_54a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_for_loop_15()).runTest("CWE400_Resource_Exhaustion__database_for_loop_15");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_write_74a()).runTest("CWE400_Resource_Exhaustion__console_readLine_write_74a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_for_loop_31()).runTest("CWE400_Resource_Exhaustion__database_for_loop_31");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_for_loop_08()).runTest("CWE400_Resource_Exhaustion__Environment_for_loop_08");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_for_loop_53a()).runTest("CWE400_Resource_Exhaustion__connect_tcp_for_loop_53a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_for_loop_12()).runTest("CWE400_Resource_Exhaustion__File_for_loop_12");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_for_loop_17()).runTest("CWE400_Resource_Exhaustion__console_readLine_for_loop_17");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_write_12()).runTest("CWE400_Resource_Exhaustion__console_readLine_write_12");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_for_loop_14()).runTest("CWE400_Resource_Exhaustion__database_for_loop_14");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_for_loop_15()).runTest("CWE400_Resource_Exhaustion__console_readLine_for_loop_15");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_for_loop_08()).runTest("CWE400_Resource_Exhaustion__connect_tcp_for_loop_08");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_for_loop_09()).runTest("CWE400_Resource_Exhaustion__database_for_loop_09");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_for_loop_13()).runTest("CWE400_Resource_Exhaustion__console_readLine_for_loop_13");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_write_61a()).runTest("CWE400_Resource_Exhaustion__console_readLine_write_61a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_write_45()).runTest("CWE400_Resource_Exhaustion__Environment_write_45");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_write_81a()).runTest("CWE400_Resource_Exhaustion__database_write_81a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_write_68a()).runTest("CWE400_Resource_Exhaustion__console_readLine_write_68a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_for_loop_75a()).runTest("CWE400_Resource_Exhaustion__console_readLine_for_loop_75a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_write_09()).runTest("CWE400_Resource_Exhaustion__Environment_write_09");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_write_54a()).runTest("CWE400_Resource_Exhaustion__console_readLine_write_54a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_for_loop_14()).runTest("CWE400_Resource_Exhaustion__File_for_loop_14");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_for_loop_73a()).runTest("CWE400_Resource_Exhaustion__connect_tcp_for_loop_73a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_for_loop_02()).runTest("CWE400_Resource_Exhaustion__connect_tcp_for_loop_02");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__Environment_for_loop_14()).runTest("CWE400_Resource_Exhaustion__Environment_for_loop_14");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__console_readLine_write_03()).runTest("CWE400_Resource_Exhaustion__console_readLine_write_03");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_write_53a()).runTest("CWE400_Resource_Exhaustion__connect_tcp_write_53a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_write_67a()).runTest("CWE400_Resource_Exhaustion__File_write_67a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_write_22a()).runTest("CWE400_Resource_Exhaustion__connect_tcp_write_22a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_for_loop_08()).runTest("CWE400_Resource_Exhaustion__File_for_loop_08");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__File_for_loop_07()).runTest("CWE400_Resource_Exhaustion__File_for_loop_07");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_write_74a()).runTest("CWE400_Resource_Exhaustion__database_write_74a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__database_for_loop_51a()).runTest("CWE400_Resource_Exhaustion__database_for_loop_51a");
			(new testcases.CWE400_Resource_Exhaustion.s01.CWE400_Resource_Exhaustion__connect_tcp_write_81a()).runTest("CWE400_Resource_Exhaustion__connect_tcp_write_81a");
			/* END-AUTOGENERATED-JAVA-TESTS-4 */
}

private static void runTestCWE5() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-5 */

			/* END-AUTOGENERATED-JAVA-TESTS-5 */
}

private static void runTestCWE6() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-6 */

			/* END-AUTOGENERATED-JAVA-TESTS-6 */
}

private static void runTestCWE7() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-7 */

			/* END-AUTOGENERATED-JAVA-TESTS-7 */
}

private static void runTestCWE8() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-8 */

			/* END-AUTOGENERATED-JAVA-TESTS-8 */
}

private static void runTestCWE9() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-9 */

			/* END-AUTOGENERATED-JAVA-TESTS-9 */
}
}