package testcases.CWE400_Resource_Exhaustion.s02;

import testcasesupport.*;

public class Main {

	public static void main(String[] args) {
		
		if(args.length != 0) {
		
			if(args[0].equals("-h") || args[0].equals("--help")) {
		
				System.err.println("To use this main, you can either run the program with no " +
				"command line arguments to run all test cases or you can specify one or more classes to test");
				System.err.println("For example:");
				System.err.println("java testcasesupport.Main testcases.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference.custom_function.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference__custom_function_01 testcases.CWE481_Assigning_instead_of_Comparing.bool.CWE481_Assigning_instead_of_Comparing__bool_01");
				System.exit(1);
			}
			
			/* User supplied some class names on the command line, just use those with introspection
			 *
			 * String classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
			 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
 			 * could read class names from command line or use
			 * http://sadun-util.sourceforge.net/api/org/sadun/util/
			 * ClassPackageExplorer.html
			 */

			for (String className : args) {

				try {
					
					/* String classNameWithPackage = "testcases." + className; */
					
					/* IO.writeLine("classNameWithPackage = " + classNameWithPackage); */

					Class<?> myClass = Class.forName(className);

					AbstractTestCase myObject = (AbstractTestCase) myClass
							.newInstance();

					myObject.runTest(className);

				} catch (Exception ex) {

					IO.writeLine("Could not run test for class " + className);
					ex.printStackTrace();

				}
				
				IO.writeLine(""); /* leave a blank line between classes */

			}

		} else {
		
			/* No command line args were used, we want to run every testcase */
			
			/* needed to separate these calls into other methods because
			   we were running into the size limit Java has for a single method */
			runTestCWE1();
			runTestCWE2();
			runTestCWE3();
			runTestCWE4();
			runTestCWE5();
			runTestCWE6();
			runTestCWE7();
			runTestCWE8();
			runTestCWE9();
		}			
	}

private static void runTestCWE1() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-1 */

			/* END-AUTOGENERATED-JAVA-TESTS-1 */
}

private static void runTestCWE2() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-2 */

			/* END-AUTOGENERATED-JAVA-TESTS-2 */
}

private static void runTestCWE3() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-3 */

			/* END-AUTOGENERATED-JAVA-TESTS-3 */
}

private static void runTestCWE4() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-4 */
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_write_06()).runTest("CWE400_Resource_Exhaustion__random_write_06");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_database_81a()).runTest("CWE400_Resource_Exhaustion__sleep_database_81a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_for_loop_08()).runTest("CWE400_Resource_Exhaustion__listen_tcp_for_loop_08");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_connect_tcp_04()).runTest("CWE400_Resource_Exhaustion__sleep_connect_tcp_04");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_for_loop_41()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_for_loop_41");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_write_73a()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_write_73a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_write_81a()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_write_81a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_for_loop_07()).runTest("CWE400_Resource_Exhaustion__max_value_for_loop_07");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_for_loop_21()).runTest("CWE400_Resource_Exhaustion__random_for_loop_21");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_for_loop_74a()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_for_loop_74a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_write_52a()).runTest("CWE400_Resource_Exhaustion__max_value_write_52a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_write_53a()).runTest("CWE400_Resource_Exhaustion__listen_tcp_write_53a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_write_71a()).runTest("CWE400_Resource_Exhaustion__listen_tcp_write_71a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_for_loop_15()).runTest("CWE400_Resource_Exhaustion__listen_tcp_for_loop_15");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_connect_tcp_75a()).runTest("CWE400_Resource_Exhaustion__sleep_connect_tcp_75a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_console_readLine_10()).runTest("CWE400_Resource_Exhaustion__sleep_console_readLine_10");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_listen_tcp_10()).runTest("CWE400_Resource_Exhaustion__sleep_listen_tcp_10");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_Environment_45()).runTest("CWE400_Resource_Exhaustion__sleep_Environment_45");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_listen_tcp_61a()).runTest("CWE400_Resource_Exhaustion__sleep_listen_tcp_61a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_Environment_17()).runTest("CWE400_Resource_Exhaustion__sleep_Environment_17");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_for_loop_01()).runTest("CWE400_Resource_Exhaustion__max_value_for_loop_01");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_write_16()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_write_16");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_listen_tcp_07()).runTest("CWE400_Resource_Exhaustion__sleep_listen_tcp_07");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_for_loop_74a()).runTest("CWE400_Resource_Exhaustion__max_value_for_loop_74a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_for_loop_45()).runTest("CWE400_Resource_Exhaustion__Property_for_loop_45");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_write_12()).runTest("CWE400_Resource_Exhaustion__Property_write_12");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_console_readLine_72a()).runTest("CWE400_Resource_Exhaustion__sleep_console_readLine_72a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_write_01()).runTest("CWE400_Resource_Exhaustion__Property_write_01");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_write_03()).runTest("CWE400_Resource_Exhaustion__listen_tcp_write_03");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_for_loop_15()).runTest("CWE400_Resource_Exhaustion__random_for_loop_15");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_for_loop_15()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_for_loop_15");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_for_loop_75a()).runTest("CWE400_Resource_Exhaustion__listen_tcp_for_loop_75a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_for_loop_71a()).runTest("CWE400_Resource_Exhaustion__listen_tcp_for_loop_71a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_listen_tcp_75a()).runTest("CWE400_Resource_Exhaustion__sleep_listen_tcp_75a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_File_41()).runTest("CWE400_Resource_Exhaustion__sleep_File_41");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_write_15()).runTest("CWE400_Resource_Exhaustion__listen_tcp_write_15");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_write_15()).runTest("CWE400_Resource_Exhaustion__max_value_write_15");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_write_72a()).runTest("CWE400_Resource_Exhaustion__Property_write_72a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_console_readLine_66a()).runTest("CWE400_Resource_Exhaustion__sleep_console_readLine_66a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_for_loop_15()).runTest("CWE400_Resource_Exhaustion__Property_for_loop_15");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_listen_tcp_54a()).runTest("CWE400_Resource_Exhaustion__sleep_listen_tcp_54a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_Environment_72a()).runTest("CWE400_Resource_Exhaustion__sleep_Environment_72a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_Environment_03()).runTest("CWE400_Resource_Exhaustion__sleep_Environment_03");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_for_loop_72a()).runTest("CWE400_Resource_Exhaustion__max_value_for_loop_72a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_database_68a()).runTest("CWE400_Resource_Exhaustion__sleep_database_68a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_write_14()).runTest("CWE400_Resource_Exhaustion__max_value_write_14");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_for_loop_52a()).runTest("CWE400_Resource_Exhaustion__Property_for_loop_52a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_write_51a()).runTest("CWE400_Resource_Exhaustion__Property_write_51a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_for_loop_54a()).runTest("CWE400_Resource_Exhaustion__listen_tcp_for_loop_54a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_for_loop_74a()).runTest("CWE400_Resource_Exhaustion__random_for_loop_74a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_listen_tcp_81a()).runTest("CWE400_Resource_Exhaustion__sleep_listen_tcp_81a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_listen_tcp_12()).runTest("CWE400_Resource_Exhaustion__sleep_listen_tcp_12");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_write_03()).runTest("CWE400_Resource_Exhaustion__random_write_03");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_write_66a()).runTest("CWE400_Resource_Exhaustion__listen_tcp_write_66a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_write_07()).runTest("CWE400_Resource_Exhaustion__listen_tcp_write_07");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_connect_tcp_11()).runTest("CWE400_Resource_Exhaustion__sleep_connect_tcp_11");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_write_45()).runTest("CWE400_Resource_Exhaustion__random_write_45");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_for_loop_16()).runTest("CWE400_Resource_Exhaustion__listen_tcp_for_loop_16");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_write_68a()).runTest("CWE400_Resource_Exhaustion__Property_write_68a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_for_loop_08()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_for_loop_08");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_write_71a()).runTest("CWE400_Resource_Exhaustion__random_write_71a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_for_loop_73a()).runTest("CWE400_Resource_Exhaustion__random_for_loop_73a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_for_loop_22a()).runTest("CWE400_Resource_Exhaustion__listen_tcp_for_loop_22a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_for_loop_21()).runTest("CWE400_Resource_Exhaustion__max_value_for_loop_21");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_database_07()).runTest("CWE400_Resource_Exhaustion__sleep_database_07");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_for_loop_12()).runTest("CWE400_Resource_Exhaustion__max_value_for_loop_12");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_Environment_06()).runTest("CWE400_Resource_Exhaustion__sleep_Environment_06");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_for_loop_51a()).runTest("CWE400_Resource_Exhaustion__max_value_for_loop_51a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_listen_tcp_45()).runTest("CWE400_Resource_Exhaustion__sleep_listen_tcp_45");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_database_12()).runTest("CWE400_Resource_Exhaustion__sleep_database_12");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_console_readLine_12()).runTest("CWE400_Resource_Exhaustion__sleep_console_readLine_12");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_write_21()).runTest("CWE400_Resource_Exhaustion__max_value_write_21");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_for_loop_73a()).runTest("CWE400_Resource_Exhaustion__max_value_for_loop_73a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_for_loop_06()).runTest("CWE400_Resource_Exhaustion__random_for_loop_06");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_connect_tcp_08()).runTest("CWE400_Resource_Exhaustion__sleep_connect_tcp_08");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_write_14()).runTest("CWE400_Resource_Exhaustion__Property_write_14");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_write_51a()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_write_51a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_write_67a()).runTest("CWE400_Resource_Exhaustion__Property_write_67a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_database_54a()).runTest("CWE400_Resource_Exhaustion__sleep_database_54a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_for_loop_71a()).runTest("CWE400_Resource_Exhaustion__Property_for_loop_71a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_write_71a()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_write_71a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_write_01()).runTest("CWE400_Resource_Exhaustion__max_value_write_01");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_database_42()).runTest("CWE400_Resource_Exhaustion__sleep_database_42");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_File_53a()).runTest("CWE400_Resource_Exhaustion__sleep_File_53a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_for_loop_13()).runTest("CWE400_Resource_Exhaustion__random_for_loop_13");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_write_81a()).runTest("CWE400_Resource_Exhaustion__listen_tcp_write_81a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_Environment_71a()).runTest("CWE400_Resource_Exhaustion__sleep_Environment_71a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_for_loop_10()).runTest("CWE400_Resource_Exhaustion__max_value_for_loop_10");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_write_10()).runTest("CWE400_Resource_Exhaustion__listen_tcp_write_10");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_write_07()).runTest("CWE400_Resource_Exhaustion__Property_write_07");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_console_readLine_06()).runTest("CWE400_Resource_Exhaustion__sleep_console_readLine_06");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_console_readLine_75a()).runTest("CWE400_Resource_Exhaustion__sleep_console_readLine_75a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_for_loop_52a()).runTest("CWE400_Resource_Exhaustion__listen_tcp_for_loop_52a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_write_10()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_write_10");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_for_loop_12()).runTest("CWE400_Resource_Exhaustion__Property_for_loop_12");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_listen_tcp_73a()).runTest("CWE400_Resource_Exhaustion__sleep_listen_tcp_73a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_for_loop_45()).runTest("CWE400_Resource_Exhaustion__max_value_for_loop_45");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_database_10()).runTest("CWE400_Resource_Exhaustion__sleep_database_10");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_Environment_12()).runTest("CWE400_Resource_Exhaustion__sleep_Environment_12");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_for_loop_72a()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_for_loop_72a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_write_52a()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_write_52a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_connect_tcp_42()).runTest("CWE400_Resource_Exhaustion__sleep_connect_tcp_42");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_write_21()).runTest("CWE400_Resource_Exhaustion__Property_write_21");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_write_10()).runTest("CWE400_Resource_Exhaustion__random_write_10");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_Environment_52a()).runTest("CWE400_Resource_Exhaustion__sleep_Environment_52a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_connect_tcp_05()).runTest("CWE400_Resource_Exhaustion__sleep_connect_tcp_05");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_write_52a()).runTest("CWE400_Resource_Exhaustion__random_write_52a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_write_68a()).runTest("CWE400_Resource_Exhaustion__random_write_68a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_write_07()).runTest("CWE400_Resource_Exhaustion__random_write_07");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_write_67a()).runTest("CWE400_Resource_Exhaustion__listen_tcp_write_67a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_listen_tcp_42()).runTest("CWE400_Resource_Exhaustion__sleep_listen_tcp_42");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_database_08()).runTest("CWE400_Resource_Exhaustion__sleep_database_08");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_listen_tcp_02()).runTest("CWE400_Resource_Exhaustion__sleep_listen_tcp_02");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_for_loop_42()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_for_loop_42");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_write_05()).runTest("CWE400_Resource_Exhaustion__Property_write_05");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_for_loop_02()).runTest("CWE400_Resource_Exhaustion__random_for_loop_02");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_write_12()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_write_12");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_for_loop_53a()).runTest("CWE400_Resource_Exhaustion__listen_tcp_for_loop_53a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_database_53a()).runTest("CWE400_Resource_Exhaustion__sleep_database_53a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_for_loop_01()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_for_loop_01");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_write_54a()).runTest("CWE400_Resource_Exhaustion__random_write_54a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_write_13()).runTest("CWE400_Resource_Exhaustion__Property_write_13");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_for_loop_09()).runTest("CWE400_Resource_Exhaustion__max_value_for_loop_09");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_connect_tcp_06()).runTest("CWE400_Resource_Exhaustion__sleep_connect_tcp_06");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_listen_tcp_52a()).runTest("CWE400_Resource_Exhaustion__sleep_listen_tcp_52a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_for_loop_10()).runTest("CWE400_Resource_Exhaustion__random_for_loop_10");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_connect_tcp_12()).runTest("CWE400_Resource_Exhaustion__sleep_connect_tcp_12");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_for_loop_68a()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_for_loop_68a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_write_72a()).runTest("CWE400_Resource_Exhaustion__listen_tcp_write_72a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_console_readLine_61a()).runTest("CWE400_Resource_Exhaustion__sleep_console_readLine_61a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_write_42()).runTest("CWE400_Resource_Exhaustion__random_write_42");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_write_73a()).runTest("CWE400_Resource_Exhaustion__listen_tcp_write_73a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_database_45()).runTest("CWE400_Resource_Exhaustion__sleep_database_45");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_for_loop_02()).runTest("CWE400_Resource_Exhaustion__max_value_for_loop_02");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_for_loop_17()).runTest("CWE400_Resource_Exhaustion__listen_tcp_for_loop_17");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_for_loop_81a()).runTest("CWE400_Resource_Exhaustion__random_for_loop_81a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_for_loop_16()).runTest("CWE400_Resource_Exhaustion__random_for_loop_16");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_for_loop_15()).runTest("CWE400_Resource_Exhaustion__max_value_for_loop_15");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_File_54a()).runTest("CWE400_Resource_Exhaustion__sleep_File_54a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_for_loop_10()).runTest("CWE400_Resource_Exhaustion__listen_tcp_for_loop_10");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_Environment_74a()).runTest("CWE400_Resource_Exhaustion__sleep_Environment_74a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_for_loop_02()).runTest("CWE400_Resource_Exhaustion__listen_tcp_for_loop_02");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_for_loop_67a()).runTest("CWE400_Resource_Exhaustion__listen_tcp_for_loop_67a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_for_loop_67a()).runTest("CWE400_Resource_Exhaustion__random_for_loop_67a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_console_readLine_03()).runTest("CWE400_Resource_Exhaustion__sleep_console_readLine_03");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_listen_tcp_09()).runTest("CWE400_Resource_Exhaustion__sleep_listen_tcp_09");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_write_22a()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_write_22a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_write_31()).runTest("CWE400_Resource_Exhaustion__Property_write_31");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_File_02()).runTest("CWE400_Resource_Exhaustion__sleep_File_02");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_for_loop_22a()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_for_loop_22a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_for_loop_75a()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_for_loop_75a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_for_loop_07()).runTest("CWE400_Resource_Exhaustion__listen_tcp_for_loop_07");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_for_loop_02()).runTest("CWE400_Resource_Exhaustion__Property_for_loop_02");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_for_loop_52a()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_for_loop_52a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_listen_tcp_21()).runTest("CWE400_Resource_Exhaustion__sleep_listen_tcp_21");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_console_readLine_01()).runTest("CWE400_Resource_Exhaustion__sleep_console_readLine_01");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_Environment_73a()).runTest("CWE400_Resource_Exhaustion__sleep_Environment_73a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_database_06()).runTest("CWE400_Resource_Exhaustion__sleep_database_06");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_for_loop_71a()).runTest("CWE400_Resource_Exhaustion__random_for_loop_71a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_for_loop_03()).runTest("CWE400_Resource_Exhaustion__listen_tcp_for_loop_03");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_File_01()).runTest("CWE400_Resource_Exhaustion__sleep_File_01");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_write_14()).runTest("CWE400_Resource_Exhaustion__random_write_14");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_File_04()).runTest("CWE400_Resource_Exhaustion__sleep_File_04");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_write_42()).runTest("CWE400_Resource_Exhaustion__max_value_write_42");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_for_loop_17()).runTest("CWE400_Resource_Exhaustion__random_for_loop_17");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_for_loop_09()).runTest("CWE400_Resource_Exhaustion__random_for_loop_09");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_for_loop_41()).runTest("CWE400_Resource_Exhaustion__random_for_loop_41");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_Environment_05()).runTest("CWE400_Resource_Exhaustion__sleep_Environment_05");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_for_loop_54a()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_for_loop_54a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_for_loop_01()).runTest("CWE400_Resource_Exhaustion__random_for_loop_01");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_write_22a()).runTest("CWE400_Resource_Exhaustion__random_write_22a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_File_15()).runTest("CWE400_Resource_Exhaustion__sleep_File_15");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_for_loop_12()).runTest("CWE400_Resource_Exhaustion__listen_tcp_for_loop_12");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_for_loop_17()).runTest("CWE400_Resource_Exhaustion__max_value_for_loop_17");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_for_loop_53a()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_for_loop_53a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_for_loop_22a()).runTest("CWE400_Resource_Exhaustion__random_for_loop_22a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_File_73a()).runTest("CWE400_Resource_Exhaustion__sleep_File_73a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_for_loop_06()).runTest("CWE400_Resource_Exhaustion__listen_tcp_for_loop_06");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_for_loop_17()).runTest("CWE400_Resource_Exhaustion__Property_for_loop_17");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_write_10()).runTest("CWE400_Resource_Exhaustion__max_value_write_10");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_File_13()).runTest("CWE400_Resource_Exhaustion__sleep_File_13");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_console_readLine_73a()).runTest("CWE400_Resource_Exhaustion__sleep_console_readLine_73a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_write_11()).runTest("CWE400_Resource_Exhaustion__listen_tcp_write_11");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_write_04()).runTest("CWE400_Resource_Exhaustion__listen_tcp_write_04");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_console_readLine_41()).runTest("CWE400_Resource_Exhaustion__sleep_console_readLine_41");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_Environment_51a()).runTest("CWE400_Resource_Exhaustion__sleep_Environment_51a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_for_loop_12()).runTest("CWE400_Resource_Exhaustion__random_for_loop_12");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_database_75a()).runTest("CWE400_Resource_Exhaustion__sleep_database_75a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_for_loop_05()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_for_loop_05");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_for_loop_61a()).runTest("CWE400_Resource_Exhaustion__Property_for_loop_61a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_write_04()).runTest("CWE400_Resource_Exhaustion__random_write_04");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_Environment_08()).runTest("CWE400_Resource_Exhaustion__sleep_Environment_08");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_database_09()).runTest("CWE400_Resource_Exhaustion__sleep_database_09");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_write_75a()).runTest("CWE400_Resource_Exhaustion__max_value_write_75a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_write_01()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_write_01");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_write_09()).runTest("CWE400_Resource_Exhaustion__random_write_09");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_database_52a()).runTest("CWE400_Resource_Exhaustion__sleep_database_52a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_write_75a()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_write_75a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_for_loop_61a()).runTest("CWE400_Resource_Exhaustion__max_value_for_loop_61a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_File_07()).runTest("CWE400_Resource_Exhaustion__sleep_File_07");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_write_02()).runTest("CWE400_Resource_Exhaustion__Property_write_02");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_write_68a()).runTest("CWE400_Resource_Exhaustion__listen_tcp_write_68a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_File_17()).runTest("CWE400_Resource_Exhaustion__sleep_File_17");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_write_68a()).runTest("CWE400_Resource_Exhaustion__max_value_write_68a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_for_loop_07()).runTest("CWE400_Resource_Exhaustion__Property_for_loop_07");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_write_13()).runTest("CWE400_Resource_Exhaustion__listen_tcp_write_13");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_write_08()).runTest("CWE400_Resource_Exhaustion__listen_tcp_write_08");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_for_loop_16()).runTest("CWE400_Resource_Exhaustion__max_value_for_loop_16");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_for_loop_51a()).runTest("CWE400_Resource_Exhaustion__listen_tcp_for_loop_51a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_console_readLine_07()).runTest("CWE400_Resource_Exhaustion__sleep_console_readLine_07");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_console_readLine_05()).runTest("CWE400_Resource_Exhaustion__sleep_console_readLine_05");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_database_51a()).runTest("CWE400_Resource_Exhaustion__sleep_database_51a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_database_03()).runTest("CWE400_Resource_Exhaustion__sleep_database_03");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_connect_tcp_31()).runTest("CWE400_Resource_Exhaustion__sleep_connect_tcp_31");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_Environment_22a()).runTest("CWE400_Resource_Exhaustion__sleep_Environment_22a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_write_42()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_write_42");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_write_74a()).runTest("CWE400_Resource_Exhaustion__Property_write_74a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_write_06()).runTest("CWE400_Resource_Exhaustion__max_value_write_06");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_for_loop_05()).runTest("CWE400_Resource_Exhaustion__max_value_for_loop_05");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_listen_tcp_05()).runTest("CWE400_Resource_Exhaustion__sleep_listen_tcp_05");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_write_73a()).runTest("CWE400_Resource_Exhaustion__max_value_write_73a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_for_loop_11()).runTest("CWE400_Resource_Exhaustion__listen_tcp_for_loop_11");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_write_06()).runTest("CWE400_Resource_Exhaustion__Property_write_06");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_write_02()).runTest("CWE400_Resource_Exhaustion__max_value_write_02");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_console_readLine_17()).runTest("CWE400_Resource_Exhaustion__sleep_console_readLine_17");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_write_12()).runTest("CWE400_Resource_Exhaustion__max_value_write_12");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_write_17()).runTest("CWE400_Resource_Exhaustion__random_write_17");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_for_loop_53a()).runTest("CWE400_Resource_Exhaustion__max_value_for_loop_53a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_write_03()).runTest("CWE400_Resource_Exhaustion__max_value_write_03");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_write_08()).runTest("CWE400_Resource_Exhaustion__max_value_write_08");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_write_15()).runTest("CWE400_Resource_Exhaustion__random_write_15");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_console_readLine_02()).runTest("CWE400_Resource_Exhaustion__sleep_console_readLine_02");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_File_06()).runTest("CWE400_Resource_Exhaustion__sleep_File_06");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_database_41()).runTest("CWE400_Resource_Exhaustion__sleep_database_41");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_write_41()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_write_41");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_for_loop_81a()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_for_loop_81a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_for_loop_41()).runTest("CWE400_Resource_Exhaustion__max_value_for_loop_41");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_listen_tcp_67a()).runTest("CWE400_Resource_Exhaustion__sleep_listen_tcp_67a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_write_73a()).runTest("CWE400_Resource_Exhaustion__random_write_73a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_write_14()).runTest("CWE400_Resource_Exhaustion__listen_tcp_write_14");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_write_12()).runTest("CWE400_Resource_Exhaustion__listen_tcp_write_12");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_for_loop_74a()).runTest("CWE400_Resource_Exhaustion__Property_for_loop_74a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_write_06()).runTest("CWE400_Resource_Exhaustion__listen_tcp_write_06");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_write_74a()).runTest("CWE400_Resource_Exhaustion__listen_tcp_write_74a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_write_72a()).runTest("CWE400_Resource_Exhaustion__random_write_72a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_connect_tcp_61a()).runTest("CWE400_Resource_Exhaustion__sleep_connect_tcp_61a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_listen_tcp_08()).runTest("CWE400_Resource_Exhaustion__sleep_listen_tcp_08");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_write_71a()).runTest("CWE400_Resource_Exhaustion__max_value_write_71a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_write_09()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_write_09");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_for_loop_66a()).runTest("CWE400_Resource_Exhaustion__max_value_for_loop_66a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_connect_tcp_66a()).runTest("CWE400_Resource_Exhaustion__sleep_connect_tcp_66a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_File_72a()).runTest("CWE400_Resource_Exhaustion__sleep_File_72a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_for_loop_71a()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_for_loop_71a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_for_loop_53a()).runTest("CWE400_Resource_Exhaustion__random_for_loop_53a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_write_22a()).runTest("CWE400_Resource_Exhaustion__listen_tcp_write_22a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_File_21()).runTest("CWE400_Resource_Exhaustion__sleep_File_21");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_for_loop_42()).runTest("CWE400_Resource_Exhaustion__random_for_loop_42");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_write_16()).runTest("CWE400_Resource_Exhaustion__max_value_write_16");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_for_loop_21()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_for_loop_21");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_write_05()).runTest("CWE400_Resource_Exhaustion__random_write_05");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_connect_tcp_03()).runTest("CWE400_Resource_Exhaustion__sleep_connect_tcp_03");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_Environment_75a()).runTest("CWE400_Resource_Exhaustion__sleep_Environment_75a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_for_loop_68a()).runTest("CWE400_Resource_Exhaustion__Property_for_loop_68a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_listen_tcp_04()).runTest("CWE400_Resource_Exhaustion__sleep_listen_tcp_04");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_write_16()).runTest("CWE400_Resource_Exhaustion__listen_tcp_write_16");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_for_loop_75a()).runTest("CWE400_Resource_Exhaustion__Property_for_loop_75a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_write_07()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_write_07");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_write_21()).runTest("CWE400_Resource_Exhaustion__random_write_21");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_database_71a()).runTest("CWE400_Resource_Exhaustion__sleep_database_71a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_write_73a()).runTest("CWE400_Resource_Exhaustion__Property_write_73a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_write_51a()).runTest("CWE400_Resource_Exhaustion__listen_tcp_write_51a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_write_03()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_write_03");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_for_loop_09()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_for_loop_09");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_database_15()).runTest("CWE400_Resource_Exhaustion__sleep_database_15");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_write_51a()).runTest("CWE400_Resource_Exhaustion__random_write_51a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_Environment_11()).runTest("CWE400_Resource_Exhaustion__sleep_Environment_11");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_Environment_68a()).runTest("CWE400_Resource_Exhaustion__sleep_Environment_68a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_write_75a()).runTest("CWE400_Resource_Exhaustion__Property_write_75a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_for_loop_03()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_for_loop_03");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_for_loop_14()).runTest("CWE400_Resource_Exhaustion__max_value_for_loop_14");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_connect_tcp_22a()).runTest("CWE400_Resource_Exhaustion__sleep_connect_tcp_22a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_database_21()).runTest("CWE400_Resource_Exhaustion__sleep_database_21");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_Environment_02()).runTest("CWE400_Resource_Exhaustion__sleep_Environment_02");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_write_22a()).runTest("CWE400_Resource_Exhaustion__Property_write_22a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_File_61a()).runTest("CWE400_Resource_Exhaustion__sleep_File_61a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_console_readLine_09()).runTest("CWE400_Resource_Exhaustion__sleep_console_readLine_09");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_for_loop_14()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_for_loop_14");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_listen_tcp_14()).runTest("CWE400_Resource_Exhaustion__sleep_listen_tcp_14");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_connect_tcp_53a()).runTest("CWE400_Resource_Exhaustion__sleep_connect_tcp_53a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_database_22a()).runTest("CWE400_Resource_Exhaustion__sleep_database_22a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_for_loop_66a()).runTest("CWE400_Resource_Exhaustion__listen_tcp_for_loop_66a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_connect_tcp_51a()).runTest("CWE400_Resource_Exhaustion__sleep_connect_tcp_51a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_write_54a()).runTest("CWE400_Resource_Exhaustion__listen_tcp_write_54a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_write_41()).runTest("CWE400_Resource_Exhaustion__random_write_41");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_write_41()).runTest("CWE400_Resource_Exhaustion__max_value_write_41");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_for_loop_52a()).runTest("CWE400_Resource_Exhaustion__random_for_loop_52a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_for_loop_66a()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_for_loop_66a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_write_53a()).runTest("CWE400_Resource_Exhaustion__Property_write_53a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_database_14()).runTest("CWE400_Resource_Exhaustion__sleep_database_14");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_File_42()).runTest("CWE400_Resource_Exhaustion__sleep_File_42");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_for_loop_06()).runTest("CWE400_Resource_Exhaustion__max_value_for_loop_06");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_for_loop_01()).runTest("CWE400_Resource_Exhaustion__Property_for_loop_01");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_write_21()).runTest("CWE400_Resource_Exhaustion__listen_tcp_write_21");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_write_09()).runTest("CWE400_Resource_Exhaustion__Property_write_09");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_for_loop_11()).runTest("CWE400_Resource_Exhaustion__random_for_loop_11");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_connect_tcp_74a()).runTest("CWE400_Resource_Exhaustion__sleep_connect_tcp_74a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_write_53a()).runTest("CWE400_Resource_Exhaustion__max_value_write_53a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_write_66a()).runTest("CWE400_Resource_Exhaustion__max_value_write_66a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_for_loop_54a()).runTest("CWE400_Resource_Exhaustion__random_for_loop_54a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_Environment_54a()).runTest("CWE400_Resource_Exhaustion__sleep_Environment_54a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_File_22a()).runTest("CWE400_Resource_Exhaustion__sleep_File_22a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_database_05()).runTest("CWE400_Resource_Exhaustion__sleep_database_05");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_for_loop_42()).runTest("CWE400_Resource_Exhaustion__max_value_for_loop_42");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_write_61a()).runTest("CWE400_Resource_Exhaustion__random_write_61a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_Environment_14()).runTest("CWE400_Resource_Exhaustion__sleep_Environment_14");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_for_loop_13()).runTest("CWE400_Resource_Exhaustion__Property_for_loop_13");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_File_75a()).runTest("CWE400_Resource_Exhaustion__sleep_File_75a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_database_01()).runTest("CWE400_Resource_Exhaustion__sleep_database_01");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_console_readLine_68a()).runTest("CWE400_Resource_Exhaustion__sleep_console_readLine_68a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_for_loop_10()).runTest("CWE400_Resource_Exhaustion__Property_for_loop_10");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_Environment_07()).runTest("CWE400_Resource_Exhaustion__sleep_Environment_07");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_for_loop_16()).runTest("CWE400_Resource_Exhaustion__Property_for_loop_16");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_write_06()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_write_06");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_console_readLine_21()).runTest("CWE400_Resource_Exhaustion__sleep_console_readLine_21");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_for_loop_66a()).runTest("CWE400_Resource_Exhaustion__Property_for_loop_66a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_console_readLine_42()).runTest("CWE400_Resource_Exhaustion__sleep_console_readLine_42");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_for_loop_51a()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_for_loop_51a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_connect_tcp_14()).runTest("CWE400_Resource_Exhaustion__sleep_connect_tcp_14");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_for_loop_05()).runTest("CWE400_Resource_Exhaustion__Property_for_loop_05");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_Environment_21()).runTest("CWE400_Resource_Exhaustion__sleep_Environment_21");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_for_loop_54a()).runTest("CWE400_Resource_Exhaustion__max_value_for_loop_54a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_for_loop_41()).runTest("CWE400_Resource_Exhaustion__Property_for_loop_41");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_for_loop_73a()).runTest("CWE400_Resource_Exhaustion__listen_tcp_for_loop_73a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_for_loop_73a()).runTest("CWE400_Resource_Exhaustion__Property_for_loop_73a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_for_loop_51a()).runTest("CWE400_Resource_Exhaustion__random_for_loop_51a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_write_01()).runTest("CWE400_Resource_Exhaustion__random_write_01");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_write_74a()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_write_74a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_for_loop_05()).runTest("CWE400_Resource_Exhaustion__random_for_loop_05");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_for_loop_31()).runTest("CWE400_Resource_Exhaustion__Property_for_loop_31");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_write_42()).runTest("CWE400_Resource_Exhaustion__Property_write_42");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_for_loop_09()).runTest("CWE400_Resource_Exhaustion__listen_tcp_for_loop_09");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_write_45()).runTest("CWE400_Resource_Exhaustion__max_value_write_45");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_File_08()).runTest("CWE400_Resource_Exhaustion__sleep_File_08");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_connect_tcp_41()).runTest("CWE400_Resource_Exhaustion__sleep_connect_tcp_41");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_for_loop_16()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_for_loop_16");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_for_loop_11()).runTest("CWE400_Resource_Exhaustion__Property_for_loop_11");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_write_22a()).runTest("CWE400_Resource_Exhaustion__max_value_write_22a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_File_71a()).runTest("CWE400_Resource_Exhaustion__sleep_File_71a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_write_09()).runTest("CWE400_Resource_Exhaustion__listen_tcp_write_09");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_listen_tcp_31()).runTest("CWE400_Resource_Exhaustion__sleep_listen_tcp_31");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_File_05()).runTest("CWE400_Resource_Exhaustion__sleep_File_05");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_for_loop_13()).runTest("CWE400_Resource_Exhaustion__max_value_for_loop_13");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_console_readLine_08()).runTest("CWE400_Resource_Exhaustion__sleep_console_readLine_08");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_for_loop_04()).runTest("CWE400_Resource_Exhaustion__listen_tcp_for_loop_04");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_console_readLine_74a()).runTest("CWE400_Resource_Exhaustion__sleep_console_readLine_74a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_write_03()).runTest("CWE400_Resource_Exhaustion__Property_write_03");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_for_loop_68a()).runTest("CWE400_Resource_Exhaustion__listen_tcp_for_loop_68a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_database_73a()).runTest("CWE400_Resource_Exhaustion__sleep_database_73a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_File_66a()).runTest("CWE400_Resource_Exhaustion__sleep_File_66a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_for_loop_66a()).runTest("CWE400_Resource_Exhaustion__random_for_loop_66a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_write_07()).runTest("CWE400_Resource_Exhaustion__max_value_write_07");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_write_51a()).runTest("CWE400_Resource_Exhaustion__max_value_write_51a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_for_loop_08()).runTest("CWE400_Resource_Exhaustion__Property_for_loop_08");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_File_12()).runTest("CWE400_Resource_Exhaustion__sleep_File_12");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_console_readLine_51a()).runTest("CWE400_Resource_Exhaustion__sleep_console_readLine_51a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_write_17()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_write_17");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_write_11()).runTest("CWE400_Resource_Exhaustion__random_write_11");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_for_loop_08()).runTest("CWE400_Resource_Exhaustion__max_value_for_loop_08");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_File_14()).runTest("CWE400_Resource_Exhaustion__sleep_File_14");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_File_51a()).runTest("CWE400_Resource_Exhaustion__sleep_File_51a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_write_66a()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_write_66a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_write_42()).runTest("CWE400_Resource_Exhaustion__listen_tcp_write_42");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_for_loop_31()).runTest("CWE400_Resource_Exhaustion__random_for_loop_31");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_database_02()).runTest("CWE400_Resource_Exhaustion__sleep_database_02");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_write_16()).runTest("CWE400_Resource_Exhaustion__Property_write_16");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_Environment_53a()).runTest("CWE400_Resource_Exhaustion__sleep_Environment_53a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_for_loop_04()).runTest("CWE400_Resource_Exhaustion__max_value_for_loop_04");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_for_loop_61a()).runTest("CWE400_Resource_Exhaustion__listen_tcp_for_loop_61a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_Environment_09()).runTest("CWE400_Resource_Exhaustion__sleep_Environment_09");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_File_03()).runTest("CWE400_Resource_Exhaustion__sleep_File_03");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_Environment_42()).runTest("CWE400_Resource_Exhaustion__sleep_Environment_42");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_Environment_41()).runTest("CWE400_Resource_Exhaustion__sleep_Environment_41");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_for_loop_12()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_for_loop_12");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_File_67a()).runTest("CWE400_Resource_Exhaustion__sleep_File_67a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_write_15()).runTest("CWE400_Resource_Exhaustion__Property_write_15");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_database_13()).runTest("CWE400_Resource_Exhaustion__sleep_database_13");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_listen_tcp_22a()).runTest("CWE400_Resource_Exhaustion__sleep_listen_tcp_22a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_console_readLine_45()).runTest("CWE400_Resource_Exhaustion__sleep_console_readLine_45");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_write_16()).runTest("CWE400_Resource_Exhaustion__random_write_16");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_console_readLine_04()).runTest("CWE400_Resource_Exhaustion__sleep_console_readLine_04");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_database_74a()).runTest("CWE400_Resource_Exhaustion__sleep_database_74a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_write_13()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_write_13");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_Environment_04()).runTest("CWE400_Resource_Exhaustion__sleep_Environment_04");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_for_loop_13()).runTest("CWE400_Resource_Exhaustion__listen_tcp_for_loop_13");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_connect_tcp_54a()).runTest("CWE400_Resource_Exhaustion__sleep_connect_tcp_54a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_for_loop_21()).runTest("CWE400_Resource_Exhaustion__listen_tcp_for_loop_21");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_for_loop_67a()).runTest("CWE400_Resource_Exhaustion__Property_for_loop_67a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_for_loop_31()).runTest("CWE400_Resource_Exhaustion__listen_tcp_for_loop_31");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_connect_tcp_15()).runTest("CWE400_Resource_Exhaustion__sleep_connect_tcp_15");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_for_loop_75a()).runTest("CWE400_Resource_Exhaustion__max_value_for_loop_75a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_for_loop_72a()).runTest("CWE400_Resource_Exhaustion__random_for_loop_72a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_for_loop_53a()).runTest("CWE400_Resource_Exhaustion__Property_for_loop_53a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_write_61a()).runTest("CWE400_Resource_Exhaustion__Property_write_61a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_console_readLine_13()).runTest("CWE400_Resource_Exhaustion__sleep_console_readLine_13");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_console_readLine_81a()).runTest("CWE400_Resource_Exhaustion__sleep_console_readLine_81a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_Environment_15()).runTest("CWE400_Resource_Exhaustion__sleep_Environment_15");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_write_31()).runTest("CWE400_Resource_Exhaustion__max_value_write_31");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_for_loop_01()).runTest("CWE400_Resource_Exhaustion__listen_tcp_for_loop_01");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_for_loop_42()).runTest("CWE400_Resource_Exhaustion__listen_tcp_for_loop_42");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_write_52a()).runTest("CWE400_Resource_Exhaustion__Property_write_52a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_for_loop_68a()).runTest("CWE400_Resource_Exhaustion__random_for_loop_68a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_for_loop_61a()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_for_loop_61a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_Environment_31()).runTest("CWE400_Resource_Exhaustion__sleep_Environment_31");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_for_loop_45()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_for_loop_45");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_write_02()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_write_02");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_write_68a()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_write_68a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_Environment_01()).runTest("CWE400_Resource_Exhaustion__sleep_Environment_01");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_console_readLine_67a()).runTest("CWE400_Resource_Exhaustion__sleep_console_readLine_67a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_write_01()).runTest("CWE400_Resource_Exhaustion__listen_tcp_write_01");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_write_17()).runTest("CWE400_Resource_Exhaustion__listen_tcp_write_17");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_for_loop_08()).runTest("CWE400_Resource_Exhaustion__random_for_loop_08");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_connect_tcp_17()).runTest("CWE400_Resource_Exhaustion__sleep_connect_tcp_17");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_listen_tcp_41()).runTest("CWE400_Resource_Exhaustion__sleep_listen_tcp_41");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_write_05()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_write_05");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_write_66a()).runTest("CWE400_Resource_Exhaustion__Property_write_66a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_write_67a()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_write_67a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_database_17()).runTest("CWE400_Resource_Exhaustion__sleep_database_17");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_connect_tcp_13()).runTest("CWE400_Resource_Exhaustion__sleep_connect_tcp_13");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_write_31()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_write_31");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_for_loop_31()).runTest("CWE400_Resource_Exhaustion__max_value_for_loop_31");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_for_loop_04()).runTest("CWE400_Resource_Exhaustion__Property_for_loop_04");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_for_loop_81a()).runTest("CWE400_Resource_Exhaustion__Property_for_loop_81a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_listen_tcp_06()).runTest("CWE400_Resource_Exhaustion__sleep_listen_tcp_06");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_write_81a()).runTest("CWE400_Resource_Exhaustion__Property_write_81a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_console_readLine_54a()).runTest("CWE400_Resource_Exhaustion__sleep_console_readLine_54a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_console_readLine_11()).runTest("CWE400_Resource_Exhaustion__sleep_console_readLine_11");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_console_readLine_31()).runTest("CWE400_Resource_Exhaustion__sleep_console_readLine_31");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_database_31()).runTest("CWE400_Resource_Exhaustion__sleep_database_31");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_write_13()).runTest("CWE400_Resource_Exhaustion__random_write_13");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_database_16()).runTest("CWE400_Resource_Exhaustion__sleep_database_16");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_connect_tcp_73a()).runTest("CWE400_Resource_Exhaustion__sleep_connect_tcp_73a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_Environment_61a()).runTest("CWE400_Resource_Exhaustion__sleep_Environment_61a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_for_loop_31()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_for_loop_31");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_for_loop_07()).runTest("CWE400_Resource_Exhaustion__random_for_loop_07");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_for_loop_09()).runTest("CWE400_Resource_Exhaustion__Property_for_loop_09");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_for_loop_05()).runTest("CWE400_Resource_Exhaustion__listen_tcp_for_loop_05");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_write_13()).runTest("CWE400_Resource_Exhaustion__max_value_write_13");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_database_61a()).runTest("CWE400_Resource_Exhaustion__sleep_database_61a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_for_loop_54a()).runTest("CWE400_Resource_Exhaustion__Property_for_loop_54a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_console_readLine_22a()).runTest("CWE400_Resource_Exhaustion__sleep_console_readLine_22a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_write_53a()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_write_53a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_for_loop_06()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_for_loop_06");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_for_loop_17()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_for_loop_17");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_for_loop_45()).runTest("CWE400_Resource_Exhaustion__random_for_loop_45");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_write_61a()).runTest("CWE400_Resource_Exhaustion__listen_tcp_write_61a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_for_loop_13()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_for_loop_13");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_listen_tcp_66a()).runTest("CWE400_Resource_Exhaustion__sleep_listen_tcp_66a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_for_loop_71a()).runTest("CWE400_Resource_Exhaustion__max_value_for_loop_71a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_write_74a()).runTest("CWE400_Resource_Exhaustion__max_value_write_74a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_for_loop_67a()).runTest("CWE400_Resource_Exhaustion__max_value_for_loop_67a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_database_04()).runTest("CWE400_Resource_Exhaustion__sleep_database_04");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_connect_tcp_01()).runTest("CWE400_Resource_Exhaustion__sleep_connect_tcp_01");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_listen_tcp_13()).runTest("CWE400_Resource_Exhaustion__sleep_listen_tcp_13");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_listen_tcp_51a()).runTest("CWE400_Resource_Exhaustion__sleep_listen_tcp_51a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_listen_tcp_74a()).runTest("CWE400_Resource_Exhaustion__sleep_listen_tcp_74a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_File_45()).runTest("CWE400_Resource_Exhaustion__sleep_File_45");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_for_loop_03()).runTest("CWE400_Resource_Exhaustion__random_for_loop_03");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_for_loop_04()).runTest("CWE400_Resource_Exhaustion__random_for_loop_04");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_write_54a()).runTest("CWE400_Resource_Exhaustion__Property_write_54a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_connect_tcp_07()).runTest("CWE400_Resource_Exhaustion__sleep_connect_tcp_07");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_write_74a()).runTest("CWE400_Resource_Exhaustion__random_write_74a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_File_10()).runTest("CWE400_Resource_Exhaustion__sleep_File_10");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_listen_tcp_16()).runTest("CWE400_Resource_Exhaustion__sleep_listen_tcp_16");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_write_72a()).runTest("CWE400_Resource_Exhaustion__max_value_write_72a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_connect_tcp_02()).runTest("CWE400_Resource_Exhaustion__sleep_connect_tcp_02");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_connect_tcp_72a()).runTest("CWE400_Resource_Exhaustion__sleep_connect_tcp_72a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_for_loop_22a()).runTest("CWE400_Resource_Exhaustion__Property_for_loop_22a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_Environment_66a()).runTest("CWE400_Resource_Exhaustion__sleep_Environment_66a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_write_02()).runTest("CWE400_Resource_Exhaustion__random_write_02");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_for_loop_72a()).runTest("CWE400_Resource_Exhaustion__Property_for_loop_72a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_for_loop_14()).runTest("CWE400_Resource_Exhaustion__listen_tcp_for_loop_14");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_write_17()).runTest("CWE400_Resource_Exhaustion__max_value_write_17");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_console_readLine_53a()).runTest("CWE400_Resource_Exhaustion__sleep_console_readLine_53a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_for_loop_68a()).runTest("CWE400_Resource_Exhaustion__max_value_for_loop_68a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_for_loop_75a()).runTest("CWE400_Resource_Exhaustion__random_for_loop_75a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_write_31()).runTest("CWE400_Resource_Exhaustion__listen_tcp_write_31");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_write_45()).runTest("CWE400_Resource_Exhaustion__Property_write_45");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_write_05()).runTest("CWE400_Resource_Exhaustion__listen_tcp_write_05");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_write_17()).runTest("CWE400_Resource_Exhaustion__Property_write_17");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_listen_tcp_17()).runTest("CWE400_Resource_Exhaustion__sleep_listen_tcp_17");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_write_10()).runTest("CWE400_Resource_Exhaustion__Property_write_10");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_for_loop_07()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_for_loop_07");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_File_16()).runTest("CWE400_Resource_Exhaustion__sleep_File_16");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_for_loop_22a()).runTest("CWE400_Resource_Exhaustion__max_value_for_loop_22a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_write_75a()).runTest("CWE400_Resource_Exhaustion__random_write_75a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_for_loop_45()).runTest("CWE400_Resource_Exhaustion__listen_tcp_for_loop_45");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_write_72a()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_write_72a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_database_66a()).runTest("CWE400_Resource_Exhaustion__sleep_database_66a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_write_31()).runTest("CWE400_Resource_Exhaustion__random_write_31");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_File_74a()).runTest("CWE400_Resource_Exhaustion__sleep_File_74a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_write_53a()).runTest("CWE400_Resource_Exhaustion__random_write_53a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_connect_tcp_45()).runTest("CWE400_Resource_Exhaustion__sleep_connect_tcp_45");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_console_readLine_15()).runTest("CWE400_Resource_Exhaustion__sleep_console_readLine_15");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_write_15()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_write_15");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_for_loop_11()).runTest("CWE400_Resource_Exhaustion__max_value_for_loop_11");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_connect_tcp_16()).runTest("CWE400_Resource_Exhaustion__sleep_connect_tcp_16");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_listen_tcp_53a()).runTest("CWE400_Resource_Exhaustion__sleep_listen_tcp_53a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_for_loop_42()).runTest("CWE400_Resource_Exhaustion__Property_for_loop_42");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_write_75a()).runTest("CWE400_Resource_Exhaustion__listen_tcp_write_75a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_write_05()).runTest("CWE400_Resource_Exhaustion__max_value_write_05");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_write_67a()).runTest("CWE400_Resource_Exhaustion__max_value_write_67a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_write_41()).runTest("CWE400_Resource_Exhaustion__listen_tcp_write_41");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_for_loop_04()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_for_loop_04");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_File_81a()).runTest("CWE400_Resource_Exhaustion__sleep_File_81a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_for_loop_73a()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_for_loop_73a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_connect_tcp_52a()).runTest("CWE400_Resource_Exhaustion__sleep_connect_tcp_52a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_for_loop_41()).runTest("CWE400_Resource_Exhaustion__listen_tcp_for_loop_41");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_File_09()).runTest("CWE400_Resource_Exhaustion__sleep_File_09");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_write_11()).runTest("CWE400_Resource_Exhaustion__Property_write_11");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_for_loop_74a()).runTest("CWE400_Resource_Exhaustion__listen_tcp_for_loop_74a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_connect_tcp_81a()).runTest("CWE400_Resource_Exhaustion__sleep_connect_tcp_81a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_write_08()).runTest("CWE400_Resource_Exhaustion__random_write_08");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_write_08()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_write_08");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_Environment_67a()).runTest("CWE400_Resource_Exhaustion__sleep_Environment_67a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_database_67a()).runTest("CWE400_Resource_Exhaustion__sleep_database_67a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_write_11()).runTest("CWE400_Resource_Exhaustion__max_value_write_11");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_write_11()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_write_11");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_connect_tcp_71a()).runTest("CWE400_Resource_Exhaustion__sleep_connect_tcp_71a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_write_54a()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_write_54a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_write_08()).runTest("CWE400_Resource_Exhaustion__Property_write_08");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_Environment_13()).runTest("CWE400_Resource_Exhaustion__sleep_Environment_13");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_write_04()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_write_04");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_connect_tcp_10()).runTest("CWE400_Resource_Exhaustion__sleep_connect_tcp_10");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_write_81a()).runTest("CWE400_Resource_Exhaustion__max_value_write_81a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_for_loop_67a()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_for_loop_67a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_for_loop_72a()).runTest("CWE400_Resource_Exhaustion__listen_tcp_for_loop_72a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_write_09()).runTest("CWE400_Resource_Exhaustion__max_value_write_09");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_for_loop_51a()).runTest("CWE400_Resource_Exhaustion__Property_for_loop_51a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_connect_tcp_67a()).runTest("CWE400_Resource_Exhaustion__sleep_connect_tcp_67a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_for_loop_81a()).runTest("CWE400_Resource_Exhaustion__listen_tcp_for_loop_81a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_write_45()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_write_45");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_Environment_81a()).runTest("CWE400_Resource_Exhaustion__sleep_Environment_81a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_File_68a()).runTest("CWE400_Resource_Exhaustion__sleep_File_68a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_console_readLine_14()).runTest("CWE400_Resource_Exhaustion__sleep_console_readLine_14");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_write_14()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_write_14");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_for_loop_21()).runTest("CWE400_Resource_Exhaustion__Property_for_loop_21");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_write_54a()).runTest("CWE400_Resource_Exhaustion__max_value_write_54a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_write_61a()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_write_61a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_listen_tcp_11()).runTest("CWE400_Resource_Exhaustion__sleep_listen_tcp_11");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_write_21()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_write_21");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_for_loop_02()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_for_loop_02");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_listen_tcp_68a()).runTest("CWE400_Resource_Exhaustion__sleep_listen_tcp_68a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_listen_tcp_15()).runTest("CWE400_Resource_Exhaustion__sleep_listen_tcp_15");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_write_71a()).runTest("CWE400_Resource_Exhaustion__Property_write_71a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_console_readLine_16()).runTest("CWE400_Resource_Exhaustion__sleep_console_readLine_16");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_File_31()).runTest("CWE400_Resource_Exhaustion__sleep_File_31");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_database_11()).runTest("CWE400_Resource_Exhaustion__sleep_database_11");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_console_readLine_52a()).runTest("CWE400_Resource_Exhaustion__sleep_console_readLine_52a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_for_loop_52a()).runTest("CWE400_Resource_Exhaustion__max_value_for_loop_52a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_for_loop_10()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_for_loop_10");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_write_04()).runTest("CWE400_Resource_Exhaustion__Property_write_04");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_listen_tcp_72a()).runTest("CWE400_Resource_Exhaustion__sleep_listen_tcp_72a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_connect_tcp_68a()).runTest("CWE400_Resource_Exhaustion__sleep_connect_tcp_68a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_connect_tcp_09()).runTest("CWE400_Resource_Exhaustion__sleep_connect_tcp_09");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_write_66a()).runTest("CWE400_Resource_Exhaustion__random_write_66a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_for_loop_81a()).runTest("CWE400_Resource_Exhaustion__max_value_for_loop_81a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__PropertiesFile_for_loop_11()).runTest("CWE400_Resource_Exhaustion__PropertiesFile_for_loop_11");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_write_61a()).runTest("CWE400_Resource_Exhaustion__max_value_write_61a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_write_67a()).runTest("CWE400_Resource_Exhaustion__random_write_67a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_database_72a()).runTest("CWE400_Resource_Exhaustion__sleep_database_72a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_listen_tcp_71a()).runTest("CWE400_Resource_Exhaustion__sleep_listen_tcp_71a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_connect_tcp_21()).runTest("CWE400_Resource_Exhaustion__sleep_connect_tcp_21");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_console_readLine_71a()).runTest("CWE400_Resource_Exhaustion__sleep_console_readLine_71a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_write_12()).runTest("CWE400_Resource_Exhaustion__random_write_12");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_listen_tcp_03()).runTest("CWE400_Resource_Exhaustion__sleep_listen_tcp_03");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_write_52a()).runTest("CWE400_Resource_Exhaustion__listen_tcp_write_52a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_for_loop_03()).runTest("CWE400_Resource_Exhaustion__Property_for_loop_03");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_Environment_16()).runTest("CWE400_Resource_Exhaustion__sleep_Environment_16");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_for_loop_06()).runTest("CWE400_Resource_Exhaustion__Property_for_loop_06");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_File_52a()).runTest("CWE400_Resource_Exhaustion__sleep_File_52a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_Environment_10()).runTest("CWE400_Resource_Exhaustion__sleep_Environment_10");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_write_04()).runTest("CWE400_Resource_Exhaustion__max_value_write_04");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_for_loop_14()).runTest("CWE400_Resource_Exhaustion__Property_for_loop_14");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__Property_write_41()).runTest("CWE400_Resource_Exhaustion__Property_write_41");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_write_02()).runTest("CWE400_Resource_Exhaustion__listen_tcp_write_02");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__listen_tcp_write_45()).runTest("CWE400_Resource_Exhaustion__listen_tcp_write_45");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__max_value_for_loop_03()).runTest("CWE400_Resource_Exhaustion__max_value_for_loop_03");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_write_81a()).runTest("CWE400_Resource_Exhaustion__random_write_81a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_for_loop_61a()).runTest("CWE400_Resource_Exhaustion__random_for_loop_61a");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_listen_tcp_01()).runTest("CWE400_Resource_Exhaustion__sleep_listen_tcp_01");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__random_for_loop_14()).runTest("CWE400_Resource_Exhaustion__random_for_loop_14");
			(new testcases.CWE400_Resource_Exhaustion.s02.CWE400_Resource_Exhaustion__sleep_File_11()).runTest("CWE400_Resource_Exhaustion__sleep_File_11");
			/* END-AUTOGENERATED-JAVA-TESTS-4 */
}

private static void runTestCWE5() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-5 */

			/* END-AUTOGENERATED-JAVA-TESTS-5 */
}

private static void runTestCWE6() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-6 */

			/* END-AUTOGENERATED-JAVA-TESTS-6 */
}

private static void runTestCWE7() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-7 */

			/* END-AUTOGENERATED-JAVA-TESTS-7 */
}

private static void runTestCWE8() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-8 */

			/* END-AUTOGENERATED-JAVA-TESTS-8 */
}

private static void runTestCWE9() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-9 */

			/* END-AUTOGENERATED-JAVA-TESTS-9 */
}
}