package testcases.CWE400_Resource_Exhaustion.s03;

import testcasesupport.*;

public class Main {

	public static void main(String[] args) {
		
		if(args.length != 0) {
		
			if(args[0].equals("-h") || args[0].equals("--help")) {
		
				System.err.println("To use this main, you can either run the program with no " +
				"command line arguments to run all test cases or you can specify one or more classes to test");
				System.err.println("For example:");
				System.err.println("java testcasesupport.Main testcases.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference.custom_function.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference__custom_function_01 testcases.CWE481_Assigning_instead_of_Comparing.bool.CWE481_Assigning_instead_of_Comparing__bool_01");
				System.exit(1);
			}
			
			/* User supplied some class names on the command line, just use those with introspection
			 *
			 * String classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
			 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
 			 * could read class names from command line or use
			 * http://sadun-util.sourceforge.net/api/org/sadun/util/
			 * ClassPackageExplorer.html
			 */

			for (String className : args) {

				try {
					
					/* String classNameWithPackage = "testcases." + className; */
					
					/* IO.writeLine("classNameWithPackage = " + classNameWithPackage); */

					Class<?> myClass = Class.forName(className);

					AbstractTestCase myObject = (AbstractTestCase) myClass
							.newInstance();

					myObject.runTest(className);

				} catch (Exception ex) {

					IO.writeLine("Could not run test for class " + className);
					ex.printStackTrace();

				}
				
				IO.writeLine(""); /* leave a blank line between classes */

			}

		} else {
		
			/* No command line args were used, we want to run every testcase */
			
			/* needed to separate these calls into other methods because
			   we were running into the size limit Java has for a single method */
			runTestCWE1();
			runTestCWE2();
			runTestCWE3();
			runTestCWE4();
			runTestCWE5();
			runTestCWE6();
			runTestCWE7();
			runTestCWE8();
			runTestCWE9();
		}			
	}

private static void runTestCWE1() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-1 */

			/* END-AUTOGENERATED-JAVA-TESTS-1 */
}

private static void runTestCWE2() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-2 */

			/* END-AUTOGENERATED-JAVA-TESTS-2 */
}

private static void runTestCWE3() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-3 */

			/* END-AUTOGENERATED-JAVA-TESTS-3 */
}

private static void runTestCWE4() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-4 */
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_max_value_16()).runTest("CWE400_Resource_Exhaustion__sleep_max_value_16");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_write_53a()).runTest("CWE400_Resource_Exhaustion__URLConnection_write_53a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_URLConnection_66a()).runTest("CWE400_Resource_Exhaustion__sleep_URLConnection_66a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_write_74a()).runTest("CWE400_Resource_Exhaustion__URLConnection_write_74a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_for_loop_51a()).runTest("CWE400_Resource_Exhaustion__URLConnection_for_loop_51a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_write_11()).runTest("CWE400_Resource_Exhaustion__URLConnection_write_11");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_write_67a()).runTest("CWE400_Resource_Exhaustion__URLConnection_write_67a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_write_66a()).runTest("CWE400_Resource_Exhaustion__URLConnection_write_66a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_write_81a()).runTest("CWE400_Resource_Exhaustion__URLConnection_write_81a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_for_loop_09()).runTest("CWE400_Resource_Exhaustion__URLConnection_for_loop_09");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_write_01()).runTest("CWE400_Resource_Exhaustion__URLConnection_write_01");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_URLConnection_41()).runTest("CWE400_Resource_Exhaustion__sleep_URLConnection_41");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_write_10()).runTest("CWE400_Resource_Exhaustion__URLConnection_write_10");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_URLConnection_71a()).runTest("CWE400_Resource_Exhaustion__sleep_URLConnection_71a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_for_loop_54a()).runTest("CWE400_Resource_Exhaustion__URLConnection_for_loop_54a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_URLConnection_21()).runTest("CWE400_Resource_Exhaustion__sleep_URLConnection_21");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_PropertiesFile_16()).runTest("CWE400_Resource_Exhaustion__sleep_PropertiesFile_16");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_max_value_66a()).runTest("CWE400_Resource_Exhaustion__sleep_max_value_66a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_URLConnection_11()).runTest("CWE400_Resource_Exhaustion__sleep_URLConnection_11");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_random_14()).runTest("CWE400_Resource_Exhaustion__sleep_random_14");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_random_03()).runTest("CWE400_Resource_Exhaustion__sleep_random_03");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_for_loop_06()).runTest("CWE400_Resource_Exhaustion__URLConnection_for_loop_06");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_for_loop_17()).runTest("CWE400_Resource_Exhaustion__URLConnection_for_loop_17");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_write_13()).runTest("CWE400_Resource_Exhaustion__URLConnection_write_13");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_max_value_42()).runTest("CWE400_Resource_Exhaustion__sleep_max_value_42");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_URLConnection_73a()).runTest("CWE400_Resource_Exhaustion__sleep_URLConnection_73a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_PropertiesFile_71a()).runTest("CWE400_Resource_Exhaustion__sleep_PropertiesFile_71a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_URLConnection_03()).runTest("CWE400_Resource_Exhaustion__sleep_URLConnection_03");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_max_value_72a()).runTest("CWE400_Resource_Exhaustion__sleep_max_value_72a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_PropertiesFile_72a()).runTest("CWE400_Resource_Exhaustion__sleep_PropertiesFile_72a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_max_value_45()).runTest("CWE400_Resource_Exhaustion__sleep_max_value_45");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_random_54a()).runTest("CWE400_Resource_Exhaustion__sleep_random_54a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_Property_04()).runTest("CWE400_Resource_Exhaustion__sleep_Property_04");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_max_value_67a()).runTest("CWE400_Resource_Exhaustion__sleep_max_value_67a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_write_71a()).runTest("CWE400_Resource_Exhaustion__URLConnection_write_71a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_Property_14()).runTest("CWE400_Resource_Exhaustion__sleep_Property_14");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_Property_51a()).runTest("CWE400_Resource_Exhaustion__sleep_Property_51a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_URLConnection_53a()).runTest("CWE400_Resource_Exhaustion__sleep_URLConnection_53a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_max_value_02()).runTest("CWE400_Resource_Exhaustion__sleep_max_value_02");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_for_loop_05()).runTest("CWE400_Resource_Exhaustion__URLConnection_for_loop_05");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_URLConnection_17()).runTest("CWE400_Resource_Exhaustion__sleep_URLConnection_17");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_URLConnection_08()).runTest("CWE400_Resource_Exhaustion__sleep_URLConnection_08");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_random_66a()).runTest("CWE400_Resource_Exhaustion__sleep_random_66a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_PropertiesFile_52a()).runTest("CWE400_Resource_Exhaustion__sleep_PropertiesFile_52a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_Property_08()).runTest("CWE400_Resource_Exhaustion__sleep_Property_08");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_URLConnection_09()).runTest("CWE400_Resource_Exhaustion__sleep_URLConnection_09");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_URLConnection_31()).runTest("CWE400_Resource_Exhaustion__sleep_URLConnection_31");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_random_10()).runTest("CWE400_Resource_Exhaustion__sleep_random_10");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_random_67a()).runTest("CWE400_Resource_Exhaustion__sleep_random_67a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_for_loop_53a()).runTest("CWE400_Resource_Exhaustion__URLConnection_for_loop_53a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_max_value_05()).runTest("CWE400_Resource_Exhaustion__sleep_max_value_05");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_PropertiesFile_81a()).runTest("CWE400_Resource_Exhaustion__sleep_PropertiesFile_81a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_write_03()).runTest("CWE400_Resource_Exhaustion__URLConnection_write_03");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_for_loop_66a()).runTest("CWE400_Resource_Exhaustion__URLConnection_for_loop_66a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_URLConnection_61a()).runTest("CWE400_Resource_Exhaustion__sleep_URLConnection_61a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_URLConnection_05()).runTest("CWE400_Resource_Exhaustion__sleep_URLConnection_05");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_Property_67a()).runTest("CWE400_Resource_Exhaustion__sleep_Property_67a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_Property_21()).runTest("CWE400_Resource_Exhaustion__sleep_Property_21");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_random_16()).runTest("CWE400_Resource_Exhaustion__sleep_random_16");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_write_16()).runTest("CWE400_Resource_Exhaustion__URLConnection_write_16");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_PropertiesFile_09()).runTest("CWE400_Resource_Exhaustion__sleep_PropertiesFile_09");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_for_loop_81a()).runTest("CWE400_Resource_Exhaustion__URLConnection_for_loop_81a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_URLConnection_51a()).runTest("CWE400_Resource_Exhaustion__sleep_URLConnection_51a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_URLConnection_75a()).runTest("CWE400_Resource_Exhaustion__sleep_URLConnection_75a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_write_73a()).runTest("CWE400_Resource_Exhaustion__URLConnection_write_73a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_for_loop_41()).runTest("CWE400_Resource_Exhaustion__URLConnection_for_loop_41");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_Property_05()).runTest("CWE400_Resource_Exhaustion__sleep_Property_05");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_for_loop_31()).runTest("CWE400_Resource_Exhaustion__URLConnection_for_loop_31");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_max_value_04()).runTest("CWE400_Resource_Exhaustion__sleep_max_value_04");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_PropertiesFile_10()).runTest("CWE400_Resource_Exhaustion__sleep_PropertiesFile_10");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_for_loop_61a()).runTest("CWE400_Resource_Exhaustion__URLConnection_for_loop_61a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_PropertiesFile_13()).runTest("CWE400_Resource_Exhaustion__sleep_PropertiesFile_13");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_PropertiesFile_07()).runTest("CWE400_Resource_Exhaustion__sleep_PropertiesFile_07");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_PropertiesFile_11()).runTest("CWE400_Resource_Exhaustion__sleep_PropertiesFile_11");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_Property_73a()).runTest("CWE400_Resource_Exhaustion__sleep_Property_73a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_write_22a()).runTest("CWE400_Resource_Exhaustion__URLConnection_write_22a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_write_14()).runTest("CWE400_Resource_Exhaustion__URLConnection_write_14");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_URLConnection_72a()).runTest("CWE400_Resource_Exhaustion__sleep_URLConnection_72a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_Property_53a()).runTest("CWE400_Resource_Exhaustion__sleep_Property_53a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_PropertiesFile_03()).runTest("CWE400_Resource_Exhaustion__sleep_PropertiesFile_03");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_write_52a()).runTest("CWE400_Resource_Exhaustion__URLConnection_write_52a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_max_value_21()).runTest("CWE400_Resource_Exhaustion__sleep_max_value_21");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_max_value_68a()).runTest("CWE400_Resource_Exhaustion__sleep_max_value_68a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_Property_11()).runTest("CWE400_Resource_Exhaustion__sleep_Property_11");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_for_loop_02()).runTest("CWE400_Resource_Exhaustion__URLConnection_for_loop_02");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_URLConnection_68a()).runTest("CWE400_Resource_Exhaustion__sleep_URLConnection_68a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_for_loop_74a()).runTest("CWE400_Resource_Exhaustion__URLConnection_for_loop_74a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_write_06()).runTest("CWE400_Resource_Exhaustion__URLConnection_write_06");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_max_value_54a()).runTest("CWE400_Resource_Exhaustion__sleep_max_value_54a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_PropertiesFile_22a()).runTest("CWE400_Resource_Exhaustion__sleep_PropertiesFile_22a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_PropertiesFile_68a()).runTest("CWE400_Resource_Exhaustion__sleep_PropertiesFile_68a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_Property_72a()).runTest("CWE400_Resource_Exhaustion__sleep_Property_72a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_random_02()).runTest("CWE400_Resource_Exhaustion__sleep_random_02");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_for_loop_13()).runTest("CWE400_Resource_Exhaustion__URLConnection_for_loop_13");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_PropertiesFile_06()).runTest("CWE400_Resource_Exhaustion__sleep_PropertiesFile_06");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_random_74a()).runTest("CWE400_Resource_Exhaustion__sleep_random_74a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_max_value_61a()).runTest("CWE400_Resource_Exhaustion__sleep_max_value_61a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_for_loop_03()).runTest("CWE400_Resource_Exhaustion__URLConnection_for_loop_03");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_URLConnection_67a()).runTest("CWE400_Resource_Exhaustion__sleep_URLConnection_67a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_PropertiesFile_51a()).runTest("CWE400_Resource_Exhaustion__sleep_PropertiesFile_51a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_max_value_07()).runTest("CWE400_Resource_Exhaustion__sleep_max_value_07");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_for_loop_75a()).runTest("CWE400_Resource_Exhaustion__URLConnection_for_loop_75a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_URLConnection_14()).runTest("CWE400_Resource_Exhaustion__sleep_URLConnection_14");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_random_05()).runTest("CWE400_Resource_Exhaustion__sleep_random_05");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_for_loop_52a()).runTest("CWE400_Resource_Exhaustion__URLConnection_for_loop_52a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_max_value_14()).runTest("CWE400_Resource_Exhaustion__sleep_max_value_14");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_Property_13()).runTest("CWE400_Resource_Exhaustion__sleep_Property_13");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_URLConnection_54a()).runTest("CWE400_Resource_Exhaustion__sleep_URLConnection_54a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_PropertiesFile_53a()).runTest("CWE400_Resource_Exhaustion__sleep_PropertiesFile_53a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_URLConnection_06()).runTest("CWE400_Resource_Exhaustion__sleep_URLConnection_06");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_PropertiesFile_54a()).runTest("CWE400_Resource_Exhaustion__sleep_PropertiesFile_54a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_Property_15()).runTest("CWE400_Resource_Exhaustion__sleep_Property_15");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_max_value_01()).runTest("CWE400_Resource_Exhaustion__sleep_max_value_01");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_random_71a()).runTest("CWE400_Resource_Exhaustion__sleep_random_71a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_PropertiesFile_61a()).runTest("CWE400_Resource_Exhaustion__sleep_PropertiesFile_61a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_write_51a()).runTest("CWE400_Resource_Exhaustion__URLConnection_write_51a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_max_value_09()).runTest("CWE400_Resource_Exhaustion__sleep_max_value_09");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_max_value_06()).runTest("CWE400_Resource_Exhaustion__sleep_max_value_06");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_URLConnection_12()).runTest("CWE400_Resource_Exhaustion__sleep_URLConnection_12");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_write_21()).runTest("CWE400_Resource_Exhaustion__URLConnection_write_21");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_random_51a()).runTest("CWE400_Resource_Exhaustion__sleep_random_51a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_max_value_12()).runTest("CWE400_Resource_Exhaustion__sleep_max_value_12");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_URLConnection_81a()).runTest("CWE400_Resource_Exhaustion__sleep_URLConnection_81a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_random_12()).runTest("CWE400_Resource_Exhaustion__sleep_random_12");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_write_68a()).runTest("CWE400_Resource_Exhaustion__URLConnection_write_68a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_random_41()).runTest("CWE400_Resource_Exhaustion__sleep_random_41");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_write_02()).runTest("CWE400_Resource_Exhaustion__URLConnection_write_02");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_Property_75a()).runTest("CWE400_Resource_Exhaustion__sleep_Property_75a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_max_value_22a()).runTest("CWE400_Resource_Exhaustion__sleep_max_value_22a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_Property_01()).runTest("CWE400_Resource_Exhaustion__sleep_Property_01");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_for_loop_07()).runTest("CWE400_Resource_Exhaustion__URLConnection_for_loop_07");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_PropertiesFile_74a()).runTest("CWE400_Resource_Exhaustion__sleep_PropertiesFile_74a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_for_loop_42()).runTest("CWE400_Resource_Exhaustion__URLConnection_for_loop_42");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_Property_81a()).runTest("CWE400_Resource_Exhaustion__sleep_Property_81a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_URLConnection_22a()).runTest("CWE400_Resource_Exhaustion__sleep_URLConnection_22a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_Property_71a()).runTest("CWE400_Resource_Exhaustion__sleep_Property_71a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_Property_22a()).runTest("CWE400_Resource_Exhaustion__sleep_Property_22a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_Property_74a()).runTest("CWE400_Resource_Exhaustion__sleep_Property_74a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_random_72a()).runTest("CWE400_Resource_Exhaustion__sleep_random_72a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_random_68a()).runTest("CWE400_Resource_Exhaustion__sleep_random_68a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_max_value_08()).runTest("CWE400_Resource_Exhaustion__sleep_max_value_08");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_Property_52a()).runTest("CWE400_Resource_Exhaustion__sleep_Property_52a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_Property_61a()).runTest("CWE400_Resource_Exhaustion__sleep_Property_61a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_max_value_73a()).runTest("CWE400_Resource_Exhaustion__sleep_max_value_73a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_random_11()).runTest("CWE400_Resource_Exhaustion__sleep_random_11");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_random_52a()).runTest("CWE400_Resource_Exhaustion__sleep_random_52a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_random_17()).runTest("CWE400_Resource_Exhaustion__sleep_random_17");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_Property_45()).runTest("CWE400_Resource_Exhaustion__sleep_Property_45");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_URLConnection_01()).runTest("CWE400_Resource_Exhaustion__sleep_URLConnection_01");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_PropertiesFile_21()).runTest("CWE400_Resource_Exhaustion__sleep_PropertiesFile_21");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_max_value_03()).runTest("CWE400_Resource_Exhaustion__sleep_max_value_03");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_random_81a()).runTest("CWE400_Resource_Exhaustion__sleep_random_81a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_for_loop_21()).runTest("CWE400_Resource_Exhaustion__URLConnection_for_loop_21");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_random_45()).runTest("CWE400_Resource_Exhaustion__sleep_random_45");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_URLConnection_10()).runTest("CWE400_Resource_Exhaustion__sleep_URLConnection_10");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_max_value_75a()).runTest("CWE400_Resource_Exhaustion__sleep_max_value_75a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_Property_09()).runTest("CWE400_Resource_Exhaustion__sleep_Property_09");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_write_05()).runTest("CWE400_Resource_Exhaustion__URLConnection_write_05");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_URLConnection_42()).runTest("CWE400_Resource_Exhaustion__sleep_URLConnection_42");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_for_loop_22a()).runTest("CWE400_Resource_Exhaustion__URLConnection_for_loop_22a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_URLConnection_45()).runTest("CWE400_Resource_Exhaustion__sleep_URLConnection_45");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_max_value_51a()).runTest("CWE400_Resource_Exhaustion__sleep_max_value_51a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_PropertiesFile_12()).runTest("CWE400_Resource_Exhaustion__sleep_PropertiesFile_12");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_PropertiesFile_73a()).runTest("CWE400_Resource_Exhaustion__sleep_PropertiesFile_73a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_write_09()).runTest("CWE400_Resource_Exhaustion__URLConnection_write_09");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_for_loop_72a()).runTest("CWE400_Resource_Exhaustion__URLConnection_for_loop_72a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_PropertiesFile_17()).runTest("CWE400_Resource_Exhaustion__sleep_PropertiesFile_17");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_Property_06()).runTest("CWE400_Resource_Exhaustion__sleep_Property_06");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_write_31()).runTest("CWE400_Resource_Exhaustion__URLConnection_write_31");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_for_loop_01()).runTest("CWE400_Resource_Exhaustion__URLConnection_for_loop_01");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_max_value_10()).runTest("CWE400_Resource_Exhaustion__sleep_max_value_10");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_URLConnection_07()).runTest("CWE400_Resource_Exhaustion__sleep_URLConnection_07");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_write_45()).runTest("CWE400_Resource_Exhaustion__URLConnection_write_45");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_max_value_52a()).runTest("CWE400_Resource_Exhaustion__sleep_max_value_52a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_random_31()).runTest("CWE400_Resource_Exhaustion__sleep_random_31");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_random_01()).runTest("CWE400_Resource_Exhaustion__sleep_random_01");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_random_15()).runTest("CWE400_Resource_Exhaustion__sleep_random_15");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_for_loop_11()).runTest("CWE400_Resource_Exhaustion__URLConnection_for_loop_11");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_random_53a()).runTest("CWE400_Resource_Exhaustion__sleep_random_53a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_Property_42()).runTest("CWE400_Resource_Exhaustion__sleep_Property_42");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_random_13()).runTest("CWE400_Resource_Exhaustion__sleep_random_13");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_max_value_31()).runTest("CWE400_Resource_Exhaustion__sleep_max_value_31");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_write_07()).runTest("CWE400_Resource_Exhaustion__URLConnection_write_07");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_write_41()).runTest("CWE400_Resource_Exhaustion__URLConnection_write_41");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_PropertiesFile_01()).runTest("CWE400_Resource_Exhaustion__sleep_PropertiesFile_01");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_Property_02()).runTest("CWE400_Resource_Exhaustion__sleep_Property_02");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_max_value_81a()).runTest("CWE400_Resource_Exhaustion__sleep_max_value_81a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_Property_41()).runTest("CWE400_Resource_Exhaustion__sleep_Property_41");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_random_61a()).runTest("CWE400_Resource_Exhaustion__sleep_random_61a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_random_42()).runTest("CWE400_Resource_Exhaustion__sleep_random_42");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_write_75a()).runTest("CWE400_Resource_Exhaustion__URLConnection_write_75a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_for_loop_12()).runTest("CWE400_Resource_Exhaustion__URLConnection_for_loop_12");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_random_73a()).runTest("CWE400_Resource_Exhaustion__sleep_random_73a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_PropertiesFile_75a()).runTest("CWE400_Resource_Exhaustion__sleep_PropertiesFile_75a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_for_loop_10()).runTest("CWE400_Resource_Exhaustion__URLConnection_for_loop_10");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_PropertiesFile_45()).runTest("CWE400_Resource_Exhaustion__sleep_PropertiesFile_45");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_random_22a()).runTest("CWE400_Resource_Exhaustion__sleep_random_22a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_Property_66a()).runTest("CWE400_Resource_Exhaustion__sleep_Property_66a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_random_04()).runTest("CWE400_Resource_Exhaustion__sleep_random_04");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_random_21()).runTest("CWE400_Resource_Exhaustion__sleep_random_21");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_max_value_11()).runTest("CWE400_Resource_Exhaustion__sleep_max_value_11");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_random_06()).runTest("CWE400_Resource_Exhaustion__sleep_random_06");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_max_value_17()).runTest("CWE400_Resource_Exhaustion__sleep_max_value_17");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_URLConnection_16()).runTest("CWE400_Resource_Exhaustion__sleep_URLConnection_16");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_PropertiesFile_15()).runTest("CWE400_Resource_Exhaustion__sleep_PropertiesFile_15");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_for_loop_45()).runTest("CWE400_Resource_Exhaustion__URLConnection_for_loop_45");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_write_72a()).runTest("CWE400_Resource_Exhaustion__URLConnection_write_72a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_write_04()).runTest("CWE400_Resource_Exhaustion__URLConnection_write_04");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_max_value_71a()).runTest("CWE400_Resource_Exhaustion__sleep_max_value_71a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_PropertiesFile_04()).runTest("CWE400_Resource_Exhaustion__sleep_PropertiesFile_04");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_Property_31()).runTest("CWE400_Resource_Exhaustion__sleep_Property_31");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_write_42()).runTest("CWE400_Resource_Exhaustion__URLConnection_write_42");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_URLConnection_52a()).runTest("CWE400_Resource_Exhaustion__sleep_URLConnection_52a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_PropertiesFile_41()).runTest("CWE400_Resource_Exhaustion__sleep_PropertiesFile_41");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_URLConnection_74a()).runTest("CWE400_Resource_Exhaustion__sleep_URLConnection_74a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_URLConnection_15()).runTest("CWE400_Resource_Exhaustion__sleep_URLConnection_15");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_write_15()).runTest("CWE400_Resource_Exhaustion__URLConnection_write_15");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_random_07()).runTest("CWE400_Resource_Exhaustion__sleep_random_07");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_for_loop_68a()).runTest("CWE400_Resource_Exhaustion__URLConnection_for_loop_68a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_Property_07()).runTest("CWE400_Resource_Exhaustion__sleep_Property_07");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_max_value_15()).runTest("CWE400_Resource_Exhaustion__sleep_max_value_15");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_max_value_41()).runTest("CWE400_Resource_Exhaustion__sleep_max_value_41");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_for_loop_71a()).runTest("CWE400_Resource_Exhaustion__URLConnection_for_loop_71a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_write_08()).runTest("CWE400_Resource_Exhaustion__URLConnection_write_08");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_PropertiesFile_66a()).runTest("CWE400_Resource_Exhaustion__sleep_PropertiesFile_66a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_max_value_13()).runTest("CWE400_Resource_Exhaustion__sleep_max_value_13");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_PropertiesFile_08()).runTest("CWE400_Resource_Exhaustion__sleep_PropertiesFile_08");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_PropertiesFile_31()).runTest("CWE400_Resource_Exhaustion__sleep_PropertiesFile_31");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_PropertiesFile_67a()).runTest("CWE400_Resource_Exhaustion__sleep_PropertiesFile_67a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_random_75a()).runTest("CWE400_Resource_Exhaustion__sleep_random_75a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_Property_54a()).runTest("CWE400_Resource_Exhaustion__sleep_Property_54a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_for_loop_73a()).runTest("CWE400_Resource_Exhaustion__URLConnection_for_loop_73a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_max_value_74a()).runTest("CWE400_Resource_Exhaustion__sleep_max_value_74a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_Property_68a()).runTest("CWE400_Resource_Exhaustion__sleep_Property_68a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_write_17()).runTest("CWE400_Resource_Exhaustion__URLConnection_write_17");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_Property_17()).runTest("CWE400_Resource_Exhaustion__sleep_Property_17");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_max_value_53a()).runTest("CWE400_Resource_Exhaustion__sleep_max_value_53a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_for_loop_16()).runTest("CWE400_Resource_Exhaustion__URLConnection_for_loop_16");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_for_loop_67a()).runTest("CWE400_Resource_Exhaustion__URLConnection_for_loop_67a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_URLConnection_13()).runTest("CWE400_Resource_Exhaustion__sleep_URLConnection_13");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_Property_16()).runTest("CWE400_Resource_Exhaustion__sleep_Property_16");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_Property_10()).runTest("CWE400_Resource_Exhaustion__sleep_Property_10");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_random_09()).runTest("CWE400_Resource_Exhaustion__sleep_random_09");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_for_loop_04()).runTest("CWE400_Resource_Exhaustion__URLConnection_for_loop_04");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_URLConnection_02()).runTest("CWE400_Resource_Exhaustion__sleep_URLConnection_02");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_URLConnection_04()).runTest("CWE400_Resource_Exhaustion__sleep_URLConnection_04");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_Property_03()).runTest("CWE400_Resource_Exhaustion__sleep_Property_03");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_for_loop_14()).runTest("CWE400_Resource_Exhaustion__URLConnection_for_loop_14");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_Property_12()).runTest("CWE400_Resource_Exhaustion__sleep_Property_12");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_write_54a()).runTest("CWE400_Resource_Exhaustion__URLConnection_write_54a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_PropertiesFile_14()).runTest("CWE400_Resource_Exhaustion__sleep_PropertiesFile_14");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_PropertiesFile_42()).runTest("CWE400_Resource_Exhaustion__sleep_PropertiesFile_42");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_PropertiesFile_02()).runTest("CWE400_Resource_Exhaustion__sleep_PropertiesFile_02");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_write_12()).runTest("CWE400_Resource_Exhaustion__URLConnection_write_12");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_for_loop_15()).runTest("CWE400_Resource_Exhaustion__URLConnection_for_loop_15");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_for_loop_08()).runTest("CWE400_Resource_Exhaustion__URLConnection_for_loop_08");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_random_08()).runTest("CWE400_Resource_Exhaustion__sleep_random_08");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__URLConnection_write_61a()).runTest("CWE400_Resource_Exhaustion__URLConnection_write_61a");
			(new testcases.CWE400_Resource_Exhaustion.s03.CWE400_Resource_Exhaustion__sleep_PropertiesFile_05()).runTest("CWE400_Resource_Exhaustion__sleep_PropertiesFile_05");
			/* END-AUTOGENERATED-JAVA-TESTS-4 */
}

private static void runTestCWE5() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-5 */

			/* END-AUTOGENERATED-JAVA-TESTS-5 */
}

private static void runTestCWE6() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-6 */

			/* END-AUTOGENERATED-JAVA-TESTS-6 */
}

private static void runTestCWE7() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-7 */

			/* END-AUTOGENERATED-JAVA-TESTS-7 */
}

private static void runTestCWE8() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-8 */

			/* END-AUTOGENERATED-JAVA-TESTS-8 */
}

private static void runTestCWE9() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-9 */

			/* END-AUTOGENERATED-JAVA-TESTS-9 */
}
}