package testcases.CWE506_Embedded_Malicious_Code;

import testcasesupport.*;

public class Main {

	public static void main(String[] args) {
		
		if(args.length != 0) {
		
			if(args[0].equals("-h") || args[0].equals("--help")) {
		
				System.err.println("To use this main, you can either run the program with no " +
				"command line arguments to run all test cases or you can specify one or more classes to test");
				System.err.println("For example:");
				System.err.println("java testcasesupport.Main testcases.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference.custom_function.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference__custom_function_01 testcases.CWE481_Assigning_instead_of_Comparing.bool.CWE481_Assigning_instead_of_Comparing__bool_01");
				System.exit(1);
			}
			
			/* User supplied some class names on the command line, just use those with introspection
			 *
			 * String classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
			 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
 			 * could read class names from command line or use
			 * http://sadun-util.sourceforge.net/api/org/sadun/util/
			 * ClassPackageExplorer.html
			 */

			for (String className : args) {

				try {
					
					/* String classNameWithPackage = "testcases." + className; */
					
					/* IO.writeLine("classNameWithPackage = " + classNameWithPackage); */

					Class<?> myClass = Class.forName(className);

					AbstractTestCase myObject = (AbstractTestCase) myClass
							.newInstance();

					myObject.runTest(className);

				} catch (Exception ex) {

					IO.writeLine("Could not run test for class " + className);
					ex.printStackTrace();

				}
				
				IO.writeLine(""); /* leave a blank line between classes */

			}

		} else {
		
			/* No command line args were used, we want to run every testcase */
			
			/* needed to separate these calls into other methods because
			   we were running into the size limit Java has for a single method */
			runTestCWE1();
			runTestCWE2();
			runTestCWE3();
			runTestCWE4();
			runTestCWE5();
			runTestCWE6();
			runTestCWE7();
			runTestCWE8();
			runTestCWE9();
		}			
	}

private static void runTestCWE1() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-1 */

			/* END-AUTOGENERATED-JAVA-TESTS-1 */
}

private static void runTestCWE2() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-2 */

			/* END-AUTOGENERATED-JAVA-TESTS-2 */
}

private static void runTestCWE3() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-3 */

			/* END-AUTOGENERATED-JAVA-TESTS-3 */
}

private static void runTestCWE4() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-4 */

			/* END-AUTOGENERATED-JAVA-TESTS-4 */
}

private static void runTestCWE5() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-5 */
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__aes_encrypted_payload_16()).runTest("CWE506_Embedded_Malicious_Code__aes_encrypted_payload_16");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_02()).runTest("CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_02");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__file_properties_02()).runTest("CWE506_Embedded_Malicious_Code__file_properties_02");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__base64_encoded_payload_09()).runTest("CWE506_Embedded_Malicious_Code__base64_encoded_payload_09");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_17()).runTest("CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_17");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__screen_capture_02()).runTest("CWE506_Embedded_Malicious_Code__screen_capture_02");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__aes_encrypted_payload_12()).runTest("CWE506_Embedded_Malicious_Code__aes_encrypted_payload_12");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_09()).runTest("CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_09");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__aes_encrypted_payload_06()).runTest("CWE506_Embedded_Malicious_Code__aes_encrypted_payload_06");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__email_03()).runTest("CWE506_Embedded_Malicious_Code__email_03");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_09()).runTest("CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_09");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_08()).runTest("CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_08");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__file_properties_12()).runTest("CWE506_Embedded_Malicious_Code__file_properties_12");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__email_17()).runTest("CWE506_Embedded_Malicious_Code__email_17");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__email_13()).runTest("CWE506_Embedded_Malicious_Code__email_13");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__file_properties_10()).runTest("CWE506_Embedded_Malicious_Code__file_properties_10");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_03()).runTest("CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_03");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__email_07()).runTest("CWE506_Embedded_Malicious_Code__email_07");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__screen_capture_16()).runTest("CWE506_Embedded_Malicious_Code__screen_capture_16");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__base64_encoded_payload_04()).runTest("CWE506_Embedded_Malicious_Code__base64_encoded_payload_04");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__aes_encrypted_payload_07()).runTest("CWE506_Embedded_Malicious_Code__aes_encrypted_payload_07");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__email_16()).runTest("CWE506_Embedded_Malicious_Code__email_16");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__base64_encoded_payload_15()).runTest("CWE506_Embedded_Malicious_Code__base64_encoded_payload_15");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__file_properties_08()).runTest("CWE506_Embedded_Malicious_Code__file_properties_08");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__aes_encrypted_payload_11()).runTest("CWE506_Embedded_Malicious_Code__aes_encrypted_payload_11");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_11()).runTest("CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_11");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_07()).runTest("CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_07");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__file_properties_03()).runTest("CWE506_Embedded_Malicious_Code__file_properties_03");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__base64_encoded_payload_16()).runTest("CWE506_Embedded_Malicious_Code__base64_encoded_payload_16");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_10()).runTest("CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_10");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_16()).runTest("CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_16");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__aes_encrypted_payload_17()).runTest("CWE506_Embedded_Malicious_Code__aes_encrypted_payload_17");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_01()).runTest("CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_01");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__base64_encoded_payload_06()).runTest("CWE506_Embedded_Malicious_Code__base64_encoded_payload_06");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__screen_capture_15()).runTest("CWE506_Embedded_Malicious_Code__screen_capture_15");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__aes_encrypted_payload_14()).runTest("CWE506_Embedded_Malicious_Code__aes_encrypted_payload_14");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_11()).runTest("CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_11");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_13()).runTest("CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_13");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_07()).runTest("CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_07");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__email_02()).runTest("CWE506_Embedded_Malicious_Code__email_02");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__screen_capture_01()).runTest("CWE506_Embedded_Malicious_Code__screen_capture_01");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__screen_capture_05()).runTest("CWE506_Embedded_Malicious_Code__screen_capture_05");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_08()).runTest("CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_08");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__base64_encoded_payload_08()).runTest("CWE506_Embedded_Malicious_Code__base64_encoded_payload_08");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__email_06()).runTest("CWE506_Embedded_Malicious_Code__email_06");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__email_10()).runTest("CWE506_Embedded_Malicious_Code__email_10");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__file_properties_15()).runTest("CWE506_Embedded_Malicious_Code__file_properties_15");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__file_properties_16()).runTest("CWE506_Embedded_Malicious_Code__file_properties_16");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__base64_encoded_payload_17()).runTest("CWE506_Embedded_Malicious_Code__base64_encoded_payload_17");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__base64_encoded_payload_11()).runTest("CWE506_Embedded_Malicious_Code__base64_encoded_payload_11");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__screen_capture_03()).runTest("CWE506_Embedded_Malicious_Code__screen_capture_03");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__aes_encrypted_payload_03()).runTest("CWE506_Embedded_Malicious_Code__aes_encrypted_payload_03");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__file_properties_09()).runTest("CWE506_Embedded_Malicious_Code__file_properties_09");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__aes_encrypted_payload_02()).runTest("CWE506_Embedded_Malicious_Code__aes_encrypted_payload_02");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__base64_encoded_payload_03()).runTest("CWE506_Embedded_Malicious_Code__base64_encoded_payload_03");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__email_14()).runTest("CWE506_Embedded_Malicious_Code__email_14");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__email_01()).runTest("CWE506_Embedded_Malicious_Code__email_01");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__aes_encrypted_payload_15()).runTest("CWE506_Embedded_Malicious_Code__aes_encrypted_payload_15");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__email_09()).runTest("CWE506_Embedded_Malicious_Code__email_09");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_04()).runTest("CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_04");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__base64_encoded_payload_14()).runTest("CWE506_Embedded_Malicious_Code__base64_encoded_payload_14");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__screen_capture_09()).runTest("CWE506_Embedded_Malicious_Code__screen_capture_09");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__base64_encoded_payload_10()).runTest("CWE506_Embedded_Malicious_Code__base64_encoded_payload_10");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_15()).runTest("CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_15");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__file_properties_17()).runTest("CWE506_Embedded_Malicious_Code__file_properties_17");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__aes_encrypted_payload_01()).runTest("CWE506_Embedded_Malicious_Code__aes_encrypted_payload_01");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__screen_capture_11()).runTest("CWE506_Embedded_Malicious_Code__screen_capture_11");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__screen_capture_14()).runTest("CWE506_Embedded_Malicious_Code__screen_capture_14");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__email_04()).runTest("CWE506_Embedded_Malicious_Code__email_04");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__base64_encoded_payload_12()).runTest("CWE506_Embedded_Malicious_Code__base64_encoded_payload_12");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__aes_encrypted_payload_13()).runTest("CWE506_Embedded_Malicious_Code__aes_encrypted_payload_13");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_01()).runTest("CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_01");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__file_properties_06()).runTest("CWE506_Embedded_Malicious_Code__file_properties_06");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_06()).runTest("CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_06");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__file_properties_13()).runTest("CWE506_Embedded_Malicious_Code__file_properties_13");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_03()).runTest("CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_03");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__screen_capture_17()).runTest("CWE506_Embedded_Malicious_Code__screen_capture_17");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_06()).runTest("CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_06");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__screen_capture_07()).runTest("CWE506_Embedded_Malicious_Code__screen_capture_07");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__aes_encrypted_payload_04()).runTest("CWE506_Embedded_Malicious_Code__aes_encrypted_payload_04");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_04()).runTest("CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_04");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__file_properties_04()).runTest("CWE506_Embedded_Malicious_Code__file_properties_04");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__aes_encrypted_payload_08()).runTest("CWE506_Embedded_Malicious_Code__aes_encrypted_payload_08");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__email_08()).runTest("CWE506_Embedded_Malicious_Code__email_08");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__file_properties_05()).runTest("CWE506_Embedded_Malicious_Code__file_properties_05");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__file_properties_11()).runTest("CWE506_Embedded_Malicious_Code__file_properties_11");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__email_15()).runTest("CWE506_Embedded_Malicious_Code__email_15");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__file_properties_07()).runTest("CWE506_Embedded_Malicious_Code__file_properties_07");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_10()).runTest("CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_10");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__aes_encrypted_payload_09()).runTest("CWE506_Embedded_Malicious_Code__aes_encrypted_payload_09");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_14()).runTest("CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_14");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__screen_capture_04()).runTest("CWE506_Embedded_Malicious_Code__screen_capture_04");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__email_11()).runTest("CWE506_Embedded_Malicious_Code__email_11");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__file_properties_14()).runTest("CWE506_Embedded_Malicious_Code__file_properties_14");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__screen_capture_08()).runTest("CWE506_Embedded_Malicious_Code__screen_capture_08");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__base64_encoded_payload_13()).runTest("CWE506_Embedded_Malicious_Code__base64_encoded_payload_13");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__aes_encrypted_payload_10()).runTest("CWE506_Embedded_Malicious_Code__aes_encrypted_payload_10");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__file_properties_01()).runTest("CWE506_Embedded_Malicious_Code__file_properties_01");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_02()).runTest("CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_02");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_05()).runTest("CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_05");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_17()).runTest("CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_17");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__screen_capture_13()).runTest("CWE506_Embedded_Malicious_Code__screen_capture_13");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__email_05()).runTest("CWE506_Embedded_Malicious_Code__email_05");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__screen_capture_06()).runTest("CWE506_Embedded_Malicious_Code__screen_capture_06");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__base64_encoded_payload_01()).runTest("CWE506_Embedded_Malicious_Code__base64_encoded_payload_01");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_05()).runTest("CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_05");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__base64_encoded_payload_07()).runTest("CWE506_Embedded_Malicious_Code__base64_encoded_payload_07");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__base64_encoded_payload_02()).runTest("CWE506_Embedded_Malicious_Code__base64_encoded_payload_02");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__reflection_01()).runTest("CWE506_Embedded_Malicious_Code__reflection_01");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__aes_encrypted_payload_05()).runTest("CWE506_Embedded_Malicious_Code__aes_encrypted_payload_05");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_14()).runTest("CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_14");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__screen_capture_10()).runTest("CWE506_Embedded_Malicious_Code__screen_capture_10");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__base64_encoded_payload_05()).runTest("CWE506_Embedded_Malicious_Code__base64_encoded_payload_05");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_16()).runTest("CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_16");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_15()).runTest("CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_15");
			(new testcases.CWE506_Embedded_Malicious_Code.CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_13()).runTest("CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_13");
			/* END-AUTOGENERATED-JAVA-TESTS-5 */
}

private static void runTestCWE6() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-6 */

			/* END-AUTOGENERATED-JAVA-TESTS-6 */
}

private static void runTestCWE7() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-7 */

			/* END-AUTOGENERATED-JAVA-TESTS-7 */
}

private static void runTestCWE8() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-8 */

			/* END-AUTOGENERATED-JAVA-TESTS-8 */
}

private static void runTestCWE9() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-9 */

			/* END-AUTOGENERATED-JAVA-TESTS-9 */
}
}