package testcases.CWE511_Logic_Time_Bomb;

import testcasesupport.*;

public class Main {

	public static void main(String[] args) {
		
		if(args.length != 0) {
		
			if(args[0].equals("-h") || args[0].equals("--help")) {
		
				System.err.println("To use this main, you can either run the program with no " +
				"command line arguments to run all test cases or you can specify one or more classes to test");
				System.err.println("For example:");
				System.err.println("java testcasesupport.Main testcases.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference.custom_function.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference__custom_function_01 testcases.CWE481_Assigning_instead_of_Comparing.bool.CWE481_Assigning_instead_of_Comparing__bool_01");
				System.exit(1);
			}
			
			/* User supplied some class names on the command line, just use those with introspection
			 *
			 * String classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
			 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
 			 * could read class names from command line or use
			 * http://sadun-util.sourceforge.net/api/org/sadun/util/
			 * ClassPackageExplorer.html
			 */

			for (String className : args) {

				try {
					
					/* String classNameWithPackage = "testcases." + className; */
					
					/* IO.writeLine("classNameWithPackage = " + classNameWithPackage); */

					Class<?> myClass = Class.forName(className);

					AbstractTestCase myObject = (AbstractTestCase) myClass
							.newInstance();

					myObject.runTest(className);

				} catch (Exception ex) {

					IO.writeLine("Could not run test for class " + className);
					ex.printStackTrace();

				}
				
				IO.writeLine(""); /* leave a blank line between classes */

			}

		} else {
		
			/* No command line args were used, we want to run every testcase */
			
			/* needed to separate these calls into other methods because
			   we were running into the size limit Java has for a single method */
			runTestCWE1();
			runTestCWE2();
			runTestCWE3();
			runTestCWE4();
			runTestCWE5();
			runTestCWE6();
			runTestCWE7();
			runTestCWE8();
			runTestCWE9();
		}			
	}

private static void runTestCWE1() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-1 */

			/* END-AUTOGENERATED-JAVA-TESTS-1 */
}

private static void runTestCWE2() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-2 */

			/* END-AUTOGENERATED-JAVA-TESTS-2 */
}

private static void runTestCWE3() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-3 */

			/* END-AUTOGENERATED-JAVA-TESTS-3 */
}

private static void runTestCWE4() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-4 */

			/* END-AUTOGENERATED-JAVA-TESTS-4 */
}

private static void runTestCWE5() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-5 */
			(new testcases.CWE511_Logic_Time_Bomb.CWE511_Logic_Time_Bomb__time_04()).runTest("CWE511_Logic_Time_Bomb__time_04");
			(new testcases.CWE511_Logic_Time_Bomb.CWE511_Logic_Time_Bomb__counter_03()).runTest("CWE511_Logic_Time_Bomb__counter_03");
			(new testcases.CWE511_Logic_Time_Bomb.CWE511_Logic_Time_Bomb__rand_13()).runTest("CWE511_Logic_Time_Bomb__rand_13");
			(new testcases.CWE511_Logic_Time_Bomb.CWE511_Logic_Time_Bomb__rand_05()).runTest("CWE511_Logic_Time_Bomb__rand_05");
			(new testcases.CWE511_Logic_Time_Bomb.CWE511_Logic_Time_Bomb__rand_15()).runTest("CWE511_Logic_Time_Bomb__rand_15");
			(new testcases.CWE511_Logic_Time_Bomb.CWE511_Logic_Time_Bomb__time_03()).runTest("CWE511_Logic_Time_Bomb__time_03");
			(new testcases.CWE511_Logic_Time_Bomb.CWE511_Logic_Time_Bomb__rand_14()).runTest("CWE511_Logic_Time_Bomb__rand_14");
			(new testcases.CWE511_Logic_Time_Bomb.CWE511_Logic_Time_Bomb__time_06()).runTest("CWE511_Logic_Time_Bomb__time_06");
			(new testcases.CWE511_Logic_Time_Bomb.CWE511_Logic_Time_Bomb__time_09()).runTest("CWE511_Logic_Time_Bomb__time_09");
			(new testcases.CWE511_Logic_Time_Bomb.CWE511_Logic_Time_Bomb__rand_09()).runTest("CWE511_Logic_Time_Bomb__rand_09");
			(new testcases.CWE511_Logic_Time_Bomb.CWE511_Logic_Time_Bomb__rand_12()).runTest("CWE511_Logic_Time_Bomb__rand_12");
			(new testcases.CWE511_Logic_Time_Bomb.CWE511_Logic_Time_Bomb__counter_11()).runTest("CWE511_Logic_Time_Bomb__counter_11");
			(new testcases.CWE511_Logic_Time_Bomb.CWE511_Logic_Time_Bomb__counter_17()).runTest("CWE511_Logic_Time_Bomb__counter_17");
			(new testcases.CWE511_Logic_Time_Bomb.CWE511_Logic_Time_Bomb__rand_16()).runTest("CWE511_Logic_Time_Bomb__rand_16");
			(new testcases.CWE511_Logic_Time_Bomb.CWE511_Logic_Time_Bomb__counter_02()).runTest("CWE511_Logic_Time_Bomb__counter_02");
			(new testcases.CWE511_Logic_Time_Bomb.CWE511_Logic_Time_Bomb__time_02()).runTest("CWE511_Logic_Time_Bomb__time_02");
			(new testcases.CWE511_Logic_Time_Bomb.CWE511_Logic_Time_Bomb__time_12()).runTest("CWE511_Logic_Time_Bomb__time_12");
			(new testcases.CWE511_Logic_Time_Bomb.CWE511_Logic_Time_Bomb__counter_04()).runTest("CWE511_Logic_Time_Bomb__counter_04");
			(new testcases.CWE511_Logic_Time_Bomb.CWE511_Logic_Time_Bomb__rand_06()).runTest("CWE511_Logic_Time_Bomb__rand_06");
			(new testcases.CWE511_Logic_Time_Bomb.CWE511_Logic_Time_Bomb__rand_17()).runTest("CWE511_Logic_Time_Bomb__rand_17");
			(new testcases.CWE511_Logic_Time_Bomb.CWE511_Logic_Time_Bomb__rand_08()).runTest("CWE511_Logic_Time_Bomb__rand_08");
			(new testcases.CWE511_Logic_Time_Bomb.CWE511_Logic_Time_Bomb__time_07()).runTest("CWE511_Logic_Time_Bomb__time_07");
			(new testcases.CWE511_Logic_Time_Bomb.CWE511_Logic_Time_Bomb__counter_09()).runTest("CWE511_Logic_Time_Bomb__counter_09");
			(new testcases.CWE511_Logic_Time_Bomb.CWE511_Logic_Time_Bomb__rand_01()).runTest("CWE511_Logic_Time_Bomb__rand_01");
			(new testcases.CWE511_Logic_Time_Bomb.CWE511_Logic_Time_Bomb__time_14()).runTest("CWE511_Logic_Time_Bomb__time_14");
			(new testcases.CWE511_Logic_Time_Bomb.CWE511_Logic_Time_Bomb__time_11()).runTest("CWE511_Logic_Time_Bomb__time_11");
			(new testcases.CWE511_Logic_Time_Bomb.CWE511_Logic_Time_Bomb__counter_12()).runTest("CWE511_Logic_Time_Bomb__counter_12");
			(new testcases.CWE511_Logic_Time_Bomb.CWE511_Logic_Time_Bomb__counter_13()).runTest("CWE511_Logic_Time_Bomb__counter_13");
			(new testcases.CWE511_Logic_Time_Bomb.CWE511_Logic_Time_Bomb__time_15()).runTest("CWE511_Logic_Time_Bomb__time_15");
			(new testcases.CWE511_Logic_Time_Bomb.CWE511_Logic_Time_Bomb__counter_16()).runTest("CWE511_Logic_Time_Bomb__counter_16");
			(new testcases.CWE511_Logic_Time_Bomb.CWE511_Logic_Time_Bomb__rand_07()).runTest("CWE511_Logic_Time_Bomb__rand_07");
			(new testcases.CWE511_Logic_Time_Bomb.CWE511_Logic_Time_Bomb__time_17()).runTest("CWE511_Logic_Time_Bomb__time_17");
			(new testcases.CWE511_Logic_Time_Bomb.CWE511_Logic_Time_Bomb__counter_14()).runTest("CWE511_Logic_Time_Bomb__counter_14");
			(new testcases.CWE511_Logic_Time_Bomb.CWE511_Logic_Time_Bomb__counter_07()).runTest("CWE511_Logic_Time_Bomb__counter_07");
			(new testcases.CWE511_Logic_Time_Bomb.CWE511_Logic_Time_Bomb__rand_10()).runTest("CWE511_Logic_Time_Bomb__rand_10");
			(new testcases.CWE511_Logic_Time_Bomb.CWE511_Logic_Time_Bomb__time_16()).runTest("CWE511_Logic_Time_Bomb__time_16");
			(new testcases.CWE511_Logic_Time_Bomb.CWE511_Logic_Time_Bomb__time_01()).runTest("CWE511_Logic_Time_Bomb__time_01");
			(new testcases.CWE511_Logic_Time_Bomb.CWE511_Logic_Time_Bomb__counter_10()).runTest("CWE511_Logic_Time_Bomb__counter_10");
			(new testcases.CWE511_Logic_Time_Bomb.CWE511_Logic_Time_Bomb__counter_08()).runTest("CWE511_Logic_Time_Bomb__counter_08");
			(new testcases.CWE511_Logic_Time_Bomb.CWE511_Logic_Time_Bomb__rand_04()).runTest("CWE511_Logic_Time_Bomb__rand_04");
			(new testcases.CWE511_Logic_Time_Bomb.CWE511_Logic_Time_Bomb__rand_11()).runTest("CWE511_Logic_Time_Bomb__rand_11");
			(new testcases.CWE511_Logic_Time_Bomb.CWE511_Logic_Time_Bomb__rand_02()).runTest("CWE511_Logic_Time_Bomb__rand_02");
			(new testcases.CWE511_Logic_Time_Bomb.CWE511_Logic_Time_Bomb__time_13()).runTest("CWE511_Logic_Time_Bomb__time_13");
			(new testcases.CWE511_Logic_Time_Bomb.CWE511_Logic_Time_Bomb__time_10()).runTest("CWE511_Logic_Time_Bomb__time_10");
			(new testcases.CWE511_Logic_Time_Bomb.CWE511_Logic_Time_Bomb__time_05()).runTest("CWE511_Logic_Time_Bomb__time_05");
			(new testcases.CWE511_Logic_Time_Bomb.CWE511_Logic_Time_Bomb__time_08()).runTest("CWE511_Logic_Time_Bomb__time_08");
			(new testcases.CWE511_Logic_Time_Bomb.CWE511_Logic_Time_Bomb__counter_05()).runTest("CWE511_Logic_Time_Bomb__counter_05");
			(new testcases.CWE511_Logic_Time_Bomb.CWE511_Logic_Time_Bomb__counter_01()).runTest("CWE511_Logic_Time_Bomb__counter_01");
			(new testcases.CWE511_Logic_Time_Bomb.CWE511_Logic_Time_Bomb__counter_06()).runTest("CWE511_Logic_Time_Bomb__counter_06");
			(new testcases.CWE511_Logic_Time_Bomb.CWE511_Logic_Time_Bomb__rand_03()).runTest("CWE511_Logic_Time_Bomb__rand_03");
			(new testcases.CWE511_Logic_Time_Bomb.CWE511_Logic_Time_Bomb__counter_15()).runTest("CWE511_Logic_Time_Bomb__counter_15");
			/* END-AUTOGENERATED-JAVA-TESTS-5 */
}

private static void runTestCWE6() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-6 */

			/* END-AUTOGENERATED-JAVA-TESTS-6 */
}

private static void runTestCWE7() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-7 */

			/* END-AUTOGENERATED-JAVA-TESTS-7 */
}

private static void runTestCWE8() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-8 */

			/* END-AUTOGENERATED-JAVA-TESTS-8 */
}

private static void runTestCWE9() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-9 */

			/* END-AUTOGENERATED-JAVA-TESTS-9 */
}
}