package testcases.CWE789_Uncontrolled_Mem_Alloc.s01;

import testcasesupport.*;

public class Main {

	public static void main(String[] args) {
		
		if(args.length != 0) {
		
			if(args[0].equals("-h") || args[0].equals("--help")) {
		
				System.err.println("To use this main, you can either run the program with no " +
				"command line arguments to run all test cases or you can specify one or more classes to test");
				System.err.println("For example:");
				System.err.println("java testcasesupport.Main testcases.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference.custom_function.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference__custom_function_01 testcases.CWE481_Assigning_instead_of_Comparing.bool.CWE481_Assigning_instead_of_Comparing__bool_01");
				System.exit(1);
			}
			
			/* User supplied some class names on the command line, just use those with introspection
			 *
			 * String classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
			 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
 			 * could read class names from command line or use
			 * http://sadun-util.sourceforge.net/api/org/sadun/util/
			 * ClassPackageExplorer.html
			 */

			for (String className : args) {

				try {
					
					/* String classNameWithPackage = "testcases." + className; */
					
					/* IO.writeLine("classNameWithPackage = " + classNameWithPackage); */

					Class<?> myClass = Class.forName(className);

					AbstractTestCase myObject = (AbstractTestCase) myClass
							.newInstance();

					myObject.runTest(className);

				} catch (Exception ex) {

					IO.writeLine("Could not run test for class " + className);
					ex.printStackTrace();

				}
				
				IO.writeLine(""); /* leave a blank line between classes */

			}

		} else {
		
			/* No command line args were used, we want to run every testcase */
			
			/* needed to separate these calls into other methods because
			   we were running into the size limit Java has for a single method */
			runTestCWE1();
			runTestCWE2();
			runTestCWE3();
			runTestCWE4();
			runTestCWE5();
			runTestCWE6();
			runTestCWE7();
			runTestCWE8();
			runTestCWE9();
		}			
	}

private static void runTestCWE1() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-1 */

			/* END-AUTOGENERATED-JAVA-TESTS-1 */
}

private static void runTestCWE2() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-2 */

			/* END-AUTOGENERATED-JAVA-TESTS-2 */
}

private static void runTestCWE3() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-3 */

			/* END-AUTOGENERATED-JAVA-TESTS-3 */
}

private static void runTestCWE4() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-4 */

			/* END-AUTOGENERATED-JAVA-TESTS-4 */
}

private static void runTestCWE5() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-5 */

			/* END-AUTOGENERATED-JAVA-TESTS-5 */
}

private static void runTestCWE6() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-6 */

			/* END-AUTOGENERATED-JAVA-TESTS-6 */
}

private static void runTestCWE7() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-7 */
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashSet_54a()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashSet_54a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_42()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_42");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_45()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_45");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashSet_42()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_42");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashSet_21()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashSet_21");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_81a()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_81a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashMap_11()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashMap_11");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_16()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_16");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_53a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_53a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_09()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_09");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_66a()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_66a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_04()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_04");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_08()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_08");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashSet_81a()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_81a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_68a()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_68a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_17()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_17");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_17()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_17");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_11()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_11");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_12()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_12");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashMap_07()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashMap_07");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_05()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_05");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashMap_72a()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashMap_72a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_41()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_41");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashSet_11()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_11");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_72a()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_72a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_67a()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_67a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_41()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_41");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_11()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_11");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashMap_67a()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashMap_67a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_09()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_09");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashSet_53a()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_53a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashMap_41()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashMap_41");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_67a()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_67a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_06()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_06");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_67a()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_67a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_45()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_45");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_52a()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_52a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_72a()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_72a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashSet_73a()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashSet_73a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_16()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_16");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_72a()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_72a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashSet_54a()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_54a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashSet_08()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_08");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_06()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_06");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_21()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_21");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_67a()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_67a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_05()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_05");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashMap_75a()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashMap_75a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_05()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_05");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashSet_73a()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_73a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_72a()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_72a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashMap_04()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashMap_04");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashMap_74a()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashMap_74a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashSet_51a()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_51a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashSet_45()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashSet_45");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_71a()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_71a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashMap_15()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashMap_15");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashSet_31()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_31");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_08()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_08");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_09()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_09");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_42()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_42");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashSet_16()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashSet_16");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_08()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_08");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_68a()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_68a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_04()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_04");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_02()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_02");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_54a()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_54a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_72a()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_72a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_73a()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_73a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_71a()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_71a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_45()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_45");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_71a()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_71a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_31()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_31");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_51a()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_51a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashSet_07()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashSet_07");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashMap_31()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashMap_31");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashMap_05()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashMap_05");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_17()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_17");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashSet_45()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_45");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashMap_45()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashMap_45");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_04()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_04");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_09()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_09");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_01()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_01");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_51a()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_51a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_15()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_15");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashSet_74a()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashSet_74a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_45()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_45");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_15()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_15");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_07()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_07");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_68a()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_68a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashMap_01()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashMap_01");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_01()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_01");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_21()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_21");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_81a()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_81a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_41()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_41");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_54a()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_54a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashSet_21()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_21");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashSet_42()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashSet_42");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashMap_74a()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashMap_74a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_75a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_75a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashSet_67a()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashSet_67a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_41()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_41");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_41()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_41");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashMap_14()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashMap_14");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_13()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_13");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_14()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_14");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_51a()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_51a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_53a()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_53a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_52a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_52a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_13()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_13");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_12()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_12");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_15()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_15");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_05()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_05");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_81a()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_81a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashMap_02()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashMap_02");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_54a()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_54a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_54a()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_54a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_73a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_73a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_11()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_11");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashMap_22a()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashMap_22a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_22a()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_22a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_16()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_16");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_10()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_10");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_72a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_72a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_52a()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_52a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_31()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_31");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_51a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_51a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_17()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_17");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_02()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_02");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_06()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_06");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_54a()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_54a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_81a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_81a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_21()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_21");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashSet_53a()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashSet_53a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_51a()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_51a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashMap_68a()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashMap_68a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashSet_09()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_09");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_16()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_16");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_52a()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_52a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_81a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_81a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashSet_02()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashSet_02");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_13()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_13");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashSet_16()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_16");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_03()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_03");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashMap_08()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashMap_08");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashSet_61a()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashSet_61a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_05()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_05");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_74a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_74a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_31()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_31");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_22a()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_22a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_52a()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_52a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashMap_06()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashMap_06");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashSet_15()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_15");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashSet_61a()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_61a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_61a()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_61a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_72a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_72a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_74a()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_74a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_42()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_42");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_06()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_06");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_06()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_06");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashMap_72a()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashMap_72a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashMap_31()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashMap_31");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_31()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_31");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_21()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_21");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_16()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_16");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_54a()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_54a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashMap_21()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashMap_21");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashSet_17()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashSet_17");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_51a()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_51a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_12()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_12");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashMap_06()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashMap_06");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_10()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_10");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_02()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_02");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_10()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_10");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashSet_74a()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_74a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_10()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_10");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashMap_53a()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashMap_53a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashSet_41()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_41");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_10()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_10");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_01()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_01");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_06()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_06");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_14()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_14");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_12()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_12");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashSet_04()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashSet_04");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashMap_16()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashMap_16");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_74a()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_74a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashMap_52a()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashMap_52a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashSet_10()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashSet_10");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashMap_53a()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashMap_53a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_42()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_42");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_11()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_11");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_68a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_68a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashMap_75a()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashMap_75a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_01()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_01");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_66a()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_66a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_22a()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_22a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashSet_72a()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_72a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_81a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_81a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_31()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_31");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_17()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_17");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_11()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_11");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_09()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_09");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_52a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_52a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_45()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_45");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_01()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_01");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_73a()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_73a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_74a()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_74a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_53a()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_53a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_07()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_07");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_15()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_15");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashMap_05()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashMap_05");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_14()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_14");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashSet_03()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashSet_03");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_67a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_67a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_41()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_41");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_68a()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_68a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashMap_07()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashMap_07");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_41()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_41");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_02()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_02");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_53a()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_53a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_61a()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_61a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_31()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_31");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_68a()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_68a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_71a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_71a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_51a()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_51a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashMap_22a()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashMap_22a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_54a()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_54a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_07()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_07");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashMap_03()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashMap_03");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashMap_73a()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashMap_73a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_71a()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_71a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashMap_14()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashMap_14");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashSet_66a()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_66a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_10()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_10");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_14()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_14");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_13()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_13");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_61a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_61a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashMap_12()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashMap_12");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashMap_11()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashMap_11");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashSet_13()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashSet_13");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashSet_68a()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashSet_68a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_73a()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_73a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashSet_06()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashSet_06");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_71a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_71a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_14()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_14");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_22a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_22a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_52a()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_52a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashMap_09()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashMap_09");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_11()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_11");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_81a()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_81a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_54a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_54a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_73a()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_73a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_53a()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_53a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_03()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_03");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_21()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_21");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_14()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_14");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashMap_42()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashMap_42");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_75a()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_75a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_02()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_02");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_07()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_07");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashSet_04()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_04");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_66a()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_66a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_53a()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_53a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashMap_04()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashMap_04");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_10()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_10");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_11()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_11");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_17()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_17");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashMap_81a()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashMap_81a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_15()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_15");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_15()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_15");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_17()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_17");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashSet_22a()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashSet_22a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_16()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_16");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_03()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_03");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_73a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_73a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_74a()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_74a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_45()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_45");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashMap_71a()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashMap_71a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_01()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_01");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_31()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_31");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashMap_16()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashMap_16");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashMap_02()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashMap_02");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_81a()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_81a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashSet_05()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_05");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_02()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_02");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashMap_61a()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashMap_61a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_41()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_41");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_52a()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_52a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_03()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_03");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashMap_03()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashMap_03");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_11()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_11");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashSet_06()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_06");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_71a()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_71a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashSet_15()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashSet_15");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashMap_08()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashMap_08");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_03()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_03");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_13()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_13");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashMap_21()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashMap_21");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_75a()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_75a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_14()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_14");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_71a()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_71a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_02()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_02");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashSet_22a()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_22a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashSet_41()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashSet_41");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_75a()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_75a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashSet_01()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_01");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_21()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_21");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_09()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_09");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashSet_07()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_07");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashSet_11()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashSet_11");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_31()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_31");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_53a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_53a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_08()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_08");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_74a()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_74a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_09()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_09");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_74a()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_74a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_72a()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_72a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_31()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_31");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_45()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_45");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashSet_10()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_10");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_61a()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_61a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_12()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_12");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_08()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_08");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_75a()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_75a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_68a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_68a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_10()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_10");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashMap_10()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashMap_10");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_22a()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_22a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashMap_17()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashMap_17");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_17()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_17");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_16()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_16");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_10()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_10");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_04()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_04");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashSet_72a()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashSet_72a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashSet_05()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashSet_05");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_52a()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_52a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_74a()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_74a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_61a()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_61a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_13()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_13");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashSet_81a()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashSet_81a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_21()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_21");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_75a()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_75a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_52a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_52a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_09()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_09");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_74a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_74a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_51a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_51a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_73a()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_73a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_05()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_05");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_11()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_11");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_17()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_17");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_08()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_08");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_67a()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_67a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_03()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_03");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_74a()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_74a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_42()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_42");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_66a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_66a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashMap_09()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashMap_09");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_31()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_31");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_72a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_72a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashMap_13()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashMap_13");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_42()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_42");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_42()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_42");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_15()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_15");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_17()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_17");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_66a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_66a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_54a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_54a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_81a()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_81a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_71a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_71a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_73a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_73a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashMap_45()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashMap_45");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_08()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_08");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashMap_67a()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashMap_67a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_22a()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_22a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_07()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_07");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashSet_17()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_17");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_05()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_05");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashSet_75a()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashSet_75a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_22a()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_22a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_14()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_14");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_17()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_17");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_07()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_07");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashSet_71a()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashSet_71a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_12()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_12");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_68a()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_68a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashSet_52a()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_52a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashSet_75a()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_75a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashSet_68a()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_68a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_07()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_07");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_05()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_05");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_04()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_04");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_21()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_21");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_06()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_06");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_05()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_05");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashSet_13()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_13");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_54a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_54a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_81a()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_81a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_66a()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_66a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashMap_61a()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashMap_61a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_42()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_42");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_13()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_13");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_13()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_13");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashMap_68a()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashMap_68a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_08()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_08");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_41()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_41");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_07()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_07");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashMap_71a()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashMap_71a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_08()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_08");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_16()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_16");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_67a()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_67a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_75a()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_75a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashMap_54a()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashMap_54a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_11()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_11");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashMap_41()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashMap_41");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_12()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_12");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_66a()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_66a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_22a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_22a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_12()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_12");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_05()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_05");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashMap_51a()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashMap_51a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_06()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_06");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_51a()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_51a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_53a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_53a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashMap_54a()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashMap_54a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashMap_13()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashMap_13");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_22a()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_22a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_10()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_10");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_01()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_01");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashMap_12()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashMap_12");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashSet_51a()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashSet_51a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_09()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_09");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_61a()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_61a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashMap_73a()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashMap_73a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_03()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_03");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_14()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_14");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashMap_01()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashMap_01");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_73a()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_73a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_61a()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_61a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_74a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_74a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_67a()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_67a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_45()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_45");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_66a()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_66a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_12()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_12");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_45()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_45");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_75a()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_75a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_10()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_10");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_61a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_61a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_41()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_41");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_21()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_21");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_53a()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_53a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_66a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_66a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_75a()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_75a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_04()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_04");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashMap_17()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashMap_17");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_73a()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_73a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashMap_66a()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashMap_66a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_08()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_08");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashSet_01()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashSet_01");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_68a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_68a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_42()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_42");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashMap_81a()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashMap_81a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_01()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_01");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_14()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_14");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_22a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_22a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_03()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_03");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_16()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_16");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_31()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_31");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_72a()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_72a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_71a()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_71a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_16()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_16");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_52a()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_52a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_13()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_13");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_54a()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_54a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_75a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_75a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_02()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_02");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_16()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_16");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_66a()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_66a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashSet_03()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_03");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_03()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_03");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_08()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_08");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_11()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_11");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_21()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_21");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_15()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_15");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_53a()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_53a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_09()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_09");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_04()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_04");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_53a()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_53a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_07()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_07");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_02()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_02");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_04()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_04");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_09()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_09");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_67a()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_67a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_01()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_01");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashSet_09()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashSet_09");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_07()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_07");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_06()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_06");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_67a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_67a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_51a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_51a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_07()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_07");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_41()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_41");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_01()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_01");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_05()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_05");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashSet_67a()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_67a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_01()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_01");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_75a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_75a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_61a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_61a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_04()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_04");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_03()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_03");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashSet_02()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_02");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_06()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_06");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_15()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_15");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_21()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_21");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_42()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashMap_42");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashMap_66a()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashMap_66a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashSet_31()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashSet_31");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_12()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_12");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_61a()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_61a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_15()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_15");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashMap_52a()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashMap_52a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_61a()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_61a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_51a()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_51a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_12()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_12");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashSet_52a()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashSet_52a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_02()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_ArrayList_02");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_71a()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_71a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_67a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_67a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashSet_12()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_12");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashSet_14()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashSet_14");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_68a()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_68a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_22a()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_22a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_15()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_15");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashSet_66a()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashSet_66a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashSet_08()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashSet_08");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashMap_15()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashMap_15");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashMap_51a()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashMap_51a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_81a()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_81a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashSet_71a()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_71a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_13()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_13");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_13()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_13");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_03()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_03");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__database_HashSet_12()).runTest("CWE789_Uncontrolled_Mem_Alloc__database_HashSet_12");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_14()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_14");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_02()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_ArrayList_02");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_45()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_45");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_68a()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_68a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_66a()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashMap_66a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_06()).runTest("CWE789_Uncontrolled_Mem_Alloc__console_readLine_HashSet_06");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_04()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashSet_04");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_42()).runTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_42");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashSet_14()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_14");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_72a()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_72a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashMap_10()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashMap_10");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__File_HashMap_42()).runTest("CWE789_Uncontrolled_Mem_Alloc__File_HashMap_42");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_04()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_ArrayList_04");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_45()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_45");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s01.CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_73a()).runTest("CWE789_Uncontrolled_Mem_Alloc__connect_tcp_HashMap_73a");
			/* END-AUTOGENERATED-JAVA-TESTS-7 */
}

private static void runTestCWE8() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-8 */

			/* END-AUTOGENERATED-JAVA-TESTS-8 */
}

private static void runTestCWE9() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-9 */

			/* END-AUTOGENERATED-JAVA-TESTS-9 */
}
}