package testcases.CWE789_Uncontrolled_Mem_Alloc.s02;

import testcasesupport.*;

public class Main {

	public static void main(String[] args) {
		
		if(args.length != 0) {
		
			if(args[0].equals("-h") || args[0].equals("--help")) {
		
				System.err.println("To use this main, you can either run the program with no " +
				"command line arguments to run all test cases or you can specify one or more classes to test");
				System.err.println("For example:");
				System.err.println("java testcasesupport.Main testcases.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference.custom_function.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference__custom_function_01 testcases.CWE481_Assigning_instead_of_Comparing.bool.CWE481_Assigning_instead_of_Comparing__bool_01");
				System.exit(1);
			}
			
			/* User supplied some class names on the command line, just use those with introspection
			 *
			 * String classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
			 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
 			 * could read class names from command line or use
			 * http://sadun-util.sourceforge.net/api/org/sadun/util/
			 * ClassPackageExplorer.html
			 */

			for (String className : args) {

				try {
					
					/* String classNameWithPackage = "testcases." + className; */
					
					/* IO.writeLine("classNameWithPackage = " + classNameWithPackage); */

					Class<?> myClass = Class.forName(className);

					AbstractTestCase myObject = (AbstractTestCase) myClass
							.newInstance();

					myObject.runTest(className);

				} catch (Exception ex) {

					IO.writeLine("Could not run test for class " + className);
					ex.printStackTrace();

				}
				
				IO.writeLine(""); /* leave a blank line between classes */

			}

		} else {
		
			/* No command line args were used, we want to run every testcase */
			
			/* needed to separate these calls into other methods because
			   we were running into the size limit Java has for a single method */
			runTestCWE1();
			runTestCWE2();
			runTestCWE3();
			runTestCWE4();
			runTestCWE5();
			runTestCWE6();
			runTestCWE7();
			runTestCWE8();
			runTestCWE9();
		}			
	}

private static void runTestCWE1() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-1 */

			/* END-AUTOGENERATED-JAVA-TESTS-1 */
}

private static void runTestCWE2() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-2 */

			/* END-AUTOGENERATED-JAVA-TESTS-2 */
}

private static void runTestCWE3() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-3 */

			/* END-AUTOGENERATED-JAVA-TESTS-3 */
}

private static void runTestCWE4() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-4 */

			/* END-AUTOGENERATED-JAVA-TESTS-4 */
}

private static void runTestCWE5() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-5 */

			/* END-AUTOGENERATED-JAVA-TESTS-5 */
}

private static void runTestCWE6() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-6 */

			/* END-AUTOGENERATED-JAVA-TESTS-6 */
}

private static void runTestCWE7() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-7 */
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_06()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_06");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_15()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_15");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_12()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_12");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_17()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_17");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_02()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_02");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_53a()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_53a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_72a()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_72a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_17()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_17");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_53a()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_53a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_74a()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_74a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_75a()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_75a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__heap_10()).runTest("CWE789_Uncontrolled_Mem_Alloc__heap_10");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_15()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_15");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_08()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_08");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_61a()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_61a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_61a()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_61a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_42()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_42");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_72a()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_72a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_54a()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_54a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_53a()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_53a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_67a()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_67a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_08()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_08");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_31()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_31");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_09()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_09");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_09()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_09");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_71a()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_71a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_54a()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_54a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_12()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_12");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_52a()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_52a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_03()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_03");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_15()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_15");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_15()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_15");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_14()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_14");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__heap_02()).runTest("CWE789_Uncontrolled_Mem_Alloc__heap_02");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_11()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_11");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_71a()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_71a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_81a()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_81a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_05()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_05");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_67a()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_67a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_07()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_07");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_14()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_14");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__heap_16()).runTest("CWE789_Uncontrolled_Mem_Alloc__heap_16");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_75a()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_75a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_73a()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_73a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_51a()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_51a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_68a()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_68a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__heap_14()).runTest("CWE789_Uncontrolled_Mem_Alloc__heap_14");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_05()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_05");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_03()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_03");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_11()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_11");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_16()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_16");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_53a()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_53a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_03()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_03");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_13()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_13");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_61a()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_61a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_06()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_06");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_09()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_09");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_13()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_13");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_73a()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_73a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_73a()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_73a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_22a()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_22a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_01()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_01");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_16()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_16");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_04()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_04");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_45()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_45");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_73a()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_73a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_03()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_03");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__heap_07()).runTest("CWE789_Uncontrolled_Mem_Alloc__heap_07");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_14()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_14");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__heap_12()).runTest("CWE789_Uncontrolled_Mem_Alloc__heap_12");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_15()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_15");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_04()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_04");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_16()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_16");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_41()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_41");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_03()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_03");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_61a()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_61a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_06()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_06");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_10()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_10");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_61a()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_61a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_02()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_02");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_14()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_14");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_81a()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_81a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_13()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_13");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_68a()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_68a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_71a()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_71a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_14()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_14");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_10()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_10");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_04()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_04");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_14()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_14");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_66a()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_66a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_09()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_09");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_74a()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_74a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_14()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_14");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_54a()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_54a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_52a()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_52a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_75a()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_75a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__heap_03()).runTest("CWE789_Uncontrolled_Mem_Alloc__heap_03");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_02()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_02");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_54a()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_54a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_52a()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_52a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_05()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_05");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__heap_05()).runTest("CWE789_Uncontrolled_Mem_Alloc__heap_05");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_54a()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_54a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_45()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_45");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__heap_09()).runTest("CWE789_Uncontrolled_Mem_Alloc__heap_09");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_41()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_41");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_08()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_08");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_66a()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_66a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_13()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_13");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_22a()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_22a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_81a()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_81a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_61a()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_61a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_81a()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_81a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_06()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_06");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_02()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_02");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_01()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_01");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_04()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_04");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_52a()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_52a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_73a()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_73a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_51a()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_51a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_52a()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_52a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_21()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_21");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_14()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_14");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_42()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_42");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_74a()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_74a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_09()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_09");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_41()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_41");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_41()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_41");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__heap_04()).runTest("CWE789_Uncontrolled_Mem_Alloc__heap_04");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_45()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_45");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_02()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_02");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_53a()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_53a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_51a()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_51a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_51a()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_51a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__heap_11()).runTest("CWE789_Uncontrolled_Mem_Alloc__heap_11");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_71a()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_71a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_17()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_17");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_41()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_41");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__heap_17()).runTest("CWE789_Uncontrolled_Mem_Alloc__heap_17");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_08()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_08");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_01()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_01");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_72a()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_72a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_21()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_21");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_66a()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_66a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_75a()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_75a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_66a()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_66a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_10()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_10");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_72a()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_72a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_15()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_15");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_72a()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_72a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_07()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_07");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_06()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_06");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_13()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_13");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_42()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_42");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_75a()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_75a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_22a()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_22a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_73a()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_73a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_67a()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_67a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_51a()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_51a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_17()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_17");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_31()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_31");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_07()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_07");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_68a()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_68a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_67a()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_67a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__heap_08()).runTest("CWE789_Uncontrolled_Mem_Alloc__heap_08");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_17()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_17");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_12()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_12");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_68a()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_68a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_68a()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_68a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_12()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_12");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_68a()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_68a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_10()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_10");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_54a()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_54a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_42()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_42");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_11()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_11");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_06()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_06");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_21()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_21");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_42()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_42");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_16()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_16");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_41()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_41");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_05()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_05");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_08()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_08");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_01()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_01");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_09()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_09");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_45()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_45");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_10()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_10");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_08()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_08");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_67a()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_67a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_16()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_16");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_09()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_09");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_07()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_07");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_74a()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_74a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_74a()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_74a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_11()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_11");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_11()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_11");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_17()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_17");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_04()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_04");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_22a()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_22a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_75a()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_75a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_54a()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_54a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_15()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_15");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_41()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_41");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_74a()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_74a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_71a()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_71a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_21()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_21");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_03()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_03");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_13()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_13");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_53a()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_53a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_51a()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_51a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_10()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_10");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_02()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_02");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_73a()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_73a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_74a()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_74a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_22a()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_22a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_02()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_02");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_07()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_07");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_71a()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_71a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_06()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_06");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_13()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_13");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_53a()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_53a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_53a()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_53a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_04()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_04");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_02()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_02");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_31()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_31");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_08()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_08");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_66a()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_66a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_12()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_12");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_51a()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_51a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_07()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_07");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_81a()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_81a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_22a()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_22a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_54a()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_54a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_66a()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_66a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_66a()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_66a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_11()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_11");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_52a()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_52a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_22a()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_22a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_12()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_12");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_21()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_21");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_45()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_45");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_81a()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_81a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_31()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_31");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_05()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_05");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_07()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_07");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_06()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_06");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_74a()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_74a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_72a()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_72a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_05()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_05");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_61a()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_61a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_45()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_45");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_45()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_45");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_66a()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_66a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_11()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_11");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_21()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_21");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_21()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_21");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_41()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_41");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__heap_15()).runTest("CWE789_Uncontrolled_Mem_Alloc__heap_15");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_73a()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_73a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_05()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_05");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_01()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_01");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_01()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_01");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_12()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_12");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_67a()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_67a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_21()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_21");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_11()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_11");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_17()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_17");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_81a()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_81a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_72a()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_72a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_10()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_10");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_42()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_42");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_52a()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_52a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_04()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_04");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_31()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_31");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_45()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_45");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_71a()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_71a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_75a()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_75a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_68a()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_68a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_07()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_07");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_10()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_10");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_68a()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_68a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_67a()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_67a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_67a()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_67a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_81a()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_81a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_71a()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_71a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__heap_01()).runTest("CWE789_Uncontrolled_Mem_Alloc__heap_01");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_01()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_01");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_51a()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_51a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__heap_06()).runTest("CWE789_Uncontrolled_Mem_Alloc__heap_06");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_42()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_42");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_16()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_16");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_09()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_09");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_61a()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_61a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__heap_13()).runTest("CWE789_Uncontrolled_Mem_Alloc__heap_13");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_04()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_04");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_12()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_12");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_31()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_31");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_31()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_31");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_16()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_16");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_22a()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_22a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_75a()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_ArrayList_75a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_01()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_01");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_52a()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_52a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_31()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_31");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_42()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_42");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_13()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashMap_13");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_03()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_HashSet_03");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_05()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_05");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_16()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashMap_16");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_72a()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_ArrayList_72a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_15()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_15");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_03()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashMap_03");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_08()).runTest("CWE789_Uncontrolled_Mem_Alloc__listen_tcp_ArrayList_08");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s02.CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_17()).runTest("CWE789_Uncontrolled_Mem_Alloc__max_value_HashSet_17");
			/* END-AUTOGENERATED-JAVA-TESTS-7 */
}

private static void runTestCWE8() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-8 */

			/* END-AUTOGENERATED-JAVA-TESTS-8 */
}

private static void runTestCWE9() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-9 */

			/* END-AUTOGENERATED-JAVA-TESTS-9 */
}
}