package testcases.CWE789_Uncontrolled_Mem_Alloc.s03;

import testcasesupport.*;

public class Main {

	public static void main(String[] args) {
		
		if(args.length != 0) {
		
			if(args[0].equals("-h") || args[0].equals("--help")) {
		
				System.err.println("To use this main, you can either run the program with no " +
				"command line arguments to run all test cases or you can specify one or more classes to test");
				System.err.println("For example:");
				System.err.println("java testcasesupport.Main testcases.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference.custom_function.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference__custom_function_01 testcases.CWE481_Assigning_instead_of_Comparing.bool.CWE481_Assigning_instead_of_Comparing__bool_01");
				System.exit(1);
			}
			
			/* User supplied some class names on the command line, just use those with introspection
			 *
			 * String classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
			 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
 			 * could read class names from command line or use
			 * http://sadun-util.sourceforge.net/api/org/sadun/util/
			 * ClassPackageExplorer.html
			 */

			for (String className : args) {

				try {
					
					/* String classNameWithPackage = "testcases." + className; */
					
					/* IO.writeLine("classNameWithPackage = " + classNameWithPackage); */

					Class<?> myClass = Class.forName(className);

					AbstractTestCase myObject = (AbstractTestCase) myClass
							.newInstance();

					myObject.runTest(className);

				} catch (Exception ex) {

					IO.writeLine("Could not run test for class " + className);
					ex.printStackTrace();

				}
				
				IO.writeLine(""); /* leave a blank line between classes */

			}

		} else {
		
			/* No command line args were used, we want to run every testcase */
			
			/* needed to separate these calls into other methods because
			   we were running into the size limit Java has for a single method */
			runTestCWE1();
			runTestCWE2();
			runTestCWE3();
			runTestCWE4();
			runTestCWE5();
			runTestCWE6();
			runTestCWE7();
			runTestCWE8();
			runTestCWE9();
		}			
	}

private static void runTestCWE1() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-1 */

			/* END-AUTOGENERATED-JAVA-TESTS-1 */
}

private static void runTestCWE2() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-2 */

			/* END-AUTOGENERATED-JAVA-TESTS-2 */
}

private static void runTestCWE3() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-3 */

			/* END-AUTOGENERATED-JAVA-TESTS-3 */
}

private static void runTestCWE4() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-4 */

			/* END-AUTOGENERATED-JAVA-TESTS-4 */
}

private static void runTestCWE5() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-5 */

			/* END-AUTOGENERATED-JAVA-TESTS-5 */
}

private static void runTestCWE6() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-6 */

			/* END-AUTOGENERATED-JAVA-TESTS-6 */
}

private static void runTestCWE7() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-7 */
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashSet_72a()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashSet_72a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_75a()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_75a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_54a()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_54a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashSet_53a()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashSet_53a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashMap_16()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashMap_16");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_10()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_10");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_12()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_12");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_06()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_06");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_72a()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_72a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_13()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_13");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_53a()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_53a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_73a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_73a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_75a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_75a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_72a()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_72a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_17()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_17");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_03()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_03");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_16()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_16");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashSet_73a()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashSet_73a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashMap_31()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashMap_31");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashMap_10()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashMap_10");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashSet_14()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashSet_14");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_21()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_21");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_75a()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_75a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_66a()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_66a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_71a()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_71a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_22a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_22a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashSet_15()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashSet_15");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashSet_07()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashSet_07");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_01()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_01");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_11()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_11");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_42()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_42");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_54a()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_54a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_11()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_11");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_51a()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_51a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_74a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_74a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashMap_54a()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashMap_54a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_71a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_71a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_08()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_08");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_74a()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_74a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashSet_75a()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashSet_75a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_01()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_01");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_31()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_31");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_06()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_06");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_07()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_07");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_31()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_31");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashSet_52a()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashSet_52a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_74a()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_74a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_52a()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_52a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashSet_12()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashSet_12");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_51a()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_51a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_14()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_14");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_12()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_12");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_10()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_10");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_05()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_05");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_16()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_16");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashSet_01()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashSet_01");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_03()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_03");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_75a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_75a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_04()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_04");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_81a()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_81a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_11()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_11");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_42()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_42");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_13()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_13");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_13()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_13");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_41()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_41");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_74a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_74a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_12()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_12");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_52a()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_52a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashMap_13()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashMap_13");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_14()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_14");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashSet_05()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashSet_05");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashMap_01()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashMap_01");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_16()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_16");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashMap_81a()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashMap_81a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_53a()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_53a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_53a()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_53a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_52a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_52a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_08()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_08");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_51a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_51a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_02()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_02");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_05()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_05");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_54a()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_54a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashSet_54a()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashSet_54a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_73a()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_73a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_01()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_01");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_81a()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_81a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_66a()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_66a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashSet_42()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashSet_42");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_53a()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_53a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashMap_14()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashMap_14");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashSet_31()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashSet_31");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_07()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_07");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_09()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_09");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_12()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_12");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_07()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_07");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_04()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_04");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_15()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_15");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_54a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_54a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashMap_12()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashMap_12");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_08()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_08");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_13()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_13");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashMap_67a()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashMap_67a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_68a()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_68a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_54a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_54a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashMap_08()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashMap_08");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_15()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_15");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_03()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_03");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_53a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_53a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashSet_71a()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashSet_71a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_52a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_52a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_71a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_71a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_06()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_06");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_16()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_16");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_04()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_04");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_09()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_09");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashSet_51a()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashSet_51a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_15()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_15");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_72a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_72a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_22a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_22a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_41()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_41");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_72a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_72a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_73a()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_73a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_07()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_07");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_67a()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_67a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_04()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_04");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_22a()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_22a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_14()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_14");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_68a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_68a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_66a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_66a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_10()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_10");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_09()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_09");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_31()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_31");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_61a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_61a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_15()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_15");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_09()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_09");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashMap_22a()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashMap_22a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_51a()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_51a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_02()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_02");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_81a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_81a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_14()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_14");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_72a()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_72a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_71a()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_71a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_05()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_05");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_53a()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_53a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_75a()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_75a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_14()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_14");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_61a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_61a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_42()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_42");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_07()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_07");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_10()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_10");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_05()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_05");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_73a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_73a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashMap_74a()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashMap_74a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_07()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_07");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashSet_02()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashSet_02");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_67a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_67a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_17()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_17");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_01()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_01");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashMap_61a()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashMap_61a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_21()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_21");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashMap_11()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashMap_11");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashMap_42()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashMap_42");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_68a()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_68a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_81a()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_81a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_54a()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_54a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashSet_04()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashSet_04");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_06()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_06");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_17()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_17");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_73a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_73a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_67a()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_67a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_03()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_03");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_74a()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_74a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashSet_08()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashSet_08");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_02()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_02");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_31()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_31");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashSet_68a()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashSet_68a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashMap_09()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashMap_09");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_17()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_17");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_45()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_45");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_10()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_10");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_52a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_52a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_14()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_14");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_14()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_14");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashSet_61a()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashSet_61a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashMap_52a()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashMap_52a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_15()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_15");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_42()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_42");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_45()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_45");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_16()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_16");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_42()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_42");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_52a()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_52a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_02()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_02");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_03()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_03");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_51a()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_51a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_04()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_04");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashMap_02()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashMap_02");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashMap_07()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashMap_07");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_08()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_08");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_72a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_72a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashSet_45()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashSet_45");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_41()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_41");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_09()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_09");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_05()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_05");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_21()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_21");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashSet_06()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashSet_06");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_04()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_04");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_21()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_21");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_13()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_13");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashSet_13()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashSet_13");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_81a()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_81a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_73a()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_73a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_68a()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_68a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashMap_03()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashMap_03");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_74a()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_74a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_17()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_17");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_15()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_15");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_01()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_01");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_71a()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_71a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_81a()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_81a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_04()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_04");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_66a()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_66a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_67a()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_67a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashMap_51a()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashMap_51a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_66a()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_66a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_75a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_75a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_52a()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_52a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_02()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_02");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_09()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_09");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_08()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_08");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_41()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_41");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashMap_53a()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashMap_53a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_11()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_11");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_42()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_42");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_08()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_08");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_10()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_10");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_68a()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_68a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_75a()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_75a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_72a()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_72a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashMap_75a()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashMap_75a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_54a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_54a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_66a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_66a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_54a()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_54a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashMap_68a()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashMap_68a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_13()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_13");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_81a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_81a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_05()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_05");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_41()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_41");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_06()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_06");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_02()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_02");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_11()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_11");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_68a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_68a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_10()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_10");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_22a()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_22a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_21()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_21");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_42()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_42");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_08()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_08");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_73a()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_73a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashSet_09()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashSet_09");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_71a()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_71a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_61a()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_61a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_68a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_68a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_67a()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_67a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_51a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_51a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_06()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_06");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_15()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_15");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_22a()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_22a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashMap_45()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashMap_45");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_74a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_74a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_61a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_61a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_42()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_42");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_11()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_11");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_09()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_09");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_05()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_05");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashMap_72a()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashMap_72a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_52a()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_52a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_03()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_03");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_45()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_45");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashSet_66a()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashSet_66a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_01()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_01");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_31()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_31");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_72a()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_72a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_21()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_21");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_41()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_41");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_45()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_45");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_13()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_13");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashSet_03()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashSet_03");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_16()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_16");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_81a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_81a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_21()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_21");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_66a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_66a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashSet_74a()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashSet_74a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_04()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_04");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_67a()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_67a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashMap_73a()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashMap_73a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_61a()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_61a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_07()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_07");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_06()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_06");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_16()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_16");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_03()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_03");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_73a()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_73a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashMap_17()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashMap_17");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_71a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_71a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_12()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_12");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_66a()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_66a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_67a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_67a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_07()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_07");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_06()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_06");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashMap_41()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashMap_41");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_31()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_31");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_41()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_41");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_61a()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_61a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_45()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_45");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_02()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_02");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_05()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_05");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_67a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_67a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashSet_22a()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashSet_22a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_22a()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_22a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_11()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_11");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashSet_10()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashSet_10");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_01()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_01");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_75a()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_75a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashMap_04()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashMap_04");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_53a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_53a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_01()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_01");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashSet_41()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashSet_41");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashMap_66a()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashMap_66a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_17()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_17");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashSet_21()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashSet_21");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_10()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_10");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashMap_06()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashMap_06");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashMap_21()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashMap_21");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_45()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_45");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_14()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_14");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_31()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_31");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_03()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_03");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_22a()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_22a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashMap_05()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashMap_05");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashMap_15()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashMap_15");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_61a()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_61a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_12()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_12");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_15()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_15");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_68a()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_68a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_41()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_41");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_16()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_16");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_13()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_13");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_17()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_17");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_22a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_22a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_61a()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_61a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashSet_16()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashSet_16");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashMap_71a()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashMap_71a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashSet_17()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashSet_17");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_45()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_45");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_71a()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_71a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_17()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_17");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_11()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_11");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashSet_81a()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashSet_81a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_45()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_45");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_12()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_12");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_12()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashSet_12");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_09()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_09");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_53a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashSet_53a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashSet_67a()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashSet_67a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_HashSet_11()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_HashSet_11");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_21()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_HashMap_21");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_74a()).runTest("CWE789_Uncontrolled_Mem_Alloc__random_ArrayList_74a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_31()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_ArrayList_31");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_51a()).runTest("CWE789_Uncontrolled_Mem_Alloc__URLConnection_HashMap_51a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_02()).runTest("CWE789_Uncontrolled_Mem_Alloc__PropertiesFile_HashSet_02");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_51a()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_51a");
			(new testcases.CWE789_Uncontrolled_Mem_Alloc.s03.CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_08()).runTest("CWE789_Uncontrolled_Mem_Alloc__Property_ArrayList_08");
			/* END-AUTOGENERATED-JAVA-TESTS-7 */
}

private static void runTestCWE8() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-8 */

			/* END-AUTOGENERATED-JAVA-TESTS-8 */
}

private static void runTestCWE9() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-9 */

			/* END-AUTOGENERATED-JAVA-TESTS-9 */
}
}