package testcases.CWE89_SQL_Injection.s02;

import testcasesupport.*;

public class Main {

	public static void main(String[] args) {
		
		if(args.length != 0) {
		
			if(args[0].equals("-h") || args[0].equals("--help")) {
		
				System.err.println("To use this main, you can either run the program with no " +
				"command line arguments to run all test cases or you can specify one or more classes to test");
				System.err.println("For example:");
				System.err.println("java testcasesupport.Main testcases.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference.custom_function.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference__custom_function_01 testcases.CWE481_Assigning_instead_of_Comparing.bool.CWE481_Assigning_instead_of_Comparing__bool_01");
				System.exit(1);
			}
			
			/* User supplied some class names on the command line, just use those with introspection
			 *
			 * String classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
			 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
 			 * could read class names from command line or use
			 * http://sadun-util.sourceforge.net/api/org/sadun/util/
			 * ClassPackageExplorer.html
			 */

			for (String className : args) {

				try {
					
					/* String classNameWithPackage = "testcases." + className; */
					
					/* IO.writeLine("classNameWithPackage = " + classNameWithPackage); */

					Class<?> myClass = Class.forName(className);

					AbstractTestCase myObject = (AbstractTestCase) myClass
							.newInstance();

					myObject.runTest(className);

				} catch (Exception ex) {

					IO.writeLine("Could not run test for class " + className);
					ex.printStackTrace();

				}
				
				IO.writeLine(""); /* leave a blank line between classes */

			}

		} else {
		
			/* No command line args were used, we want to run every testcase */
			
			/* needed to separate these calls into other methods because
			   we were running into the size limit Java has for a single method */
			runTestCWE1();
			runTestCWE2();
			runTestCWE3();
			runTestCWE4();
			runTestCWE5();
			runTestCWE6();
			runTestCWE7();
			runTestCWE8();
			runTestCWE9();
		}			
	}

private static void runTestCWE1() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-1 */

			/* END-AUTOGENERATED-JAVA-TESTS-1 */
}

private static void runTestCWE2() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-2 */

			/* END-AUTOGENERATED-JAVA-TESTS-2 */
}

private static void runTestCWE3() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-3 */

			/* END-AUTOGENERATED-JAVA-TESTS-3 */
}

private static void runTestCWE4() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-4 */

			/* END-AUTOGENERATED-JAVA-TESTS-4 */
}

private static void runTestCWE5() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-5 */

			/* END-AUTOGENERATED-JAVA-TESTS-5 */
}

private static void runTestCWE6() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-6 */

			/* END-AUTOGENERATED-JAVA-TESTS-6 */
}

private static void runTestCWE7() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-7 */

			/* END-AUTOGENERATED-JAVA-TESTS-7 */
}

private static void runTestCWE8() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-8 */
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_prepareStatement_51a()).runTest("CWE89_SQL_Injection__File_prepareStatement_51a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_prepareStatement_08()).runTest("CWE89_SQL_Injection__File_prepareStatement_08");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeUpdate_16()).runTest("CWE89_SQL_Injection__File_executeUpdate_16");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeUpdate_75a()).runTest("CWE89_SQL_Injection__File_executeUpdate_75a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_prepareStatement_03()).runTest("CWE89_SQL_Injection__File_prepareStatement_03");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeQuery_17()).runTest("CWE89_SQL_Injection__File_executeQuery_17");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_execute_22a()).runTest("CWE89_SQL_Injection__File_execute_22a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeQuery_13()).runTest("CWE89_SQL_Injection__File_executeQuery_13");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_execute_71a()).runTest("CWE89_SQL_Injection__Environment_execute_71a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_prepareStatement_03()).runTest("CWE89_SQL_Injection__Environment_prepareStatement_03");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_execute_15()).runTest("CWE89_SQL_Injection__File_execute_15");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeUpdate_05()).runTest("CWE89_SQL_Injection__Environment_executeUpdate_05");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeUpdate_51a()).runTest("CWE89_SQL_Injection__Environment_executeUpdate_51a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_execute_72a()).runTest("CWE89_SQL_Injection__Environment_execute_72a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_execute_41()).runTest("CWE89_SQL_Injection__Environment_execute_41");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeQuery_05()).runTest("CWE89_SQL_Injection__Environment_executeQuery_05");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeQuery_41()).runTest("CWE89_SQL_Injection__File_executeQuery_41");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_execute_01()).runTest("CWE89_SQL_Injection__Environment_execute_01");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeBatch_54a()).runTest("CWE89_SQL_Injection__File_executeBatch_54a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_prepareStatement_81a()).runTest("CWE89_SQL_Injection__File_prepareStatement_81a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_prepareStatement_13()).runTest("CWE89_SQL_Injection__File_prepareStatement_13");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeUpdate_10()).runTest("CWE89_SQL_Injection__File_executeUpdate_10");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_execute_10()).runTest("CWE89_SQL_Injection__Environment_execute_10");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_execute_11()).runTest("CWE89_SQL_Injection__Environment_execute_11");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_prepareStatement_05()).runTest("CWE89_SQL_Injection__File_prepareStatement_05");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_execute_51a()).runTest("CWE89_SQL_Injection__Environment_execute_51a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeQuery_12()).runTest("CWE89_SQL_Injection__Environment_executeQuery_12");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeQuery_13()).runTest("CWE89_SQL_Injection__Environment_executeQuery_13");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeQuery_02()).runTest("CWE89_SQL_Injection__File_executeQuery_02");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeUpdate_81a()).runTest("CWE89_SQL_Injection__Environment_executeUpdate_81a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_prepareStatement_61a()).runTest("CWE89_SQL_Injection__Environment_prepareStatement_61a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_execute_05()).runTest("CWE89_SQL_Injection__Environment_execute_05");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeBatch_14()).runTest("CWE89_SQL_Injection__File_executeBatch_14");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_prepareStatement_66a()).runTest("CWE89_SQL_Injection__File_prepareStatement_66a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeQuery_31()).runTest("CWE89_SQL_Injection__Environment_executeQuery_31");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeUpdate_41()).runTest("CWE89_SQL_Injection__File_executeUpdate_41");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_prepareStatement_09()).runTest("CWE89_SQL_Injection__Environment_prepareStatement_09");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeQuery_12()).runTest("CWE89_SQL_Injection__File_executeQuery_12");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_execute_07()).runTest("CWE89_SQL_Injection__Environment_execute_07");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeQuery_21()).runTest("CWE89_SQL_Injection__Environment_executeQuery_21");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_execute_04()).runTest("CWE89_SQL_Injection__Environment_execute_04");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_prepareStatement_02()).runTest("CWE89_SQL_Injection__File_prepareStatement_02");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeUpdate_09()).runTest("CWE89_SQL_Injection__Environment_executeUpdate_09");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeUpdate_10()).runTest("CWE89_SQL_Injection__Environment_executeUpdate_10");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeUpdate_04()).runTest("CWE89_SQL_Injection__Environment_executeUpdate_04");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeUpdate_06()).runTest("CWE89_SQL_Injection__Environment_executeUpdate_06");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeQuery_75a()).runTest("CWE89_SQL_Injection__Environment_executeQuery_75a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_execute_02()).runTest("CWE89_SQL_Injection__Environment_execute_02");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeUpdate_16()).runTest("CWE89_SQL_Injection__Environment_executeUpdate_16");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeUpdate_74a()).runTest("CWE89_SQL_Injection__File_executeUpdate_74a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_execute_81a()).runTest("CWE89_SQL_Injection__Environment_execute_81a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeQuery_52a()).runTest("CWE89_SQL_Injection__Environment_executeQuery_52a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeBatch_15()).runTest("CWE89_SQL_Injection__File_executeBatch_15");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_execute_15()).runTest("CWE89_SQL_Injection__Environment_execute_15");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeBatch_81a()).runTest("CWE89_SQL_Injection__File_executeBatch_81a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_prepareStatement_42()).runTest("CWE89_SQL_Injection__File_prepareStatement_42");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeUpdate_72a()).runTest("CWE89_SQL_Injection__Environment_executeUpdate_72a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeUpdate_61a()).runTest("CWE89_SQL_Injection__File_executeUpdate_61a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeBatch_67a()).runTest("CWE89_SQL_Injection__File_executeBatch_67a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeQuery_41()).runTest("CWE89_SQL_Injection__Environment_executeQuery_41");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeBatch_04()).runTest("CWE89_SQL_Injection__File_executeBatch_04");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeQuery_10()).runTest("CWE89_SQL_Injection__File_executeQuery_10");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeUpdate_53a()).runTest("CWE89_SQL_Injection__Environment_executeUpdate_53a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeQuery_45()).runTest("CWE89_SQL_Injection__File_executeQuery_45");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_execute_74a()).runTest("CWE89_SQL_Injection__File_execute_74a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_execute_03()).runTest("CWE89_SQL_Injection__File_execute_03");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeUpdate_01()).runTest("CWE89_SQL_Injection__Environment_executeUpdate_01");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_prepareStatement_61a()).runTest("CWE89_SQL_Injection__File_prepareStatement_61a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_execute_17()).runTest("CWE89_SQL_Injection__File_execute_17");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeQuery_16()).runTest("CWE89_SQL_Injection__File_executeQuery_16");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeUpdate_75a()).runTest("CWE89_SQL_Injection__Environment_executeUpdate_75a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeBatch_02()).runTest("CWE89_SQL_Injection__File_executeBatch_02");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeUpdate_31()).runTest("CWE89_SQL_Injection__File_executeUpdate_31");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_prepareStatement_53a()).runTest("CWE89_SQL_Injection__Environment_prepareStatement_53a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_prepareStatement_17()).runTest("CWE89_SQL_Injection__File_prepareStatement_17");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_execute_71a()).runTest("CWE89_SQL_Injection__File_execute_71a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeBatch_17()).runTest("CWE89_SQL_Injection__File_executeBatch_17");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_prepareStatement_53a()).runTest("CWE89_SQL_Injection__File_prepareStatement_53a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeBatch_42()).runTest("CWE89_SQL_Injection__File_executeBatch_42");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeUpdate_74a()).runTest("CWE89_SQL_Injection__Environment_executeUpdate_74a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeQuery_54a()).runTest("CWE89_SQL_Injection__Environment_executeQuery_54a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeUpdate_73a()).runTest("CWE89_SQL_Injection__File_executeUpdate_73a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeBatch_45()).runTest("CWE89_SQL_Injection__File_executeBatch_45");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_prepareStatement_72a()).runTest("CWE89_SQL_Injection__File_prepareStatement_72a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeBatch_66a()).runTest("CWE89_SQL_Injection__File_executeBatch_66a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_prepareStatement_10()).runTest("CWE89_SQL_Injection__File_prepareStatement_10");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeQuery_01()).runTest("CWE89_SQL_Injection__Environment_executeQuery_01");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeBatch_75a()).runTest("CWE89_SQL_Injection__File_executeBatch_75a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_execute_54a()).runTest("CWE89_SQL_Injection__File_execute_54a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_execute_12()).runTest("CWE89_SQL_Injection__Environment_execute_12");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_prepareStatement_41()).runTest("CWE89_SQL_Injection__File_prepareStatement_41");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeUpdate_72a()).runTest("CWE89_SQL_Injection__File_executeUpdate_72a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeQuery_67a()).runTest("CWE89_SQL_Injection__File_executeQuery_67a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeQuery_72a()).runTest("CWE89_SQL_Injection__File_executeQuery_72a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeQuery_51a()).runTest("CWE89_SQL_Injection__File_executeQuery_51a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_execute_04()).runTest("CWE89_SQL_Injection__File_execute_04");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_execute_75a()).runTest("CWE89_SQL_Injection__File_execute_75a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeQuery_11()).runTest("CWE89_SQL_Injection__File_executeQuery_11");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_execute_51a()).runTest("CWE89_SQL_Injection__File_execute_51a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_prepareStatement_14()).runTest("CWE89_SQL_Injection__Environment_prepareStatement_14");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_prepareStatement_02()).runTest("CWE89_SQL_Injection__Environment_prepareStatement_02");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_prepareStatement_06()).runTest("CWE89_SQL_Injection__Environment_prepareStatement_06");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeQuery_66a()).runTest("CWE89_SQL_Injection__Environment_executeQuery_66a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_execute_07()).runTest("CWE89_SQL_Injection__File_execute_07");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeUpdate_71a()).runTest("CWE89_SQL_Injection__File_executeUpdate_71a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_execute_52a()).runTest("CWE89_SQL_Injection__Environment_execute_52a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_execute_09()).runTest("CWE89_SQL_Injection__Environment_execute_09");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_execute_13()).runTest("CWE89_SQL_Injection__Environment_execute_13");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_execute_16()).runTest("CWE89_SQL_Injection__File_execute_16");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeUpdate_21()).runTest("CWE89_SQL_Injection__File_executeUpdate_21");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_execute_06()).runTest("CWE89_SQL_Injection__Environment_execute_06");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_execute_08()).runTest("CWE89_SQL_Injection__File_execute_08");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_execute_12()).runTest("CWE89_SQL_Injection__File_execute_12");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_execute_16()).runTest("CWE89_SQL_Injection__Environment_execute_16");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_prepareStatement_45()).runTest("CWE89_SQL_Injection__File_prepareStatement_45");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeUpdate_41()).runTest("CWE89_SQL_Injection__Environment_executeUpdate_41");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeQuery_68a()).runTest("CWE89_SQL_Injection__File_executeQuery_68a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_prepareStatement_74a()).runTest("CWE89_SQL_Injection__File_prepareStatement_74a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_prepareStatement_14()).runTest("CWE89_SQL_Injection__File_prepareStatement_14");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_execute_21()).runTest("CWE89_SQL_Injection__File_execute_21");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeQuery_31()).runTest("CWE89_SQL_Injection__File_executeQuery_31");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeQuery_03()).runTest("CWE89_SQL_Injection__Environment_executeQuery_03");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_execute_67a()).runTest("CWE89_SQL_Injection__Environment_execute_67a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_execute_09()).runTest("CWE89_SQL_Injection__File_execute_09");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeUpdate_15()).runTest("CWE89_SQL_Injection__File_executeUpdate_15");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeUpdate_12()).runTest("CWE89_SQL_Injection__File_executeUpdate_12");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_execute_17()).runTest("CWE89_SQL_Injection__Environment_execute_17");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeQuery_71a()).runTest("CWE89_SQL_Injection__File_executeQuery_71a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeBatch_73a()).runTest("CWE89_SQL_Injection__File_executeBatch_73a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeUpdate_61a()).runTest("CWE89_SQL_Injection__Environment_executeUpdate_61a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeBatch_13()).runTest("CWE89_SQL_Injection__File_executeBatch_13");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_prepareStatement_07()).runTest("CWE89_SQL_Injection__File_prepareStatement_07");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_prepareStatement_22a()).runTest("CWE89_SQL_Injection__File_prepareStatement_22a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeQuery_09()).runTest("CWE89_SQL_Injection__Environment_executeQuery_09");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_prepareStatement_12()).runTest("CWE89_SQL_Injection__Environment_prepareStatement_12");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_prepareStatement_05()).runTest("CWE89_SQL_Injection__Environment_prepareStatement_05");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeUpdate_71a()).runTest("CWE89_SQL_Injection__Environment_executeUpdate_71a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeBatch_22a()).runTest("CWE89_SQL_Injection__File_executeBatch_22a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeBatch_01()).runTest("CWE89_SQL_Injection__File_executeBatch_01");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_prepareStatement_68a()).runTest("CWE89_SQL_Injection__Environment_prepareStatement_68a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeQuery_16()).runTest("CWE89_SQL_Injection__Environment_executeQuery_16");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_execute_05()).runTest("CWE89_SQL_Injection__File_execute_05");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeUpdate_13()).runTest("CWE89_SQL_Injection__Environment_executeUpdate_13");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeQuery_08()).runTest("CWE89_SQL_Injection__File_executeQuery_08");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_execute_13()).runTest("CWE89_SQL_Injection__File_execute_13");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_execute_72a()).runTest("CWE89_SQL_Injection__File_execute_72a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeBatch_71a()).runTest("CWE89_SQL_Injection__File_executeBatch_71a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeUpdate_52a()).runTest("CWE89_SQL_Injection__Environment_executeUpdate_52a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_execute_52a()).runTest("CWE89_SQL_Injection__File_execute_52a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeQuery_42()).runTest("CWE89_SQL_Injection__File_executeQuery_42");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_execute_31()).runTest("CWE89_SQL_Injection__Environment_execute_31");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeBatch_08()).runTest("CWE89_SQL_Injection__File_executeBatch_08");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_prepareStatement_08()).runTest("CWE89_SQL_Injection__Environment_prepareStatement_08");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_prepareStatement_04()).runTest("CWE89_SQL_Injection__File_prepareStatement_04");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeUpdate_11()).runTest("CWE89_SQL_Injection__File_executeUpdate_11");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_execute_53a()).runTest("CWE89_SQL_Injection__Environment_execute_53a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeQuery_73a()).runTest("CWE89_SQL_Injection__Environment_executeQuery_73a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeQuery_21()).runTest("CWE89_SQL_Injection__File_executeQuery_21");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_execute_73a()).runTest("CWE89_SQL_Injection__Environment_execute_73a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_prepareStatement_71a()).runTest("CWE89_SQL_Injection__Environment_prepareStatement_71a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeQuery_04()).runTest("CWE89_SQL_Injection__File_executeQuery_04");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeQuery_22a()).runTest("CWE89_SQL_Injection__File_executeQuery_22a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_prepareStatement_22a()).runTest("CWE89_SQL_Injection__Environment_prepareStatement_22a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeUpdate_31()).runTest("CWE89_SQL_Injection__Environment_executeUpdate_31");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeQuery_04()).runTest("CWE89_SQL_Injection__Environment_executeQuery_04");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_prepareStatement_52a()).runTest("CWE89_SQL_Injection__Environment_prepareStatement_52a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeQuery_54a()).runTest("CWE89_SQL_Injection__File_executeQuery_54a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_prepareStatement_52a()).runTest("CWE89_SQL_Injection__File_prepareStatement_52a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_prepareStatement_10()).runTest("CWE89_SQL_Injection__Environment_prepareStatement_10");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeQuery_15()).runTest("CWE89_SQL_Injection__Environment_executeQuery_15");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_execute_03()).runTest("CWE89_SQL_Injection__Environment_execute_03");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_prepareStatement_73a()).runTest("CWE89_SQL_Injection__File_prepareStatement_73a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeQuery_52a()).runTest("CWE89_SQL_Injection__File_executeQuery_52a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeUpdate_13()).runTest("CWE89_SQL_Injection__File_executeUpdate_13");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeUpdate_66a()).runTest("CWE89_SQL_Injection__File_executeUpdate_66a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_prepareStatement_31()).runTest("CWE89_SQL_Injection__Environment_prepareStatement_31");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_prepareStatement_72a()).runTest("CWE89_SQL_Injection__Environment_prepareStatement_72a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_execute_22a()).runTest("CWE89_SQL_Injection__Environment_execute_22a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_prepareStatement_09()).runTest("CWE89_SQL_Injection__File_prepareStatement_09");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeUpdate_52a()).runTest("CWE89_SQL_Injection__File_executeUpdate_52a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_execute_66a()).runTest("CWE89_SQL_Injection__File_execute_66a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeQuery_75a()).runTest("CWE89_SQL_Injection__File_executeQuery_75a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeBatch_09()).runTest("CWE89_SQL_Injection__File_executeBatch_09");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_prepareStatement_45()).runTest("CWE89_SQL_Injection__Environment_prepareStatement_45");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_execute_61a()).runTest("CWE89_SQL_Injection__File_execute_61a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeBatch_53a()).runTest("CWE89_SQL_Injection__File_executeBatch_53a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeUpdate_03()).runTest("CWE89_SQL_Injection__File_executeUpdate_03");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeUpdate_54a()).runTest("CWE89_SQL_Injection__File_executeUpdate_54a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_prepareStatement_13()).runTest("CWE89_SQL_Injection__Environment_prepareStatement_13");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeQuery_53a()).runTest("CWE89_SQL_Injection__Environment_executeQuery_53a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeBatch_61a()).runTest("CWE89_SQL_Injection__File_executeBatch_61a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_execute_14()).runTest("CWE89_SQL_Injection__File_execute_14");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeBatch_51a()).runTest("CWE89_SQL_Injection__File_executeBatch_51a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeUpdate_06()).runTest("CWE89_SQL_Injection__File_executeUpdate_06");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_prepareStatement_67a()).runTest("CWE89_SQL_Injection__File_prepareStatement_67a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeUpdate_45()).runTest("CWE89_SQL_Injection__Environment_executeUpdate_45");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_prepareStatement_16()).runTest("CWE89_SQL_Injection__Environment_prepareStatement_16");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_execute_67a()).runTest("CWE89_SQL_Injection__File_execute_67a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeQuery_81a()).runTest("CWE89_SQL_Injection__File_executeQuery_81a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_execute_53a()).runTest("CWE89_SQL_Injection__File_execute_53a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_prepareStatement_54a()).runTest("CWE89_SQL_Injection__Environment_prepareStatement_54a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_prepareStatement_11()).runTest("CWE89_SQL_Injection__File_prepareStatement_11");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeQuery_14()).runTest("CWE89_SQL_Injection__Environment_executeQuery_14");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_execute_45()).runTest("CWE89_SQL_Injection__Environment_execute_45");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_prepareStatement_21()).runTest("CWE89_SQL_Injection__Environment_prepareStatement_21");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_execute_21()).runTest("CWE89_SQL_Injection__Environment_execute_21");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeUpdate_03()).runTest("CWE89_SQL_Injection__Environment_executeUpdate_03");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeBatch_03()).runTest("CWE89_SQL_Injection__File_executeBatch_03");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeQuery_53a()).runTest("CWE89_SQL_Injection__File_executeQuery_53a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_prepareStatement_15()).runTest("CWE89_SQL_Injection__File_prepareStatement_15");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeQuery_61a()).runTest("CWE89_SQL_Injection__Environment_executeQuery_61a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeUpdate_15()).runTest("CWE89_SQL_Injection__Environment_executeUpdate_15");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_prepareStatement_21()).runTest("CWE89_SQL_Injection__File_prepareStatement_21");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeUpdate_07()).runTest("CWE89_SQL_Injection__Environment_executeUpdate_07");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_prepareStatement_54a()).runTest("CWE89_SQL_Injection__File_prepareStatement_54a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeUpdate_17()).runTest("CWE89_SQL_Injection__Environment_executeUpdate_17");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeQuery_17()).runTest("CWE89_SQL_Injection__Environment_executeQuery_17");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeUpdate_08()).runTest("CWE89_SQL_Injection__File_executeUpdate_08");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeQuery_66a()).runTest("CWE89_SQL_Injection__File_executeQuery_66a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeQuery_11()).runTest("CWE89_SQL_Injection__Environment_executeQuery_11");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_execute_41()).runTest("CWE89_SQL_Injection__File_execute_41");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_prepareStatement_11()).runTest("CWE89_SQL_Injection__Environment_prepareStatement_11");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeQuery_07()).runTest("CWE89_SQL_Injection__Environment_executeQuery_07");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_prepareStatement_75a()).runTest("CWE89_SQL_Injection__File_prepareStatement_75a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeUpdate_66a()).runTest("CWE89_SQL_Injection__Environment_executeUpdate_66a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_prepareStatement_04()).runTest("CWE89_SQL_Injection__Environment_prepareStatement_04");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeQuery_06()).runTest("CWE89_SQL_Injection__Environment_executeQuery_06");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeBatch_07()).runTest("CWE89_SQL_Injection__File_executeBatch_07");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeUpdate_54a()).runTest("CWE89_SQL_Injection__Environment_executeUpdate_54a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_execute_74a()).runTest("CWE89_SQL_Injection__Environment_execute_74a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_prepareStatement_42()).runTest("CWE89_SQL_Injection__Environment_prepareStatement_42");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeUpdate_12()).runTest("CWE89_SQL_Injection__Environment_executeUpdate_12");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeBatch_11()).runTest("CWE89_SQL_Injection__File_executeBatch_11");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_prepareStatement_41()).runTest("CWE89_SQL_Injection__Environment_prepareStatement_41");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeUpdate_14()).runTest("CWE89_SQL_Injection__Environment_executeUpdate_14");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeQuery_22a()).runTest("CWE89_SQL_Injection__Environment_executeQuery_22a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeQuery_67a()).runTest("CWE89_SQL_Injection__Environment_executeQuery_67a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeBatch_10()).runTest("CWE89_SQL_Injection__File_executeBatch_10");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeQuery_10()).runTest("CWE89_SQL_Injection__Environment_executeQuery_10");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeQuery_74a()).runTest("CWE89_SQL_Injection__File_executeQuery_74a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_prepareStatement_01()).runTest("CWE89_SQL_Injection__File_prepareStatement_01");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_execute_68a()).runTest("CWE89_SQL_Injection__File_execute_68a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_prepareStatement_67a()).runTest("CWE89_SQL_Injection__Environment_prepareStatement_67a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_prepareStatement_16()).runTest("CWE89_SQL_Injection__File_prepareStatement_16");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_execute_08()).runTest("CWE89_SQL_Injection__Environment_execute_08");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeQuery_02()).runTest("CWE89_SQL_Injection__Environment_executeQuery_02");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeUpdate_22a()).runTest("CWE89_SQL_Injection__Environment_executeUpdate_22a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_prepareStatement_17()).runTest("CWE89_SQL_Injection__Environment_prepareStatement_17");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_execute_14()).runTest("CWE89_SQL_Injection__Environment_execute_14");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_prepareStatement_31()).runTest("CWE89_SQL_Injection__File_prepareStatement_31");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_execute_66a()).runTest("CWE89_SQL_Injection__Environment_execute_66a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_execute_54a()).runTest("CWE89_SQL_Injection__Environment_execute_54a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeQuery_73a()).runTest("CWE89_SQL_Injection__File_executeQuery_73a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeQuery_68a()).runTest("CWE89_SQL_Injection__Environment_executeQuery_68a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_execute_10()).runTest("CWE89_SQL_Injection__File_execute_10");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_execute_45()).runTest("CWE89_SQL_Injection__File_execute_45");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeQuery_72a()).runTest("CWE89_SQL_Injection__Environment_executeQuery_72a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeBatch_06()).runTest("CWE89_SQL_Injection__File_executeBatch_06");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeBatch_21()).runTest("CWE89_SQL_Injection__File_executeBatch_21");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_execute_42()).runTest("CWE89_SQL_Injection__File_execute_42");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeBatch_12()).runTest("CWE89_SQL_Injection__File_executeBatch_12");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeBatch_74a()).runTest("CWE89_SQL_Injection__File_executeBatch_74a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeQuery_07()).runTest("CWE89_SQL_Injection__File_executeQuery_07");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeQuery_51a()).runTest("CWE89_SQL_Injection__Environment_executeQuery_51a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_prepareStatement_68a()).runTest("CWE89_SQL_Injection__File_prepareStatement_68a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeQuery_42()).runTest("CWE89_SQL_Injection__Environment_executeQuery_42");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeUpdate_42()).runTest("CWE89_SQL_Injection__File_executeUpdate_42");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_execute_81a()).runTest("CWE89_SQL_Injection__File_execute_81a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_prepareStatement_81a()).runTest("CWE89_SQL_Injection__Environment_prepareStatement_81a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_execute_61a()).runTest("CWE89_SQL_Injection__Environment_execute_61a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_execute_31()).runTest("CWE89_SQL_Injection__File_execute_31");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeQuery_74a()).runTest("CWE89_SQL_Injection__Environment_executeQuery_74a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeBatch_41()).runTest("CWE89_SQL_Injection__File_executeBatch_41");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_prepareStatement_74a()).runTest("CWE89_SQL_Injection__Environment_prepareStatement_74a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeUpdate_14()).runTest("CWE89_SQL_Injection__File_executeUpdate_14");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeUpdate_68a()).runTest("CWE89_SQL_Injection__Environment_executeUpdate_68a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_prepareStatement_66a()).runTest("CWE89_SQL_Injection__Environment_prepareStatement_66a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeUpdate_51a()).runTest("CWE89_SQL_Injection__File_executeUpdate_51a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeUpdate_02()).runTest("CWE89_SQL_Injection__Environment_executeUpdate_02");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeUpdate_01()).runTest("CWE89_SQL_Injection__File_executeUpdate_01");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeQuery_01()).runTest("CWE89_SQL_Injection__File_executeQuery_01");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_execute_73a()).runTest("CWE89_SQL_Injection__File_execute_73a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeUpdate_17()).runTest("CWE89_SQL_Injection__File_executeUpdate_17");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeUpdate_22a()).runTest("CWE89_SQL_Injection__File_executeUpdate_22a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_execute_06()).runTest("CWE89_SQL_Injection__File_execute_06");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeQuery_71a()).runTest("CWE89_SQL_Injection__Environment_executeQuery_71a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_execute_02()).runTest("CWE89_SQL_Injection__File_execute_02");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeUpdate_21()).runTest("CWE89_SQL_Injection__Environment_executeUpdate_21");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeQuery_03()).runTest("CWE89_SQL_Injection__File_executeQuery_03");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_prepareStatement_07()).runTest("CWE89_SQL_Injection__Environment_prepareStatement_07");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_execute_01()).runTest("CWE89_SQL_Injection__File_execute_01");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeQuery_06()).runTest("CWE89_SQL_Injection__File_executeQuery_06");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeBatch_52a()).runTest("CWE89_SQL_Injection__File_executeBatch_52a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeQuery_08()).runTest("CWE89_SQL_Injection__Environment_executeQuery_08");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeQuery_05()).runTest("CWE89_SQL_Injection__File_executeQuery_05");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_prepareStatement_15()).runTest("CWE89_SQL_Injection__Environment_prepareStatement_15");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeUpdate_42()).runTest("CWE89_SQL_Injection__Environment_executeUpdate_42");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeUpdate_08()).runTest("CWE89_SQL_Injection__Environment_executeUpdate_08");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeQuery_45()).runTest("CWE89_SQL_Injection__Environment_executeQuery_45");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeBatch_31()).runTest("CWE89_SQL_Injection__File_executeBatch_31");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_execute_75a()).runTest("CWE89_SQL_Injection__Environment_execute_75a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeUpdate_73a()).runTest("CWE89_SQL_Injection__Environment_executeUpdate_73a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeUpdate_68a()).runTest("CWE89_SQL_Injection__File_executeUpdate_68a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeUpdate_67a()).runTest("CWE89_SQL_Injection__Environment_executeUpdate_67a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeUpdate_02()).runTest("CWE89_SQL_Injection__File_executeUpdate_02");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_execute_11()).runTest("CWE89_SQL_Injection__File_execute_11");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeBatch_16()).runTest("CWE89_SQL_Injection__File_executeBatch_16");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_prepareStatement_75a()).runTest("CWE89_SQL_Injection__Environment_prepareStatement_75a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeUpdate_81a()).runTest("CWE89_SQL_Injection__File_executeUpdate_81a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeUpdate_07()).runTest("CWE89_SQL_Injection__File_executeUpdate_07");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_execute_68a()).runTest("CWE89_SQL_Injection__Environment_execute_68a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeUpdate_04()).runTest("CWE89_SQL_Injection__File_executeUpdate_04");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_prepareStatement_51a()).runTest("CWE89_SQL_Injection__Environment_prepareStatement_51a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_prepareStatement_73a()).runTest("CWE89_SQL_Injection__Environment_prepareStatement_73a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeBatch_72a()).runTest("CWE89_SQL_Injection__File_executeBatch_72a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeBatch_68a()).runTest("CWE89_SQL_Injection__File_executeBatch_68a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_prepareStatement_01()).runTest("CWE89_SQL_Injection__Environment_prepareStatement_01");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeQuery_15()).runTest("CWE89_SQL_Injection__File_executeQuery_15");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_execute_42()).runTest("CWE89_SQL_Injection__Environment_execute_42");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeQuery_09()).runTest("CWE89_SQL_Injection__File_executeQuery_09");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeUpdate_09()).runTest("CWE89_SQL_Injection__File_executeUpdate_09");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_prepareStatement_06()).runTest("CWE89_SQL_Injection__File_prepareStatement_06");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeQuery_14()).runTest("CWE89_SQL_Injection__File_executeQuery_14");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeUpdate_05()).runTest("CWE89_SQL_Injection__File_executeUpdate_05");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeUpdate_67a()).runTest("CWE89_SQL_Injection__File_executeUpdate_67a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeBatch_05()).runTest("CWE89_SQL_Injection__File_executeBatch_05");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeUpdate_11()).runTest("CWE89_SQL_Injection__Environment_executeUpdate_11");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeUpdate_53a()).runTest("CWE89_SQL_Injection__File_executeUpdate_53a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeQuery_61a()).runTest("CWE89_SQL_Injection__File_executeQuery_61a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__Environment_executeQuery_81a()).runTest("CWE89_SQL_Injection__Environment_executeQuery_81a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_prepareStatement_12()).runTest("CWE89_SQL_Injection__File_prepareStatement_12");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_prepareStatement_71a()).runTest("CWE89_SQL_Injection__File_prepareStatement_71a");
			(new testcases.CWE89_SQL_Injection.s02.CWE89_SQL_Injection__File_executeUpdate_45()).runTest("CWE89_SQL_Injection__File_executeUpdate_45");
			/* END-AUTOGENERATED-JAVA-TESTS-8 */
}

private static void runTestCWE9() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-9 */

			/* END-AUTOGENERATED-JAVA-TESTS-9 */
}
}